/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/resources","fs","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","util","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function(x){for(var t=[],v=0,T=x.length;v<T;v++)t[v]=Q[x[v]];return t};define(Q[57],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function v(T,D){if(!T)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}t.ok=v}),define(Q[44],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function v(F){return(O,u,c)=>{let R=null,y=null;if(typeof c.value=="function"?(R="value",y=c.value):typeof c.get=="function"&&(R="get",y=c.get),!y)throw new Error("not supported");c[R]=F(y,u)}}t.createDecorator=v;function T(F,O,u){let c=null,R=null;if(typeof u.value=="function"?(c="value",R=u.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",R=u.get),!R)throw new Error("not supported");const y=`$memoize$${O}`;u[c]=function(...w){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,w)}),this[y]}}t.memoize=T;function D(F,O,u){return v((c,R)=>{const y=`$debounce$${R}`,w=`$debounce$result$${R}`;return function(...P){this[w]||(this[w]=u?u():void 0),clearTimeout(this[y]),O&&(this[w]=O(this[w],...P),P=[this[w]]),this[y]=setTimeout(()=>{c.apply(this,P),this[w]=u?u():void 0},F)}})}t.debounce=D;function S(F,O,u){return v((c,R)=>{const y=`$throttle$timer$${R}`,w=`$throttle$result$${R}`,P=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...d){if(this[w]||(this[w]=u?u():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),O&&(this[w]=O(this[w],...d)),!this[f]){const b=this[P]+F;b<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[w]]),this[w]=u?u():void 0):(this[f]=!0,this[y]=setTimeout(()=>{this[f]=!1,this[P]=Date.now(),c.apply(this,[this[w]]),this[w]=u?u():void 0},b-Date.now()))}}})}t.throttle=S}),define(Q[23],Z([0,1,12]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function T(_,q=0){return _[_.length-(1+q)]}t.tail=T;function D(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}t.tail2=D;function S(_,q,J=(h,o)=>h===o){if(_===q)return!0;if(!_||!q||_.length!==q.length)return!1;for(let h=0,o=_.length;h<o;h++)if(!J(_[h],q[h]))return!1;return!0}t.equals=S;function F(_,q,J){let h=0,o=_.length-1;for(;h<=o;){const I=(h+o)/2|0,p=J(_[I],q);if(p<0)h=I+1;else if(p>0)o=I-1;else return I}return-(h+1)}t.binarySearch=F;function O(_,q){let J=0,h=_.length;if(h===0)return 0;for(;J<h;){const o=Math.floor((J+h)/2);q(_[o])?h=o:J=o+1}return J}t.findFirstInSorted=O;function u(_,q,J){if(_=_|0,_>=q.length)throw new TypeError("invalid index");let h=q[Math.floor(q.length*Math.random())],o=[],I=[],p=[];for(let A of q){const N=J(A,h);N<0?o.push(A):N>0?I.push(A):p.push(A)}return _<o.length?u(_,o,J):_<o.length+p.length?p[0]:u(_-(o.length+p.length),I,J)}t.quickSelect=u;function c(_,q){const J=[];let h;for(const o of _.slice(0).sort(q))!h||q(h[0],o)!==0?(h=[o],J.push(h)):h.push(o);return J}t.groupBy=c;function R(_,q,J){const h=[];function o(A,N,B){if(!(N===0&&B.length===0)){const V=h[h.length-1];V&&V.start+V.deleteCount===A?(V.deleteCount+=N,V.toInsert.push(...B)):h.push({start:A,deleteCount:N,toInsert:B})}}let I=0,p=0;for(;;){if(I===_.length){o(I,0,q.slice(p));break}if(p===q.length){o(I,_.length-I,[]);break}const A=_[I],N=q[p],B=J(A,N);B===0?(I+=1,p+=1):B<0?(o(I,1,[]),I+=1):B>0&&(o(I,0,[N]),p+=1)}return h}t.sortedDiff=R;function y(_,q,J){const h=R(_,q,J),o=[],I=[];for(const p of h)o.push(..._.slice(p.start,p.start+p.deleteCount)),I.push(...p.toInsert);return{removed:o,added:I}}t.delta=y;function w(_,q,J){if(J===0)return[];const h=_.slice(0,J).sort(q);return f(_,q,h,J,_.length),h}t.top=w;function P(_,q,J,h,o){return J===0?Promise.resolve([]):new Promise((I,p)=>{(async()=>{const A=_.length,N=_.slice(0,J).sort(q);for(let B=J,V=Math.min(J+h,A);B<A;B=V,V=Math.min(V+h,A)){if(B>J&&await new Promise($=>setTimeout($)),o&&o.isCancellationRequested)throw(0,v.canceled)();f(_,q,N,B,V)}return N})().then(I,p)})}t.topAsync=P;function f(_,q,J,h,o){for(const I=J.length;h<o;h++){const p=_[h];if(q(p,J[I-1])<0){J.pop();const A=O(J,N=>q(p,N)<0);J.splice(A,0,p)}}}function d(_){return _.filter(q=>!!q)}t.coalesce=d;function b(_){let q=0;for(let J=0;J<_.length;J++)_[J]&&(_[q]=_[J],q+=1);_.length=q}t.coalesceInPlace=b;function L(_,q,J){_.splice(J,0,_.splice(q,1)[0])}t.move=L;function C(_){return!Array.isArray(_)||_.length===0}t.isFalsyOrEmpty=C;function m(_){return Array.isArray(_)&&_.length>0}t.isNonEmptyArray=m;function s(_,q){if(!q)return _.filter((h,o)=>_.indexOf(h)===o);const J=Object.create(null);return _.filter(h=>{const o=q(h);return J[o]?!1:(J[o]=!0,!0)})}t.distinct=s;function r(_){const q=new Set;return _.filter(J=>q.has(J)?!1:(q.add(J),!0))}t.distinctES6=r;function e(_){const q=Object.create(null);return J=>{const h=_(J);return q[h]?!1:(q[h]=!0,!0)}}t.uniqueFilter=e;function i(_,q){for(let J=_.length-1;J>=0;J--){const h=_[J];if(q(h))return J}return-1}t.lastIndex=i;function n(_,q){return _.length>0?_[0]:q}t.firstOrDefault=n;function a(_,q,J=(h,o)=>h===o){let h=0;for(let o=0,I=Math.min(_.length,q.length);o<I&&J(_[o],q[o]);o++)h++;return h}t.commonPrefixLength=a;function l(_){return[].concat(..._)}t.flatten=l;function g(_,q){let J=typeof q=="number"?_:0;typeof q=="number"?J=_:(J=0,q=_);const h=[];if(J<=q)for(let o=J;o<q;o++)h.push(o);else for(let o=J;o>q;o--)h.push(o);return h}t.range=g;function E(_,q,J){return _.reduce((h,o)=>(h[q(o)]=J?J(o):o,h),Object.create(null))}t.index=E;function M(_,q){return _.push(q),()=>j(_,q)}t.insert=M;function j(_,q){const J=_.indexOf(q);if(J>-1)return _.splice(J,1),q}t.remove=j;function k(_,q,J){const h=_.slice(0,q),o=_.slice(q);return h.concat(J,o)}t.arrayInsert=k;function U(_,q){let J;if(typeof q=="number"){let h=q;J=()=>{const o=Math.sin(h++)*179426549;return o-Math.floor(o)}}else J=Math.random;for(let h=_.length-1;h>0;h-=1){const o=Math.floor(J()*(h+1)),I=_[h];_[h]=_[o],_[o]=I}}t.shuffle=U;function W(_,q){const J=_.indexOf(q);J>-1&&(_.splice(J,1),_.unshift(q))}t.pushToStart=W;function H(_,q){const J=_.indexOf(q);J>-1&&(_.splice(J,1),_.push(q))}t.pushToEnd=H;function ne(_,q){return Array.isArray(_)?_.map(q):q(_)}t.mapArrayOrNot=ne;function ee(_){return Array.isArray(_)?_:[_]}t.asArray=ee;function ie(_){return _[Math.floor(Math.random()*_.length)]}t.getRandomElement=ie;function oe(_,q){for(const J of _){const h=q(J);if(h!==void 0)return h}}t.mapFind=oe}),define(Q[58],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var v;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(v=t.ScanError||(t.ScanError={}));var T;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(T=t.SyntaxKind||(t.SyntaxKind={}));var D;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(D=t.ParseErrorCode||(t.ParseErrorCode={}));var S;(function(e){e.DEFAULT={allowTrailingComma:!0}})(S=t.ParseOptions||(t.ParseOptions={}));function F(e,i=!1){let n=0,a=e.length,l="",g=0,E=16,M=0;function j(ie){let oe=0,_=0;for(;oe<ie;){const q=e.charCodeAt(n);if(q>=48&&q<=57)_=_*16+q-48;else if(q>=65&&q<=70)_=_*16+q-65+10;else if(q>=97&&q<=102)_=_*16+q-97+10;else break;n++,oe++}return oe<ie&&(_=-1),_}function k(ie){n=ie,l="",g=0,E=16,M=0}function U(){const ie=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&c(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&c(e.charCodeAt(n)))for(n++;n<e.length&&c(e.charCodeAt(n));)n++;else return M=3,e.substring(ie,n);let oe=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&c(e.charCodeAt(n))){for(n++;n<e.length&&c(e.charCodeAt(n));)n++;oe=n}else M=3;return e.substring(ie,oe)}function W(){let ie="",oe=n;for(;;){if(n>=a){ie+=e.substring(oe,n),M=2;break}const _=e.charCodeAt(n);if(_===34){ie+=e.substring(oe,n),n++;break}if(_===92){if(ie+=e.substring(oe,n),n++,n>=a){M=2;break}switch(e.charCodeAt(n++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:const J=j(4);J>=0?ie+=String.fromCharCode(J):M=4;break;default:M=5}oe=n;continue}if(_>=0&&_<=31)if(u(_)){ie+=e.substring(oe,n),M=2;break}else M=6;n++}return ie}function H(){if(l="",M=0,g=n,n>=a)return g=a,E=17;let ie=e.charCodeAt(n);if(O(ie)){do n++,l+=String.fromCharCode(ie),ie=e.charCodeAt(n);while(O(ie));return E=15}if(u(ie))return n++,l+=String.fromCharCode(ie),ie===13&&e.charCodeAt(n)===10&&(n++,l+=`
`),E=14;switch(ie){case 123:return n++,E=1;case 125:return n++,E=2;case 91:return n++,E=3;case 93:return n++,E=4;case 58:return n++,E=6;case 44:return n++,E=5;case 34:return n++,l=W(),E=10;case 47:const oe=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<a&&!u(e.charCodeAt(n));)n++;return l=e.substring(oe,n),E=12}if(e.charCodeAt(n+1)===42){n+=2;const _=a-1;let q=!1;for(;n<_;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,q=!0;break}n++}return q||(n++,M=1),l=e.substring(oe,n),E=13}return l+=String.fromCharCode(ie),n++,E=16;case 45:if(l+=String.fromCharCode(ie),n++,n===a||!c(e.charCodeAt(n)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=U(),E=11;default:for(;n<a&&ne(ie);)n++,ie=e.charCodeAt(n);if(g!==n){switch(l=e.substring(g,n),l){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return l+=String.fromCharCode(ie),n++,E=16}}function ne(ie){if(O(ie)||u(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let ie;do ie=H();while(ie>=12&&ie<=15);return ie}return{setPosition:k,getPosition:()=>n,scan:i?ee:H,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>M}}t.createScanner=F;function O(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function c(e){return e>=48&&e<=57}var R;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(R||(R={}));function y(e,i){const n=[],a=new Object;let l;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function M(j,k,U,W){g.value=j,g.offset=k,g.length=U,g.type=W,g.colonOffset=void 0,l=g}try{m(e,{onObjectBegin:(j,k)=>{if(i<=j)throw a;l=void 0,E=i>j,n.push("")},onObjectProperty:(j,k,U)=>{if(i<k||(M(j,k,U,"property"),n[n.length-1]=j,i<=k+U))throw a},onObjectEnd:(j,k)=>{if(i<=j)throw a;l=void 0,n.pop()},onArrayBegin:(j,k)=>{if(i<=j)throw a;l=void 0,n.push(0)},onArrayEnd:(j,k)=>{if(i<=j)throw a;l=void 0,n.pop()},onLiteralValue:(j,k,U)=>{if(i<k||(M(j,k,U,r(j)),i<=k+U))throw a},onSeparator:(j,k,U)=>{if(i<=k)throw a;if(j===":"&&l&&l.type==="property")l.colonOffset=k,E=!1,l=void 0;else if(j===","){const W=n[n.length-1];typeof W=="number"?n[n.length-1]=W+1:(E=!0,n[n.length-1]=""),l=void 0}}})}catch(j){if(j!==a)throw j}return{path:n,previousNode:l,isAtPropertyKey:E,matches:j=>{let k=0;for(let U=0;k<j.length&&U<n.length;U++)if(j[k]===n[U]||j[k]==="*")k++;else if(j[k]!=="**")return!1;return k===j.length}}}t.getLocation=y;function w(e,i=[],n=S.DEFAULT){let a=null,l=[];const g=[];function E(j){Array.isArray(l)?l.push(j):a!==null&&(l[a]=j)}return m(e,{onObjectBegin:()=>{const j={};E(j),g.push(l),l=j,a=null},onObjectProperty:j=>{a=j},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const j=[];E(j),g.push(l),l=j,a=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:E,onError:(j,k,U)=>{i.push({error:j,offset:k,length:U})}},n),l[0]}t.parse=w;function P(e,i=[],n=S.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(j){a.type==="property"&&(a.length=j-a.offset,a=a.parent)}function g(j){return a.children.push(j),j}m(e,{onObjectBegin:j=>{a=g({type:"object",offset:j,length:-1,parent:a,children:[]})},onObjectProperty:(j,k,U)=>{a=g({type:"property",offset:k,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:j,offset:k,length:U,parent:a})},onObjectEnd:(j,k)=>{a.length=j+k-a.offset,a=a.parent,l(j+k)},onArrayBegin:(j,k)=>{a=g({type:"array",offset:j,length:-1,parent:a,children:[]})},onArrayEnd:(j,k)=>{a.length=j+k-a.offset,a=a.parent,l(j+k)},onLiteralValue:(j,k,U)=>{g({type:r(j),offset:k,length:U,parent:a,value:j}),l(k+U)},onSeparator:(j,k,U)=>{a.type==="property"&&(j===":"?a.colonOffset=k:j===","&&l(k))},onError:(j,k,U)=>{i.push({error:j,offset:k,length:U})}},n);const M=a.children[0];return M&&delete M.parent,M}t.parseTree=P;function f(e,i){if(!!e){let n=e;for(let a of i)if(typeof a=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===a){n=g.children[1],l=!0;break}if(!l)return}else{const l=a;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}}t.findNodeAtLocation=f;function d(e){if(!e.parent||!e.parent.children)return[];const i=d(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=d;function b(e){switch(e.type){case"array":return e.children.map(b);case"object":const i=Object.create(null);for(let n of e.children){const a=n.children[1];a&&(i[n.children[0].value]=b(a))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=b;function L(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=L;function C(e,i,n=!1){if(L(e,i,n)){const a=e.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=i;l++){const g=C(a[l],i,n);if(g)return g}return e}}t.findNodeAtOffset=C;function m(e,i,n=S.DEFAULT){const a=F(e,!1);function l(N){return N?()=>N(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(N){return N?B=>N(B,a.getTokenOffset(),a.getTokenLength()):()=>!0}const E=l(i.onObjectBegin),M=g(i.onObjectProperty),j=l(i.onObjectEnd),k=l(i.onArrayBegin),U=l(i.onArrayEnd),W=g(i.onLiteralValue),H=g(i.onSeparator),ne=l(i.onComment),ee=g(i.onError),ie=n&&n.disallowComments,oe=n&&n.allowTrailingComma;function _(){for(;;){const N=a.scan();switch(a.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:ie||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(N){case 12:case 13:ie?q(10):ne();break;case 16:q(1);break;case 15:case 14:break;default:return N}}}function q(N,B=[],V=[]){if(ee(N),B.length+V.length>0){let $=a.getToken();for(;$!==17;){if(B.indexOf($)!==-1){_();break}else if(V.indexOf($)!==-1)break;$=_()}}}function J(N){const B=a.getTokenValue();return N?W(B):M(B),_(),!0}function h(){switch(a.getToken()){case 11:let N=0;try{N=JSON.parse(a.getTokenValue()),typeof N!="number"&&(q(2),N=0)}catch(B){q(2)}W(N);break;case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return _(),!0}function o(){return a.getToken()!==10?(q(3,[],[2,5]),!1):(J(!1),a.getToken()===6?(H(":"),_(),A()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function I(){E(),_();let N=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(N||q(4,[],[]),H(","),_(),a.getToken()===2&&oe)break}else N&&q(6,[],[]);o()||q(4,[],[2,5]),N=!0}return j(),a.getToken()!==2?q(7,[2],[]):_(),!0}function p(){k(),_();let N=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(N||q(4,[],[]),H(","),_(),a.getToken()===4&&oe)break}else N&&q(6,[],[]);A()||q(4,[],[4,5]),N=!0}return U(),a.getToken()!==4?q(8,[4],[]):_(),!0}function A(){switch(a.getToken()){case 3:return p();case 1:return I();case 10:return J(!0);default:return h()}}return _(),a.getToken()===17?n.allowEmptyContent?!0:(q(4,[],[]),!1):A()?(a.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}t.visit=m;function s(e,i){let n=F(e),a=[],l,g=0,E;do switch(E=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:g!==E&&a.push(e.substring(g,E)),i!==void 0&&a.push(n.getTokenValue().replace(/[^\r\n]/g,i)),g=n.getPosition();break}while(l!==17);return a.join("")}t.stripComments=s;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r});"use strict";(function(){function x(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function F(u){S.push(u,Date.now())}function O(){const u=[];for(let c=0;c<S.length;c+=2)u.push({name:S[c],startTime:S[c+1]});return u}return{mark:F,getMarks:O}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const F of performance.getEntriesByType("mark"))S.push({name:F.name,startTime:Math.round(D+F.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=t()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=v(T))})(),function(x,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var v=t();for(var T in v)(typeof exports=="object"?exports:x)[T]=v[T]}}(typeof self!="undefined"?self:this,function(){return function(x){var t={};function v(T){if(t[T])return t[T].exports;var D=t[T]={i:T,l:!1,exports:{}};return x[T].call(D.exports,D,D.exports,v),D.l=!0,D.exports}return v.m=x,v.c=t,v.d=function(T,D,S){v.o(T,D)||Object.defineProperty(T,D,{enumerable:!0,get:S})},v.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},v.t=function(T,D){if(1&D&&(T=v(T)),8&D||4&D&&typeof T=="object"&&T&&T.__esModule)return T;var S=Object.create(null);if(v.r(S),Object.defineProperty(S,"default",{enumerable:!0,value:T}),2&D&&typeof T!="string")for(var F in T)v.d(S,F,function(O){return T[O]}.bind(null,F));return S},v.n=function(T){var D=T&&T.__esModule?function(){return T.default}:function(){return T};return v.d(D,"a",D),D},v.o=function(T,D){return Object.prototype.hasOwnProperty.call(T,D)},v.p="",v(v.s=0)}([function(x,t,v){(function(T){var D;t=x.exports=V,D=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var S=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,O=t.re=[],u=t.src=[],c=0,R=c++;u[R]="0|[1-9]\\d*";var y=c++;u[y]="[0-9]+";var w=c++;u[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;u[P]="("+u[R]+")\\.("+u[R]+")\\.("+u[R]+")";var f=c++;u[f]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var d=c++;u[d]="(?:"+u[R]+"|"+u[w]+")";var b=c++;u[b]="(?:"+u[y]+"|"+u[w]+")";var L=c++;u[L]="(?:-("+u[d]+"(?:\\."+u[d]+")*))";var C=c++;u[C]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var m=c++;u[m]="[0-9A-Za-z-]+";var s=c++;u[s]="(?:\\+("+u[m]+"(?:\\."+u[m]+")*))";var r=c++,e="v?"+u[P]+u[L]+"?"+u[s]+"?";u[r]="^"+e+"$";var i="[v=\\s]*"+u[f]+u[C]+"?"+u[s]+"?",n=c++;u[n]="^"+i+"$";var a=c++;u[a]="((?:<|>)?=?)";var l=c++;u[l]=u[y]+"|x|X|\\*";var g=c++;u[g]=u[R]+"|x|X|\\*";var E=c++;u[E]="[v=\\s]*("+u[g]+")(?:\\.("+u[g]+")(?:\\.("+u[g]+")(?:"+u[L]+")?"+u[s]+"?)?)?";var M=c++;u[M]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[C]+")?"+u[s]+"?)?)?";var j=c++;u[j]="^"+u[a]+"\\s*"+u[E]+"$";var k=c++;u[k]="^"+u[a]+"\\s*"+u[M]+"$";var U=c++;u[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=c++;u[W]="(?:~>?)";var H=c++;u[H]="(\\s*)"+u[W]+"\\s+",O[H]=new RegExp(u[H],"g");var ne=c++;u[ne]="^"+u[W]+u[E]+"$";var ee=c++;u[ee]="^"+u[W]+u[M]+"$";var ie=c++;u[ie]="(?:\\^)";var oe=c++;u[oe]="(\\s*)"+u[ie]+"\\s+",O[oe]=new RegExp(u[oe],"g");var _=c++;u[_]="^"+u[ie]+u[E]+"$";var q=c++;u[q]="^"+u[ie]+u[M]+"$";var J=c++;u[J]="^"+u[a]+"\\s*("+i+")$|^$";var h=c++;u[h]="^"+u[a]+"\\s*("+e+")$|^$";var o=c++;u[o]="(\\s*)"+u[a]+"\\s*("+i+"|"+u[E]+")",O[o]=new RegExp(u[o],"g");var I=c++;u[I]="^\\s*("+u[E]+")\\s+-\\s+("+u[E]+")\\s*$";var p=c++;u[p]="^\\s*("+u[M]+")\\s+-\\s+("+u[M]+")\\s*$";var A=c++;u[A]="(<|>)?=?\\s*\\*";for(var N=0;N<35;N++)D(N,u[N]),O[N]||(O[N]=new RegExp(u[N]));function B(z,G){if(z instanceof V)return z;if(typeof z!="string"||z.length>S||!(G?O[n]:O[r]).test(z))return null;try{return new V(z,G)}catch(K){return null}}function V(z,G){if(z instanceof V){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>S)throw new TypeError("version is longer than "+S+" characters");if(!(this instanceof V))return new V(z,G);D("SemVer",z,G),this.loose=G;var K=z.trim().match(G?O[n]:O[r]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ae=+se;if(ae>=0&&ae<F)return ae}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=B,t.valid=function(z,G){var K=B(z,G);return K?K.version:null},t.clean=function(z,G){var K=B(z.trim().replace(/^[=v]+/,""),G);return K?K.version:null},t.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(z){return D("SemVer.compare",this.version,this.loose,z),z instanceof V||(z=new V(z,this.loose)),this.compareMain(z)||this.comparePre(z)},V.prototype.compareMain=function(z){return z instanceof V||(z=new V(z,this.loose)),X(this.major,z.major)||X(this.minor,z.minor)||X(this.patch,z.patch)},V.prototype.comparePre=function(z){if(z instanceof V||(z=new V(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],se=z.prerelease[G];if(D("prerelease compare",G,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return X(K,se)}while(++G)},V.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,G,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new V(z,K).inc(G,se).version}catch(ae){return null}},t.diff=function(z,G){if(le(z,G))return null;var K=B(z),se=B(G);if(K.prerelease.length||se.prerelease.length){for(var ae in K)if((ae==="major"||ae==="minor"||ae==="patch")&&K[ae]!==se[ae])return"pre"+ae;return"prerelease"}for(var ae in K)if((ae==="major"||ae==="minor"||ae==="patch")&&K[ae]!==se[ae])return ae},t.compareIdentifiers=X;var $=/^[0-9]+$/;function X(z,G){var K=$.test(z),se=$.test(G);return K&&se&&(z=+z,G=+G),K&&!se?-1:se&&!K?1:z<G?-1:z>G?1:0}function Y(z,G,K){return new V(z,K).compare(new V(G,K))}function te(z,G,K){return Y(z,G,K)>0}function re(z,G,K){return Y(z,G,K)<0}function le(z,G,K){return Y(z,G,K)===0}function ge(z,G,K){return Y(z,G,K)!==0}function Ie(z,G,K){return Y(z,G,K)>=0}function Fe(z,G,K){return Y(z,G,K)<=0}function Le(z,G,K,se){var ae;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),ae=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),ae=z!==K;break;case"":case"=":case"==":ae=le(z,K,se);break;case"!=":ae=ge(z,K,se);break;case">":ae=te(z,K,se);break;case">=":ae=Ie(z,K,se);break;case"<":ae=re(z,K,se);break;case"<=":ae=Fe(z,K,se);break;default:throw new TypeError("Invalid operator: "+G)}return ae}function Ee(z,G){if(z instanceof Ee){if(z.loose===G)return z;z=z.value}if(!(this instanceof Ee))return new Ee(z,G);D("comparator",z,G),this.loose=G,this.parse(z),this.semver===Ne?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}t.rcompareIdentifiers=function(z,G){return X(G,z)},t.major=function(z,G){return new V(z,G).major},t.minor=function(z,G){return new V(z,G).minor},t.patch=function(z,G){return new V(z,G).patch},t.compare=Y,t.compareLoose=function(z,G){return Y(z,G,!0)},t.rcompare=function(z,G,K){return Y(G,z,K)},t.sort=function(z,G){return z.sort(function(K,se){return t.compare(K,se,G)})},t.rsort=function(z,G){return z.sort(function(K,se){return t.rcompare(K,se,G)})},t.gt=te,t.lt=re,t.eq=le,t.neq=ge,t.gte=Ie,t.lte=Fe,t.cmp=Le,t.Comparator=Ee;var Ne={};function pe(z,G){if(z instanceof pe)return z.loose===G?z:new pe(z.raw,G);if(z instanceof Ee)return new pe(z.value,G);if(!(this instanceof pe))return new pe(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function We(z,G,K,se,ae,be,de,Ce,we,Oe,ke,Se,Pe){return((G=Re(K)?"":Re(se)?">="+K+".0.0":Re(ae)?">="+K+"."+se+".0":">="+G)+" "+(Ce=Re(we)?"":Re(Oe)?"<"+(+we+1)+".0.0":Re(ke)?"<"+we+"."+(+Oe+1)+".0":Se?"<="+we+"."+Oe+"."+ke+"-"+Se:"<="+Ce)).trim()}function xe(z,G){for(var K=0;K<z.length;K++)if(!z[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<z.length;K++)if(D(z[K].semver),z[K].semver!==Ne&&z[K].semver.prerelease.length>0){var se=z[K].semver;if(se.major===G.major&&se.minor===G.minor&&se.patch===G.patch)return!0}return!1}return!0}function Ue(z,G,K){try{G=new pe(G,K)}catch(se){return!1}return G.test(z)}function ze(z,G,K,se){var ae,be,de,Ce,we;switch(z=new V(z,se),G=new pe(G,se),K){case">":ae=te,be=Fe,de=re,Ce=">",we=">=";break;case"<":ae=re,be=Ie,de=te,Ce="<",we="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,G,se))return!1;for(var Oe=0;Oe<G.set.length;++Oe){var ke=G.set[Oe],Se=null,Pe=null;if(ke.forEach(function(Te){Te.semver===Ne&&(Te=new Ee(">=0.0.0")),Se=Se||Te,Pe=Pe||Te,ae(Te.semver,Se.semver,se)?Se=Te:de(Te.semver,Pe.semver,se)&&(Pe=Te)}),Se.operator===Ce||Se.operator===we||(!Pe.operator||Pe.operator===Ce)&&be(z,Pe.semver)||Pe.operator===we&&de(z,Pe.semver))return!1}return!0}Ee.prototype.parse=function(z){var G=this.loose?O[J]:O[h],K=z.match(G);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new V(K[2],this.loose):this.semver=Ne},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(z){return D("Comparator.test",z,this.loose),this.semver===Ne||(typeof z=="string"&&(z=new V(z,this.loose)),Le(z,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(z,G){if(!(z instanceof Ee))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new pe(z.value,G),Ue(this.value,K,G);if(z.operator==="")return K=new pe(this.value,G),Ue(z.semver,K,G);var se=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ae=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),be=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ce=Le(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),we=Le(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return se||ae||be&&de||Ce||we},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),D("range",z,G);var K=G?O[p]:O[I];z=z.replace(K,We),D("hyphen replace",z),z=z.replace(O[o],"$1$2$3"),D("comparator trim",z,O[o]),z=(z=(z=z.replace(O[H],"$1~")).replace(O[oe],"$1^")).split(/\s+/).join(" ");var se=G?O[J]:O[h],ae=z.split(" ").map(function(be){return function(de,Ce){return D("comp",de),de=function(we,Oe){return we.trim().split(/\s+/).map(function(ke){return function(Se,Pe){D("caret",Se,Pe);var Te=Pe?O[q]:O[_];return Se.replace(Te,function(Ae,ce,he,me,ve){var De;return D("caret",Se,Ae,ce,he,me,ve),Re(ce)?De="":Re(he)?De=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(me)?De=ce==="0"?">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+".0 <"+(+ce+1)+".0.0":ve?(D("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=ce==="0"?he==="0"?">="+ce+"."+he+"."+me+ve+" <"+ce+"."+he+"."+(+me+1):">="+ce+"."+he+"."+me+ve+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+me+ve+" <"+(+ce+1)+".0.0"):(D("no pr"),De=ce==="0"?he==="0"?">="+ce+"."+he+"."+me+" <"+ce+"."+he+"."+(+me+1):">="+ce+"."+he+"."+me+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+me+" <"+(+ce+1)+".0.0"),D("caret return",De),De})}(ke,Oe)}).join(" ")}(de,Ce),D("caret",de),de=function(we,Oe){return we.trim().split(/\s+/).map(function(ke){return function(Se,Pe){var Te=Pe?O[ee]:O[ne];return Se.replace(Te,function(Ae,ce,he,me,ve){var De;return D("tilde",Se,Ae,ce,he,me,ve),Re(ce)?De="":Re(he)?De=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(me)?De=">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":ve?(D("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=">="+ce+"."+he+"."+me+ve+" <"+ce+"."+(+he+1)+".0"):De=">="+ce+"."+he+"."+me+" <"+ce+"."+(+he+1)+".0",D("tilde return",De),De})}(ke,Oe)}).join(" ")}(de,Ce),D("tildes",de),de=function(we,Oe){return D("replaceXRanges",we,Oe),we.split(/\s+/).map(function(ke){return function(Se,Pe){Se=Se.trim();var Te=Pe?O[k]:O[j];return Se.replace(Te,function(Ae,ce,he,me,ve,De){D("xRange",Se,Ae,ce,he,me,ve,De);var _e=Re(he),Me=_e||Re(me),je=Me||Re(ve);return ce==="="&&je&&(ce=""),_e?Ae=ce===">"||ce==="<"?"<0.0.0":"*":ce&&je?(Me&&(me=0),je&&(ve=0),ce===">"?(ce=">=",Me?(he=+he+1,me=0,ve=0):je&&(me=+me+1,ve=0)):ce==="<="&&(ce="<",Me?he=+he+1:me=+me+1),Ae=ce+he+"."+me+"."+ve):Me?Ae=">="+he+".0.0 <"+(+he+1)+".0.0":je&&(Ae=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0"),D("xRange return",Ae),Ae})}(ke,Oe)}).join(" ")}(de,Ce),D("xrange",de),de=function(we,Oe){return D("replaceStars",we,Oe),we.trim().replace(O[A],"")}(de,Ce),D("stars",de),de}(be,G)}).join(" ").split(/\s+/);return this.loose&&(ae=ae.filter(function(be){return!!be.match(se)})),ae=ae.map(function(be){return new Ee(be,G)})},pe.prototype.intersects=function(z,G){if(!(z instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return z.set.some(function(ae){return ae.every(function(be){return se.intersects(be,G)})})})})},t.toComparators=function(z,G){return new pe(z,G).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new V(z,this.loose));for(var G=0;G<this.set.length;G++)if(xe(this.set[G],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,G,K){var se=null,ae=null;try{var be=new pe(G,K)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(se&&ae.compare(de)!==-1||(ae=new V(se=de,K)))}),se},t.minSatisfying=function(z,G,K){var se=null,ae=null;try{var be=new pe(G,K)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(se&&ae.compare(de)!==1||(ae=new V(se=de,K)))}),se},t.validRange=function(z,G){try{return new pe(z,G).range||"*"}catch(K){return null}},t.ltr=function(z,G,K){return ze(z,G,"<",K)},t.gtr=function(z,G,K){return ze(z,G,">",K)},t.outside=ze,t.prerelease=function(z,G){var K=B(z,G);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(z,G,K){return z=new pe(z,K),G=new pe(G,K),z.intersects(G)},t.coerce=function(z){if(z instanceof V)return z;if(typeof z!="string")return null;var G=z.match(O[U]);return G==null?null:B((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,v(1))},function(x,t){var v,T,D=x.exports={};function S(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function O(b){if(v===setTimeout)return setTimeout(b,0);if((v===S||!v)&&setTimeout)return v=setTimeout,setTimeout(b,0);try{return v(b,0)}catch(L){try{return v.call(null,b,0)}catch(C){return v.call(this,b,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:S}catch(b){v=S}try{T=typeof clearTimeout=="function"?clearTimeout:F}catch(b){T=F}})();var u,c=[],R=!1,y=-1;function w(){R&&u&&(R=!1,u.length?c=u.concat(c):y=-1,c.length&&P())}function P(){if(!R){var b=O(w);R=!0;for(var L=c.length;L;){for(u=c,c=[];++y<L;)u&&u[y].run();y=-1,L=c.length}u=null,R=!1,function(C){if(T===clearTimeout)return clearTimeout(C);if((T===F||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(C);try{T(C)}catch(m){try{return T.call(null,C)}catch(s){return T.call(this,C)}}}(b)}}function f(b,L){this.fun=b,this.array=L}function d(){}D.nextTick=function(b){var L=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)L[C-1]=arguments[C];c.push(new f(b,L)),c.length!==1||R||O(P)},f.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=d,D.addListener=d,D.once=d,D.off=d,D.removeListener=d,D.removeAllListeners=d,D.emit=d,D.prependListener=d,D.prependOnceListener=d,D.listeners=function(b){return[]},D.binding=function(b){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(b){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Q[35],Z([0,1,12,2]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function D(m){const s=m;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=D;function S(m){const s=m;return s?D(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=S;function F(m,s){return new O(m,s)}t.newWriteableStream=F;class O{constructor(s,r){this.reducer=s,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(r=>r(s))}emitError(s){this.listeners.error.length===0?(0,v.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(r=>r(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,r){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(s,r){if(!this.state.destroyed){let e;switch(s){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(r);i>=0&&e.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(m,s){const r=[];let e;for(;(e=m.read())!==null;)r.push(e);return s(r)}t.consumeReadable=u;function c(m,s,r){const e=[];let i;for(;(i=m.read())!==null&&e.length<r;)e.push(i);return i===null&&e.length>0?s(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return m.read()}}}t.peekReadable=c;function R(m,s){return new Promise((r,e)=>{const i=[];y(m,{onData:n=>{s&&i.push(n)},onError:n=>{s?e(n):r(void 0)},onEnd:()=>{r(s?s(i):void 0)}})})}t.consumeStream=R;function y(m,s){m.on("error",r=>s.onError(r)),m.on("end",()=>s.onEnd()),m.on("data",r=>s.onData(r))}t.listenStream=y;function w(m,s){return new Promise((r,e)=>{const i=new T.DisposableStore,n=[],a=E=>{if(n.push(E),n.length>s)return i.dispose(),m.pause(),r({stream:m,buffer:n,ended:!1})},l=E=>e(E),g=()=>r({stream:m,buffer:n,ended:!0});i.add((0,T.toDisposable)(()=>m.removeListener("error",l))),m.on("error",l),i.add((0,T.toDisposable)(()=>m.removeListener("end",g))),m.on("end",g),i.add((0,T.toDisposable)(()=>m.removeListener("data",a))),m.on("data",a)})}t.peekStream=w;function P(m,s){const r=F(s);return r.end(m),r}t.toStream=P;function f(){const m=F(()=>{throw new Error("not supported")});return m.end(),m}t.emptyStream=f;function d(m){let s=!1;return{read:()=>s?null:(s=!0,m)}}t.toReadable=d;function b(m,s,r){const e=F(r);return y(m,{onData:i=>e.write(s.data(i)),onError:i=>e.error(s.error?s.error(i):i),onEnd:()=>e.end()}),e}t.transform=b;function L(m,s,r){let e=!1;return{read:()=>{const i=s.read();return e?i:(e=!0,i!==null?r([m,i]):m)}}}t.prefixedReadable=L;function C(m,s,r){let e=!1;const i=F(r);return y(s,{onData:n=>e?i.write(n):(e=!0,i.write(r([m,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(m)),i.end()}}),i}t.prefixedStream=C}),define(Q[16],Z([0,1,20,35]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",F=typeof TextDecoder!="undefined";let O,u;class c{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return D?new c(Buffer.allocUnsafe(E)):new c(new Uint8Array(E))}static wrap(E){return D&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new c(E)}static fromString(E,M){return!((M==null?void 0:M.dontUseNodeBuffer)||!1)&&D?new c(Buffer.from(E)):S?(O||(O=new TextEncoder),new c(O.encode(E))):new c(v.encodeUTF8(E))}static concat(E,M){if(typeof M=="undefined"){M=0;for(let U=0,W=E.length;U<W;U++)M+=E[U].byteLength}const j=c.alloc(M);let k=0;for(let U=0,W=E.length;U<W;U++){const H=E[U];j.set(H,k),k+=H.byteLength}return j}toString(){return D?this.buffer.toString():F?(u||(u=new TextDecoder),u.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(E,M){return new c(this.buffer.subarray(E,M))}set(E,M){E instanceof c?this.buffer.set(E.buffer,M):this.buffer.set(E,M)}readUInt32BE(E){return w(this.buffer,E)}writeUInt32BE(E,M){P(this.buffer,E,M)}readUInt32LE(E){return f(this.buffer,E)}writeUInt32LE(E,M){d(this.buffer,E,M)}readUInt8(E){return b(this.buffer,E)}writeUInt8(E,M){L(this.buffer,E,M)}}t.VSBuffer=c;function R(g,E){return g[E+0]<<0>>>0|g[E+1]<<8>>>0}t.readUInt16LE=R;function y(g,E,M){g[M+0]=E&255,E=E>>>8,g[M+1]=E&255}t.writeUInt16LE=y;function w(g,E){return g[E]*2**24+g[E+1]*2**16+g[E+2]*2**8+g[E+3]}t.readUInt32BE=w;function P(g,E,M){g[M+3]=E,E=E>>>8,g[M+2]=E,E=E>>>8,g[M+1]=E,E=E>>>8,g[M]=E}t.writeUInt32BE=P;function f(g,E){return g[E+0]<<0>>>0|g[E+1]<<8>>>0|g[E+2]<<16>>>0|g[E+3]<<24>>>0}t.readUInt32LE=f;function d(g,E,M){g[M+0]=E&255,E=E>>>8,g[M+1]=E&255,E=E>>>8,g[M+2]=E&255,E=E>>>8,g[M+3]=E&255}t.writeUInt32LE=d;function b(g,E){return g[E]}t.readUInt8=b;function L(g,E,M){g[M]=E}t.writeUInt8=L;function C(g){return T.consumeReadable(g,E=>c.concat(E))}t.readableToBuffer=C;function m(g){return T.toReadable(g)}t.bufferToReadable=m;function s(g){return T.consumeStream(g,E=>c.concat(E))}t.streamToBuffer=s;async function r(g){return g.ended?c.concat(g.buffer):c.concat([...g.buffer,await s(g.stream)])}t.bufferedStreamToBuffer=r;function e(g){return T.toStream(g,E=>c.concat(E))}t.bufferToStream=e;function i(g){return T.transform(g,{data:E=>typeof E=="string"?c.fromString(E):c.wrap(E)},E=>c.concat(E))}t.streamToBufferReadableStream=i;function n(g){return T.newWriteableStream(E=>c.concat(E),g)}t.newWriteableBufferStream=n;function a(g,E){return T.prefixedReadable(g,E,M=>c.concat(M))}t.prefixedBufferReadable=a;function l(g,E){return T.prefixedStream(g,E,M=>c.concat(M))}t.prefixedBufferStream=l}),define(Q[21],Z([0,1,11]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function T(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const b=Array.isArray(d)?[]:{};return Object.keys(d).forEach(L=>{d[L]&&typeof d[L]=="object"?b[L]=T(d[L]):b[L]=d[L]}),b}t.deepClone=T;function D(d){if(!d||typeof d!="object")return d;const b=[d];for(;b.length>0;){const L=b.shift();Object.freeze(L);for(const C in L)if(S.call(L,C)){const m=L[C];typeof m=="object"&&!Object.isFrozen(m)&&b.push(m)}}return d}t.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function F(d,b){return O(d,b,new Set)}t.cloneAndChange=F;function O(d,b,L){if((0,v.isUndefinedOrNull)(d))return d;const C=b(d);if(typeof C!="undefined")return C;if((0,v.isArray)(d)){const m=[];for(const s of d)m.push(O(s,b,L));return m}if((0,v.isObject)(d)){if(L.has(d))throw new Error("Cannot clone recursive data-structure");L.add(d);const m={};for(let s in d)S.call(d,s)&&(m[s]=O(d[s],b,L));return L.delete(d),m}return d}function u(d,b,L=!0){return(0,v.isObject)(d)?((0,v.isObject)(b)&&Object.keys(b).forEach(C=>{C in d?L&&((0,v.isObject)(d[C])&&(0,v.isObject)(b[C])?u(d[C],b[C],L):d[C]=b[C]):d[C]=b[C]}),d):b}t.mixin=u;function c(d,b){if(d===b)return!0;if(d==null||b===null||b===void 0||typeof d!=typeof b||typeof d!="object"||Array.isArray(d)!==Array.isArray(b))return!1;let L,C;if(Array.isArray(d)){if(d.length!==b.length)return!1;for(L=0;L<d.length;L++)if(!c(d[L],b[L]))return!1}else{const m=[];for(C in d)m.push(C);m.sort();const s=[];for(C in b)s.push(C);if(s.sort(),!c(m,s))return!1;for(L=0;L<m.length;L++)if(!c(d[m[L]],b[m[L]]))return!1}return!0}t.equals=c;function R(d){const b=new Set;return JSON.stringify(d,(L,C)=>{if((0,v.isObject)(C)||Array.isArray(C)){if(b.has(C))return"[Circular]";b.add(C)}return C})}t.safeStringify=R;function y(d,b,L){const C=b(d);return typeof C=="undefined"?L:C}t.getOrDefault=y;function w(d,b){const L=Object.create(null);return!d||!b||Object.keys(b).forEach(m=>{const s=d[m],r=b[m];c(s,r)||(L[m]=r)}),L}t.distinct=w;function P(d,b){const L=b.toLowerCase(),C=Object.keys(d).find(m=>m.toLowerCase()===L);return C?d[C]:d[b]}t.getCaseInsensitive=P;function f(d,b){const L=Object.create(null);for(const C of Object.keys(d))b(C,d[C])&&(L[C]=d[C]);return L}t.filter=f}),define(Q[59],Z([0,1,7]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function T(c){const R=c;return R&&typeof R.type=="string"&&typeof R.severity=="string"}t.isRemoteConsoleLog=T;function D(c){const R=[];let y;try{const w=JSON.parse(c.arguments),P=w[w.length-1];P&&P.__$stack&&(w.pop(),y=P.__$stack),R.push(...w)}catch(w){R.push("Unable to log remote console arguments",c.arguments)}return{args:R,stack:y}}t.parse=D;function S(c){if(typeof c!="string")return S(D(c).stack);const R=c;if(R){const y=F(R),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(w&&w.length===4)return{uri:v.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}t.getFirstFrame=S;function F(c){if(!c)return c;const R=c.indexOf(`
`);return R===-1?c:c.substring(0,R)}function O(c,R){const{args:y,stack:w}=D(c),P=typeof y[0]=="string"&&y.length===1;let f=F(w);f&&(f=`(${f.trim()})`);let d=[];if(typeof y[0]=="string"?f&&P?d=[`%c[${R}] %c${y[0]} %c${f}`,u("blue"),u(""),u("grey")]:d=[`%c[${R}] %c${y[0]}`,u("blue"),u(""),...y.slice(1)]:d=[`%c[${R}]%`,u("blue"),...y],f&&!P&&d.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,d)}t.log=O;function u(c){return`color: ${c}`}}),define(Q[60],Z([0,1,16,20,7]),function(x,t,v,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function S(c){return JSON.stringify(c,O)}t.stringify=S;function F(c){let R=JSON.parse(c);return R=u(R),R}t.parse=F;function O(c,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,T.regExpFlags)(R)}:R}function u(c,R=0){if(!c||R>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return D.URI.revive(c);case 2:return new RegExp(c.source,c.flags)}if(c instanceof v.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let y=0;y<c.length;++y)c[y]=u(c[y],R+1);else for(const y in c)Object.hasOwnProperty.call(c,y)&&(c[y]=u(c[y],R+1))}return c}t.revive=u}),define(Q[61],Z([0,1,20,36,3,45,4]),function(x,t,v,T,D,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function O(){return Object.create(null)}t.getEmptyExpression=O;const u="**",c="/",R="[/\\\\]",y="[^/\\\\]",w=/\//g;function P(o){switch(o){case 0:return"";case 1:return`${y}*?`;default:return`(?:${R}|${y}+${R}|${R}${y}+)*?`}}function f(o,I){if(!o)return[];const p=[];let A=!1,N=!1,B="";for(const V of o){switch(V){case I:if(!A&&!N){p.push(B),B="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":N=!0;break;case"]":N=!1;break}B+=V}return B&&p.push(B),p}t.splitGlobAware=f;function d(o){if(!o)return"";let I="";const p=f(o,c);if(p.every(A=>A===u))I=".*";else{let A=!1;p.forEach((N,B)=>{if(N===u){A||(I+=P(2),A=!0);return}let V=!1,$="",X=!1,Y="";for(const te of N){if(te!=="}"&&V){$+=te;continue}if(X&&(te!=="]"||!Y)){let re;te==="-"?re=te:(te==="^"||te==="!")&&!Y?re="^":te===c?re="":re=v.escapeRegExpCharacters(te),Y+=re;continue}switch(te){case"{":V=!0;continue;case"[":X=!0;continue;case"}":I+=`(?:${f($,",").map(ge=>d(ge)).join("|")})`,V=!1,$="";break;case"]":I+="["+Y+"]",X=!1,Y="";break;case"?":I+=y;continue;case"*":I+=P(1);continue;default:I+=v.escapeRegExpCharacters(te)}}B<p.length-1&&(p[B+1]!==u||B+2<p.length)&&(I+=R),A=!1})}return I}const b=/^\*\*\/\*\.[\w\.-]+$/,L=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),i=function(){return!1},n=function(){return null};function a(o,I){if(!o)return n;let p;typeof o!="string"?p=o.pattern:p=o,p=p.trim();const A=`${p}_${!!I.trimForExclusions}`;let N=e.get(A);if(N)return l(N,o);let B;if(b.test(p)){const V=p.substr(4);N=function($,X){return typeof $=="string"&&$.endsWith(V)?p:null}}else(B=L.exec(g(p,I)))?N=E(B[1],p):(I.trimForExclusions?m:C).test(p)?N=M(p,I):(B=s.exec(g(p,I)))?N=j(B[1].substr(1),p,!0):(B=r.exec(g(p,I)))?N=j(B[1],p,!1):N=k(p);return e.set(A,N),l(N,o)}function l(o,I){return typeof I=="string"?o:function(p,A){return T.isEqualOrParent(p,I.base)?o(D.relative(I.base,p),A):null}}function g(o,I){return I.trimForExclusions&&o.endsWith("/**")?o.substr(0,o.length-2):o}function E(o,I){const p=`/${o}`,A=`\\${o}`,N=function(V,$){return typeof V!="string"?null:$?$===o?I:null:V===o||V.endsWith(p)||V.endsWith(A)?I:null},B=[o];return N.basenames=B,N.patterns=[I],N.allBasenames=B,N}function M(o,I){const p=h(o.slice(1,-1).split(",").map($=>a($,I)).filter($=>$!==n),o),A=p.length;if(!A)return n;if(A===1)return p[0];const N=function($,X){for(let Y=0,te=p.length;Y<te;Y++)if(p[Y]($,X))return o;return null},B=p.find($=>!!$.allBasenames);B&&(N.allBasenames=B.allBasenames);const V=p.reduce(($,X)=>X.allPaths?$.concat(X.allPaths):$,[]);return V.length&&(N.allPaths=V),N}function j(o,I,p){const A=D.sep===D.posix.sep,N=A?o:o.replace(w,D.sep),B=D.sep+N,V=D.posix.sep+o,$=p?function(X,Y){return typeof X=="string"&&(X===N||X.endsWith(B)||!A&&(X===o||X.endsWith(V)))?I:null}:function(X,Y){return typeof X=="string"&&(X===N||!A&&X===o)?I:null};return $.allPaths=[(p?"*/":"./")+o],$}function k(o){try{const I=new RegExp(`^${d(o)}$`);return function(p){return I.lastIndex=0,typeof p=="string"&&I.test(p)?o:null}}catch(I){return n}}function U(o,I,p){return!o||typeof I!="string"?!1:W(o)(I,void 0,p)}t.match=U;function W(o,I={}){if(!o)return i;if(typeof o=="string"||ie(o)){const p=a(o,I);if(p===n)return i;const A=function(N,B){return!!p(N,B)};return p.allBasenames&&(A.allBasenames=p.allBasenames),p.allPaths&&(A.allPaths=p.allPaths),A}return q(o,I)}t.parse=W;function H(o){if(!!o){let I;return p=>(I||(I=(o()||Promise.resolve([])).then(A=>A?ee(A):{})),I.then(A=>!!A[p]))}}t.hasSiblingPromiseFn=H;function ne(o){if(!!o){let I;return p=>{if(!I){const A=o();I=A?ee(A):{}}return!!I[p]}}}t.hasSiblingFn=ne;function ee(o){const I={};for(const p of o)I[p]=!0;return I}function ie(o){const I=o;return I&&typeof I.base=="string"&&typeof I.pattern=="string"}t.isRelativePattern=ie;function oe(o){return o.allBasenames||[]}t.getBasenameTerms=oe;function _(o){return o.allPaths||[]}t.getPathTerms=_;function q(o,I){const p=h(Object.getOwnPropertyNames(o).map($=>J($,o[$],I)).filter($=>$!==n)),A=p.length;if(!A)return n;if(!p.some($=>!!$.requiresSiblings)){if(A===1)return p[0];const $=function(te,re){for(let le=0,ge=p.length;le<ge;le++){const Ie=p[le](te,re);if(Ie)return Ie}return null},X=p.find(te=>!!te.allBasenames);X&&($.allBasenames=X.allBasenames);const Y=p.reduce((te,re)=>re.allPaths?te.concat(re.allPaths):te,[]);return Y.length&&($.allPaths=Y),$}const N=function($,X,Y){let te;for(let re=0,le=p.length;re<le;re++){const ge=p[re];ge.requiresSiblings&&Y&&(X||(X=D.basename($)),te||(te=X.substr(0,X.length-D.extname($).length)));const Ie=ge($,X,te,Y);if(Ie)return Ie}return null},B=p.find($=>!!$.allBasenames);B&&(N.allBasenames=B.allBasenames);const V=p.reduce(($,X)=>X.allPaths?$.concat(X.allPaths):$,[]);return V.length&&(N.allPaths=V),N}function J(o,I,p){if(I===!1)return n;const A=a(o,p);if(A===n)return n;if(typeof I=="boolean")return A;if(I){const N=I.when;if(typeof N=="string"){const B=(V,$,X,Y)=>{if(!Y||!A(V,$))return null;const te=N.replace("$(basename)",X),re=Y(te);return(0,F.isThenable)(re)?re.then(le=>le?o:null):re?o:null};return B.requiresSiblings=!0,B}}return A}function h(o,I){const p=o.filter($=>!!$.basenames);if(p.length<2)return o;const A=p.reduce(($,X)=>{const Y=X.basenames;return Y?$.concat(Y):$},[]);let N;if(I){N=[];for(let $=0,X=A.length;$<X;$++)N.push(I)}else N=p.reduce(($,X)=>{const Y=X.patterns;return Y?$.concat(Y):$},[]);const B=function($,X){if(typeof $!="string")return null;if(!X){let te;for(te=$.length;te>0;te--){const re=$.charCodeAt(te-1);if(re===47||re===92)break}X=$.substr(te)}const Y=A.indexOf(X);return Y!==-1?N[Y]:null};B.basenames=A,B.patterns=N,B.allBasenames=A;const V=o.filter($=>!$.basenames);return V.push(B),V}}),define(Q[62],Z([0,1,7,3,20,8,13,17,36]),function(x,t,v,T,D,S,F,O,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function c(a,l,g){if(typeof a=="string"&&(a=v.URI.file(a)),g){const M=g.getWorkspaceFolder(a);if(M){const j=g.getWorkspace().folders.length>1;let k;if((0,O.isEqual)(M.uri,a)?k="":k=(0,O.relativePath)(M.uri,a),j){const U=M.name?M.name:(0,O.basename)(M.uri);k=k?U+" \u2022 "+k:U}return k}}if(a.scheme!==S.Schemas.file&&a.scheme!==S.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,u.hasDriveLetter)(a.fsPath))return(0,T.normalize)(y(a.fsPath));let E=(0,T.normalize)(a.fsPath);return!F.isWindows&&(l==null?void 0:l.userHome)&&(E=P(E,l.userHome.fsPath)),E}t.getPathLabel=c;function R(a){if(!!a){typeof a=="string"&&(a=v.URI.file(a));const l=(0,O.basename)(a)||(a.scheme===S.Schemas.file?a.fsPath:a.path);return F.isWindows&&(0,u.isRootOrDriveLetter)(l)?y(l):l}}t.getBaseLabel=R;function y(a){return(0,u.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}t.normalizeDriveLetter=y;let w=Object.create(null);function P(a,l){if(F.isWindows||!a||!l)return a;let g=w.original===l?w.normalized:void 0;return g||(g=`${(0,D.rtrim)(l,T.posix.sep)}${T.posix.sep}`,w={original:l,normalized:g}),(F.isLinux?a.startsWith(g):(0,D.startsWithIgnoreCase)(a,g))&&(a=`~/${a.substr(g.length)}`),a}t.tildify=P;function f(a,l){return a.replace(/^~($|\/|\\)/,`${l}$1`)}t.untildify=f;const d="\u2026",b="\\\\",L="~";function C(a,l=T.sep){const g=new Array(a.length);let E=!1;for(let M=0;M<a.length;M++){let j=a[M];if(j===""){g[M]=`.${l}`;continue}if(!j){g[M]=j;continue}E=!0;let k="";j.indexOf(b)===0?(k=j.substr(0,j.indexOf(b)+b.length),j=j.substr(j.indexOf(b)+b.length)):j.indexOf(l)===0?(k=j.substr(0,j.indexOf(l)+l.length),j=j.substr(j.indexOf(l)+l.length)):j.indexOf(L)===0&&(k=j.substr(0,j.indexOf(L)+L.length),j=j.substr(j.indexOf(L)+L.length));const U=j.split(l);for(let W=1;E&&W<=U.length;W++)for(let H=U.length-W;E&&H>=0;H--){E=!1;let ne=U.slice(H,H+W).join(l);for(let ee=0;!E&&ee<a.length;ee++)if(ee!==M&&a[ee]&&a[ee].indexOf(ne)>-1){const ie=H+W===U.length,oe=H>0&&a[ee].indexOf(l)>-1?l+ne:ne,_=a[ee].endsWith(oe);E=!ie||_}if(!E){let ee="";(U[0].endsWith(":")||k!=="")&&(H===1&&(H=0,W++,ne=U[0]+l+ne),H>0&&(ee=U[0]+l),ee=k+ee),H>0&&(ee=ee+d+l),ee=ee+ne,H+W<U.length&&(ee=ee+l+d),g[M]=ee}}E&&(g[M]=j)}return g}t.shorten=C;var m;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function s(a,l=Object.create(null)){const g=[];let E=!1,M="";for(const j of a)if(j==="$"||E&&j==="{")M&&g.push({value:M,type:m.TEXT}),M="",E=!0;else if(j==="}"&&E){const k=l[M];if(typeof k=="string")k.length&&g.push({value:k,type:m.VARIABLE});else if(k){const U=g[g.length-1];(!U||U.type!==m.SEPARATOR)&&g.push({value:k.label,type:m.SEPARATOR})}M="",E=!1}else M+=j;return M&&!E&&g.push({value:M,type:m.TEXT}),g.filter((j,k)=>{if(j.type===m.SEPARATOR){const U=g[k-1],W=g[k+1];return[U,W].every(H=>H&&(H.type===m.VARIABLE||H.type===m.TEXT)&&H.value.length>0)}return!0}).map(j=>j.value).join("")}t.template=s;function r(a,l){return F.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):a.replace(/&&|&/g,g=>g==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(a,l){return F.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,""):F.isWindows?a.replace(/&&|&/g,g=>g==="&"?"&&":"&"):a.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(a){return a.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(a){const l=a.indexOf("/")!==-1?T.posix:T.win32,g=l.basename(a),E=l.dirname(a);return g.length?{name:g,parentPath:E}:{name:E,parentPath:""}}t.splitName=n}),define(Q[46],Z([0,1,125]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class T{constructor(S="utf8"){this.stringDecoder=new v.StringDecoder(S),this.remaining=null}write(S){const F=[],O=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(O.length<1)return F;let u=0,c,R=u;for(;R<O.length;)if(c=O.charCodeAt(R),c===13||c===10){if(F.push(O.substring(u,R)),R++,R<O.length){const y=c;c=O.charCodeAt(R),(y===13&&c===10||y===10&&c===13)&&R++}u=R}else R++;return this.remaining=u<O.length?O.substr(u):null,F}end(){return this.remaining}}t.LineDecoder=T}),define(Q[63],Z([0,1,18,64,20,3,14]),function(x,t,v,T,D,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function O(y){const w=(0,S.dirname)(y);if(y===w)return y;const P=((0,S.basename)(y)||y).toLowerCase();try{const d=(0,F.readdirSync)(w).filter(b=>b.toLowerCase()===P);if(d.length===1){const b=O(w);if(b)return(0,S.join)(b,d[0])}else if(d.length>1){const b=d.indexOf(P);if(b>=0){const L=O(w);if(L)return(0,S.join)(L,d[b])}}}catch(f){}return null}t.realcaseSync=O;async function u(y){try{return await(0,T.promisify)(v.realpath)(y)}catch(w){const P=R(y);return await v.promises.access(P,v.constants.R_OK),P}}t.realpath=u;function c(y){try{return v.realpathSync(y)}catch(w){const P=R(y);return v.accessSync(P,v.constants.R_OK),P}}t.realpathSync=c;function R(y){return(0,D.rtrim)((0,S.normalize)(y),S.sep)}});var ye=this&&this.__await||function(x){return this instanceof ye?(this.v=x,this):new ye(x)},Ve=this&&this.__asyncGenerator||function(x,t,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var T=v.apply(x,t||[]),D,S=[];return D={},F("next"),F("throw"),F("return"),D[Symbol.asyncIterator]=function(){return this},D;function F(w){T[w]&&(D[w]=function(P){return new Promise(function(f,d){S.push([w,P,f,d])>1||O(w,P)})})}function O(w,P){try{u(T[w](P))}catch(f){y(S[0][3],f)}}function u(w){w.value instanceof ye?Promise.resolve(w.value.v).then(c,R):y(S[0][2],w)}function c(w){O("next",w)}function R(w){O("throw",w)}function y(w,P){w(P),S.shift(),S.length&&O(S[0][0],S[0][1])}},Be=this&&this.__asyncValues||function(x){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=x[Symbol.asyncIterator],v;return t?t.call(x):(x=typeof __values=="function"?__values(x):x[Symbol.iterator](),v={},T("next"),T("throw"),T("return"),v[Symbol.asyncIterator]=function(){return this},v);function T(S){v[S]=x[S]&&function(F){return new Promise(function(O,u){F=x[S](F),D(O,u,F.done,F.value)})}}function D(S,F,O,u){Promise.resolve(u).then(function(c){S({value:c,done:O})},F)}};define(Q[65],Z([0,1,14,32,3]),function(x,t,v,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,F=/^Microsoft.PowerShell_.*/,O=/^Microsoft.PowerShellPreview_.*/;var u;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class y{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:s=!1}={}){return s?c===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function P({useAlternateBitness:s=!1,findPreview:r=!1}={}){const e=w({useAlternateBitness:s});if(!e)return null;const i=D.join(e,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(i))return null;let n=-1,a=null;for(const E of await v.readdir(i)){let M=-1;if(r){const k=E.indexOf("-");if(k<0)continue;const U=E.substring(0,k);if(!S.test(U)||E.substring(k+1)!=="preview")continue;M=parseInt(U,10)}else{if(!S.test(E))continue;M=parseInt(E,10)}if(!(M<=n)){const j=D.join(i,E,"pwsh.exe");!await v.SymlinkSupport.existsFile(j)||(a=j,n=M)}}if(!a)return null;const l=e.includes("x86")?" (x86)":"",g=r?" Preview":"";return new y(a,`PowerShell${g}${l}`,!0)}async function f({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const r=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=s?{pwshMsixDirRegex:O,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const n of await v.readdir(r))if(e.test(n)){const a=D.join(r,n,"pwsh.exe");return new y(a,i)}return null}function d(){const s=D.join(T.homedir(),".dotnet","tools","pwsh.exe");return new y(s,".NET Core PowerShell Global Tool")}function b(){const s=D.join(process.env.windir,c===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(s,"Windows PowerShell",!0)}function L(){return Ve(this,arguments,function*(){let r=yield ye(P());r&&(yield yield ye(r)),r=yield ye(P({useAlternateBitness:!0})),r&&(yield yield ye(r)),r=yield ye(f()),r&&(yield yield ye(r)),r=d(),r&&(yield yield ye(r)),r=yield ye(P({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(f({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(P({useAlternateBitness:!0,findPreview:!0})),r&&(yield yield ye(r)),r=b(),r&&(yield yield ye(r))})}function C(){return Ve(this,arguments,function*(){var r,e;try{for(var i=Be(L()),n;n=yield ye(i.next()),!n.done;){const a=n.value;(yield ye(a.exists()))&&(yield yield ye(a))}}catch(a){r={error:a}}finally{try{n&&!n.done&&(e=i.return)&&(yield ye(e.call(i)))}finally{if(r)throw r.error}}})}t.enumeratePowerShellInstallations=C;async function m(){var s,r;try{for(var e=Be(C()),i;i=await e.next(),!i.done;)return i.value}catch(n){s={error:n}}finally{try{i&&!i.done&&(r=e.return)&&await r.call(e)}finally{if(s)throw s.error}}return null}t.getFirstAvailablePowerShellInstallation=m}),define(Q[66],Z([0,1,3,18,13,126,2,14]),function(x,t,v,T,D,S,F,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function u(y,w,P){return R({path:y,isDirectory:!1},w,P)}t.watchFile=u;function c(y,w,P){return R({path:y,isDirectory:!0},w,P)}t.watchFolder=c,t.CHANGE_BUFFER_DELAY=100;function R(y,w,P){const f=(0,v.basename)(y.path),d=new Map;let b=!1,L=[(0,F.toDisposable)(()=>{d.forEach(C=>(0,F.dispose)(C)),d.clear()})];try{const C=(0,T.watch)(y.path);L.push((0,F.toDisposable)(()=>{C.removeAllListeners(),C.close()}));const m=new Set;y.isDirectory&&(0,O.readdir)(y.path).then(s=>s.forEach(r=>m.add(r))),C.on("error",(s,r)=>{b||P(`Failed to watch ${y.path} for changes using fs.watch() (${s}, ${r})`)}),C.on("change",(s,r)=>{if(!b){let e="";if(r&&(e=r.toString(),D.isMacintosh&&(e=(0,S.normalizeNFC)(e))),!(!e||s!=="change"&&s!=="rename")){const i=y.isDirectory?(0,v.join)(y.path,e):y.path;if(y.isDirectory)if(s==="rename"){const n=d.get(i);n&&(0,F.dispose)(n);const a=setTimeout(async()=>{d.delete(i);const l=await(0,O.exists)(i);if(!b){let g;l?m.has(e)?g="changed":(g="added",m.add(e)):(m.delete(e),g="deleted"),w(g,i)}},t.CHANGE_BUFFER_DELAY);d.set(i,(0,F.toDisposable)(()=>clearTimeout(a)))}else{let n;m.has(e)?n="changed":(n="added",m.add(e)),w(n,i)}else if(s==="rename"||e!==f){const n=setTimeout(async()=>{const a=await(0,O.exists)(i);b||(a?(w("changed",i),L=[R(y,w,P)]):w("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,F.dispose)(L),L=[(0,F.toDisposable)(()=>clearTimeout(n))]}else w("changed",i)}}})}catch(C){(0,O.exists)(y.path).then(m=>{m&&!b&&P(`Failed to watch ${y.path} for changes using fs.watch() (${C.toString()})`)})}return(0,F.toDisposable)(()=>{b=!0,L=(0,F.dispose)(L)})}});var ue=this&&this.__decorate||function(x,t,v,T){var D=arguments.length,S=D<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,v):T,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(x,t,v,T);else for(var O=x.length-1;O>=0;O--)(F=x[O])&&(S=(D<3?F(S):D>3?F(t,v,S):F(t,v))||S);return D>3&&S&&Object.defineProperty(t,v,S),S};define(Q[37],Z([0,1,9,2,4,28,12,16,23,11,60,20,44]),function(x,t,v,T,D,S,F,O,u,c,R,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var P;(function(h){h[h.Promise=100]="Promise",h[h.PromiseCancel=101]="PromiseCancel",h[h.EventListen=102]="EventListen",h[h.EventDispose=103]="EventDispose"})(P=t.RequestType||(t.RequestType={}));function f(h){switch(h){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(h){h[h.Initialize=200]="Initialize",h[h.PromiseSuccess=201]="PromiseSuccess",h[h.PromiseError=202]="PromiseError",h[h.PromiseErrorObj=203]="PromiseErrorObj",h[h.EventFire=204]="EventFire"})(d=t.ResponseType||(t.ResponseType={}));function b(h){switch(h){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var L;(function(h){h[h.Uninitialized=0]="Uninitialized",h[h.Idle=1]="Idle"})(L||(L={}));class C{constructor(o){this.buffer=o,this.pos=0}read(o){const I=this.buffer.slice(this.pos,this.pos+o);return this.pos+=I.byteLength,I}}class m{constructor(){this.buffers=[]}get buffer(){return O.VSBuffer.concat(this.buffers)}write(o){this.buffers.push(o)}}var s;(function(h){h[h.Undefined=0]="Undefined",h[h.String=1]="String",h[h.Buffer=2]="Buffer",h[h.VSBuffer=3]="VSBuffer",h[h.Array=4]="Array",h[h.Object=5]="Object"})(s||(s={}));function r(h){const o=O.VSBuffer.alloc(4);return o.writeUInt32BE(h,0),o}function e(h){return h.read(4).readUInt32BE(0)}function i(h){const o=O.VSBuffer.alloc(1);return o.writeUInt8(h,0),o}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object)},a=typeof Buffer!="undefined";function l(h,o){if(typeof o=="undefined")h.write(n.Undefined);else if(typeof o=="string"){const I=O.VSBuffer.fromString(o);h.write(n.String),h.write(r(I.byteLength)),h.write(I)}else if(a&&Buffer.isBuffer(o)){const I=O.VSBuffer.wrap(o);h.write(n.Buffer),h.write(r(I.byteLength)),h.write(I)}else if(o instanceof O.VSBuffer)h.write(n.VSBuffer),h.write(r(o.byteLength)),h.write(o);else if(Array.isArray(o)){h.write(n.Array),h.write(r(o.length));for(const I of o)l(h,I)}else{const I=O.VSBuffer.fromString(JSON.stringify(o));h.write(n.Object),h.write(r(I.byteLength)),h.write(I)}}function g(h){switch(h.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return h.read(e(h)).toString();case s.Buffer:return h.read(e(h)).buffer;case s.VSBuffer:return h.read(e(h));case s.Array:{const I=e(h),p=[];for(let A=0;A<I;A++)p.push(g(h));return p}case s.Object:return JSON.parse(h.read(e(h)).toString())}}class E{constructor(o,I,p=null,A=1e3){this.protocol=o,this.ctx=I,this.logger=p,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(o,I){this.channels.set(o,I),setTimeout(()=>this.flushPendingRequests(o),0)}sendResponse(o){switch(o.type){case 200:{const I=this.send([o.type]);this.logger&&this.logger.logOutgoing(I,0,1,b(o.type));return}case 201:case 202:case 204:case 203:{const I=this.send([o.type,o.id],o.data);this.logger&&this.logger.logOutgoing(I,o.id,1,b(o.type),o.data);return}}}send(o,I=void 0){const p=new m;return l(p,o),l(p,I),this.sendBuffer(p.buffer)}sendBuffer(o){try{return this.protocol.send(o),o.byteLength}catch(I){return 0}}onRawMessage(o){const I=new C(o),p=g(I),A=g(I),N=p[0];switch(N){case 100:return this.logger&&this.logger.logIncoming(o.byteLength,p[1],1,`${f(N)}: ${p[2]}.${p[3]}`,A),this.onPromise({type:N,id:p[1],channelName:p[2],name:p[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(o.byteLength,p[1],1,`${f(N)}: ${p[2]}.${p[3]}`,A),this.onEventListen({type:N,id:p[1],channelName:p[2],name:p[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(o.byteLength,p[1],1,`${f(N)}`),this.disposeActiveRequest({type:N,id:p[1]});case 103:return this.logger&&this.logger.logIncoming(o.byteLength,p[1],1,`${f(N)}`),this.disposeActiveRequest({type:N,id:p[1]})}}onPromise(o){const I=this.channels.get(o.channelName);if(!I){this.collectPendingRequest(o);return}const p=new S.CancellationTokenSource;let A;try{A=I.call(this.ctx,o.name,o.arg,p.token)}catch(V){A=Promise.reject(V)}const N=o.id;A.then(V=>{this.sendResponse({id:N,data:V,type:201}),this.activeRequests.delete(o.id)},V=>{V instanceof Error?this.sendResponse({id:N,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:N,data:V,type:203}),this.activeRequests.delete(o.id)});const B=(0,T.toDisposable)(()=>p.cancel());this.activeRequests.set(o.id,B)}onEventListen(o){const I=this.channels.get(o.channelName);if(!I){this.collectPendingRequest(o);return}const p=o.id,N=I.listen(this.ctx,o.name,o.arg)(B=>this.sendResponse({id:p,data:B,type:204}));this.activeRequests.set(o.id,N)}disposeActiveRequest(o){const I=this.activeRequests.get(o.id);I&&(I.dispose(),this.activeRequests.delete(o.id))}collectPendingRequest(o){let I=this.pendingRequests.get(o.channelName);I||(I=[],this.pendingRequests.set(o.channelName,I));const p=setTimeout(()=>{console.error(`Unknown channel: ${o.channelName}`),o.type===100&&this.sendResponse({id:o.id,data:{name:"Unknown channel",message:`Channel name '${o.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);I.push({request:o,timeoutTimer:p})}flushPendingRequests(o){const I=this.pendingRequests.get(o);if(I){for(const p of I)switch(clearTimeout(p.timeoutTimer),p.request.type){case 100:this.onPromise(p.request);break;case 102:this.onEventListen(p.request);break}this.pendingRequests.delete(o)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(o=>o.dispose()),this.activeRequests.clear()}}t.ChannelServer=E;var M;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(M=t.RequestInitiator||(t.RequestInitiator={}));class j{constructor(o,I=null){this.protocol=o,this.isDisposed=!1,this.state=L.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(p=>this.onBuffer(p)),this.logger=I}getChannel(o){const I=this;return{call(p,A,N){return I.isDisposed?Promise.reject(F.canceled()):I.requestPromise(o,p,A,N)},listen(p,A){return I.isDisposed?Promise.reject(F.canceled()):I.requestEvent(o,p,A)}}}requestPromise(o,I,p,A=S.CancellationToken.None){const N=this.lastRequestId++,V={id:N,type:100,channelName:o,name:I,arg:p};if(A.isCancellationRequested)return Promise.reject(F.canceled());let $;return new Promise((Y,te)=>{if(A.isCancellationRequested)return te(F.canceled());const re=()=>{const Fe=Le=>{switch(Le.type){case 201:this.handlers.delete(N),Y(Le.data);break;case 202:this.handlers.delete(N);const Ee=new Error(Le.data.message);Ee.stack=Le.data.stack,Ee.name=Le.data.name,te(Ee);break;case 203:this.handlers.delete(N),te(Le.data);break}};this.handlers.set(N,Fe),this.sendRequest(V)};let le=null;this.state===L.Idle?re():(le=(0,D.createCancelablePromise)(Fe=>this.whenInitialized()),le.then(()=>{le=null,re()}));const ge=()=>{le?(le.cancel(),le=null):this.sendRequest({id:N,type:101}),te(F.canceled())},Ie=A.onCancellationRequested(ge);$=(0,T.combinedDisposable)((0,T.toDisposable)(ge),Ie),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(o,I,p){const A=this.lastRequestId++,B={id:A,type:102,channelName:o,name:I,arg:p};let V=null;const $=new v.Emitter({onFirstListenerAdd:()=>{V=(0,D.createCancelablePromise)(Y=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add($),this.sendRequest(B)})},onLastListenerRemove:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete($),this.sendRequest({id:A,type:103}))}}),X=Y=>$.fire(Y.data);return this.handlers.set(A,X),$.event}sendRequest(o){switch(o.type){case 100:case 102:{const I=this.send([o.type,o.id,o.channelName,o.name],o.arg);this.logger&&this.logger.logOutgoing(I,o.id,0,`${f(o.type)}: ${o.channelName}.${o.name}`,o.arg);return}case 101:case 103:{const I=this.send([o.type,o.id]);this.logger&&this.logger.logOutgoing(I,o.id,0,f(o.type));return}}}send(o,I=void 0){const p=new m;return l(p,o),l(p,I),this.sendBuffer(p.buffer)}sendBuffer(o){try{return this.protocol.send(o),o.byteLength}catch(I){return 0}}onBuffer(o){const I=new C(o),p=g(I),A=g(I),N=p[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(o.byteLength,0,0,b(N)),this.onResponse({type:p[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(o.byteLength,p[1],0,b(N),A),this.onResponse({type:p[0],id:p[1],data:A})}}onResponse(o){if(o.type===200){this.state=L.Idle,this._onDidInitialize.fire();return}const I=this.handlers.get(o.id);I&&I(o)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===L.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(o=>o.dispose()),this.activeRequests.clear()}}ue([w.memoize],j.prototype,"onDidInitializePromise",null),t.ChannelClient=j;class k{constructor(o){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,o(({protocol:I,onDidClientDisconnect:p})=>{v.Event.once(I.onMessage)(N=>{const B=new C(N),V=g(B),$=new E(I,V),X=new j(I);this.channels.forEach((te,re)=>$.registerChannel(re,te));const Y={channelServer:$,channelClient:X,ctx:V};this._connections.add(Y),this._onDidAddConnection.fire(Y),p(()=>{$.dispose(),X.dispose(),this._connections.delete(Y),this._onDidRemoveConnection.fire(Y)})})})}get connections(){const o=[];return this._connections.forEach(I=>o.push(I)),o}getChannel(o,I){const p=this;return{call(A,N,B){let V;if((0,c.isFunction)(I)){let X=(0,u.getRandomElement)(p.connections.filter(I));V=X?Promise.resolve(X):v.Event.toPromise(v.Event.filter(p.onDidAddConnection,I))}else V=I.routeCall(p,A,N);const $=V.then(X=>X.channelClient.getChannel(o));return W($).call(A,N,B)},listen(A,N){if((0,c.isFunction)(I))return p.getMulticastEvent(o,I,A,N);const B=I.routeEvent(p,A,N).then(V=>V.channelClient.getChannel(o));return W(B).listen(A,N)}}}getMulticastEvent(o,I,p,A){const N=this;let B=new T.DisposableStore;const V=new v.Emitter({onFirstListenerAdd:()=>{B=new T.DisposableStore;const $=new v.EventMultiplexer,X=new Map,Y=re=>{const ge=re.channelClient.getChannel(o).listen(p,A),Ie=$.add(ge);X.set(re,Ie)},te=re=>{const le=X.get(re);!le||(le.dispose(),X.delete(re))};N.connections.filter(I).forEach(Y),v.Event.filter(N.onDidAddConnection,I)(Y,void 0,B),N.onDidRemoveConnection(te,void 0,B),$.event(V.fire,V,B),B.add($)},onLastListenerRemove:()=>{B.dispose()}});return V.event}registerChannel(o,I){this.channels.set(o,I),this._connections.forEach(p=>{p.channelServer.registerChannel(o,I)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=k;class U{constructor(o,I,p=null){const A=new m;l(A,I),o.send(A.buffer),this.channelClient=new j(o,p),this.channelServer=new E(o,I,p)}getChannel(o){return this.channelClient.getChannel(o)}registerChannel(o,I){this.channelServer.registerChannel(o,I)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=U;function W(h){return{call(o,I,p){return h.then(A=>A.call(o,I,p))},listen(o,I){const p=new v.Relay;return h.then(A=>p.input=A.listen(o,I)),p.event}}}t.getDelayedChannel=W;function H(h){let o=!1;return{call(I,p,A){return o?h.call(I,p,A):(0,D.timeout)(0).then(()=>o=!0).then(()=>h.call(I,p,A))},listen(I,p){if(o)return h.listen(I,p);const A=new v.Relay;return(0,D.timeout)(0).then(()=>o=!0).then(()=>A.input=h.listen(I,p)),A.event}}}t.getNextTickChannel=H;class ne{constructor(o){this.fn=o}routeCall(o){return this.route(o)}routeEvent(o){return this.route(o)}async route(o){for(const I of o.connections)if(await Promise.resolve(this.fn(I.ctx)))return Promise.resolve(I);return await v.Event.toPromise(o.onDidAddConnection),await this.route(o)}}t.StaticRouter=ne;var ee;(function(h){function o(A,N){const B=A,V=N&&N.disableMarshalling,$=new Map;for(const X in B)p(X)&&$.set(X,v.Event.buffer(B[X],!0));return new class{listen(X,Y){const te=$.get(Y);if(te)return te;throw new Error(`Event not found: ${Y}`)}call(X,Y,te){const re=B[Y];if(typeof re=="function"){if(!V&&Array.isArray(te))for(let le=0;le<te.length;le++)te[le]=(0,R.revive)(te[le]);return re.apply(B,te)}throw new Error(`Method not found: ${Y}`)}}}h.fromService=o;function I(A,N){const B=N&&N.disableMarshalling;return new Proxy({},{get(V,$){var X;if(typeof $=="string")return((X=N==null?void 0:N.properties)===null||X===void 0?void 0:X.has($))?N.properties.get($):p($)?A.listen($):async function(...Y){let te;N&&!(0,c.isUndefinedOrNull)(N.context)?te=[N.context,...Y]:te=Y;const re=await A.call($,te);return B?re:(0,R.revive)(re)};throw new Error(`Property not found: ${String($)}`)}})}h.toService=I;function p(A){return A[0]==="o"&&A[1]==="n"&&y.isUpperAsciiLetter(A.charCodeAt(2))}})(ee=t.ProxyChannel||(t.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(h){if(Array.isArray(h))return h;if(h&&typeof h=="object"&&typeof h.toString=="function"){let o=h.toString();if(o!=="[object Object]")return o}return h}function _(h){return Array.isArray(h)?h.map(oe):oe(h)}function q(h,o,I,p,A,N,B){B=_(B);const V=ie[A],$=V[p%V.length];let X=[`%c[${h}]%c[${String(o).padStart(7," ")}]%c[len: ${String(I).padStart(5," ")}]%c${String(p).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(N)?(X=X.concat(B),X.push(")")):X.push(B),console.log.apply(console,X)}t.logWithColors=q;class J{constructor(o,I){this._outgoingPrefix=o,this._incomingPrefix=I,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(o,I,p,A,N){this._totalOutgoing+=o,q(this._outgoingPrefix,this._totalOutgoing,o,I,p,A,N)}logIncoming(o,I,p,A,N){this._totalIncoming+=o,q(this._incomingPrefix,this._totalIncoming,o,I,p,A,N)}}t.IPCLogger=J}),define(Q[67],Z([0,1,2,9,4,11]),function(x,t,v,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var O;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(O||(O={}));class u extends v.Disposable{constructor(y,w=Object.create(null)){super();this.database=y,this.options=w,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=O.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){var w,P;(w=y.changed)===null||w===void 0||w.forEach((f,d)=>this.accept(d,f)),(P=y.deleted)===null||P===void 0||P.forEach(f=>this.accept(f,void 0))}accept(y,w){if(this.state!==O.Closed){let P=!1;(0,S.isUndefinedOrNull)(w)?P=this.cache.delete(y):this.cache.get(y)!==w&&(this.cache.set(y,w),P=!0),P&&this._onDidChangeStorage.fire(y)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===O.None&&(this.state=O.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,w){const P=this.cache.get(y);return(0,S.isUndefinedOrNull)(P)?w:P}getBoolean(y,w){const P=this.get(y);return(0,S.isUndefinedOrNull)(P)?w:P==="true"}getNumber(y,w){const P=this.get(y);return(0,S.isUndefinedOrNull)(P)?w:parseInt(P,10)}async set(y,w){if(this.state!==O.Closed){if((0,S.isUndefinedOrNull)(w))return this.delete(y);const P=String(w);if(this.cache.get(y)!==P)return this.cache.set(y,P),this.pendingInserts.set(y,P),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(y){if(this.state!==O.Closed&&!!this.cache.delete(y))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=O.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{var w;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(w=this.whenFlushedCallbacks.pop())===null||w===void 0||w()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class c{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((w,P)=>this.items.set(P,w)),y.delete&&y.delete.forEach(w=>this.items.delete(w))}async close(){}}t.InMemoryStorageDatabase=c}),define(Q[68],Z([5,6]),function(x,t){return x.create("vs/base/common/date",t)}),define(Q[69],Z([0,1,68]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const T=60,D=T*60,S=D*24,F=S*7,O=S*30,u=S*365;function c(y,w){typeof y!="number"&&(y=y.getTime());const P=Math.round((new Date().getTime()-y)/1e3);if(P<-30)return(0,v.localize)(0,null,c(new Date().getTime()+P*1e3,!1));if(P<30)return(0,v.localize)(1,null);let f;return P<T?(f=P,w?f===1?(0,v.localize)(2,null,f):(0,v.localize)(3,null,f):f===1?(0,v.localize)(4,null,f):(0,v.localize)(5,null,f)):P<D?(f=Math.floor(P/T),w?f===1?(0,v.localize)(6,null,f):(0,v.localize)(7,null,f):f===1?(0,v.localize)(8,null,f):(0,v.localize)(9,null,f)):P<S?(f=Math.floor(P/D),w?f===1?(0,v.localize)(10,null,f):(0,v.localize)(11,null,f):f===1?(0,v.localize)(12,null,f):(0,v.localize)(13,null,f)):P<F?(f=Math.floor(P/S),w?f===1?(0,v.localize)(14,null,f):(0,v.localize)(15,null,f):f===1?(0,v.localize)(16,null,f):(0,v.localize)(17,null,f)):P<O?(f=Math.floor(P/F),w?f===1?(0,v.localize)(18,null,f):(0,v.localize)(19,null,f):f===1?(0,v.localize)(20,null,f):(0,v.localize)(21,null,f)):P<u?(f=Math.floor(P/O),w?f===1?(0,v.localize)(22,null,f):(0,v.localize)(23,null,f):f===1?(0,v.localize)(24,null,f):(0,v.localize)(25,null,f)):(f=Math.floor(P/u),w?f===1?(0,v.localize)(26,null,f):(0,v.localize)(27,null,f):f===1?(0,v.localize)(28,null,f):(0,v.localize)(29,null,f))}t.fromNow=c;function R(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=R}),define(Q[70],Z([5,6]),function(x,t){return x.create("vs/base/common/errorMessage",t)}),define(Q[29],Z([0,1,70,11,23]),function(x,t,v,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function S(c,R){return R&&(c.stack||c.stacktrace)?v.localize(0,null,O(c),F(c.stack)||F(c.stacktrace)):O(c)}function F(c){return Array.isArray(c)?c.join(`
`):c}function O(c){return typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?v.localize(1,null,c.message):c.message||v.localize(2,null)}function u(c=null,R=!1){if(!c)return v.localize(3,null);if(Array.isArray(c)){const y=D.coalesce(c),w=u(y[0],R);return y.length>1?v.localize(4,null,w,y.length):w}if(T.isString(c))return c;if(c.detail){const y=c.detail;if(y.error)return S(y.error,R);if(y.exception)return S(y.exception,R)}return c.stack?S(c,R):c.message?c.message:v.localize(5,null)}t.toErrorMessage=u}),define(Q[71],Z([5,6]),function(x,t){return x.create("vs/base/node/processes",t)}),define(Q[47],Z([0,1,3,18,14,33,71,34,11,21,36,13,46,8]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function f(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(r,e){if(y.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};e&&(i.cwd=e);const n=S.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(a=>{n.once("error",l=>{a({success:!1,error:l})}),n.once("exit",(l,g)=>{a(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?f(i.status):1})}else if(y.isLinux||y.isMacintosh)try{const i=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(n=>{S.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(a,l,g)=>{n(a?{success:!1,error:a}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function b(r=O.env){return r.comspec||"cmd.exe"}t.getWindowsShell=b;class L{constructor(e,i,n,a){if(i!==void 0&&n!==void 0&&a!==void 0)this.cmd=e,this.args=i,this.shell=n,this.options=a;else{const l=e;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(O.env).forEach(g=>{l[g]=O.env[g]}),Object.keys(this.options.env).forEach(g=>{l[g]=this.options.env[g]}),this.options.env=l}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const i=e.lastIndexOf(v.sep);return i!==-1&&(e=e.substring(i+1)),L.WellKnowCommands[e]?e:"other"}start(e){return y.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(O.cwd()))?Promise.reject(new Error(F.localize(0,null))):this.useExec().then(i=>{let n,a;const l=new Promise((g,E)=>{n=g,a=E});if(i){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=S.exec(g,this.options,(E,M,j)=>{this.childProcess=null;const k=E;k&&k.killed?a({killed:this.terminateRequested,stdout:M.toString(),stderr:j.toString()}):this.handleExec(n,e,E,M,j)})}else{let g=null;const E=M=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(M,n,e,a);const j={terminated:this.terminateRequested};u.isNumber(M)&&(j.cmdCode=M),n(j)};if(this.shell&&y.isWindows){const M=c.deepClone(this.options);M.windowsVerbatimArguments=!0,M.detached=!1;let j=!1,k=!1;const U=[];let W=this.ensureQuotes(this.cmd);U.push(W.value),j=W.quoted,this.args&&this.args.forEach(ne=>{W=this.ensureQuotes(ne),U.push(W.value),k=k&&W.quoted});const H=["/s","/c"];j?k?H.push('"'+U.join(" ")+'"'):U.length>1?H.push('"'+U[0]+'" '+U.slice(1).join(" ")):H.push('"'+U[0]+'"'):H.push(U.join(" ")),g=S.spawn(b(),H,M)}else this.cmd&&(g=S.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(u.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",M=>{this.childProcess=null,a({terminated:this.terminateRequested,error:M})}),g.pid&&(this.childProcess.on("close",E),this.handleSpawn(g,n,e,a,!0)))}return l})}handleClose(e,i,n,a){}ensureQuotes(e){return L.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,d(e,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!y.isWindows)return e(!1);const i=S.spawn(b(),["/s","/c"]);i.on("error",n=>e(!0)),i.on("exit",n=>e(!1))})}}t.AbstractProcess=L,L.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},L.regexp=/^[^"].* .*[^"]/;class C extends L{constructor(e,i,n,a){super(e,i,n,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,i,n,a,l){[a,l].forEach((g,E)=>{const M=new w.LineDecoder;M.write(g).forEach(U=>{i({line:U,source:E===0?0:1})});const k=M.end();k&&i({line:k,source:E===0?0:1})}),e({terminated:this.terminateRequested,error:n})}handleSpawn(e,i,n,a,l){const g=new w.LineDecoder,E=new w.LineDecoder;e.stdout.on("data",M=>{g.write(M).forEach(k=>n({line:k,source:0}))}),e.stderr.on("data",M=>{E.write(M).forEach(k=>n({line:k,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=E}handleClose(e,i,n,a){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&n({line:l,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&n({line:g,source:1})}}t.LineProcess=C;function m(r){let e=[],i=!1;const n=function(a){if(i){e.push(a);return}(!r.send(a,g=>{if(g&&console.error(g),i=!1,e.length>0){const E=e.slice(0);e=[],E.forEach(M=>n(M))}})||y.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=m;var s;(function(r){async function e(i,n,a){if(v.isAbsolute(i))return i;if(n===void 0&&(n=O.cwd()),v.dirname(i)!=="."||(a===void 0&&u.isString(O.env.PATH)&&(a=O.env.PATH.split(v.delimiter)),a===void 0||a.length===0))return v.join(n,i);async function g(E){return await D.exists(E)?!(await T.promises.stat(E)).isDirectory():!1}for(let E of a){let M;if(v.isAbsolute(E)?M=v.join(E,i):M=v.join(n,E,i),await g(M))return M;let j=M+".com";if(await g(j)||(j=M+".exe",await g(j)))return j}return v.join(n,i)}r.findExecutable=e})(s=t.win32||(t.win32={}))}),define(Q[72],Z([0,1,32,13,65,47]),function(x,t,v,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(P,f){return P===1?T.isWindows?y():S.getWindowsShell(f):c(P,f)}t.getSystemShell=F;function O(P,f){return P===1?T.isWindows?w(f):S.getWindowsShell(f):c(P,f)}t.getSystemShellSync=O;let u=null;function c(P,f){if(T.isLinux&&P===2||T.isMacintosh&&P===3)return"/bin/bash";if(!u){let d;if(T.isWindows)d="/bin/bash";else{if(d=f.SHELL,!d)try{d=(0,v.userInfo)().shell}catch(b){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}u=d}return u}let R=null;async function y(){return R||(R=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),R}function w(P){if(R)return R;const f=T.isWindows&&parseFloat((0,v.release)())>=10,d=P.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${P.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?b:S.getWindowsShell(P)}}),define(Q[48],Z([0,1,33,2,4,21,9,47,37,59,28,12,16,13]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class f extends u.ChannelServer{constructor(L){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(m){}},onMessage:F.Event.fromNodeEventEmitter(process,"message",C=>w.VSBuffer.wrap(Buffer.from(C,"base64")))},L);process.once("disconnect",()=>this.dispose())}}t.Server=f;class d{constructor(L,C){this.modulePath=L,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new F.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new D.Delayer(m),this.child=null,this._client=null}getChannel(L){const C=this;return{call(m,s,r){return C.requestPromise(L,m,s,r)},listen(m,s){return C.requestEvent(L,m,s)}}}requestPromise(L,C,m,s=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(L),e=(0,D.createCancelablePromise)(a=>r.call(C,m,a)),i=s.onCancellationRequested(()=>e.cancel()),n=(0,T.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(L,C,m){if(!this.disposeDelayer)return F.Event.None;this.disposeDelayer.cancel();let s;const r=new F.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(L).listen(C,m)(r.fire,r),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const L=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env=Object.assign(Object.assign({},(0,S.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(C.env=Object.assign(Object.assign({},C.env),this.options.env)),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),P.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,L,C);const m=new F.Emitter;F.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,c.isRemoteConsoleLog)(l)){(0,c.log)(l,`IPC Library: ${this.options.serverName}`);return}m.fire(w.VSBuffer.wrap(Buffer.from(l,"base64")))});const r=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,e=l=>this.child&&this.child.connected&&r.send(l.buffer.toString("base64")),i=m.event,n={send:e,onMessage:i};this._client=new u.ChannelClient(n);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,g)=>{process.removeListener("exit",a),this.activeRequests.forEach(E=>(0,T.dispose)(E)),this.activeRequests.clear(),l!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:g})})}return this._client}getCachedChannel(L){let C=this.channels.get(L);return C||(C=this.client.getChannel(L),this.channels.set(L,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=d}),define(Q[73],Z([5,6]),function(x,t){return x.create("vs/base/node/zip",t)}),define(Q[74],Z([5,6]),function(x,t){return x.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[75],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[76],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[77],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[78],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[79],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[80],Z([5,6]),function(x,t){return x.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[81],Z([5,6]),function(x,t){return x.create("vs/platform/files/common/fileService",t)}),define(Q[82],Z([5,6]),function(x,t){return x.create("vs/platform/files/common/io",t)}),define(Q[83],Z([5,6]),function(x,t){return x.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[84],Z([5,6]),function(x,t){return x.create("vs/platform/request/common/request",t)}),define(Q[85],Z([5,6]),function(x,t){return x.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[86],Z([0,1,3,17,44,69,8,7,34]),function(x,t,v,T,D,S,F,O,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class c{constructor(f,d,b){this._args=f,this.paths=d,this.productService=b}get appRoot(){return(0,v.dirname)(F.FileAccess.asFileUri("",x).fsPath)}get userHome(){return O.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return O.URI.file((0,v.join)(this.userDataPath,"User"))}get tmpDir(){return O.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,v.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return O.URI.file((0,v.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(O.URI.file((0,v.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return O.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return O.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=u.env.VSCODE_PORTABLE;return f?O.URI.file((0,v.join)(f,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return O.URI.file((0,v.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,v.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,v.resolve)(f):(0,v.normalize)((0,v.join)(F.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?(0,v.resolve)(f):(0,v.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,v.resolve)(f);const d=u.env.VSCODE_EXTENSIONS;if(d)return d;const b=u.env.VSCODE_PORTABLE;return b?(0,v.join)(b,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(d=>/^[^:/?#]+?:\/\//.test(d)?O.URI.parse(d):O.URI.file((0,v.normalize)(d)))}get extensionDevelopmentKind(){var f;return(f=this.args.extensionDevelopmentKind)===null||f===void 0?void 0:f.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?O.URI.parse(f):O.URI.file((0,v.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!u.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(O.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return O.URI.file((0,v.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ue([D.memoize],c.prototype,"appRoot",null),ue([D.memoize],c.prototype,"userHome",null),ue([D.memoize],c.prototype,"userDataPath",null),ue([D.memoize],c.prototype,"appSettingsHome",null),ue([D.memoize],c.prototype,"tmpDir",null),ue([D.memoize],c.prototype,"userRoamingDataHome",null),ue([D.memoize],c.prototype,"settingsResource",null),ue([D.memoize],c.prototype,"userDataSyncHome",null),ue([D.memoize],c.prototype,"userDataSyncLogResource",null),ue([D.memoize],c.prototype,"sync",null),ue([D.memoize],c.prototype,"machineSettingsResource",null),ue([D.memoize],c.prototype,"globalStorageHome",null),ue([D.memoize],c.prototype,"workspaceStorageHome",null),ue([D.memoize],c.prototype,"keybindingsResource",null),ue([D.memoize],c.prototype,"keyboardLayoutResource",null),ue([D.memoize],c.prototype,"argvResource",null),ue([D.memoize],c.prototype,"snippetsHome",null),ue([D.memoize],c.prototype,"isExtensionDevelopment",null),ue([D.memoize],c.prototype,"untitledWorkspacesHome",null),ue([D.memoize],c.prototype,"installSourcePath",null),ue([D.memoize],c.prototype,"builtinExtensionsPath",null),ue([D.memoize],c.prototype,"extensionsPath",null),ue([D.memoize],c.prototype,"extensionDevelopmentLocationURI",null),ue([D.memoize],c.prototype,"extensionDevelopmentKind",null),ue([D.memoize],c.prototype,"extensionTestsLocationURI",null),ue([D.memoize],c.prototype,"debugExtensionHost",null),ue([D.memoize],c.prototype,"serviceMachineIdResource",null),ue([D.memoize],c.prototype,"telemetryLogResource",null),t.AbstractNativeEnvironmentService=c;function R(P,f){return w(P["inspect-extensions"],P["inspect-brk-extensions"],5870,f,P.debugId)}t.parseExtensionHostPort=R;function y(P,f){return w(P["inspect-search"],P["inspect-brk-search"],5876,f)}t.parseSearchPort=y;function w(P,f,d,b,L){const m=Number(f||P)||(b?null:d),s=m?Boolean(!!f):!1;return{port:m,break:s,debugId:L}}}),function(){"use strict";function x(t,v,T,D){function S(O){const u=F(O),c=[u];return t.isAbsolute(u)||c.unshift(D),t.resolve(...c)}function F(O){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");const c=O["user-data-dir"];if(c)return c;let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=t.join(y,"AppData","Roaming")}break;case"darwin":R=t.join(v.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||t.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(R,T)}return{getUserDataPath:S}}if(typeof define=="function")define(Q[87],Z([0,88,32,8,17,34]),function(t,v,T,D,S,F){const O=S.dirname(D.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(S.joinPath(O,"package.json").fsPath);return x(v,T,u.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),v=require("path"),T=require("os");module.exports=x(v,T,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[89],Z([0,1,32,87,86]),function(x,t,v,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class S extends D.AbstractNativeEnvironmentService{constructor(O,u){super(O,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,T.getUserDataPath)(O)},u)}}t.NativeEnvironmentService=S}),define(Q[90],Z([0,1,21]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function D(S,F){const O=u=>{if(typeof u=="string"){const c=T.exec(u);if(!!c)return F[c[1]]||u}};return(0,v.cloneAndChange)(S,O)}t.localizeManifest=D}),define(Q[49],Z([0,1,80]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function S(w){return w=w.trim(),w==="*"||T.test(w)}t.isValidVersionStr=S;function F(w){if(!S(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let P=w.match(T);return P?{hasCaret:P[1]==="^",hasGreaterEquals:P[1]===">=",majorBase:P[2]==="x"?0:parseInt(P[2],10),majorMustEqual:P[2]!=="x",minorBase:P[4]==="x"?0:parseInt(P[4],10),minorMustEqual:P[4]!=="x",patchBase:P[6]==="x"?0:parseInt(P[6],10),patchMustEqual:P[6]!=="x",preRelease:P[8]||null}:null}t.parseVersion=F;function O(w){if(!w)return null;let P=w.majorBase,f=w.majorMustEqual,d=w.minorBase,b=w.minorMustEqual,L=w.patchBase,C=w.patchMustEqual;w.hasCaret&&(P===0||(b=!1),C=!1);let m=0;if(w.preRelease){const s=D.exec(w.preRelease);if(s){const[,r,e,i]=s;m=Date.UTC(Number(r),Number(e)-1,Number(i))}}return{majorBase:P,majorMustEqual:f,minorBase:d,minorMustEqual:b,patchBase:L,patchMustEqual:C,isMinimum:w.hasGreaterEquals,notBefore:m}}t.normalizeVersion=O;function u(w,P,f){let d;typeof w=="string"?d=O(F(w)):d=w;let b;P instanceof Date?b=P.getTime():typeof P=="string"&&(b=new Date(P).getTime());let L;if(typeof f=="string"?L=O(F(f)):L=f,!d||!L)return!1;let C=d.majorBase,m=d.minorBase,s=d.patchBase,r=L.majorBase,e=L.minorBase,i=L.patchBase,n=L.notBefore,a=L.majorMustEqual,l=L.minorMustEqual,g=L.patchMustEqual;return L.isMinimum?C>r?!0:C<r?!1:m>e?!0:m<e||b&&b<n?!1:s>=i:(C===1&&r===0&&(!a||!l||!g)&&(r=1,e=0,i=0,a=!0,l=!1,g=!1),C<r?!1:C>r?!a:m<e?!1:m>e?!l:s<i?!1:s>i?!g:!(b&&b<n))}t.isValidVersion=u;function c(w,P,f,d){return f.isBuiltin||typeof f.main=="undefined"?!0:y(w,P,f.engines.vscode,d)}t.isValidExtensionVersion=c;function R(w,P,f){return w==="*"||y(P,f,w)}t.isEngineValid=R;function y(w,P,f,d=[]){let b=O(F(f));if(!b)return d.push(v.localize(0,null,f)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return d.push(v.localize(1,null,f)),!1}else if(!b.majorMustEqual)return d.push(v.localize(2,null,f)),!1;return u(w,P,b)?!0:(d.push(v.localize(3,null,w,f)),!1)}}),define(Q[91],Z([0,1,37,48,2,8]),function(x,t,v,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends D.Disposable{constructor(u,c,R,y){super();this.folders=u,this.onDidFilesChange=c,this.onLogMessage=R,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new T.Client(S.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(c=>!this.isDisposed&&this.onDidFilesChange(c))),this._register(this.service.onDidLogMessage(c=>this.onLogMessage(c))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Q[92],Z([0,1,37,48,2,8]),function(x,t,v,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends D.Disposable{constructor(u,c,R,y,w={}){super();this.folders=u,this.onDidFilesChange=c,this.onLogMessage=R,this.verboseLogging=y,this.watcherOptions=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new T.Client(S.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(u.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(c=>!this.isDisposed&&this.onDidFilesChange(c))),this._register(this.service.onDidLogMessage(c=>this.onLogMessage(c))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Q[93],Z([0,1,33,46,61,8]),function(x,t,v,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(u,c,R,y,w){this.watchedFolder=u,this.eventCallback=R,this.logCallback=y,this.verboseLogging=w,this.restartCounter=0,Array.isArray(c)?this.ignored=c.map(P=>D.parse(P)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=v.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",x).fsPath,u);const c=new T.LineDecoder;this.handle.stdout.on("data",R=>{const y=[];c.write(R).forEach(w=>{const P=w.split("|");if(P.length===2){const f=Number(P[0]),d=P[1];if(f>=0&&f<3){if(this.ignored&&this.ignored.some(b=>b(d))){this.verboseLogging&&this.log(d);return}y.push({type:F.changeTypeMap[f],path:d})}else this.log(P[1])}}),y.length>0&&this.eventCallback(y)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,y)=>this.onExit(R,y))}onError(u){this.error("process error: "+u.toString())}onExit(u,c){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${c})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(Q[94],Z([0,1,93,3,20]),function(x,t,v,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class S{constructor(O,u,c,R){this.onDidFilesChange=u,this.onLogMessage=c,this.verboseLogging=R,this.service=void 0,this.folder=O[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,O=>this.onFileEvents(O),O=>this.onLogMessage(O),this.verboseLogging)}setVerboseLogging(O){this.verboseLogging=O,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(O){this.isDisposed||O.length>0&&this.onDidFilesChange(O)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=S}),define(Q[50],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class v{constructor(S,F=[],O=!1){this.ctor=S,this.staticArguments=F,this.supportsDelayedInstantiation=O}}t.SyncDescriptor=v;const T=(D,...S)=>new v(D,S);t.createSyncDescriptor=T}),define(Q[95],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class v{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}t.Node=v;class T{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let F of this._nodes.values())F.outgoing.size===0&&S.push(F);return S}insertEdge(S,F){const O=this.lookupOrInsertNode(S),u=this.lookupOrInsertNode(F);O.outgoing.set(this._hashFn(F),u),u.incoming.set(this._hashFn(S),O)}removeNode(S){const F=this._hashFn(S);this._nodes.delete(F);for(let O of this._nodes.values())O.outgoing.delete(F),O.incoming.delete(F)}lookupOrInsertNode(S){const F=this._hashFn(S);let O=this._nodes.get(F);return O||(O=new v(S),this._nodes.set(F,O)),O}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[F,O]of this._nodes)S.push(`${F}, (incoming)[${[...O.incoming.keys()].join(", ")}], (outgoing)[${[...O.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,F]of this._nodes){const O=new Set([S]),u=this._findCycle(F,O);if(u)return u}}_findCycle(S,F){for(let[O,u]of S.outgoing){if(F.has(O))return[...F,O].join(" -> ");F.add(O);const c=this._findCycle(u,F);if(c)return c;F.delete(O)}}}t.Graph=T}),define(Q[96],Z([0,1,10]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,v.createDecorator)("downloadService")}),define(Q[22],Z([0,1,10]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,v.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,v.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[24],Z([0,1,75,10,8]),function(x,t,v,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function S(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}t.isIExtensionIdentifier=S;var F;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var O;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(O=t.SortOrder||(t.SortOrder={}));var u;(function(y){y.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var c;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(c=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(w,P){super(w);this.code=P}}t.ExtensionManagementError=R,t.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),t.ExtensionsLabel=(0,v.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,v.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(Q[38],Z([0,1,20,10]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}t.isIExtensionIdentifier=D,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(S=t.ExtensionType||(t.ExtensionType={}));class F{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,y){if(typeof R=="undefined"||R===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof R=="string"||typeof y=="string"){let w=typeof R=="string"?R:R.value,P=typeof y=="string"?y:y.value;return v.equalsIgnoreCase(w,P)}return R._lower===y._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}t.ExtensionIdentifier=F;function O(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}t.isLanguagePackExtension=O;function u(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=u,t.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[25],Z([0,1,20,38]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function D(P,f){return P.uuid&&f.uuid?P.uuid===f.uuid:P.id===f.id?!0:(0,v.compareIgnoreCase)(P.id,f.id)===0}t.areSameExtensions=D;class S{constructor(f,d){this.version=d,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof S?D(this,f)&&this.version===f.version:!1}}t.ExtensionIdentifierWithVersion=S;function F(P,f){return`${P}.${f}`}t.getExtensionId=F;function O(P){return P.toLocaleLowerCase()}t.adoptToGalleryExtensionId=O;function u(P,f){return O(F(P,f))}t.getGalleryExtensionId=u;function c(P,f){const d=[],b=L=>{for(const C of d)if(C.some(m=>D(f(m),f(L))))return C;return null};for(const L of P){const C=b(L);C?C.push(L):d.push([L])}return d}t.groupByExtension=c;function R(P){return{id:P.identifier.id,name:P.manifest.name,galleryId:null,publisherId:P.publisherId,publisherName:P.manifest.publisher,publisherDisplayName:P.publisherDisplayName,dependencies:P.manifest.extensionDependencies&&P.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=R;function y(P){return Object.assign({id:P.identifier.id,name:P.name,galleryId:P.identifier.uuid,publisherId:P.publisherId,publisherName:P.publisher,publisherDisplayName:P.publisherDisplayName,dependencies:!!(P.properties.dependencies&&P.properties.dependencies.length>0)},P.telemetryData)}t.getGalleryExtensionTelemetryData=y,t.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function w(P){const f=new Set;for(const d of P)d.malicious&&f.add(d.id.id);return f}t.getMaliciousExtensionsSet=w});var fe=this&&this.__param||function(x,t){return function(v,T){t(v,T,x)}};define(Q[97],Z([0,1,76,12,7,39,24,25,38,62,28,8]),function(x,t,v,T,D,S,F,O,u,c,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const w=C=>(0,v.localize)(0,null,C),P=(0,v.localize)(1,null,"ms-dotnettools.csharp");function f(C,m){return m?`${C.publisher}.${C.name}@${C.version}`:`${C.publisher}.${C.name}`}const d=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function b(C){const m=d.exec(C);return m&&m[1]?[(0,O.adoptToGalleryExtensionId)(m[1]),m[2]]:[(0,O.adoptToGalleryExtensionId)(C),void 0]}t.getIdAndVersion=b;let L=class{constructor(m,s){this.extensionManagementService=m,this.extensionGalleryService=s}get location(){}async listExtensions(m,s,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=u.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(s&&s!==""){if(i.indexOf(s.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(a=>a.manifest.categories?a.manifest.categories.map(g=>g.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){r.log("Possible Categories: "),i.forEach(a=>{r.log(a)});return}this.location&&r.log((0,v.localize)(2,null,this.location)),e=e.sort((a,l)=>a.identifier.id.localeCompare(l.identifier.id));let n;for(let a of e)n!==a.identifier.id&&(n=a.identifier.id,r.log(f(a.manifest,m)))}async installExtensions(m,s,r,e,i=console){const n=[],a=[];m.length&&i.log(this.location?(0,v.localize)(3,null,this.location):(0,v.localize)(4,null));const l=await this.extensionManagementService.getInstalled(1),g=(j,k)=>{const U=l.find(W=>(0,O.areSameExtensions)(W.identifier,{id:j}));if(U){if(!k&&!e)return i.log((0,v.localize)(5,null,j,U.manifest.version,j)),!1;if(k&&U.manifest.version===k)return i.log((0,v.localize)(6,null,`${j}@${k}`)),!1}return!0},E=[],M=[];for(const j of m)if(j instanceof D.URI)E.push(j);else{const[k,U]=b(j);g(k,U)&&M.push({id:k,version:U,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const j of s){const[k,U]=b(j);g(k,U)&&M.push({id:k,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(E.length&&await Promise.all(E.map(async j=>{try{const k=await this.installVSIX(j,{isBuiltin:!1,isMachineScoped:r},e,i);k&&a.push(k)}catch(k){i.error(k.message||k.stack||k),n.push(j.toString())}})),M.length){const j=await this.getGalleryExtensions(M);await Promise.all(M.map(async k=>{const U=j.get(k.id.toLowerCase());if(U)try{const W=await this.installFromGallery(k,U,l,e,i);W&&a.push(W)}catch(W){i.error(W.message||W.stack||W),n.push(k.id)}else i.error(`${w(k.version?`${k.id}@${k.version}`:k.id)}
${P}`),n.push(k.id)}))}if(n.length)throw new Error((0,v.localize)(7,null,n.join(", ")))}async installVSIX(m,s,r,e){const i=await this.extensionManagementService.getManifest(m);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(m,s),e.log((0,v.localize)(8,null,(0,c.getBaseLabel)(m))),i}catch(a){if((0,T.isPromiseCanceledError)(a))return e.log((0,v.localize)(9,null,(0,c.getBaseLabel)(m))),null;throw a}return null}async getGalleryExtensions(m){const s=m.filter(({version:i})=>i===void 0).map(({id:i})=>i),r=m.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(s,R.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(r.map(async({id:i,version:n})=>{const a=await this.extensionGalleryService.getCompatibleExtension({id:i},n);a&&e.set(a.identifier.id.toLowerCase(),a)}))]),e}async installFromGallery({id:m,version:s,installOptions:r},e,i,n,a){const l=await this.extensionGalleryService.getManifest(e,R.CancellationToken.None);if(l&&!this.validateExtensionKind(l,a))return null;const g=i.find(E=>(0,O.areSameExtensions)(E.identifier,e.identifier));if(g){if(e.version===g.manifest.version)return a.log((0,v.localize)(10,null,s?`${m}@${s}`:m)),null;a.log((0,v.localize)(11,null,m,e.version))}try{return r.isBuiltin?a.log((0,v.localize)(12,null,m,e.version)):a.log((0,v.localize)(13,null,m,e.version)),await this.extensionManagementService.installFromGallery(e,r),a.log((0,v.localize)(14,null,m,e.version)),l}catch(E){if((0,T.isPromiseCanceledError)(E))return a.log((0,v.localize)(15,null,m)),null;throw E}}validateExtensionKind(m,s){return!0}async validateVSIX(m,s,r){const e={id:(0,O.getGalleryExtensionId)(m.publisher,m.name)},n=(await this.extensionManagementService.getInstalled(1)).find(a=>(0,O.areSameExtensions)(e,a.identifier)&&(0,S.gt)(a.manifest.version,m.version));return n&&!s?(r.log((0,v.localize)(16,null,n.identifier.id,n.manifest.version,m.version)),!1):this.validateExtensionKind(m,r)}async uninstallExtensions(m,s,r=console){const e=async n=>{if(n instanceof D.URI){const a=await this.extensionManagementService.getManifest(n);return f(a)}return n},i=[];for(const n of m){const a=await e(n),g=(await this.extensionManagementService.getInstalled()).filter(E=>(0,O.areSameExtensions)(E.identifier,{id:a}));if(!g.length)throw new Error(`${this.notInstalled(a)}
${P}`);if(g.some(E=>E.type===0)){r.log((0,v.localize)(17,null,a));return}if(!s&&g.some(E=>E.isBuiltin)){r.log((0,v.localize)(18,null,a));return}r.log((0,v.localize)(19,null,a));for(const E of g)await this.extensionManagementService.uninstall(E),i.push(E);this.location?r.log((0,v.localize)(20,null,a,this.location)):r.log((0,v.localize)(21,null,a))}}async locateExtension(m,s=console){const r=await this.extensionManagementService.getInstalled();m.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===y.Schemas.file){s.log(i.location.fsPath);return}})})}notInstalled(m){return this.location?(0,v.localize)(22,null,m,this.location):(0,v.localize)(23,null,m)}};L=ue([fe(0,F.IExtensionManagementService),fe(1,F.IExtensionGalleryService)],L),t.ExtensionManagementCLIService=L}),define(Q[98],Z([0,1,2,3,38,14]),function(x,t,v,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends v.Disposable{constructor(u,c){super();this.environmentService=u,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(c.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(c.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(u){u.error||this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){S.rimraf(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(Q[99],Z([0,1,88,33,30,13,127,29,72]),function(x,t,v,T,D,S,F,O,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function c(w,P,f){return P["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,F.isLaunchedFromCli)(f)&&!P["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,F.isLaunchedFromCli)(f)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),R||(R=y(w)),R)}t.resolveShellEnv=c;let R;async function y(w){const P=new Promise(async(f,d)=>{const b=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",b);const L=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",L);const C=(0,D.generateUuid)().replace(/-/g,"").substr(0,12),m=new RegExp(C+"(.*)"+C),s=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});w.trace("getUnixShellEnvironment#env",s);const r=await(0,u.getSystemShell)(S.OS,s);w.trace("getUnixShellEnvironment#shell",r);const e=v.basename(r);let i,n;/^pwsh(-preview)?$/.test(e)?(i=`& '${process.execPath}' -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,n=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,n=["-ilc"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(n),i);const a=(0,T.spawn)(r,[...n,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});a.on("error",E=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(E)),f({})});const l=[];a.stdout.on("data",E=>l.push(E));const g=[];a.stderr.on("data",E=>g.push(E)),a.on("close",(E,M)=>{const j=Buffer.concat(l).toString("utf8");w.trace("getUnixShellEnvironment#raw",j);const k=Buffer.concat(g).toString("utf8");if(k.trim()&&w.trace("getUnixShellEnvironment#stderr",k),E||M)return d(new Error(`Failed to get environment (code ${E}, signal ${M})`));const U=m.exec(j),W=U?U[1]:"{}";try{const H=JSON.parse(W);b?H.ELECTRON_RUN_AS_NODE=b:delete H.ELECTRON_RUN_AS_NODE,L?H.ELECTRON_NO_ATTACH_CONSOLE=L:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",H),f(H)}catch(H){w.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(H)),d(H)}})});try{return await P}catch(f){return w.error("getUnixShellEnvironment#error",(0,O.toErrorMessage)(f)),{}}}}),define(Q[51],Z([0,1,7,19,13]),function(x,t,v,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function S(u){return u.map(c=>({type:c.type,resource:v.URI.file(c.path)}))}t.toFileChanges=S;function F(u){const c=new O;for(const R of u)c.processEvent(R);return c.normalize()}t.normalizeFileChanges=F;class O{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(c){const R=this.mapPathToChange.get(c.path);if(R){const y=R.type,w=c.type;y===1&&w===2?(this.mapPathToChange.delete(c.path),this.normalized.splice(this.normalized.indexOf(R),1)):y===2&&w===1?R.type=0:y===1&&w===0||(R.type=w)}else this.normalized.push(c),this.mapPathToChange.set(c.path,c)}normalize(){const c=[],R=[];return this.normalized.filter(y=>y.type!==2?(c.push(y),!1):!0).sort((y,w)=>y.path.length-w.path.length).filter(y=>R.some(w=>(0,T.isParent)(y.path,w,!D.isLinux))?!1:(R.push(y.path),!0)).concat(c)}}}),define(Q[100],Z([0,1,51,2,14,63,66,4,3]),function(x,t,v,T,D,S,F,O,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class c extends T.Disposable{constructor(y,w,P,f){super();this.path=y,this.onDidFilesChange=w,this.onLogMessage=P,this.verboseLogging=f,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(F.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:w}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let P=this.path;if(w)try{P=await(0,S.realpath)(P)}catch(f){if(this.onError(f),w.dangling)return}y.isDirectory()?this._register((0,F.watchFolder)(P,(f,d)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:(0,u.join)(this.path,(0,u.basename)(d))})},f=>this.onError(f))):this._register((0,F.watchFile)(P,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const P=(0,v.normalizeFileChanges)(w);this.verboseLogging&&P.forEach(f=>{this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`)}),P.length>0&&this.onDidFilesChange(P)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=c}),define(Q[52],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[S,F]of D)this.set(S,F)}set(D,S){const F=this._entries.get(D);return this._entries.set(D,S),F}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}t.ServiceCollection=v}),define(Q[101],Z([0,1,12,95,50,10,52,4]),function(x,t,v,T,D,S,F,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class c extends Error{constructor(f){var d;super("cyclic dependency between services");this.message=(d=f.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class R{constructor(f=new F.ServiceCollection,d=!1,b){this._activeInstantiations=new Set,this._services=f,this._strict=d,this._parent=b,this._services.set(S.IInstantiationService,this)}createChild(f){return new R(f,this._strict,this)}invokeFunction(f,...d){let b=w.traceInvocation(f),L=!1;try{return f({get:(m,s)=>{if(L)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(m,b);if(!r&&s!==S.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return r}},...d)}finally{L=!0,b.stop()}}createInstance(f,...d){let b,L;return f instanceof D.SyncDescriptor?(b=w.traceCreation(f.ctor),L=this._createInstance(f.ctor,f.staticArguments.concat(d),b)):(b=w.traceCreation(f),L=this._createInstance(f,d,b)),b.stop(),L}_createInstance(f,d=[],b){let L=S._util.getServiceDependencies(f).sort((s,r)=>s.index-r.index),C=[];for(const s of L){let r=this._getOrCreateServiceInstance(s.id,b);if(!r&&this._strict&&!s.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${s.id}.`);C.push(r)}let m=L.length>0?L[0].index:d.length;if(d.length!==m){console.warn(`[createInstance] First service dependency of ${f.name} at position ${m+1} conflicts with ${d.length} static arguments`);let s=m-d.length;s>0?d=d.concat(new Array(s)):d=d.slice(0,m)}return new f(...[...d,...C])}_setServiceInstance(f,d){if(this._services.get(f)instanceof D.SyncDescriptor)this._services.set(f,d);else if(this._parent)this._parent._setServiceInstance(f,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let d=this._services.get(f);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):d}_getOrCreateServiceInstance(f,d){let b=this._getServiceInstanceOrDescriptor(f);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,b,d.branch(f,!0)):(d.branch(f,!1),b)}_safeCreateAndCacheServiceInstance(f,d,b){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,d,b)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,d,b){const L=new T.Graph(s=>s.id.toString());let C=0;const m=[{id:f,desc:d,_trace:b}];for(;m.length;){const s=m.pop();if(L.lookupOrInsertNode(s),C++>1e3)throw new c(L);for(let r of S._util.getServiceDependencies(s.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`),e instanceof D.SyncDescriptor){const i={id:r.id,desc:e,_trace:s._trace.branch(r.id,!0)};L.insertEdge(s,i),m.push(i)}}}for(;;){const s=L.roots();if(s.length===0){if(!L.isEmpty())throw new c(L);break}for(const{data:r}of s){if(this._getServiceInstanceOrDescriptor(r.id)instanceof D.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}L.removeNode(r)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,d,b=[],L,C){if(this._services.get(f)instanceof D.SyncDescriptor)return this._createServiceInstance(d,b,L,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,d,b,L,C);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(f,d=[],b,L){if(b){const C=new O.IdleValue(()=>this._createInstance(f,d,L));return new Proxy(Object.create(null),{get(m,s){if(s in m)return m[s];let r=C.value,e=r[s];return typeof e!="function"||(e=e.bind(r),m[s]=e),e},set(m,s,r){return C.value[s]=r,!0}})}else return this._createInstance(f,d,L)}}t.InstantiationService=R;var y;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(y||(y={}));class w{constructor(f,d){this.type=f,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return u?new w(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(f){return u?new w(0,f.name):w._None}branch(f,d){let b=new w(2,f.toString());return this._dep.push([f,d,b]),b}stop(){let f=Date.now()-this._start;w._totals+=f;let d=!1;function b(C,m){let s=[],r=new Array(C+1).join("	");for(const[e,i,n]of m._dep)if(i&&n){d=!0,s.push(`${r}CREATES -> ${e}`);let a=b(C+1,n);a&&s.push(a)}else s.push(`${r}uses -> ${e}`);return s.join(`
`)}let L=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(f>2||d)&&console.log(L.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(Q[53],Z([0,1,10]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,v.createDecorator)("localizationsService");function T(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const S of D.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}t.isValidLocalization=T}),define(Q[15],Z([0,1,10,2,13,9,29]),function(x,t,v,T,D,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,v.createDecorator)("logService"),t.ILoggerService=(0,v.createDecorator)("loggerService");function O(){return new Date().toISOString()}var u;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class c extends T.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=c;class R extends c{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(u.Error,this.format(n))}else this.log(u.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let a=e[n];if(typeof a=="object")try{a=JSON.stringify(a)}catch(l){}i+=(n>0?" ":"")+a}return i}}t.AbstractMessageLogger=R;class y extends c{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!D.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${O()}][0m`,e,...i):console.log(`[main ${O()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${O()}][0m`,e,...i):console.log(`[main ${O()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${O()}][0m`,e,...i):console.log(`[main ${O()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${O()}][0m`,e,...i):console.warn(`[main ${O()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${O()}][0m`,e,...i):console.error(`[main ${O()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${O()}][0m`,e,...i):console.error(`[main ${O()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=y;class w extends c{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=w;class P extends c{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,F.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=P;class f extends c{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=f;class d extends T.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=d;class b extends T.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,(i==null?void 0:i.always)?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=b;class L{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=L;function C(r){if(r.verbose)return u.Trace;if(typeof r.logLevel=="string"){const e=m(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=C;function m(r){switch(r){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=m;function s(r){switch(r){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=s}),define(Q[102],Z([0,1,18,2,19,24,22,7,17,25,15,30,39,13,4,12]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let L=class extends T.Disposable{constructor(m,s,r,e){super();this.fileService=s,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=O.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,s){await this.cleanUpPromise;const r=this.getName(m),e=(0,u.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=(0,u.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(m,i,s);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(a){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,d.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(m){}async rename(m,s,r){try{await v.promises.rename(m.fsPath,s.fsPath)}catch(e){if(P.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${m} to ${s} with 'EPERM' error. Trying again...`),this.rename(m,s,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const s=[],r=[];for(const n of m.children){const a=this.parse(n.name);a&&r.push([a,n])}const e=(0,c.groupByExtension)(r,([n])=>n),i=[];for(const n of e)n.sort((a,l)=>w.rcompare(a[0].version,l[0].version)),s.push(...n.slice(1).map(a=>a[1].resource)),i.push(n[0][1]);i.sort((n,a)=>n.mtime-a.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await f.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?new c.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase():(0,y.generateUuid)()}parse(m){const s=b.exec(m);return s&&s[1]&&s[2]?new c.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};L=ue([fe(0,F.INativeEnvironmentService),fe(1,D.IFileService),fe(2,S.IExtensionGalleryService),fe(3,R.ILogService)],L),t.ExtensionsDownloader=L}),define(Q[103],Z([0,1,2,15,33,29,3,4,9,8,14,22]),function(x,t,v,T,D,S,F,O,u,c,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let w=class extends v.Disposable{constructor(f,d){super();this.environmentService=f,this.logService=d,this.processesLimiter=new O.Limiter(5)}async postUninstall(f){const d=this.parseScript(f,"uninstall");return d&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${b}`)))),(0,R.rimraf)(this.getExtensionStoragePath(f)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(f,d){const b=`vscode:${d}`;if(f.location.scheme===c.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[b]=="string"){const L=f.manifest.scripts[b].split(" ");return L.length<2||L[0]!=="node"||!L[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${b} should be a node script`),null):{script:(0,F.join)(f.location.fsPath,L[1]),args:L.slice(2)||[]}}return null}runLifecycleHook(f,d,b,L,C){return new Promise((m,s)=>{const r=this.start(f,d,b,C);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?s(n):m(void 0)};r.on("error",n=>{i((0,S.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,a)=>{i(n?`post-${d} process exited with code ${n}`:void 0)}),L&&(e=setTimeout(()=>{e=null,r.kill(),s("timed out")},5e3))})}start(f,d,b,L){const C={silent:!0,execArgv:void 0},m=(0,D.fork)(f,[`--type=extension-post-${d}`,...b],C);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const s=u.Event.fromNodeEventEmitter(m.stdout,"data"),r=u.Event.fromNodeEventEmitter(m.stderr,"data");s(n=>this.logService.info(L.identifier.id,L.manifest.version,`post-${d}`,n)),r(n=>this.logService.error(L.identifier.id,L.manifest.version,`post-${d}`,n));const e=u.Event.any(u.Event.map(s,n=>({data:`%c${n}`,format:[""]})),u.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return u.Event.debounce(e,(n,a)=>n?{data:n.data+a.data,format:[...n.format,...a.format]}:{data:a.data,format:a.format},100)(n=>{console.group(L.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}getExtensionStoragePath(f){return(0,F.join)(this.environmentService.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};w=ue([fe(0,y.IEnvironmentService),fe(1,T.ILogService)],w),t.ExtensionsLifecycle=w}),define(Q[104],Z([0,1,2,22,9,19,7,25,17,15]),function(x,t,v,T,D,S,F,O,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let R=class extends v.Disposable{constructor(w,P,f,d){super();this.extensionsManagementService=w,this.logService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(w.onInstallExtension(C=>this.onInstallExtension(C))),this._register(w.onDidInstallExtension(C=>this.onDidInstallExtension(C))),this._register(w.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const b=F.URI.file(f.extensionsPath),L=new u.ExtUri(C=>!P.hasCapability(C,1024));this._register(P.watch(b)),this._register(D.Event.filter(P.onDidFilesChange,C=>C.changes.some(m=>this.doesChangeAffects(m,b,L)))(()=>this.onDidChange()))}doesChangeAffects(w,P,f){return f.isEqual(f.dirname(w.resource),P)?f.isEqual(w.resource,f.joinPath(P,".obsolete"))?!0:!(w.type!==1&&w.type!==2||f.basename(w.resource).startsWith(".")):!1}onInstallExtension(w){this.addInstallingExtension(w.identifier)}onDidInstallExtension(w){this.removeInstallingExtension(w.identifier),w.error||this.addInstalledExtension(w.identifier)}onDidUninstallExtension(w){w.error||this.removeInstalledExtension(w.identifier)}addInstallingExtension(w){this.removeInstallingExtension(w),this.installingExtensions.push(w)}removeInstallingExtension(w){this.installingExtensions=this.installingExtensions.filter(P=>!(0,O.areSameExtensions)(P,w))}addInstalledExtension(w){this.installedExtensions&&(this.removeInstalledExtension(w),this.installedExtensions.push(w))}removeInstalledExtension(w){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(P=>!(0,O.areSameExtensions)(P,w)))}async onDidChange(){if(this.installedExtensions){const w=await this.extensionsManagementService.getInstalled(1),P=w.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(b=>(0,O.areSameExtensions)(b,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),f=this.installedExtensions.filter(d=>this.installingExtensions.some(b=>(0,O.areSameExtensions)(b,d))?!1:w.every(b=>!(0,O.areSameExtensions)(b.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=w.map(d=>d.identifier),(P.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P,removed:f})}}};R=ue([fe(1,S.IFileService),fe(2,T.INativeEnvironmentService),fe(3,c.ILogService)],R),t.ExtensionsWatcher=R}),define(Q[105],Z([0,1,14,18,128,24,2,22,4,25,15,53,23,9,8,3]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let b=class extends F.Disposable{constructor(m,s,r){super();this.extensionManagementService=m,this.logService=r,this._onDidLanguagesChange=this._register(new P.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new L(s,r)),this._register(m.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(m.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(m=>{const s=["en",...Object.keys(m)];return(0,w.distinct)(s)})}onDidInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",m.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(m){this.cache.getLanguagePacks().then(s=>{Object.keys(s).some(r=>s[r]&&s[r].extensions.some(e=>(0,c.areSameExtensions)(e.extensionIdentifier,m)))&&(this.logService.debug("Removing language packs from the extension",m.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[m,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(s);return!(0,w.equals)(Object.keys(m),Object.keys(r))}};b=ue([fe(0,S.IExtensionManagementService),fe(1,O.INativeEnvironmentService),fe(2,R.ILogService)],b),t.LocalizationsService=b;let L=class extends F.Disposable{constructor(m,s){super();this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,d.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new u.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(s=>{Object.keys(s).forEach(r=>delete s[r]),this.createLanguagePacksFromExtensions(s,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...s){for(const r of s)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,r);Object.keys(m).forEach(r=>this.updateHash(m[r]))}createLanguagePacksFromExtension(m,s){const r=s.identifier,e=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of e)if(s.location.scheme===f.Schemas.file&&(0,y.isValidLocalization)(i)){let n=m[i.languageId];n||(n={hash:"",extensions:[],translations:{}},m[i.languageId]=n);let a=n.extensions.filter(l=>(0,c.areSameExtensions)(l.extensionIdentifier,r))[0];a?a.version=s.manifest.version:n.extensions.push({extensionIdentifier:r,version:s.manifest.version});for(const l of i.translations)n.translations[l.id]=(0,d.join)(s.location.fsPath,l.path)}}updateHash(m){if(m){const s=(0,D.createHash)("md5");for(const r of m.extensions)s.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);m.hash=s.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return T.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(e){return{}}}).then(r=>(s=m(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,v.writeFile)(this.languagePacksFilePath,e)}).then(()=>s,r=>this.logService.error(r))})}};L=ue([fe(0,O.INativeEnvironmentService),fe(1,R.ILogService)],L)}),define(Q[106],Z([0,1,15,19]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function D(u,c,R,y){try{return(await new Promise((P,f)=>{x(["spdlog"],P,f)})).createAsyncRotatingLogger(u,c,R,y)}catch(w){console.error(w)}return null}function S(u,c,R,y){return x.__$__nodeRequire("spdlog").createRotatingLogger(u,c,R,y)}t.createRotatingLogger=S;function F(u,c,R){switch(c){case v.LogLevel.Trace:u.trace(R);break;case v.LogLevel.Debug:u.debug(R);break;case v.LogLevel.Info:u.info(R);break;case v.LogLevel.Warning:u.warn(R);break;case v.LogLevel.Error:u.error(R);break;case v.LogLevel.Critical:u.critical(R);break;default:throw new Error("Invalid log level")}}class O extends v.AbstractMessageLogger{constructor(c,R,y,w){super();this.name=c,this.filepath=R,this.rotating=y,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(P=>{this._logger&&this._logger.setLevel(P)}))}_createSpdLogLogger(){const c=this.rotating?6:1,R=30/c*T.ByteSize.MB;return D(this.name,this.filepath,R,c).then(y=>{if(y){this._logger=y,this._logger.setLevel(this.getLevel());for(const{level:w,message:P}of this.buffer)F(this._logger,w,P);this.buffer=[]}})}log(c,R){this._logger?F(this._logger,c,R):this.getLevel()<=c&&this.buffer.push({level:c,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=O}),define(Q[54],Z([0,1,82,16,19,12,40]),function(x,t,v,T,D,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function O(y,w,P,f,d,b){let L;try{await u(y,w,P,f,d,b)}catch(C){L=C}finally{L&&d.errorTransformer&&(L=d.errorTransformer(L)),typeof L!="undefined"&&P.error(L),P.end()}}t.readFileIntoStream=O;async function u(y,w,P,f,d,b){c(b);const L=await y.open(w,{create:!1});try{c(b);let C=0,m=0,s=d&&typeof d.length=="number"?d.length:void 0,r=T.VSBuffer.alloc(Math.min(d.bufferSize,typeof s=="number"?s:d.bufferSize)),e=d&&typeof d.position=="number"?d.position:0,i=0;do m=await y.read(L,e,r.buffer,i,r.byteLength-i),e+=m,i+=m,C+=m,typeof s=="number"&&(s-=m),i===r.byteLength&&(await P.write(f(r)),r=T.VSBuffer.alloc(Math.min(d.bufferSize,typeof s=="number"?s:d.bufferSize)),i=0);while(m>0&&(typeof s!="number"||s>0)&&c(b)&&R(C,d));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),P.write(f(r.slice(0,n)))}}catch(C){throw(0,D.ensureFileSystemProviderError)(C)}finally{await y.close(L)}}function c(y){if(y.isCancellationRequested)throw(0,S.canceled)();return!0}function R(y,w){if(w==null?void 0:w.limits){if(typeof w.limits.memory=="number"&&y>w.limits.memory)throw(0,D.createFileSystemProviderError)((0,v.localize)(0,null,F.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&y>w.limits.size)throw(0,D.createFileSystemProviderError)((0,v.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[107],Z([0,1,81,129,2,19,9,17,45,23,15,16,35,4,28,8,54,130]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P,f,d,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let C=class extends D.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(s,r){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,T.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:r});const e=new D.DisposableStore;return e.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new S.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:s}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:r}),this.provider.delete(s),(0,D.dispose)(e)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(e){r.push(e)}}),!this.provider.has(s)&&await P.Promises.settled(r)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,r){const e=this.provider.get(s.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return L.Iterable.map(this.provider,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async withProvider(s){if(!(0,O.isAbsolutePath)(s))throw new S.FileOperationError((0,v.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const r=this.provider.get(s.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=(0,v.localize)(1,null,s.toString()),e}return r}async withReadProvider(s){const r=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(r)||(0,S.hasReadWriteCapability)(r)||(0,S.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const r=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(r)||(0,S.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.doResolveFile(s,r)}catch(e){throw(0,S.toFileSystemProviderErrorCode)(e)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,v.localize)(2,null,this.resourceForError(s)),1):(0,S.ensureFileSystemProviderError)(e)}}async doResolveFile(s,r){const e=await this.withProvider(s),i=this.isPathCaseSensitive(e),n=r==null?void 0:r.resolveTo,a=r==null?void 0:r.resolveSingleChildDescendants,l=r==null?void 0:r.resolveMetadata,g=await e.stat(s);let E;return this.toFileStat(e,s,g,void 0,!!l,(M,j)=>(E||(E=u.TernarySearchTree.forUris(()=>!i),E.set(s,!0),(0,c.isNonEmptyArray)(n)&&n.forEach(k=>E.set(k,!0))),Boolean(E.findSuperstr(M.resource)||E.get(M.resource))?!0:M.isDirectory&&a?j===1:!1))}async toFileStat(s,r,e,i,n,a){var l;const{providerExtUri:g}=this.getExtUri(s),E={resource:r,name:g.basename(r),isFile:(e.type&S.FileType.File)!=0,isDirectory:(e.type&S.FileType.Directory)!=0,isSymbolicLink:(e.type&S.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean(((l=e.permissions)!==null&&l!==void 0?l:0)&S.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,S.etag)({mtime:e.mtime,size:e.size})};if(E.isDirectory&&a(E,i)){try{const M=await s.readdir(r),j=await P.Promises.settled(M.map(async([k,U])=>{try{const W=g.joinPath(r,k),H=n?await s.stat(W):{type:U};return await this.toFileStat(s,W,H,M.length,n,a)}catch(W){return this.logService.trace(W),null}}));E.children=(0,c.coalesce)(j)}catch(M){this.logService.trace(M),E.children=[]}return E}return E}async resolveAll(s){return P.Promises.settled(s.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(s){const r=await this.withProvider(s);try{return!!await r.stat(s)}catch(e){return!1}}async canCreateFile(s,r){try{await this.doValidateCreateFile(s,r)}catch(e){return e}return!0}async doValidateCreateFile(s,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(s))throw new S.FileOperationError((0,v.localize)(3,null,this.resourceForError(s)),3,r)}async createFile(s,r=y.VSBuffer.fromString(""),e){await this.doValidateCreateFile(s,e);const i=await this.writeFile(s,r);return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,i)),i}async writeFile(s,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,e)||await this.mkdirp(i,n.dirname(s));let l;if((0,S.hasReadWriteCapability)(i)&&!(r instanceof y.VSBuffer))if((0,w.isReadableStream)(r)){const g=await(0,w.peekStream)(r,3);g.ended?l=y.VSBuffer.concat(g.buffer):l=g}else l=(0,w.peekReadable)(r,g=>y.VSBuffer.concat(g),3);else l=r;!(0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i)&&l instanceof y.VSBuffer?await this.doWriteUnbuffered(i,s,e,l):await this.doWriteBuffered(i,s,e,l instanceof y.VSBuffer?(0,y.bufferToReadable)(l):l)}catch(a){throw new S.FileOperationError((0,v.localize)(4,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),e)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,r,e){if(!!(e==null?void 0:e.unlock)&&!(s.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(r)));let n;try{n=await s.stat(r)}catch(a){return}if((n.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,v.localize)(6,null,this.resourceForError(r)),0,e);if(this.throwIfFileIsReadonly(r,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,S.etag)({mtime:e.mtime,size:n.size}))throw new S.FileOperationError((0,v.localize)(7,null),3,e);return n}async readFile(s,r){const e=await this.withReadProvider(s);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(e,s,r):this.doReadFile(e,s,r)}async doReadFileAtomic(s,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(s,r,e);i(a)}catch(a){n(a)}})})}async doReadFile(s,r,e){const i=await this.doReadFileStream(s,r,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,y.streamToBuffer)(i.value)})}async readFileStream(s,r){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,r)}async doReadFileStream(s,r,e){const i=new f.CancellationTokenSource,n=this.validateReadFile(r,e).then(l=>l,l=>{throw i.cancel(),l});let a;try{e&&typeof e.etag=="string"&&e.etag!==S.ETAG_DISABLED&&await n,!((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasFileReadStreamCapability)(s))||(0,S.hasReadWriteCapability)(s)&&(e==null?void 0:e.preferUnbuffered)?a=this.readFileUnbuffered(s,r,e):(0,S.hasFileReadStreamCapability)(s)?a=this.readFileStreamed(s,r,i.token,e):a=this.readFileBuffered(s,r,i.token,e);const l=await n;return Object.assign(Object.assign({},l),{value:a})}catch(l){throw a&&await(0,w.consumeStream)(a),new S.FileOperationError((0,v.localize)(8,null,this.resourceForError(r),(0,S.ensureFileSystemProviderError)(l).toString()),(0,S.toFileOperationResult)(l),e)}}readFileStreamed(s,r,e,i=Object.create(null)){const n=s.readFileStream(r,i,e);return(0,w.transform)(n,{data:a=>a instanceof y.VSBuffer?a:y.VSBuffer.wrap(a),error:a=>new S.FileOperationError((0,v.localize)(9,null,this.resourceForError(r),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),i)},a=>y.VSBuffer.concat(a))}readFileBuffered(s,r,e,i=Object.create(null)){const n=(0,y.newWriteableBufferStream)();return(0,b.readFileIntoStream)(s,r,n,a=>a,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new S.FileOperationError((0,v.localize)(10,null,this.resourceForError(r),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),i)}),e),n}readFileUnbuffered(s,r,e){const i=(0,w.newWriteableStream)(n=>y.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(r);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(y.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,r){const e=await this.resolve(s,{resolveMetadata:!0});if(e.isDirectory)throw new S.FileOperationError((0,v.localize)(11,null,this.resourceForError(s)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==S.ETAG_DISABLED&&r.etag===e.etag)throw new S.FileOperationError((0,v.localize)(12,null),2,r);return this.validateReadFileLimits(s,e.size,r),e}validateReadFileLimits(s,r,e){if(e==null?void 0:e.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new S.FileOperationError((0,v.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,r,e){return this.doCanMoveCopy(s,r,"move",e)}async canCopy(s,r,e){return this.doCanMoveCopy(s,r,"copy",e)}async doCanMoveCopy(s,r,e,i){if(s.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,s,a,r,e,i)}catch(n){return n}return!0}async move(s,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(i,s,n,r,"move",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,a==="move"?2:3,l)),l}async copy(s,r,e){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(i,s,n,r,"copy",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,a==="copy"?3:2,l)),l}async doMoveCopy(s,r,e,i,n,a){if(r.toString()===i.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(s,r,e,i,n,a);if(l&&!g&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(s===e&&(0,S.hasFileFolderCopyCapability)(s))await s.copy(r,i,{overwrite:a});else{const E=await this.resolve(r);E.isDirectory?await this.doCopyFolder(s,E,e,i):await this.doCopyFile(s,r,e,i)}return n}else return s===e?(await s.rename(r,i,{overwrite:a}),n):(await this.doMoveCopy(s,r,e,i,"copy",a),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(s,r,e,i){if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(s,r,e,i);if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(s,r,e,i);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(s,r,e,i);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasReadWriteCapability)(e))return this.doPipeUnbuffered(s,r,e,i)}async doCopyFolder(s,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await P.Promises.settled(r.children.map(async n=>{const a=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),e,a):this.doCopyFile(s,n.resource,e,a)}))}async doValidateMoveCopy(s,r,e,i,n,a){let l=!1;if(s===e){const{providerExtUri:E,isPathCaseSensitive:M}=this.getExtUri(s);if(M||(l=E.isEqual(r,i)),l&&n==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!l&&E.isEqualOrParent(i,r))throw new Error((0,v.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const g=await this.exists(i);if(g&&!l){if(!a)throw new S.FileOperationError((0,v.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(s===e){const{providerExtUri:E}=this.getExtUri(s);if(E.isEqualOrParent(r,i))throw new Error((0,v.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:g,isSameResourceWithDifferentPathCase:l}}getExtUri(s){const r=this.isPathCaseSensitive(s);return{providerExtUri:r?O.extUri:O.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(r,s);const e=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,e)),e}async mkdirp(s,r){const e=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(r,i.dirname(r));)try{if(((await s.stat(r)).type&S.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await s.mkdir(r)}catch(a){if((0,S.toFileSystemProviderErrorCode)(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(s,r){try{await this.doValidateDelete(s,r)}catch(e){return e}return!0}async doValidateDelete(s,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(r==null?void 0:r.useTrash)&&!(e.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(s)));let n;try{n=await e.stat(s)}catch(l){}if(n)this.throwIfFileIsReadonly(s,n);else throw new S.FileOperationError((0,v.localize)(20,null,this.resourceForError(s)),1);if(!!!(r==null?void 0:r.recursive)){const l=await this.resolve(s);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(s)))}return e}async del(s,r){const e=await this.doValidateDelete(s,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await e.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new S.FileOperationEvent(s,1))}watch(s,r={recursive:!1,excludes:[]}){let e=!1,i=()=>{e=!0};return this.doWatch(s,r).then(n=>{e?(0,D.dispose)(n):i=()=>(0,D.dispose)(n)},n=>this.logService.error(n)),(0,D.toDisposable)(()=>i())}async doWatch(s,r){const e=await this.withProvider(s),i=this.toWatchKey(e,s,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(s,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,D.toDisposable)(()=>{n.count--,n.count===0&&((0,D.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,r,e){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,D.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{var n;const a=await s.open(r,{create:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1});try{(0,w.isReadableStream)(i)||(0,w.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,a,i):await this.doWriteReadableBufferedQueued(s,a,i)}catch(l){throw(0,S.ensureFileSystemProviderError)(l)}finally{await s.close(a)}})}async doWriteStreamBufferedQueued(s,r,e){let i=0,n;if((0,w.isReadableBufferedStream)(e)){if(e.buffer.length>0){const a=y.VSBuffer.concat(e.buffer);await this.doWriteBuffer(s,r,a,a.byteLength,i,0),i+=a.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(a,l)=>{(0,w.listenStream)(n,{onData:async g=>{n.pause();try{await this.doWriteBuffer(s,r,g,g.byteLength,i,0)}catch(E){return l(E)}i+=g.byteLength,setTimeout(()=>n.resume())},onError:g=>l(g),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(s,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(s,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,r,e,i,n,a){let l=0;for(;l<i;)l+=await s.write(r,n+l,e.buffer,a+l,i-l)}async doWriteUnbuffered(s,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,r,e,i))}async doWriteUnbufferedQueued(s,r,e,i){var n;let a;i instanceof y.VSBuffer?a=i:(0,w.isReadableStream)(i)?a=await(0,y.streamToBuffer)(i):(0,w.isReadableBufferedStream)(i)?a=await(0,y.bufferedStreamToBuffer)(i):a=(0,y.readableToBuffer)(i),await s.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,r,e,i))}async doPipeBufferedQueued(s,r,e,i){let n,a;try{n=await s.open(r,{create:!1}),a=await e.open(i,{create:!0,unlock:!1});const l=y.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,E=0,M=0;do M=await s.read(n,g,l.buffer,E,l.byteLength-E),await this.doWriteBuffer(e,a,l,M,g,E),g+=M,E+=M,E===l.byteLength&&(E=0);while(M>0)}catch(l){throw(0,S.ensureFileSystemProviderError)(l)}finally{await P.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof a=="number"?e.close(a):Promise.resolve()])}}async doPipeUnbuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,r,e,i))}async doPipeUnbufferedQueued(s,r,e,i){return e.writeFile(i,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,r,e,i))}async doPipeUnbufferedToBufferedQueued(s,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const a=await s.readFile(r);await this.doWriteBuffer(e,n,y.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,S.ensureFileSystemProviderError)(a)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(s,r,e,i){const n=await(0,y.streamToBuffer)(this.readFileBuffered(s,r,f.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(s,r){if(s.capabilities&2048)throw new S.FileOperationError((0,v.localize)(22,null,this.resourceForError(r)),6);return s}throwIfFileIsReadonly(s,r){var e;if(((e=r.permissions)!==null&&e!==void 0?e:0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,v.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===d.Schemas.file?s.fsPath:s.toString(!0)}};C=ue([fe(0,R.ILogService)],C),t.FileService=C}),define(Q[108],Z([0,1,18,64,2,19,9,13,14,3,17,36,4,15,83,51,92,94,91,100,35,54,23,16]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P,f,d,b,L,C,m,s,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class n extends D.Disposable{constructor(l,g){var E;super();this.logService=l,this.options=g,this.BUFFER_SIZE=((E=this.options)===null||E===void 0?void 0:E.bufferSize)||64*1024,this.onDidChangeCapabilities=F.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new F.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new F.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new w.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(l){try{const{stat:g,symbolicLink:E}=await u.SymlinkSupport.stat(this.toFilePath(l));return{type:this.toType(g,E),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(l){try{const g=await(0,u.readdir)(this.toFilePath(l),{withFileTypes:!0}),E=[];return await Promise.all(g.map(async M=>{try{let j;M.isSymbolicLink()?j=(await this.stat((0,R.joinPath)(l,M.name))).type:j=this.toType(M),E.push([M.name,j])}catch(j){this.logService.trace(j)}})),E}catch(g){throw this.toFileSystemProviderError(g)}}toType(l,g){let E;return(g==null?void 0:g.dangling)?E=S.FileType.Unknown:l.isFile()?E=S.FileType.File:l.isDirectory()?E=S.FileType.Directory:E=S.FileType.Unknown,g&&(E|=S.FileType.SymbolicLink),E}async readFile(l){try{const g=this.toFilePath(l);return await v.promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(l,g,E){const M=(0,s.newWriteableStream)(j=>i.VSBuffer.concat(j.map(k=>i.VSBuffer.wrap(k))).buffer);return(0,r.readFileIntoStream)(this,l,M,j=>j.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),E),M}async writeFile(l,g,E){let M;try{const j=this.toFilePath(l);if(!E.create||!E.overwrite){if(await(0,u.exists)(j)){if(!E.overwrite)throw(0,S.createFileSystemProviderError)((0,f.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!E.create)throw(0,S.createFileSystemProviderError)((0,f.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}M=await this.open(l,{create:!0,unlock:E.unlock}),await this.write(M,0,g,0,g.byteLength)}catch(j){throw await this.toFileSystemProviderWriteError(l,j)}finally{typeof M=="number"&&await this.close(M)}}async open(l,g){try{const E=this.toFilePath(l);if((0,S.isFileOpenForWriteOptions)(g)&&g.unlock)try{const{stat:k}=await u.SymlinkSupport.stat(E);k.mode&128||await v.promises.chmod(E,k.mode|128)}catch(k){this.logService.trace(k)}let M;if((0,S.isFileOpenForWriteOptions)(g)){if(O.isWindows)try{await v.promises.truncate(E,0),M="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}M||(M="w")}else M="r";const j=await(0,T.promisify)(v.open)(E,M);return this.mapHandleToPos.set(j,0),(0,S.isFileOpenForWriteOptions)(g)&&this.writeHandles.set(j,l),j}catch(E){throw(0,S.isFileOpenForWriteOptions)(g)?await this.toFileSystemProviderWriteError(l,E):this.toFileSystemProviderError(E)}}async close(l){try{if(this.mapHandleToPos.delete(l),this.writeHandles.delete(l)&&this.canFlush)try{await(0,T.promisify)(v.fdatasync)(l)}catch(g){this.canFlush=!1,this.logService.error(g)}return await(0,T.promisify)(v.close)(l)}catch(g){throw this.toFileSystemProviderError(g)}}async read(l,g,E,M,j){const k=this.normalizePos(l,g);let U=null;try{const W=await(0,T.promisify)(v.read)(l,E,M,j,k);return typeof W=="number"?U=W:U=W.bytesRead,U}catch(W){throw this.toFileSystemProviderError(W)}finally{this.updatePos(l,k,U)}}normalizePos(l,g){return g===this.mapHandleToPos.get(l)?null:g}updatePos(l,g,E){const M=this.mapHandleToPos.get(l);typeof M=="number"&&(typeof g=="number"||(typeof E=="number"?this.mapHandleToPos.set(l,M+E):this.mapHandleToPos.delete(l)))}async write(l,g,E,M,j){return(0,w.retry)(()=>this.doWrite(l,g,E,M,j),100,3)}async doWrite(l,g,E,M,j){const k=this.normalizePos(l,g);let U=null;try{const W=await(0,T.promisify)(v.write)(l,E,M,j,k);return typeof W=="number"?U=W:U=W.bytesWritten,U}catch(W){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(l),W)}finally{this.updatePos(l,k,U)}}async mkdir(l){try{await v.promises.mkdir(this.toFilePath(l))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(l,g){try{const E=this.toFilePath(l);await this.doDelete(E,g)}catch(E){throw this.toFileSystemProviderError(E)}}async doDelete(l,g){g.recursive?await(0,u.rimraf)(l,u.RimRafMode.MOVE):await v.promises.unlink(l)}async rename(l,g,E){const M=this.toFilePath(l),j=this.toFilePath(g);if(M!==j)try{await this.validateTargetDeleted(l,g,"move",E.overwrite),await(0,u.move)(M,j)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,f.localize)(2,null,(0,c.basename)(M),(0,c.basename)((0,c.dirname)(j)),k.toString()))),this.toFileSystemProviderError(k)}}async copy(l,g,E){const M=this.toFilePath(l),j=this.toFilePath(g);if(M!==j)try{await this.validateTargetDeleted(l,g,"copy",E.overwrite),await(0,u.copy)(M,j,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,f.localize)(3,null,(0,c.basename)(M),(0,c.basename)((0,c.dirname)(j)),k.toString()))),this.toFileSystemProviderError(k)}}async validateTargetDeleted(l,g,E,M){const j=this.toFilePath(l),k=this.toFilePath(g);let U=!1;if(!!(this.capabilities&1024)||(U=(0,y.isEqual)(j,k,!0)),U&&E==="copy")throw(0,S.createFileSystemProviderError)((0,f.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!U&&await(0,u.exists)(k)){if(!M)throw(0,S.createFileSystemProviderError)((0,f.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(l,g){return g.recursive?this.watchRecursive(l,g.excludes):this.watchNonRecursive(l)}watchRecursive(l,g){const E={path:this.toFilePath(l),excludes:g},M=(0,e.insert)(this.recursiveFoldersToWatch,E);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{M(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var l,g,E;if(this.recursiveWatcher instanceof C.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let M,j;((g=(l=this.options)===null||l===void 0?void 0:l.watcher)===null||g===void 0?void 0:g.usePolling)?(M=b.FileWatcher,j=(E=this.options)===null||E===void 0?void 0:E.watcher):this.recursiveFoldersToWatch.length===1?O.isWindows?M=L.FileWatcher:M=b.FileWatcher:M=C.FileWatcher,this.recursiveWatcher=new M(this.recursiveFoldersToWatch,k=>this._onDidChangeFile.fire((0,d.toFileChanges)(k)),k=>{k.type==="error"&&this._onDidWatchErrorOccur.fire(k.message),this.logService[k.type](k.message)},this.logService.getLevel()===P.LogLevel.Trace,j),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))}}watchNonRecursive(l){const g=new m.FileWatcher(this.toFilePath(l),M=>this._onDidChangeFile.fire((0,d.toFileChanges)(M)),M=>{M.type==="error"&&this._onDidWatchErrorOccur.fire(M.message),this.logService[M.type](M.message)},this.logService.getLevel()===P.LogLevel.Trace),E=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)});return(0,D.combinedDisposable)(g,E)}toFilePath(l){return(0,c.normalize)(l.fsPath)}toFileSystemProviderError(l){if(l instanceof S.FileSystemProviderError)return l;let g;switch(l.code){case"ENOENT":g=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=S.FileSystemProviderErrorCode.NoPermissions;break;default:g=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(l,g)}async toFileSystemProviderWriteError(l,g){let E=this.toFileSystemProviderError(g);if(l&&E.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:M}=await u.SymlinkSupport.stat(this.toFilePath(l));M.mode&128||(E=(0,S.createFileSystemProviderError)(g,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(M){this.logService.trace(M)}return E}dispose(){super.dispose(),(0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,D.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=n}),define(Q[41],Z([0,1,10]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,v.createDecorator)("productService")}),define(Q[26],Z([0,1,11,57]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class D{constructor(){this.data=new Map}add(F,O){T.ok(v.isString(F)),T.ok(v.isObject(O)),T.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,O)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new D}),define(Q[109],Z([0,1,26,9]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function D(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class S{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,c){this.schemasById[D(u)]=c,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new S;v.Registry.add(t.Extensions.JSONContribution,F)}),define(Q[31],Z([0,1,74,9,26,11,109]),function(x,t,v,T,D,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var O;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const u=D.Registry.as(F.Extensions.JSONContribution);class c{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},u.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(L,C=!0){this.registerConfigurations([L],C)}registerConfigurations(L,C=!0){const m=[];L.forEach(s=>{m.push(...this.validateAndRegisterProperties(s,C,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),u.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(L){const C=[],m=s=>{if(s.properties)for(const r in s.properties)C.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r]);s.allOf&&s.allOf.forEach(r=>m(r))};for(const s of L){m(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}u.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}registerDefaultConfigurations(L){const C=[],m=[];for(const s of L)for(const r in s)if(C.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),s[r]);const e={type:"object",default:this.defaultValues[r],description:v.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};m.push(y(r)),this.configurationProperties[r]=e,this.defaultLanguageConfigurationOverridesNode.properties[r]=e}else{this.defaultValues[r]=s[r];const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}deregisterDefaultConfigurations(L){const C=[];for(const m of L)for(const s in m)if(C.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}notifyConfigurationSchemaUpdated(...L){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(L){for(const C of L)this.overrideIdentifiers.add(C);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(L,C=!0,m,s=3){var r;s=S.isUndefinedOrNull(L.scope)?s:L.scope;let e=[],i=L.properties;if(i)for(let a in i){if(C&&f(a)){delete i[a];continue}const l=i[a];if(this.updatePropertyDefaultValue(a,l),t.OVERRIDE_PROPERTY_PATTERN.test(a)?l.scope=void 0:(l.scope=S.isUndefinedOrNull(l.scope)?s:l.scope,l.restricted=S.isUndefinedOrNull(l.restricted)?!!((r=m==null?void 0:m.restrictedConfigurations)===null||r===void 0?void 0:r.includes(a)):l.restricted),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),e.push(a)}let n=L.allOf;if(n)for(let a of n)e.push(...this.validateAndRegisterProperties(a,C,m,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(L){const C=m=>{let s=m.properties;if(s)for(const e in s)this.updateSchema(e,s[e]);let r=m.allOf;r&&r.forEach(C)};C(L)}updateSchema(L,C){switch(t.allSettings.properties[L]=C,C.scope){case 1:t.applicationSettings.properties[L]=C;break;case 2:t.machineSettings.properties[L]=C;break;case 6:t.machineOverridableSettings.properties[L]=C;break;case 3:t.windowSettings.properties[L]=C;break;case 4:t.resourceSettings.properties[L]=C;break;case 5:t.resourceSettings.properties[L]=C,this.resourceLanguageSettingsSchema.properties[L]=C;break}}removeFromSchema(L,C){switch(delete t.allSettings.properties[L],C.scope){case 1:delete t.applicationSettings.properties[L];break;case 2:delete t.machineSettings.properties[L];break;case 6:delete t.machineOverridableSettings.properties[L];break;case 3:delete t.windowSettings.properties[L];break;case 4:case 5:delete t.resourceSettings.properties[L];break}}updateOverridePropertyPatternKey(){for(const L of this.overrideIdentifiers.values()){const C=`[${L}]`,m={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(C,m),t.allSettings.properties[C]=m,t.applicationSettings.properties[C]=m,t.machineSettings.properties[C]=m,t.machineOverridableSettings.properties[C]=m,t.windowSettings.properties[C]=m,t.resourceSettings.properties[C]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(L,C){let m=this.defaultValues[L];S.isUndefined(m)&&(m=C.default),S.isUndefined(m)&&(m=w(C.type)),C.default=m}}const R="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function y(b){return b.substring(1,b.length-1)}t.overrideIdentifierFromKey=y;function w(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=w;const P=new c;D.Registry.add(t.Extensions.Configuration,P);function f(b){return b.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(b)?v.localize(5,null,b):P.getConfigurationProperties()[b]!==void 0?v.localize(6,null,b):null:v.localize(4,null)}t.validateProperty=f;function d(){const b=[],L=P.getConfigurationProperties();for(const C of Object.keys(L))b.push([C,L[C].scope]);return b.push(["launch",4]),b.push(["task",4]),b}t.getScopes=d}),define(Q[27],Z([0,1,21,11,7,26,10,31]),function(x,t,v,T,D,S,F,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,F.createDecorator)("configurationService");function u(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof D.URI)}t.isConfigurationOverrides=u;var c;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(c=t.ConfigurationTarget||(t.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=R;function y(i,n){const a=n?i?n.keys.filter(U=>i.keys.indexOf(U)===-1):[...n.keys]:[],l=i?n?i.keys.filter(U=>n.keys.indexOf(U)===-1):[...i.keys]:[],g=[];if(n&&i){for(const U of i.keys)if(n.keys.indexOf(U)!==-1){const W=L(i.contents,U),H=L(n.contents,U);v.equals(W,H)||g.push(U)}}const E=[],M=U=>{const W={};for(const H of U)for(const ne of H.identifiers)W[r(ne)]=H;return W},j=n?M(n.overrides):{},k=i?M(i.overrides):{};if(Object.keys(j).length)for(const U of a){const W=j[U];W&&E.push([(0,O.overrideIdentifierFromKey)(U),W.keys])}if(Object.keys(k).length)for(const U of l){const W=k[U];W&&E.push([(0,O.overrideIdentifierFromKey)(U),W.keys])}if(Object.keys(j).length&&Object.keys(k).length)for(const U of g){const W=k[U],H=j[U];if(W&&H){const ne=y({contents:W.contents,keys:W.keys,overrides:[]},{contents:H.contents,keys:H.keys,overrides:[]});E.push([(0,O.overrideIdentifierFromKey)(U),[...ne.added,...ne.removed,...ne.updated]])}}return{added:a,removed:l,updated:g,overrides:E}}t.compare=y;function w(i,n){const a=[];for(const l of Object.keys(i))if(O.OVERRIDE_PROPERTY_PATTERN.test(l)){const g={};for(const E in i[l])g[E]=i[l][E];a.push({identifiers:[(0,O.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(g),contents:P(g,n)})}return a}t.toOverrides=w;function P(i,n){const a=Object.create(null);for(let l in i)f(a,l,i[l],n);return a}t.toValuesTree=P;function f(i,n,a,l){const g=n.split("."),E=g.pop();let M=i;for(let j=0;j<g.length;j++){let k=g[j],U=M[k];switch(typeof U){case"undefined":U=M[k]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${g.slice(0,j+1).join(".")} is ${JSON.stringify(U)}`);return}M=U}if(typeof M=="object"&&M!==null)try{M[E]=a}catch(j){l(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(M)}`)}else l(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(M)}`)}t.addToValueTree=f;function d(i,n){const a=n.split(".");b(i,a)}t.removeFromValueTree=d;function b(i,n){const a=n.shift();if(n.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const l=i[a];typeof l=="object"&&!Array.isArray(l)&&(b(l,n),Object.keys(l).length===0&&delete i[a])}}function L(i,n,a){function l(M,j){let k=M;for(const U of j){if(typeof k!="object"||k===null)return;k=k[U]}return k}const g=n.split("."),E=l(i,g);return typeof E=="undefined"?a:E}t.getConfigurationValue=L;function C(i,n,a){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in i?T.isObject(i[l])&&T.isObject(n[l])?C(i[l],n[l],a):a&&(i[l]=n[l]):i[l]=n[l])})}t.merge=C;function m(){const i=S.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=m;function s(){const i=Object.create(null),n=S.Registry.as(O.Extensions.Configuration).getConfigurationProperties();for(let a in n){let l=n[a].default;f(i,a,l,g=>console.error(`Conflict in default settings: ${g}`))}return i}t.getDefaultValues=s;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,a){const l=i.inspect(n),g=i.inspect(a);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:l.defaultValue}t.getMigratedSettingValue=e}),define(Q[110],Z([0,1,58,45,23,11,21,7,31,27,26,2,9]),function(x,t,v,T,D,S,F,O,u,c,R,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class P{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,c.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,c.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const a of D.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[a],g=i[a];g&&(typeof l=="object"&&typeof g=="object"?(l=F.deepClone(l),this.mergeContents(l,g)):l=g),n[a]=l}return new P(n,this.keys,this.overrides)}merge(...e){const i=F.deepClone(this.contents),n=F.deepClone(this.overrides),a=[...this.keys];for(const l of e){this.mergeContents(i,l.contents);for(const g of l.overrides){const[E]=n.filter(M=>D.equals(M.identifiers,g.identifiers));E?this.mergeContents(E.contents,g.contents):n.push(F.deepClone(g))}for(const g of l.keys)a.indexOf(g)===-1&&a.push(g)}return new P(i,a,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&S.isObject(e[n])&&S.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=F.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?F.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,c.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,c.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=P;class f extends P{constructor(){const e=(0,c.getDefaultValues)(),i=(0,c.getConfigurationKeys)(),n=[];for(const a of Object.keys(e))u.OVERRIDE_PROPERTY_PATTERN.test(a)&&n.push({identifiers:[(0,u.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(e[a]),contents:(0,c.toValuesTree)(e[a],l=>console.error(`Conflict in default settings file: ${l}`))});super(e,i,n)}}t.DefaultConfigurationModel=f;class d{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!S.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:a,overrides:l,restricted:g}=this.doParseRaw(e,i);this._configurationModel=new P(n,a,l),this._restrictedConfigurations=g||[]}doParseContent(e){let i={},n=null,a=[],l=[],g=[];function E(j){Array.isArray(a)?a.push(j):n&&(a[n]=j)}let M={onObjectBegin:()=>{let j={};E(j),l.push(a),a=j,n=null},onObjectProperty:j=>{n=j},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{let j=[];E(j),l.push(a),a=j,n=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:E,onError:(j,k,U)=>{g.push({error:j,offset:k,length:U})}};if(e)try{v.visit(e,M),i=a[0]||{}}catch(j){console.error(`Error while parsing settings file ${this._name}: ${j}`),this._parseErrors=[j]}return i}doParseRaw(e,i){const n=R.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),a=this.filter(e,n,!0,i);e=a.raw;const l=(0,c.toValuesTree)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),g=Object.keys(e),E=(0,c.toOverrides)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:l,keys:g,overrides:E,restricted:a.restricted}}filter(e,i,n,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:e,restricted:[]};const l={},g=[];for(let E in e)if(u.OVERRIDE_PROPERTY_PATTERN.test(E)&&n){const M=this.filter(e[E],i,!1,a);l[E]=M.raw,g.push(...M.restricted)}else{const M=i[E],j=M?typeof M.scope!="undefined"?M.scope:3:void 0;(M==null?void 0:M.restricted)&&g.push(E),(j===void 0||a.scopes===void 0||a.scopes.includes(j))&&(a.skipRestricted&&(M==null?void 0:M.restricted)||(l[E]=e[E]))}return{raw:l,restricted:g}}}t.ConfigurationModelParser=d;class b extends y.Disposable{constructor(e,i,n,a){super();this.userSettingsResource=e,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new P}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=b;class L{constructor(e,i,n=new P,a=new P,l=new T.ResourceMap,g=new P,E=new T.ResourceMap,M=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=g,this._memoryConfigurationByResource=E,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let a;n.resource?(a=this._memoryConfigurationByResource.get(n.resource),a||(a=new P,this._memoryConfigurationByResource.set(n.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(e):a.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const a=this.getConsolidateConfigurationModel(i,n),l=this.getFolderConfigurationModelForResource(i.resource,n),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),M=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),j=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),U=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,W=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(e):l.freeze().getValue(e):void 0,H=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(e):g.getValue(e),ne=a.getValue(e),ee=D.distinct(D.flatten(a.overrides.map(ie=>ie.identifiers))).filter(ie=>a.getOverrideValue(e,ie)!==void 0);return{defaultValue:E,userValue:M,userLocalValue:j,userRemoteValue:k,workspaceValue:U,workspaceFolderValue:W,memoryValue:H,value:ne,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:j!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:W!==void 0?{value:l==null?void 0:l.freeze().getValue(e),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:g.getValue(e),override:i.overrideIdentifier?g.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(a=>u.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const l=(0,u.overrideIdentifierFromKey)(a),g=this._defaultConfiguration.getKeysForOverrideIdentifier(l),E=e.getKeysForOverrideIdentifier(l),M=[...E.filter(j=>g.indexOf(j)===-1),...g.filter(j=>E.indexOf(j)===-1),...g.filter(j=>!F.equals(this._defaultConfiguration.override(l).getValue(j),e.override(l).getValue(j)))];return[l,M]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:a,overrides:l}=(0,c.compare)(this.localUserConfiguration,e),g=[...i,...n,...a];return g.length&&this.updateLocalUserConfiguration(e),{keys:g,overrides:l}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:a,overrides:l}=(0,c.compare)(this.remoteUserConfiguration,e);let g=[...i,...n,...a];return g.length&&this.updateRemoteUserConfiguration(e),{keys:g,overrides:l}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:a,overrides:l}=(0,c.compare)(this.workspaceConfiguration,e);let g=[...i,...n,...a];return g.length&&this.updateWorkspaceConfiguration(e),{keys:g,overrides:l}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:a,updated:l,removed:g,overrides:E}=(0,c.compare)(n,i);let M=[...a,...l,...g];return(M.length||!n)&&this.updateFolderConfiguration(e,i),{keys:M,overrides:E}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:a,removed:l,overrides:g}=(0,c.compare)(i,void 0);return{keys:[...n,...a,...l],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const a=i.getFolder(e);a&&(n=this.getFolderConsolidatedConfiguration(a.uri)||n);const l=this._memoryConfigurationByResource.get(e);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(e);a?(i=n.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:a,keys:l}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:a,keys:l}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(a=>i.add(a))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),a=this.parseConfigurationModel(e.workspace),l=e.folders.reduce((g,E)=>(g.set(O.URI.revive(E[0]),this.parseConfigurationModel(E[1])),g),new T.ResourceMap);return new L(i,n,new P,a,l,new P,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new P(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=L;function C(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const a of r)a.keys.forEach(l=>e.add(l)),a.overrides.forEach(([l,g])=>{const E=(0,T.getOrSet)(i,l,new Set);g.forEach(M=>E.add(M))});const n=[];return i.forEach((a,l)=>n.push([l,[...a.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=C;class m{constructor(e,i,n,a){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=a,this._previousConfiguration=void 0;const l=new Set;e.keys.forEach(E=>l.add(E)),e.overrides.forEach(([,E])=>E.forEach(M=>l.add(M))),this.affectedKeys=[...l.values()];const g=new P;this.affectedKeys.forEach(E=>g.setValue(E,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=L.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(e,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,l=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!F.equals(a,l)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,c.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof n=="object"&&(a=Object.keys(n)[0]);){if(e=e[a],!e)return!1;n=n[a]}return!0}}t.ConfigurationChangeEvent=m;class s extends m{constructor(e,i,n,a){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=a}}t.AllKeysConfigurationChangeEvent=s}),define(Q[111],Z([0,1,26,31,2,27,110,9,4,17]),function(x,t,v,T,D,S,F,O,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class R extends D.Disposable{constructor(w,P){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new F.UserSettings(this.settingsResource,void 0,c.extUriBiasedIgnorePathCase,P)),this.configuration=new F.Configuration(new F.DefaultConfigurationModel,new F.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new u.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(T.Extensions.Configuration).onDidUpdateConfiguration(f=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const w=await this.userConfiguration.loadConfiguration();this.configuration=new F.Configuration(new F.DefaultConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(w,P){const f=typeof w=="string"?w:void 0,d=(0,S.isConfigurationOverrides)(w)?w:(0,S.isConfigurationOverrides)(P)?P:{};return this.configuration.getValue(f,d,void 0)}updateValue(w,P,f,d){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const P=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(f,P,1)}onDidDefaultConfigurationChange(w){const P=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new F.DefaultConfigurationModel,w);this.trigger(f,P,6)}trigger(w,P,f){const d=new F.ConfigurationChangeEvent(w,{data:P},this.configuration);d.source=f,d.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(w){switch(w){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=R}),define(Q[55],Z([0,1,84,10,31,26,16]),function(x,t,v,T,D,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,T.createDecorator)("requestService");function O(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}t.isSuccess=O;function u(f){return f.res.statusCode===204}async function c(f){if(!O(f))throw new Error("Server returned "+f.res.statusCode);return u(f)?null:(await(0,F.streamToBuffer)(f.stream)).toString()}t.asText=c;async function R(f){if(!O(f))throw new Error("Server returned "+f.res.statusCode);if(u(f))return null;const b=(await(0,F.streamToBuffer)(f.stream)).toString();try{return JSON.parse(b)}catch(L){throw L.message+=`:
`+b,L}}t.asJson=R;function y(f){P(f)}t.updateProxyConfigurationsScope=y;let w;function P(f){const d=S.Registry.as(D.Extensions.Configuration);w&&d.deregisterConfigurations([w]),w={id:"http",order:15,title:(0,v.localize)(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null),(0,v.localize)(7,null)],default:"override",description:(0,v.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(9,null),restricted:!0}}},d.registerConfiguration(w)}P(2)}),define(Q[112],Z([0,1,113,11]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function D(F,O){return F.protocol==="http:"?O.HTTP_PROXY||O.http_proxy||null:F.protocol==="https:"&&(O.HTTPS_PROXY||O.https_proxy||O.HTTP_PROXY||O.http_proxy)||null}async function S(F,O,u={}){const c=(0,v.parse)(F),R=u.proxyUrl||D(c,O);if(!R)return null;const y=(0,v.parse)(R);if(!/^https?:$/.test(y.protocol||""))return null;const w={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,T.isBoolean)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((P,f)=>{x(["http-proxy-agent"],P,f)}))(w):new(await new Promise((P,f)=>{x(["https-proxy-agent"],P,f)}))(w)}t.getProxyAgent=S}),define(Q[114],Z([0,1,30,16]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function D(S,F,O){let u=O&&O.get("storage.serviceMachineId",0)||null;if(u)return u;try{const R=(await F.readFile(S.serviceMachineIdResource)).value.toString();u=(0,v.isUUID)(R)?R:null}catch(c){u=null}if(!u){u=(0,v.generateUuid)();try{await F.writeFile(S.serviceMachineIdResource,T.VSBuffer.fromString(u))}catch(c){}}return O&&O.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=D}),define(Q[115],Z([0,1,10,9,2,11,67,4]),function(x,t,v,T,D,S,F,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=(0,v.createDecorator)("storageService");var c;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(c=t.WillSaveStateReason||(t.WillSaveStateReason={}));var R;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(R=t.StorageScope||(t.StorageScope={}));var y;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(y=t.StorageTarget||(t.StorageTarget={}));class w extends D.Disposable{constructor(b={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,L){L===u?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:L,target:this.getKeyTargets(b)[L]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,L,C){var m;return(m=this.getStorage(L))===null||m===void 0?void 0:m.get(b,C)}getBoolean(b,L,C){var m;return(m=this.getStorage(L))===null||m===void 0?void 0:m.getBoolean(b,C)}getNumber(b,L,C){var m;return(m=this.getStorage(L))===null||m===void 0?void 0:m.getNumber(b,C)}store(b,L,C,m){if((0,S.isUndefinedOrNull)(L)){this.remove(b,C);return}this.withPausedEmitters(()=>{var s;this.updateKeyTarget(b,C,m),(s=this.getStorage(C))===null||s===void 0||s.set(b,L)})}remove(b,L){this.withPausedEmitters(()=>{var C;this.updateKeyTarget(b,L,void 0),(C=this.getStorage(L))===null||C===void 0||C.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,L){const C=[],m=this.getKeyTargets(b);for(const s of Object.keys(m))m[s]===L&&C.push(s);return C}updateKeyTarget(b,L,C){var m,s;const r=this.getKeyTargets(L);typeof C=="number"?r[b]!==C&&(r[b]=C,(m=this.getStorage(L))===null||m===void 0||m.set(u,JSON.stringify(r))):typeof r[b]=="number"&&(delete r[b],(s=this.getStorage(L))===null||s===void 0||s.set(u,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const L=this.get(u,b);if(L)try{return JSON.parse(L)}catch(C){}return Object.create(null)}isNew(b){return this.getBoolean(t.IS_NEW_KEY,b)===!0}async flush(){var b,L,C,m;this._onWillSaveState.fire({reason:c.NONE}),await O.Promises.settled([(L=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&L!==void 0?L:Promise.resolve(),(m=(C=this.getStorage(1))===null||C===void 0?void 0:C.whenFlushed())!==null&&m!==void 0?m:Promise.resolve()])}async logStorage(){var b,L,C,m,s,r;const e=(L=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&L!==void 0?L:new Map,i=(m=(C=this.getStorage(1))===null||C===void 0?void 0:C.items)!==null&&m!==void 0?m:new Map;return f(e,i,(s=this.getLogDetails(0))!==null&&s!==void 0?s:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}t.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class P extends w{constructor(){super();this.globalStorage=new F.Storage(new F.InMemoryStorageDatabase),this.workspaceStorage=new F.Storage(new F.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}t.InMemoryStorageService=P;async function f(d,b,L,C){const m=l=>{try{return JSON.parse(l)}catch(g){return l}},s=new Map,r=new Map;d.forEach((l,g)=>{s.set(g,l),r.set(g,m(l))});const e=new Map,i=new Map;b.forEach((l,g)=>{e.set(g,l),i.set(g,m(l))}),console.group(`Storage: Global (path: ${L})`);let n=[];s.forEach((l,g)=>{n.push({key:g,value:l})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${C})`);let a=[];e.forEach((l,g)=>{a.push({key:g,value:l})}),console.table(a),console.groupEnd(),console.log(i)}t.logStorage=f}),define(Q[116],Z([0,1,13,34,30,7]),function(x,t,v,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function F(c){if(v.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function O(c,R,y,w,P,f,d,b,L,C){const m=Object.create(null);m["common.machineId"]=d,m.sessionID=(0,D.generateUuid)()+Date.now(),m.commitHash=P,m.version=f,m["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,v.PlatformToString)(v.platform),m["common.nodePlatform"]=T.platform,m["common.nodeArch"]=w,m["common.product"]=C||"desktop";const s=u(b||[]);s&&(m["common.msftInternal"]=s);let r=0;const e=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),v.isLinuxSnap&&(m["common.snap"]="true");const i=F(y);i&&(m["common.platformDetail"]=i);try{const n=await c.readFile(S.URI.file(L));m["common.source"]=n.value.toString().slice(0,30)}catch(n){}return m}t.resolveCommonProperties=O;function u(c){const R=T.env.USERDNSDOMAIN;if(!R)return!1;const y=R.toLowerCase();return c.some(w=>y===w)}t.verifyMicrosoftInternalDomain=u}),define(Q[42],Z([0,1,10]),function(x,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,v.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[117],Z([0,1,12,24,25,21,42,55,49,22,28,15,19,7,41,115,114,10,17]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P,f,d,b,L,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var m;(function(h){h[h.None=0]="None",h[h.IncludeVersions=1]="IncludeVersions",h[h.IncludeFiles=2]="IncludeFiles",h[h.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",h[h.IncludeSharedAccounts=8]="IncludeSharedAccounts",h[h.IncludeVersionProperties=16]="IncludeVersionProperties",h[h.ExcludeNonValidated=32]="ExcludeNonValidated",h[h.IncludeInstallationTargets=64]="IncludeInstallationTargets",h[h.IncludeAssetUri=128]="IncludeAssetUri",h[h.IncludeStatistics=256]="IncludeStatistics",h[h.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",h[h.Unpublished=4096]="Unpublished"})(m||(m={}));function s(...h){return String(h.reduce((o,I)=>o|I,0))}var r;(function(h){h[h.Tag=1]="Tag",h[h.ExtensionId=4]="ExtensionId",h[h.Category=5]="Category",h[h.ExtensionName=7]="ExtensionName",h[h.Target=8]="Target",h[h.Featured=9]="Featured",h[h.SearchText=10]="SearchText",h[h.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:m.None,criteria:[],assetTypes:[]};class l{constructor(o=a){this.state=o}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(o,I=this.state.pageSize){return new l(Object.assign(Object.assign({},this.state),{pageNumber:o,pageSize:I}))}withFilter(o,...I){const p=[...this.state.criteria,...I.length?I.map(A=>({filterType:o,value:A})):[{filterType:o}]];return new l(Object.assign(Object.assign({},this.state),{criteria:p}))}withSortBy(o){return new l(Object.assign(Object.assign({},this.state),{sortBy:o}))}withSortOrder(o){return new l(Object.assign(Object.assign({},this.state),{sortOrder:o}))}withFlags(...o){return new l(Object.assign(Object.assign({},this.state),{flags:o.reduce((I,p)=>I|p,0)}))}withAssetTypes(...o){return new l(Object.assign(Object.assign({},this.state),{assetTypes:o}))}get raw(){const{criteria:o,pageNumber:I,pageSize:p,sortBy:A,sortOrder:N,flags:B,assetTypes:V}=this.state;return{filters:[{criteria:o,pageNumber:I,pageSize:p,sortBy:A,sortOrder:N}],assetTypes:V,flags:B}}get searchText(){const o=this.state.criteria.filter(I=>I.filterType===r.SearchText)[0];return o&&o.value?o.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(o=>String(o.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(h,o){const I=(h||[]).filter(p=>p.statisticName===o)[0];return I?I.value:0}function E(h){const o="Microsoft.VisualStudio.Code.Translation.";return h.files.filter(p=>p.assetType.indexOf(o)===0).reduce((p,A)=>{const N=U(h,A.assetType);return N&&p.push([A.assetType.substring(o.length),N]),p},[])}function M(h){if(h.properties){const o=h.properties.filter(A=>A.key===e.Repository),I=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),p=o.filter(A=>I.test(A.value))[0];return p?{uri:p.value,fallbackUri:p.value}:null}return U(h,e.Repository)}function j(h){return{uri:`${h.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${h.fallbackAssetUri}/${e.VSIX}`}}function k(h){const o=U(h,e.Icon);if(o)return o;const I=T.DefaultIconPath;return{uri:I,fallbackUri:I}}function U(h,o){return h.files.filter(p=>p.assetType===o)[0]?{uri:`${h.assetUri}/${o}`,fallbackUri:`${h.fallbackAssetUri}/${o}`}:null}function W(h,o){const I=h.properties?h.properties.filter(A=>A.key===o):[],p=I.length>0&&I[0].value;return p?p.split(",").map(A=>(0,D.adoptToGalleryExtensionId)(A)):[]}function H(h){const o=h.properties?h.properties.filter(I=>I.key===i.Engine):[];return o.length>0&&o[0].value||""}function ne(h){const o=h.properties?h.properties.filter(p=>p.key===i.LocalizedLanguages):[],I=o.length>0&&o[0].value||"";return I?I.split(","):[]}function ee(h){return h.indexOf("preview")!==-1}function ie(h){const o=h.properties?h.properties.find(I=>I.key===i.WebExtension):void 0;return!!o&&o.value==="true"}function oe(h){return h.files.some(o=>o.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,C.joinPath)(P.URI.parse(h.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function _(h,o,I,p,A){const N={manifest:U(o,e.Manifest),readme:U(o,e.Details),changelog:U(o,e.Changelog),license:U(o,e.License),repository:M(o),download:j(o),icon:k(o),coreTranslations:E(o)};return{identifier:{id:(0,D.getGalleryExtensionId)(h.publisher.publisherName,h.extensionName),uuid:h.extensionId},name:h.extensionName,version:o.version,date:o.lastUpdated,displayName:h.displayName,publisherId:h.publisher.publisherId,publisher:h.publisher.publisherName,publisherDisplayName:h.publisher.displayName,description:h.shortDescription||"",installCount:g(h.statistics,"install"),rating:g(h.statistics,"averagerating"),ratingCount:g(h.statistics,"ratingcount"),assetUri:P.URI.parse(o.assetUri),webResource:oe(o),assetTypes:o.files.map(({assetType:B})=>B),assets:N,properties:{dependencies:W(o,i.Dependency),extensionPack:W(o,i.ExtensionPack),engine:H(o),localizedLanguages:ne(o),webExtension:ie(o)},telemetryData:{index:(p.pageNumber-1)*p.pageSize+I,querySource:A},preview:ee(h.flags)}}let q=class{constructor(o,I,p,A,N,B,V){this.requestService=o,this.logService=I,this.environmentService=p,this.telemetryService=A,this.fileService=N,this.productService=B;const $=B.extensionsGallery;this.extensionsGalleryUrl=$&&$.serviceUrl,this.extensionsControlUrl=$&&$.controlUrl,this.commonHeadersPromise=J(B.version,this.environmentService,this.fileService,V)}api(o=""){return`${this.extensionsGalleryUrl}${o}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(o,I){const p=[];let{total:A,firstPage:N,getPage:B}=await this.query({names:o,pageSize:o.length},I);p.push(...N);for(let V=1;p.length<A&&(N=await B(V,I),N.length);V++)p.push(...N);return p}async getCompatibleExtension(o,I){const p=await this.getCompatibleExtensionByEngine(o,I);return(p==null?void 0:p.properties.webExtension)?p.webResource?p:null:p}async getCompatibleExtensionByEngine(o,I){const p=(0,T.isIExtensionIdentifier)(o)?null:o;if(p&&p.properties.engine&&(0,u.isEngineValid)(p.properties.engine,this.productService.version,this.productService.date))return p;const{id:A,uuid:N}=p?p.identifier:o;let B=new l().withFlags(m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");N?B=B.withFilter(r.ExtensionId,N):B=B.withFilter(r.ExtensionName,A);const{galleryExtensions:V}=await this.queryGallery(B,R.CancellationToken.None),[$]=V;if(!$||!$.versions.length)return null;if(I){const Y=$.versions.filter(te=>te.version===I)[0];if(Y){const te=_($,Y,0,B);if(te.properties.engine&&(0,u.isEngineValid)(te.properties.engine,this.productService.version,this.productService.date))return te}return null}const X=await this.getLastValidExtensionVersion($,$.versions);return X?_($,X,0,B):null}async query(o,I){const p=R.CancellationToken.isCancellationToken(o)?{}:o,A=R.CancellationToken.isCancellationToken(o)?o:I;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let N=p.text||"";const B=(0,S.getOrDefault)(p,re=>re.pageSize,50);let V=new l().withFlags(m.IncludeLatestVersionOnly,m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,B).withFilter(r.Target,"Microsoft.VisualStudio.Code");N?(N=N.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,le,ge)=>(V=V.withFilter(r.Category,ge||le),"")),N=N.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,le,ge)=>(V=V.withFilter(r.Tag,ge||le),"")),N=N.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(r.Featured),"")),N=N.trim(),N&&(N=N.length<200?N:N.substring(0,200),V=V.withFilter(r.SearchText,N)),V=V.withSortBy(0)):p.ids?V=V.withFilter(r.ExtensionId,...p.ids):p.names?V=V.withFilter(r.ExtensionName,...p.names):V=V.withSortBy(4),typeof p.sortBy=="number"&&(V=V.withSortBy(p.sortBy)),typeof p.sortOrder=="number"&&(V=V.withSortOrder(p.sortOrder));const{galleryExtensions:$,total:X}=await this.queryGallery(V,A),Y=$.map((re,le)=>_(re,re.versions[0],le,V,p.source)),te=async(re,le)=>{if(le.isCancellationRequested)throw(0,v.canceled)();const ge=V.withPage(re+1),{galleryExtensions:Ie}=await this.queryGallery(ge,le);return Ie.map((Fe,Le)=>_(Fe,Fe.versions[0],Le,ge,p.source))};return{firstPage:Y,total:X,pageSize:V.pageSize,getPage:te}}async queryGallery(o,I){if(!this.isEnabled())throw new Error("No extension gallery service configured.");o=o.withFlags(o.flags,m.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(m.Unpublished));const p=await this.commonHeadersPromise,A=JSON.stringify(o.raw),N=Object.assign(Object.assign({},p),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(A.length)}),B=new Date().getTime();let V,$,X=0;try{if(V=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:A,headers:N},I),V.res.statusCode&&V.res.statusCode>=400&&V.res.statusCode<500)return{galleryExtensions:[],total:X};const Y=await(0,O.asJson)(V);if(Y){const te=Y.results[0],re=te.extensions,le=te.resultMetadata&&te.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return X=le&&le.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:X}}return{galleryExtensions:[],total:X}}catch(Y){throw $=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},o.telemetryData),{requestBodySize:String(A.length),duration:new Date().getTime()-B,success:!!V&&(0,O.isSuccess)(V),responseBodySize:V==null?void 0:V.res.headers["Content-Length"],statusCode:V?String(V.res.statusCode):void 0,errorCode:$?(0,v.isPromiseCanceledError)($)?"canceled":(0,v.getErrorMessage)($).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)}))}}async reportStatistic(o,I,p,A){if(!!this.isEnabled()){const N=await this.commonHeadersPromise,B=Object.assign(Object.assign({},N),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${o}/extensions/${I}/${p}/stats?statType=${A}`),headers:B},R.CancellationToken.None)}catch(V){}}}async download(o,I,p){this.logService.trace("ExtensionGalleryService#download",o.identifier.id);const A=(0,D.getGalleryExtensionTelemetryData)(o),N=new Date().getTime(),B=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},A),{duration:Y})),V=p===1?"install":p===2?"update":"",$=V?{uri:`${o.assets.download.uri}&${V}=true`,fallbackUri:`${o.assets.download.fallbackUri}?${V}=true`}:o.assets.download,X=await this.getAsset($);await this.fileService.writeFile(I,X.stream),B(new Date().getTime()-N)}async getReadme(o,I){if(o.assets.readme){const p=await this.getAsset(o.assets.readme,{},I);return await(0,O.asText)(p)||""}return""}async getManifest(o,I){if(o.assets.manifest){const p=await this.getAsset(o.assets.manifest,{},I),A=await(0,O.asText)(p);return A?JSON.parse(A):null}return null}async getCoreTranslation(o,I){const p=o.assets.coreTranslations.filter(A=>A[0]===I.toUpperCase())[0];if(p){const A=await this.getAsset(p[1]),N=await(0,O.asText)(A);return N?JSON.parse(N):null}return null}async getChangelog(o,I){if(o.assets.changelog){const p=await this.getAsset(o.assets.changelog,{},I);return await(0,O.asText)(p)||""}return""}async getAllVersions(o,I){let p=new l().withFlags(m.IncludeVersions,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");o.identifier.uuid?p=p.withFilter(r.ExtensionId,o.identifier.uuid):p=p.withFilter(r.ExtensionName,o.identifier.id);const A=[],{galleryExtensions:N}=await this.queryGallery(p,R.CancellationToken.None);return N.length&&(I?await Promise.all(N[0].versions.map(async B=>{let V;try{V=await this.getEngine(B)}catch($){}V&&(0,u.isEngineValid)(V,this.productService.version,this.productService.date)&&A.push({version:B.version,date:B.lastUpdated})})):A.push(...N[0].versions.map(B=>({version:B.version,date:B.lastUpdated})))),A}async getAsset(o,I={},p=R.CancellationToken.None){const A=await this.commonHeadersPromise,N={type:"GET"},B=Object.assign(Object.assign({},A),I.headers||{});I=Object.assign(Object.assign(Object.assign({},I),N),{headers:B});const V=o.uri,$=o.fallbackUri,X=Object.assign(Object.assign({},I),{url:V});try{const Y=await this.requestService.request(X,p);if(Y.res.statusCode===200)return Y;const te=await(0,O.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${te}`)}catch(Y){if((0,v.isPromiseCanceledError)(Y))throw Y;const te=(0,v.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:V,message:te});const re=Object.assign(Object.assign({},I),{url:$});return this.requestService.request(re,p)}}async getLastValidExtensionVersion(o,I){const p=this.getLastValidExtensionVersionFromProperties(o,I);return p||this.getLastValidExtensionVersionRecursively(o,I)}getLastValidExtensionVersionFromProperties(o,I){for(const p of I){const A=H(p);if(!A)return null;if((0,u.isEngineValid)(A,this.productService.version,this.productService.date))return p}return null}async getEngine(o){const I=H(o);if(I)return I;const p=U(o,e.Manifest);if(!p)throw new Error("Manifest was not found");const A={"Accept-Encoding":"gzip"},N=await this.getAsset(p,{headers:A}),B=await(0,O.asJson)(N);if(B)return B.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(o,I){if(!I.length)return null;const p=I[0],A=await this.getEngine(p);return(0,u.isEngineValid)(A,this.productService.version,this.productService.date)?(p.properties=p.properties||[],p.properties.push({key:i.Engine,value:A}),p):this.getLastValidExtensionVersionRecursively(o,I.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const o=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(o.res.statusCode!==200)throw new Error("Could not get extensions report.");const I=await(0,O.asJson)(o),p=new Map;if(I)for(const A of I.malicious){const N=p.get(A)||{id:{id:A},malicious:!0,slow:!1};N.malicious=!0,p.set(A,N)}return[...p.values()]}};q=ue([fe(0,O.IRequestService),fe(1,y.ILogService),fe(2,c.IEnvironmentService),fe(3,F.ITelemetryService),fe(4,w.IFileService),fe(5,f.IProductService),fe(6,(0,L.optional)(d.IStorageService))],q),t.ExtensionGalleryService=q;async function J(h,o,I,p){const A={"X-Market-Client-Id":`VSCode ${h}`,"User-Agent":`VSCode ${h}`},N=await(0,b.getServiceMachineId)(o,I,p);return A["X-Market-User-Id"]=N,A}t.resolveMarketplaceHeaders=J}),define(Q[118],Z([0,1,40,85,20,10,27,31,2,21,26]),function(x,t,v,T,D,S,F,O,u,c,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let y=class{constructor(f,d){this._configurationService=d,this._experimentProperties={},this._disposables=new u.DisposableStore,this._cleanupPatterns=[],this._appender=f.appender,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const L=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!L})}))}setExperimentProperty(f,d){this._experimentProperties[f]=d}setEnabled(f){this._enabled=f}_updateUserOptIn(){var f;const d=(f=this._configurationService)===null||f===void 0?void 0:f.getValue(w);this._userOptIn=d?d.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const f=await this._commonProperties;let d=f.sessionID,b=f["common.instanceId"],L=f["common.machineId"],C=f["common.firstSessionDate"],m=f["common.msftInternal"];return{sessionId:d,instanceId:b,machineId:L,firstSessionDate:C,msftInternal:m}}dispose(){this._disposables.dispose()}publicLog(f,d,b){return this.isOptedIn?this._commonProperties.then(L=>{d=(0,c.mixin)(d,L),d=(0,c.mixin)(d,this._experimentProperties),d=(0,c.cloneAndChange)(d,C=>{if(typeof C=="string")return this._cleanupInfo(C,b)}),this._appender.log(f,d)},L=>{console.error(L)}):Promise.resolve(void 0)}publicLog2(f,d,b){return this.publicLog(f,d,b)}publicLogError(f,d){return this.sendErrorTelemetry?this.publicLog(f,d,!0):Promise.resolve(void 0)}publicLogError2(f,d){return this.publicLogError(f,d)}_cleanupInfo(f,d){let b=f;if(d){const L=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(f);if(!e)break;L.push([e.index,r.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(b="";;){const r=m.exec(f);if(!r)break;!C.test(r[0])&&L.every(([e,i])=>r.index<e||r.index>=i)&&(b+=f.substring(s,r.index)+"<REDACTED: user-file-path>",s=m.lastIndex)}s<f.length&&(b+=f.substr(s))}for(let L of this._cleanupPatterns)b=b.replace(L,"");return b}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ue([fe(1,(0,S.optional)(F.IConfigurationService))],y),t.TelemetryService=y;const w="telemetry";R.Registry.as(O.Extensions.Configuration).registerConfiguration({id:w,order:110,type:"object",title:(0,T.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,T.localize)(2,null,v.default.privacyStatementUrl):(0,T.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Q[56],Z([0,1,27,21,11,4]),function(x,t,v,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(f,d){return Promise.resolve(void 0)}publicLog2(f,d){return this.publicLog(f,d)}publicLogError(f,d){return Promise.resolve(void 0)}publicLogError2(f,d){return this.publicLogError(f,d)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(d,b,L){}async publicLogError(d,b,L){}}t.NullEndpointTelemetryService=F;function O(...f){return{log:(d,b)=>f.forEach(L=>L.log(d,b)),flush:()=>S.Promises.settled(f.map(d=>d.flush()))}}t.combinedAppender=O,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(f,d){return d.onDidChangeConfiguration(b=>{b.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(b.source),configurationKeys:w(b.sourceConfig)})})}t.configurationTelemetry=u;function c(f){const d=Object.create(null),b=Object.create(null),L=Object.create(null);y(f,L);for(let C in L){C=C.length>150?C.substr(C.length-149):C;const m=L[C];typeof m=="number"?b[C]=m:typeof m=="boolean"?b[C]=m?1:0:typeof m=="string"?d[C]=m.substring(0,1023):typeof m!="undefined"&&m!==null&&(d[C]=m)}return{properties:d,measurements:b}}t.validateTelemetryData=c;function R(f){if(!f)return"none";let d="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(L=>{f.indexOf(`${L}+`)===0&&(d=L)}),d}t.cleanRemoteAuthority=R;function y(f,d,b=0,L){if(!!f)for(let C of Object.getOwnPropertyNames(f)){const m=f[C],s=L?L+C:C;Array.isArray(m)?d[s]=(0,T.safeStringify)(m):m instanceof Date?d[s]=m.toISOString():(0,D.isObject)(m)?b<2?y(m,d,b+1,s+"."):d[s]=(0,T.safeStringify)(m):d[s]=m}}function w(f){if(!f)return[];const d=[];return P(d,"",f),d}function P(f,d,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(L=>P(f,d?`${d}.${L}`:L,b[L])):f.push(d)}}),define(Q[119],Z([0,1,12,21,56]),function(x,t,v,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function S(O){const u=await new Promise((R,y)=>{x(["applicationinsights"],R,y)});let c;return u.defaultClient?(c=new u.TelemetryClient(O),c.channel.setUseDiskRetryCaching(!0)):(u.setup(O).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),c=u.defaultClient),O.indexOf("AIF-")===0&&(c.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),c}class F{constructor(u,c,R){this._eventPrefix=u,this._defaultData=c,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=S(this._aiClient)),this._asyncAIClient.then(c=>{u(c)},c=>{(0,v.onUnexpectedError)(c),console.error(c)})}}log(u,c){!this._aiClient||(c=(0,T.mixin)(c,this._defaultData),c=(0,D.validateTelemetryData)(c),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+u,properties:c.properties,measurements:c.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(c=>{c.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(Q[120],Z([0,1,14,18,3]),function(x,t,v,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function S(F,O){const u=Object.create(null),c=(y,w)=>{const P=JSON.parse(y);u[w]=P};if(O){const y=(0,v.readdirSync)(O).filter(P=>{try{return(0,T.statSync)((0,D.join)(O,P)).isDirectory()}catch(f){return!1}}),w=[];y.forEach(P=>{(0,v.readdirSync)((0,D.join)(O,P)).filter(d=>d==="telemetry.json").length===1&&w.push(P)}),w.forEach(P=>{const f=(0,T.readFileSync)((0,D.join)(O,P,"telemetry.json")).toString();c(f,P)})}let R=(0,T.readFileSync)((0,D.join)(F,"telemetry-core.json")).toString();return c(R,"vscode-core"),R=(0,T.readFileSync)((0,D.join)(F,"telemetry-extensions.json")).toString(),c(R,"vscode-extensions"),JSON.stringify(u,null,4)}t.buildTelemetryMessage=S}),define(Q[43],Z([0,1,73,3,18,4,14,131,132,11]),function(x,t,v,T,D,S,F,O,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class R extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=R;function y(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function w(r){if(r instanceof R)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new R(e,r)}function P(r,e,i,n,a,l){const g=T.dirname(e),E=T.join(n,g);if(!E.startsWith(n))return Promise.reject(new Error(v.localize(0,null,e)));const M=T.join(n,e);let j;return l.onCancellationRequested(()=>{j&&j.destroy()}),Promise.resolve(D.promises.mkdir(E,{recursive:!0})).then(()=>new Promise((k,U)=>{if(!l.isCancellationRequested)try{j=(0,D.createWriteStream)(M,{mode:i}),j.once("close",()=>k()),j.once("error",U),r.once("error",U),r.pipe(j)}catch(W){U(W)}}))}function f(r,e,i,n){let a=(0,S.createCancelablePromise)(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{a.cancel(),r.close()}),new Promise((g,E)=>{const M=new S.Sequencer,j=k=>{k.isCancellationRequested||(l++,r.readEntry())};r.once("error",E),r.once("close",()=>a.then(()=>{n.isCancellationRequested||r.entryCount===l?g():E(new R("Incomplete",new Error(v.localize(1,null,l,r.entryCount))))},E)),r.readEntry(),r.on("entry",k=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(k.fileName)){j(n);return}const U=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(U)){const ne=T.join(e,U);a=(0,S.createCancelablePromise)(ee=>D.promises.mkdir(ne,{recursive:!0}).then(()=>j(ee)).then(void 0,E));return}const W=b(r,k),H=y(k);a=(0,S.createCancelablePromise)(ne=>M.queue(()=>W.then(ee=>P(ee,U,H,e,i,ne).then(()=>j(ne)))).then(null,E))}})})}function d(r,e=!1){return new Promise((i,n)=>{(0,O.open)(r,e?{lazyEntries:!0}:void 0,(a,l)=>{a?n(w(a)):i((0,c.assertIsDefined)(l))})})}function b(r,e){return new Promise((i,n)=>{r.openReadStream(e,(a,l)=>{a?n(w(a)):i((0,c.assertIsDefined)(l))})})}function L(r,e){return new Promise((i,n)=>{const a=new u.ZipFile;e.forEach(g=>{g.contents?a.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&a.addFile(g.localPath,g.path)}),a.end();const l=(0,D.createWriteStream)(r);a.outputStream.pipe(l),a.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>i(r))})}t.zip=L;function C(r,e,i={},n){const a=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let l=d(r,!0);return i.overwrite&&(l=l.then(g=>(0,F.rimraf)(e).then(()=>g))),l.then(g=>f(g,e,{sourcePathRegex:a},n))}t.extract=C;function m(r,e){return d(r).then(i=>new Promise((n,a)=>{i.on("entry",l=>{l.fileName===e&&b(i,l).then(g=>n(g),g=>a(g))}),i.once("close",()=>a(new Error(v.localize(2,null,e))))}))}function s(r,e){return m(r,e).then(i=>new Promise((n,a)=>{const l=[];i.once("error",a),i.on("data",g=>l.push(g)),i.on("end",()=>n(Buffer.concat(l)))}))}t.buffer=s}),define(Q[121],Z([0,1,43,78]),function(x,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function D(S){return(0,v.buffer)(S,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(O){throw new Error((0,T.localize)(0,null))}})}t.getManifest=D}),define(Q[122],Z([0,1,18,39,2,14,3,15,24,25,4,7,22,90,79,41,43,13,23,8,19,17,30,12]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P,f,d,b,L,C,m,s,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",a="scanningUser",l="extracting",g="deleting",E="renaming";let M=class extends D.Disposable{constructor(k,U,W,H,ne){super();this.beforeRemovingExtension=k,this.fileService=U,this.logService=W,this.environmentService=H,this.productService=ne,this._devSystemExtensionsPath=null,this.systemExtensionsPath=H.builtinExtensionsPath,this.extensionsPath=H.extensionsPath,this.uninstalledPath=F.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(k){const U=[];(k===null||k===0)&&U.push(this.scanSystemExtensions().then(null,W=>Promise.reject(new u.ExtensionManagementError(this.joinErrors(W).message,n)))),(k===null||k===1)&&U.push(this.scanUserExtensions(!0).then(null,W=>Promise.reject(new u.ExtensionManagementError(this.joinErrors(W).message,a))));try{const W=await Promise.all(U);return(0,C.flatten)(W)}catch(W){throw this.joinErrors(W)}}async scanUserExtensions(k){this.logService.trace("Started scanning user extensions");let[U,W]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return W=W.filter(H=>!U[new c.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version).key()]),k&&(W=(0,c.groupByExtension)(W,ne=>ne.identifier).map(ne=>ne.sort((ee,ie)=>T.rcompare(ee.manifest.version,ie.manifest.version))[0])),this.logService.trace("Scanned user extensions:",W.length),W}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(k,U,W){const H=k.key(),ne=F.join(this.extensionsPath,`.${(0,e.generateUuid)()}`),ee=F.join(this.extensionsPath,H);try{await S.rimraf(ee)}catch(oe){try{await S.rimraf(ee)}catch(_){}throw new u.ExtensionManagementError((0,f.localize)(0,null,ee,k.id),g)}await this.extractAtLocation(k,U,ne,W);let ie=await this.scanExtension(y.URI.file(ne),1);if(!ie)throw new Error((0,f.localize)(1,null,ne));await this.storeMetadata(ie,{installedTimestamp:Date.now()});try{await this.rename(k,ne,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(oe){try{await S.rimraf(ne)}catch(_){}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(oe)}. Deleted from extracted location`,ne),oe}try{ie=await this.scanExtension(y.URI.file(ee),1)}catch(oe){}if(ie)return ie;throw new Error((0,f.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(k,U){return this.setMetadata(k,U),await this.storeMetadata(k,Object.assign(Object.assign({},U),{installedTimestamp:k.installedTimestamp})),k}async storeMetadata(k,U){U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.installedTimestamp=U.installedTimestamp||void 0;const W=F.join(k.location.fsPath,"package.json"),H=await v.promises.readFile(W,"utf8"),{manifest:ne}=await this.parseManifest(H);return ne.__metadata=U,await S.writeFile(W,JSON.stringify(ne,null,"	")),k}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...k){const U=k.map(W=>new c.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version));await this.withUninstalledExtensions(W=>{U.forEach(H=>W[H.key()]=!0)})}async setInstalled(k){await this.withUninstalledExtensions(H=>delete H[k.key()]);const W=(await this.scanExtensions(1)).find(H=>new c.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version).equals(k))||null;return W?(await this.storeMetadata(W,{installedTimestamp:Date.now()}),this.scanExtension(W.location,1)):null}async withUninstalledExtensions(k){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await v.promises.readFile(this.uninstalledPath,"utf8")}catch(H){if(H.code!=="ENOENT")throw H}let W={};if(U)try{W=JSON.parse(U)}catch(H){}return k&&(k(W),Object.keys(W).length?await S.writeFile(this.uninstalledPath,JSON.stringify(W)):await S.rimraf(this.uninstalledPath)),W})}async removeExtension(k,U){this.logService.trace(`Deleting ${U} extension from disk`,k.identifier.id,k.location.fsPath),await S.rimraf(k.location.fsPath),this.logService.info("Deleted from disk",k.identifier.id,k.location.fsPath)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[new c.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version).key()])}async extractAtLocation(k,U,W,H){this.logService.trace(`Started extracting the extension from ${U} to ${W}`);try{await S.rimraf(W)}catch(ne){throw new u.ExtensionManagementError(this.joinErrors(ne).message,g)}try{await(0,b.extract)(U,W,{sourcePath:"extension",overwrite:!0},H),this.logService.info(`Extracted extension to ${W}:`,k.id)}catch(ne){try{await S.rimraf(W)}catch(ee){}throw new u.ExtensionManagementError(ne.message,ne instanceof b.ExtractError&&ne.type?ne.type:l)}}async rename(k,U,W,H){try{await v.promises.rename(U,W)}catch(ne){if(L.isWindows&&ne&&ne.code==="EPERM"&&Date.now()<H)return this.logService.info(`Failed renaming ${U} to ${W} with 'EPERM' error. Trying again...`,k.id),this.rename(k,U,W,H);throw new u.ExtensionManagementError(ne.message||(0,f.localize)(3,null,U,W),ne.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const k=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return k;const U=this.scanDevSystemExtensions(),[W,H]=await Promise.all([k,U]);return[...W,...H]}async scanExtensionsInDir(k,U){const W=new R.Limiter(10),H=await this.fileService.resolve(y.URI.file(k));return H.children?(await Promise.all(H.children.filter(ee=>ee.isDirectory).map(ee=>W.queue(async()=>U===1&&(0,r.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,U))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(k,U){var W,H;try{const ne=await this.fileService.resolve(k);if(ne.children){const{manifest:ee,metadata:ie}=await this.readManifest(k.fsPath),oe=(W=ne.children.find(({name:h})=>/^readme(\.txt|\.md|)$/i.test(h)))===null||W===void 0?void 0:W.resource,_=(H=ne.children.find(({name:h})=>/^changelog(\.txt|\.md|)$/i.test(h)))===null||H===void 0?void 0:H.resource,q={id:(0,c.getGalleryExtensionId)(ee.publisher,ee.name)},J={type:U,identifier:q,manifest:ee,location:k,readmeUrl:oe,changelogUrl:_,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:U===0};return ie&&(this.setMetadata(J,ie),J.installedTimestamp=ie.installedTimestamp),J}}catch(ne){U!==0&&this.logService.trace(ne)}return null}async scanDefaultSystemExtensions(){const k=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",k.length),k}async scanDevSystemExtensions(){const k=this.getDevSystemExtensionsList();if(k.length){const U=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",U.length),U.filter(W=>k.some(H=>(0,c.areSameExtensions)(W.identifier,{id:H})))}else return[]}setMetadata(k,U){k.publisherDisplayName=U.publisherDisplayName||null,k.publisherId=U.publisherId||null,k.identifier.uuid=U.id,k.isMachineScoped=!!U.isMachineScoped,k.isBuiltin=k.type===0||!!U.isBuiltin}async removeUninstalledExtensions(){const k=await this.getUninstalledExtensions(),U=await this.scanAllUserExtensions(),W=new Set;for(const ee of U)k[new c.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||W.add(ee.identifier.id.toLowerCase());const H=(0,c.groupByExtension)(U,ee=>ee.identifier);await R.Promises.settled(H.map(async ee=>{const ie=ee.sort((oe,_)=>T.rcompare(oe.manifest.version,_.manifest.version))[0];W.has(ie.identifier.id.toLowerCase())||await this.beforeRemovingExtension(ie)}));const ne=U.filter(ee=>k[new c.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await R.Promises.settled(ne.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const k=await this.scanAllUserExtensions(),U=[],W=(0,c.groupByExtension)(k,H=>H.identifier);U.push(...(0,C.flatten)(W.map(H=>H.sort((ne,ee)=>T.rcompare(ne.manifest.version,ee.manifest.version)).slice(1)))),await R.Promises.settled(U.map(H=>this.removeExtension(H,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(k=>k.name)}joinErrors(k){const U=Array.isArray(k)?k:[k];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((W,H)=>new Error(`${W.message}${W.message?",":""}${H instanceof Error?H.message:H}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=F.normalize(F.join(m.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(k){const U=[v.promises.readFile(F.join(k,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),v.promises.readFile(F.join(k,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:W,metadata:H},ne]=await Promise.all(U);return{manifest:(0,P.localizeManifest)(W,ne),metadata:H}}parseManifest(k){return new Promise((U,W)=>{try{const H=JSON.parse(k),ne=H.__metadata||null;U({manifest:H,metadata:ne})}catch(H){W(new Error((0,f.localize)(4,null)))}})}};M=ue([fe(1,s.IFileService),fe(2,O.ILogService),fe(3,w.INativeEnvironmentService),fe(4,d.IProductService)],M),t.ExtensionsScanner=M}),define(Q[123],Z([0,1,18,77,3,14,2,23,43,24,25,22,4,9,39,7,40,13,15,98,29,42,49,17,30,96,10,8,28,121,102,122,103,104,19]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P,f,d,b,L,C,m,s,r,e,i,n,a,l,g,E,M,j,k,U,W,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const ne="unsetUninstalled",ee="downloading",ie="validating",oe="local",_="unknown";let q=class extends F.Disposable{constructor(h,o,I,p,A,N,B){super();this.environmentService=h,this.galleryService=o,this.logService=I,this.downloadService=p,this.telemetryService=A,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new P.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new P.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new P.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new P.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const V=this._register(N.createInstance(U.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(k.ExtensionsScanner,X=>V.postUninstall(X))),this.manifestCache=this._register(new m.ExtensionsManifestCache(h,this)),this.extensionsDownloader=this._register(N.createInstance(j.ExtensionsDownloader));const $=this._register(new W.ExtensionsWatcher(this,B,h,I));this._register($.onDidChangeExtensionsByAnotherSource(({added:X,removed:Y})=>{X.forEach(te=>this._onDidInstallExtension.fire({identifier:te.identifier,operation:0,local:te})),Y.forEach(te=>this._onDidUninstallExtension.fire({identifier:te}))})),this._register((0,F.toDisposable)(()=>{this.installingExtensions.forEach(X=>X.cancel()),this.uninstallingExtensions.forEach(X=>X.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(h){this.logService.trace("ExtensionManagementService#zip",h.identifier.id);const o=await this.collectFiles(h),I=await(0,u.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,o);return d.URI.file(I)}async unzip(h){return this.logService.trace("ExtensionManagementService#unzip",h.toString()),(await this.install(h)).identifier}async getManifest(h){const o=await this.downloadVsix(h),I=D.resolve(o.fsPath);return(0,M.getManifest)(I)}async collectFiles(h){const o=async p=>{let A=await S.readdir(p);A=A.map(V=>D.join(p,V));const N=await Promise.all(A.map(V=>v.promises.stat(V)));let B=Promise.resolve([]);return N.forEach((V,$)=>{const X=A[$];V.isFile()&&(B=B.then(Y=>[...Y,X])),V.isDirectory()&&(B=B.then(Y=>o(X).then(te=>[...Y,...te])))}),B};return(await o(h.location.fsPath)).map(p=>({path:`extension/${D.relative(h.location.fsPath,p)}`,localPath:p}))}async install(h,o={}){return this.logService.trace("ExtensionManagementService#install",h.toString()),(0,w.createCancelablePromise)(async I=>{const p=await this.downloadVsix(h),A=D.resolve(p.fsPath),N=await(0,M.getManifest)(A),B={id:(0,R.getGalleryExtensionId)(N.publisher,N.name)};let V=1;if(N.engines&&N.engines.vscode&&!(0,e.isEngineValid)(N.engines.vscode,b.default.version,b.default.date))throw new Error(T.localize(0,null,B.id,b.default.version));const $=new R.ExtensionIdentifierWithVersion(B,N.version),Y=(await this.getInstalled(1)).find(re=>(0,R.areSameExtensions)(B,re.identifier));if(Y)if(o.isMachineScoped=o.isMachineScoped||Y.isMachineScoped,o.isBuiltin=o.isBuiltin||Y.isBuiltin,V=2,$.equals(new R.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version)))try{await this.extensionsScanner.removeExtension(Y,"existing")}catch(re){throw new Error(T.localize(1,null,N.displayName||N.name))}else f.gt(Y.manifest.version,N.version)&&await this.uninstallExtension(Y);else{const re=await this.unsetUninstalledAndGetLocal($);if(re)try{await this.extensionsScanner.removeExtension(re,"existing")}catch(le){throw new Error(T.localize(2,null,N.displayName||N.name))}}this.logService.info("Installing the extension:",B.id),this._onInstallExtension.fire({identifier:B,zipPath:A});let te;try{te=await this.getGalleryMetadata((0,R.getGalleryExtensionId)(N.publisher,N.name))}catch(re){}try{const re=await this.installFromZipPath($,A,Object.assign(Object.assign({},te||{}),o),o,V,I);return this.logService.info("Successfully installed the extension:",B.id),re}catch(re){throw this.logService.error("Failed to install the extension:",B.id,re.message),re}})}async downloadVsix(h){if(h.scheme===g.Schemas.file)return h;if(!this.downloadService)throw new Error("Download service is not available");const o=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(h,o),o}async installFromZipPath(h,o,I,p,A,N){try{const B=await this.installExtension({zipPath:o,identifierWithVersion:h,metadata:I},N);try{await this.installDependenciesAndPackExtensions(B,void 0,p)}catch(V){(0,O.isNonEmptyArray)(B.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",B.identifier.id,V.message),(0,O.isNonEmptyArray)(B.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",B.identifier.id,V.message)}return this._onDidInstallExtension.fire({identifier:h,zipPath:o,local:B,operation:A}),B}catch(B){throw this._onDidInstallExtension.fire({identifier:h,zipPath:o,operation:A,error:B}),B}}async canInstall(h){return!0}async installFromGallery(h,o={}){if(!this.galleryService.isEnabled())throw new Error(T.localize(3,null));try{h=await this.checkAndGetCompatibleVersion(h)}catch(A){const N=A&&A.code?A.code:_;throw this.logService.error("Failed to install extension:",h.identifier.id,A?A.message:N),this.reportTelemetry(this.getTelemetryEvent(1),(0,R.getGalleryExtensionTelemetryData)(h),void 0,A),A instanceof Error&&(A.name=N),A}const I=new R.ExtensionIdentifierWithVersion(h.identifier,h.version).key();let p=this.installingExtensions.get(I);return p||(p=(0,w.createCancelablePromise)(A=>this.doInstallFromGallery(h,o,A)),this.installingExtensions.set(I,p),p.finally(()=>this.installingExtensions.delete(I))),p}async doInstallFromGallery(h,o,I){const p=new Date().getTime();let A=1;this.logService.info("Installing extension:",h.identifier.id),this._onInstallExtension.fire({identifier:h.identifier,gallery:h});try{const B=(await this.getInstalled(1)).find(X=>(0,R.areSameExtensions)(X.identifier,h.identifier));B&&(A=2);const V=await this.downloadInstallableExtension(h,A);V.metadata.isMachineScoped=o.isMachineScoped||(B==null?void 0:B.isMachineScoped),V.metadata.isBuiltin=o.isBuiltin||(B==null?void 0:B.isBuiltin);const $=await this.installExtension(V,I);try{await this.extensionsDownloader.delete(d.URI.file(V.zipPath))}catch(X){}if(!o.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions($,B,o)}catch(X){try{await this.uninstall($)}catch(Y){}throw X}return B&&f.neq(B.manifest.version,h.version)&&await this.extensionsScanner.setUninstalled(B),this.logService.info("Extensions installed successfully:",h.identifier.id),this._onDidInstallExtension.fire({identifier:h.identifier,gallery:h,local:$,operation:A}),this.reportTelemetry(this.getTelemetryEvent(A),(0,R.getGalleryExtensionTelemetryData)(h),new Date().getTime()-p,void 0),$}catch(N){const B=N&&N.code?N.code:_;throw this.logService.error("Failed to install extension:",h.identifier.id,N?N.message:B),this._onDidInstallExtension.fire({identifier:h.identifier,gallery:h,operation:A,error:B}),this.reportTelemetry(this.getTelemetryEvent(A),(0,R.getGalleryExtensionTelemetryData)(h),new Date().getTime()-p,N),N instanceof Error&&(N.name=B),N}}async checkAndGetCompatibleVersion(h){if(await this.isMalicious(h))throw new c.ExtensionManagementError(T.localize(4,null),c.INSTALL_ERROR_MALICIOUS);const o=await this.galleryService.getCompatibleExtension(h);if(!o)throw new c.ExtensionManagementError(T.localize(5,null,h.identifier.id,b.default.version),c.INSTALL_ERROR_INCOMPATIBLE);return o}async reinstallFromGallery(h){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",h.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(6,null));const o=await this.findGalleryExtension(h);if(!o)throw new Error(T.localize(7,null));await this.extensionsScanner.setUninstalled(h);try{await this.extensionsScanner.removeUninstalledExtension(h)}catch(I){throw new Error(T.localize(8,null,(0,s.toErrorMessage)(I)))}await this.installFromGallery(o)}getTelemetryEvent(h){return h===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(h){const o=await this.getExtensionsReport();return(0,R.getMaliciousExtensionsSet)(o).has(h.identifier.id)}async downloadInstallableExtension(h,o){const I={id:h.identifier.uuid,publisherId:h.publisherId,publisherDisplayName:h.publisherDisplayName};let p;try{this.logService.trace("Started downloading extension:",h.identifier.id),p=(await this.extensionsDownloader.downloadExtension(h,o)).fsPath,this.logService.info("Downloaded extension:",h.identifier.id,p)}catch(A){throw new c.ExtensionManagementError(this.joinErrors(A).message,ee)}try{const A=await(0,M.getManifest)(p);return{zipPath:p,identifierWithVersion:new R.ExtensionIdentifierWithVersion(h.identifier,A.version),metadata:I}}catch(A){throw new c.ExtensionManagementError(this.joinErrors(A).message,ie)}}async installExtension(h,o){try{const I=await this.unsetUninstalledAndGetLocal(h.identifierWithVersion);if(I)return h.metadata?this.extensionsScanner.saveMetadataForLocalExtension(I,h.metadata):I}catch(I){throw L.isMacintosh?new c.ExtensionManagementError(T.localize(9,null),ne):new c.ExtensionManagementError(T.localize(10,null),ne)}return this.extractAndInstall(h,o)}async unsetUninstalledAndGetLocal(h){if(!await this.isUninstalled(h))return null;this.logService.trace("Removing the extension from uninstalled list:",h.id);const I=await this.extensionsScanner.setInstalled(h);return this.logService.info("Removed the extension from uninstalled list:",h.id),I}async extractAndInstall({zipPath:h,identifierWithVersion:o,metadata:I},p){let A=await this.extensionsScanner.extractUserExtension(o,h,p);return this.logService.info("Installation completed.",o.id),I&&(A=await this.extensionsScanner.saveMetadataForLocalExtension(A,I)),A}async installDependenciesAndPackExtensions(h,o,I){if(!!this.galleryService.isEnabled()){const p=h.manifest.extensionDependencies||[];if(h.manifest.extensionPack)for(const A of h.manifest.extensionPack)o&&o.manifest.extensionPack&&o.manifest.extensionPack.some(N=>(0,R.areSameExtensions)({id:N},{id:A}))||p.every(N=>!(0,R.areSameExtensions)({id:N},{id:A}))&&p.push(A);if(p.length){const A=await this.getInstalled(),N=p.filter(B=>A.every(({identifier:V})=>!(0,R.areSameExtensions)(V,{id:B})));if(N.length){const V=(await this.galleryService.query({names:N,pageSize:p.length},E.CancellationToken.None)).firstPage;try{await w.Promises.settled(V.map($=>this.installFromGallery($,I)))}catch($){try{await this.rollback(V)}catch(X){}throw $}}}}}async rollback(h){const I=(await this.getInstalled(1)).filter(p=>h.some(A=>new R.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).equals(new R.ExtensionIdentifierWithVersion(A.identifier,A.version))));await w.Promises.settled(I.map(p=>this.uninstall(p)))}async uninstall(h,o={}){this.logService.trace("ExtensionManagementService#uninstall",h.identifier.id);const I=await this.getInstalled(1),p=I.find(A=>(0,R.areSameExtensions)(A.identifier,h.identifier));if(!p)throw new Error(T.localize(11,null,h.manifest.displayName||h.manifest.name));try{await this.checkForDependenciesAndUninstall(p,I,o)}catch(A){throw this.joinErrors(A)}}async updateMetadata(h,o){return this.logService.trace("ExtensionManagementService#updateMetadata",h.identifier.id),h=await this.extensionsScanner.saveMetadataForLocalExtension(h,Object.assign(Object.assign({},h.manifest.__metadata||{}),o)),this.manifestCache.invalidate(),h}async updateExtensionScope(h,o){return this.logService.trace("ExtensionManagementService#updateExtensionScope",h.identifier.id),h=await this.extensionsScanner.saveMetadataForLocalExtension(h,Object.assign(Object.assign({},h.manifest.__metadata||{}),{isMachineScoped:o})),this.manifestCache.invalidate(),h}async getGalleryMetadata(h){const o=await this.findGalleryExtensionByName(h);return o?{id:o.identifier.uuid,publisherDisplayName:o.publisherDisplayName,publisherId:o.publisherId}:void 0}async findGalleryExtension(h){if(h.identifier.uuid){const o=await this.findGalleryExtensionById(h.identifier.uuid);return o||this.findGalleryExtensionByName(h.identifier.id)}return this.findGalleryExtensionByName(h.identifier.id)}async findGalleryExtensionById(h){return(await this.galleryService.query({ids:[h],pageSize:1},E.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(h){return(await this.galleryService.query({names:[h],pageSize:1},E.CancellationToken.None)).firstPage[0]}joinErrors(h){const o=Array.isArray(h)?h:[h];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((I,p)=>new Error(`${I.message}${I.message?",":""}${p instanceof Error?p.message:p}`),new Error(""))}async checkForDependenciesAndUninstall(h,o,I){try{await this.preUninstallExtension(h);const p=I.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(h,o);await this.uninstallExtensions(h,p,o,I)}catch(p){throw await this.postUninstallExtension(h,new c.ExtensionManagementError(p instanceof Error?p.message:p,oe)),p}await this.postUninstallExtension(h)}async uninstallExtensions(h,o,I,p){const A=[h,...o];if(!p.donotCheckDependents)for(const N of A)this.checkForDependents(N,A,I,h);await w.Promises.settled([this.uninstallExtension(h),...o.map(N=>this.doUninstall(N))])}checkForDependents(h,o,I,p){const A=this.getDependents(h,I);if(A.length){const N=A.filter(B=>o.indexOf(B)===-1);if(N.length)throw new Error(this.getDependentsErrorMessage(h,N,p))}}getDependentsErrorMessage(h,o,I){return I===h?o.length===1?T.localize(12,null,I.manifest.displayName||I.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(13,null,I.manifest.displayName||I.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(14,null,I.manifest.displayName||I.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?T.localize(15,null,I.manifest.displayName||I.manifest.name,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(16,null,I.manifest.displayName||I.manifest.name,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(17,null,I.manifest.displayName||I.manifest.name,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(h,o,I=[]){if(I.indexOf(h)!==-1)return[];I.push(h);const p=h.manifest.extensionPack?h.manifest.extensionPack:[];if(p.length){const A=o.filter(B=>!B.isBuiltin&&p.some(V=>(0,R.areSameExtensions)({id:V},B.identifier))),N=[];for(const B of A)N.push(...this.getAllPackExtensionsToUninstall(B,o,I));return[...A,...N]}return[]}getDependents(h,o){return o.filter(I=>I.manifest.extensionDependencies&&I.manifest.extensionDependencies.some(p=>(0,R.areSameExtensions)({id:p},h.identifier)))}async doUninstall(h){try{await this.preUninstallExtension(h),await this.uninstallExtension(h)}catch(o){throw await this.postUninstallExtension(h,new c.ExtensionManagementError(o instanceof Error?o.message:o,oe)),o}await this.postUninstallExtension(h)}async preUninstallExtension(h){if(!await S.exists(h.location.fsPath))throw new Error(T.localize(18,null));this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier)}async uninstallExtension(h){let o=this.uninstallingExtensions.get(h.identifier.id);return o||(o=(0,w.createCancelablePromise)(async()=>{const I=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...I.filter(p=>(0,R.areSameExtensions)(p.identifier,h.identifier)))}),this.uninstallingExtensions.set(h.identifier.id,o),o.finally(()=>this.uninstallingExtensions.delete(h.identifier.id))),o}async postUninstallExtension(h,o){if(o)this.logService.error("Failed to uninstall extension:",h.identifier.id,o.message);else if(this.logService.info("Successfully uninstalled extension:",h.identifier.id),h.identifier.uuid)try{await this.galleryService.reportStatistic(h.manifest.publisher,h.manifest.name,h.manifest.version,"uninstall")}catch(p){}this.reportTelemetry("extensionGallery:uninstall",(0,R.getLocalExtensionTelemetryData)(h),void 0,o);const I=o?o instanceof c.ExtensionManagementError?o.code:_:void 0;this._onDidUninstallExtension.fire({identifier:h.identifier,error:I})}getInstalled(h=null){return this.extensionsScanner.scanExtensions(h)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(h){return(await this.filterUninstalled(h)).length===1}async filterUninstalled(...h){const o=[],I=await this.extensionsScanner.getUninstalledExtensions();for(const p of h)I[p.key()]&&o.push(p.key());return o}getExtensionsReport(){const h=new Date().getTime();return(!this.reportedExtensions||h-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=h),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const h=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${h.length} reported extensions from service`),h}catch(h){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(h,o,I,p){const A=p?p instanceof c.ExtensionManagementError?p.code:_:void 0;this.telemetryService.publicLogError(h,Object.assign(Object.assign({},o),{success:!p,duration:I,errorcode:A}))}};q=ue([fe(0,y.INativeEnvironmentService),fe(1,c.IExtensionGalleryService),fe(2,C.ILogService),fe(3,(0,l.optional)(a.IDownloadService)),fe(4,r.ITelemetryService),fe(5,l.IInstantiationService),fe(6,H.IFileService)],q),t.ExtensionManagementService=q}),define(Q[124],Z([0,1,133,113,2,11,12,112,27,15,16,22,99]),function(x,t,v,T,D,S,F,O,u,c,R,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let P=class extends D.Disposable{constructor(d,b,L){super();this.environmentService=b,this.logService=L,this.configure(d.getValue()),this._register(d.onDidChangeConfiguration(()=>this.configure(d.getValue()),this))}configure(d){this.proxyUrl=d.http&&d.http.proxy,this.strictSSL=!!(d.http&&d.http.proxyStrictSSL),this.authorization=d.http&&d.http.proxyAuthorization}async request(d,b){this.logService.trace("RequestService#request",d.url);const{proxyUrl:L,strictSSL:C}=this,m=Object.assign(Object.assign({},process.env),await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),s=d.agent?d.agent:await(0,O.getProxyAgent)(d.url||"",m,{proxyUrl:L,strictSSL:C});return d.agent=s,d.strictSSL=C,this.authorization&&(d.headers=Object.assign(Object.assign({},d.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(d,b)}async getNodeRequest(d){return((0,T.parse)(d.url).protocol==="https:"?await new Promise((C,m)=>{x(["https"],C,m)}):await new Promise((C,m)=>{x(["http"],C,m)})).request}_request(d,b){return new Promise(async(L,C)=>{let m;const s=(0,T.parse)(d.url),r=d.getRawRequest?d.getRawRequest(d):await this.getNodeRequest(d),e={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,S.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(e.auth=d.user+":"+d.password),m=r(e,i=>{const n=(0,S.isNumber)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},d),{url:i.headers.location,followRedirects:n-1}),b).then(L,C);else{let a=i;i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,v.createGunzip)())),L({res:i,stream:(0,R.streamToBufferReadableStream)(a)})}}),m.on("error",C),d.timeout&&m.setTimeout(d.timeout),d.data&&typeof d.data=="string"&&m.write(d.data),m.end(),b.onCancellationRequested(()=>{m.abort(),C((0,F.canceled)())})})}async resolveProxy(d){}};P=ue([fe(0,u.IConfigurationService),fe(1,y.INativeEnvironmentService),fe(2,c.ILogService)],P),t.RequestService=P}),define(Q[134],Z([0,1,32,18,135,3,4,40,52,50,101,22,89,24,123,117,42,56,118,116,55,124,27,111,119,15,8,106,120,107,19,108,2,41,97,7,105,53,12,29,16,34]),function(x,t,v,T,D,S,F,O,u,c,R,y,w,P,f,d,b,L,C,m,s,r,e,i,n,a,l,g,E,M,j,k,U,W,H,ne,ee,ie,oe,_,q,J){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class h extends U.Disposable{constructor(p){super();this.argv=p,(0,D.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[p,A]=await this.initServices();return p.invokeFunction(async N=>{const B=N.get(a.ILogService),V=N.get(j.IFileService),$=N.get(y.INativeEnvironmentService),X=N.get(P.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun($,X,V),(0,F.raceTimeout)((0,L.combinedAppender)(...A).flush(),1e3)})}async initServices(){const p=new u.ServiceCollection,A=Object.assign({_serviceBrand:void 0},O.default);p.set(W.IProductService,A);const N=new w.NativeEnvironmentService(this.argv,A);p.set(y.INativeEnvironmentService,N),await Promise.all([N.appSettingsHome.fsPath,N.extensionsPath].map(le=>le?T.promises.mkdir(le,{recursive:!0}):void 0));const B=(0,a.getLogLevel)(N),V=[];V.push(new g.SpdLogLogger("cli",(0,S.join)(N.logsPath,"cli.log"),!0,B)),B===a.LogLevel.Trace&&V.push(new a.ConsoleLogger(B));const $=this._register(new a.MultiplexLogService(V));p.set(a.ILogService,$);const X=this._register(new M.FileService($));p.set(j.IFileService,X);const Y=this._register(new k.DiskFileSystemProvider($));X.registerProvider(l.Schemas.file,Y);const te=this._register(new i.ConfigurationService(N.settingsResource,X));p.set(e.IConfigurationService,te),await te.initialize(),p.set(s.IRequestService,new c.SyncDescriptor(r.RequestService)),p.set(P.IExtensionManagementService,new c.SyncDescriptor(f.ExtensionManagementService)),p.set(P.IExtensionGalleryService,new c.SyncDescriptor(d.ExtensionGalleryService)),p.set(P.IExtensionManagementCLIService,new c.SyncDescriptor(H.ExtensionManagementCLIService)),p.set(ie.ILocalizationsService,new c.SyncDescriptor(ee.LocalizationsService));const re=[];if(N.isBuilt&&!N.isExtensionDevelopment&&!N.disableTelemetry&&A.enableTelemetry){A.aiConfig&&A.aiConfig.asimovKey&&re.push(new n.AppInsightsAppender("monacoworkbench",null,A.aiConfig.asimovKey));const{appRoot:le,extensionsPath:ge,installSourcePath:Ie}=N,Fe={appender:(0,L.combinedAppender)(...re),sendErrorTelemetry:!1,commonProperties:(async()=>{let Le;try{const Ee=await T.promises.readFile((0,S.join)(N.userDataPath,"storage.json"));Le=JSON.parse(Ee.toString())[b.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&$.error(Ee)}return(0,m.resolveCommonProperties)(X,(0,v.release)(),(0,v.hostname)(),process.arch,A.commit,A.version,Le,A.msftInternalDomains,Ie)})(),piiPaths:[le,ge]};p.set(b.ITelemetryService,new c.SyncDescriptor(C.TelemetryService,[Fe]))}else p.set(b.ITelemetryService,L.NullTelemetryService);return[new R.InstantiationService(p),re]}registerErrorHandler(p){(0,oe.setUnexpectedErrorHandler)(A=>{const N=(0,_.toErrorMessage)(A,!0);!N||p.error(`[uncaught exception in CLI]: ${N}`)})}async doRun(p,A,N){if(this.argv["install-source"])return this.setInstallSource(p,N,this.argv["install-source"]);if(this.argv["list-extensions"])return A.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return A.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return A.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return A.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,E.buildTelemetryMessage)(p.appRoot,p.extensionsPath))}asExtensionIdOrVSIX(p){return p.map(A=>/\.vsix$/i.test(A)?ne.URI.file((0,S.isAbsolute)(A)?A:(0,S.join)((0,J.cwd)(),A)):A)}async setInstallSource(p,A,N){await A.writeFile(ne.URI.file(p.installSourcePath),q.VSBuffer.fromString(N.slice(0,30)))}}async function o(I){const p=new h(I);try{await p.run()}finally{p.dispose()}}t.main=o})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/40d5e6796fbc32d67dd0009e5b0027003803fd7e/core/vs/code/node/cliProcessMain.js.map
