/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/platform","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/base/common/codicons","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(Q){for(var e=[],b=0,R=Q.length;b<R;b++)e[b]=me[Q[b]];return e};define(me[52],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(R,I){if(!R)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=b}),define(me[53],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function R(P){const f=[];for(let m in P)b.call(P,m)&&f.push(P[m]);return f}e.values=R;function I(P,f){for(let m in P)if(b.call(P,m)&&f({key:m,value:P[m]},function(){delete P[m]})===!1)return}e.forEach=I;function A(P,f){const m=Object.create(null);for(const o of P){const d=f(o);let E=m[d];E||(E=m[d]=[]),E.push(o)}return m}e.groupBy=A;function y(P,f){const m=new Map;for(const o of P){const d=f(o);let E=m.get(d);E||(E=[],m.set(d,E)),E.push(o)}return m}e.groupByNumber=y;function C(P){const f=Object.create(null);return P&&P.forEach((m,o)=>{f[o]=m}),f}e.fromMap=C;function D(P,f){const m=[],o=[];for(let d of P)f.has(d)||m.push(d);for(let d of f)P.has(d)||o.push(d);return{removed:m,added:o}}e.diffSets=D;function k(P,f){const m=[],o=[];for(let[d,E]of P)f.has(d)||m.push(E);for(let[d,E]of f)P.has(d)||o.push(E);return{removed:m,added:o}}e.diffMaps=k;class r{constructor(){this.map=new Map}add(f,m){let o=this.map.get(f);o||(o=new Set,this.map.set(f,o)),o.add(m)}delete(f,m){const o=this.map.get(f);!o||(o.delete(m),o.size===0&&this.map.delete(f))}forEach(f,m){const o=this.map.get(f);!o||o.forEach(m)}}e.SetMap=r}),define(me[54],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(y){return(C,D,k)=>{let r=null,P=null;if(typeof k.value=="function"?(r="value",P=k.value):typeof k.get=="function"&&(r="get",P=k.get),!P)throw new Error("not supported");k[r]=y(P,D)}}e.createDecorator=b;function R(y,C,D){let k=null,r=null;if(typeof D.value=="function"?(k="value",r=D.value,r.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(k="get",r=D.get),!r)throw new Error("not supported");const P=`$memoize$${C}`;D[k]=function(...f){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:r.apply(this,f)}),this[P]}}e.memoize=R;function I(y,C,D){return b((k,r)=>{const P=`$debounce$${r}`,f=`$debounce$result$${r}`;return function(...m){this[f]||(this[f]=D?D():void 0),clearTimeout(this[P]),C&&(this[f]=C(this[f],...m),m=[this[f]]),this[P]=setTimeout(()=>{k.apply(this,m),this[f]=D?D():void 0},y)}})}e.debounce=I;function A(y,C,D){return b((k,r)=>{const P=`$throttle$timer$${r}`,f=`$throttle$result$${r}`,m=`$throttle$lastRun$${r}`,o=`$throttle$pending$${r}`;return function(...d){if(this[f]||(this[f]=D?D():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),C&&(this[f]=C(this[f],...d)),!this[o]){const E=this[m]+y;E<=Date.now()?(this[m]=Date.now(),k.apply(this,[this[f]]),this[f]=D?D():void 0):(this[o]=!0,this[P]=setTimeout(()=>{this[o]=!1,this[m]=Date.now(),k.apply(this,[this[f]]),this[f]=D?D():void 0},E-Date.now()))}}})}e.throttle=A}),define(me[17],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function R(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=R;function I(h){D(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=I;function A(h){D(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=A;function y(h){if(h instanceof Error){let{name:t,message:n}=h;const s=h.stacktrace||h.stack;return{$isError:!0,name:t,message:n,stack:s}}return h}e.transformErrorForSerialization=y;const C="Canceled";function D(h){return h instanceof Error&&h.name===C&&h.message===C}e.isPromiseCanceledError=D;class k extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=k;function r(){const h=new Error(C);return h.name=h.message,h}e.canceled=r;function P(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=P;function f(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=f;function m(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function o(h){const t=new Error(`${h} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function d(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=d;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function u(h){const t=h;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function c(h,t=Object.create(null)){const n=new Error(h);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=c}),define(me[16],ge([0,1,17]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(x,L=0){return x[x.length-(1+L)]}e.tail=R;function I(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=I;function A(x,L,O=(F,M)=>F===M){if(x===L)return!0;if(!x||!L||x.length!==L.length)return!1;for(let F=0,M=x.length;F<M;F++)if(!O(x[F],L[F]))return!1;return!0}e.equals=A;function y(x,L,O){let F=0,M=x.length-1;for(;F<=M;){const W=(F+M)/2|0,q=O(x[W],L);if(q<0)F=W+1;else if(q>0)M=W-1;else return W}return-(F+1)}e.binarySearch=y;function C(x,L){let O=0,F=x.length;if(F===0)return 0;for(;O<F;){const M=Math.floor((O+F)/2);L(x[M])?F=M:O=M+1}return O}e.findFirstInSorted=C;function D(x,L,O){if(x=x|0,x>=L.length)throw new TypeError("invalid index");let F=L[Math.floor(L.length*Math.random())],M=[],W=[],q=[];for(let K of L){const le=O(K,F);le<0?M.push(K):le>0?W.push(K):q.push(K)}return x<M.length?D(x,M,O):x<M.length+q.length?q[0]:D(x-(M.length+q.length),W,O)}e.quickSelect=D;function k(x,L){const O=[];let F;for(const M of x.slice(0).sort(L))!F||L(F[0],M)!==0?(F=[M],O.push(F)):F.push(M);return O}e.groupBy=k;function r(x,L,O){const F=[];function M(K,le,ve){if(!(le===0&&ve.length===0)){const Re=F[F.length-1];Re&&Re.start+Re.deleteCount===K?(Re.deleteCount+=le,Re.toInsert.push(...ve)):F.push({start:K,deleteCount:le,toInsert:ve})}}let W=0,q=0;for(;;){if(W===x.length){M(W,0,L.slice(q));break}if(q===L.length){M(W,x.length-W,[]);break}const K=x[W],le=L[q],ve=O(K,le);ve===0?(W+=1,q+=1):ve<0?(M(W,1,[]),W+=1):ve>0&&(M(W,0,[le]),q+=1)}return F}e.sortedDiff=r;function P(x,L,O){const F=r(x,L,O),M=[],W=[];for(const q of F)M.push(...x.slice(q.start,q.start+q.deleteCount)),W.push(...q.toInsert);return{removed:M,added:W}}e.delta=P;function f(x,L,O){if(O===0)return[];const F=x.slice(0,O).sort(L);return o(x,L,F,O,x.length),F}e.top=f;function m(x,L,O,F,M){return O===0?Promise.resolve([]):new Promise((W,q)=>{(async()=>{const K=x.length,le=x.slice(0,O).sort(L);for(let ve=O,Re=Math.min(O+F,K);ve<K;ve=Re,Re=Math.min(Re+F,K)){if(ve>O&&await new Promise(Se=>setTimeout(Se)),M&&M.isCancellationRequested)throw(0,b.canceled)();o(x,L,le,ve,Re)}return le})().then(W,q)})}e.topAsync=m;function o(x,L,O,F,M){for(const W=O.length;F<M;F++){const q=x[F];if(L(q,O[W-1])<0){O.pop();const K=C(O,le=>L(q,le)<0);O.splice(K,0,q)}}}function d(x){return x.filter(L=>!!L)}e.coalesce=d;function E(x){let L=0;for(let O=0;O<x.length;O++)x[O]&&(x[L]=x[O],L+=1);x.length=L}e.coalesceInPlace=E;function v(x,L,O){x.splice(O,0,x.splice(L,1)[0])}e.move=v;function S(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=S;function u(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=u;function c(x,L){if(!L)return x.filter((F,M)=>x.indexOf(F)===M);const O=Object.create(null);return x.filter(F=>{const M=L(F);return O[M]?!1:(O[M]=!0,!0)})}e.distinct=c;function h(x){const L=new Set;return x.filter(O=>L.has(O)?!1:(L.add(O),!0))}e.distinctES6=h;function t(x){const L=Object.create(null);return O=>{const F=x(O);return L[F]?!1:(L[F]=!0,!0)}}e.uniqueFilter=t;function n(x,L){for(let O=x.length-1;O>=0;O--){const F=x[O];if(L(F))return O}return-1}e.lastIndex=n;function s(x,L){return x.length>0?x[0]:L}e.firstOrDefault=s;function i(x,L,O=(F,M)=>F===M){let F=0;for(let M=0,W=Math.min(x.length,L.length);M<W&&O(x[M],L[M]);M++)F++;return F}e.commonPrefixLength=i;function a(x){return[].concat(...x)}e.flatten=a;function p(x,L){let O=typeof L=="number"?x:0;typeof L=="number"?O=x:(O=0,L=x);const F=[];if(O<=L)for(let M=O;M<L;M++)F.push(M);else for(let M=O;M>L;M--)F.push(M);return F}e.range=p;function g(x,L,O){return x.reduce((F,M)=>(F[L(M)]=O?O(M):M,F),Object.create(null))}e.index=g;function _(x,L){return x.push(L),()=>l(x,L)}e.insert=_;function l(x,L){const O=x.indexOf(L);if(O>-1)return x.splice(O,1),L}e.remove=l;function w(x,L,O){const F=x.slice(0,L),M=x.slice(L);return F.concat(O,M)}e.arrayInsert=w;function T(x,L){let O;if(typeof L=="number"){let F=L;O=()=>{const M=Math.sin(F++)*179426549;return M-Math.floor(M)}}else O=Math.random;for(let F=x.length-1;F>0;F-=1){const M=Math.floor(O()*(F+1)),W=x[F];x[F]=x[M],x[M]=W}}e.shuffle=T;function N(x,L){const O=x.indexOf(L);O>-1&&(x.splice(O,1),x.unshift(L))}e.pushToStart=N;function z(x,L){const O=x.indexOf(L);O>-1&&(x.splice(O,1),x.push(L))}e.pushToEnd=z;function ne(x,L){return Array.isArray(x)?x.map(L):L(x)}e.mapArrayOrNot=ne;function ie(x){return Array.isArray(x)?x:[x]}e.asArray=ie;function U(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=U;function B(x,L){for(const O of x){const F=L(O);if(F!==void 0)return F}}e.mapFind=B}),define(me[72],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(R){const I=this;let A=!1,y;return function(){return A||(A=!0,y=R.apply(I,arguments)),y}}e.once=b}),define(me[73],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(me[55],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(R){function I(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}R.is=I;const A=Object.freeze([]);function y(){return A}R.empty=y;function*C(h){yield h}R.single=C;function D(h){return h||A}R.from=D;function k(h){return!h||h[Symbol.iterator]().next().done===!0}R.isEmpty=k;function r(h){return h[Symbol.iterator]().next().value}R.first=r;function P(h,t){for(const n of h)if(t(n))return!0;return!1}R.some=P;function f(h,t){for(const n of h)if(t(n))return n}R.find=f;function*m(h,t){for(const n of h)t(n)&&(yield n)}R.filter=m;function*o(h,t){for(const n of h)yield t(n)}R.map=o;function*d(...h){for(const t of h)for(const n of t)yield n}R.concat=d;function*E(h){for(const t of h)for(const n of t)yield n}R.concatNested=E;function v(h,t,n){let s=n;for(const i of h)s=t(s,i);return s}R.reduce=v;function*S(h,t,n=h.length){for(t<0&&(t+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);t<n;t++)yield h[t]}R.slice=S;function u(h,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,h];const s=h[Symbol.iterator]();for(let i=0;i<t;i++){const a=s.next();if(a.done)return[n,R.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}R.consume=u;function c(h,t,n=(s,i)=>s===i){const s=h[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const a=s.next(),p=i.next();if(a.done!==p.done)return!1;if(a.done)return!0;if(!n(a.value,p.value))return!1}}R.equals=c})(b=e.Iterable||(e.Iterable={}))}),define(me[56],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,i=t.length,a="",p=0,g=16,_=0;function l(U){let B=0,x=0;for(;B<U;){const L=t.charCodeAt(s);if(L>=48&&L<=57)x=x*16+L-48;else if(L>=65&&L<=70)x=x*16+L-65+10;else if(L>=97&&L<=102)x=x*16+L-97+10;else break;s++,B++}return B<U&&(x=-1),x}function w(U){s=U,a="",p=0,g=16,_=0}function T(){const U=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return _=3,t.substring(U,s);let B=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;B=s}else _=3;return t.substring(U,B)}function N(){let U="",B=s;for(;;){if(s>=i){U+=t.substring(B,s),_=2;break}const x=t.charCodeAt(s);if(x===34){U+=t.substring(B,s),s++;break}if(x===92){if(U+=t.substring(B,s),s++,s>=i){_=2;break}switch(t.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:const O=l(4);O>=0?U+=String.fromCharCode(O):_=4;break;default:_=5}B=s;continue}if(x>=0&&x<=31)if(D(x)){U+=t.substring(B,s),_=2;break}else _=6;s++}return U}function z(){if(a="",_=0,p=s,s>=i)return p=i,g=17;let U=t.charCodeAt(s);if(C(U)){do s++,a+=String.fromCharCode(U),U=t.charCodeAt(s);while(C(U));return g=15}if(D(U))return s++,a+=String.fromCharCode(U),U===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),g=14;switch(U){case 123:return s++,g=1;case 125:return s++,g=2;case 91:return s++,g=3;case 93:return s++,g=4;case 58:return s++,g=6;case 44:return s++,g=5;case 34:return s++,a=N(),g=10;case 47:const B=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!D(t.charCodeAt(s));)s++;return a=t.substring(B,s),g=12}if(t.charCodeAt(s+1)===42){s+=2;const x=i-1;let L=!1;for(;s<x;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,L=!0;break}s++}return L||(s++,_=1),a=t.substring(B,s),g=13}return a+=String.fromCharCode(U),s++,g=16;case 45:if(a+=String.fromCharCode(U),s++,s===i||!k(t.charCodeAt(s)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=T(),g=11;default:for(;s<i&&ne(U);)s++,U=t.charCodeAt(s);if(p!==s){switch(a=t.substring(p,s),a){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return a+=String.fromCharCode(U),s++,g=16}}function ne(U){if(C(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let U;do U=z();while(U>=12&&U<=15);return U}return{setPosition:w,getPosition:()=>s,scan:n?ie:z,getToken:()=>g,getTokenValue:()=>a,getTokenOffset:()=>p,getTokenLength:()=>s-p,getTokenError:()=>_}}e.createScanner=y;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function P(t,n){const s=[],i=new Object;let a;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function _(l,w,T,N){p.value=l,p.offset=w,p.length=T,p.type=N,p.colonOffset=void 0,a=p}try{u(t,{onObjectBegin:(l,w)=>{if(n<=l)throw i;a=void 0,g=n>l,s.push("")},onObjectProperty:(l,w,T)=>{if(n<w||(_(l,w,T,"property"),s[s.length-1]=l,n<=w+T))throw i},onObjectEnd:(l,w)=>{if(n<=l)throw i;a=void 0,s.pop()},onArrayBegin:(l,w)=>{if(n<=l)throw i;a=void 0,s.push(0)},onArrayEnd:(l,w)=>{if(n<=l)throw i;a=void 0,s.pop()},onLiteralValue:(l,w,T)=>{if(n<w||(_(l,w,T,h(l)),n<=w+T))throw i},onSeparator:(l,w,T)=>{if(n<=w)throw i;if(l===":"&&a&&a.type==="property")a.colonOffset=w,g=!1,a=void 0;else if(l===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(g=!0,s[s.length-1]=""),a=void 0}}})}catch(l){if(l!==i)throw l}return{path:s,previousNode:a,isAtPropertyKey:g,matches:l=>{let w=0;for(let T=0;w<l.length&&T<s.length;T++)if(l[w]===s[T]||l[w]==="*")w++;else if(l[w]!=="**")return!1;return w===l.length}}}e.getLocation=P;function f(t,n=[],s=A.DEFAULT){let i=null,a=[];const p=[];function g(l){Array.isArray(a)?a.push(l):i!==null&&(a[i]=l)}return u(t,{onObjectBegin:()=>{const l={};g(l),p.push(a),a=l,i=null},onObjectProperty:l=>{i=l},onObjectEnd:()=>{a=p.pop()},onArrayBegin:()=>{const l=[];g(l),p.push(a),a=l,i=null},onArrayEnd:()=>{a=p.pop()},onLiteralValue:g,onError:(l,w,T)=>{n.push({error:l,offset:w,length:T})}},s),a[0]}e.parse=f;function m(t,n=[],s=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(l){i.type==="property"&&(i.length=l-i.offset,i=i.parent)}function p(l){return i.children.push(l),l}u(t,{onObjectBegin:l=>{i=p({type:"object",offset:l,length:-1,parent:i,children:[]})},onObjectProperty:(l,w,T)=>{i=p({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:l,offset:w,length:T,parent:i})},onObjectEnd:(l,w)=>{i.length=l+w-i.offset,i=i.parent,a(l+w)},onArrayBegin:(l,w)=>{i=p({type:"array",offset:l,length:-1,parent:i,children:[]})},onArrayEnd:(l,w)=>{i.length=l+w-i.offset,i=i.parent,a(l+w)},onLiteralValue:(l,w,T)=>{p({type:h(l),offset:w,length:T,parent:i,value:l}),a(w+T)},onSeparator:(l,w,T)=>{i.type==="property"&&(l===":"?i.colonOffset=w:l===","&&a(w))},onError:(l,w,T)=>{n.push({error:l,offset:w,length:T})}},s);const _=i.children[0];return _&&delete _.parent,_}e.parseTree=m;function o(t,n){if(!!t){let s=t;for(let i of n)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const p of s.children)if(Array.isArray(p.children)&&p.children[0].value===i){s=p.children[1],a=!0;break}if(!a)return}else{const a=i;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}}e.findNodeAtLocation=o;function d(t){if(!t.parent||!t.parent.children)return[];const n=d(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=d;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(n[s.children[0].value]=E(i))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function v(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=v;function S(t,n,s=!1){if(v(t,n,s)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const p=S(i[a],n,s);if(p)return p}return t}}e.findNodeAtOffset=S;function u(t,n,s=A.DEFAULT){const i=y(t,!1);function a(le){return le?()=>le(i.getTokenOffset(),i.getTokenLength()):()=>!0}function p(le){return le?ve=>le(ve,i.getTokenOffset(),i.getTokenLength()):()=>!0}const g=a(n.onObjectBegin),_=p(n.onObjectProperty),l=a(n.onObjectEnd),w=a(n.onArrayBegin),T=a(n.onArrayEnd),N=p(n.onLiteralValue),z=p(n.onSeparator),ne=a(n.onComment),ie=p(n.onError),U=s&&s.disallowComments,B=s&&s.allowTrailingComma;function x(){for(;;){const le=i.scan();switch(i.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:U||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(le){case 12:case 13:U?L(10):ne();break;case 16:L(1);break;case 15:case 14:break;default:return le}}}function L(le,ve=[],Re=[]){if(ie(le),ve.length+Re.length>0){let Se=i.getToken();for(;Se!==17;){if(ve.indexOf(Se)!==-1){x();break}else if(Re.indexOf(Se)!==-1)break;Se=x()}}}function O(le){const ve=i.getTokenValue();return le?N(ve):_(ve),x(),!0}function F(){switch(i.getToken()){case 11:let le=0;try{le=JSON.parse(i.getTokenValue()),typeof le!="number"&&(L(2),le=0)}catch(ve){L(2)}N(le);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return x(),!0}function M(){return i.getToken()!==10?(L(3,[],[2,5]),!1):(O(!1),i.getToken()===6?(z(":"),x(),K()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function W(){g(),x();let le=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(le||L(4,[],[]),z(","),x(),i.getToken()===2&&B)break}else le&&L(6,[],[]);M()||L(4,[],[2,5]),le=!0}return l(),i.getToken()!==2?L(7,[2],[]):x(),!0}function q(){w(),x();let le=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(le||L(4,[],[]),z(","),x(),i.getToken()===4&&B)break}else le&&L(6,[],[]);K()||L(4,[],[4,5]),le=!0}return T(),i.getToken()!==4?L(8,[4],[]):x(),!0}function K(){switch(i.getToken()){case 3:return q();case 1:return W();case 10:return O(!0);default:return F()}}return x(),i.getToken()===17?s.allowEmptyContent?!0:(L(4,[],[]),!1):K()?(i.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=u;function c(t,n){let s=y(t),i=[],a,p=0,g;do switch(g=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:p!==g&&i.push(t.substring(p,g)),n!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,n)),p=s.getPosition();break}while(a!==17);return i.join("")}e.stripComments=c;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(me[132],ge([0,1,56]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(D,k,r){let P,f,m,o,d;if(k){for(o=k.offset,d=o+k.length,m=o;m>0&&!C(D,m-1);)m--;let p=d;for(;p<D.length&&!C(D,p);)p++;f=D.substring(m,p),P=A(f,r)}else f=D,P=0,m=0,o=0,d=D.length;const E=y(r,D);let v=!1,S=0,u;r.insertSpaces?u=I(" ",r.tabSize||4):u="	";const c=(0,b.createScanner)(f,!1);let h=!1;function t(){return E+I(u,P+S)}function n(){let p=c.scan();for(v=!1;p===15||p===14;)v=v||p===14,p=c.scan();return h=p===16||c.getTokenError()!==0,p}const s=[];function i(p,g,_){!h&&g<d&&_>o&&D.substring(g,_)!==p&&s.push({offset:g,length:_-g,content:p})}let a=n();if(a!==17){const p=c.getTokenOffset()+m,g=I(u,P);i(g,m,p)}for(;a!==17;){let p=c.getTokenOffset()+c.getTokenLength()+m,g=n(),_="";for(;!v&&(g===12||g===13);){const w=c.getTokenOffset()+m;i(" ",p,w),p=c.getTokenOffset()+c.getTokenLength()+m,_=g===12?t():"",g=n()}if(g===2)a!==1&&(S--,_=t());else if(g===4)a!==3&&(S--,_=t());else{switch(a){case 3:case 1:S++,_=t();break;case 5:case 12:_=t();break;case 13:v?_=t():_=" ";break;case 6:_=" ";break;case 10:if(g===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?_=" ":g!==5&&g!==17&&(h=!0);break;case 16:h=!0;break}v&&(g===12||g===13)&&(_=t())}const l=c.getTokenOffset()+m;i(_,p,l),a=g}return s}e.format=R;function I(D,k){let r="";for(let P=0;P<k;P++)r+=D;return r}function A(D,k){let r=0,P=0;const f=k.tabSize||4;for(;r<D.length;){const m=D.charAt(r);if(m===" ")P++;else if(m==="	")P+=f;else break;r++}return Math.floor(P/f)}function y(D,k){for(let r=0;r<k.length;r++){const P=k.charAt(r);if(P==="\r")return r+1<k.length&&k.charAt(r+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function C(D,k){return`\r
`.indexOf(D.charAt(k))!==-1}e.isEOL=C}),define(me[133],ge([0,1,56,132]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(k,r,P){return A(k,r,void 0,P)}e.removeProperty=I;function A(k,r,P,f,m){const o=r.slice(),d=[],E=(0,b.parseTree)(k,d);let v,S;for(;o.length>0&&(S=o.pop(),v=(0,b.findNodeAtLocation)(E,o),v===void 0&&P!==void 0);)typeof S=="string"?P={[S]:P}:P=[P];if(v)if(v.type==="object"&&typeof S=="string"&&Array.isArray(v.children)){const u=(0,b.findNodeAtLocation)(v,[S]);if(u!==void 0)if(P===void 0){if(!u.parent)throw new Error("Malformed AST");const c=v.children.indexOf(u.parent);let h,t=u.parent.offset+u.parent.length;if(c>0){const n=v.children[c-1];h=n.offset+n.length}else h=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return y(k,{offset:h,length:t-h,content:""},f)}else return y(k,{offset:u.offset,length:u.length,content:JSON.stringify(P)},f);else{if(P===void 0)return[];const c=`${JSON.stringify(S)}: ${JSON.stringify(P)}`,h=m?m(v.children.map(n=>n.children[0].value)):v.children.length;let t;if(h>0){const n=v.children[h-1];t={offset:n.offset+n.length,length:0,content:","+c}}else v.children.length===0?t={offset:v.offset+1,length:0,content:c}:t={offset:v.offset+1,length:0,content:c+","};return y(k,t,f)}}else if(v.type==="array"&&typeof S=="number"&&Array.isArray(v.children))if(P!==void 0){const u=`${JSON.stringify(P)}`;let c;if(v.children.length===0||S===0)c={offset:v.offset+1,length:0,content:v.children.length===0?u:u+","};else{const h=S===-1||S>v.children.length?v.children.length:S,t=v.children[h-1];c={offset:t.offset+t.length,length:0,content:","+u}}return y(k,c,f)}else{const u=S,c=v.children[u];let h;if(v.children.length===1)h={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===u){const t=v.children[u-1],n=t.offset+t.length,s=v.offset+v.length;h={offset:n,length:s-2-n,content:""}}else h={offset:c.offset,length:v.children[u+1].offset-c.offset,content:""};return y(k,h,f)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${v.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(P)},f)}}e.setProperty=A;function y(k,r,P){let f=C(k,r),m=r.offset,o=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;m>0&&!(0,R.isEOL)(f,m-1);)m--;for(;o<f.length&&!(0,R.isEOL)(f,o);)o++}const d=(0,R.format)(f,{offset:m,length:o-m},P);for(let v=d.length-1;v>=0;v--){const S=d[v];f=C(f,S),m=Math.min(m,S.offset),o=Math.max(o,S.offset+S.length),o+=S.content.length-S.length}const E=k.length-(f.length-o)-m;return[{offset:m,length:E,content:f.substring(m,o)}]}e.withFormatting=y;function C(k,r){return k.substring(0,r.offset)+r.content+k.substring(r.offset+r.length)}e.applyEdit=C;function D(k,r){let P=r.slice(0).sort((m,o)=>{const d=m.offset-o.offset;return d===0?m.length-o.length:d}),f=k.length;for(let m=P.length-1;m>=0;m--){let o=P[m];if(o.offset+o.length<=f)k=C(k,o);else throw new Error("Overlapping edit");f=o.offset}return k}e.applyEdits=D}),define(me[134],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new b(()=>I(this.getValue()))}}e.Lazy=b}),define(me[6],ge([0,1,72,55]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const I=!1;let A=null;function y(u){A=u}if(e.setDisposableTracker=y,I){const u="__is_disposable_tracked__";A=new class{trackDisposable(c){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[u]||console.log(h)},3e3)}markTracked(c){if(c&&c!==d.None)try{c[u]=!0}catch(h){}}}}function C(u){!A||A.markTracked(u)}function D(u){return A&&A.trackDisposable(u),u}e.trackDisposable=D;class k extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=k;function r(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=r;function P(u){if(R.Iterable.is(u)){let c=[];for(const h of u)if(h){C(h);try{h.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new k(c);return Array.isArray(u)?[]:u}else if(u)return C(u),u.dispose(),u}e.dispose=P;function f(...u){return u.forEach(C),m(()=>P(u))}e.combinedDisposable=f;function m(u){const c=D({dispose:()=>{C(c),u()}});return c}e.toDisposable=m;class o{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return C(c),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=o,o.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new o,D(this)}dispose(){C(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var h;this._isDisposed||c===this._value||((h=this._value)===null||h===void 0||h.dispose(),c&&C(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,C(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=E;class v{constructor(){this.references=new Map}acquire(c,...h){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...h)},this.references.set(c,t));const{object:n}=t,s=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=v;class S{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=S}),define(me[57],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(A){this.element=A,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class R{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let A=this._first;for(;A!==b.Undefined;){const y=A.next;A.prev=b.Undefined,A.next=b.Undefined,A=y}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const C=new b(A);if(this._first===b.Undefined)this._first=C,this._last=C;else if(y){const k=this._last;this._last=C,C.prev=k,k.next=C}else{const k=this._first;this._first=C,C.next=k,k.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==b.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==b.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==b.Undefined&&A.next!==b.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===b.Undefined&&A.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):A.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):A.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==b.Undefined;)yield A.element,A=A.next}}e.LinkedList=R}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(De,ye){for(var Ie=0;Ie<ye.length;Ie++){var oe=ye[Ie];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(De,oe.key,oe)}}function e(De,ye,Ie){return ye&&Q(De.prototype,ye),Ie&&Q(De,Ie),De}function b(De,ye){if(!!De){if(typeof De=="string")return R(De,ye);var Ie=Object.prototype.toString.call(De).slice(8,-1);if(Ie==="Object"&&De.constructor&&(Ie=De.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(De);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return R(De,ye)}}function R(De,ye){(ye==null||ye>De.length)&&(ye=De.length);for(var Ie=0,oe=new Array(ye);Ie<ye;Ie++)oe[Ie]=De[Ie];return oe}function I(De,ye){var Ie;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Ie=b(De))||ye&&De&&typeof De.length=="number"){Ie&&(De=Ie);var oe=0;return function(){return oe>=De.length?{done:!0}:{done:!1,value:De[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ie=De[Symbol.iterator](),Ie.next.bind(Ie)}function A(De){var ye={exports:{}};return De(ye,ye.exports),ye.exports}var y=A(function(De){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ie(oe){De.exports.defaults=oe}De.exports={defaults:ye(),getDefaults:ye,changeDefaults:Ie}}),C=/[&<>"']/,D=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(ye){return P[ye]};function m(De,ye){if(ye){if(C.test(De))return De.replace(D,f)}else if(k.test(De))return De.replace(r,f);return De}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(De){return De.replace(o,function(ye,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var E=/(^|[^\[])\^/g;function v(De,ye){De=De.source||De,ye=ye||"";var Ie={replace:function(ue,H){return H=H.source||H,H=H.replace(E,"$1"),De=De.replace(ue,H),Ie},getRegex:function(){return new RegExp(De,ye)}};return Ie}var S=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(De,ye,Ie){if(De){var oe;try{oe=decodeURIComponent(d(Ie)).replace(S,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}ye&&!u.test(Ie)&&(Ie=i(ye,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch(ue){return null}return Ie}var h={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(De,ye){h[" "+De]||(t.test(De)?h[" "+De]=De+"/":h[" "+De]=_(De,"/",!0)),De=h[" "+De];var Ie=De.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ie?ye:De.replace(n,"$1")+ye:ye.charAt(0)==="/"?Ie?ye:De.replace(s,"$1")+ye:De+ye}var a={exec:function(){}};function p(De){for(var ye=1,Ie,oe;ye<arguments.length;ye++){Ie=arguments[ye];for(oe in Ie)Object.prototype.hasOwnProperty.call(Ie,oe)&&(De[oe]=Ie[oe])}return De}function g(De,ye){var Ie=De.replace(/\|/g,function(H,J,ce){for(var Pe=!1,Ae=J;--Ae>=0&&ce[Ae]==="\\";)Pe=!Pe;return Pe?"|":" |"}),oe=Ie.split(/ \|/),ue=0;if(oe.length>ye)oe.splice(ye);else for(;oe.length<ye;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function _(De,ye,Ie){var oe=De.length;if(oe===0)return"";for(var ue=0;ue<oe;){var H=De.charAt(oe-ue-1);if(H===ye&&!Ie)ue++;else if(H!==ye&&Ie)ue++;else break}return De.substr(0,oe-ue)}function l(De,ye){if(De.indexOf(ye[1])===-1)return-1;for(var Ie=De.length,oe=0,ue=0;ue<Ie;ue++)if(De[ue]==="\\")ue++;else if(De[ue]===ye[0])oe++;else if(De[ue]===ye[1]&&(oe--,oe<0))return ue;return-1}function w(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(De,ye){if(ye<1)return"";for(var Ie="";ye>1;)ye&1&&(Ie+=De),ye>>=1,De+=De;return Ie+De}var N={escape:m,unescape:d,edit:v,cleanUrl:c,resolveUrl:i,noopTest:a,merge:p,splitCells:g,rtrim:_,findClosingBracket:l,checkSanitizeDeprecation:w,repeatString:T},z=y.defaults,ne=N.rtrim,ie=N.splitCells,U=N.escape,B=N.findClosingBracket;function x(De,ye,Ie){var oe=ye.href,ue=ye.title?U(ye.title):null,H=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Ie,href:oe,title:ue,text:H}:{type:"image",raw:Ie,href:oe,title:ue,text:U(H)}}function L(De,ye){var Ie=De.match(/^(\s+)(?:```)/);if(Ie===null)return ye;var oe=Ie[1];return ye.split(`
`).map(function(ue){var H=ue.match(/^\s+/);if(H===null)return ue;var J=H[0];return J.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var O=function(){function De(Ie){this.options=Ie||z}var ye=De.prototype;return ye.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var H=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?H:ne(H,`
`)}}},ye.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var H=ue[0],J=L(H,ue[3]||"");return{type:"code",raw:H,lang:ue[2]?ue[2].trim():ue[2],text:J}}},ye.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var H=ue[2].trim();if(/#$/.test(H)){var J=ne(H,"#");(this.options.pedantic||!J||/ $/.test(J))&&(H=J.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:H}}},ye.nptable=function(oe){var ue=this.rules.block.nptable.exec(oe);if(ue){var H={type:"table",header:ie(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(H.header.length===H.align.length){var J=H.align.length,ce;for(ce=0;ce<J;ce++)/^ *-+: *$/.test(H.align[ce])?H.align[ce]="right":/^ *:-+: *$/.test(H.align[ce])?H.align[ce]="center":/^ *:-+ *$/.test(H.align[ce])?H.align[ce]="left":H.align[ce]=null;for(J=H.cells.length,ce=0;ce<J;ce++)H.cells[ce]=ie(H.cells[ce],H.header.length);return H}}},ye.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var H=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:H}}},ye.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var H=ue[0],J=ue[2],ce=J.length>1,Pe={type:"list",raw:H,ordered:ce,start:ce?+J.slice(0,-1):"",loose:!1,items:[]},Ae=ue[0].match(this.rules.block.item),Fe=!1,We,Xe,rt,tt,Qe,gt,wt,be,he=Ae.length;rt=this.rules.block.listItemStart.exec(Ae[0]);for(var ae=0;ae<he;ae++){if(We=Ae[ae],H=We,ae!==he-1){if(tt=this.rules.block.listItemStart.exec(Ae[ae+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Ae.splice(ae,2,Ae[ae]+`
`+Ae[ae+1]),ae--,he--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==J[J.length-1]:ce===(tt[2].length===1))&&(Qe=Ae.slice(ae+1).join(`
`),Pe.raw=Pe.raw.substring(0,Pe.raw.length-Qe.length),ae=he-1);rt=tt}Xe=We.length,We=We.replace(/^ *([*+-]|\d+[.)]) ?/,""),~We.indexOf(`
 `)&&(Xe-=We.length,We=this.options.pedantic?We.replace(/^ {1,4}/gm,""):We.replace(new RegExp("^ {1,"+Xe+"}","gm"),"")),gt=Fe||/\n\n(?!\s*$)/.test(We),ae!==he-1&&(Fe=We.charAt(We.length-1)===`
`,gt||(gt=Fe)),gt&&(Pe.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(We),be=void 0,wt&&(be=We[1]!==" ",We=We.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:H,task:wt,checked:be,loose:gt,text:We})}return Pe}},ye.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):U(ue[0]):ue[0]}},ye.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var H=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var H={type:"table",header:ie(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=ue[0];var J=H.align.length,ce;for(ce=0;ce<J;ce++)/^ *-+: *$/.test(H.align[ce])?H.align[ce]="right":/^ *:-+: *$/.test(H.align[ce])?H.align[ce]="center":/^ *:-+ *$/.test(H.align[ce])?H.align[ce]="left":H.align[ce]=null;for(J=H.cells.length,ce=0;ce<J;ce++)H.cells[ce]=ie(H.cells[ce].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},ye.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},ye.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},ye.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},ye.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:U(ue[1])}},ye.tag=function(oe,ue,H){var J=this.rules.inline.tag.exec(oe);if(J)return!ue&&/^<a /i.test(J[0])?ue=!0:ue&&/^<\/a>/i.test(J[0])&&(ue=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:ue,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):U(J[0]):J[0]}},ye.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var H=ue[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var J=ne(H.slice(0,-1),"\\");if((H.length-J.length)%2==0)return}else{var ce=B(ue[2],"()");if(ce>-1){var Pe=ue[0].indexOf("!")===0?5:4,Ae=Pe+ue[1].length+ce;ue[2]=ue[2].substring(0,ce),ue[0]=ue[0].substring(0,Ae).trim(),ue[3]=""}}var Fe=ue[2],We="";if(this.options.pedantic){var Xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Fe);Xe&&(Fe=Xe[1],We=Xe[3])}else We=ue[3]?ue[3].slice(1,-1):"";return Fe=Fe.trim(),/^</.test(Fe)&&(this.options.pedantic&&!/>$/.test(H)?Fe=Fe.slice(1):Fe=Fe.slice(1,-1)),x(ue,{href:Fe&&Fe.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},ue[0])}},ye.reflink=function(oe,ue){var H;if((H=this.rules.inline.reflink.exec(oe))||(H=this.rules.inline.nolink.exec(oe))){var J=(H[2]||H[1]).replace(/\s+/g," ");if(J=ue[J.toLowerCase()],!J||!J.href){var ce=H[0].charAt(0);return{type:"text",raw:ce,text:ce}}return x(H,J,H[0])}},ye.emStrong=function(oe,ue,H){H===void 0&&(H="");var J=this.rules.inline.emStrong.lDelim.exec(oe);if(!!J&&!(J[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=J[1]||J[2]||"";if(!ce||ce&&(H===""||this.rules.inline.punctuation.exec(H))){var Pe=J[0].length-1,Ae,Fe,We=Pe,Xe=0,rt=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ue=ue.slice(-1*oe.length+Pe);(J=rt.exec(ue))!=null;)if(Ae=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!Ae){if(Fe=Ae.length,J[3]||J[4]){We+=Fe;continue}else if((J[5]||J[6])&&Pe%3&&!((Pe+Fe)%3)){Xe+=Fe;continue}if(We-=Fe,!(We>0)){if(We+Xe-Fe<=0&&!ue.slice(rt.lastIndex).match(rt)&&(Fe=Math.min(Fe,Fe+We+Xe)),Math.min(Pe,Fe)%2)return{type:"em",raw:oe.slice(0,Pe+J.index+Fe+1),text:oe.slice(1,Pe+J.index+Fe)};if(Math.min(Pe,Fe)%2==0)return{type:"strong",raw:oe.slice(0,Pe+J.index+Fe+1),text:oe.slice(2,Pe+J.index+Fe-1)}}}}}},ye.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var H=ue[2].replace(/\n/g," "),J=/[^ ]/.test(H),ce=/^ /.test(H)&&/ $/.test(H);return J&&ce&&(H=H.substring(1,H.length-1)),H=U(H,!0),{type:"codespan",raw:ue[0],text:H}}},ye.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},ye.autolink=function(oe,ue){var H=this.rules.inline.autolink.exec(oe);if(H){var J,ce;return H[2]==="@"?(J=U(this.options.mangle?ue(H[1]):H[1]),ce="mailto:"+J):(J=U(H[1]),ce=J),{type:"link",raw:H[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},ye.url=function(oe,ue){var H;if(H=this.rules.inline.url.exec(oe)){var J,ce;if(H[2]==="@")J=U(this.options.mangle?ue(H[0]):H[0]),ce="mailto:"+J;else{var Pe;do Pe=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Pe!==H[0]);J=U(H[0]),H[1]==="www."?ce="http://"+J:ce=J}return{type:"link",raw:H[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},ye.inlineText=function(oe,ue,H){var J=this.rules.inline.text.exec(oe);if(J){var ce;return ue?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):U(J[0]):J[0]:ce=U(this.options.smartypants?H(J[0]):J[0]),{type:"text",raw:J[0],text:ce}}},De}(),F=N.noopTest,M=N.edit,W=N.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=M(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=M(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=M(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=M(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=M(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=M(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=M(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=W({},q),q.gfm=W({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=M(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=M(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=W({},q.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=M(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=M(q._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=M(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=M(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=M(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=M(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=M(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=M(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=M(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=M(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=W({},K),K.pedantic=W({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=W({},K.normal,{escape:M(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),K.gfm.url=M(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=W({},K.gfm,{br:M(K.br).replace("{2,}","*").getRegex(),text:M(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:q,inline:K},ve=y.defaults,Re=le.block,Se=le.inline,Oe=N.repeatString;function V(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(De){var ye="",Ie,oe,ue=De.length;for(Ie=0;Ie<ue;Ie++)oe=De.charCodeAt(Ie),Math.random()>.5&&(oe="x"+oe.toString(16)),ye+="&#"+oe+";";return ye}var Z=function(){function De(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||ve,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var oe={block:Re.normal,inline:Se.normal};this.options.pedantic?(oe.block=Re.pedantic,oe.inline=Se.pedantic):this.options.gfm&&(oe.block=Re.gfm,this.options.breaks?oe.inline=Se.breaks:oe.inline=Se.gfm),this.tokenizer.rules=oe}De.lex=function(oe,ue){var H=new De(ue);return H.lex(oe)},De.lexInline=function(oe,ue){var H=new De(ue);return H.inlineTokens(oe)};var ye=De.prototype;return ye.lex=function(oe){return oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(oe,ue,H){ue===void 0&&(ue=[]),H===void 0&&(H=!0),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var J,ce,Pe,Ae;oe;){if(J=this.tokenizer.space(oe)){oe=oe.substring(J.raw.length),J.type&&ue.push(J);continue}if(J=this.tokenizer.code(oe)){oe=oe.substring(J.raw.length),Ae=ue[ue.length-1],Ae&&Ae.type==="paragraph"?(Ae.raw+=`
`+J.raw,Ae.text+=`
`+J.text):ue.push(J);continue}if(J=this.tokenizer.fences(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.heading(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.nptable(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.hr(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.blockquote(oe)){oe=oe.substring(J.raw.length),J.tokens=this.blockTokens(J.text,[],H),ue.push(J);continue}if(J=this.tokenizer.list(oe)){for(oe=oe.substring(J.raw.length),Pe=J.items.length,ce=0;ce<Pe;ce++)J.items[ce].tokens=this.blockTokens(J.items[ce].text,[],!1);ue.push(J);continue}if(J=this.tokenizer.html(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(H&&(J=this.tokenizer.def(oe))){oe=oe.substring(J.raw.length),this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.lheading(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(H&&(J=this.tokenizer.paragraph(oe))){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.text(oe)){oe=oe.substring(J.raw.length),Ae=ue[ue.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+J.raw,Ae.text+=`
`+J.text):ue.push(J);continue}if(oe){var Fe="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Fe);break}else throw new Error(Fe)}}return ue},ye.inline=function(oe){var ue,H,J,ce,Pe,Ae,Fe=oe.length;for(ue=0;ue<Fe;ue++)switch(Ae=oe[ue],Ae.type){case"paragraph":case"text":case"heading":{Ae.tokens=[],this.inlineTokens(Ae.text,Ae.tokens);break}case"table":{for(Ae.tokens={header:[],cells:[]},ce=Ae.header.length,H=0;H<ce;H++)Ae.tokens.header[H]=[],this.inlineTokens(Ae.header[H],Ae.tokens.header[H]);for(ce=Ae.cells.length,H=0;H<ce;H++)for(Pe=Ae.cells[H],Ae.tokens.cells[H]=[],J=0;J<Pe.length;J++)Ae.tokens.cells[H][J]=[],this.inlineTokens(Pe[J],Ae.tokens.cells[H][J]);break}case"blockquote":{this.inline(Ae.tokens);break}case"list":{for(ce=Ae.items.length,H=0;H<ce;H++)this.inline(Ae.items[H].tokens);break}}return oe},ye.inlineTokens=function(oe,ue,H,J){ue===void 0&&(ue=[]),H===void 0&&(H=!1),J===void 0&&(J=!1);var ce,Pe,Ae=oe,Fe,We,Xe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Fe=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)rt.includes(Fe[0].slice(Fe[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Fe.index)+"["+Oe("a",Fe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Fe=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Fe.index)+"["+Oe("a",Fe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Fe=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Fe.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;){if(We||(Xe=""),We=!1,ce=this.tokenizer.escape(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.tag(oe,H,J)){oe=oe.substring(ce.raw.length),H=ce.inLink,J=ce.inRawBlock;var tt=ue[ue.length-1];tt&&ce.type==="text"&&tt.type==="text"?(tt.raw+=ce.raw,tt.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.link(oe)){oe=oe.substring(ce.raw.length),ce.type==="link"&&(ce.tokens=this.inlineTokens(ce.text,[],!0,J)),ue.push(ce);continue}if(ce=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ce.raw.length);var Qe=ue[ue.length-1];ce.type==="link"?(ce.tokens=this.inlineTokens(ce.text,[],!0,J),ue.push(ce)):Qe&&ce.type==="text"&&Qe.type==="text"?(Qe.raw+=ce.raw,Qe.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.emStrong(oe,Ae,Xe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],H,J),ue.push(ce);continue}if(ce=this.tokenizer.codespan(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.br(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.del(oe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],H,J),ue.push(ce);continue}if(ce=this.tokenizer.autolink(oe,X)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(!H&&(ce=this.tokenizer.url(oe,X))){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.inlineText(oe,J,V)){oe=oe.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Xe=ce.raw.slice(-1)),We=!0,Pe=ue[ue.length-1],Pe&&Pe.type==="text"?(Pe.raw+=ce.raw,Pe.text+=ce.text):ue.push(ce);continue}if(oe){var gt="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(gt);break}else throw new Error(gt)}}return ue},e(De,null,[{key:"rules",get:function(){return{block:Re,inline:Se}}}]),De}(),se=y.defaults,fe=N.cleanUrl,Ee=N.escape,Be=function(){function De(Ie){this.options=Ie||se}var ye=De.prototype;return ye.code=function(oe,ue,H){var J=(ue||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(oe,J);ce!=null&&ce!==oe&&(H=!0,oe=ce)}return oe=oe.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+Ee(J,!0)+'">'+(H?oe:Ee(oe,!0))+`</code></pre>
`:"<pre><code>"+(H?oe:Ee(oe,!0))+`</code></pre>
`},ye.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},ye.html=function(oe){return oe},ye.heading=function(oe,ue,H,J){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+J.slug(H)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(oe,ue,H){var J=ue?"ol":"ul",ce=ue&&H!==1?' start="'+H+'"':"";return"<"+J+ce+`>
`+oe+"</"+J+`>
`},ye.listitem=function(oe){return"<li>"+oe+`</li>
`},ye.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(oe){return"<p>"+oe+`</p>
`},ye.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},ye.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},ye.tablecell=function(oe,ue){var H=ue.header?"th":"td",J=ue.align?"<"+H+' align="'+ue.align+'">':"<"+H+">";return J+oe+"</"+H+`>
`},ye.strong=function(oe){return"<strong>"+oe+"</strong>"},ye.em=function(oe){return"<em>"+oe+"</em>"},ye.codespan=function(oe){return"<code>"+oe+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(oe){return"<del>"+oe+"</del>"},ye.link=function(oe,ue,H){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return H;var J='<a href="'+Ee(oe)+'"';return ue&&(J+=' title="'+ue+'"'),J+=">"+H+"</a>",J},ye.image=function(oe,ue,H){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return H;var J='<img src="'+oe+'" alt="'+H+'"';return ue&&(J+=' title="'+ue+'"'),J+=this.options.xhtml?"/>":">",J},ye.text=function(oe){return oe},De}(),pe=function(){function De(){}var ye=De.prototype;return ye.strong=function(oe){return oe},ye.em=function(oe){return oe},ye.codespan=function(oe){return oe},ye.del=function(oe){return oe},ye.html=function(oe){return oe},ye.text=function(oe){return oe},ye.link=function(oe,ue,H){return""+H},ye.image=function(oe,ue,H){return""+H},ye.br=function(){return""},De}(),Ce=function(){function De(){this.seen={}}var ye=De.prototype;return ye.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(oe,ue){var H=oe,J=0;if(this.seen.hasOwnProperty(H)){J=this.seen[oe];do J++,H=oe+"-"+J;while(this.seen.hasOwnProperty(H))}return ue||(this.seen[oe]=J,this.seen[H]=0),H},ye.slug=function(oe,ue){ue===void 0&&(ue={});var H=this.serialize(oe);return this.getNextSafeSlug(H,ue.dryrun)},De}(),Me=y.defaults,ze=N.unescape,_e=function(){function De(Ie){this.options=Ie||Me,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Ce}De.parse=function(oe,ue){var H=new De(ue);return H.parse(oe)},De.parseInline=function(oe,ue){var H=new De(ue);return H.parseInline(oe)};var ye=De.prototype;return ye.parse=function(oe,ue){ue===void 0&&(ue=!0);var H="",J,ce,Pe,Ae,Fe,We,Xe,rt,tt,Qe,gt,wt,be,he,ae,Y,Ne,Le,Ye=oe.length;for(J=0;J<Ye;J++)switch(Qe=oe[J],Qe.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,ze(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(rt="",Xe="",Ae=Qe.header.length,ce=0;ce<Ae;ce++)Xe+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[ce]),{header:!0,align:Qe.align[ce]});for(rt+=this.renderer.tablerow(Xe),tt="",Ae=Qe.cells.length,ce=0;ce<Ae;ce++){for(We=Qe.tokens.cells[ce],Xe="",Fe=We.length,Pe=0;Pe<Fe;Pe++)Xe+=this.renderer.tablecell(this.parseInline(We[Pe]),{header:!1,align:Qe.align[Pe]});tt+=this.renderer.tablerow(Xe)}H+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Qe.tokens),H+=this.renderer.blockquote(tt);continue}case"list":{for(gt=Qe.ordered,wt=Qe.start,be=Qe.loose,Ae=Qe.items.length,tt="",ce=0;ce<Ae;ce++)ae=Qe.items[ce],Y=ae.checked,Ne=ae.task,he="",ae.task&&(Le=this.renderer.checkbox(Y),be?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Le+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Le+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Le}):he+=Le),he+=this.parse(ae.tokens,be),tt+=this.renderer.listitem(he,Ne,Y);H+=this.renderer.list(tt,gt,wt);continue}case"html":{H+=this.renderer.html(Qe.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(tt=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;J+1<Ye&&oe[J+1].type==="text";)Qe=oe[++J],tt+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);H+=ue?this.renderer.paragraph(tt):tt;continue}default:{var et='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return H},ye.parseInline=function(oe,ue){ue=ue||this.renderer;var H="",J,ce,Pe=oe.length;for(J=0;J<Pe;J++)switch(ce=oe[J],ce.type){case"escape":{H+=ue.text(ce.text);break}case"html":{H+=ue.html(ce.text);break}case"link":{H+=ue.link(ce.href,ce.title,this.parseInline(ce.tokens,ue));break}case"image":{H+=ue.image(ce.href,ce.title,ce.text);break}case"strong":{H+=ue.strong(this.parseInline(ce.tokens,ue));break}case"em":{H+=ue.em(this.parseInline(ce.tokens,ue));break}case"codespan":{H+=ue.codespan(ce.text);break}case"br":{H+=ue.br();break}case"del":{H+=ue.del(this.parseInline(ce.tokens,ue));break}case"text":{H+=ue.text(ce.text);break}default:{var Ae='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}return H},De}(),Ke=N.merge,G=N.checkSanitizeDeprecation,te=N.escape,we=y.getDefaults,xe=y.changeDefaults,je=y.defaults;function Ve(De,ye,Ie){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof ye=="function"&&(Ie=ye,ye=null),ye=Ke({},Ve.defaults,ye||{}),G(ye),Ie){var oe=ye.highlight,ue;try{ue=Z.lex(De,ye)}catch(Pe){return Ie(Pe)}var H=function(Ae){var Fe;if(!Ae)try{Fe=_e.parse(ue,ye)}catch(We){Ae=We}return ye.highlight=oe,Ae?Ie(Ae):Ie(null,Fe)};if(!oe||oe.length<3||(delete ye.highlight,!ue.length))return H();var J=0;Ve.walkTokens(ue,function(Pe){Pe.type==="code"&&(J++,setTimeout(function(){oe(Pe.text,Pe.lang,function(Ae,Fe){if(Ae)return H(Ae);Fe!=null&&Fe!==Pe.text&&(Pe.text=Fe,Pe.escaped=!0),J--,J===0&&H()})},0))}),J===0&&H();return}try{var ce=Z.lex(De,ye);return ye.walkTokens&&Ve.walkTokens(ce,ye.walkTokens),_e.parse(ce,ye)}catch(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+te(Pe.message+"",!0)+"</pre>";throw Pe}}Ve.options=Ve.setOptions=function(De){return Ke(Ve.defaults,De),xe(Ve.defaults),Ve},Ve.getDefaults=we,Ve.defaults=je,Ve.use=function(De){var ye=Ke({},De);if(De.renderer&&function(){var oe=Ve.defaults.renderer||new Be,ue=function(ce){var Pe=oe[ce];oe[ce]=function(){for(var Ae=arguments.length,Fe=new Array(Ae),We=0;We<Ae;We++)Fe[We]=arguments[We];var Xe=De.renderer[ce].apply(oe,Fe);return Xe===!1&&(Xe=Pe.apply(oe,Fe)),Xe}};for(var H in De.renderer)ue(H);ye.renderer=oe}(),De.tokenizer&&function(){var oe=Ve.defaults.tokenizer||new O,ue=function(ce){var Pe=oe[ce];oe[ce]=function(){for(var Ae=arguments.length,Fe=new Array(Ae),We=0;We<Ae;We++)Fe[We]=arguments[We];var Xe=De.tokenizer[ce].apply(oe,Fe);return Xe===!1&&(Xe=Pe.apply(oe,Fe)),Xe}};for(var H in De.tokenizer)ue(H);ye.tokenizer=oe}(),De.walkTokens){var Ie=Ve.defaults.walkTokens;ye.walkTokens=function(oe){De.walkTokens(oe),Ie&&Ie(oe)}}Ve.setOptions(ye)},Ve.walkTokens=function(De,ye){for(var Ie=I(De),oe;!(oe=Ie()).done;){var ue=oe.value;switch(ye(ue),ue.type){case"table":{for(var H=I(ue.tokens.header),J;!(J=H()).done;){var ce=J.value;Ve.walkTokens(ce,ye)}for(var Pe=I(ue.tokens.cells),Ae;!(Ae=Pe()).done;)for(var Fe=Ae.value,We=I(Fe),Xe;!(Xe=We()).done;){var rt=Xe.value;Ve.walkTokens(rt,ye)}break}case"list":{Ve.walkTokens(ue.items,ye);break}default:ue.tokens&&Ve.walkTokens(ue.tokens,ye)}}},Ve.parseInline=function(De,ye){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");ye=Ke({},Ve.defaults,ye||{}),G(ye);try{var Ie=Z.lexInline(De,ye);return ye.walkTokens&&Ve.walkTokens(Ie,ye.walkTokens),_e.parseInline(Ie,ye)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+te(oe.message+"",!0)+"</pre>";throw oe}},Ve.Parser=_e,Ve.parser=_e.parse,Ve.Renderer=Be,Ve.TextRenderer=pe,Ve.Lexer=Z,Ve.lexer=Z.lex,Ve.Tokenizer=O,Ve.Slugger=Ce,Ve.parse=Ve;var Je=Ve;return Je}),define(me[74],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,C,D){return Math.min(Math.max(y,C),D)}e.clamp=b;function R(y,C){return(C+y%C)%C}e.rot=R;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class A{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function Q(I){const A=[];typeof I=="number"&&A.push("code/timeOrigin",I);function y(D){A.push(D,Date.now())}function C(){const D=[];for(let k=0;k<A.length;k+=2)D.push({name:A[k],startTime:A[k+1]});return D}return{mark:y,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(I+y.startTime)});return A}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function b(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=b(R))})(),define(me[10],ge([0,1]),function(Q,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let I=!1,A=!1,y=!1,C=!1,D=!1,k=!1,r=!1,P,f=R,m,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const E=typeof((b=d==null?void 0:d.versions)===null||b===void 0?void 0:b.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=E&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)o=navigator.userAgent,I=o.indexOf("Windows")>=0,A=o.indexOf("Macintosh")>=0,r=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=o.indexOf("Linux")>=0,k=!0,P=navigator.language,f=P;else if(typeof d=="object"){I=d.platform==="win32",A=d.platform==="darwin",y=d.platform==="linux",C=y&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,P=R,f=R;const i=d.env.VSCODE_NLS_CONFIG;if(i)try{const a=JSON.parse(i),p=a.availableLanguages["*"];P=a.locale,f=p||R,m=a._translationsConfigFile}catch(a){}D=!0}else console.error("Unable to resolve platform.");var v;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function S(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let u=0;A?u=1:I?u=3:y&&(u=2),e.isWindows=I,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=C,e.isNative=D,e.isWeb=k,e.isIOS=r,e.platform=u,e.userAgent=o,e.language=f;var c;(function(i){function a(){return e.language}i.value=a;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=p;function g(){return e.language==="en"}i.isDefault=g})(c=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let p=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let l=0,w=p.length;l<w;l++){const T=p[l];if(T.id===_.data.vscodeSetImmediateId){p.splice(l,1),T.callback();return}}});let g=0;return _=>{const l=++g;p.push({id:l,callback:_}),e.globals.postMessage({vscodeSetImmediateId:l},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const a=Promise.resolve();return p=>a.then(p)}();var h;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||r?2:I?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,t=new Uint16Array(i.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(me[36],ge([0,1,10]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof b.globals.vscode!="undefined"&&typeof b.globals.vscode.process!="undefined"){const I=b.globals.vscode.process;R={get platform(){return I.platform},get env(){return I.env},cwd(){return I.cwd()},nextTick(A){return(0,b.setImmediate)(A)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(I){return process.nextTick(I)}}:R={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(I){return(0,b.setImmediate)(I)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(me[9],ge([0,1,36]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,I=97,A=90,y=122,C=46,D=47,k=92,r=58,P=63;class f extends Error{constructor(c,h,t){let n;typeof h=="string"&&h.indexOf("not ")===0?(n="must not be",h=h.replace(/^not /,"")):n="must be";const s=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${s} ${n} of type ${h}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function m(u,c){if(typeof u!="string")throw new f(c,"string",u)}function o(u){return u===D||u===k}function d(u){return u===D}function E(u){return u>=R&&u<=A||u>=I&&u<=y}function v(u,c,h,t){let n="",s=0,i=-1,a=0,p=0;for(let g=0;g<=u.length;++g){if(g<u.length)p=u.charCodeAt(g);else{if(t(p))break;p=D}if(t(p)){if(!(i===g-1||a===1))if(a===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const _=n.lastIndexOf(h);_===-1?(n="",s=0):(n=n.slice(0,_),s=n.length-1-n.lastIndexOf(h)),i=g,a=0;continue}else if(n.length!==0){n="",s=0,i=g,a=0;continue}}c&&(n+=n.length>0?`${h}..`:"..",s=2)}else n.length>0?n+=`${h}${u.slice(i+1,g)}`:n=u.slice(i+1,g),s=g-i-1;i=g,a=0}else p===C&&a!==-1?++a:a=-1}return n}function S(u,c){if(c===null||typeof c!="object")throw new f("pathObject","Object",c);const h=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return h?h===c.root?`${h}${t}`:`${h}${u}${t}`:t}e.win32={resolve(...u){let c="",h="",t=!1;for(let n=u.length-1;n>=-1;n--){let s;if(n>=0){if(s=u[n],m(s,"path"),s.length===0)continue}else c.length===0?s=b.cwd():(s=b.env[`=${c}`]||b.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${c}\\`));const i=s.length;let a=0,p="",g=!1;const _=s.charCodeAt(0);if(i===1)o(_)&&(a=1,g=!0);else if(o(_))if(g=!0,o(s.charCodeAt(1))){let l=2,w=l;for(;l<i&&!o(s.charCodeAt(l));)l++;if(l<i&&l!==w){const T=s.slice(w,l);for(w=l;l<i&&o(s.charCodeAt(l));)l++;if(l<i&&l!==w){for(w=l;l<i&&!o(s.charCodeAt(l));)l++;(l===i||l!==w)&&(p=`\\\\${T}\\${s.slice(w,l)}`,a=l)}}}else a=1;else E(_)&&s.charCodeAt(1)===r&&(p=s.slice(0,2),a=2,i>2&&o(s.charCodeAt(2))&&(g=!0,a=3));if(p.length>0)if(c.length>0){if(p.toLowerCase()!==c.toLowerCase())continue}else c=p;if(t){if(c.length>0)break}else if(h=`${s.slice(a)}\\${h}`,t=g,g&&c.length>0)break}return h=v(h,!t,"\\",o),t?`${c}\\${h}`:`${c}${h}`||"."},normalize(u){m(u,"path");const c=u.length;if(c===0)return".";let h=0,t,n=!1;const s=u.charCodeAt(0);if(c===1)return d(s)?"\\":u;if(o(s))if(n=!0,o(u.charCodeAt(1))){let a=2,p=a;for(;a<c&&!o(u.charCodeAt(a));)a++;if(a<c&&a!==p){const g=u.slice(p,a);for(p=a;a<c&&o(u.charCodeAt(a));)a++;if(a<c&&a!==p){for(p=a;a<c&&!o(u.charCodeAt(a));)a++;if(a===c)return`\\\\${g}\\${u.slice(p)}\\`;a!==p&&(t=`\\\\${g}\\${u.slice(p,a)}`,h=a)}}}else h=1;else E(s)&&u.charCodeAt(1)===r&&(t=u.slice(0,2),h=2,c>2&&o(u.charCodeAt(2))&&(n=!0,h=3));let i=h<c?v(u.slice(h),!n,"\\",o):"";return i.length===0&&!n&&(i="."),i.length>0&&o(u.charCodeAt(c-1))&&(i+="\\"),t===void 0?n?`\\${i}`:i:n?`${t}\\${i}`:`${t}${i}`},isAbsolute(u){m(u,"path");const c=u.length;if(c===0)return!1;const h=u.charCodeAt(0);return o(h)||c>2&&E(h)&&u.charCodeAt(1)===r&&o(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let c,h;for(let s=0;s<u.length;++s){const i=u[s];m(i,"path"),i.length>0&&(c===void 0?c=h=i:c+=`\\${i}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof h=="string"&&o(h.charCodeAt(0))){++n;const s=h.length;s>1&&o(h.charCodeAt(1))&&(++n,s>2&&(o(h.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&o(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.win32.normalize(c)},relative(u,c){if(m(u,"from"),m(c,"to"),u===c)return"";const h=e.win32.resolve(u),t=e.win32.resolve(c);if(h===t||(u=h.toLowerCase(),c=t.toLowerCase(),u===c))return"";let n=0;for(;n<u.length&&u.charCodeAt(n)===k;)n++;let s=u.length;for(;s-1>n&&u.charCodeAt(s-1)===k;)s--;const i=s-n;let a=0;for(;a<c.length&&c.charCodeAt(a)===k;)a++;let p=c.length;for(;p-1>a&&c.charCodeAt(p-1)===k;)p--;const g=p-a,_=i<g?i:g;let l=-1,w=0;for(;w<_;w++){const N=u.charCodeAt(n+w);if(N!==c.charCodeAt(a+w))break;N===k&&(l=w)}if(w!==_){if(l===-1)return t}else{if(g>_){if(c.charCodeAt(a+w)===k)return t.slice(a+w+1);if(w===2)return t.slice(a+w)}i>_&&(u.charCodeAt(n+w)===k?l=w:w===2&&(l=3)),l===-1&&(l=0)}let T="";for(w=n+l+1;w<=s;++w)(w===s||u.charCodeAt(w)===k)&&(T+=T.length===0?"..":"\\..");return a+=l,T.length>0?`${T}${t.slice(a,p)}`:(t.charCodeAt(a)===k&&++a,t.slice(a,p))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const c=e.win32.resolve(u);if(c.length<=2)return u;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const h=c.charCodeAt(2);if(h!==P&&h!==C)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(E(c.charCodeAt(0))&&c.charCodeAt(1)===r&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return u},dirname(u){m(u,"path");const c=u.length;if(c===0)return".";let h=-1,t=0;const n=u.charCodeAt(0);if(c===1)return o(n)?u:".";if(o(n)){if(h=t=1,o(u.charCodeAt(1))){let a=2,p=a;for(;a<c&&!o(u.charCodeAt(a));)a++;if(a<c&&a!==p){for(p=a;a<c&&o(u.charCodeAt(a));)a++;if(a<c&&a!==p){for(p=a;a<c&&!o(u.charCodeAt(a));)a++;if(a===c)return u;a!==p&&(h=t=a+1)}}}}else E(n)&&u.charCodeAt(1)===r&&(h=c>2&&o(u.charCodeAt(2))?3:2,t=h);let s=-1,i=!0;for(let a=c-1;a>=t;--a)if(o(u.charCodeAt(a))){if(!i){s=a;break}}else i=!1;if(s===-1){if(h===-1)return".";s=h}return u.slice(0,s)},basename(u,c){c!==void 0&&m(c,"ext"),m(u,"path");let h=0,t=-1,n=!0,s;if(u.length>=2&&E(u.charCodeAt(0))&&u.charCodeAt(1)===r&&(h=2),c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let i=c.length-1,a=-1;for(s=u.length-1;s>=h;--s){const p=u.charCodeAt(s);if(o(p)){if(!n){h=s+1;break}}else a===-1&&(n=!1,a=s+1),i>=0&&(p===c.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=a))}return h===t?t=a:t===-1&&(t=u.length),u.slice(h,t)}for(s=u.length-1;s>=h;--s)if(o(u.charCodeAt(s))){if(!n){h=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(h,t)},extname(u){m(u,"path");let c=0,h=-1,t=0,n=-1,s=!0,i=0;u.length>=2&&u.charCodeAt(1)===r&&E(u.charCodeAt(0))&&(c=t=2);for(let a=u.length-1;a>=c;--a){const p=u.charCodeAt(a);if(o(p)){if(!s){t=a+1;break}continue}n===-1&&(s=!1,n=a+1),p===C?h===-1?h=a:i!==1&&(i=1):h!==-1&&(i=-1)}return h===-1||n===-1||i===0||i===1&&h===n-1&&h===t+1?"":u.slice(h,n)},format:S.bind(null,"\\"),parse(u){m(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const h=u.length;let t=0,n=u.charCodeAt(0);if(h===1)return o(n)?(c.root=c.dir=u,c):(c.base=c.name=u,c);if(o(n)){if(t=1,o(u.charCodeAt(1))){let l=2,w=l;for(;l<h&&!o(u.charCodeAt(l));)l++;if(l<h&&l!==w){for(w=l;l<h&&o(u.charCodeAt(l));)l++;if(l<h&&l!==w){for(w=l;l<h&&!o(u.charCodeAt(l));)l++;l===h?t=l:l!==w&&(t=l+1)}}}}else if(E(n)&&u.charCodeAt(1)===r){if(h<=2)return c.root=c.dir=u,c;if(t=2,o(u.charCodeAt(2))){if(h===3)return c.root=c.dir=u,c;t=3}}t>0&&(c.root=u.slice(0,t));let s=-1,i=t,a=-1,p=!0,g=u.length-1,_=0;for(;g>=t;--g){if(n=u.charCodeAt(g),o(n)){if(!p){i=g+1;break}continue}a===-1&&(p=!1,a=g+1),n===C?s===-1?s=g:_!==1&&(_=1):s!==-1&&(_=-1)}return a!==-1&&(s===-1||_===0||_===1&&s===a-1&&s===i+1?c.base=c.name=u.slice(i,a):(c.name=u.slice(i,s),c.base=u.slice(i,a),c.ext=u.slice(s,a))),i>0&&i!==t?c.dir=u.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let c="",h=!1;for(let t=u.length-1;t>=-1&&!h;t--){const n=t>=0?u[t]:b.cwd();m(n,"path"),n.length!==0&&(c=`${n}/${c}`,h=n.charCodeAt(0)===D)}return c=v(c,!h,"/",d),h?`/${c}`:c.length>0?c:"."},normalize(u){if(m(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===D,h=u.charCodeAt(u.length-1)===D;return u=v(u,!c,"/",d),u.length===0?c?"/":h?"./":".":(h&&(u+="/"),c?`/${u}`:u)},isAbsolute(u){return m(u,"path"),u.length>0&&u.charCodeAt(0)===D},join(...u){if(u.length===0)return".";let c;for(let h=0;h<u.length;++h){const t=u[h];m(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(u,c){if(m(u,"from"),m(c,"to"),u===c||(u=e.posix.resolve(u),c=e.posix.resolve(c),u===c))return"";const h=1,t=u.length,n=t-h,s=1,i=c.length-s,a=n<i?n:i;let p=-1,g=0;for(;g<a;g++){const l=u.charCodeAt(h+g);if(l!==c.charCodeAt(s+g))break;l===D&&(p=g)}if(g===a)if(i>a){if(c.charCodeAt(s+g)===D)return c.slice(s+g+1);if(g===0)return c.slice(s+g)}else n>a&&(u.charCodeAt(h+g)===D?p=g:g===0&&(p=0));let _="";for(g=h+p+1;g<=t;++g)(g===t||u.charCodeAt(g)===D)&&(_+=_.length===0?"..":"/..");return`${_}${c.slice(s+p)}`},toNamespacedPath(u){return u},dirname(u){if(m(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===D;let h=-1,t=!0;for(let n=u.length-1;n>=1;--n)if(u.charCodeAt(n)===D){if(!t){h=n;break}}else t=!1;return h===-1?c?"/":".":c&&h===1?"//":u.slice(0,h)},basename(u,c){c!==void 0&&m(c,"ext"),m(u,"path");let h=0,t=-1,n=!0,s;if(c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let i=c.length-1,a=-1;for(s=u.length-1;s>=0;--s){const p=u.charCodeAt(s);if(p===D){if(!n){h=s+1;break}}else a===-1&&(n=!1,a=s+1),i>=0&&(p===c.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=a))}return h===t?t=a:t===-1&&(t=u.length),u.slice(h,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===D){if(!n){h=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(h,t)},extname(u){m(u,"path");let c=-1,h=0,t=-1,n=!0,s=0;for(let i=u.length-1;i>=0;--i){const a=u.charCodeAt(i);if(a===D){if(!n){h=i+1;break}continue}t===-1&&(n=!1,t=i+1),a===C?c===-1?c=i:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||t===-1||s===0||s===1&&c===t-1&&c===h+1?"":u.slice(c,t)},format:S.bind(null,"/"),parse(u){m(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const h=u.charCodeAt(0)===D;let t;h?(c.root="/",t=1):t=0;let n=-1,s=0,i=-1,a=!0,p=u.length-1,g=0;for(;p>=t;--p){const _=u.charCodeAt(p);if(_===D){if(!a){s=p+1;break}continue}i===-1&&(a=!1,i=p+1),_===C?n===-1?n=p:g!==1&&(g=1):n!==-1&&(g=-1)}if(i!==-1){const _=s===0&&h?1:s;n===-1||g===0||g===1&&n===i-1&&n===s+1?c.base=c.name=u.slice(_,i):(c.name=u.slice(_,n),c.base=u.slice(_,i),c.ext=u.slice(n,i))}return s>0?c.dir=u.slice(0,s-1):h&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[135],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var R;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(A,...y){const C=y.reduce((r,P)=>(r[P]=!0,r),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(r=>!C[r]).forEach(r=>{for(let P=0;P<D.length;P++)if(r.search(D[P])!==-1){delete A[r];break}})}e.sanitizeProcessEnvironment=I}),define(me[45],ge([0,1,10]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=b.globals.performance&&typeof b.globals.performance.now=="function";class I{constructor(y){this._highResolution=R&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new I(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=I}),define(me[3],ge([0,1,17,72,6,57,45]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(v){v.None=()=>I.Disposable.None;function S(U){return(B,x=null,L)=>{let O=!1,F;return F=U(M=>{if(!O)return F?F.dispose():O=!0,B.call(x,M)},null,L),O&&F.dispose(),F}}v.once=S;function u(U,B){return i((x,L=null,O)=>U(F=>x.call(L,B(F)),null,O))}v.map=u;function c(U,B){return i((x,L=null,O)=>U(F=>{B(F),x.call(L,F)},null,O))}v.forEach=c;function h(U,B){return i((x,L=null,O)=>U(F=>B(F)&&x.call(L,F),null,O))}v.filter=h;function t(U){return U}v.signal=t;function n(...U){return(B,x=null,L)=>(0,I.combinedDisposable)(...U.map(O=>O(F=>B.call(x,F),null,L)))}v.any=n;function s(U,B,x){let L=x;return u(U,O=>(L=B(L,O),L))}v.reduce=s;function i(U){let B;const x=new f({onFirstListenerAdd(){B=U(x.fire,x)},onLastListenerRemove(){B.dispose()}});return x.event}v.snapshot=i;function a(U,B,x=100,L=!1,O){let F,M,W,q=0;const K=new f({leakWarningThreshold:O,onFirstListenerAdd(){F=U(le=>{q++,M=B(M,le),L&&!W&&(K.fire(M),M=void 0),clearTimeout(W),W=setTimeout(()=>{const ve=M;M=void 0,W=void 0,(!L||q>1)&&K.fire(ve),q=0},x)})},onLastListenerRemove(){F.dispose()}});return K.event}v.debounce=a;function p(U){const B=new Date().getTime();return u(S(U),x=>new Date().getTime()-B)}v.stopwatch=p;function g(U,B=(x,L)=>x===L){let x=!0,L;return h(U,O=>{const F=x||!B(O,L);return x=!1,L=O,F})}v.latch=g;function _(U,B){return[v.filter(U,B),v.filter(U,x=>!B(x))]}v.split=_;function l(U,B=!1,x=[]){let L=x.slice(),O=U(W=>{L?L.push(W):M.fire(W)});const F=()=>{L&&L.forEach(W=>M.fire(W)),L=null},M=new f({onFirstListenerAdd(){O||(O=U(W=>M.fire(W)))},onFirstListenerDidAdd(){L&&(B?setTimeout(F):F())},onLastListenerRemove(){O&&O.dispose(),O=null}});return M.event}v.buffer=l;class w{constructor(B){this.event=B}map(B){return new w(u(this.event,B))}forEach(B){return new w(c(this.event,B))}filter(B){return new w(h(this.event,B))}reduce(B,x){return new w(s(this.event,B,x))}latch(){return new w(g(this.event))}debounce(B,x=100,L=!1,O){return new w(a(this.event,B,x,L,O))}on(B,x,L){return this.event(B,x,L)}once(B,x,L){return S(this.event)(B,x,L)}}function T(U){return new w(U)}v.chain=T;function N(U,B,x=L=>L){const L=(...W)=>M.fire(x(...W)),O=()=>U.on(B,L),F=()=>U.removeListener(B,L),M=new f({onFirstListenerAdd:O,onLastListenerRemove:F});return M.event}v.fromNodeEventEmitter=N;function z(U,B,x=L=>L){const L=(...W)=>M.fire(x(...W)),O=()=>U.addEventListener(B,L),F=()=>U.removeEventListener(B,L),M=new f({onFirstListenerAdd:O,onLastListenerRemove:F});return M.event}v.fromDOMEventEmitter=z;function ne(U){const B=new f;let x=!1;return U.then(void 0,()=>null).then(()=>{x?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),x=!0,B.event}v.fromPromise=ne;function ie(U){return new Promise(B=>S(U)(B))}v.toPromise=ie})(C=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let k=-1;function r(v){const S=k;return k=v,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=r;class P{constructor(S,u=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let u=k;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),!(u<=0||S<u)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),h=this._stacks.get(c)||0;if(this._stacks.set(c,h+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,n=0;for(const[s,i]of this._stacks)(!t||n<i)&&(t=s,n=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class f{constructor(S){var u;this._disposed=!1,this._options=S,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,u,c)=>{var h;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(u?[S,u]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,u);const s=(h=this._leakageMon)===null||h===void 0?void 0:h.check(this._listeners.size);let i;return i={dispose:()=>{s&&s(),i.dispose=f._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof I.DisposableStore?c.add(i):Array.isArray(c)&&c.push(i),i}),this._event}fire(S){var u,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let h of this._listeners)this._deliveryQueue.push([h,S]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[h,t]=this._deliveryQueue.shift();try{typeof h=="function"?h.call(void 0,t):h[0].call(h[1],t)}catch(n){(0,b.onUnexpectedError)(n)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var S,u,c,h;(S=this._listeners)===null||S===void 0||S.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),((c=this._options)===null||c===void 0?void 0:c.onLastListenerRemove)&&this._options.onLastListenerRemove(),(h=this._leakageMon)===null||h===void 0||h.dispose(),this._disposed=!0}}e.Emitter=f,f._noop=function(){};class m extends f{constructor(S){super(S);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=m;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const u={event:S,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const c=()=>{this.hasListeners&&this.unhook(u);const h=this.events.indexOf(u);this.events.splice(h,1)};return(0,I.toDisposable)((0,R.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(u=>this.emitter.fire(u))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class d{constructor(){this.buffers=[]}wrapEvent(S){return(u,c,h)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>u.call(c,t)):u.call(c,t)},void 0,h)}bufferEvents(S){const u=[];this.buffers.push(u);const c=S();return this.buffers.pop(),u.forEach(h=>h()),c}}e.EventBufferer=d;class E{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=I.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(C,D){const k=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(k)}}});var I;(function(C){function D(k){return k===C.None||k===C.Cancelled||k instanceof A?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(I=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=I.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=y}),define(me[46],ge([0,1,3]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(P){const f=this._icons.get(P.id);f?P.description?f.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new R;e.iconRegistry=I;function A(r,P){return new C(r,P)}e.registerCodicon=A;function y(r){return r?r.replace(/\$\((.*?)\)/g,(P,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=y;class C{constructor(P,f,m){this.id=P,this.definition=f,this.description=m,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(r,P){const f=["codicon","codicon-"+r];return P&&f.push("codicon-modifier-"+P),f}e.getClassNamesArray=D;var k;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function f(d){if(d instanceof C)return["codicon","codicon-"+d.id];const E=P.exec(d.id);if(!E)return f(C.error);let[,v,S]=E;const u=["codicon","codicon-"+v];return S&&u.push("codicon-modifier-"+S.substr(1)),u}r.asClassNameArray=f;function m(d){return f(d).join(" ")}r.asClassName=m;function o(d){return"."+f(d).join(".")}r.asCSSSelector=o})(k=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(me[94],ge([0,1,17,6]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(h=>typeof h=="function"):!1}e.isReadableStream=I;function A(u){const c=u;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(u,c){return new C(u,c)}e.newWriteableStream=y;class C{constructor(c,h){this.reducer=c,this.options=h,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var h;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((h=this.options)===null||h===void 0?void 0:h.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(h=>h(c))}emitError(c){this.listeners.error.length===0?(0,b.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(h=>h(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,h){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(h),this.resume();break;case"end":this.listeners.end.push(h),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(h),this.state.flowing&&this.flowErrors();break}}removeListener(c,h){if(!this.state.destroyed){let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(h);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const h=[...this.pendingWritePromises];this.pendingWritePromises.length=0,h.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(u,c){const h=[];let t;for(;(t=u.read())!==null;)h.push(t);return c(h)}e.consumeReadable=D;function k(u,c,h){const t=[];let n;for(;(n=u.read())!==null&&t.length<h;)t.push(n);return n===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return u.read()}}}e.peekReadable=k;function r(u,c){return new Promise((h,t)=>{const n=[];P(u,{onData:s=>{c&&n.push(s)},onError:s=>{c?t(s):h(void 0)},onEnd:()=>{h(c?c(n):void 0)}})})}e.consumeStream=r;function P(u,c){u.on("error",h=>c.onError(h)),u.on("end",()=>c.onEnd()),u.on("data",h=>c.onData(h))}e.listenStream=P;function f(u,c){return new Promise((h,t)=>{const n=new R.DisposableStore,s=[],i=g=>{if(s.push(g),s.length>c)return n.dispose(),u.pause(),h({stream:u,buffer:s,ended:!1})},a=g=>t(g),p=()=>h({stream:u,buffer:s,ended:!0});n.add((0,R.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),n.add((0,R.toDisposable)(()=>u.removeListener("end",p))),u.on("end",p),n.add((0,R.toDisposable)(()=>u.removeListener("data",i))),u.on("data",i)})}e.peekStream=f;function m(u,c){const h=y(c);return h.end(u),h}e.toStream=m;function o(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=o;function d(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=d;function E(u,c,h){const t=y(h);return P(u,{onData:n=>t.write(c.data(n)),onError:n=>t.error(c.error?c.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function v(u,c,h){let t=!1;return{read:()=>{const n=c.read();return t?n:(t=!0,n!==null?h([u,n]):u)}}}e.prefixedReadable=v;function S(u,c,h){let t=!1;const n=y(h);return P(c,{onData:s=>t?n.write(s):(t=!0,n.write(h([u,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(u)),n.end()}}),n}e.prefixedStream=S}),define(me[8],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=b;const R=/{(\d+)}/g;function I(H,...J){return J.length===0?H:H.replace(R,function(ce,Pe){const Ae=parseInt(Pe,10);return isNaN(Ae)||Ae<0||Ae>=J.length?ce:J[Ae]})}e.format=I;function A(H){return H.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}e.escape=A;function y(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function C(H,J){let ce=0;const Pe=J.charCodeAt(0);for(let Ae=H.length-1;Ae>=0;Ae--)H.charCodeAt(Ae)===Pe&&ce++;return ce}e.count=C;function D(H,J,ce="\u2026"){return H.length<=J?H:`${H.substr(0,J)}${ce}`}e.truncate=D;function k(H,J=" "){const ce=r(H,J);return P(ce,J)}e.trim=k;function r(H,J){if(!H||!J)return H;const ce=J.length;if(ce===0||H.length===0)return H;let Pe=0;for(;H.indexOf(J,Pe)===Pe;)Pe=Pe+ce;return H.substring(Pe)}e.ltrim=r;function P(H,J){if(!H||!J)return H;const ce=J.length,Pe=H.length;if(ce===0||Pe===0)return H;let Ae=Pe,Fe=-1;for(;Fe=H.lastIndexOf(J,Ae-1),!(Fe===-1||Fe+ce!==Ae);){if(Fe===0)return"";Ae=Fe}return H.substring(0,Ae)}e.rtrim=P;function f(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function m(H){return H.replace(/\*/g,"")}e.stripWildcards=m;function o(H,J,ce={}){if(!H)throw new Error("Cannot create regex from empty string");J||(H=y(H)),ce.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Pe="";return ce.global&&(Pe+="g"),ce.matchCase||(Pe+="i"),ce.multiline&&(Pe+="m"),ce.unicode&&(Pe+="u"),new RegExp(H,Pe)}e.createRegExp=o;function d(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function E(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function v(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=v;function S(H){return H.split(/\r\n|\r|\n/)}e.splitLines=S;function u(H){for(let J=0,ce=H.length;J<ce;J++){const Pe=H.charCodeAt(J);if(Pe!==32&&Pe!==9)return J}return-1}e.firstNonWhitespaceIndex=u;function c(H,J=0,ce=H.length){for(let Pe=J;Pe<ce;Pe++){const Ae=H.charCodeAt(Pe);if(Ae!==32&&Ae!==9)return H.substring(J,Pe)}return H.substring(J,ce)}e.getLeadingWhitespace=c;function h(H,J=H.length-1){for(let ce=J;ce>=0;ce--){const Pe=H.charCodeAt(ce);if(Pe!==32&&Pe!==9)return ce}return-1}e.lastNonWhitespaceIndex=h;function t(H,J){return H<J?-1:H>J?1:0}e.compare=t;function n(H,J,ce=0,Pe=H.length,Ae=0,Fe=J.length){for(;ce<Pe&&Ae<Fe;ce++,Ae++){let rt=H.charCodeAt(ce),tt=J.charCodeAt(Ae);if(rt<tt)return-1;if(rt>tt)return 1}const We=Pe-ce,Xe=Fe-Ae;return We<Xe?-1:We>Xe?1:0}e.compareSubstring=n;function s(H,J){return i(H,J,0,H.length,0,J.length)}e.compareIgnoreCase=s;function i(H,J,ce=0,Pe=H.length,Ae=0,Fe=J.length){for(;ce<Pe&&Ae<Fe;ce++,Ae++){let rt=H.charCodeAt(ce),tt=J.charCodeAt(Ae);if(rt!==tt){const Qe=rt-tt;if(!(Qe===32&&p(tt))&&!(Qe===-32&&p(rt)))return a(rt)&&a(tt)?Qe:n(H.toLowerCase(),J.toLowerCase(),ce,Pe,Ae,Fe)}}const We=Pe-ce,Xe=Fe-Ae;return We<Xe?-1:We>Xe?1:0}e.compareSubstringIgnoreCase=i;function a(H){return H>=97&&H<=122}e.isLowerAsciiLetter=a;function p(H){return H>=65&&H<=90}e.isUpperAsciiLetter=p;function g(H){return a(H)||p(H)}function _(H,J){return H.length===J.length&&l(H,J)}e.equalsIgnoreCase=_;function l(H,J,ce=H.length){for(let Pe=0;Pe<ce;Pe++){const Ae=H.charCodeAt(Pe),Fe=J.charCodeAt(Pe);if(Ae!==Fe){if(g(Ae)&&g(Fe)){const We=Math.abs(Ae-Fe);if(We!==0&&We!==32)return!1}else if(String.fromCharCode(Ae).toLowerCase()!==String.fromCharCode(Fe).toLowerCase())return!1}}return!0}function w(H,J){const ce=J.length;return J.length>H.length?!1:l(H,J,ce)}e.startsWithIgnoreCase=w;function T(H,J){let ce,Pe=Math.min(H.length,J.length);for(ce=0;ce<Pe;ce++)if(H.charCodeAt(ce)!==J.charCodeAt(ce))return ce;return Pe}e.commonPrefixLength=T;function N(H,J){let ce,Pe=Math.min(H.length,J.length);const Ae=H.length-1,Fe=J.length-1;for(ce=0;ce<Pe;ce++)if(H.charCodeAt(Ae-ce)!==J.charCodeAt(Fe-ce))return ce;return Pe}e.commonSuffixLength=N;function z(H){return 55296<=H&&H<=56319}e.isHighSurrogate=z;function ne(H){return 56320<=H&&H<=57343}e.isLowSurrogate=ne;function ie(H,J){return(H-55296<<10)+(J-56320)+65536}e.computeCodePoint=ie;function U(H,J,ce){const Pe=H.charCodeAt(ce);if(z(Pe)&&ce+1<J){const Ae=H.charCodeAt(ce+1);if(ne(Ae))return ie(Pe,Ae)}return Pe}e.getNextCodePoint=U;function B(H,J){const ce=H.charCodeAt(J-1);if(ne(ce)&&J>1){const Pe=H.charCodeAt(J-2);if(z(Pe))return ie(Pe,ce)}return ce}function x(H,J){const ce=Ve.getInstance(),Pe=J,Ae=H.length,Fe=U(H,Ae,J);J+=Fe>=65536?2:1;let We=ce.getGraphemeBreakType(Fe);for(;J<Ae;){const Xe=U(H,Ae,J),rt=ce.getGraphemeBreakType(Xe);if(xe(We,rt))break;J+=Xe>=65536?2:1,We=rt}return J-Pe}e.nextCharLength=x;function L(H,J){const ce=Ve.getInstance(),Pe=J,Ae=B(H,J);J-=Ae>=65536?2:1;let Fe=ce.getGraphemeBreakType(Ae);for(;J>0;){const We=B(H,J),Xe=ce.getGraphemeBreakType(We);if(xe(Xe,Fe))break;J-=We>=65536?2:1,Fe=Xe}return Pe-J}e.prevCharLength=L;function O(H,J){const ce=Ve.getInstance(),Pe=H.length,Ae=J,Fe=U(H,Pe,J),We=ce.getGraphemeBreakType(Fe);J+=Fe>=65536?2:1;let Xe=We;for(;J<Pe;){const tt=U(H,Pe,J),Qe=ce.getGraphemeBreakType(tt);if(xe(Xe,Qe))break;J+=tt>=65536?2:1,Xe=Qe}const rt=J;for(J=Ae,Xe=We;J>0;){const tt=B(H,J),Qe=ce.getGraphemeBreakType(tt);if(xe(Qe,Xe))break;J-=tt>=65536?2:1,Xe=Qe}return[J,rt]}function F(H,J){return J>0&&ne(H.charCodeAt(J))?O(H,J-1):O(H,J)}e.getCharContainingOffset=F;function M(H){const J=H.length;let ce=0,Pe=0;for(;Pe<J;){const We=U(H,J,Pe);Pe+=We>=65536?2:1,We<128?ce+=1:We<2048?ce+=2:We<65536?ce+=3:ce+=4}const Ae=new Uint8Array(ce);Pe=0;let Fe=0;for(;Pe<J;){const We=U(H,J,Pe);Pe+=We>=65536?2:1,We<128?Ae[Fe++]=We:We<2048?(Ae[Fe++]=192|(We&1984)>>>6,Ae[Fe++]=128|(We&63)>>>0):We<65536?(Ae[Fe++]=224|(We&61440)>>>12,Ae[Fe++]=128|(We&4032)>>>6,Ae[Fe++]=128|(We&63)>>>0):(Ae[Fe++]=240|(We&1835008)>>>18,Ae[Fe++]=128|(We&258048)>>>12,Ae[Fe++]=128|(We&4032)>>>6,Ae[Fe++]=128|(We&63)>>>0)}return Ae}e.encodeUTF8=M;function W(H){const J=H.byteLength,ce=[];let Pe=0;for(;Pe<J;){const Ae=H[Pe];let Fe;if(Ae>=240&&Pe+3<J?Fe=(H[Pe++]&7)<<18>>>0|(H[Pe++]&63)<<12>>>0|(H[Pe++]&63)<<6>>>0|(H[Pe++]&63)<<0>>>0:Ae>=224&&Pe+2<J?Fe=(H[Pe++]&15)<<12>>>0|(H[Pe++]&63)<<6>>>0|(H[Pe++]&63)<<0>>>0:Ae>=192&&Pe+1<J?Fe=(H[Pe++]&31)<<6>>>0|(H[Pe++]&63)<<0>>>0:Fe=H[Pe++],Fe>=0&&Fe<=55295||Fe>=57344&&Fe<=65535)ce.push(String.fromCharCode(Fe));else if(Fe>=65536&&Fe<=1114111){const We=Fe-65536,Xe=55296+((We&1047552)>>>10),rt=56320+((We&1023)>>>0);ce.push(String.fromCharCode(Xe)),ce.push(String.fromCharCode(rt))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=W;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(H){return q.test(H)}e.containsRTL=K;const le=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(H){return le.test(H)}e.containsEmoji=ve;const Re=/^[\t\n\r\x20-\x7E]*$/;function Se(H){return Re.test(H)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Oe;function V(H){for(let J=0,ce=H.length;J<ce;J++)if(X(H.charCodeAt(J)))return!0;return!1}e.containsFullWidthCharacter=V;function X(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=X;function Z(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=Z;function se(H,J){if(H.length<J)return H;const ce=/\b/g;let Pe=0;for(;ce.test(H)&&!(H.length-ce.lastIndex<J);)Pe=ce.lastIndex,ce.lastIndex+=1;return H.substring(Pe).replace(/^\s/,"")}e.lcut=se;const fe=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,Be=/\x1b\[0?m/g;function pe(H){return H&&(H=H.replace(fe,""),H=H.replace(Ee,""),H=H.replace(Be,"")),H}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Me(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Me;function ze(H,J){if(!H||!J||H.length<J.length)return!1;const ce=J.length,Pe=H.toLowerCase();let Ae=0,Fe=-1;for(;Ae<ce;){const We=Pe.indexOf(J[Ae],Fe+1);if(We<0)return!1;Fe=We,Ae++}return!0}e.fuzzyContains=ze;function _e(H,J=!1){return H?(J&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=_e;function Ke(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Ke;function G(H,J=1){if(J===0)return"";let ce=-1;do ce=H.indexOf(`
`,ce+1),J--;while(J>0&&ce>=0);return ce===-1?H:(H[ce-1]==="\r"&&ce--,H.substr(0,ce))}e.getNLines=G;function te(H){const J=90-65+1;return H=H%(2*J),H<J?String.fromCharCode(97+H):String.fromCharCode(65+H-J)}e.singleLetterHash=te;function we(H){return Ve.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=we;function xe(H,J){return H===0?J!==5&&J!==7:H===2&&J===3?!1:H===4||H===2||H===3||J===4||J===2||J===3?!0:!(H===8&&(J===8||J===9||J===11||J===12)||(H===11||H===9)&&(J===9||J===10)||(H===12||H===10)&&J===10||J===5||J===13||J===7||H===1||H===13&&J===14||H===6&&J===6)}e.breakBetweenGraphemeBreakType=xe;var je;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ve{constructor(){this._data=Je()}static getInstance(){return Ve._INSTANCE||(Ve._INSTANCE=new Ve),Ve._INSTANCE}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const ce=this._data,Pe=ce.length/3;let Ae=1;for(;Ae<=Pe;)if(J<ce[3*Ae])Ae=2*Ae;else if(J>ce[3*Ae+1])Ae=2*Ae+1;else return ce[3*Ae+2];return 0}}Ve._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(H,J){if(H===0)return 0;const ce=ye(H,J);if(ce!==void 0)return ce;const Pe=B(J,H);return H-=Ie(Pe),H}e.getLeftDeleteOffset=De;function ye(H,J){let ce=B(J,H);for(H-=Ie(ce);oe(ce)||ce===65039||ce===8419;){if(H===0)return;ce=B(J,H),H-=Ie(ce)}if(!!Z(ce)){if(H>=0){const Pe=B(J,H);Pe===8205&&(H-=Ie(Pe))}return H}}function Ie(H){return H>=65536?2:1}function oe(H){return 127995<=H&&H<=127999}var ue;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(ue||(ue={}))}),define(me[23],ge([0,1,8,94]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let C,D;class k{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return I?new k(Buffer.allocUnsafe(g)):new k(new Uint8Array(g))}static wrap(g){return I&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new k(g)}static fromString(g,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&I?new k(Buffer.from(g)):A?(C||(C=new TextEncoder),new k(C.encode(g))):new k(b.encodeUTF8(g))}static concat(g,_){if(typeof _=="undefined"){_=0;for(let T=0,N=g.length;T<N;T++)_+=g[T].byteLength}const l=k.alloc(_);let w=0;for(let T=0,N=g.length;T<N;T++){const z=g[T];l.set(z,w),w+=z.byteLength}return l}toString(){return I?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(g,_){return new k(this.buffer.subarray(g,_))}set(g,_){g instanceof k?this.buffer.set(g.buffer,_):this.buffer.set(g,_)}readUInt32BE(g){return f(this.buffer,g)}writeUInt32BE(g,_){m(this.buffer,g,_)}readUInt32LE(g){return o(this.buffer,g)}writeUInt32LE(g,_){d(this.buffer,g,_)}readUInt8(g){return E(this.buffer,g)}writeUInt8(g,_){v(this.buffer,g,_)}}e.VSBuffer=k;function r(p,g){return p[g+0]<<0>>>0|p[g+1]<<8>>>0}e.readUInt16LE=r;function P(p,g,_){p[_+0]=g&255,g=g>>>8,p[_+1]=g&255}e.writeUInt16LE=P;function f(p,g){return p[g]*2**24+p[g+1]*2**16+p[g+2]*2**8+p[g+3]}e.readUInt32BE=f;function m(p,g,_){p[_+3]=g,g=g>>>8,p[_+2]=g,g=g>>>8,p[_+1]=g,g=g>>>8,p[_]=g}e.writeUInt32BE=m;function o(p,g){return p[g+0]<<0>>>0|p[g+1]<<8>>>0|p[g+2]<<16>>>0|p[g+3]<<24>>>0}e.readUInt32LE=o;function d(p,g,_){p[_+0]=g&255,g=g>>>8,p[_+1]=g&255,g=g>>>8,p[_+2]=g&255,g=g>>>8,p[_+3]=g&255}e.writeUInt32LE=d;function E(p,g){return p[g]}e.readUInt8=E;function v(p,g,_){p[_]=g}e.writeUInt8=v;function S(p){return R.consumeReadable(p,g=>k.concat(g))}e.readableToBuffer=S;function u(p){return R.toReadable(p)}e.bufferToReadable=u;function c(p){return R.consumeStream(p,g=>k.concat(g))}e.streamToBuffer=c;async function h(p){return p.ended?k.concat(p.buffer):k.concat([...p.buffer,await c(p.stream)])}e.bufferedStreamToBuffer=h;function t(p){return R.toStream(p,g=>k.concat(g))}e.bufferToStream=t;function n(p){return R.transform(p,{data:g=>typeof g=="string"?k.fromString(g):k.wrap(g)},g=>k.concat(g))}e.streamToBufferReadableStream=n;function s(p){return R.newWriteableStream(g=>k.concat(g),p)}e.newWriteableBufferStream=s;function i(p,g){return R.prefixedReadable(p,g,_=>k.concat(_))}e.prefixedBufferReadable=i;function a(p,g){return R.prefixedStream(p,g,_=>k.concat(_))}e.prefixedBufferStream=a}),define(me[75],ge([0,1,8]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(v){return I(v,0)}e.hash=R;function I(v,S){switch(typeof v){case"object":return v===null?A(349,S):Array.isArray(v)?D(v,S):k(v,S);case"string":return C(v,S);case"boolean":return y(v,S);case"number":return A(v,S);case"undefined":return A(937,S);default:return A(617,S)}}e.doHash=I;function A(v,S){return(S<<5)-S+v|0}function y(v,S){return A(v?433:863,S)}function C(v,S){S=A(149417,S);for(let u=0,c=v.length;u<c;u++)S=A(v.charCodeAt(u),S);return S}e.stringHash=C;function D(v,S){return S=A(104579,S),v.reduce((u,c)=>I(c,u),S)}function k(v,S){return S=A(181387,S),Object.keys(v).sort().reduce((u,c)=>(u=C(c,u),I(v[c],u)),S)}class r{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=I(S,this._value),this._value}}e.Hasher=r;var P;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function f(v,S,u=32){const c=u-S,h=~((1<<c)-1);return(v<<S|(h&v)>>>c)>>>0}function m(v,S=0,u=v.byteLength,c=0){for(let h=0;h<u;h++)v[S+h]=c}function o(v,S,u="0"){for(;v.length<S;)v=u+v;return v}function d(v,S=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(u=>u.toString(16).padStart(2,"0")).join(""):o((v>>>0).toString(16),S/4)}e.toHexString=d;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const u=S.length;if(u!==0){const c=this._buff;let h=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=S.charCodeAt(0),s=0);;){let i=n;if(b.isHighSurrogate(n))if(s+1<u){const a=S.charCodeAt(s+1);b.isLowSurrogate(a)?(s++,i=b.computeCodePoint(n,a)):i=65533}else{t=n;break}else b.isLowSurrogate(n)&&(i=65533);if(h=this._push(c,h,i),s++,s<u)n=S.charCodeAt(s);else break}this._buffLen=h,this._leftoverHighSurrogate=t}}_push(S,u,c){return c<128?S[u++]=c:c<2048?(S[u++]=192|(c&1984)>>>6,S[u++]=128|(c&63)>>>0):c<65536?(S[u++]=224|(c&61440)>>>12,S[u++]=128|(c&4032)>>>6,S[u++]=128|(c&63)>>>0):(S[u++]=240|(c&1835008)>>>18,S[u++]=128|(c&258048)>>>12,S[u++]=128|(c&4032)>>>6,S[u++]=128|(c&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=E._bigBlock32,u=this._buffDV;for(let g=0;g<64;g+=4)S.setUint32(g,u.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)S.setUint32(g,f(S.getUint32(g-12,!1)^S.getUint32(g-32,!1)^S.getUint32(g-56,!1)^S.getUint32(g-64,!1),1),!1);let c=this._h0,h=this._h1,t=this._h2,n=this._h3,s=this._h4,i,a,p;for(let g=0;g<80;g++)g<20?(i=h&t|~h&n,a=1518500249):g<40?(i=h^t^n,a=1859775393):g<60?(i=h&t|h&n|t&n,a=2400959708):(i=h^t^n,a=3395469782),p=f(c,5)+i+s+a+S.getUint32(g*4,!1)&4294967295,s=n,n=t,t=f(h,30),h=c,c=p;this._h0=this._h0+c&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[58],ge([0,1,8]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(R||(R={})),function(I){const A="error",y="warning",C="warn",D="info",k="ignore";function r(f){return f?b.equalsIgnoreCase(A,f)?I.Error:b.equalsIgnoreCase(y,f)||b.equalsIgnoreCase(C,f)?I.Warning:b.equalsIgnoreCase(D,f)?I.Info:I.Ignore:I.Ignore}I.fromValue=r;function P(f){switch(f){case I.Error:return A;case I.Warning:return y;case I.Info:return D;default:return k}}I.toString=P}(R||(R={})),e.default=R}),define(me[11],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(g){return Array.isArray(g)}e.isArray=b;function R(g){return typeof g=="string"}e.isString=R;function I(g){return Array.isArray(g)&&g.every(_=>R(_))}e.isStringArray=I;function A(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=A;function y(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=y;function C(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=C;function D(g){return g===!0||g===!1}e.isBoolean=D;function k(g){return typeof g=="undefined"}e.isUndefined=k;function r(g){return!P(g)}e.isDefined=r;function P(g){return k(g)||g===null}e.isUndefinedOrNull=P;function f(g,_){if(!g)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=f;function m(g){if(P(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=m;function o(...g){const _=[];for(let l=0;l<g.length;l++){const w=g[l];if(P(w))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);_.push(w)}return _}e.assertAllDefined=o;const d=Object.prototype.hasOwnProperty;function E(g){if(!A(g))return!1;for(let _ in g)if(d.call(g,_))return!1;return!0}e.isEmptyObject=E;function v(g){return typeof g=="function"}e.isFunction=v;function S(...g){return g.length>0&&g.every(v)}e.areFunctions=S;function u(g,_){const l=Math.min(g.length,_.length);for(let w=0;w<l;w++)c(g[w],_[w])}e.validateConstraints=u;function c(g,_){if(R(_)){if(typeof g!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(v(_)){try{if(g instanceof _)return}catch(l){}if(!P(g)&&g.constructor===_||_.length===1&&_.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function h(g){let _=[],l=Object.getPrototypeOf(g);for(;Object.prototype!==l;)_=_.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return _}e.getAllPropertyNames=h;function t(g){const _=[];for(const l of h(g))typeof g[l]=="function"&&_.push(l);return _}e.getAllMethodNames=t;function n(g,_){const l=T=>function(){const N=Array.prototype.slice.call(arguments,0);return _(T,N)};let w={};for(const T of g)w[T]=l(T);return w}e.createProxyObject=n;function s(g){return g===null?void 0:g}e.withNullAsUndefined=s;function i(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=i;function a(g){return class{constructor(){return new Proxy({},{get(_,l){if(_[l])return _[l];throw new Error(`Not Implemented: ${g}->${String(l)}`)}})}}}e.NotImplementedProxy=a;function p(g){throw new Error("Unreachable")}e.assertNever=p}),define(me[29],ge([0,1,10,8,9,11]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function C(s){return s.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=C;function D(s){return s.indexOf("/")===-1&&(s=C(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=D;function k(s,i=I.posix.sep){if(!s)return"";const a=s.length,p=s.charCodeAt(0);if(y(p)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let _=3;const l=_;for(;_<a&&!y(s.charCodeAt(_));_++);if(l!==_&&!y(s.charCodeAt(_+1))){for(_+=1;_<a;_++)if(y(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,i)}}return i}else if(v(p)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let g=s.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(y(s.charCodeAt(g)))return s.slice(0,g+1)}return""}e.getRoot=k;function r(s){if(!b.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let a=2;const p=a;for(;a<s.length&&(i=s.charCodeAt(a),i!==92);a++);return!(p===a||(i=s.charCodeAt(a+1),isNaN(i)||i===92))}e.isUNC=r;const P=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(s,i=b.isWindows){const a=i?P:f;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||i&&m.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=o;function d(s,i,a){const p=s===i;return!a||p?p:!s||!i?!1:(0,R.equalsIgnoreCase)(s,i)}e.isEqual=d;function E(s,i,a,p=I.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let _=i.length;return i.charAt(i.length-1)===p&&_--,s.charAt(_)===p}return i.charAt(i.length-1)!==p&&(i+=p),s.indexOf(i)===0}e.isEqualOrParent=E;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function S(s,i){return b.isWindows&&s.endsWith(":")&&(s+=I.sep),(0,I.isAbsolute)(s)||(s=(0,I.join)(i,s)),s=(0,I.normalize)(s),b.isWindows?(s=(0,R.rtrim)(s,I.sep),s.endsWith(":")&&(s+=I.sep)):(s=(0,R.rtrim)(s,I.sep),s||(s=I.sep)),s}e.sanitizeFilePath=S;function u(s){const i=(0,I.normalize)(s);return b.isWindows?s.length>3?!1:c(i)&&(s.length===2||i.charCodeAt(2)===92):i===I.posix.sep}e.isRootOrDriveLetter=u;function c(s){return b.isWindows?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function h(s){return c(s)?s[0]:void 0}e.getDriveLetter=h;function t(s,i,a){return i.length>s.length?-1:s===i?0:(a&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function n(s){const i=s.split(":");let a,p,g;if(i.forEach(_=>{const l=Number(_);(0,A.isNumber)(l)?p===void 0?p=l:g===void 0&&(g=l):a=a?[a,_].join(":"):_}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:p!==void 0?p:void 0,column:g!==void 0?g:p!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(me[24],ge([0,1,11]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const E=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?E[v]=R(d[v]):E[v]=d[v]}),E}e.deepClone=R;function I(d){if(!d||typeof d!="object")return d;const E=[d];for(;E.length>0;){const v=E.shift();Object.freeze(v);for(const S in v)if(A.call(v,S)){const u=v[S];typeof u=="object"&&!Object.isFrozen(u)&&E.push(u)}}return d}e.deepFreeze=I;const A=Object.prototype.hasOwnProperty;function y(d,E){return C(d,E,new Set)}e.cloneAndChange=y;function C(d,E,v){if((0,b.isUndefinedOrNull)(d))return d;const S=E(d);if(typeof S!="undefined")return S;if((0,b.isArray)(d)){const u=[];for(const c of d)u.push(C(c,E,v));return u}if((0,b.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const u={};for(let c in d)A.call(d,c)&&(u[c]=C(d[c],E,v));return v.delete(d),u}return d}function D(d,E,v=!0){return(0,b.isObject)(d)?((0,b.isObject)(E)&&Object.keys(E).forEach(S=>{S in d?v&&((0,b.isObject)(d[S])&&(0,b.isObject)(E[S])?D(d[S],E[S],v):d[S]=E[S]):d[S]=E[S]}),d):E}e.mixin=D;function k(d,E){if(d===E)return!0;if(d==null||E===null||E===void 0||typeof d!=typeof E||typeof d!="object"||Array.isArray(d)!==Array.isArray(E))return!1;let v,S;if(Array.isArray(d)){if(d.length!==E.length)return!1;for(v=0;v<d.length;v++)if(!k(d[v],E[v]))return!1}else{const u=[];for(S in d)u.push(S);u.sort();const c=[];for(S in E)c.push(S);if(c.sort(),!k(u,c))return!1;for(v=0;v<u.length;v++)if(!k(d[u[v]],E[u[v]]))return!1}return!0}e.equals=k;function r(d){const E=new Set;return JSON.stringify(d,(v,S)=>{if((0,b.isObject)(S)||Array.isArray(S)){if(E.has(S))return"[Circular]";E.add(S)}return S})}e.safeStringify=r;function P(d,E,v){const S=E(d);return typeof S=="undefined"?v:S}e.getOrDefault=P;function f(d,E){const v=Object.create(null);return!d||!E||Object.keys(E).forEach(u=>{const c=d[u],h=E[u];k(c,h)||(v[u]=h)}),v}e.distinct=f;function m(d,E){const v=E.toLowerCase(),S=Object.keys(d).find(u=>u.toLowerCase()===v);return S?d[S]:d[E]}e.getCaseInsensitive=m;function o(d,E){const v=Object.create(null);for(const S of Object.keys(d))E(S,d[S])&&(v[S]=d[S]);return v}e.filter=o}),define(me[95],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function R(A){return A<0?0:A>255?255:A|0}e.toUint8=R;function I(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=I}),define(me[2],ge([0,1,10,9]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function C(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!I.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,i){return!s&&!i?"file":s}function k(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==P&&(i=P+i):i=P;break}return i}const r="",P="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(i,a,p,g,_,l=!1){typeof i=="object"?(this.scheme=i.scheme||r,this.authority=i.authority||r,this.path=i.path||r,this.query=i.query||r,this.fragment=i.fragment||r):(this.scheme=D(i,l),this.authority=a||r,this.path=k(this.scheme,p||r),this.query=g||r,this.fragment=_||r,C(this,l))}static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:p,path:g,query:_,fragment:l}=i;return a===void 0?a=this.scheme:a===null&&(a=r),p===void 0?p=this.authority:p===null&&(p=r),g===void 0?g=this.path:g===null&&(g=r),_===void 0?_=this.query:_===null&&(_=r),l===void 0?l=this.fragment:l===null&&(l=r),a===this.scheme&&p===this.authority&&g===this.path&&_===this.query&&l===this.fragment?this:new d(a,p,g,_,l)}static parse(i,a=!1){const p=f.exec(i);return p?new d(p[2]||r,n(p[4]||r),n(p[5]||r),n(p[7]||r),n(p[9]||r),a):new d(r,r,r,r,r)}static file(i){let a=r;if(b.isWindows&&(i=i.replace(/\\/g,P)),i[0]===P&&i[1]===P){const p=i.indexOf(P,2);p===-1?(a=i.substring(2),i=P):(a=i.substring(2,p),i=i.substring(p)||P)}return new d("file",a,i,r,r)}static from(i){return new d(i.scheme,i.authority,i.path,i.query,i.fragment)}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return b.isWindows&&i.scheme==="file"?p=m.file(R.win32.join(u(i,!0),...a)).path:p=R.posix.join(i.path,...a),i.with({path:p})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const a=new d(i);return a._formatted=i.external,a._fsPath=i._sep===o?i.fsPath:null,a}}else return i}}e.URI=m;const o=b.isWindows?1:void 0;class d extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=o),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,i){let a,p=-1;for(let g=0;g<s.length;g++){const _=s.charCodeAt(g);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||i&&_===47)p!==-1&&(a+=encodeURIComponent(s.substring(p,g)),p=-1),a!==void 0&&(a+=s.charAt(g));else{a===void 0&&(a=s.substr(0,g));const l=E[_];l!==void 0?(p!==-1&&(a+=encodeURIComponent(s.substring(p,g)),p=-1),a+=l):p===-1&&(p=g)}}return p!==-1&&(a+=encodeURIComponent(s.substring(p))),a!==void 0?a:s}function S(s){let i;for(let a=0;a<s.length;a++){const p=s.charCodeAt(a);p===35||p===63?(i===void 0&&(i=s.substr(0,a)),i+=E[p]):i!==void 0&&(i+=s[a])}return i!==void 0?i:s}function u(s,i){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,b.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=u;function c(s,i){const a=i?S:v;let p="",{scheme:g,authority:_,path:l,query:w,fragment:T}=s;if(g&&(p+=g,p+=":"),(_||g==="file")&&(p+=P,p+=P),_){let N=_.indexOf("@");if(N!==-1){const z=_.substr(0,N);_=_.substr(N+1),N=z.indexOf(":"),N===-1?p+=a(z,!1):(p+=a(z.substr(0,N),!1),p+=":",p+=a(z.substr(N+1),!1)),p+="@"}_=_.toLowerCase(),N=_.indexOf(":"),N===-1?p+=a(_,!1):(p+=a(_.substr(0,N),!1),p+=_.substr(N))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const N=l.charCodeAt(1);N>=65&&N<=90&&(l=`/${String.fromCharCode(N+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const N=l.charCodeAt(0);N>=65&&N<=90&&(l=`${String.fromCharCode(N+32)}:${l.substr(2)}`)}p+=a(l,!0)}return w&&(p+="?",p+=a(w,!1)),T&&(p+="#",p+=i?T:v(T,!1)),p}function h(s){try{return decodeURIComponent(s)}catch(i){return s.length>3?s.substr(0,3)+h(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,i=>h(i)):s}});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)};define(me[22],ge([0,1,2,8]),function(Q,e,b,R){"use strict";var I,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,n,s){let i=t.get(n);return i===void 0&&(i=s,t.set(n,i)),i}e.getOrSet=C;function D(t){const n=[];return t.forEach((s,i)=>{n.push(`${i} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function k(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class r{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=r;class P{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class f{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class o{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,R.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new o(n))}static forPaths(){return new E(new f)}static forStrings(){return new E(new r)}static forConfigKeys(){return new E(new P)}clear(){this._root=void 0}set(n,s){const i=this._iter.reset(n);let a;for(this._root||(this._root=new d,this._root.segment=i.value()),a=this._root;;){const g=i.cmp(a.segment);if(g>0)a.left||(a.left=new d,a.left.segment=i.value()),a=a.left;else if(g<0)a.right||(a.right=new d,a.right.segment=i.value()),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new d,a.mid.segment=i.value()),a=a.mid;else break}const p=a.value;return a.value=s,a.key=n,p}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let i=this._root;for(;i;){const a=s.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const i=this._iter.reset(n),a=[];let p=this._root;for(;p;){const g=i.cmp(p.segment);if(g>0)a.push([1,p]),p=p.left;else if(g<0)a.push([-1,p]),p=p.right;else if(i.hasNext())i.next(),a.push([0,p]),p=p.mid;else{for(s?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;a.length>0&&p.isEmpty();){let[_,l]=a.pop();switch(_){case 1:l.left=void 0;break;case 0:l.mid=void 0;break;case-1:l.right=void 0;break}p=l}break}}}findSubstr(n){const s=this._iter.reset(n);let i=this._root,a;for(;i;){const p=s.cmp(i.segment);if(p>0)i=i.left;else if(p<0)i=i.right;else if(s.hasNext())s.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(n){const s=this._iter.reset(n);let i=this._root;for(;i;){const a=s.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(n){for(const[s,i]of this)n(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class v{constructor(n,s){this[I]="ResourceMap",n instanceof v?(this.map=new Map(n.map),this.toKey=s!=null?s:v.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:v.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[i,a]of this.map)n(a,b.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield b.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[b.URI.parse(n[0]),n[1]]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[b.URI.parse(n[0]),n[1]]}}e.ResourceMap=v,v.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class u{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const i=this._map.get(n);if(!!i)return s!==0&&this.touch(i,s),i.value}set(n,s,i=0){let a=this._map.get(n);if(a)a.value=s,i!==0&&this.touch(a,i);else{switch(a={key:n,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const i=this._state;let a=this._head;for(;a;){if(s?n.bind(s)(a.value,a.key,this):n(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,s=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:i.key,done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return a}values(){const n=this,s=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:i.value,done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return a}entries(){const n=this,s=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:[i.key,i.value],done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>n;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,i=n.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const i=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const i=n.next,a=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,i)=>{n.push([i,s])}),n}fromJSON(n){this.clear();for(const[s,i]of n)this.set(s,i)}}e.LinkedMap=u;class c extends u{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class h{constructor(n){y.set(this,void 0),it(this,y,n,"f")}get size(){return $e(this,y,"f").size}forEach(n,s){$e(this,y,"f").forEach(n,s)}get(n){return $e(this,y,"f").get(n)}has(n){return $e(this,y,"f").has(n)}entries(){return $e(this,y,"f").entries()}keys(){return $e(this,y,"f").keys()}values(){return $e(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return $e(this,y,"f").entries()}}e.ReadonlyMapView=h}),define(me[96],ge([0,1,22,8]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...pe){return function(Ce,Me){for(let ze=0,_e=pe.length;ze<_e;ze++){const Ke=pe[ze](Ce,Me);if(Ke)return Ke}return null}}e.or=I,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(pe,Ce,Me){if(!Me||Me.length<Ce.length)return null;let ze;return pe?ze=R.startsWithIgnoreCase(Me,Ce):ze=Me.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function y(pe,Ce){const Me=Ce.toLowerCase().indexOf(pe.toLowerCase());return Me===-1?null:[{start:Me,end:Me+pe.length}]}e.matchesContiguousSubString=y;function C(pe,Ce){return D(pe.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=C;function D(pe,Ce,Me,ze){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(pe[Me]===Ce[ze]){let _e=null;return(_e=D(pe,Ce,Me+1,ze+1))?v({start:ze,end:ze+1},_e):null}return D(pe,Ce,Me,ze+1)}function k(pe){return 97<=pe&&pe<=122}function r(pe){return 65<=pe&&pe<=90}e.isUpper=r;function P(pe){return 48<=pe&&pe<=57}function f(pe){return pe===32||pe===9||pe===10||pe===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(pe=>m.add(pe.charCodeAt(0)));function o(pe){return f(pe)||m.has(pe)}function d(pe,Ce){return pe===Ce||o(pe)&&o(Ce)}function E(pe){return k(pe)||r(pe)||P(pe)}function v(pe,Ce){return Ce.length===0?Ce=[pe]:pe.end===Ce[0].start?Ce[0].start=pe.start:Ce.unshift(pe),Ce}function S(pe,Ce){for(let Me=Ce;Me<pe.length;Me++){const ze=pe.charCodeAt(Me);if(r(ze)||P(ze)||Me>0&&!E(pe.charCodeAt(Me-1)))return Me}return pe.length}function u(pe,Ce,Me,ze){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(pe[Me]!==Ce[ze].toLowerCase())return null;{let _e=null,Ke=ze+1;for(_e=u(pe,Ce,Me+1,ze+1);!_e&&(Ke=S(Ce,Ke))<Ce.length;)_e=u(pe,Ce,Me+1,Ke),Ke++;return _e===null?null:v({start:ze,end:ze+1},_e)}}function c(pe){let Ce=0,Me=0,ze=0,_e=0,Ke=0;for(let je=0;je<pe.length;je++)Ke=pe.charCodeAt(je),r(Ke)&&Ce++,k(Ke)&&Me++,E(Ke)&&ze++,P(Ke)&&_e++;const G=Ce/pe.length,te=Me/pe.length,we=ze/pe.length,xe=_e/pe.length;return{upperPercent:G,lowerPercent:te,alphaPercent:we,numericPercent:xe}}function h(pe){const{upperPercent:Ce,lowerPercent:Me}=pe;return Me===0&&Ce>.6}function t(pe){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:ze,numericPercent:_e}=pe;return Me>.2&&Ce<.8&&ze>.6&&_e<.2}function n(pe){let Ce=0,Me=0,ze=0,_e=0;for(let Ke=0;Ke<pe.length;Ke++)ze=pe.charCodeAt(Ke),r(ze)&&Ce++,k(ze)&&Me++,f(ze)&&_e++;return(Ce===0||Me===0)&&_e===0?pe.length<=30:Ce<=5}function s(pe,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(pe)||Ce.length>60)return null;const Me=c(Ce);if(!t(Me)){if(!h(Me))return null;Ce=Ce.toLowerCase()}let ze=null,_e=0;for(pe=pe.toLowerCase();_e<Ce.length&&(ze=u(pe,Ce,0,_e))===null;)_e=S(Ce,_e+1);return ze}e.matchesCamelCase=s;function i(pe,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let ze=null,_e=0;for(pe=pe.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&(ze=a(pe,Ce,0,_e,Me))===null;)_e=p(Ce,_e+1);return ze}e.matchesWords=i;function a(pe,Ce,Me,ze,_e){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(d(pe.charCodeAt(Me),Ce.charCodeAt(ze))){let Ke=null,G=ze+1;if(Ke=a(pe,Ce,Me+1,ze+1,_e),!_e)for(;!Ke&&(G=p(Ce,G))<Ce.length;)Ke=a(pe,Ce,Me+1,G,_e),G++;return Ke===null?null:v({start:ze,end:ze+1},Ke)}else return null}function p(pe,Ce){for(let Me=Ce;Me<pe.length;Me++)if(o(pe.charCodeAt(Me))||Me>0&&o(pe.charCodeAt(Me-1)))return Me;return pe.length}const g=I(e.matchesPrefix,s,y),_=I(e.matchesPrefix,s,C),l=new b.LRUCache(1e4);function w(pe,Ce,Me=!1){if(typeof pe!="string"||typeof Ce!="string")return null;let ze=l.get(pe);ze||(ze=new RegExp(R.convertSimple2RegExpPattern(pe),"i"),l.set(pe,ze));const _e=ze.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Me?_(pe,Ce):g(pe,Ce)}e.matchesFuzzy=w;function T(pe,Ce){const Me=V(pe,pe.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Me?z(Me):null}e.matchesFuzzy2=T;function N(pe,Ce,Me,ze,_e,Ke){const G=Math.min(13,pe.length);for(;Me<G;Me++){const te=V(pe,Ce,Me,ze,_e,Ke,!1);if(te)return te}return[0,Ke]}e.anyScore=N;function z(pe){if(typeof pe=="undefined")return[];const Ce=[],Me=pe[1];for(let ze=pe.length-1;ze>1;ze--){const _e=pe[ze]+Me,Ke=Ce[Ce.length-1];Ke&&Ke.end===_e?Ke.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=z;const ne=128;function ie(){const pe=[],Ce=[];for(let Me=0;Me<=ne;Me++)Ce[Me]=0;for(let Me=0;Me<=ne;Me++)pe.push(Ce.slice(0));return pe}function U(pe){const Ce=[];for(let Me=0;Me<=pe;Me++)Ce[Me]=0;return Ce}const B=U(2*ne),x=U(2*ne),L=ie(),O=ie(),F=ie(),M=!1;function W(pe,Ce,Me,ze,_e){function Ke(te,we,xe=" "){for(;te.length<we;)te=xe+te;return te}let G=` |   |${ze.split("").map(te=>Ke(te,3)).join("|")}
`;for(let te=0;te<=Me;te++)te===0?G+=" |":G+=`${Ce[te-1]}|`,G+=pe[te].slice(0,_e+1).map(we=>Ke(we.toString(),3)).join("|")+`
`;return G}function q(pe,Ce,Me,ze){pe=pe.substr(Ce),Me=Me.substr(ze),console.log(W(O,pe,pe.length,Me,Me.length)),console.log(W(F,pe,pe.length,Me,Me.length)),console.log(W(L,pe,pe.length,Me,Me.length))}function K(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;const Me=pe.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(Me)}}function le(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;switch(pe.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function ve(pe,Ce,Me){return Ce[pe]!==Me[pe]}function Re(pe,Ce,Me,ze,_e,Ke,G=!1){for(;Ce<Me&&_e<Ke;)pe[Ce]===ze[_e]&&(G&&(B[Ce]=_e),Ce+=1),_e+=1;return Ce===Me}e.isPatternInWord=Re;var Se;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Oe;(function(pe){pe.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}pe.isDefault=Ce})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function V(pe,Ce,Me,ze,_e,Ke,G){const te=pe.length>ne?ne:pe.length,we=ze.length>ne?ne:ze.length;if(!(Me>=te||Ke>=we||te-Me>we-Ke)&&!!Re(Ce,Me,te,_e,Ke,we,!0)){X(te,we,Me,Ke,Ce,_e);let xe=1,je=1,Ve=Me,Je=Ke;const De=[!1];for(xe=1,Ve=Me;Ve<te;xe++,Ve++){const H=B[Ve],J=x[Ve],ce=Ve+1<te?x[Ve+1]:we;for(je=H-Ke+1,Je=H;Je<ce;je++,Je++){let Pe=Number.MIN_SAFE_INTEGER,Ae=!1;Je<=J&&(Pe=Z(pe,Ce,Ve,Me,ze,_e,Je,we,Ke,L[xe-1][je-1]===0,De));let Fe=0;Pe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Fe=Pe+O[xe-1][je-1]);const We=Je>H,Xe=We?O[xe][je-1]+(L[xe][je-1]>0?-5:0):0,rt=Je>H+1&&L[xe][je-1]>0,tt=rt?O[xe][je-2]+(L[xe][je-2]>0?-5:0):0;if(rt&&(!We||tt>=Xe)&&(!Ae||tt>=Fe))O[xe][je]=tt,F[xe][je]=3,L[xe][je]=0;else if(We&&(!Ae||Xe>=Fe))O[xe][je]=Xe,F[xe][je]=2,L[xe][je]=0;else if(Ae)O[xe][je]=Fe,F[xe][je]=1,L[xe][je]=L[xe-1][je-1]+1;else throw new Error("not possible")}}if(M&&q(pe,Me,ze,Ke),!(!De[0]&&!G)){xe--,je--;const ye=[O[xe][je],Ke];let Ie=0,oe=0;for(;xe>=1;){let H=je;do{const J=F[xe][H];if(J===3)H=H-2;else if(J===2)H=H-1;else break}while(H>=1);Ie>1&&Ce[Me+xe-1]===_e[Ke+je-1]&&!ve(H+Ke-1,ze,_e)&&Ie+1>L[xe][H]&&(H=je),H===je?Ie++:Ie=1,oe||(oe=H),xe--,je=H-1,ye.push(je)}we===te&&(ye[0]+=2);const ue=oe-te;return ye[0]-=ue,ye}}}e.fuzzyScore=V;function X(pe,Ce,Me,ze,_e,Ke){let G=pe-1,te=Ce-1;for(;G>=Me&&te>=ze;)_e[G]===Ke[te]&&(x[G]=te,G--),te--}function Z(pe,Ce,Me,ze,_e,Ke,G,te,we,xe,je){if(Ce[Me]!==Ke[G])return Number.MIN_SAFE_INTEGER;let Ve=1,Je=!1;return G===Me-ze?Ve=pe[Me]===_e[G]?7:5:ve(G,_e,Ke)&&(G===0||!ve(G-1,_e,Ke))?(Ve=pe[Me]===_e[G]?7:5,Je=!0):K(Ke,G)&&(G===0||!K(Ke,G-1))?Ve=5:(K(Ke,G-1)||le(Ke,G-1))&&(Ve=5,Je=!0),Ve>1&&Me===ze&&(je[0]=!0),Je||(Je=ve(G,_e,Ke)||K(Ke,G-1)||le(Ke,G-1)),Me===ze?G>we&&(Ve-=Je?3:5):xe?Ve+=Je?2:0:Ve+=Je?0:1,G+1===te&&(Ve-=Je?3:5),Ve}function se(pe,Ce,Me,ze,_e,Ke,G){return Ee(pe,Ce,Me,ze,_e,Ke,!0,G)}e.fuzzyScoreGracefulAggressive=se;function fe(pe,Ce,Me,ze,_e,Ke,G){return Ee(pe,Ce,Me,ze,_e,Ke,!1,G)}e.fuzzyScoreGraceful=fe;function Ee(pe,Ce,Me,ze,_e,Ke,G,te){let we=V(pe,Ce,Me,ze,_e,Ke,te);if(we&&!G)return we;if(pe.length>=3){const xe=Math.min(7,pe.length-1);for(let je=Me+1;je<xe;je++){const Ve=Be(pe,je);if(Ve){const Je=V(Ve,Ve.toLowerCase(),Me,ze,_e,Ke,te);Je&&(Je[0]-=3,(!we||Je[0]>we[0])&&(we=Je))}}}return we}function Be(pe,Ce){if(!(Ce+1>=pe.length)){const Me=pe[Ce],ze=pe[Ce+1];if(Me!==ze)return pe.slice(0,Ce)+ze+Me+pe.slice(Ce+2)}}}),define(me[136],ge([0,1,46,96,8]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function C(d){return d.replace(y,(E,v)=>v?E:`\\${E}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${A.source}`,"g");function k(d){return d.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=k;const r=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function P(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(r,(E,v,S,u)=>S?E:v||u||"")}e.stripIcons=P;function f(d){const E=d.indexOf(e.iconStartMarker);return E===-1?{text:d}:m(d,E)}e.parseLabelWithIcons=f;function m(d,E){const v=[];let S="";function u(p){if(p){S+=p;for(const g of p)v.push(t)}}let c=-1,h="",t=0,n,s,i=E;const a=d.length;for(u(d.substr(0,E));i<a;)n=d[i],s=d[i+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(c=i,u(h),h=e.iconStartMarker,i++):n===")"&&c!==-1?(t+=i-c+1,c=-1,h=""):c!==-1?/^[a-z0-9\-]$/i.test(n)?h+=n:(u(h),c=-1,h=""):u(n),i++;return u(h),{text:S,iconOffsets:v}}function o(d,E,v=!1){const{text:S,iconOffsets:u}=E;if(!u||u.length===0)return(0,R.matchesFuzzy)(d,S,v);const c=(0,I.ltrim)(S," "),h=S.length-c.length,t=(0,R.matchesFuzzy)(d,c,v);if(t)for(const n of t){const s=u[n.start+h]+h;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=o}),define(me[97],ge([0,1,16,136,17]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",E=!1){var v,S;if(this.value=d,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(v=E.isTrusted)!==null&&v!==void 0?v:void 0,this.supportThemeIcons=(S=E.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(d,E=0){return this.value+=P(this.supportThemeIcons?(0,R.escapeIcons)(d):d).replace(/([ \t]+)/g,(v,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,E){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function C(o){return D(o)?!o.value:Array.isArray(o)?o.every(C):!0}e.isEmptyMarkdownString=C;function D(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function k(o,d){return!o&&!d?!0:!o||!d?!1:Array.isArray(o)&&Array.isArray(d)?(0,b.equals)(o,d,r):D(o)&&D(d)?r(o,d):!1}e.markedStringsEquals=k;function r(o,d){return o===d?!0:!o||!d?!1:o.value===d.value&&o.isTrusted===d.isTrusted&&o.supportThemeIcons===d.supportThemeIcons}function P(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function f(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function m(o){const d=[],E=o.split("|").map(S=>S.trim());o=E[0];const v=E[1];if(v){const S=/height=(\d+)/.exec(v),u=/width=(\d+)/.exec(v),c=S?S[1]:"",h=u?u[1]:"",t=isFinite(parseInt(h)),n=isFinite(parseInt(c));t&&d.push(`width="${h}"`),n&&d.push(`height="${c}"`)}return{href:o,dimensions:d}}e.parseHrefAndDimensions=m}),define(me[59],ge([0,1,23,8,2]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(k){return JSON.stringify(k,C)}e.stringify=A;function y(k){let r=JSON.parse(k);return r=D(r),r}e.parse=y;function C(k,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:(0,R.regExpFlags)(r)}:r}function D(k,r=0){if(!k||r>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return I.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof b.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=D(k[P],r+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=D(k[P],r+1))}return k}e.revive=D}),define(me[12],ge([0,1,2,10]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(I=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,k,r){this._hosts[D]=k,this._ports[D]=r}setConnectionToken(D,k){this._connectionTokens[D]=k}rewrite(D){if(this._delegate)return this._delegate(D);const k=D.authority;let r=this._hosts[k];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const P=this._ports[k],f=this._connectionTokens[k];let m=`path=${encodeURIComponent(D.path)}`;return typeof f=="string"&&(m+=`&tkn=${encodeURIComponent(f)}`),b.URI.from({scheme:R.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${r}:${P}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,k,r){const P=this.toUri(D,k);return P.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(P):R.isNative&&(r||R.isPreferringBrowserCodeLoad)&&P.scheme===I.file?P.with({scheme:I.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(D,k){const r=this.toUri(D,k);return r.scheme===I.vscodeFileResource?r.with({scheme:I.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(D,k){return b.URI.isUri(D)?D:b.URI.parse(k.toUrl(D))}}e.FileAccess=new y}),define(me[76],ge([0,1,22]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new b.LRUCache(1e4);function I(k){return D(k,"NFC",R)}e.normalizeNFC=I;const A=new b.LRUCache(1e4);function y(k){return D(k,"NFD",A)}e.normalizeNFD=y;const C=/[^\u0000-\u0080]/;function D(k,r,P){if(!e.canNormalize||!k)return k;const f=P.get(k);if(f)return f;let m;return C.test(k)?m=k.normalize(r):m=k,P.set(k,m),m}e.removeAccents=function(){if(e.canNormalize){const k=/[\u0300-\u036f]/g;return function(r){return y(r).replace(k,"")}}else return function(k){return k}}()}),define(me[25],ge([0,1,29,9,2,8,12,10]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(m){return(0,I.uriToFsPath)(m,!0)}e.originalFSPath=D;class k{constructor(o){this._ignorePathCasing=o}compare(o,d,E=!1){return o===d?0:(0,A.compare)(this.getComparisonKey(o,E),this.getComparisonKey(d,E))}isEqual(o,d,E=!1){return o===d?!0:!o||!d?!1:this.getComparisonKey(o,E)===this.getComparisonKey(d,E)}getComparisonKey(o,d=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,d,E=!1){if(o.scheme===d.scheme){if(o.scheme===y.Schemas.file)return b.isEqualOrParent(D(o),D(d),this._ignorePathCasing(o))&&o.query===d.query&&(E||o.fragment===d.fragment);if((0,e.isEqualAuthority)(o.authority,d.authority))return b.isEqualOrParent(o.path,d.path,this._ignorePathCasing(o),"/")&&o.query===d.query&&(E||o.fragment===d.fragment)}return!1}joinPath(o,...d){return I.URI.joinPath(o,...d)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return R.posix.basename(o.path)}extname(o){return R.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let d;return o.scheme===y.Schemas.file?d=I.URI.file(R.dirname(D(o))).path:(d=R.posix.dirname(o.path),o.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),d="/")),o.with({path:d})}normalizePath(o){if(!o.path.length)return o;let d;return o.scheme===y.Schemas.file?d=I.URI.file(R.normalize(D(o))).path:d=R.posix.normalize(o.path),o.with({path:d})}relativePath(o,d){if(!(o.scheme!==d.scheme||!(0,e.isEqualAuthority)(o.authority,d.authority))){if(o.scheme===y.Schemas.file){const S=R.relative(D(o),D(d));return C.isWindows?b.toSlashes(S):S}let E=o.path||"/",v=d.path||"/";if(this._ignorePathCasing(o)){let S=0;for(const u=Math.min(E.length,v.length);S<u&&!(E.charCodeAt(S)!==v.charCodeAt(S)&&E.charAt(S).toLowerCase()!==v.charAt(S).toLowerCase());S++);E=v.substr(0,S)+E.substr(S)}return R.posix.relative(E,v)}}resolvePath(o,d){if(o.scheme===y.Schemas.file){const E=I.URI.file(R.resolve(D(o),d));return o.with({authority:E.authority,path:E.path})}return d=b.toPosixPath(d),o.with({path:R.posix.resolve(o.path,d)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,d){return o===d||(0,A.equalsIgnoreCase)(o,d)}hasTrailingPathSeparator(o,d=R.sep){if(o.scheme===y.Schemas.file){const E=D(o);return E.length>b.getRoot(E).length&&E[E.length-1]===d}else{const E=o.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,d=R.sep){return(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,d=R.sep){let E=!1;if(o.scheme===y.Schemas.file){const v=D(o);E=v!==void 0&&v.length===b.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=o.path;E=v.length===1&&v.charCodeAt(v.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path+"/"}):o}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(m=>m.scheme===y.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new k(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(m,o){const d=[];for(let E=0;E<m.length;E++){const v=o(m[E]);m.some((S,u)=>u===E?!1:(0,e.isEqualOrParent)(v,o(S)))||d.push(m[E])}return d}e.distinctParents=r;var P;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function o(d){const E=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[c,h]=u.split(":");c&&h&&E.set(c,h)});const S=d.path.substring(0,d.path.indexOf(";"));return S&&E.set(m.META_DATA_MIME,S),E}m.parseMetaData=o})(P=e.DataUri||(e.DataUri={}));function f(m,o,d){if(o){let E=m.path;return E&&E[0]!==R.posix.sep&&(E=R.posix.sep+E),m.with({scheme:d,authority:o,path:E})}return m.with({scheme:d})}e.toLocalResource=f}),define(me[13],ge([0,1,21,17,3,6,57,25]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(O){return!!O&&typeof O.then=="function"}e.isThenable=D;function k(O){const F=new b.CancellationTokenSource,M=O(F.token),W=new Promise((q,K)=>{F.token.onCancellationRequested(()=>{K((0,R.canceled)())}),Promise.resolve(M).then(le=>{F.dispose(),q(le)},le=>{F.dispose(),K(le)})});return new class{cancel(){F.cancel()}then(q,K){return W.then(q,K)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=k;function r(O,F,M){return Promise.race([O,new Promise(W=>F.onCancellationRequested(()=>W(M)))])}e.raceCancellation=r;async function P(O){let F=-1;const M=O.map((q,K)=>q.then(le=>(F=K,le))),W=await Promise.race(M);return O.forEach((q,K)=>{K!==F&&q.cancel()}),W}e.raceCancellablePromises=P;function f(O,F,M){let W;const q=setTimeout(()=>{W==null||W(void 0),M==null||M()},F);return Promise.race([O.finally(()=>clearTimeout(q)),new Promise(K=>W=K)])}e.raceTimeout=f;function m(O){return new Promise((F,M)=>{const W=O();D(W)?W.then(F,M):F(W)})}e.asPromise=m;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(M,M).then(W)})}return new Promise((M,W)=>{this.queuedPromise.then(M,W)})}return this.activePromise=F(),new Promise((M,W)=>{this.activePromise.then(q=>{this.activePromise=null,M(q)},q=>{this.activePromise=null,W(q)})})}}e.Throttler=o;class d{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=d;class E{constructor(){this.promiseMap=new Map}queue(F,M){var W;const K=((W=this.promiseMap.get(F))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===K&&this.promiseMap.delete(F)});return this.promiseMap.set(F,K),K}}e.SequencerByKey=E;class v{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,q)=>{this.doResolve=W,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class S{constructor(F){this.delayer=new v(F),this.throttler=new o}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class c extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function h(O,F){return F?new Promise((M,W)=>{const q=setTimeout(M,O);F.onCancellationRequested(()=>{clearTimeout(q),W((0,R.canceled)())})}):k(M=>h(O,M))}e.timeout=h;function t(O,F=0){const M=setTimeout(O,F);return(0,A.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function n(O){return O.then(void 0,F=>{})}e.ignoreErrors=n;function s(O){const F=[];let M=0;const W=O.length;function q(){return M<W?O[M++]():null}function K(le){le!=null&&F.push(le);const ve=q();return ve?ve.then(K):Promise.resolve(F)}return Promise.resolve(null).then(K)}e.sequence=s;function i(O,F=W=>!!W,M=null){let W=0;const q=O.length,K=()=>{if(W>=q)return Promise.resolve(M);const le=O[W++];return Promise.resolve(le()).then(Re=>F(Re)?Promise.resolve(Re):K())};return K()}e.first=i;function a(O,F=W=>!!W,M=null){if(O.length===0)return Promise.resolve(M);let W=O.length;const q=()=>{var K,le;W=-1;for(const ve of O)(le=(K=ve).cancel)===null||le===void 0||le.call(K)};return new Promise((K,le)=>{for(const ve of O)ve.then(Re=>{--W>=0&&F(Re)?(q(),K(Re)):W===0&&K(M)}).catch(Re=>{--W>=0&&(q(),le(Re))})})}e.firstParallel=a;class p{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,W)=>{this.outstandingPromises.push({factory:F,c:M,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class g extends p{constructor(){super(1)}}e.Queue=g;class _{constructor(){this.queues=new Map}queueFor(F,M=C.extUri){const W=M.getComparisonKey(F);let q=this.queues.get(W);return q||(q=new g,I.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(W)}),this.queues.set(W,q)),q}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=_;class l{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=l;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=w;class T{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class N extends T{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const O=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(O));let W=!1;return{dispose(){W||(W=!0,clearTimeout(M))}}}}else e.runWhenIdle=(O,F)=>{const M=requestIdleCallback(O,typeof F=="number"?{timeout:F}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(M))}}}}();class z{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function ne(O,F,M){let W;for(let q=0;q<M;q++)try{return await O()}catch(K){W=K,await h(F)}throw W}e.retry=ne;class ie{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,W){return this._pending={taskId:F,cancel:()=>W==null?void 0:W(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,W;const q=new Promise((K,le)=>{M=K,W=le});this._next={run:F,promise:q,promiseResolve:M,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=ie;class U{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=B;class x extends I.Emitter{async fireAsync(F,M,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[q,K]=this._asyncDeliveryQueue.shift(),le=[],ve=Object.assign(Object.assign({},K),{waitUntil:Re=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");W&&(Re=W(Re,typeof q=="function"?q:q[0])),le.push(Re)}});try{typeof q=="function"?q.call(void 0,ve):q[0].call(q[1],ve)}catch(Re){(0,R.onUnexpectedError)(Re);continue}Object.freeze(le),await L.settled(le).catch(Re=>(0,R.onUnexpectedError)(Re))}}}}e.AsyncEmitter=x;var L;(function(O){async function F(K){return typeof Promise.allSettled=="function"?M(K):W(K)}O.allSettled=F;async function M(K){return Promise.allSettled(K)}async function W(K){return Promise.all(K.map(le=>le.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function q(K){let le;const ve=await Promise.all(K.map(Re=>Re.then(Se=>Se,Se=>{le||(le=Se)})));if(typeof le!="undefined")throw le;return ve}O.settled=q})(L=e.Promises||(e.Promises={}))}),define(me[98],ge([0,1,9,13]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new R.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(l,w,T=!1){const N=l||"",z=w||"",ne=I.value.collator.compare(N,z);return I.value.collatorIsNumeric&&ne===0&&N!==z?N<z?-1:1:ne}e.compareFileNames=C;function D(l,w){const T=A.value.collator;return l=l||"",w=w||"",h(T,l,w)}e.compareFileNamesDefault=D;function k(l,w){const T=A.value.collator;return l=l||"",w=w||"",i(l,w)||h(T,l,w)}e.compareFileNamesUpper=k;function r(l,w){const T=A.value.collator;return l=l||"",w=w||"",s(l,w)||h(T,l,w)}e.compareFileNamesLower=r;function P(l,w){return l=l||"",w=w||"",l===w?0:l<w?-1:1}e.compareFileNamesUnicode=P;function f(l,w,T=!1){T||(l=l&&l.toLowerCase(),w=w&&w.toLowerCase());const[N,z]=u(l),[ne,ie]=u(w);return N!==ne?N<ne?-1:1:z===ie?0:z<ie?-1:1}e.noIntlCompareFileNames=f;function m(l,w){const[T,N]=u(l),[z,ne]=u(w);let ie=I.value.collator.compare(N,ne);if(ie===0){if(I.value.collatorIsNumeric&&N!==ne)return N<ne?-1:1;if(ie=I.value.collator.compare(T,z),I.value.collatorIsNumeric&&ie===0&&T!==z)return T<z?-1:1}return ie}e.compareFileExtensions=m;function o(l,w){l=l||"",w=w||"";const T=c(l),N=c(w),z=A.value.collator,ne=y.value.collator;return h(ne,T,N)||h(z,l,w)}e.compareFileExtensionsDefault=o;function d(l,w){l=l||"",w=w||"";const T=c(l),N=c(w),z=A.value.collator,ne=y.value.collator;return h(ne,T,N)||i(l,w)||h(z,l,w)}e.compareFileExtensionsUpper=d;function E(l,w){l=l||"",w=w||"";const T=c(l),N=c(w),z=A.value.collator,ne=y.value.collator;return h(ne,T,N)||s(l,w)||h(z,l,w)}e.compareFileExtensionsLower=E;function v(l,w){l=l||"",w=w||"";const T=c(l).toLowerCase(),N=c(w).toLowerCase();return T!==N?T<N?-1:1:l!==w?l<w?-1:1:0}e.compareFileExtensionsUnicode=v;const S=/^(.*?)(\.([^.]*))?$/;function u(l,w=!1){const T=l?S.exec(l):[];let N=[T&&T[1]||"",T&&T[3]||""];return w&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function c(l){const w=l?S.exec(l):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function h(l,w,T){let N=l.compare(w,T);return N!==0?N:w.length!==T.length?w.length<T.length?-1:1:0}function t(l){const w=l.charAt(0);return w.toLocaleUpperCase()!==w}function n(l){const w=l.charAt(0);return w.toLocaleLowerCase()!==w}function s(l,w){return t(l)&&n(w)?-1:n(l)&&t(w)?1:0}function i(l,w){return n(l)&&t(w)?-1:t(l)&&n(w)?1:0}function a(l,w,T=!1){return T||(l=l&&l.toLowerCase(),w=w&&w.toLowerCase()),l===w?0:l<w?-1:1}function p(l,w,T=!1){const N=l.split(b.sep),z=w.split(b.sep),ne=N.length-1,ie=z.length-1;let U,B;for(let x=0;;x++){if(U=ne===x,B=ie===x,U&&B)return C(N[x],z[x],T);if(U)return-1;if(B)return 1;const L=a(N[x],z[x],T);if(L!==0)return L}}e.comparePaths=p;function g(l,w,T){const N=l.toLowerCase(),z=w.toLowerCase(),ne=_(l,w,T);if(ne)return ne;const ie=N.endsWith(T),U=z.endsWith(T);if(ie!==U)return ie?-1:1;const B=C(N,z);return B!==0?B:N.localeCompare(z)}e.compareAnything=g;function _(l,w,T){const N=l.toLowerCase(),z=w.toLowerCase(),ne=N.startsWith(T),ie=z.startsWith(T);if(ne!==ie)return ne?-1:1;if(ne&&ie){if(N.length<z.length)return-1;if(N.length>z.length)return 1}return 0}e.compareByPrefix=_}),define(me[99],ge([0,1,98,96,9,10,8]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,D=[C,[]];function k(U,B,x,L){if(!U||!B)return D;const O=U.length,F=B.length;if(O<F)return D;const M=U.toLowerCase();return!L&&!M.includes(x)?D:r(B,x,F,U,M,O)}e.scoreFuzzy=k;function r(U,B,x,L,O,F){const M=[],W=[];for(let ve=0;ve<x;ve++){const Re=ve*F,Se=Re-F,Oe=ve>0,V=U[ve],X=B[ve];for(let Z=0;Z<F;Z++){const se=Z>0,fe=Re+Z,Ee=fe-1,Be=Se+Z-1,pe=se?M[Ee]:0,Ce=Oe&&se?M[Be]:0,Me=Oe&&se?W[Be]:0;let ze;!Ce&&Oe?ze=0:ze=P(V,X,L,O,Z,Me),ze&&Ce+ze>=pe?(W[fe]=Me+1,M[fe]=Ce+ze):(W[fe]=C,M[fe]=pe)}}const q=[];let K=x-1,le=F-1;for(;K>=0&&le>=0;){const ve=K*F+le;W[ve]===C||(q.push(le),K--),le--}return[M[x*F-1],q.reverse()]}function P(U,B,x,L,O,F){let M=0;if(!f(B,L[O]))return M;if(M+=1,F>0&&(M+=F*5),U===x[O]&&(M+=1),O===0)M+=8;else{const W=m(x.charCodeAt(O-1));W?M+=W:(0,R.isUpper)(x.charCodeAt(O))&&(M+=2)}return M}function f(U,B){return U===B?!0:U==="/"||U==="\\"?B==="/"||B==="\\":!1}function m(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const o=[void 0,[]];function d(U,B,x=0,L=0){const O=B;return O.values&&O.values.length>1?E(U,O.values,x,L):v(U,B,x,L)}e.scoreFuzzy2=d;function E(U,B,x,L){let O=0;const F=[];for(const M of B){const[W,q]=v(U,M,x,L);if(typeof W!="number")return o;O+=W,F.push(...q)}return[O,p(F)]}function v(U,B,x,L){const O=(0,R.fuzzyScore)(B.original,B.originalLowercase,x,U,U.toLowerCase(),L,!0);return O?[O[0],(0,R.createMatches)(O)]:o}const S=Object.freeze({score:0}),u=1<<18,c=1<<17,h=1<<16;function t(U,B,x,L,O){if(!U||!B.normalized)return S;const F=L.getItemLabel(U);if(!F)return S;const M=L.getItemDescription(U);let W;M?W=`${F}${M}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${x}`:W=`${F}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${x}`;const q=O[W];if(q)return q;const K=n(F,M,L.getItemPath(U),B,x);return O[W]=K,K}e.scoreItemFuzzy=t;function n(U,B,x,L,O){const F=!x||!L.containsPathSeparator;return x&&(A.isLinux?L.pathNormalized===x:(0,y.equalsIgnoreCase)(L.pathNormalized,x))?{score:u,labelMatch:[{start:0,end:U.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:L.values&&L.values.length>1?s(U,B,x,L.values,F,O):i(U,B,x,L,F,O)}function s(U,B,x,L,O,F){let M=0;const W=[],q=[];for(const K of L){const{score:le,labelMatch:ve,descriptionMatch:Re}=i(U,B,x,K,O,F);if(le===C)return S;M+=le,ve&&W.push(...ve),Re&&q.push(...Re)}return{score:M,labelMatch:p(W),descriptionMatch:p(q)}}function i(U,B,x,L,O,F){if(O||!B){const[M,W]=k(U,L.normalized,L.normalizedLowercase,F);if(M){const q=(0,R.matchesPrefix)(L.normalized,U);let K;return q?(K=c,K+=Math.round(L.normalized.length/U.length*100)):K=h,{score:K+M,labelMatch:q||a(W)}}}if(B){let M=B;x&&(M=`${B}${I.sep}`);const W=M.length,q=`${M}${U}`,[K,le]=k(q,L.normalized,L.normalizedLowercase,F);if(K){const ve=a(le),Re=[],Se=[];return ve.forEach(Oe=>{Oe.start<W&&Oe.end>W?(Re.push({start:0,end:Oe.end-W}),Se.push({start:Oe.start,end:W})):Oe.start>=W?Re.push({start:Oe.start-W,end:Oe.end-W}):Se.push(Oe)}),{score:K,labelMatch:Re,descriptionMatch:Se}}}return S}function a(U){const B=[];if(!U)return B;let x;for(const L of U)x&&x.end===L?x.end+=1:(x={start:L,end:L+1},B.push(x));return B}function p(U){const B=U.sort((O,F)=>O.start-F.start),x=[];let L;for(const O of B)!L||!g(L,O)?(L=O,x.push(O)):(L.start=Math.min(L.start,O.start),L.end=Math.max(L.end,O.end));return x}function g(U,B){return!(U.end<B.start||B.end<U.start)}function _(U,B,x,L,O,F){const M=t(U,x,L,O,F),W=t(B,x,L,O,F),q=M.score,K=W.score;if((q===u||K===u)&&q!==K)return q===u?-1:1;if(q>h||K>h){if(q!==K)return q>K?-1:1;if(q<c&&K<c){const X=w(M.labelMatch,W.labelMatch);if(X!==0)return X}const Oe=O.getItemLabel(U)||"",V=O.getItemLabel(B)||"";if(Oe.length!==V.length)return Oe.length-V.length}if(q!==K)return q>K?-1:1;const le=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,ve=Array.isArray(W.labelMatch)&&W.labelMatch.length>0;if(le&&!ve)return-1;if(ve&&!le)return 1;const Re=l(U,M,O),Se=l(B,W,O);return Re&&Se&&Re!==Se?Se>Re?-1:1:T(U,B,x,O)}e.compareItemsByFuzzyScore=_;function l(U,B,x){let L=-1,O=-1;if(B.descriptionMatch&&B.descriptionMatch.length?L=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(L=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(O=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const F=x.getItemDescription(U);F&&(O+=F.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(O=B.descriptionMatch[B.descriptionMatch.length-1].end);return O-L}function w(U,B){if(!U&&!B||(!U||!U.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!U||!U.length)return 1;const x=U[0].start,O=U[U.length-1].end-x,F=B[0].start,W=B[B.length-1].end-F;return O===W?0:W<O?1:-1}function T(U,B,x,L){const O=L.getItemLabel(U)||"",F=L.getItemLabel(B)||"",M=L.getItemDescription(U),W=L.getItemDescription(B),q=O.length+(M?M.length:0),K=F.length+(W?W.length:0);if(q!==K)return q-K;const le=L.getItemPath(U),ve=L.getItemPath(B);return le&&ve&&le.length!==ve.length?le.length-ve.length:O!==F?(0,b.compareAnything)(O,F,x.normalized):M&&W&&M!==W?(0,b.compareAnything)(M,W,x.normalized):le&&ve&&le!==ve?(0,b.compareAnything)(le,ve,x.normalized):0}const N=" ";function z(U){typeof U!="string"&&(U="");const B=U.toLowerCase(),{pathNormalized:x,normalized:L,normalizedLowercase:O}=ne(U),F=x.indexOf(I.sep)>=0;let M;const W=U.split(N);if(W.length>1)for(const q of W){const{pathNormalized:K,normalized:le,normalizedLowercase:ve}=ne(q);le&&(M||(M=[]),M.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:K,normalized:le,normalizedLowercase:ve}))}return{original:U,originalLowercase:B,pathNormalized:x,normalized:L,normalizedLowercase:O,values:M,containsPathSeparator:F}}e.prepareQuery=z;function ne(U){let B;A.isWindows?B=U.replace(/\//g,I.sep):B=U.replace(/\\/g,I.sep);const x=(0,y.stripWildcards)(B).replace(/\s/g,"");return{pathNormalized:B,normalized:x,normalizedLowercase:x.toLowerCase()}}function ie(U){return Array.isArray(U)?z(U.map(B=>B.original).join(N)):z(U.original)}e.pieceToQuery=ie}),define(me[32],ge([0,1,8,29,9,22,13]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",k="/",r="[/\\\\]",P="[^/\\\\]",f=/\//g;function m(M){switch(M){case 0:return"";case 1:return`${P}*?`;default:return`(?:${r}|${P}+${r}|${r}${P}+)*?`}}function o(M,W){if(!M)return[];const q=[];let K=!1,le=!1,ve="";for(const Re of M){switch(Re){case W:if(!K&&!le){q.push(ve),ve="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":le=!0;break;case"]":le=!1;break}ve+=Re}return ve&&q.push(ve),q}e.splitGlobAware=o;function d(M){if(!M)return"";let W="";const q=o(M,k);if(q.every(K=>K===D))W=".*";else{let K=!1;q.forEach((le,ve)=>{if(le===D){K||(W+=m(2),K=!0);return}let Re=!1,Se="",Oe=!1,V="";for(const X of le){if(X!=="}"&&Re){Se+=X;continue}if(Oe&&(X!=="]"||!V)){let Z;X==="-"?Z=X:(X==="^"||X==="!")&&!V?Z="^":X===k?Z="":Z=b.escapeRegExpCharacters(X),V+=Z;continue}switch(X){case"{":Re=!0;continue;case"[":Oe=!0;continue;case"}":W+=`(?:${o(Se,",").map(fe=>d(fe)).join("|")})`,Re=!1,Se="";break;case"]":W+="["+V+"]",Oe=!1,V="";break;case"?":W+=P;continue;case"*":W+=m(1);continue;default:W+=b.escapeRegExpCharacters(X)}}ve<q.length-1&&(q[ve+1]!==D||ve+2<q.length)&&(W+=r),K=!1})}return W}const E=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},s=function(){return null};function i(M,W){if(!M)return s;let q;typeof M!="string"?q=M.pattern:q=M,q=q.trim();const K=`${q}_${!!W.trimForExclusions}`;let le=t.get(K);if(le)return a(le,M);let ve;if(E.test(q)){const Re=q.substr(4);le=function(Se,Oe){return typeof Se=="string"&&Se.endsWith(Re)?q:null}}else(ve=v.exec(p(q,W)))?le=g(ve[1],q):(W.trimForExclusions?u:S).test(q)?le=_(q,W):(ve=c.exec(p(q,W)))?le=l(ve[1].substr(1),q,!0):(ve=h.exec(p(q,W)))?le=l(ve[1],q,!1):le=w(q);return t.set(K,le),a(le,M)}function a(M,W){return typeof W=="string"?M:function(q,K){return R.isEqualOrParent(q,W.base)?M(I.relative(W.base,q),K):null}}function p(M,W){return W.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function g(M,W){const q=`/${M}`,K=`\\${M}`,le=function(Re,Se){return typeof Re!="string"?null:Se?Se===M?W:null:Re===M||Re.endsWith(q)||Re.endsWith(K)?W:null},ve=[M];return le.basenames=ve,le.patterns=[W],le.allBasenames=ve,le}function _(M,W){const q=F(M.slice(1,-1).split(",").map(Se=>i(Se,W)).filter(Se=>Se!==s),M),K=q.length;if(!K)return s;if(K===1)return q[0];const le=function(Se,Oe){for(let V=0,X=q.length;V<X;V++)if(q[V](Se,Oe))return M;return null},ve=q.find(Se=>!!Se.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Re=q.reduce((Se,Oe)=>Oe.allPaths?Se.concat(Oe.allPaths):Se,[]);return Re.length&&(le.allPaths=Re),le}function l(M,W,q){const K=I.sep===I.posix.sep,le=K?M:M.replace(f,I.sep),ve=I.sep+le,Re=I.posix.sep+M,Se=q?function(Oe,V){return typeof Oe=="string"&&(Oe===le||Oe.endsWith(ve)||!K&&(Oe===M||Oe.endsWith(Re)))?W:null}:function(Oe,V){return typeof Oe=="string"&&(Oe===le||!K&&Oe===M)?W:null};return Se.allPaths=[(q?"*/":"./")+M],Se}function w(M){try{const W=new RegExp(`^${d(M)}$`);return function(q){return W.lastIndex=0,typeof q=="string"&&W.test(q)?M:null}}catch(W){return s}}function T(M,W,q){return!M||typeof W!="string"?!1:N(M)(W,void 0,q)}e.match=T;function N(M,W={}){if(!M)return n;if(typeof M=="string"||U(M)){const q=i(M,W);if(q===s)return n;const K=function(le,ve){return!!q(le,ve)};return q.allBasenames&&(K.allBasenames=q.allBasenames),q.allPaths&&(K.allPaths=q.allPaths),K}return L(M,W)}e.parse=N;function z(M){if(!!M){let W;return q=>(W||(W=(M()||Promise.resolve([])).then(K=>K?ie(K):{})),W.then(K=>!!K[q]))}}e.hasSiblingPromiseFn=z;function ne(M){if(!!M){let W;return q=>{if(!W){const K=M();W=K?ie(K):{}}return!!W[q]}}}e.hasSiblingFn=ne;function ie(M){const W={};for(const q of M)W[q]=!0;return W}function U(M){const W=M;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=U;function B(M){return M.allBasenames||[]}e.getBasenameTerms=B;function x(M){return M.allPaths||[]}e.getPathTerms=x;function L(M,W){const q=F(Object.getOwnPropertyNames(M).map(Se=>O(Se,M[Se],W)).filter(Se=>Se!==s)),K=q.length;if(!K)return s;if(!q.some(Se=>!!Se.requiresSiblings)){if(K===1)return q[0];const Se=function(X,Z){for(let se=0,fe=q.length;se<fe;se++){const Ee=q[se](X,Z);if(Ee)return Ee}return null},Oe=q.find(X=>!!X.allBasenames);Oe&&(Se.allBasenames=Oe.allBasenames);const V=q.reduce((X,Z)=>Z.allPaths?X.concat(Z.allPaths):X,[]);return V.length&&(Se.allPaths=V),Se}const le=function(Se,Oe,V){let X;for(let Z=0,se=q.length;Z<se;Z++){const fe=q[Z];fe.requiresSiblings&&V&&(Oe||(Oe=I.basename(Se)),X||(X=Oe.substr(0,Oe.length-I.extname(Se).length)));const Ee=fe(Se,Oe,X,V);if(Ee)return Ee}return null},ve=q.find(Se=>!!Se.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Re=q.reduce((Se,Oe)=>Oe.allPaths?Se.concat(Oe.allPaths):Se,[]);return Re.length&&(le.allPaths=Re),le}function O(M,W,q){if(W===!1)return s;const K=i(M,q);if(K===s)return s;if(typeof W=="boolean")return K;if(W){const le=W.when;if(typeof le=="string"){const ve=(Re,Se,Oe,V)=>{if(!V||!K(Re,Se))return null;const X=le.replace("$(basename)",Oe),Z=V(X);return(0,y.isThenable)(Z)?Z.then(se=>se?M:null):Z?M:null};return ve.requiresSiblings=!0,ve}}return K}function F(M,W){const q=M.filter(Se=>!!Se.basenames);if(q.length<2)return M;const K=q.reduce((Se,Oe)=>{const V=Oe.basenames;return V?Se.concat(V):Se},[]);let le;if(W){le=[];for(let Se=0,Oe=K.length;Se<Oe;Se++)le.push(W)}else le=q.reduce((Se,Oe)=>{const V=Oe.patterns;return V?Se.concat(V):Se},[]);const ve=function(Se,Oe){if(typeof Se!="string")return null;if(!Oe){let X;for(X=Se.length;X>0;X--){const Z=Se.charCodeAt(X-1);if(Z===47||Z===92)break}Oe=Se.substr(X)}const V=K.indexOf(Oe);return V!==-1?le[V]:null};ve.basenames=K,ve.patterns=le,ve.allBasenames=K;const Re=M.filter(Se=>!Se.basenames);return Re.push(ve),Re}}),define(me[77],ge([0,1,2,9,8,12,10,25,29]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,a,p){if(typeof i=="string"&&(i=b.URI.file(i)),p){const _=p.getWorkspaceFolder(i);if(_){const l=p.getWorkspace().folders.length>1;let w;if((0,C.isEqual)(_.uri,i)?w="":w=(0,C.relativePath)(_.uri,i),l){const T=_.name?_.name:(0,C.basename)(_.uri);w=w?T+" \u2022 "+w:T}return w}}if(i.scheme!==A.Schemas.file&&i.scheme!==A.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(i.fsPath))return(0,R.normalize)(P(i.fsPath));let g=(0,R.normalize)(i.fsPath);return!y.isWindows&&(a==null?void 0:a.userHome)&&(g=m(g,a.userHome.fsPath)),g}e.getPathLabel=k;function r(i){if(!!i){typeof i=="string"&&(i=b.URI.file(i));const a=(0,C.basename)(i)||(i.scheme===A.Schemas.file?i.fsPath:i.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(a)?P(a):a}}e.getBaseLabel=r;function P(i){return(0,D.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=P;let f=Object.create(null);function m(i,a){if(y.isWindows||!i||!a)return i;let p=f.original===a?f.normalized:void 0;return p||(p=`${(0,I.rtrim)(a,R.posix.sep)}${R.posix.sep}`,f={original:a,normalized:p}),(y.isLinux?i.startsWith(p):(0,I.startsWithIgnoreCase)(i,p))&&(i=`~/${i.substr(p.length)}`),i}e.tildify=m;function o(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=o;const d="\u2026",E="\\\\",v="~";function S(i,a=R.sep){const p=new Array(i.length);let g=!1;for(let _=0;_<i.length;_++){let l=i[_];if(l===""){p[_]=`.${a}`;continue}if(!l){p[_]=l;continue}g=!0;let w="";l.indexOf(E)===0?(w=l.substr(0,l.indexOf(E)+E.length),l=l.substr(l.indexOf(E)+E.length)):l.indexOf(a)===0?(w=l.substr(0,l.indexOf(a)+a.length),l=l.substr(l.indexOf(a)+a.length)):l.indexOf(v)===0&&(w=l.substr(0,l.indexOf(v)+v.length),l=l.substr(l.indexOf(v)+v.length));const T=l.split(a);for(let N=1;g&&N<=T.length;N++)for(let z=T.length-N;g&&z>=0;z--){g=!1;let ne=T.slice(z,z+N).join(a);for(let ie=0;!g&&ie<i.length;ie++)if(ie!==_&&i[ie]&&i[ie].indexOf(ne)>-1){const U=z+N===T.length,B=z>0&&i[ie].indexOf(a)>-1?a+ne:ne,x=i[ie].endsWith(B);g=!U||x}if(!g){let ie="";(T[0].endsWith(":")||w!=="")&&(z===1&&(z=0,N++,ne=T[0]+a+ne),z>0&&(ie=T[0]+a),ie=w+ie),z>0&&(ie=ie+d+a),ie=ie+ne,z+N<T.length&&(ie=ie+a+d),p[_]=ie}}g&&(p[_]=l)}return p}e.shorten=S;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(i,a=Object.create(null)){const p=[];let g=!1,_="";for(const l of i)if(l==="$"||g&&l==="{")_&&p.push({value:_,type:u.TEXT}),_="",g=!0;else if(l==="}"&&g){const w=a[_];if(typeof w=="string")w.length&&p.push({value:w,type:u.VARIABLE});else if(w){const T=p[p.length-1];(!T||T.type!==u.SEPARATOR)&&p.push({value:w.label,type:u.SEPARATOR})}_="",g=!1}else _+=l;return _&&!g&&p.push({value:_,type:u.TEXT}),p.filter((l,w)=>{if(l.type===u.SEPARATOR){const T=p[w-1],N=p[w+1];return[T,N].every(z=>z&&(z.type===u.VARIABLE||z.type===u.TEXT)&&z.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=c;function h(i,a){return y.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):i.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function t(i,a){return y.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):y.isWindows?i.replace(/&&|&/g,p=>p==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(i){const a=i.indexOf("/")!==-1?R.posix:R.win32,p=a.basename(i),g=a.dirname(i);return p.length?{name:p,parentPath:g}:{name:g,parentPath:""}}e.splitName=s}),define(me[100],ge([0,1,2]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(r){return r.toJSON()}class I{constructor(P){this._uriTransformer=P}transformIncoming(P){const f=this._uriTransformer.transformIncoming(P);return f===P?P:R(b.URI.from(f))}transformOutgoing(P){const f=this._uriTransformer.transformOutgoing(P);return f===P?P:R(b.URI.from(f))}transformOutgoingURI(P){const f=this._uriTransformer.transformOutgoing(P);return f===P?P:b.URI.from(f)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(r){return r}transformOutgoing(r){return r}transformOutgoingURI(r){return r}transformOutgoingScheme(r){return r}};function A(r,P,f){if(!r||f>200)return null;if(typeof r=="object"){if(r instanceof b.URI)return P.transformOutgoing(r);for(let m in r)if(Object.hasOwnProperty.call(r,m)){const o=A(r[m],P,f+1);o!==null&&(r[m]=o)}}return null}function y(r,P){const f=A(r,P,0);return f===null?r:f}e.transformOutgoingURIs=y;function C(r,P,f,m){if(!r||m>200)return null;if(typeof r=="object"){if(r.$mid===1)return f?b.URI.revive(P.transformIncoming(r)):P.transformIncoming(r);for(let o in r)if(Object.hasOwnProperty.call(r,o)){const d=C(r[o],P,f,m+1);d!==null&&(r[o]=d)}}return null}function D(r,P){const f=C(r,P,!1,0);return f===null?r:f}e.transformIncomingURIs=D;function k(r,P){const f=C(r,P,!0,0);return f===null?r:f}e.transformAndReviveIncomingURIs=k}),define(me[30],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return b.test(D)}e.isUUID=R;const I=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let k=0;k<D.length;k++)D[k]=Math.floor(Math.random()*256);return D};function C(){y(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let D=0,k="";return k+=A[I[D++]],k+=A[I[D++]],k+=A[I[D++]],k+=A[I[D++]],k+="-",k+=A[I[D++]],k+=A[I[D++]],k+="-",k+=A[I[D++]],k+=A[I[D++]],k+="-",k+=A[I[D++]],k+=A[I[D++]],k+="-",k+=A[I[D++]],k+=A[I[D++]],k+=A[I[D++]],k+=A[I[D++]],k+=A[I[D++]],k+=A[I[D++]],k}e.generateUuid=C}),define(me[137],ge([0,1,101]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(A="utf8"){this.stringDecoder=new b.StringDecoder(A),this.remaining=null}write(A){const y=[],C=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(C.length<1)return y;let D=0,k,r=D;for(;r<C.length;)if(k=C.charCodeAt(r),k===13||k===10){if(y.push(C.substring(D,r)),r++,r<C.length){const P=k;k=C.charCodeAt(r),(P===13&&k===10||P===10&&k===13)&&r++}D=r}else r++;return this.remaining=D<C.length?C.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=R}),define(me[28],ge([0,1,37,102,9,13,10,29,30,76,25,2]),function(Q,e,b,R,I,A,y,C,D,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var f;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function m(B,x=f.UNLINK){if((0,C.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return x===f.UNLINK?d(B):o(B)}e.rimraf=m;async function o(B){try{const x=(0,I.join)((0,R.tmpdir)(),(0,D.generateUuid)());try{await b.promises.rename(B,x)}catch(L){return d(B)}d(x).catch(L=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function d(B){return b.promises.rmdir(B,{recursive:!0,maxRetries:3})}function E(B){if((0,C.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");b.rmdirSync(B,{recursive:!0})}e.rimrafSync=E;async function v(B,x){return c(await(x?S(B):b.promises.readdir(B)))}e.readdir=v;async function S(B){try{return await b.promises.readdir(B,{withFileTypes:!0})}catch(O){console.warn("[node.js fs] readdir with filetypes failed with error: ",O)}const x=[],L=await v(B);for(const O of L){let F=!1,M=!1,W=!1;try{const q=await b.promises.lstat((0,I.join)(B,O));F=q.isFile(),M=q.isDirectory(),W=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}x.push({name:O,isFile:()=>F,isDirectory:()=>M,isSymbolicLink:()=>W})}return x}function u(B){return c(b.readdirSync(B))}e.readdirSync=u;function c(B){return B.map(x=>typeof x=="string"?y.isMacintosh?(0,k.normalizeNFC)(x):x:(x.name=y.isMacintosh?(0,k.normalizeNFC)(x.name):x.name,x))}async function h(B){const x=await v(B),L=[];for(const O of x)await n.existsDirectory((0,I.join)(B,O))&&L.push(O);return L}e.readDirsInDir=h;function t(B,x=1e3){return new Promise(L=>{let O=!1;const F=setInterval(()=>{O||(O=!0,b.access(B,M=>{O=!1,M&&(clearInterval(F),L(void 0))}))},x)})}e.whenDeleted=t;var n;(function(B){async function x(F){let M;try{if(M=await b.promises.lstat(F),!M.isSymbolicLink())return{stat:M}}catch(W){}try{return{stat:await b.promises.stat(F),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(y.isWindows&&W.code==="EACCES")try{return{stat:await b.promises.stat(await b.promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw q}throw W}}B.stat=x;async function L(F){try{const{stat:M,symbolicLink:W}=await B.stat(F);return M.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(M){}return!1}B.existsFile=L;async function O(F){try{const{stat:M,symbolicLink:W}=await B.stat(F);return M.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(M){}return!1}B.existsDirectory=O})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new A.ResourceQueue;function i(B,x,L){return s.queueFor(P.URI.file(B),r.extUriBiasedIgnorePathCase).queue(()=>{const O=_(L);return new Promise((F,M)=>p(B,x,O,W=>W?M(W):F()))})}e.writeFile=i;let a=!0;function p(B,x,L,O){if(!a)return b.writeFile(B,x,{mode:L.mode,flag:L.flag},O);b.open(B,L.flag,L.mode,(F,M)=>{if(F)return O(F);b.writeFile(M,x,W=>{if(W)return b.close(M,()=>O(W));b.fdatasync(M,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),a=!1),b.close(M,K=>O(K))))})})}function g(B,x,L){const O=_(L);if(!a)return b.writeFileSync(B,x,{mode:O.mode,flag:O.flag});const F=b.openSync(B,O.flag,O.mode);try{b.writeFileSync(F,x);try{b.fdatasyncSync(F)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),a=!1}}finally{b.closeSync(F)}}e.writeFileSync=g;function _(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function l(B,x){if(B!==x){async function L(O){try{const F=await b.promises.lstat(O);if(F.isDirectory()||F.isSymbolicLink())return;const M=await b.promises.open(O,"a");try{await M.utimes(F.atime,new Date)}finally{await M.close()}}catch(F){}}try{await b.promises.rename(B,x),await L(x)}catch(O){if(B.toLowerCase()!==x.toLowerCase()&&O.code==="EXDEV"||B.endsWith("."))await w(B,x,{preserveSymlinks:!1}),await m(B,f.MOVE),await L(x);else throw O}}}e.move=l;async function w(B,x,L){return N(B,x,{root:{source:B,target:x},options:L,handledSourcePaths:new Set})}e.copy=w;const T=511;async function N(B,x,L){if(!L.handledSourcePaths.has(B)){L.handledSourcePaths.add(B);const{stat:O,symbolicLink:F}=await n.stat(B);if(F){if(L.options.preserveSymlinks)try{return await ie(B,x,L)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(F.dangling)return}return O.isDirectory()?z(B,x,O.mode&T,L):ne(B,x,O.mode&T)}}async function z(B,x,L,O){await b.promises.mkdir(x,{recursive:!0,mode:L});const F=await v(B);for(const M of F)await N((0,I.join)(B,M),(0,I.join)(x,M),O)}async function ne(B,x,L){await b.promises.copyFile(B,x),await b.promises.chmod(x,L)}async function ie(B,x,L){let O=await b.promises.readlink(B);(0,C.isEqualOrParent)(O,L.root.source,!y.isLinux)&&(O=(0,I.join)(L.root.target,O.substr(L.root.source.length+1))),await b.promises.symlink(O,x)}async function U(B){try{return await b.promises.access(B),!0}catch(x){return!1}}e.exists=U}),define(me[103],ge([0,1,37,279,8,9,28]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function C(P){const f=(0,A.dirname)(P);if(P===f)return P;const m=((0,A.basename)(P)||P).toLowerCase();try{const d=(0,y.readdirSync)(f).filter(E=>E.toLowerCase()===m);if(d.length===1){const E=C(f);if(E)return(0,A.join)(E,d[0])}else if(d.length>1){const E=d.indexOf(m);if(E>=0){const v=C(f);if(v)return(0,A.join)(v,d[E])}}}catch(o){}return null}e.realcaseSync=C;async function D(P){try{return await(0,R.promisify)(b.realpath)(P)}catch(f){const m=r(P);return await b.promises.access(m,b.constants.R_OK),m}}e.realpath=D;function k(P){try{return b.realpathSync(P)}catch(f){const m=r(P);return b.accessSync(m,b.constants.R_OK),m}}e.realpathSync=k;function r(P){return(0,I.rtrim)((0,A.normalize)(P),A.sep)}});var qe=this&&this.__decorate||function(Q,e,b,R){var I=arguments.length,A=I<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,b):R,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Q,e,b,R);else for(var C=Q.length-1;C>=0;C--)(y=Q[C])&&(A=(I<3?y(A):I>3?y(e,b,A):y(e,b))||A);return I>3&&A&&Object.defineProperty(e,b,A),A};define(me[104],ge([0,1,3,6,13,21,17,23,16,11,59,8,54]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function o(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function E(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(v||(v={}));class S{constructor(M){this.buffer=M,this.pos=0}read(M){const W=this.buffer.slice(this.pos,this.pos+M);return this.pos+=W.byteLength,W}}class u{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var c;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(c||(c={}));function h(F){const M=C.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function n(F){const M=C.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const s={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object)},i=typeof Buffer!="undefined";function a(F,M){if(typeof M=="undefined")F.write(s.Undefined);else if(typeof M=="string"){const W=C.VSBuffer.fromString(M);F.write(s.String),F.write(h(W.byteLength)),F.write(W)}else if(i&&Buffer.isBuffer(M)){const W=C.VSBuffer.wrap(M);F.write(s.Buffer),F.write(h(W.byteLength)),F.write(W)}else if(M instanceof C.VSBuffer)F.write(s.VSBuffer),F.write(h(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(s.Array),F.write(h(M.length));for(const W of M)a(F,W)}else{const W=C.VSBuffer.fromString(JSON.stringify(M));F.write(s.Object),F.write(h(W.byteLength)),F.write(W)}}function p(F){switch(F.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return F.read(t(F)).toString();case c.Buffer:return F.read(t(F)).buffer;case c.VSBuffer:return F.read(t(F));case c.Array:{const W=t(F),q=[];for(let K=0;K<W;K++)q.push(p(F));return q}case c.Object:return JSON.parse(F.read(t(F)).toString())}}class g{constructor(M,W,q=null,K=1e3){this.protocol=M,this.ctx=W,this.logger=q,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(M,W){this.channels.set(M,W),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const W=this.send([M.type]);this.logger&&this.logger.logOutgoing(W,0,1,E(M.type));return}case 201:case 202:case 204:case 203:{const W=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(W,M.id,1,E(M.type),M.data);return}}}send(M,W=void 0){const q=new u;return a(q,M),a(q,W),this.sendBuffer(q.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(W){return 0}}onRawMessage(M){const W=new S(M),q=p(W),K=p(W),le=q[0];switch(le){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],1,`${o(le)}: ${q[2]}.${q[3]}`,K),this.onPromise({type:le,id:q[1],channelName:q[2],name:q[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],1,`${o(le)}: ${q[2]}.${q[3]}`,K),this.onEventListen({type:le,id:q[1],channelName:q[2],name:q[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],1,`${o(le)}`),this.disposeActiveRequest({type:le,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],1,`${o(le)}`),this.disposeActiveRequest({type:le,id:q[1]})}}onPromise(M){const W=this.channels.get(M.channelName);if(!W){this.collectPendingRequest(M);return}const q=new A.CancellationTokenSource;let K;try{K=W.call(this.ctx,M.name,M.arg,q.token)}catch(Re){K=Promise.reject(Re)}const le=M.id;K.then(Re=>{this.sendResponse({id:le,data:Re,type:201}),this.activeRequests.delete(M.id)},Re=>{Re instanceof Error?this.sendResponse({id:le,data:{message:Re.message,name:Re.name,stack:Re.stack?Re.stack.split?Re.stack.split(`
`):Re.stack:void 0},type:202}):this.sendResponse({id:le,data:Re,type:203}),this.activeRequests.delete(M.id)});const ve=(0,R.toDisposable)(()=>q.cancel());this.activeRequests.set(M.id,ve)}onEventListen(M){const W=this.channels.get(M.channelName);if(!W){this.collectPendingRequest(M);return}const q=M.id,le=W.listen(this.ctx,M.name,M.arg)(ve=>this.sendResponse({id:q,data:ve,type:204}));this.activeRequests.set(M.id,le)}disposeActiveRequest(M){const W=this.activeRequests.get(M.id);W&&(W.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let W=this.pendingRequests.get(M.channelName);W||(W=[],this.pendingRequests.set(M.channelName,W));const q=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:M,timeoutTimer:q})}flushPendingRequests(M){const W=this.pendingRequests.get(M);if(W){for(const q of W)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=g;var _;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(_=e.RequestInitiator||(e.RequestInitiator={}));class l{constructor(M,W=null){this.protocol=M,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=W}getChannel(M){const W=this;return{call(q,K,le){return W.isDisposed?Promise.reject(y.canceled()):W.requestPromise(M,q,K,le)},listen(q,K){return W.isDisposed?Promise.reject(y.canceled()):W.requestEvent(M,q,K)}}}requestPromise(M,W,q,K=A.CancellationToken.None){const le=this.lastRequestId++,Re={id:le,type:100,channelName:M,name:W,arg:q};if(K.isCancellationRequested)return Promise.reject(y.canceled());let Se;return new Promise((V,X)=>{if(K.isCancellationRequested)return X(y.canceled());const Z=()=>{const Be=pe=>{switch(pe.type){case 201:this.handlers.delete(le),V(pe.data);break;case 202:this.handlers.delete(le);const Ce=new Error(pe.data.message);Ce.stack=pe.data.stack,Ce.name=pe.data.name,X(Ce);break;case 203:this.handlers.delete(le),X(pe.data);break}};this.handlers.set(le,Be),this.sendRequest(Re)};let se=null;this.state===v.Idle?Z():(se=(0,I.createCancelablePromise)(Be=>this.whenInitialized()),se.then(()=>{se=null,Z()}));const fe=()=>{se?(se.cancel(),se=null):this.sendRequest({id:le,type:101}),X(y.canceled())},Ee=K.onCancellationRequested(fe);Se=(0,R.combinedDisposable)((0,R.toDisposable)(fe),Ee),this.activeRequests.add(Se)}).finally(()=>{this.activeRequests.delete(Se)})}requestEvent(M,W,q){const K=this.lastRequestId++,ve={id:K,type:102,channelName:M,name:W,arg:q};let Re=null;const Se=new b.Emitter({onFirstListenerAdd:()=>{Re=(0,I.createCancelablePromise)(V=>this.whenInitialized()),Re.then(()=>{Re=null,this.activeRequests.add(Se),this.sendRequest(ve)})},onLastListenerRemove:()=>{Re?(Re.cancel(),Re=null):(this.activeRequests.delete(Se),this.sendRequest({id:K,type:103}))}}),Oe=V=>Se.fire(V.data);return this.handlers.set(K,Oe),Se.event}sendRequest(M){switch(M.type){case 100:case 102:{const W=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(W,M.id,0,`${o(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const W=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(W,M.id,0,o(M.type));return}}}send(M,W=void 0){const q=new u;return a(q,M),a(q,W),this.sendBuffer(q.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(W){return 0}}onBuffer(M){const W=new S(M),q=p(W),K=p(W),le=q[0];switch(le){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,E(le)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],0,E(le),K),this.onResponse({type:q[0],id:q[1],data:K})}}onResponse(M){if(M.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(M.id);W&&W(M)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}qe([f.memoize],l.prototype,"onDidInitializePromise",null),e.ChannelClient=l;class w{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:W,onDidClientDisconnect:q})=>{b.Event.once(W.onMessage)(le=>{const ve=new S(le),Re=p(ve),Se=new g(W,Re),Oe=new l(W);this.channels.forEach((X,Z)=>Se.registerChannel(Z,X));const V={channelServer:Se,channelClient:Oe,ctx:Re};this._connections.add(V),this._onDidAddConnection.fire(V),q(()=>{Se.dispose(),Oe.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const M=[];return this._connections.forEach(W=>M.push(W)),M}getChannel(M,W){const q=this;return{call(K,le,ve){let Re;if((0,k.isFunction)(W)){let Oe=(0,D.getRandomElement)(q.connections.filter(W));Re=Oe?Promise.resolve(Oe):b.Event.toPromise(b.Event.filter(q.onDidAddConnection,W))}else Re=W.routeCall(q,K,le);const Se=Re.then(Oe=>Oe.channelClient.getChannel(M));return N(Se).call(K,le,ve)},listen(K,le){if((0,k.isFunction)(W))return q.getMulticastEvent(M,W,K,le);const ve=W.routeEvent(q,K,le).then(Re=>Re.channelClient.getChannel(M));return N(ve).listen(K,le)}}}getMulticastEvent(M,W,q,K){const le=this;let ve=new R.DisposableStore;const Re=new b.Emitter({onFirstListenerAdd:()=>{ve=new R.DisposableStore;const Se=new b.EventMultiplexer,Oe=new Map,V=Z=>{const fe=Z.channelClient.getChannel(M).listen(q,K),Ee=Se.add(fe);Oe.set(Z,Ee)},X=Z=>{const se=Oe.get(Z);!se||(se.dispose(),Oe.delete(Z))};le.connections.filter(W).forEach(V),b.Event.filter(le.onDidAddConnection,W)(V,void 0,ve),le.onDidRemoveConnection(X,void 0,ve),Se.event(Re.fire,Re,ve),ve.add(Se)},onLastListenerRemove:()=>{ve.dispose()}});return Re.event}registerChannel(M,W){this.channels.set(M,W),this._connections.forEach(q=>{q.channelServer.registerChannel(M,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class T{constructor(M,W,q=null){const K=new u;a(K,W),M.send(K.buffer),this.channelClient=new l(M,q),this.channelServer=new g(M,W,q)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,W){this.channelServer.registerChannel(M,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function N(F){return{call(M,W,q){return F.then(K=>K.call(M,W,q))},listen(M,W){const q=new b.Relay;return F.then(K=>q.input=K.listen(M,W)),q.event}}}e.getDelayedChannel=N;function z(F){let M=!1;return{call(W,q,K){return M?F.call(W,q,K):(0,I.timeout)(0).then(()=>M=!0).then(()=>F.call(W,q,K))},listen(W,q){if(M)return F.listen(W,q);const K=new b.Relay;return(0,I.timeout)(0).then(()=>M=!0).then(()=>K.input=F.listen(W,q)),K.event}}}e.getNextTickChannel=z;class ne{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const W of M.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await b.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ne;var ie;(function(F){function M(K,le){const ve=K,Re=le&&le.disableMarshalling,Se=new Map;for(const Oe in ve)q(Oe)&&Se.set(Oe,b.Event.buffer(ve[Oe],!0));return new class{listen(Oe,V){const X=Se.get(V);if(X)return X;throw new Error(`Event not found: ${V}`)}call(Oe,V,X){const Z=ve[V];if(typeof Z=="function"){if(!Re&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,r.revive)(X[se]);return Z.apply(ve,X)}throw new Error(`Method not found: ${V}`)}}}F.fromService=M;function W(K,le){const ve=le&&le.disableMarshalling;return new Proxy({},{get(Re,Se){var Oe;if(typeof Se=="string")return((Oe=le==null?void 0:le.properties)===null||Oe===void 0?void 0:Oe.has(Se))?le.properties.get(Se):q(Se)?K.listen(Se):async function(...V){let X;le&&!(0,k.isUndefinedOrNull)(le.context)?X=[le.context,...V]:X=V;const Z=await K.call(Se,X);return ve?Z:(0,r.revive)(Z)};throw new Error(`Property not found: ${String(Se)}`)}})}F.toService=W;function q(K){return K[0]==="o"&&K[1]==="n"&&P.isUpperAsciiLetter(K.charCodeAt(2))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function x(F){return Array.isArray(F)?F.map(B):B(F)}function L(F,M,W,q,K,le,ve){ve=x(ve);const Re=U[K],Se=Re[q%Re.length];let Oe=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(le)?(Oe=Oe.concat(ve),Oe.push(")")):Oe.push(ve),console.log.apply(console,Oe)}e.logWithColors=L;class O{constructor(M,W){this._outgoingPrefix=M,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,W,q,K,le){this._totalOutgoing+=M,L(this._outgoingPrefix,this._totalOutgoing,M,W,q,K,le)}logIncoming(M,W,q,K,le){this._totalIncoming+=M,L(this._incomingPrefix,this._totalIncoming,M,W,q,K,le)}}e.IPCLogger=O}),define(me[105],ge([0,1,3,104,6,23,10,36]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function k(){return D||(D=A.VSBuffer.alloc(0)),D}class r{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,i){if(s===0)return k();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const _=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=s),_}if(this._chunks[0].byteLength>s){const _=this._chunks[0].slice(0,s);return i&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),_}let a=A.VSBuffer.alloc(s),p=0,g=0;for(;s>0;){const _=this._chunks[g];if(_.byteLength>s){const l=_.slice(0,s);a.set(l,p),p+=s,i&&(this._chunks[g]=_.slice(s),this._totalLength-=s),s-=s}else a.set(_,p),p+=_.byteLength,i?(this._chunks.shift(),this._totalLength-=_.byteLength):g++,s-=_.byteLength}return a}}e.ChunkStream=r;var P;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(P||(P={}));var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(s,i,a,p){this.type=s,this.id=i,this.ack=a,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends I.Disposable{constructor(s){super();this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new r,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const a=this._state.messageType,p=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(a,p,g,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=A.VSBuffer.alloc(13);i.writeUInt8(s.type,0),i.writeUInt32BE(s.id,1),i.writeUInt32BE(s.ack,5),i.writeUInt32BE(s.data.byteLength,9),this._writeSoon(i,s.data)}}_bufferAdd(s,i){const a=this._totalLength===0;return this._data.push(s,i),this._totalLength+=s.byteLength+i.byteLength,a}_bufferTake(){const s=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,i){this._bufferAdd(s,i)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends I.Disposable{constructor(s){super();this._onMessage=new b.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new o(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new m(1,0,0,s))}}e.Protocol=E;class v extends R.IPCClient{constructor(s,i,a=null){super(s,i,a);this.protocol=s}static fromSocket(s,i){return new v(new E(s),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=v;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new b.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class u{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],i=0,a=this._first;for(;a;)s[i++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const i=new u(s);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class h{constructor(){this.lastRuns=[];const s=Date.now();for(let i=0;i<h._HISTORY_LENGTH;i++)this.lastRuns[i]=s-1e3*i;setInterval(()=>{for(let i=h._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}load(){const s=Date.now(),i=(1+h._HISTORY_LENGTH)*1e3;let a=0;for(let p=0;p<h._HISTORY_LENGTH;p++)s-this.lastRuns[p]<=i&&a++;return 1-a/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}h._HISTORY_LENGTH=10,h._INSTANCE=null;class t{constructor(s,i=null){this._loadEstimator=h.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new o(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new m(5,0,0,k());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const i=new m(4,0,0,k());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,i){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new o(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let i=0,a=s.length;i<a;i++)this._socketWriter.write(s[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new m(6,0,0,k())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const i=this._outgoingUnackMsg.toArray();for(let a=0,p=i.length;a<p;a++)this._socketWriter.write(i[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new m(1,i,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const i=new m(2,0,0,s);this._socketWriter.write(i)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),i=Date.now()-s.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new m(3,0,this._incomingAckId,k());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(me[106],ge([0,1,95]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(C){let D=(0,b.toUint8)(C);this._defaultValue=D,this._asciiMap=R._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let k=0;k<256;k++)D[k]=C;return D}set(C,D){let k=(0,b.toUint8)(D);C>=0&&C<256?this._asciiMap[C]=k:this._map.set(C,k)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=R;var I;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(I||(I={}));class A{constructor(){this._actual=new R(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=A}),define(me[138],ge([0,1,106]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends b.CharacterClassifier{constructor(C){super(0);for(let D=0,k=C.length;D<k;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function A(y){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=y(D)),C[D])}e.getMapForWordSeparators=A(y=>new I(y))}),define(me[47],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(I,A){this.lineNumber=I,this.column=A}with(I=this.lineNumber,A=this.column){return I===this.lineNumber&&A===this.column?this:new b(I,A)}delta(I=0,A=0){return this.with(this.lineNumber+I,this.column+A)}equals(I){return b.equals(this,I)}static equals(I,A){return!I&&!A?!0:!!I&&!!A&&I.lineNumber===A.lineNumber&&I.column===A.column}isBefore(I){return b.isBefore(this,I)}static isBefore(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<A.column}isBeforeOrEqual(I){return b.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<=A.column}static compare(I,A){let y=I.lineNumber|0,C=A.lineNumber|0;if(y===C){let D=I.column|0,k=A.column|0;return D-k}return y-C}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new b(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=b}),define(me[43],ge([0,1,47]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(A,y,C,D){A>C||A===C&&y>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return R.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return R.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return R.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return R.plusRange(this,A)}static plusRange(A,y){let C,D,k,r;return y.startLineNumber<A.startLineNumber?(C=y.startLineNumber,D=y.startColumn):y.startLineNumber===A.startLineNumber?(C=y.startLineNumber,D=Math.min(y.startColumn,A.startColumn)):(C=A.startLineNumber,D=A.startColumn),y.endLineNumber>A.endLineNumber?(k=y.endLineNumber,r=y.endColumn):y.endLineNumber===A.endLineNumber?(k=y.endLineNumber,r=Math.max(y.endColumn,A.endColumn)):(k=A.endLineNumber,r=A.endColumn),new R(C,D,k,r)}intersectRanges(A){return R.intersectRanges(this,A)}static intersectRanges(A,y){let C=A.startLineNumber,D=A.startColumn,k=A.endLineNumber,r=A.endColumn,P=y.startLineNumber,f=y.startColumn,m=y.endLineNumber,o=y.endColumn;return C<P?(C=P,D=f):C===P&&(D=Math.max(D,f)),k>m?(k=m,r=o):k===m&&(r=Math.min(r,o)),C>k||C===k&&D>r?null:new R(C,D,k,r)}equalsRange(A){return R.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(A){return new b.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(A){return new b.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new R(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new R(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(A){return new R(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new R(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const k=A.startLineNumber|0,r=y.startLineNumber|0;if(k===r){const P=A.startColumn|0,f=y.startColumn|0;if(P===f){const m=A.endLineNumber|0,o=y.endLineNumber|0;if(m===o){const d=A.endColumn|0,E=y.endColumn|0;return d-E}return m-o}return P-f}return k-r}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=R}),define(me[139],ge([0,1,47,43]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class A extends R.Range{constructor(C,D,k,r){super(C,D,k,r);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=k,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return A.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,C,D):new A(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new A(C,D,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new A(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new A(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let k=0,r=C.length;k<r;k++)if(!this.selectionsEqual(C[k],D[k]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,k,r,P){return P===0?new A(C,D,k,r):new A(k,r,C,D)}}e.Selection=A}),define(me[107],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var I;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(d){this.tabSize=Math.max(1,d.tabSize|0),this.indentSize=d.tabSize|0,this.insertSpaces=Boolean(d.insertSpaces),this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=Boolean(d.trimAutoWhitespace)}equals(d){return this.tabSize===d.tabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class D{constructor(d,E){this.range=d,this.matches=E}}e.FindMatch=D;var k;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var r;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right"})(r=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class f{constructor(d,E,v,S,u,c){this.identifier=d,this.range=E,this.text=v,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=u,this._isTracked=c}}e.ValidAnnotatedEditOperation=f;class m{constructor(d,E,v){this.reverseEdits=d,this.changes=E,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=m}),define(me[140],ge([0,1,8,138,47,43,107]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(u,c,h,t){this.searchString=u,this.isRegex=c,this.matchCase=h,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=k(this.searchString):u=this.searchString.indexOf(`
`)>=0;let c=null;try{c=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let h=!this.isRegex&&!u;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new r(c,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,h?this.searchString:null)}}e.SearchParams=D;function k(S){if(!S||S.length===0)return!1;for(let u=0,c=S.length;u<c;u++)if(S.charCodeAt(u)===92){if(u++,u>=c)break;const t=S.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class r{constructor(u,c,h){this.regex=u,this.wordSeparators=c,this.simpleSearch=h}}e.SearchData=r;function P(S,u,c){if(!c)return new y.FindMatch(S,null);let h=[];for(let t=0,n=u.length;t<n;t++)h[t]=u[t];return new y.FindMatch(S,h)}e.createFindMatch=P;class f{constructor(u){let c=[],h=0;for(let t=0,n=u.length;t<n;t++)u.charCodeAt(t)===10&&(c[h++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(u){const c=this._lineFeedsOffsets;let h=0,t=c.length-1;if(t===-1||u<=c[0])return 0;for(;h<t;){const n=h+((t-h)/2>>0);c[n]>=u?t=n-1:c[n+1]>=u?(h=n,t=n):h=n+1}return h+1}}class m{static findMatches(u,c,h,t,n){const s=c.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,h,new v(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(u,h,s,t,n):[]}static _getMultilineMatchRange(u,c,h,t,n,s){let i,a=0;t?(a=t.findLineFeedCountBeforeOffset(n),i=c+n+a):i=c+n;let p;if(t){let w=t.findLineFeedCountBeforeOffset(n+s.length)-a;p=i+s.length+w}else p=i+s.length;const g=u.getPositionAt(i),_=u.getPositionAt(p);return new A.Range(g.lineNumber,g.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(u,c,h,t,n){const s=u.getOffsetAt(c.getStartPosition()),i=u.getValueInRange(c,1),a=u.getEOL()===`\r
`?new f(i):null,p=[];let g=0,_;for(h.reset(0);_=h.next(i);)if(p[g++]=P(this._getMultilineMatchRange(u,s,i,a,_.index,_[0]),_,t),g>=n)return p;return p}static _doFindMatchesLineByLine(u,c,h,t,n){const s=[];let i=0;if(c.startLineNumber===c.endLineNumber){const p=u.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return i=this._findMatchesInLine(h,p,c.startLineNumber,c.startColumn-1,i,s,t,n),s}const a=u.getLineContent(c.startLineNumber).substring(c.startColumn-1);i=this._findMatchesInLine(h,a,c.startLineNumber,c.startColumn-1,i,s,t,n);for(let p=c.startLineNumber+1;p<c.endLineNumber&&i<n;p++)i=this._findMatchesInLine(h,u.getLineContent(p),p,0,i,s,t,n);if(i<n){const p=u.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);i=this._findMatchesInLine(h,p,c.endLineNumber,0,i,s,t,n)}return s}static _findMatchesInLine(u,c,h,t,n,s,i,a){const p=u.wordSeparators;if(!i&&u.simpleSearch){const l=u.simpleSearch,w=l.length,T=c.length;let N=-w;for(;(N=c.indexOf(l,N+w))!==-1;)if((!p||E(p,c,T,N,w))&&(s[n++]=new y.FindMatch(new A.Range(h,N+1+t,h,N+1+w+t),null),n>=a))return n;return n}const g=new v(u.wordSeparators,u.regex);let _;g.reset(0);do if(_=g.next(c),_&&(s[n++]=P(new A.Range(h,_.index+1+t,h,_.index+1+_[0].length+t),_,i),n>=a))return n;while(_);return n}static findNextMatch(u,c,h,t){const n=c.parseSearchRequest();if(!n)return null;const s=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(u,h,s,t):this._doFindNextMatchLineByLine(u,h,s,t)}static _doFindNextMatchMultiline(u,c,h,t){const n=new I.Position(c.lineNumber,1),s=u.getOffsetAt(n),i=u.getLineCount(),a=u.getValueInRange(new A.Range(n.lineNumber,n.column,i,u.getLineMaxColumn(i)),1),p=u.getEOL()===`\r
`?new f(a):null;h.reset(c.column-1);let g=h.next(a);return g?P(this._getMultilineMatchRange(u,s,a,p,g.index,g[0]),g,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(u,new I.Position(1,1),h,t):null}static _doFindNextMatchLineByLine(u,c,h,t){const n=u.getLineCount(),s=c.lineNumber,i=u.getLineContent(s),a=this._findFirstMatchInLine(h,i,s,c.column,t);if(a)return a;for(let p=1;p<=n;p++){const g=(s+p-1)%n,_=u.getLineContent(g+1),l=this._findFirstMatchInLine(h,_,g+1,1,t);if(l)return l}return null}static _findFirstMatchInLine(u,c,h,t,n){u.reset(t-1);const s=u.next(c);return s?P(new A.Range(h,s.index+1,h,s.index+1+s[0].length),s,n):null}static findPreviousMatch(u,c,h,t){const n=c.parseSearchRequest();if(!n)return null;const s=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(u,h,s,t):this._doFindPreviousMatchLineByLine(u,h,s,t)}static _doFindPreviousMatchMultiline(u,c,h,t){const n=this._doFindMatchesMultiline(u,new A.Range(1,1,c.lineNumber,c.column),h,t,10*C);if(n.length>0)return n[n.length-1];const s=u.getLineCount();return c.lineNumber!==s||c.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new I.Position(s,u.getLineMaxColumn(s)),h,t):null}static _doFindPreviousMatchLineByLine(u,c,h,t){const n=u.getLineCount(),s=c.lineNumber,i=u.getLineContent(s).substring(0,c.column-1),a=this._findLastMatchInLine(h,i,s,t);if(a)return a;for(let p=1;p<=n;p++){const g=(n+s-p-1)%n,_=u.getLineContent(g+1),l=this._findLastMatchInLine(h,_,g+1,t);if(l)return l}return null}static _findLastMatchInLine(u,c,h,t){let n=null,s;for(u.reset(0);s=u.next(c);)n=P(new A.Range(h,s.index+1,h,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=m;function o(S,u,c,h,t){if(h===0)return!0;const n=u.charCodeAt(h-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(h);if(S.get(s)!==0)return!0}return!1}function d(S,u,c,h,t){if(h+t===c)return!0;const n=u.charCodeAt(h+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(h+t-1);if(S.get(s)!==0)return!0}return!1}function E(S,u,c,h,t){return o(S,u,c,h,t)&&d(S,u,c,h,t)}e.isValidMatch=E;class v{constructor(u,c){this._wordSeparators=u,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const c=u.length;let h;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(h=this._searchRegex.exec(u),!h))return null;const t=h.index,n=h[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){b.getNextCodePoint(u,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,u,c,t,n))return h}while(h);return null}}e.Searcher=v}),define(me[108],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)C.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=b();function R(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),D=new RegExp(C.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=R;const I={maxLen:1e3,windowSize:15,timeBudget:150};function A(C,D,k,r,P=I){if(k.length>P.maxLen){let E=C-P.maxLen/2;return E<0?E=0:r+=E,k=k.substring(E,C+P.maxLen/2),A(C,D,k,r,P)}const f=Date.now(),m=C-1-r;let o=-1,d=null;for(let E=1;!(Date.now()-f>=P.timeBudget);E++){const v=m-P.windowSize*E;D.lastIndex=Math.max(0,v);const S=y(D,k,m,o);if(!S&&d||(d=S,v<=0))break;o=v}if(d){let E={word:d[0],startColumn:r+1+d.index,endColumn:r+1+d.index+d[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=A;function y(C,D,k,r){let P;for(;P=C.exec(D);){const f=P.index||0;if(f<=k&&C.lastIndex>=k)return P;if(r>0&&f>r)return null}return null}}),define(me[141],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class R{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,k=C.notIn.length;D<k;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=R;class I{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=I;function A(y,C,D){y.has(C)?y.get(C).push(D):y.set(C,[D])}}),define(me[78],ge([0,1,32,9]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(A,y,C,D){if(Array.isArray(A)){let k=0;for(const r of A){const P=I(r,y,C,D);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof A=="string")return D?A==="*"?5:A===C?10:0:0;if(A){const{language:k,pattern:r,scheme:P,hasAccessToAllModels:f}=A;if(!D&&!f)return 0;let m=0;if(P)if(P===y.scheme)m=10;else if(P==="*")m=5;else return 0;if(k)if(k===C)m=10;else if(k==="*")m=Math.max(m,5);else return 0;if(r){let o;if(typeof r=="string"?o=r:o=Object.assign(Object.assign({},r),{base:(0,R.normalize)(r.base)}),o===y.fsPath||(0,b.match)(o,y.fsPath))m=10;else return 0}return m}else return 0}}e.score=I}),define(me[142],ge([0,1,106]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class I{constructor(o,d,E){const v=new Uint8Array(o*d);for(let S=0,u=o*d;S<u;S++)v[S]=E;this._data=v,this.rows=o,this.cols=d}get(o,d){return this._data[o*this.cols+d]}set(o,d,E){this._data[o*this.cols+d]=E}}e.Uint8Matrix=I;class A{constructor(o){let d=0,E=0;for(let S=0,u=o.length;S<u;S++){let[c,h,t]=o[S];h>d&&(d=h),c>E&&(E=c),t>E&&(E=t)}d++,E++;let v=new I(E,d,0);for(let S=0,u=o.length;S<u;S++){let[c,h,t]=o[S];v.set(c,h,t)}this._states=v,this._maxCharCode=d}nextState(o,d){return d<0||d>=this._maxCharCode?0:this._states.get(o,d)}}e.StateMachine=A;let y=null;function C(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let k=null;function r(){if(k===null){k=new b.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<m.length;d++)k.set(m.charCodeAt(d),1);const o=".,;";for(let d=0;d<o.length;d++)k.set(o.charCodeAt(d),2)}return k}class P{static _createLink(o,d,E,v,S){let u=S-1;do{const c=d.charCodeAt(u);if(o.get(c)!==2)break;u--}while(u>v);if(v>0){const c=d.charCodeAt(v-1),h=d.charCodeAt(u);(c===40&&h===41||c===91&&h===93||c===123&&h===125)&&u--}return{range:{startLineNumber:E,startColumn:v+1,endLineNumber:E,endColumn:u+2},url:d.substring(v,u+1)}}static computeLinks(o,d=C()){const E=r();let v=[];for(let S=1,u=o.getLineCount();S<=u;S++){const c=o.getLineContent(S),h=c.length;let t=0,n=0,s=0,i=1,a=!1,p=!1,g=!1,_=!1;for(;t<h;){let l=!1;const w=c.charCodeAt(t);if(i===13){let T;switch(w){case 40:a=!0,T=0;break;case 41:T=a?0:1;break;case 91:g=!0,p=!0,T=0;break;case 93:g=!1,T=p?0:1;break;case 123:_=!0,T=0;break;case 125:T=_?0:1;break;case 39:T=s===34||s===96?0:1;break;case 34:T=s===39||s===96?0:1;break;case 96:T=s===39||s===34?0:1;break;case 42:T=s===42?1:0;break;case 124:T=s===124?1:0;break;case 32:T=g?0:1;break;default:T=E.get(w)}T===1&&(v.push(P._createLink(E,c,S,n,t)),l=!0)}else if(i===12){let T;w===91?(p=!0,T=0):T=E.get(w),T===1?l=!0:i=13}else i=d.nextState(i,w),i===0&&(l=!0);l&&(i=1,a=!1,p=!1,_=!1,n=t+1,s=w),t++}i===13&&v.push(P._createLink(E,c,S,n,h))}return v}}e.LinkComputer=P;function f(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:P.computeLinks(m)}e.computeLinks=f}),define(me[143],ge([0,1,3,6]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,C){return this._map.set(y,C),this.fire([y]),(0,R.toDisposable)(()=>{this._map.get(y)===C&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,C){let D=null,k=!1;return this._promises.set(y,C.then(r=>{this._promises.delete(y),!(k||!r)&&(D=this.register(y,r))})),(0,R.toDisposable)(()=>{k=!0,D&&D.dispose()})}getPromise(y){const C=this.get(y);if(C)return Promise.resolve(C);const D=this._promises.get(y);return D?D.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(me[109],ge([0,1,23,10]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(I||(I={}));function A(P){for(let f=0,m=P.length;f<m;f+=4){const o=P[f+0],d=P[f+1],E=P[f+2],v=P[f+3];P[f+0]=v,P[f+1]=E,P[f+2]=d,P[f+3]=o}}function y(P){const f=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.isLittleEndian()||A(f),b.VSBuffer.wrap(f)}function C(P){const f=P.buffer;if(R.isLittleEndian()||A(f),f.byteOffset%4==0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const m=new Uint8Array(f.byteLength);return m.set(f),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function D(P){const f=new Uint32Array(k(P));let m=0;if(f[m++]=P.id,P.type==="full")f[m++]=1,f[m++]=P.data.length,f.set(P.data,m),m+=P.data.length;else{f[m++]=2,f[m++]=P.deltas.length;for(const o of P.deltas)f[m++]=o.start,f[m++]=o.deleteCount,o.data?(f[m++]=o.data.length,f.set(o.data,m),m+=o.data.length):f[m++]=0}return y(f)}e.encodeSemanticTokensDto=D;function k(P){let f=0;if(f+=1+1,P.type==="full")f+=1+P.data.length;else{f+=1,f+=(1+1+1)*P.deltas.length;for(const m of P.deltas)m.data&&(f+=m.data.length)}return f}function r(P){const f=C(P);let m=0;const o=f[m++];if(f[m++]===1){const S=f[m++],u=f.subarray(m,m+S);return m+=S,{id:o,type:"full",data:u}}const E=f[m++];let v=[];for(let S=0;S<E;S++){const u=f[m++],c=f[m++],h=f[m++];let t;h>0&&(t=f.subarray(m,m+h),m+=h),v[S]={start:u,deleteCount:c,data:t}}return{id:o,type:"delta",deltas:v}}e.decodeSemanticTokensDto=r}),define(me[110],ge([0,1,95]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(y,C){this.index=y,this.remainder=C}}e.PrefixSumIndexOfResult=R;class I{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,C){y=(0,b.toUint32)(y);const D=this.values,k=this.prefixSum,r=C.length;return r===0?!1:(this.values=new Uint32Array(D.length+r),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+r),this.values.set(C,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,C){return y=(0,b.toUint32)(y),C=(0,b.toUint32)(C),this.values[y]===C?!1:(this.values[y]=C,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,C){y=(0,b.toUint32)(y),C=(0,b.toUint32)(C);const D=this.values,k=this.prefixSum;if(y>=D.length)return!1;let r=D.length-y;return C>=r&&(C=r),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+C),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),y>=this.values.length&&(y=this.values.length-1);for(let D=C;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let C=0,D=this.values.length-1,k=0,r=0,P=0;for(;C<=D;)if(k=C+(D-C)/2|0,r=this.prefixSum[k],P=r-this.values[k],y<P)D=k-1;else if(y>=r)C=k+1;else break;return new R(k,y-P)}}e.PrefixSumComputer=I}),define(me[144],ge([0,1,8,47,110]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(C,D,k,r){this._uri=C,this._lines=D,this._eol=k,this._versionId=r,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const k of D)this._acceptDeleteRange(k.range),this._acceptInsertText(new R.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,k=new Uint32Array(D);for(let r=0;r<D;r++)k[r]=this._lines[r].length+C;this._lineStarts=new I.PrefixSumComputer(k)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length!==0){let k=(0,b.splitLines)(D);if(k.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}k[k.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]);let r=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(C.lineNumber+P-1,0,k[P]),r[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,r)}}}e.MirrorTextModel=A}),define(me[145],ge([18,19]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(me[146],ge([0,1,145]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,I=R*60,A=I*24,y=A*7,C=A*30,D=A*365;function k(P,f){typeof P!="number"&&(P=P.getTime());const m=Math.round((new Date().getTime()-P)/1e3);if(m<-30)return(0,b.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(m<30)return(0,b.localize)(1,null);let o;return m<R?(o=m,f?o===1?(0,b.localize)(2,null,o):(0,b.localize)(3,null,o):o===1?(0,b.localize)(4,null,o):(0,b.localize)(5,null,o)):m<I?(o=Math.floor(m/R),f?o===1?(0,b.localize)(6,null,o):(0,b.localize)(7,null,o):o===1?(0,b.localize)(8,null,o):(0,b.localize)(9,null,o)):m<A?(o=Math.floor(m/I),f?o===1?(0,b.localize)(10,null,o):(0,b.localize)(11,null,o):o===1?(0,b.localize)(12,null,o):(0,b.localize)(13,null,o)):m<y?(o=Math.floor(m/A),f?o===1?(0,b.localize)(14,null,o):(0,b.localize)(15,null,o):o===1?(0,b.localize)(16,null,o):(0,b.localize)(17,null,o)):m<C?(o=Math.floor(m/y),f?o===1?(0,b.localize)(18,null,o):(0,b.localize)(19,null,o):o===1?(0,b.localize)(20,null,o):(0,b.localize)(21,null,o)):m<D?(o=Math.floor(m/C),f?o===1?(0,b.localize)(22,null,o):(0,b.localize)(23,null,o):o===1?(0,b.localize)(24,null,o):(0,b.localize)(25,null,o)):(o=Math.floor(m/D),f?o===1?(0,b.localize)(26,null,o):(0,b.localize)(27,null,o):o===1?(0,b.localize)(28,null,o):(0,b.localize)(29,null,o))}e.fromNow=k;function r(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(me[147],ge([18,19]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,147,11,16]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(k,r){return r&&(k.stack||k.stacktrace)?b.localize(0,null,C(k),y(k.stack)||y(k.stacktrace)):C(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?b.localize(1,null,k.message):k.message||b.localize(2,null)}function D(k=null,r=!1){if(!k)return b.localize(3,null);if(Array.isArray(k)){const P=I.coalesce(k),f=D(P[0],r);return P.length>1?b.localize(4,null,f,P.length):f}if(R.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return A(P.error,r);if(P.exception)return A(P.exception,r)}return k.stack?A(k,r):k.message?k.message:b.localize(5,null)}e.toErrorMessage=D}),define(me[148],ge([18,19]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(me[111],ge([0,1,9,37,28,38,148,36,11,24,29,10,137,12]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function o(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(h,t){if(P.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const s=A.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],n);return new Promise(i=>{s.once("error",a=>{i({success:!1,error:a})}),s.once("exit",(a,p)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?o(n.status):1})}else if(P.isLinux||P.isMacintosh)try{const n=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(s=>{A.execFile(n,[h.pid.toString()],{encoding:"utf8",shell:!0},(i,a,p)=>{s(i?{success:!1,error:i}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function E(h=C.env){return h.comspec||"cmd.exe"}e.getWindowsShell=E;class v{constructor(t,n,s,i){if(n!==void 0&&s!==void 0&&i!==void 0)this.cmd=t,this.args=n,this.shell=s,this.options=i;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(C.env).forEach(p=>{a[p]=C.env[p]}),Object.keys(this.options.env).forEach(p=>{a[p]=this.options.env[p]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(b.sep);return n!==-1&&(t=t.substring(n+1)),v.WellKnowCommands[t]?t:"other"}start(t){return P.isWindows&&(this.options&&this.options.cwd&&r.isUNC(this.options.cwd)||!this.options&&r.isUNC(C.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let s,i;const a=new Promise((p,g)=>{s=p,i=g});if(n){let p=this.cmd;this.args&&(p=p+" "+this.args.join(" ")),this.childProcess=A.exec(p,this.options,(g,_,l)=>{this.childProcess=null;const w=g;w&&w.killed?i({killed:this.terminateRequested,stdout:_.toString(),stderr:l.toString()}):this.handleExec(s,t,g,_,l)})}else{let p=null;const g=_=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(_,s,t,i);const l={terminated:this.terminateRequested};D.isNumber(_)&&(l.cmdCode=_),s(l)};if(this.shell&&P.isWindows){const _=k.deepClone(this.options);_.windowsVerbatimArguments=!0,_.detached=!1;let l=!1,w=!1;const T=[];let N=this.ensureQuotes(this.cmd);T.push(N.value),l=N.quoted,this.args&&this.args.forEach(ne=>{N=this.ensureQuotes(ne),T.push(N.value),w=w&&N.quoted});const z=["/s","/c"];l?w?z.push('"'+T.join(" ")+'"'):T.length>1?z.push('"'+T[0]+'" '+T.slice(1).join(" ")):z.push('"'+T[0]+'"'):z.push(T.join(" ")),p=A.spawn(E(),z,_)}else this.cmd&&(p=A.spawn(this.cmd,this.args,this.options));p&&(this.childProcess=p,this.childProcessPromise=Promise.resolve(p),this.pidResolve&&(this.pidResolve(D.isNumber(p.pid)?p.pid:-1),this.pidResolve=void 0),p.on("error",_=>{this.childProcess=null,i({terminated:this.terminateRequested,error:_})}),p.pid&&(this.childProcess.on("close",g),this.handleSpawn(p,s,t,i,!0)))}return a})}handleClose(t,n,s,i){}ensureQuotes(t){return v.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,d(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!P.isWindows)return t(!1);const n=A.spawn(E(),["/s","/c"]);n.on("error",s=>t(!0)),n.on("exit",s=>t(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class S extends v{constructor(t,n,s,i){super(t,n,s,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,s,i,a){[i,a].forEach((p,g)=>{const _=new f.LineDecoder;_.write(p).forEach(T=>{n({line:T,source:g===0?0:1})});const w=_.end();w&&n({line:w,source:g===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,n,s,i,a){const p=new f.LineDecoder,g=new f.LineDecoder;t.stdout.on("data",_=>{p.write(_).forEach(w=>s({line:w,source:0}))}),t.stderr.on("data",_=>{g.write(_).forEach(w=>s({line:w,source:1}))}),this.stdoutLineDecoder=p,this.stderrLineDecoder=g}handleClose(t,n,s,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&s({line:a,source:0});const p=this.stderrLineDecoder?this.stderrLineDecoder.end():null;p&&s({line:p,source:1})}}e.LineProcess=S;function u(h){let t=[],n=!1;const s=function(i){if(n){t.push(i);return}(!h.send(i,p=>{if(p&&console.error(p),n=!1,t.length>0){const g=t.slice(0);t=[],g.forEach(_=>s(_))}})||P.isWindows)&&(n=!0)};return{send:s}}e.createQueuedSender=u;var c;(function(h){async function t(n,s,i){if(b.isAbsolute(n))return n;if(s===void 0&&(s=C.cwd()),b.dirname(n)!=="."||(i===void 0&&D.isString(C.env.PATH)&&(i=C.env.PATH.split(b.delimiter)),i===void 0||i.length===0))return b.join(s,n);async function p(g){return await I.exists(g)?!(await R.promises.stat(g)).isDirectory():!1}for(let g of i){let _;if(b.isAbsolute(g)?_=b.join(g,n):_=b.join(s,g,n),await p(_))return _;let l=_+".com";if(await p(l)||(l=_+".exe",await p(l)))return l}return b.join(s,n)}h.findExecutable=t})(c=e.win32||(e.win32={}))}),define(me[149],ge([18,19]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(me[150],ge([0,1,149,10,108]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=y;class C{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,we){this._values[te]=we}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class k{constructor(te,we,xe,je){this.id=te,this.name=we,this.defaultValue=xe,this.schema=je}compute(te,we,xe){return xe}}class r{constructor(te,we=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=we}validate(te){return this.defaultValue}}class P{constructor(te,we,xe,je){this.id=te,this.name=we,this.defaultValue=xe,this.schema=je}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,we,xe){return xe}}function f(G,te){return typeof G=="undefined"?te:G==="false"?!1:Boolean(G)}e.boolean=f;class m extends P{constructor(te,we,xe,je=void 0){typeof je!="undefined"&&(je.type="boolean",je.default=xe),super(te,we,xe,je)}validate(te){return f(te,this.defaultValue)}}class o extends P{constructor(te,we,xe,je,Ve,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=xe,Je.minimum=je,Je.maximum=Ve),super(te,we,xe,Je),this.minimum=je,this.maximum=Ve}static clampedInt(te,we,xe,je){if(typeof te=="undefined")return we;let Ve=parseInt(te,10);return isNaN(Ve)?we:(Ve=Math.max(xe,Ve),Ve=Math.min(je,Ve),Ve|0)}validate(te){return o.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class d extends P{constructor(te,we,xe,je,Ve){typeof Ve!="undefined"&&(Ve.type="number",Ve.default=xe),super(te,we,xe,Ve),this.validationFn=je}static clamp(te,we,xe){return te<we?we:te>xe?xe:te}static float(te,we){if(typeof te=="number")return te;if(typeof te=="undefined")return we;const xe=parseFloat(te);return isNaN(xe)?we:xe}validate(te){return this.validationFn(d.float(te,this.defaultValue))}}class E extends P{static string(te,we){return typeof te!="string"?we:te}constructor(te,we,xe,je=void 0){typeof je!="undefined"&&(je.type="string",je.default=xe),super(te,we,xe,je)}validate(te){return E.string(te,this.defaultValue)}}function v(G,te,we){return typeof G!="string"||we.indexOf(G)===-1?te:G}e.stringSet=v;class S extends P{constructor(te,we,xe,je,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=je,Ve.default=xe),super(te,we,xe,Ve),this._allowedValues=je}validate(te){return v(te,this.defaultValue,this._allowedValues)}}class u extends k{constructor(te,we,xe,je,Ve,Je,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=Ve,De.default=je),super(te,we,xe,De),this._allowedValues=Ve,this._convert=Je}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function c(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,we,xe){return xe===0?te.accessibilitySupport:xe}}class t extends k{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:b.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{insertSpace:f(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(G){switch(G){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function p(G){switch(G){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class g extends r{constructor(){super(124,[62,31])}compute(te,we,xe){const je=["monaco-editor"];return we.get(31)&&je.push(we.get(31)),te.extraEditorClassName&&je.push(te.extraEditorClassName),we.get(62)==="default"?je.push("mouse-default"):we.get(62)==="copy"&&je.push("mouse-copy"),we.get(97)&&je.push("showUnused"),we.get(122)&&je.push("showDeprecated"),je.join(" ")}}class _ extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(te,we,xe){return xe&&te.emptySelectionClipboard}}class l extends k{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:b.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:b.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{cursorMoveOnType:f(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:f(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":v(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(we.loop,this.defaultValue.loop)}}}class w extends k{constructor(){super(41,"fontLigatures",w.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?w.OFF:te==="true"?w.ON:te:Boolean(te)?w.ON:w.OFF}}e.EditorFontLigatures=w,w.OFF='"liga" off, "calt" off',w.ON='"liga" on, "calt" on';class T extends r{constructor(){super(40)}compute(te,we,xe){return te.fontInfo}}class N extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(te){let we=d.float(te,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(we,6,100)}compute(te,we,xe){return te.fontInfo.fontSize}}class z extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(o.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class ne extends k{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},we),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},we),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},we),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},we),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},we),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:xe,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:xe,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:xe,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:xe,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:xe,description:b.localize(35,null)}})}validate(te){var we,xe,je,Ve,Je;if(!te||typeof te!="object")return this.defaultValue;const De=te;return{multiple:v(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(we=De.multipleDefinitions)!==null&&we!==void 0?we:v(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=De.multipleTypeDefinitions)!==null&&xe!==void 0?xe:v(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(je=De.multipleDeclarations)!==null&&je!==void 0?je:v(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ve=De.multipleImplementations)!==null&&Ve!==void 0?Ve:v(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Je=De.multipleReferences)!==null&&Je!==void 0?Je:v(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ie extends k{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:b.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:f(we.enabled,this.defaultValue.enabled),delay:o.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:f(we.sticky,this.defaultValue.sticky)}}}var U;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class B extends r{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(te,we,xe){return B.computeLayout(we,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const we=te.height/te.lineHeight,xe=te.scrollBeyondLastLine?we-1:0,je=(te.viewLineCount+xe)/(te.pixelRatio*te.height),Ve=Math.floor(te.viewLineCount/je);return{typicalViewportLineCount:we,extraLinesBeyondLastLine:xe,desiredRatio:je,minimapLineCount:Ve}}static _computeMinimapLayout(te,we){const xe=te.outerWidth,je=te.outerHeight,Ve=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Je=we.stableMinimapLayoutInput,De=Je&&te.outerHeight===Je.outerHeight&&te.lineHeight===Je.lineHeight&&te.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&te.pixelRatio===Je.pixelRatio&&te.scrollBeyondLastLine===Je.scrollBeyondLastLine&&te.minimap.enabled===Je.minimap.enabled&&te.minimap.side===Je.minimap.side&&te.minimap.size===Je.minimap.size&&te.minimap.showSlider===Je.minimap.showSlider&&te.minimap.renderCharacters===Je.minimap.renderCharacters&&te.minimap.maxColumn===Je.minimap.maxColumn&&te.minimap.scale===Je.minimap.scale&&te.verticalScrollbarWidth===Je.verticalScrollbarWidth&&te.isViewportWrapping===Je.isViewportWrapping,ye=te.lineHeight,Ie=te.typicalHalfwidthCharacterWidth,oe=te.scrollBeyondLastLine,ue=te.minimap.renderCharacters;let H=Ve>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const J=te.minimap.maxColumn,ce=te.minimap.size,Pe=te.minimap.side,Ae=te.verticalScrollbarWidth,Fe=te.viewLineCount,We=te.remainingWidth,Xe=te.isViewportWrapping,rt=ue?2:3;let tt=Math.floor(Ve*je);const Qe=tt/Ve;let gt=!1,wt=!1,be=rt*H,he=H/Ve,ae=1;if(ce==="fill"||ce==="fit"){const{typicalViewportLineCount:ut,extraLinesBeyondLastLine:Ze,desiredRatio:mt,minimapLineCount:ht}=B.computeContainedMinimapLineCount({viewLineCount:Fe,scrollBeyondLastLine:oe,height:je,lineHeight:ye,pixelRatio:Ve});if(Fe/ht>1)gt=!0,wt=!0,H=1,be=1,he=H/Ve;else{let at=!1,St=H+1;if(ce==="fit"){const Et=Math.ceil((Fe+Ze)*be);Xe&&De&&We<=we.stableFitRemainingWidth?(at=!0,St=we.stableFitMaxMinimapScale):(at=Et>tt,Xe&&at?(we.stableMinimapLayoutInput=te,we.stableFitRemainingWidth=We):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0))}if(ce==="fill"||at){gt=!0;const Et=H;be=Math.min(ye*Ve,Math.max(1,Math.floor(1/mt))),H=Math.min(St,Math.max(1,Math.floor(be/rt))),H>Et&&(ae=Math.min(2,H/Et)),he=H/Ve/ae,tt=Math.ceil(Math.max(ut,Fe+Ze)*be),Xe&&at&&(we.stableFitMaxMinimapScale=H)}}}const Y=Math.floor(J*he),Ne=Math.min(Y,Math.max(0,Math.floor((We-Ae-2)*he/(Ie+he)))+e.MINIMAP_GUTTER_WIDTH);let Le=Math.floor(Ve*Ne);const Ye=Le/Ve;Le=Math.floor(Le*ae);const et=ue?1:2,ct=Pe==="left"?0:xe-Ne-Ae;return{renderMinimap:et,minimapLeft:ct,minimapWidth:Ne,minimapHeightIsEditorHeight:gt,minimapIsSampling:wt,minimapScale:H,minimapLineHeight:be,minimapCanvasInnerWidth:Le,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Ye,minimapCanvasOuterHeight:Qe}}static computeLayout(te,we){const xe=we.outerWidth|0,je=we.outerHeight|0,Ve=we.lineHeight|0,Je=we.lineNumbersDigitCount|0,De=we.typicalHalfwidthCharacterWidth,ye=we.maxDigitWidth,Ie=we.pixelRatio,oe=we.viewLineCount,ue=te.get(119),H=ue==="inherit"?te.get(118):ue,J=H==="inherit"?te.get(114):H,ce=te.get(117),Pe=te.get(2),Ae=we.isDominatedByLongLines,Fe=te.get(46),We=te.get(56).renderType!==0,Xe=te.get(57),rt=te.get(91),tt=te.get(61),Qe=te.get(89),gt=Qe.verticalScrollbarSize,wt=Qe.verticalHasArrows,be=Qe.arrowSize,he=Qe.horizontalScrollbarSize,ae=te.get(54),Y=te.get(35);let Ne;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const _t=parseFloat(ae.substr(0,ae.length-2));Ne=o.clampedInt(_t*De,0,0,1e3)}else Ne=o.clampedInt(ae,0,0,1e3);Y&&(Ne+=16);let Le=0;if(We){const _t=Math.max(Je,Xe);Le=Math.round(_t*ye)}let Ye=0;Fe&&(Ye=Ve);let et=0,ct=et+Ye,ut=ct+Le,Ze=ut+Ne;const mt=xe-Ye-Le-Ne;let ht=!1,ft=!1,at=-1;Pe!==2&&(H==="inherit"&&Ae?(ht=!0,ft=!0):J==="on"||J==="bounded"?ft=!0:J==="wordWrapColumn"&&(at=ce));const St=B._computeMinimapLayout({outerWidth:xe,outerHeight:je,lineHeight:Ve,typicalHalfwidthCharacterWidth:De,pixelRatio:Ie,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:gt,viewLineCount:oe,remainingWidth:mt,isViewportWrapping:ft},we.memory||new D);St.renderMinimap!==0&&St.minimapLeft===0&&(et+=St.minimapWidth,ct+=St.minimapWidth,ut+=St.minimapWidth,Ze+=St.minimapWidth);const Et=mt-St.minimapWidth,Ot=Math.max(1,Math.floor((Et-gt-2)/De)),Tt=wt?be:0;return ft&&(at=Math.max(1,Ot),J==="bounded"&&(at=Math.min(at,ce))),{width:xe,height:je,glyphMarginLeft:et,glyphMarginWidth:Ye,lineNumbersLeft:ct,lineNumbersWidth:Le,decorationsLeft:ut,decorationsWidth:Ne,contentLeft:Ze,contentWidth:Et,minimap:St,viewportColumn:Ot,isWordWrapMinified:ht,isViewportWrapping:ft,wrappingColumn:at,verticalScrollbarWidth:gt,horizontalScrollbarHeight:he,overviewRuler:{top:Tt,width:gt,height:je-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=B;class x extends k{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:b.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:f(te.enabled,this.defaultValue.enabled)}}}class L extends k{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:b.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,description:b.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:b.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:f(we.enabled,this.defaultValue.enabled),fontSize:o.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(we.fontFamily,this.defaultValue.fontFamily)}}}class O extends o{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(te,we,xe){return te.fontInfo.lineHeight}}class F extends k{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:te.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:b.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:f(we.enabled,this.defaultValue.enabled),size:v(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(we.side,this.defaultValue.side,["right","left"]),showSlider:v(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(we.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(we.scale,1,1,3),maxColumn:o.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(G){return G==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{top:o.clampedInt(we.top,0,0,1e3),bottom:o.clampedInt(we.bottom,0,0,1e3)}}}class q extends k{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:b.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:f(we.enabled,this.defaultValue.enabled),cycle:f(we.cycle,this.defaultValue.cycle)}}}class K extends r{constructor(){super(125)}compute(te,we,xe){return te.pixelRatio}}class le extends k{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:b.localize(58,null)},comments:{type:"boolean",default:te.comments,description:b.localize(59,null)},other:{type:"boolean",default:te.other,description:b.localize(60,null)}}}],default:te,description:b.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const we=te,xe={other:f(we.other,this.defaultValue.other),comments:f(we.comments,this.defaultValue.comments),strings:f(we.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var ve;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(te){let we=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(we=4,xe=te):te==="interval"?we=3:te==="relative"?we=2:te==="on"?we=1:we=0),{renderType:we,renderFn:xe}}}function Se(G){const te=G.get(84);return te==="editable"?G.get(77):te!=="on"}e.filterValidationDecorations=Se;class Oe extends k{constructor(){const te=[],we={type:"number",description:b.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:te,description:b.localize(69,null)})}validate(te){if(Array.isArray(te)){let we=[];for(let xe of te)if(typeof xe=="number")we.push({column:o.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const je=xe;we.push({column:o.clampedInt(je.column,0,0,1e4),color:je.color})}return we.sort((xe,je)=>xe.column-je.column),we}return this.defaultValue}}function V(G,te){if(typeof G!="string")return te;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class X extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te,xe=o.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=o.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(we.vertical,this.defaultValue.vertical),horizontal:V(we.horizontal,this.defaultValue.horizontal),useShadows:f(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:o.clampedInt(we.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:je,verticalSliderSize:o.clampedInt(we.verticalSliderSize,je,0,1e3),scrollByPage:f(we.scrollByPage,this.defaultValue.scrollByPage)}}}class Z extends k{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:te.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{insertMode:v(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(we.showIcons,this.defaultValue.showIcons),showStatusBar:f(we.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:f(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(we.showMethods,this.defaultValue.showMethods),showFunctions:f(we.showFunctions,this.defaultValue.showFunctions),showConstructors:f(we.showConstructors,this.defaultValue.showConstructors),showFields:f(we.showFields,this.defaultValue.showFields),showVariables:f(we.showVariables,this.defaultValue.showVariables),showClasses:f(we.showClasses,this.defaultValue.showClasses),showStructs:f(we.showStructs,this.defaultValue.showStructs),showInterfaces:f(we.showInterfaces,this.defaultValue.showInterfaces),showModules:f(we.showModules,this.defaultValue.showModules),showProperties:f(we.showProperties,this.defaultValue.showProperties),showEvents:f(we.showEvents,this.defaultValue.showEvents),showOperators:f(we.showOperators,this.defaultValue.showOperators),showUnits:f(we.showUnits,this.defaultValue.showUnits),showValues:f(we.showValues,this.defaultValue.showValues),showConstants:f(we.showConstants,this.defaultValue.showConstants),showEnums:f(we.showEnums,this.defaultValue.showEnums),showEnumMembers:f(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(we.showKeywords,this.defaultValue.showKeywords),showWords:f(we.showWords,this.defaultValue.showWords),showColors:f(we.showColors,this.defaultValue.showColors),showFiles:f(we.showFiles,this.defaultValue.showFiles),showReferences:f(we.showReferences,this.defaultValue.showReferences),showFolders:f(we.showFolders,this.defaultValue.showFolders),showTypeParameters:f(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(we.showSnippets,this.defaultValue.showSnippets),showUsers:f(we.showUsers,this.defaultValue.showUsers),showIssues:f(we.showIssues,this.defaultValue.showIssues)}}}class se extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends r{constructor(){super(126,[77])}compute(te,we,xe){return we.get(77)?!0:te.tabFocusMode}}var Ee;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Ee=e.WrappingIndent||(e.WrappingIndent={}));function Be(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends r{constructor(){super(128,[127])}compute(te,we,xe){const je=we.get(127);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Me:R.isLinux?ze:Ce,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(G){return e.editorOptionsRegistry[G.id]=G,G}var Ke;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.codeLens=12]="codeLens",G[G.codeLensFontFamily=13]="codeLensFontFamily",G[G.codeLensFontSize=14]="codeLensFontSize",G[G.colorDecorators=15]="colorDecorators",G[G.columnSelection=16]="columnSelection",G[G.comments=17]="comments",G[G.contextmenu=18]="contextmenu",G[G.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",G[G.cursorBlinking=20]="cursorBlinking",G[G.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",G[G.cursorStyle=22]="cursorStyle",G[G.cursorSurroundingLines=23]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",G[G.cursorWidth=25]="cursorWidth",G[G.disableLayerHinting=26]="disableLayerHinting",G[G.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",G[G.domReadOnly=28]="domReadOnly",G[G.dragAndDrop=29]="dragAndDrop",G[G.emptySelectionClipboard=30]="emptySelectionClipboard",G[G.extraEditorClassName=31]="extraEditorClassName",G[G.fastScrollSensitivity=32]="fastScrollSensitivity",G[G.find=33]="find",G[G.fixedOverflowWidgets=34]="fixedOverflowWidgets",G[G.folding=35]="folding",G[G.foldingStrategy=36]="foldingStrategy",G[G.foldingHighlight=37]="foldingHighlight",G[G.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=39]="fontFamily",G[G.fontInfo=40]="fontInfo",G[G.fontLigatures=41]="fontLigatures",G[G.fontSize=42]="fontSize",G[G.fontWeight=43]="fontWeight",G[G.formatOnPaste=44]="formatOnPaste",G[G.formatOnType=45]="formatOnType",G[G.glyphMargin=46]="glyphMargin",G[G.gotoLocation=47]="gotoLocation",G[G.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",G[G.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",G[G.hover=50]="hover",G[G.inDiffEditor=51]="inDiffEditor",G[G.letterSpacing=52]="letterSpacing",G[G.lightbulb=53]="lightbulb",G[G.lineDecorationsWidth=54]="lineDecorationsWidth",G[G.lineHeight=55]="lineHeight",G[G.lineNumbers=56]="lineNumbers",G[G.lineNumbersMinChars=57]="lineNumbersMinChars",G[G.linkedEditing=58]="linkedEditing",G[G.links=59]="links",G[G.matchBrackets=60]="matchBrackets",G[G.minimap=61]="minimap",G[G.mouseStyle=62]="mouseStyle",G[G.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=64]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",G[G.multiCursorModifier=66]="multiCursorModifier",G[G.multiCursorPaste=67]="multiCursorPaste",G[G.occurrencesHighlight=68]="occurrencesHighlight",G[G.overviewRulerBorder=69]="overviewRulerBorder",G[G.overviewRulerLanes=70]="overviewRulerLanes",G[G.padding=71]="padding",G[G.parameterHints=72]="parameterHints",G[G.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",G[G.quickSuggestions=75]="quickSuggestions",G[G.quickSuggestionsDelay=76]="quickSuggestionsDelay",G[G.readOnly=77]="readOnly",G[G.renameOnType=78]="renameOnType",G[G.renderControlCharacters=79]="renderControlCharacters",G[G.renderIndentGuides=80]="renderIndentGuides",G[G.renderFinalNewline=81]="renderFinalNewline",G[G.renderLineHighlight=82]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=84]="renderValidationDecorations",G[G.renderWhitespace=85]="renderWhitespace",G[G.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",G[G.roundedSelection=87]="roundedSelection",G[G.rulers=88]="rulers",G[G.scrollbar=89]="scrollbar",G[G.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=91]="scrollBeyondLastLine",G[G.scrollPredominantAxis=92]="scrollPredominantAxis",G[G.selectionClipboard=93]="selectionClipboard",G[G.selectionHighlight=94]="selectionHighlight",G[G.selectOnLineNumbers=95]="selectOnLineNumbers",G[G.showFoldingControls=96]="showFoldingControls",G[G.showUnused=97]="showUnused",G[G.snippetSuggestions=98]="snippetSuggestions",G[G.smartSelect=99]="smartSelect",G[G.smoothScrolling=100]="smoothScrolling",G[G.stickyTabStops=101]="stickyTabStops",G[G.stopRenderingLineAfter=102]="stopRenderingLineAfter",G[G.suggest=103]="suggest",G[G.suggestFontSize=104]="suggestFontSize",G[G.suggestLineHeight=105]="suggestLineHeight",G[G.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",G[G.suggestSelection=107]="suggestSelection",G[G.tabCompletion=108]="tabCompletion",G[G.tabIndex=109]="tabIndex",G[G.unusualLineTerminators=110]="unusualLineTerminators",G[G.useShadowDOM=111]="useShadowDOM",G[G.useTabStops=112]="useTabStops",G[G.wordSeparators=113]="wordSeparators",G[G.wordWrap=114]="wordWrap",G[G.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=117]="wordWrapColumn",G[G.wordWrapOverride1=118]="wordWrapOverride1",G[G.wordWrapOverride2=119]="wordWrapOverride2",G[G.wrappingIndent=120]="wrappingIndent",G[G.wrappingStrategy=121]="wrappingStrategy",G[G.showDeprecated=122]="showDeprecated",G[G.inlayHints=123]="inlayHints",G[G.editorClassName=124]="editorClassName",G[G.pixelRatio=125]="pixelRatio",G[G.tabFocusMode=126]="tabFocusMode",G[G.layoutInfo=127]="layoutInfo",G[G.wrappingInfo=128]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:_e(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:_e(new h),accessibilityPageSize:_e(new o(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:_e(new E(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:_e(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:_e(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:_e(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:_e(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:_e(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:_e(new m(10,"automaticLayout",!1)),autoSurround:_e(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:_e(new m(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:_e(new m(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:_e(new E(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:_e(new o(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:_e(new m(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:_e(new m(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:_e(new t),contextmenu:_e(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new m(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:_e(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:_e(new m(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:_e(new u(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:b.localize(145,null)})),cursorSurroundingLines:_e(new o(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:_e(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:_e(new o(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:_e(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new m(28,"domReadOnly",!1)),dragAndDrop:_e(new m(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:_e(new _),extraEditorClassName:_e(new E(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new d(32,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:b.localize(152,null)})),find:_e(new l),fixedOverflowWidgets:_e(new m(34,"fixedOverflowWidgets",!1)),folding:_e(new m(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:_e(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:_e(new m(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:_e(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:_e(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:_e(new T),fontLigatures2:_e(new w),fontSize:_e(new N),fontWeight:_e(new z),formatOnPaste:_e(new m(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:_e(new m(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:_e(new m(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:_e(new ne),hideCursorInOverviewRuler:_e(new m(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:_e(new m(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:_e(new ie),inDiffEditor:_e(new m(51,"inDiffEditor",!1)),letterSpacing:_e(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>d.clamp(G,-5,20),{description:b.localize(165,null)})),lightbulb:_e(new x),lineDecorationsWidth:_e(new P(54,"lineDecorationsWidth",10)),lineHeight:_e(new O),lineNumbers:_e(new Re),lineNumbersMinChars:_e(new o(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new m(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:_e(new m(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:_e(new S(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:_e(new F),mouseStyle:_e(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new d(63,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:_e(new m(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:_e(new m(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:_e(new u(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:_e(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:_e(new m(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:_e(new m(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:_e(new o(70,"overviewRulerLanes",3,0,3)),padding:_e(new W),parameterHints:_e(new q),peekWidgetDefaultFocus:_e(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:_e(new m(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:_e(new le),quickSuggestionsDelay:_e(new o(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:_e(new m(77,"readOnly",!1)),renameOnType:_e(new m(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:_e(new m(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:_e(new m(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:_e(new m(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:_e(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:_e(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:_e(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:_e(new o(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new m(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:_e(new Oe),scrollbar:_e(new X),scrollBeyondLastColumn:_e(new o(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:_e(new m(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:_e(new m(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:_e(new m(93,"selectionClipboard",!0,{description:b.localize(201,null),included:R.isLinux})),selectionHighlight:_e(new m(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:_e(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:_e(new m(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:_e(new m(122,"showDeprecated",!0,{description:b.localize(207,null)})),inlayHints:_e(new L),snippetSuggestions:_e(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:_e(new se),smoothScrolling:_e(new m(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:_e(new o(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new Z),suggestFontSize:_e(new o(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:_e(new o(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:_e(new m(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:_e(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:_e(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:_e(new o(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useShadowDOM:_e(new m(111,"useShadowDOM",!0)),useTabStops:_e(new m(112,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:_e(new E(113,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:_e(new S(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:_e(new E(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new E(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new o(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:_e(new S(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new S(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new u(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Be,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:_e(new S(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:_e(new g),pixelRatio:_e(new K),tabFocusMode:_e(new fe),layoutInfo:_e(new B),wrappingInfo:_e(new pe)}}),define(me[151],ge([18,19]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[152],ge([18,19]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[153],ge([18,19]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[154],ge([18,19]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[155],ge([18,19]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(me[156],ge([18,19]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(me[157],ge([18,19]),function(Q,e){return Q.create("vs/platform/theme/common/iconRegistry",e)}),define(me[158],ge([18,19]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(me[159],ge([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHost.api.impl",e)}),define(me[160],ge([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[161],ge([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[162],ge([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(me[163],ge([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[164],ge([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[165],ge([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[166],ge([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[167],ge([18,19]),function(Q,e){return Q.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[168],ge([18,19]),function(Q,e){return Q.create("vs/workbench/common/views",e)}),define(me[169],ge([18,19]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[170],ge([18,19]),function(Q,e){return Q.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[171],ge([18,19]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[172],ge([18,19]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[173],ge([18,19]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[174],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var R;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var I;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[175],ge([0,1,153]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function A(f){return f=f.trim(),f==="*"||R.test(f)}e.isValidVersionStr=A;function y(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=f.match(R);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=y;function C(f){if(!f)return null;let m=f.majorBase,o=f.majorMustEqual,d=f.minorBase,E=f.minorMustEqual,v=f.patchBase,S=f.patchMustEqual;f.hasCaret&&(m===0||(E=!1),S=!1);let u=0;if(f.preRelease){const c=I.exec(f.preRelease);if(c){const[,h,t,n]=c;u=Date.UTC(Number(h),Number(t)-1,Number(n))}}return{majorBase:m,majorMustEqual:o,minorBase:d,minorMustEqual:E,patchBase:v,patchMustEqual:S,isMinimum:f.hasGreaterEquals,notBefore:u}}e.normalizeVersion=C;function D(f,m,o){let d;typeof f=="string"?d=C(y(f)):d=f;let E;m instanceof Date?E=m.getTime():typeof m=="string"&&(E=new Date(m).getTime());let v;if(typeof o=="string"?v=C(y(o)):v=o,!d||!v)return!1;let S=d.majorBase,u=d.minorBase,c=d.patchBase,h=v.majorBase,t=v.minorBase,n=v.patchBase,s=v.notBefore,i=v.majorMustEqual,a=v.minorMustEqual,p=v.patchMustEqual;return v.isMinimum?S>h?!0:S<h?!1:u>t?!0:u<t||E&&E<s?!1:c>=n:(S===1&&h===0&&(!i||!a||!p)&&(h=1,t=0,n=0,i=!0,a=!1,p=!1),S<h?!1:S>h?!i:u<t?!1:u>t?!a:c<n?!1:c>n?!p:!(E&&E<s))}e.isValidVersion=D;function k(f,m,o,d){return o.isBuiltin||typeof o.main=="undefined"?!0:P(f,m,o.engines.vscode,d)}e.isValidExtensionVersion=k;function r(f,m,o){return f==="*"||P(m,o,f)}e.isEngineValid=r;function P(f,m,o,d=[]){let E=C(y(o));if(!E)return d.push(b.localize(0,null,o)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return d.push(b.localize(1,null,o)),!1}else if(!E.majorMustEqual)return d.push(b.localize(2,null,o)),!1;return D(f,m,E)?!0:(d.push(b.localize(3,null,f,o)),!1)}}),define(me[112],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(A,y=[],C=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=b;const R=(I,...A)=>new b(I,A);e.createSyncDescriptor=R}),define(me[79],ge([0,1,112]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function I(y,C,D){C instanceof b.SyncDescriptor||(C=new b.SyncDescriptor(C,[],D)),R.push([y,C])}e.registerSingleton=I;function A(){return R}e.getSingletonServiceDescriptors=A}),define(me[176],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=b;class R{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const C=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(y);C.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(A),C)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let C of this._nodes.values())C.outgoing.delete(y),C.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let C=this._nodes.get(y);return C||(C=new b(A),this._nodes.set(y,C)),C}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,C]of this._nodes)A.push(`${y}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const C=new Set([A]),D=this._findCycle(y,C);if(D)return D}}_findCycle(A,y){for(let[C,D]of A.outgoing){if(y.has(C))return[...y,C].join(" -> ");y.add(C);const k=this._findCycle(D,y);if(k)return k;y.delete(C)}}}e.Graph=R}),define(me[4],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(k){return k[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(b=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function R(C,D,k,r){D[b.DI_TARGET]===D?D[b.DI_DEPENDENCIES].push({id:C,index:k,optional:r}):(D[b.DI_DEPENDENCIES]=[{id:C,index:k,optional:r}],D[b.DI_TARGET]=D)}function I(C){if(b.serviceIds.has(C))return b.serviceIds.get(C);const D=function(k,r,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,k,P,!1)};return D.toString=()=>C,b.serviceIds.set(C,D),D}e.createDecorator=I;function A(C){return C}e.refineServiceDecorator=A;function y(C){return function(D,k,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(C,D,r,!0)}}e.optional=y}),define(me[177],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function R(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(me[178],ge([0,1,3,75,6,22,74,78,177]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(f){return typeof f=="string"?!1:Array.isArray(f)?f.every(k):!!f.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(m,o){let d={selector:m,provider:o,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,I.toDisposable)(()=>{if(d){let E=this._entries.indexOf(d);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const o=[];for(let d of this._entries)d._score>0&&o.push(d.provider);return o}ordered(m){const o=[];return this._orderedForEach(m,d=>o.push(d.provider)),o}orderedGroups(m){const o=[];let d,E;return this._orderedForEach(m,v=>{d&&E===v._score?d.push(v.provider):(E=v._score,d=[v.provider],o.push(d))}),o}_orderedForEach(m,o){if(!!m){this._updateScores(m);for(const d of this._entries)d._score>0&&o(d)}}_updateScores(m){let o={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===o.language&&this._lastCandidate.uri===o.uri)){this._lastCandidate=o;for(let d of this._entries)if(d._score=(0,C.score)(d.selector,m.uri,m.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(m)),k(d.selector)&&d._score>0){for(let E of this._entries)E._score=0;d._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(m,o){return m._score<o._score?1:m._score>o._score?-1:m._time<o._time?1:m._time>o._time?-1:0}}e.LanguageFeatureRegistry=r;class P{constructor(m,o,d=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=o,this.max=d,this._cache=new A.LRUCache(50,.7)}_key(m){return m.id+(0,R.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const o=this._key(m),d=this._cache.get(o);return this._clamp(d==null?void 0:d.value)}update(m,o){const d=this._key(m);let E=this._cache.get(d);return E||(E=new y.MovingAverage,this._cache.set(d,E)),E.update(o),this.get(m)}}e.LanguageFeatureRequestDelays=P}),define(me[80],ge([0,1,2,43,178,143,46]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(w,T){this.language=w,this.id=T}}e.LanguageIdentifier=D;var k;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var r;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var P;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var f;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(f=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(w){return(w&255)>>>0}static getTokenType(w){return(w&1792)>>>8}static getFontStyle(w){return(w&14336)>>>11}static getForeground(w){return(w&8372224)>>>14}static getBackground(w){return(w&4286578688)>>>23}static getClassNameFromMetadata(w){let T=this.getForeground(w),N="mtk"+T,z=this.getFontStyle(w);return z&1&&(N+=" mtki"),z&2&&(N+=" mtkb"),z&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(w,T){const N=this.getForeground(w),z=this.getFontStyle(w);let ne=`color: ${T[N]};`;return z&1&&(ne+="font-style: italic;"),z&2&&(ne+="font-weight: bold;"),z&4&&(ne+="text-decoration: underline;"),ne}}e.TokenMetadata=m;var o;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(w){const T=l[w];let N=T&&y.iconRegistry.get(T);return N||(console.info("No codicon found for CompletionItemKind "+w),N=y.Codicon.symbolProperty),N.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(w,T){let N=l[w];return typeof N=="undefined"&&!T&&(N=9),N}}();var d;(function(l){l[l.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function h(l){return l&&b.URI.isUri(l.uri)&&R.Range.isIRange(l.range)&&(R.Range.isIRange(l.originSelectionRange)||R.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=h;var t;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(l){l[l.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(l){const w=new Map;w.set("file",0),w.set("module",1),w.set("namespace",2),w.set("package",3),w.set("class",4),w.set("method",5),w.set("property",6),w.set("field",7),w.set("constructor",8),w.set("enum",9),w.set("interface",10),w.set("function",11),w.set("variable",12),w.set("constant",13),w.set("string",14),w.set("number",15),w.set("boolean",16),w.set("array",17),w.set("object",18),w.set("key",19),w.set("null",20),w.set("enum-member",21),w.set("struct",22),w.set("event",23),w.set("operator",24),w.set("type-parameter",25);const T=new Map;T.set(0,"file"),T.set(1,"module"),T.set(2,"namespace"),T.set(3,"package"),T.set(4,"class"),T.set(5,"method"),T.set(6,"property"),T.set(7,"field"),T.set(8,"constructor"),T.set(9,"enum"),T.set(10,"interface"),T.set(11,"function"),T.set(12,"variable"),T.set(13,"constant"),T.set(14,"string"),T.set(15,"number"),T.set(16,"boolean"),T.set(17,"array"),T.set(18,"object"),T.set(19,"key"),T.set(20,"null"),T.set(21,"enum-member"),T.set(22,"struct"),T.set(23,"event"),T.set(24,"operator"),T.set(25,"type-parameter");function N(ie){return w.get(ie)}l.fromString=N;function z(ie){return T.get(ie)}l.toString=z;function ne(ie,U){const B=T.get(ie);let x=B&&y.iconRegistry.get("symbol-"+B);return x||(console.info("No codicon found for SymbolKind "+ie),x=y.Codicon.symbolProperty),`${U?"inline":"block"} ${x.classNames}`}l.toCssClassName=ne})(s=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(w){this.value=w}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var a;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var g;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(g=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var _;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[179],ge([0,1,6,11,4,3,57,55]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,I.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,k){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:D,handler:k})}if(D.description){const o=[];for(let E of D.description.args)o.push(E.constraint);const d=D.handler;D.handler=function(E,...v){return(0,R.validateConstraints)(v,o),d(E,...v)}}const{id:r}=D;let P=this._commands.get(r);P||(P=new y.LinkedList,this._commands.set(r,P));let f=P.unshift(D),m=(0,b.toDisposable)(()=>{f();const o=this._commands.get(r);(o==null?void 0:o.isEmpty())&&this._commands.delete(r)});return this._onDidRegisterCommand.fire(r),m}registerCommandAlias(D,k){return e.CommandsRegistry.registerCommand(D,(r,...P)=>r.get(e.ICommandService).executeCommand(k,...P))}getCommand(D){const k=this._commands.get(D);if(!(!k||k.isEmpty()))return C.Iterable.first(k)}getCommands(){const D=new Map;for(const k of this._commands.keys()){const r=this.getCommand(k);r&&D.set(k,r)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(me[81],ge([0,1,8,4,10]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=I.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",I.isMacintosh),y.set("isLinux",I.isLinux),y.set("isWindows",I.isWindows),y.set("isWeb",I.isWeb),y.set("isMacNative",I.isMacintosh&&!I.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(l){l[l.False=0]="False",l[l.True=1]="True",l[l.Defined=2]="Defined",l[l.Not=3]="Not",l[l.Equals=4]="Equals",l[l.NotEquals=5]="NotEquals",l[l.And=6]="And",l[l.Regex=7]="Regex",l[l.NotRegex=8]="NotRegex",l[l.Or=9]="Or",l[l.In=10]="In",l[l.NotIn=11]="NotIn",l[l.Greater=12]="Greater",l[l.GreaterEquals=13]="GreaterEquals",l[l.Smaller=14]="Smaller",l[l.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return f.INSTANCE}static has(w){return m.create(w)}static equals(w,T){return o.create(w,T)}static notEquals(w,T){return v.create(w,T)}static regex(w,T){return n.create(w,T)}static in(w,T){return d.create(w,T)}static not(w){return S.create(w)}static and(...w){return i.create(w)}static or(...w){return a.create(w)}static greater(w,T){return u.create(w,T)}static less(w,T){return h.create(w,T)}static deserialize(w,T=!1){if(!!w)return this._deserializeOrExpression(w,T)}static _deserializeOrExpression(w,T){let N=w.split("||");return a.create(N.map(z=>this._deserializeAndExpression(z,T)))}static _deserializeAndExpression(w,T){let N=w.split("&&");return i.create(N.map(z=>this._deserializeOne(z,T)))}static _deserializeOne(w,T){if(w=w.trim(),w.indexOf("!=")>=0){let N=w.split("!=");return v.create(N[0].trim(),this._deserializeValue(N[1],T))}if(w.indexOf("==")>=0){let N=w.split("==");return o.create(N[0].trim(),this._deserializeValue(N[1],T))}if(w.indexOf("=~")>=0){let N=w.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],T))}if(w.indexOf(" in ")>=0){let N=w.split(" in ");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const N=w.split(">=");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const N=w.split(">");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const N=w.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const N=w.split("<");return h.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(w)?S.create(w.substr(1).trim()):m.create(w)}static _deserializeValue(w,T){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let N=/^'([^']*)'$/.exec(w);return N?N[1].trim():w}static _deserializeRegexValue(w,T){if((0,b.isFalsyOrWhitespace)(w)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=w.indexOf("/"),z=w.lastIndexOf("/");if(N===z||N<0){if(T)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let ne=w.slice(N+1,z),ie=w[z+1]==="i"?"i":"";try{return new RegExp(ne,ie)}catch(U){if(T)throw new Error(`bad regexp-value '${w}', parse error: ${U}`);return console.warn(`bad regexp-value '${w}', parse error: ${U}`),null}}}e.ContextKeyExpr=k;function r(l,w){return l.cmp(w)}class P{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class f{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class m{constructor(w){this.key=w,this.type=2}static create(w){const T=y.get(w);return typeof T=="boolean"?T?f.INSTANCE:P.INSTANCE:new m(w)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=m;class o{constructor(w,T){this.key=w,this.value=T,this.type=4}static create(w,T){if(typeof T=="boolean")return T?m.create(w):S.create(w);const N=y.get(w);return typeof N=="boolean"?T===(N?"true":"false")?f.INSTANCE:P.INSTANCE:new o(w,T)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=o;class d{constructor(w,T){this.key=w,this.valueKey=T,this.type=10}static create(w,T){return new d(w,T)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const T=w.getValue(this.valueKey),N=w.getValue(this.key);return Array.isArray(T)?T.indexOf(N)>=0:typeof N=="string"&&typeof T=="object"&&T!==null?C.call(T,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=d;class E{constructor(w){this._actual=w,this.type=11}static create(w){return new E(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new E(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class v{constructor(w,T){this.key=w,this.value=T,this.type=5}static create(w,T){if(typeof T=="boolean")return T?S.create(w):m.create(w);const N=y.get(w);return typeof N=="boolean"?T===(N?"true":"false")?P.INSTANCE:f.INSTANCE:new v(w,T)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class S{constructor(w){this.key=w,this.type=3}static create(w){const T=y.get(w);return typeof T=="boolean"?T?P.INSTANCE:f.INSTANCE:new S(w)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=S;class u{constructor(w,T){this.key=w,this.value=T,this.type=12}static create(w,T){return new u(w,T)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class c{constructor(w,T){this.key=w,this.value=T,this.type=13}static create(w,T){return new c(w,T)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class h{constructor(w,T){this.key=w,this.value=T,this.type=14}static create(w,T){return new h(w,T)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=h;class t{constructor(w,T){this.key=w,this.value=T,this.type=15}static create(w,T){return new t(w,T)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(w,T){this.key=w,this.regexp=T,this.type=7}static create(w,T){return new n(w,T)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const T=this.regexp?this.regexp.source:"",N=w.regexp?w.regexp.source:"";return T<N?-1:T>N?1:0}equals(w){if(w.type===this.type){const T=this.regexp?this.regexp.source:"",N=w.regexp?w.regexp.source:"";return this.key===w.key&&T===N}return!1}evaluate(w){let T=w.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(w){this._actual=w,this.type=8}static create(w){return new s(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new s(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(w){this.expr=w,this.type=6}static create(w){return i._normalizeArr(w)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let T=0,N=this.expr.length;T<N;T++){const z=r(this.expr[T],w.expr[T]);if(z!==0)return z}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let T=0,N=this.expr.length;T<N;T++)if(!this.expr[T].equals(w.expr[T]))return!1;return!0}return!1}evaluate(w){for(let T=0,N=this.expr.length;T<N;T++)if(!this.expr[T].evaluate(w))return!1;return!0}static _normalizeArr(w){const T=[];let N=!1;for(const z of w)if(!!z){if(z.type===1){N=!0;continue}if(z.type===0)return P.INSTANCE;if(z.type===6){T.push(...z.expr);continue}T.push(z)}if(T.length===0&&N)return f.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(r);T.length>1;){const z=T[T.length-1];if(z.type!==9)break;T.pop();const ne=T.pop(),ie=a.create(z.expr.map(U=>i.create([U,ne])));ie&&(T.push(ie),T.sort(r))}return T.length===1?T[0]:new i(T)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let T of this.expr)w.push(...T.keys());return w}map(w){return new i(this.expr.map(T=>T.map(w)))}negate(){let w=[];for(let T of this.expr)w.push(T.negate());return a.create(w)}}e.ContextKeyAndExpr=i;class a{constructor(w){this.expr=w,this.type=9}static create(w){const T=a._normalizeArr(w);if(T.length!==0)return T.length===1?T[0]:new a(T)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let T=0,N=this.expr.length;T<N;T++){const z=r(this.expr[T],w.expr[T]);if(z!==0)return z}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let T=0,N=this.expr.length;T<N;T++)if(!this.expr[T].equals(w.expr[T]))return!1;return!0}return!1}evaluate(w){for(let T=0,N=this.expr.length;T<N;T++)if(this.expr[T].evaluate(w))return!0;return!1}static _normalizeArr(w){let T=[],N=!1;if(w){for(let z=0,ne=w.length;z<ne;z++){const ie=w[z];if(!!ie){if(ie.type===0){N=!0;continue}if(ie.type===1)return[f.INSTANCE];if(ie.type===9){T=T.concat(ie.expr);continue}T.push(ie)}}if(T.length===0&&N)return[P.INSTANCE];T.sort(r)}return T}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let T of this.expr)w.push(...T.keys());return w}map(w){return new a(this.expr.map(T=>T.map(w)))}negate(){let w=[];for(let N of this.expr)w.push(N.negate());const T=N=>N.type===9?N.expr:[N];for(;w.length>1;){const N=w.shift(),z=w.shift(),ne=[];for(const ie of T(N))for(const U of T(z))ne.push(k.and(ie,U));w.unshift(k.or(...ne))}return w[0]}}e.ContextKeyOrExpr=a;class p extends m{constructor(w,T,N){super(w);this._defaultValue=T,typeof N=="object"?p._info.push(Object.assign(Object.assign({},N),{key:w})):N!==!0&&p._info.push({key:w,description:N,type:T!=null?typeof T:void 0})}static all(){return p._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(w){return k.equals(this.key,w)}notEqualsTo(w){return k.notEquals(this.key,w)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(l,w){return l<w?-1:l>w?1:0}function _(l,w,T,N){return l<T?-1:l>T?1:w<N?-1:w>N?1:0}}),define(me[180],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(me[181],ge([0,1,152,4,12]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=A;var y;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var C;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var D;(function(P){P.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var k;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(k=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(f,m){super(f);this.code=m}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=I.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,8,4]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,P){if(typeof r=="undefined"||r===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof r=="string"||typeof P=="string"){let f=typeof r=="string"?r:r.value,m=typeof P=="string"?P:P.value;return b.equalsIgnoreCase(f,m)}return r._lower===P._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.ExtensionIdentifier=y;function C(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function D(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[182],ge([0,1,8,26]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(m,o){return m.uuid&&o.uuid?m.uuid===o.uuid:m.id===o.id?!0:(0,b.compareIgnoreCase)(m.id,o.id)===0}e.areSameExtensions=I;class A{constructor(o,d){this.version=d,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof A?I(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(m,o){return`${m}.${o}`}e.getExtensionId=y;function C(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(m,o){return C(y(m,o))}e.getGalleryExtensionId=D;function k(m,o){const d=[],E=v=>{for(const S of d)if(S.some(u=>I(o(u),o(v))))return S;return null};for(const v of m){const S=E(v);S?S.push(v):d.push([v])}return d}e.groupByExtension=k;function r(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function P(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function f(m){const o=new Set;for(const d of m)d.malicious&&o.add(d.id.id);return o}e.getMaliciousExtensionsSet=f}),define(me[183],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,b.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,b.createDecorator)("externalTerminal")}),define(me[44],ge([0,1,155,9,2,4,8,11,22]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function k(U){return U.create===!0}e.isFileOpenForWriteOptions=k;var r;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var P;(function(U){U[U.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var f;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=m;function o(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=o;function d(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function E(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=E;var v;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(B,x){super(B);this.code=x}}e.FileSystemProviderError=S;function u(U,B){const x=new S(U.toString(),B);return h(x,B),x}e.createFileSystemProviderError=u;function c(U){return U||u((0,b.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=c;function h(U,B){return U.name=B?`${B} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=h;function t(U){if(!U)return v.Unknown;if(U instanceof S)return U.code;const B=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!B)return v.Unknown;switch(B[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=t;function n(U){if(U instanceof _)return U.fileOperationResult;switch(t(U)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(B,x,L){this.resource=B,this.operation=x,this.target=L}isOperation(B){return this.operation===B}}e.FileOperationEvent=i;var a;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class p{constructor(B,x){this.ignorePathCasing=x,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const L of B)switch(L.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(L.resource,L);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(L.resource,L);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(L.resource,L);break}}contains(B,...x){return this.doContains(B,{includeChildren:!1},...x)}affects(B,...x){return this.doContains(B,{includeChildren:!0},...x)}doContains(B,x,...L){var O,F,M,W,q,K;if(!B)return!1;const le=L.length>0;return!!((!le||L.includes(1))&&(((O=this.added)===null||O===void 0?void 0:O.get(B))||x.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(B)))||(!le||L.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(B))||x.includeChildren&&((W=this.updated)===null||W===void 0?void 0:W.findSuperstr(B)))||(!le||L.includes(2))&&(((q=this.deleted)===null||q===void 0?void 0:q.findSubstr(B))||x.includeChildren&&((K=this.deleted)===null||K===void 0?void 0:K.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const x=[],L=B===1?this.added:B===0?this.updated:this.deleted;if(L)for(const[,O]of L)x.push(O);return x}filter(B){return new p(this.changes.filter(x=>B(x)),this.ignorePathCasing)}}e.FileChangesEvent=p;function g(U,B,x){return!U||!B||U===B||B.length>U.length?!1:(B.charAt(B.length-1)!==R.sep&&(B+=R.sep),x?(0,y.startsWithIgnoreCase)(U,B):U.indexOf(B)===0)}e.isParent=g;class _ extends Error{constructor(B,x,L){super(B);this.fileOperationResult=x,this.options=L}static isFileOperationError(B){return B instanceof Error&&!(0,C.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=_;var l;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(l=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var w;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(w=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=T;async function N(U,B){if(!B.canHandleResource(I.URI.from({scheme:U.scheme})))return new Promise(x=>{const L=B.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===U.scheme&&O.added&&(L.dispose(),x())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(B){return(0,C.isNumber)(B)||(B=0),B<z.KB?(0,b.localize)(1,null,B.toFixed(0)):B<z.MB?(0,b.localize)(2,null,(B/z.KB).toFixed(2)):B<z.GB?(0,b.localize)(3,null,(B/z.MB).toFixed(2)):B<z.TB?(0,b.localize)(4,null,(B/z.GB).toFixed(2)):(0,b.localize)(5,null,(B/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var ne;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function ie(U){return{maxFileSize:U===0?300*z.MB:16*z.GB,maxHeapSize:U===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=ie}),define(me[82],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...I){this._entries=new Map;for(let[A,y]of I)this.set(A,y)}set(I,A){const y=this._entries.get(I);return this._entries.set(I,A),y}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=b}),define(me[184],ge([0,1,17,176,112,4,82,13]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class k extends Error{constructor(o){var d;super("cyclic dependency between services");this.message=(d=o.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class r{constructor(o=new y.ServiceCollection,d=!1,E){this._activeInstantiations=new Set,this._services=o,this._strict=d,this._parent=E,this._services.set(A.IInstantiationService,this)}createChild(o){return new r(o,this._strict,this)}invokeFunction(o,...d){let E=f.traceInvocation(o),v=!1;try{return o({get:(u,c)=>{if(v)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(u,E);if(!h&&c!==A.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return h}},...d)}finally{v=!0,E.stop()}}createInstance(o,...d){let E,v;return o instanceof I.SyncDescriptor?(E=f.traceCreation(o.ctor),v=this._createInstance(o.ctor,o.staticArguments.concat(d),E)):(E=f.traceCreation(o),v=this._createInstance(o,d,E)),E.stop(),v}_createInstance(o,d=[],E){let v=A._util.getServiceDependencies(o).sort((c,h)=>c.index-h.index),S=[];for(const c of v){let h=this._getOrCreateServiceInstance(c.id,E);if(!h&&this._strict&&!c.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${c.id}.`);S.push(h)}let u=v.length>0?v[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${o.name} at position ${u+1} conflicts with ${d.length} static arguments`);let c=u-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,u)}return new o(...[...d,...S])}_setServiceInstance(o,d){if(this._services.get(o)instanceof I.SyncDescriptor)this._services.set(o,d);else if(this._parent)this._parent._setServiceInstance(o,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let d=this._services.get(o);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):d}_getOrCreateServiceInstance(o,d){let E=this._getServiceInstanceOrDescriptor(o);return E instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,E,d.branch(o,!0)):(d.branch(o,!1),E)}_safeCreateAndCacheServiceInstance(o,d,E){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,d,E)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,d,E){const v=new R.Graph(c=>c.id.toString());let S=0;const u=[{id:o,desc:d,_trace:E}];for(;u.length;){const c=u.pop();if(v.lookupOrInsertNode(c),S++>1e3)throw new k(v);for(let h of A._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(h.id);if(!t&&!h.optional&&console.warn(`[createInstance] ${o} depends on ${h.id} which is NOT registered.`),t instanceof I.SyncDescriptor){const n={id:h.id,desc:t,_trace:c._trace.branch(h.id,!0)};v.insertEdge(c,n),u.push(n)}}}for(;;){const c=v.roots();if(c.length===0){if(!v.isEmpty())throw new k(v);break}for(const{data:h}of c){if(this._getServiceInstanceOrDescriptor(h.id)instanceof I.SyncDescriptor){const n=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,n)}v.removeNode(h)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,d,E=[],v,S){if(this._services.get(o)instanceof I.SyncDescriptor)return this._createServiceInstance(d,E,v,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,d,E,v,S);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(o,d=[],E,v){if(E){const S=new C.IdleValue(()=>this._createInstance(o,d,v));return new Proxy(Object.create(null),{get(u,c){if(c in u)return u[c];let h=S.value,t=h[c];return typeof t!="function"||(t=t.bind(h),u[c]=t),t},set(u,c,h){return S.value[c]=h,!0}})}else return this._createInstance(o,d,v)}}e.InstantiationService=r;var P;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(P||(P={}));class f{constructor(o,d){this.type=o,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return D?new f(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(o){return D?new f(0,o.name):f._None}branch(o,d){let E=new f(2,o.toString());return this._dep.push([o,d,E]),E}stop(){let o=Date.now()-this._start;f._totals+=o;let d=!1;function E(S,u){let c=[],h=new Array(S+1).join("	");for(const[t,n,s]of u._dep)if(n&&s){d=!0,c.push(`${h}CREATES -> ${t}`);let i=E(S+1,s);i&&c.push(i)}else c.push(`${h}uses -> ${t}`);return c.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(o>2||d)&&console.log(v.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(me[14],ge([0,1,4,6,10,3,60]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function C(){return new Date().toISOString()}var D;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class r extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(a){}n+=(s>0?" ":"")+i}return n}}e.AbstractMessageLogger=r;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!I.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...n):console.warn(`[main ${C()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class f extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class m extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class o extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class d extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=d;class E extends R.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class v{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=v;function S(h){if(h.verbose)return D.Trace;if(typeof h.logLevel=="string"){const t=u(h.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function u(h){switch(h){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function c(h){switch(h){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(me[113],ge([0,1,14,44]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function I(D,k,r,P){try{return(await new Promise((m,o)=>{Q(["spdlog"],m,o)})).createAsyncRotatingLogger(D,k,r,P)}catch(f){console.error(f)}return null}function A(D,k,r,P){return Q.__$__nodeRequire("spdlog").createRotatingLogger(D,k,r,P)}e.createRotatingLogger=A;function y(D,k,r){switch(k){case b.LogLevel.Trace:D.trace(r);break;case b.LogLevel.Debug:D.debug(r);break;case b.LogLevel.Info:D.info(r);break;case b.LogLevel.Warning:D.warn(r);break;case b.LogLevel.Error:D.error(r);break;case b.LogLevel.Critical:D.critical(r);break;default:throw new Error("Invalid log level")}}class C extends b.AbstractMessageLogger{constructor(k,r,P,f){super();this.name=k,this.filepath=r,this.rotating=P,this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const k=this.rotating?6:1,r=30/k*R.ByteSize.MB;return I(this.name,this.filepath,r,k).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:f,message:m}of this.buffer)y(this._logger,f,m);this.buffer=[]}})}log(k,r){this._logger?y(this._logger,k,r):this.getLevel()<=k&&this.buffer.push({level:k,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(me[114],ge([0,1,4,156,58]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(o,d){return d-o}D.compare=k;const r=Object.create(null);r[D.Error]=(0,R.localize)(0,null),r[D.Warning]=(0,R.localize)(1,null),r[D.Info]=(0,R.localize)(2,null);function P(o){return r[o]||""}D.toString=P;function f(o){switch(o){case I.default.Error:return D.Error;case I.default.Warning:return D.Warning;case I.default.Info:return D.Info;case I.default.Ignore:return D.Hint}}D.fromSeverity=f;function m(o){switch(o){case D.Error:return I.default.Error;case D.Warning:return I.default.Warning;case D.Info:return I.default.Info;case D.Hint:return I.default.Ignore}}D.toSeverity=m}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const k="";function r(f){return P(f,!0)}D.makeKey=r;function P(f,m){let o=[k];return f.source?o.push(f.source.replace("\xA6","\\\xA6")):o.push(k),f.code?typeof f.code=="string"?o.push(f.code.replace("\xA6","\\\xA6")):o.push(f.code.value.replace("\xA6","\\\xA6")):o.push(k),f.severity!==void 0&&f.severity!==null?o.push(y.toString(f.severity)):o.push(k),f.message&&m?o.push(f.message.replace("\xA6","\\\xA6")):o.push(k),f.startLineNumber!==void 0&&f.startLineNumber!==null?o.push(f.startLineNumber.toString()):o.push(k),f.startColumn!==void 0&&f.startColumn!==null?o.push(f.startColumn.toString()):o.push(k),f.endLineNumber!==void 0&&f.endLineNumber!==null?o.push(f.endLineNumber.toString()):o.push(k),f.endColumn!==void 0&&f.endColumn!==null?o.push(f.endColumn.toString()):o.push(k),o.push(k),o.join("\xA6")}D.makeKeyOptionalMessage=P})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(me[185],ge([0,1,58,4,3]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,R.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=D}),define(me[186],ge([0,1,12,10,36,25]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const C=R.globals.vscode.context.configuration();if(C)y=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(Q==null?void 0:Q.__$__nodeRequire)=="function"){const C=(0,A.dirname)(b.FileAccess.asFileUri("",Q));y=Q.__$__nodeRequire((0,A.joinPath)(C,"product.json").fsPath);const D=Q.__$__nodeRequire((0,A.joinPath)(C,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var He=this&&this.__param||function(Q,e){return function(b,R){e(b,R,Q)}};define(me[115],ge([0,1,4,21,6,13]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(r){r[r.Explorer=1]="Explorer",r[r.Scm=3]="Scm",r[r.Extensions=5]="Extensions",r[r.Window=10]="Window",r[r.Notification=15]="Notification",r[r.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends I.Disposable{constructor(P,f){super();this.deferred=new A.DeferredPromise,f.withProgress(P,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};D=qe([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends I.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(P){this.stop();const f=++this.currentOperationId,m=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{f===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:f,token:m.token,stop:()=>this.doStop(f),isCurrent:()=>this.currentOperationId===f}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(me[39],ge([0,1,11,52]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(y,C){R.ok(b.isString(y)),R.ok(b.isObject(C)),R.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,C)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new I}),define(me[116],ge([0,1,39,3]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class A{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,k){this.schemasById[I(D)]=k,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;b.Registry.add(e.Extensions.JSONContribution,y)}),define(me[83],ge([0,1,151,3,39,11,116]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=I.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,S=!0){this.registerConfigurations([v],S)}registerConfigurations(v,S=!0){const u=[];v.forEach(c=>{u.push(...this.validateAndRegisterProperties(c,S,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(v){const S=[],u=c=>{if(c.properties)for(const h in c.properties)S.push(h),delete this.configurationProperties[h],this.removeFromSchema(h,c.properties[h]);c.allOf&&c.allOf.forEach(h=>u(h))};for(const c of v){u(c);const h=this.configurationContributors.indexOf(c);h!==-1&&this.configurationContributors.splice(h,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(v){const S=[],u=[];for(const c of v)for(const h in c)if(S.push(h),e.OVERRIDE_PROPERTY_PATTERN.test(h)){this.defaultValues[h]=Object.assign(Object.assign({},this.defaultValues[h]||{}),c[h]);const t={type:"object",default:this.defaultValues[h],description:b.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId};u.push(P(h)),this.configurationProperties[h]=t,this.defaultLanguageConfigurationOverridesNode.properties[h]=t}else{this.defaultValues[h]=c[h];const t=this.configurationProperties[h];t&&(this.updatePropertyDefaultValue(h,t),this.updateSchema(h,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(v){const S=[];for(const u of v)for(const c in u)if(S.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const h=this.configurationProperties[c];h&&(this.updatePropertyDefaultValue(c,h),this.updateSchema(c,h))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const S of v)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,S=!0,u,c=3){var h;c=A.isUndefinedOrNull(v.scope)?c:v.scope;let t=[],n=v.properties;if(n)for(let i in n){if(S&&o(i)){delete n[i];continue}const a=n[i];if(this.updatePropertyDefaultValue(i,a),e.OVERRIDE_PROPERTY_PATTERN.test(i)?a.scope=void 0:(a.scope=A.isUndefinedOrNull(a.scope)?c:a.scope,a.restricted=A.isUndefinedOrNull(a.restricted)?!!((h=u==null?void 0:u.restrictedConfigurations)===null||h===void 0?void 0:h.includes(i)):a.restricted),n[i].hasOwnProperty("included")&&!n[i].included){this.excludedConfigurationProperties[i]=n[i],delete n[i];continue}else this.configurationProperties[i]=n[i];!n[i].deprecationMessage&&n[i].markdownDeprecationMessage&&(n[i].deprecationMessage=n[i].markdownDeprecationMessage),t.push(i)}let s=v.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,S,u,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const S=u=>{let c=u.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let h=u.allOf;h&&h.forEach(S)};S(v)}updateSchema(v,S){switch(e.allSettings.properties[v]=S,S.scope){case 1:e.applicationSettings.properties[v]=S;break;case 2:e.machineSettings.properties[v]=S;break;case 6:e.machineOverridableSettings.properties[v]=S;break;case 3:e.windowSettings.properties[v]=S;break;case 4:e.resourceSettings.properties[v]=S;break;case 5:e.resourceSettings.properties[v]=S,this.resourceLanguageSettingsSchema.properties[v]=S;break}}removeFromSchema(v,S){switch(delete e.allSettings.properties[v],S.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const S=`[${v}]`,u={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,u),e.allSettings.properties[S]=u,e.applicationSettings.properties[S]=u,e.machineSettings.properties[S]=u,e.machineOverridableSettings.properties[S]=u,e.windowSettings.properties[S]=u,e.resourceSettings.properties[S]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,S){let u=this.defaultValues[v];A.isUndefined(u)&&(u=S.default),A.isUndefined(u)&&(u=f(S.type)),S.default=u}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function P(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=P;function f(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const m=new k;I.Registry.add(e.Extensions.Configuration,m);function o(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?b.localize(5,null,E):m.getConfigurationProperties()[E]!==void 0?b.localize(6,null,E):null:b.localize(4,null)}e.validateProperty=o;function d(){const E=[],v=m.getConfigurationProperties();for(const S of Object.keys(v))E.push([S,v[S].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=d}),define(me[84],ge([0,1,24,11,2,39,4,83]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof I.URI)}e.isConfigurationOverrides=D;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function P(n,s){const i=s?n?s.keys.filter(T=>n.keys.indexOf(T)===-1):[...s.keys]:[],a=n?s?n.keys.filter(T=>s.keys.indexOf(T)===-1):[...n.keys]:[],p=[];if(s&&n){for(const T of n.keys)if(s.keys.indexOf(T)!==-1){const N=v(n.contents,T),z=v(s.contents,T);b.equals(N,z)||p.push(T)}}const g=[],_=T=>{const N={};for(const z of T)for(const ne of z.identifiers)N[h(ne)]=z;return N},l=s?_(s.overrides):{},w=n?_(n.overrides):{};if(Object.keys(l).length)for(const T of i){const N=l[T];N&&g.push([(0,C.overrideIdentifierFromKey)(T),N.keys])}if(Object.keys(w).length)for(const T of a){const N=w[T];N&&g.push([(0,C.overrideIdentifierFromKey)(T),N.keys])}if(Object.keys(l).length&&Object.keys(w).length)for(const T of p){const N=w[T],z=l[T];if(N&&z){const ne=P({contents:N.contents,keys:N.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});g.push([(0,C.overrideIdentifierFromKey)(T),[...ne.added,...ne.removed,...ne.updated]])}}return{added:i,removed:a,updated:p,overrides:g}}e.compare=P;function f(n,s){const i=[];for(const a of Object.keys(n))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const p={};for(const g in n[a])p[g]=n[a][g];i.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(p),contents:m(p,s)})}return i}e.toOverrides=f;function m(n,s){const i=Object.create(null);for(let a in n)o(i,a,n[a],s);return i}e.toValuesTree=m;function o(n,s,i,a){const p=s.split("."),g=p.pop();let _=n;for(let l=0;l<p.length;l++){let w=p[l],T=_[w];switch(typeof T){case"undefined":T=_[w]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${p.slice(0,l+1).join(".")} is ${JSON.stringify(T)}`);return}_=T}if(typeof _=="object"&&_!==null)try{_[g]=i}catch(l){a(`Ignoring ${s} as ${p.join(".")} is ${JSON.stringify(_)}`)}else a(`Ignoring ${s} as ${p.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=o;function d(n,s){const i=s.split(".");E(n,i)}e.removeFromValueTree=d;function E(n,s){const i=s.shift();if(s.length===0){delete n[i];return}if(Object.keys(n).indexOf(i)!==-1){const a=n[i];typeof a=="object"&&!Array.isArray(a)&&(E(a,s),Object.keys(a).length===0&&delete n[i])}}function v(n,s,i){function a(_,l){let w=_;for(const T of l){if(typeof w!="object"||w===null)return;w=w[T]}return w}const p=s.split("."),g=a(n,p);return typeof g=="undefined"?i:g}e.getConfigurationValue=v;function S(n,s,i){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in n?R.isObject(n[a])&&R.isObject(s[a])?S(n[a],s[a],i):i&&(n[a]=s[a]):n[a]=s[a])})}e.merge=S;function u(){const n=A.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=u;function c(){const n=Object.create(null),s=A.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let i in s){let a=s[i].default;o(n,i,a,p=>console.error(`Conflict in default settings: ${p}`))}return n}e.getDefaultValues=c;function h(n){return`[${n}]`}e.keyFromOverrideIdentifier=h;function t(n,s,i){const a=n.inspect(s),p=n.inspect(i);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:a.defaultValue}e.getMigratedSettingValue=t}),define(me[187],ge([0,1,56,22,16,11,24,2,83,84,39,6,3]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const i of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[i],p=n[i];p&&(typeof a=="object"&&typeof p=="object"?(a=y.deepClone(a),this.mergeContents(a,p)):a=p),s[i]=a}return new m(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),i=[...this.keys];for(const a of t){this.mergeContents(n,a.contents);for(const p of a.overrides){const[g]=s.filter(_=>I.equals(_.identifiers,p.identifiers));g?this.mergeContents(g.contents,p.contents):s.push(y.deepClone(p))}for(const p of a.keys)i.indexOf(p)===-1&&i.push(p)}return new m(n,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&A.isObject(t[s])&&A.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=m;class o extends m{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,D.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,k.toValuesTree)(t[i],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,n,s)}}e.DefaultConfigurationModel=o;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:i,overrides:a,restricted:p}=this.doParseRaw(t,n);this._configurationModel=new m(s,i,a),this._restrictedConfigurations=p||[]}doParseContent(t){let n={},s=null,i=[],a=[],p=[];function g(l){Array.isArray(i)?i.push(l):s&&(i[s]=l)}let _={onObjectBegin:()=>{let l={};g(l),a.push(i),i=l,s=null},onObjectProperty:l=>{s=l},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{let l=[];g(l),a.push(i),i=l,s=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:g,onError:(l,w,T)=>{p.push({error:l,offset:w,length:T})}};if(t)try{b.visit(t,_),n=i[0]||{}}catch(l){console.error(`Error while parsing settings file ${this._name}: ${l}`),this._parseErrors=[l]}return n}doParseRaw(t,n){const s=r.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,n);t=i.raw;const a=(0,k.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),p=Object.keys(t),g=(0,k.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:a,keys:p,overrides:g,restricted:i.restricted}}filter(t,n,s,i){if(!(i==null?void 0:i.scopes)&&!(i==null?void 0:i.skipRestricted))return{raw:t,restricted:[]};const a={},p=[];for(let g in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(g)&&s){const _=this.filter(t[g],n,!1,i);a[g]=_.raw,p.push(..._.restricted)}else{const _=n[g],l=_?typeof _.scope!="undefined"?_.scope:3:void 0;(_==null?void 0:_.restricted)&&p.push(g),(l===void 0||i.scopes===void 0||i.scopes.includes(l))&&(i.skipRestricted&&(_==null?void 0:_.restricted)||(a[g]=t[g]))}return{raw:a,restricted:p}}}e.ConfigurationModelParser=d;class E extends P.Disposable{constructor(t,n,s,i){super();this.userSettingsResource=t,this.scopes=n,this.fileService=i,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(f.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class v{constructor(t,n,s=new m,i=new m,a=new R.ResourceMap,p=new m,g=new R.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=a,this._memoryConfiguration=p,this._memoryConfigurationByResource=g,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new m,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,n===void 0?i.removeValue(t):i.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const i=this.getConsolidateConfigurationModel(n,s),a=this.getFolderConfigurationModelForResource(n.resource,s),p=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,g=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),l=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),w=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,z=n.overrideIdentifier?p.override(n.overrideIdentifier).getValue(t):p.getValue(t),ne=i.getValue(t),ie=I.distinct(I.flatten(i.overrides.map(U=>U.identifiers))).filter(U=>i.getOverrideValue(t,U)!==void 0);return{defaultValue:g,userValue:_,userLocalValue:l,userRemoteValue:w,workspaceValue:T,workspaceFolderValue:N,memoryValue:z,value:ne,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:l!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:w!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:n.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:p.getValue(t),override:n.overrideIdentifier?p.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ie.length?ie:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(i=>D.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const a=(0,D.overrideIdentifierFromKey)(i),p=this._defaultConfiguration.getKeysForOverrideIdentifier(a),g=t.getKeysForOverrideIdentifier(a),_=[...g.filter(l=>p.indexOf(l)===-1),...p.filter(l=>g.indexOf(l)===-1),...p.filter(l=>!y.equals(this._defaultConfiguration.override(a).getValue(l),t.override(a).getValue(l)))];return[a,_]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:i,overrides:a}=(0,k.compare)(this.localUserConfiguration,t),p=[...n,...s,...i];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:i,overrides:a}=(0,k.compare)(this.remoteUserConfiguration,t);let p=[...n,...s,...i];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:i,overrides:a}=(0,k.compare)(this.workspaceConfiguration,t);let p=[...n,...s,...i];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:a}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:i,updated:a,removed:p,overrides:g}=(0,k.compare)(s,n);let _=[...i,...a,...p];return(_.length||!s)&&this.updateFolderConfiguration(t,n),{keys:_,overrides:g}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:a,overrides:p}=(0,k.compare)(n,void 0);return{keys:[...s,...i,...a],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const i=n.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const a=this._memoryConfigurationByResource.get(t);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(n=s.merge(i),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:i,keys:a}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:i,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((p,g)=>(p.set(C.URI.revive(g[0]),this.parseConfigurationModel(g[1])),p),new R.ResourceMap);return new v(n,s,new m,i,a,new m,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function S(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const t=new Set,n=new Map;for(const i of h)i.keys.forEach(a=>t.add(a)),i.overrides.forEach(([a,p])=>{const g=(0,R.getOrSet)(n,a,new Set);p.forEach(_=>g.add(_))});const s=[];return n.forEach((i,a)=>s.push([a,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=S;class u{constructor(t,n,s,i){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(g=>a.add(g)),t.overrides.forEach(([,g])=>g.forEach(_=>a.add(_))),this.affectedKeys=[...a.values()];const p=new m;this.affectedKeys.forEach(g=>p.setValue(g,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,a=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(i,a)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,k.toValuesTree)({[n]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=u;class c extends u{constructor(t,n,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=c}),define(me[188],ge([0,1,38,9,111,154,28,10,183,84,4,12,135]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=A.localize(0,null);class o{async getDefaultTerminalForPlatforms(){const t=await v.getDefaultTerminalLinuxReady();return{windows:d.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let d=class zt extends o{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,I.getWindowsShell(),t)}spawnTerminal(t,n,s,i){const a=n.terminal.external,p=(a==null?void 0:a.windowsExec)||zt.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const g=R.basename(p).toLowerCase();if(g==="cmder"||g==="cmder.exe")return t.spawn(p,i?[i]:void 0),Promise.resolve(void 0);const _=["/c","start","/wait"];return p.indexOf(" ")>=0&&_.push('""'),_.push(p),(g==="wt"||g==="wt.exe")&&_.push("-d ."),new Promise((l,w)=>{const T=S(process),N=t.spawn(s,_,{cwd:i,env:T});N.on("error",w),N.on("exit",()=>l())})}runInTerminal(t,n,s,i,a){const p="windowsExec"in a&&a.windowsExec?a.windowsExec:zt.getDefaultTerminalWindows();return new Promise((g,_)=>{const l=`"${n} - ${m}"`,w=`""${s.join('" "')}" & pause"`,T=["/c","start",l,"/wait",p,"/c",w],N=Object.assign({},S(process),i);Object.keys(N).filter(ie=>N[ie]===null).forEach(ie=>delete N[ie]);const z={cwd:n,env:N,windowsVerbatimArguments:!0};b.spawn(zt.CMD,T,z).on("error",ie=>{_(u(ie))}),g(void 0)})}static getDefaultTerminalWindows(){if(!zt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");zt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return zt._DEFAULT_TERMINAL_WINDOWS}};d.CMD="cmd.exe",d=qe([He(0,(0,r.optional)(k.IConfigurationService))],d),e.WindowsExternalTerminalService=d;let E=class Fn extends o{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,s,i,a){const p=a.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((g,_)=>{if(p===D.DEFAULT_TERMINAL_OSX||p==="iTerm.app"){const l=p===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",T=[P.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,Q).fsPath,"-t",t||m,"-w",n];for(let ne of s)T.push("-a"),T.push(ne);if(i)for(let ne in i){const ie=i[ne];ie===null?(T.push("-u"),T.push(ne)):(T.push("-e"),T.push(`${ne}=${ie}`))}let N="";const z=b.spawn(Fn.OSASCRIPT,T);z.on("error",ne=>{_(u(ne))}),z.stderr.on("data",ne=>{N+=ne.toString()}),z.on("exit",ne=>{if(ne===0)g(void 0);else if(N){const ie=N.split(`
`,1);_(new Error(ie[0]))}else _(new Error(A.localize(1,null,l,ne)))})}else _(new Error(A.localize(2,null,p)))})}spawnTerminal(t,n,s){const i=n.terminal.external,a=(i==null?void 0:i.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((p,g)=>{const _=["-a",a];s&&_.push(s);const l=t.spawn("/usr/bin/open",_);l.on("error",g),l.on("exit",()=>p())})}};E.OSASCRIPT="/usr/bin/osascript",E=qe([He(0,(0,r.optional)(k.IConfigurationService))],E),e.MacExternalTerminalService=E;let v=class Vt extends o{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,s,i,a){const p=a.linuxExec?Promise.resolve(a.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((g,_)=>{let l=[];p.then(w=>{w.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const T=`${c(s)}; echo; read -p "${Vt.WAIT_MESSAGE}" -n1;`;l.push(`''${T}''`);const N=Object.assign({},process.env,i);Object.keys(N).filter(U=>N[U]===null).forEach(U=>delete N[U]);const z={cwd:n,env:N};let ne="";const ie=b.spawn(w,l,z);ie.on("error",U=>{_(u(U))}),ie.stderr.on("data",U=>{ne+=U.toString()}),ie.on("exit",U=>{if(U===0)g(void 0);else if(ne){const B=ne.split(`
`,1);_(new Error(B[0]))}else _(new Error(A.localize(4,null,w,U)))})})})}static async getDefaultTerminalLinuxReady(){return Vt._DEFAULT_TERMINAL_LINUX_READY||(Vt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{C.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Vt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,s){const i=n.terminal.external,a=(i==null?void 0:i.linuxExec)?Promise.resolve(i.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((p,g)=>{a.then(_=>{const l=S(process),w=t.spawn(_,[],{cwd:s,env:l});w.on("error",g),w.on("exit",()=>p())})})}};v.WAIT_MESSAGE=A.localize(3,null),v=qe([He(0,(0,r.optional)(k.IConfigurationService))],v),e.LinuxExternalTerminalService=v;function S(h){const t=h.env;return(0,f.sanitizeProcessEnvironment)(t),t}function u(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(A.localize(5,null,h.path)):h}function c(h){let t="";for(let n of h)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(me[85],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var R;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(R=e.RemoteTrustOption||(e.RemoteTrustOption={}));var I;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(C,D=I.Unknown,k){super(C);this._message=C,this._code=D,this._detail=k,this.isHandled=D===I.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(C){return C instanceof A&&C._code===I.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof A&&C._code===I.NoResolverFound}static isHandled(C){return C instanceof A&&C.isHandled}}e.RemoteAuthorityResolverError=A}),define(me[117],ge([0,1,12]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(D){return D.scheme===b.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=R;function I(D){if(!!D){const k=D.indexOf("+");return k<0?D:D.substr(0,k)}}e.getRemoteName=I;function A(D){return D.scheme!==b.Schemas.file&&D.scheme!==b.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(k=>A(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&A(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function C(D){var k;return(k=y(D))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=C}),define(me[189],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{vsda(){return new Promise((I,A)=>Q(["vsda"],I,A))}async sign(I){try{const A=await this.vsda(),y=new A.signer;if(y)return y.sign(I)}catch(A){}return I}}e.SignService=b}),define(me[190],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,A,y=5){let C;return C=A(D=>{const k=typeof D=="string"?D:D.data;let r=this._terminalBufferMap.get(I);if(r){r.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(I),y);r={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(I),C.dispose()}},this._terminalBufferMap.set(I,r)}),C}stopBuffering(I){const A=this._terminalBufferMap.get(I);A&&A.dispose()}flushBuffer(I){const A=this._terminalBufferMap.get(I);A&&(this._terminalBufferMap.delete(I),this._callback(I,A.data.join("")))}}e.TerminalDataBufferer=b}),define(me[191],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(me[192],ge([0,1,4,6,39,3,191,46]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var D;(function(E){function v(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=v})(D=e.ThemeColor||(e.ThemeColor={}));function k(E){return{id:E}}e.themeColorFromId=k;var r;(function(E){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}E.isThemeIcon=v;const S=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function u(t){const n=S.exec(t);if(!!n){let[,s]=n;return{id:s}}}E.fromString=u;function c(t,n){let s=t.id;const i=s.lastIndexOf("~");return i!==-1&&(s=s.substring(0,i)),n&&(s=`${s}~${n}`),{id:s}}E.modify=c;function h(t,n){var s,i;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((i=n.color)===null||i===void 0?void 0:i.id)}E.isEqual=h,E.asClassNameArray=C.CSSIcon.asClassNameArray,E.asClassName=C.CSSIcon.asClassName,E.asCSSSelector=C.CSSIcon.asCSSSelector})(r=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function P(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,R.toDisposable)(()=>{const S=this.themingParticipants.indexOf(v);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new f;I.Registry.add(e.Extensions.ThemingContribution,m);function o(E){return m.onColorThemeChange(E)}e.registerThemingParticipant=o;class d extends R.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,S){let u=this.theme.getColor(v);return u&&S&&(u=S(u,this.theme)),u?u.toString():null}}e.Themable=d}),define(me[193],ge([0,1,39,192,3,157,116,13,46]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,S,u,c){const h=this.iconsById[v];if(h){if(u&&!h.description){h.description=u,this.iconSchema.properties[v].markdownDescription=`${u} $(${v})`;const s=this.iconReferenceSchema.enum.indexOf(v);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=u),this._onDidChange.fire()}return h}let t={id:v,description:u,defaults:S,deprecationMessage:c};this.iconsById[v]=t;let n={$ref:"#/definitions/icons"};return c&&(n.deprecationMessage=c),u&&(n.markdownDescription=`${u}: $(${v})`),this.iconSchema.properties[v]=n,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(u||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const S=this.iconReferenceSchema.enum.indexOf(v);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,S){const u=this.iconFontsById[v];if(u)return u;let c={id:v,definition:S};return this.iconFontsById[v]=c,this._onDidChange.fire(),c}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(h,t)=>h.id.localeCompare(t.id),S=h=>{for(;R.ThemeIcon.isThemeIcon(h.defaults);)h=this.iconsById[h.defaults.id];return`codicon codicon-${h?h.id:""}`};let u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(h=>this.iconsById[h]);for(const h of c.filter(t=>!!t.description).sort(v))u.push(`|<i class="${S(h)}"></i>|${h.id}|${R.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const h of c.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(v))u.push(`|<i class="${S(h)}"></i>|${h.id}|`);return u.join(`
`)}}const r=new k;b.Registry.add(e.Extensions.IconContribution,r);function P(E,v,S,u){return r.registerIcon(E,v,S,u)}e.registerIcon=P;function f(){return r}e.getIconRegistry=f;function m(){for(const E of D.iconRegistry.all)r.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>r.registerIcon(E.id,E.definition,E.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let o=b.Registry.as(y.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,r.getIconSchema());const d=new C.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=P("widget-close",D.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",D.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",D.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=R.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(me[61],ge([0,1,2,25,4,22]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");var y;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function C(f){const m=f;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=C;function D(f){const m=f;return!!(m&&typeof m=="object"&&b.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=D;class k{constructor(m,o,d,E){this._id=m,this._configuration=d,this._ignorePathCasing=E,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class r{constructor(m,o){this.raw=o,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,R.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function P(f){return new r({uri:f,index:0,name:(0,R.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=P}),define(me[118],ge([0,1,4,158,61,2,10,9,25,133,56,12,77,29,117]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(B){return(typeof B=="string"?(0,C.extname)(B):(0,D.extname)(B))===d}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function v(B){return B.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function S(B){return B.hasOwnProperty("folderUri")}e.isRecentFolder=S;function u(B){return B.hasOwnProperty("fileUri")}e.isRecentFile=u;function c(B){const x=B;return typeof(x==null?void 0:x.id)=="string"&&A.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=c;function h(B){if(B.configuration)return{id:B.id,configPath:B.configuration};if(B.folders.length===1)return{id:B.id,uri:B.folders[0].uri}}e.toWorkspaceIdentifier=h;function t(B){const x=B;return typeof(x==null?void 0:x.id)=="string"&&A.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function n(B){const x=B;if(x==null?void 0:x.uri)return{id:x.id,uri:A.URI.revive(x.uri)};const L=B;if(L==null?void 0:L.configPath)return{id:L.id,configPath:A.URI.revive(L.configPath)};if(B==null?void 0:B.id)return{id:B.id}}e.reviveIdentifier=n;function s(B,x){return D.extUriBiasedIgnorePathCase.isEqualOrParent(B,x.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function i(B){return a(B)||p(B)}e.isStoredWorkspaceFolder=i;function a(B){const x=B;return typeof(x==null?void 0:x.path)=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=a;function p(B){const x=B;return typeof(x==null?void 0:x.uri)=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=p;function g(B,x,L,O,F=!y.isWindows,M){if(B.scheme!==O.scheme)return{name:L,uri:B.toString(!0)};let W=x?void 0:M.relativePath(O,B);if(W!==void 0)W.length===0?W=".":y.isWindows&&B.scheme===P.Schemas.file&&!F&&(W=W.replace(/\//g,"\\"));else if(B.scheme===P.Schemas.file)W=B.fsPath,y.isWindows&&(W=(0,f.normalizeDriveLetter)(W),F&&(W=(0,m.toSlashes)(W)));else{if(!M.isEqualAuthority(B.authority,O.authority))return{name:L,uri:B.toString(!0)};W=B.path}return{name:L,path:W}}e.getStoredWorkspaceFolder=g;function _(B,x,L){let O=[],F=new Set;const M=L.dirname(x);for(let W of B){let q;if(a(W))W.path&&(q=L.resolvePath(M,W.path));else if(p(W))try{q=A.URI.parse(W.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(K){console.warn(K)}if(q){let K=L.getComparisonKey(q);if(!F.has(K)){F.add(K);const le=W.name||L.basenameOrAuthority(q);O.push(new I.WorkspaceFolder({uri:q,name:le,index:O.length},W))}}}return O}e.toWorkspaceFolders=_;function l(B,x,L,O,F){let M=w(x,B);const W=F.dirname(x),q=F.dirname(O),K=[],le=T(M.folders);for(const Oe of M.folders){const V=a(Oe)?F.resolvePath(W,Oe.path):A.URI.parse(Oe.uri);let X;L?X=!1:X=!a(Oe)||(0,C.isAbsolute)(Oe.path),K.push(g(V,X,Oe.name,q,le,F))}const ve={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Re=k.setProperty(B,["folders"],K,ve);let Se=k.applyEdits(B,Re);return M.remoteAuthority===(0,o.getRemoteAuthority)(O)&&(Se=k.applyEdits(Se,k.removeProperty(Se,["remoteAuthority"],ve))),Se}e.rewriteWorkspaceFileForNewLocation=l;function w(B,x){let L=r.parse(x);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(O=>i(O));else throw new Error(`${B} looks like an invalid workspace file.`);return L}function T(B){return y.isWindows?B.some(x=>a(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function N(B){return B.workspace&&typeof B.workspace=="object"&&typeof B.workspace.id=="string"&&typeof B.workspace.configPath=="string"}function z(B){return typeof B.folderUri=="string"}function ne(B){return typeof B.fileUri=="string"}function ie(B,x){const L={workspaces:[],files:[]};if(B){const O=function(M,W){for(let q=0;q<M.length;q++)try{W(M[q],q)}catch(K){x.warn(`Error restoring recent entry ${JSON.stringify(M[q])}: ${K.toString()}. Skip entry.`)}},F=B;if(Array.isArray(F.entries))O(F.entries,M=>{const W=M.label,q=M.remoteAuthority;N(M)?L.workspaces.push({label:W,remoteAuthority:q,workspace:{id:M.workspace.id,configPath:A.URI.parse(M.workspace.configPath)}}):z(M)?L.workspaces.push({label:W,remoteAuthority:q,folderUri:A.URI.parse(M.folderUri)}):ne(M)&&L.files.push({label:W,remoteAuthority:q,fileUri:A.URI.parse(M.fileUri)})});else{const M=B;Array.isArray(M.workspaces3)&&O(M.workspaces3,(W,q)=>{const K=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[q]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?L.workspaces.push({label:K,workspace:{id:W.id,configPath:A.URI.parse(W.configURIPath)}}):typeof W=="string"&&L.workspaces.push({label:K,folderUri:A.URI.parse(W)})}),Array.isArray(M.files2)&&O(M.files2,(W,q)=>{const K=Array.isArray(M.fileLabels)&&M.fileLabels[q]||void 0;typeof W=="string"&&L.files.push({label:K,fileUri:A.URI.parse(W)})})}}return L}e.restoreRecentlyOpened=ie;function U(B){const x={entries:[]};for(const L of B.workspaces)S(L)?x.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):x.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of B.files)x.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return x}e.toStoreData=U}),define(me[86],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const A=this._idPool++;return this._data.set(A,I),this.logDebugInfo(),A}get(I,A){return this._data.has(I)?this._data.get(I)[A]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(me[48],ge([0,1,2,3,4]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class A{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(D=>({name:D.name,group:D.group,resource:b.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(me[62],ge([0,1,12,4]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class I{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,C){C===null?this._providerInfo.delete(y):this._providerInfo.set(y,C)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=I,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(me[194],ge([0,1,13]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(y,C,D){this._deferredPromises=new Map,this._id=y,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new b.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const r of k.values())r.complete()}catch(r){for(const P of k.values())P.error(r)}})()},0)}get whenReady(){return this._init}get(y,C){let D=this._value[y];return typeof D=="undefined"&&(D=C),D}update(y,C){this._value[y]=C;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const k=new b.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class I extends R{constructor(y,C){super(y.identifier.value,!0,C);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=I}),define(me[15],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class R{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)};define(me[195],ge([0,1,26,3]),function(Q,e,b,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(C,D){I.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(C.identifier),it(this,I,D,"f"),$e(this,I,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(C){return $e(this,I,"f").get(this._id,C)}store(C,D){return $e(this,I,"f").store(this._id,C,D)}delete(C){return $e(this,I,"f").delete(this._id,C)}}e.ExtensionSecrets=A,I=new WeakMap}),define(me[119],ge([0,1,4,3]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(me[87],ge([0,1,3]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const I=new WeakMap,A=y=>{let C=I.get(y);return C||(C={children:new Map,bus:new b.Emitter},I.set(y,C)),C};e.getPrivateApiFor=A}),define(me[49],ge([0,1,4,3,15]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(C){function D(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public}}C.fromApiTunnel=D;function k(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.public}}C.fromServiceTunnel=k})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,k){return{dispose:()=>{}}}async $providePortAttributes(D,k,r,P,f){return[]}async $forwardPort(D,k){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=qe([He(0,I.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)},Xt=this&&this.__rest||function(Q,e){var b={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(b[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var I=0,R=Object.getOwnPropertySymbols(Q);I<R.length;I++)e.indexOf(R[I])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[I])&&(b[R[I]]=Q[R[I]]);return b};define(me[7],ge([0,1,16,17,97,22,8,11,2,30,44,85,87]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f){"use strict";var m,o,d,E,v,S,u,c,h,t,n,s,i,a,p,g;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(j){function $(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf($,j),Object.setPrototypeOf($.prototype,j.prototype),$}let l=d=class{constructor($){m.set(this,void 0),it(this,m,$,"f")}static from(...$){let re=$;return new d(function(){if(re){for(const ke of re)ke&&typeof ke.dispose=="function"&&ke.dispose();re=void 0}})}dispose(){typeof $e(this,m,"f")=="function"&&($e(this,m,"f").call(this),it(this,m,void 0,"f"))}};m=new WeakMap,l=d=qe([_],l),e.Disposable=l;let w=E=class{constructor($,re){if($<0)throw(0,R.illegalArgument)("line must be non-negative");if(re<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=$,this._character=re}static Min(...$){if($.length===0)throw new TypeError;let re=$[0];for(let ke=1;ke<$.length;ke++){const Ge=$[ke];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...$){if($.length===0)throw new TypeError;let re=$[0];for(let ke=1;ke<$.length;ke++){const Ge=$[ke];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition($){if(!$)return!1;if($ instanceof E)return!0;let{line:re,character:ke}=$;return typeof re=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,re=0){if($===null||re===null)throw(0,R.illegalArgument)();let ke;return typeof $=="undefined"?ke=0:typeof $=="number"?ke=$:(ke=typeof $.lineDelta=="number"?$.lineDelta:0,re=typeof $.characterDelta=="number"?$.characterDelta:0),ke===0&&re===0?this:new E(this.line+ke,this.character+re)}with($,re=this.character){if($===null||re===null)throw(0,R.illegalArgument)();let ke;return typeof $=="undefined"?ke=this.line:typeof $=="number"?ke=$:(ke=typeof $.line=="number"?$.line:this.line,re=typeof $.character=="number"?$.character:this.character),ke===this.line&&re===this.character?this:new E(ke,re)}toJSON(){return{line:this.line,character:this.character}}};w=E=qe([_],w),e.Position=w;let T=v=class{constructor($,re,ke,Ge){let nt,ot;if(typeof $=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(nt=new w($,re),ot=new w(ke,Ge)):$ instanceof w&&re instanceof w&&(nt=$,ot=re),!nt||!ot)throw new Error("Invalid arguments");nt.isBefore(ot)?(this._start=nt,this._end=ot):(this._start=ot,this._end=nt)}static isRange($){return $ instanceof v?!0:$?w.isPosition($.start)&&w.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof v?this.contains($._start)&&this.contains($._end):$ instanceof w?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const re=w.Max($.start,this._start),ke=w.Min($.end,this._end);if(!re.isAfter(ke))return new v(re,ke)}union($){if(this.contains($))return this;if($.contains(this))return $;const re=w.Min($.start,this._start),ke=w.Max($.end,this.end);return new v(re,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,re=this.end){if($===null||re===null)throw(0,R.illegalArgument)();let ke;return $?w.isPosition($)?ke=$:(ke=$.start||this.start,re=$.end||this.end):ke=this.start,ke.isEqual(this._start)&&re.isEqual(this.end)?this:new v(ke,re)}toJSON(){return[this.start,this.end]}};T=v=qe([_],T),e.Range=T;let N=S=class extends T{constructor($,re,ke,Ge){let nt,ot;if(typeof $=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(nt=new w($,re),ot=new w(ke,Ge)):$ instanceof w&&re instanceof w&&(nt=$,ot=re),!nt||!ot)throw new Error("Invalid arguments");super(nt,ot);this._anchor=nt,this._active=ot}static isSelection($){return $ instanceof S?!0:$?T.isRange($)&&w.isPosition($.anchor)&&w.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};N=S=qe([_],N),e.Selection=N;class z{constructor($,re,ke){if(typeof $!="string"||$.length===0)throw(0,R.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,R.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,R.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(re),this.connectionToken=ke}}e.ResolvedAuthority=z;class ne extends Error{constructor($,re=P.RemoteAuthorityResolverErrorCode.Unknown,ke){super($);this._message=$,this._code=re,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ne.prototype)}static NotAvailable($,re){return new ne($,P.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable($){return new ne($,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ne;var ie;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ie=e.EndOfLine||(e.EndOfLine={}));var U;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=u=class{constructor($,re){this._range=$,this._newText=re}static isTextEdit($){return $ instanceof u?!0:$?T.isRange($)&&typeof $.newText=="string":!1}static replace($,re){return new u($,re)}static insert($,re){return u.replace(new T($,$),re)}static delete($){return u.replace($,"")}static setEndOfLine($){const re=new u(new T(new w(0,0),new w(0,0)),"");return re.newEol=$,re}get range(){return this._range}set range($){if($&&!T.isRange($))throw(0,R.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,R.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,R.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=u=qe([_],B),e.TextEdit=B;var x;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellOutput=4]="CellOutput",j[j.CellReplace=5]="CellReplace",j[j.CellOutputItem=6]="CellOutputItem"})(x=e.FileEditType||(e.FileEditType={}));let L=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,re,ke,Ge){this._edits.push({_type:1,from:$,to:re,options:ke,metadata:Ge})}createFile($,re,ke){this._edits.push({_type:1,from:void 0,to:$,options:re,metadata:ke})}deleteFile($,re,ke){this._edits.push({_type:1,from:$,to:void 0,options:re,metadata:ke})}replaceNotebookMetadata($,re,ke){this._edits.push({_type:3,metadata:ke,uri:$,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells($,re,ke,Ge,nt){let ot,dt,yt=[],kt;if(Wt.isNotebookRange(re)&&Pt.isNotebookCellDataArray(ke)&&!Pt.isNotebookCellDataArray(Ge)?(ot=re.start,dt=re.end,yt=ke,kt=Ge):typeof re=="number"&&typeof ke=="number"&&Pt.isNotebookCellDataArray(Ge)&&(ot=re,dt=ke,yt=Ge,kt=nt),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||yt.length>0)&&this._edits.push({_type:5,uri:$,index:ot,count:dt-ot,cells:yt,metadata:kt})}replaceNotebookCellMetadata($,re,ke,Ge){this._edits.push({_type:3,metadata:Ge,uri:$,edit:{editType:8,index:re,metadata:ke}})}replace($,re,ke,Ge){this._edits.push({_type:2,uri:$,edit:new B(re,ke),metadata:Ge})}insert($,re,ke,Ge){this.replace($,new T(re,re),ke,Ge)}delete($,re,ke){this.replace($,re,"",ke)}has($){return this._edits.some(re=>re._type===2&&re.uri.toString()===$.toString())}set($,re){if(re)for(const ke of re)ke&&this._edits.push({_type:2,uri:$,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ge=this._edits[ke];Ge._type===2&&Ge.uri.toString()===$.toString()&&(this._edits[ke]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get($){const re=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===$.toString()&&re.push(ke.edit);return re}entries(){const $=new A.ResourceMap;for(let re of this._edits)if(re._type===2){let ke=$.get(re.uri);ke||(ke=[re.uri,[]],$.set(re.uri,ke)),ke[1].push(re.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};L=qe([_],L),e.WorkspaceEdit=L;let O=c=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof c?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=c._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,re=this._tabstop++){if(typeof $=="function"){const ke=new c;ke._tabstop=this._tabstop,$(ke),this._tabstop=ke._tabstop,$=ke.value}else $=c._escape($);return this.value+="${",this.value+=re,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,re=this._tabstop++){const ke=$.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable($,re){if(typeof re=="function"){const ke=new c;ke._tabstop=this._tabstop,re(ke),this._tabstop=ke._tabstop,re=ke.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,re&&(this.value+=":",this.value+=re),this.value+="}",this}};O=c=qe([_],O),e.SnippetString=O;var F;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(F=e.DiagnosticTag||(e.DiagnosticTag={}));var M;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(M=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let W=h=class{constructor($,re){if(this.uri=$,re)if(re instanceof T)this.range=re;else if(re instanceof w)this.range=new T(re,re);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof h?!0:$?T.isRange($.range)&&D.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};W=h=qe([_],W),e.Location=W;let q=class{constructor($,re){this.location=$,this.message=re}static is($){return $?typeof $.message=="string"&&$.location&&T.isRange($.location.range)&&D.URI.isUri($.location.uri):!1}static isEqual($,re){return $===re?!0:!$||!re?!1:$.message===re.message&&$.location.range.isEqual(re.location.range)&&$.location.uri.toString()===re.location.uri.toString()}};q=qe([_],q),e.DiagnosticRelatedInformation=q;let K=class{constructor($,re,ke=M.Error){if(!T.isRange($))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=$,this.message=re,this.severity=ke}toJSON(){return{severity:M[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,re){return $===re?!0:!$||!re?!1:$.message===re.message&&$.severity===re.severity&&$.code===re.code&&$.severity===re.severity&&$.source===re.source&&$.range.isEqual(re.range)&&(0,b.equals)($.tags,re.tags)&&(0,b.equals)($.relatedInformation,re.relatedInformation,q.isEqual)}};K=qe([_],K),e.Diagnostic=K;let le=class{constructor($,re){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:(0,I.isMarkdownString)($)?this.contents=[$]:this.contents=[$],this.range=re}};le=qe([_],le),e.Hover=le;var ve;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Re=class{constructor($,re=ve.Text){this.range=$,this.kind=re}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Re=qe([_],Re),e.DocumentHighlight=Re;var Se;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Se=e.SymbolKind||(e.SymbolKind={}));var Oe;(function(j){j[j.Deprecated=1]="Deprecated"})(Oe=e.SymbolTag||(e.SymbolTag={}));let V=t=class{constructor($,re,ke,Ge,nt){this.name=$,this.kind=re,this.containerName=nt,typeof ke=="string"&&(this.containerName=ke),Ge instanceof W?this.location=Ge:ke instanceof T&&(this.location=new W(Ge,ke)),t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Se[this.kind],location:this.location,containerName:this.containerName}}};V=t=qe([_],V),e.SymbolInformation=V;let X=n=class{constructor($,re,ke,Ge,nt){this.name=$,this.detail=re,this.kind=ke,this.range=Ge,this.selectionRange=nt,this.children=[],n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(n.validate)}};X=n=qe([_],X),e.DocumentSymbol=X;var Z;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor($,re){this.title=$,this.kind=re}};se=qe([_],se),e.CodeAction=se;let fe=s=class{constructor($){this.value=$}append($){return new s(this.value?this.value+s.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+s.sep)}};fe.sep=".",fe=s=qe([_],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let Ee=class{constructor($,re){if(this.range=$,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([_],Ee),e.SelectionRange=Ee;class Be{constructor($,re,ke,Ge,nt,ot){this.kind=$,this.name=re,this.detail=ke,this.uri=Ge,this.range=nt,this.selectionRange=ot}}e.CallHierarchyItem=Be;class pe{constructor($,re){this.fromRanges=re,this.from=$}}e.CallHierarchyIncomingCall=pe;class Ce{constructor($,re){this.fromRanges=re,this.to=$}}e.CallHierarchyOutgoingCall=Ce;let Me=class{constructor($,re){this.range=$,this.command=re}get isResolved(){return!!this.command}};Me=qe([_],Me),e.CodeLens=Me;let ze=i=class{constructor($,re=!1){o.set(this,void 0),it(this,o,new I.MarkdownString($,{supportThemeIcons:re}),"f")}static isMarkdownString($){return $ instanceof i?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return $e(this,o,"f").value}set value($){$e(this,o,"f").value=$}get isTrusted(){return $e(this,o,"f").isTrusted}set isTrusted($){$e(this,o,"f").isTrusted=$}get supportThemeIcons(){return $e(this,o,"f").supportThemeIcons}appendText($){return $e(this,o,"f").appendText($),this}appendMarkdown($){return $e(this,o,"f").appendMarkdown($),this}appendCodeblock($,re){return $e(this,o,"f").appendCodeblock(re!=null?re:"",$),this}};o=new WeakMap,ze=i=qe([_],ze),e.MarkdownString=ze;let _e=class{constructor($,re){this.label=$,this.documentation=re}};_e=qe([_],_e),e.ParameterInformation=_e;let Ke=class{constructor($,re){this.label=$,this.documentation=re,this.parameters=[]}};Ke=qe([_],Ke),e.SignatureInformation=Ke;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=qe([_],G),e.SignatureHelp=G;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var we;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(we=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor($,re,ke){this.text=$,this.position=re,this.kind=ke}};xe=qe([_],xe),e.InlayHint=xe;var je;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function(j){j[j.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let De=class{constructor($,re){this.label=$,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};De=qe([_],De),e.CompletionItem=De;let ye=class{constructor($=[],re=!1){this.items=$,this.isIncomplete=re}};ye=qe([_],ye),e.CompletionList=ye;var Ie;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Ie=e.ViewColumn||(e.ViewColumn={}));var oe;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(oe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ue;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(ue=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var H;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(H=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(J=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ce;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Pe;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Pe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function $(re){switch(re){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=$}(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ae=class{constructor($,re){if(re&&!D.URI.isUri(re))throw(0,R.illegalArgument)("target");if(!T.isRange($)||$.isEmpty)throw(0,R.illegalArgument)("range");this.range=$,this.target=re}};Ae=qe([_],Ae),e.DocumentLink=Ae;let Fe=class{constructor($,re,ke,Ge){this.red=$,this.green=re,this.blue=ke,this.alpha=Ge}};Fe=qe([_],Fe),e.Color=Fe;let We=class{constructor($,re){if(re&&!(re instanceof Fe))throw(0,R.illegalArgument)("color");if(!T.isRange($)||$.isEmpty)throw(0,R.illegalArgument)("range");this.range=$,this.color=re}};We=qe([_],We),e.ColorInformation=We;let Xe=class{constructor($){if(!$||typeof $!="string")throw(0,R.illegalArgument)("label");this.label=$}};Xe=qe([_],Xe),e.ColorPresentation=Xe;var rt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var tt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Qe;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Qe=e.TaskRevealKind||(e.TaskRevealKind={}));var gt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(gt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=a=class{constructor($,re){if(typeof $!="string"||typeof re!="string")throw(0,R.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};wt.Clean=new a("clean","Clean"),wt.Build=new a("build","Build"),wt.Rebuild=new a("rebuild","Rebuild"),wt.Test=new a("test","Test"),wt=a=qe([_],wt),e.TaskGroup=wt;function be(j){let $="";for(let re=0;re<j.length;re++)$+=j[re].replace(/,/g,",,")+",";return $}let he=class{constructor($,re,ke){if(typeof $!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=$,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ke):this._options=re)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,R.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let re of this._args)$.push(re);return be($)}};he=qe([_],he),e.ProcessExecution=he;let ae=class{constructor($,re,ke){if(this._args=[],Array.isArray(re)){if(!$)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,R.illegalArgument)("command");this._command=$,this._args=re,this._options=ke}else{if(typeof $!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=$,this._options=re}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,R.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)$.push(typeof re=="string"?re:re.value);return be($)}};ae=qe([_],ae),e.ShellExecution=ae;var Y;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Y=e.ShellQuoting||(e.ShellQuoting={}));var Ne;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ne=e.TaskScope||(e.TaskScope={}));class Le{constructor($){this._callback=$}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Le;let Ye=p=class{constructor($,re,ke,Ge,nt,ot){this.__deprecated=!1,this._definition=this.definition=$;let dt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ke,this.execution=Ge,dt=nt,this.__deprecated=!0):re===Ne.Global||re===Ne.Workspace?(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=nt,dt=ot):(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=nt,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof he?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof ae?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const re=this._definition.type;(p.EmptyType===re||p.ProcessType===re||p.ShellType===re||p.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};Ye.ExtensionCallbackType="customExecution",Ye.ProcessType="process",Ye.ShellType="shell",Ye.EmptyType="$empty",Ye=p=qe([_],Ye),e.Task=Ye;var et;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(et=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor($,re=ut.None){this.collapsibleState=re,D.URI.isUri($)?this.resourceUri=$:this.label=$}};ct=qe([_],ct),e.TreeItem=ct;var ut;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ze=class{constructor($,re){this.id=$,this.color=re}};Ze=qe([_],Ze),e.ThemeIcon=Ze,Ze.File=new Ze("file"),Ze.Folder=new Ze("folder");let mt=class{constructor($){this.id=$}};mt=qe([_],mt),e.ThemeColor=mt;var ht;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ft=class{constructor($,re){if(typeof $!="string"&&(!$||!D.URI.isUri($)&&!D.URI.isUri($.uri)))throw(0,R.illegalArgument)("base");if(typeof re!="string")throw(0,R.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=D.URI.file($),this.base=$):D.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=re}};ft=qe([_],ft),e.RelativePattern=ft;let at=class{constructor($,re,ke,Ge){this.enabled=typeof $=="boolean"?$:!0,typeof re=="string"&&(this.condition=re),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};at=qe([_],at),e.Breakpoint=at;let St=class extends at{constructor($,re,ke,Ge,nt){super(re,ke,Ge,nt);if($===null)throw(0,R.illegalArgument)("location");this.location=$}};St=qe([_],St),e.SourceBreakpoint=St;let Et=class extends at{constructor($,re,ke,Ge,nt){super(re,ke,Ge,nt);this.functionName=$}};Et=qe([_],Et),e.FunctionBreakpoint=Et;let Ot=class extends at{constructor($,re,ke,Ge,nt,ot,dt){super(Ge,nt,ot,dt);if(!re)throw(0,R.illegalArgument)("dataId");this.label=$,this.dataId=re,this.canPersist=ke}};Ot=qe([_],Ot),e.DataBreakpoint=Ot;let Tt=class{constructor($,re,ke){this.command=$,this.args=re||[],this.options=ke}};Tt=qe([_],Tt),e.DebugAdapterExecutable=Tt;let _t=class{constructor($,re){this.port=$,this.host=re}};_t=qe([_],_t),e.DebugAdapterServer=_t;let Yt=class{constructor($){this.path=$}};Yt=qe([_],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor($){this.implementation=$}};Jt=qe([_],Jt),e.DebugAdapterInlineImplementation=Jt;let pt=class{constructor($,re){this.range=$,this.expression=re}};pt=qe([_],pt),e.EvaluatableExpression=pt;let Zt=class{constructor($,re){this.range=$,this.text=re}};Zt=qe([_],Zt),e.InlineValueText=Zt;let Dt=class{constructor($,re,ke=!0){this.range=$,this.variableName=re,this.caseSensitiveLookup=ke}};Dt=qe([_],Dt),e.InlineValueVariableLookup=Dt;let qt=class{constructor($,re){this.range=$,this.expression=re}};qt=qe([_],qt),e.InlineValueEvaluatableExpression=qt;let en=class{constructor($,re){this.frameId=$,this.stoppedLocation=re}};en=qe([_],en),e.InlineValueContext=en;var Kt;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Kt=e.FileChangeType||(e.FileChangeType={}));let lt=g=class extends Error{constructor($,re=r.FileSystemProviderErrorCode.Unknown,ke){var Ge;super(D.URI.isUri($)?$.toString(!0):$);this.code=(Ge=ke==null?void 0:ke.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,r.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists($){return new g($,r.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound($){return new g($,r.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory($){return new g($,r.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory($){return new g($,r.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions($){return new g($,r.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable($){return new g($,r.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}};lt=g=qe([_],lt),e.FileSystemError=lt;let tn=class{constructor($,re,ke){this.start=$,this.end=re,this.kind=ke}};tn=qe([_],tn),e.FoldingRange=tn;var Rt;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $t;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})($t=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class En{constructor($,re=[]){this.tokenTypes=$,this.tokenModifiers=re}}e.SemanticTokensLegend=En;function hn(j){return typeof j=="undefined"||(0,C.isStringArray)(j)}class nn{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let re=0,ke=$.tokenTypes.length;re<ke;re++)this._tokenTypeStrToInt.set($.tokenTypes[re],re);for(let re=0,ke=$.tokenModifiers.length;re<ke;re++)this._tokenModifierStrToInt.set($.tokenModifiers[re],re)}}push($,re,ke,Ge,nt){if(typeof $=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded($,re,ke,Ge,nt);if(T.isRange($)&&typeof re=="string"&&hn(ke))return this._push($,re,ke);throw(0,R.illegalArgument)()}_push($,re,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=$.start.line,nt=$.start.character,ot=$.end.character-$.start.character,dt=this._tokenTypeStrToInt.get(re);let yt=0;if(ke)for(const kt of ke){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(kt);yt|=1<<It>>>0}this._pushEncoded(Ge,nt,ot,dt,yt)}_pushEncoded($,re,ke,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let kt=0,It=0;for(let At=0;At<yt;At++){let Ft=this._data[5*At],cn=this._data[5*At+1];Ft===0?(Ft=kt,cn+=It):Ft+=kt,this._data[5*At]=Ft,this._data[5*At+1]=cn,kt=Ft,It=cn}}let ot=$,dt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=$,this._prevChar=re}static _sortAndDeltaEncode($){let re=[];const ke=$.length/5|0;for(let dt=0;dt<ke;dt++)re[dt]=dt;re.sort((dt,yt)=>{const kt=$[5*dt],It=$[5*yt];if(kt===It){const At=$[5*dt+1],Ft=$[5*yt+1];return At-Ft}return kt-It});const Ge=new Uint32Array($.length);let nt=0,ot=0;for(let dt=0;dt<ke;dt++){const yt=5*re[dt],kt=$[yt+0],It=$[yt+1],At=$[yt+2],Ft=$[yt+3],cn=$[yt+4],Ln=kt-nt,xn=Ln===0?It-ot:It,un=5*dt;Ge[un+0]=Ln,Ge[un+1]=xn,Ge[un+2]=At,Ge[un+3]=Ft,Ge[un+4]=cn,nt=kt,ot=It}return Ge}build($){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),$):new Gt(nn._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=nn;class Gt{constructor($,re){this.resultId=re,this.data=$}}e.SemanticTokens=Gt;class Nt{constructor($,re,ke){this.start=$,this.deleteCount=re,this.data=ke}}e.SemanticTokensEdit=Nt;class Sn{constructor($,re){this.resultId=re,this.edits=$}}e.SemanticTokensEdits=Sn;var rn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(rn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var sn;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(sn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Qt=class{constructor(){}};Qt.Back={iconPath:new Ze("arrow-left")},Qt=qe([_],Qt),e.QuickInputButtons=Qt;var yn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(yn=e.ExtensionKind||(e.ExtensionKind={}));class Lt{constructor($,re,ke){this.badge=$,this.tooltip=re,this.color=ke}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Lt;let on=class{constructor($){this.kind=$}};on=qe([_],on),e.ColorTheme=on;var Dn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(Dn=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor($,re){if($<0)throw(0,R.illegalArgument)("start must be positive");if(re<0)throw(0,R.illegalArgument)("end must be positive");$<=re?(this._start=$,this._end=re):(this._start=re,this._end=$)}static isNotebookRange($){return $ instanceof Wt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let re=this._start,ke=this._end;return $.start!==void 0&&(re=$.start),$.end!==void 0&&(ke=$.end),re===this._start&&ke===this._end?this:new Wt(re,ke)}}e.NotebookRange=Wt;class an{constructor($,re){typeof $=="object"?Object.assign(this,$):(this.inputCollapsed=$,this.outputCollapsed=re)}with($){let{inputCollapsed:re,outputCollapsed:ke}=$,Ge=Xt($,["inputCollapsed","outputCollapsed"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),ke===void 0?ke=this.outputCollapsed:ke===null&&(ke=void 0),re===this.inputCollapsed&&ke===this.outputCollapsed&&Object.keys(Ge).length===0?this:new an(Object.assign({inputCollapsed:re,outputCollapsed:ke},Ge))}}e.NotebookCellMetadata=an;class Ut{constructor($={}){Object.assign(this,$)}with($){return new Ut($)}}e.NotebookDocumentMetadata=Ut;class Pt{constructor($,re,ke,Ge,nt,ot){this.kind=$,this.value=re,this.languageId=ke,this.outputs=Ge!=null?Ge:[],this.metadata=nt,this.executionSummary=ot,Pt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(re=>Pt.isNotebookCellData(re))}static isNotebookCellData($){return!0}}e.NotebookCellData=Pt;class fn{constructor($,re){this.cells=$,this.metadata=re!=null?re:new Ut}}e.NotebookData=fn;class xt{constructor($,re,ke){if(this.mime=$,this.value=re,this.metadata=ke,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem($){return $ instanceof xt?!0:$?typeof $.mime=="string":!1}static error($){return new xt("application/x.notebook.error",JSON.stringify({name:$.name,message:$.message,stack:$.stack}))}}e.NotebookCellOutputItem=xt;class Ue{constructor($,re,ke){this.outputs=$,typeof re=="string"?(this.id=re,this.metadata=ke):(this.id=(0,k.generateUuid)(),this.metadata=re!=null?re:ke)}}e.NotebookCellOutput=Ue;var ln;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(ln=e.NotebookCellKind||(e.NotebookCellKind={}));var mn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(mn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var vt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(vt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Cn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Cn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class kn{constructor($,re,ke,Ge,nt,ot){this.text=$,this.alignment=re,this.command=ke,this.tooltip=Ge,this.priority=nt,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=kn;var gn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(gn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor($,re=[]){this.uri=$,this.provides=typeof re=="string"?[re]:re}}e.NotebookKernelPreload=pn;let Ht=class{constructor($,re){this.label=$,this.timestamp=re}};Ht=qe([_],Ht),e.TimelineItem=Ht;var In;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(In=e.ExtensionMode||(e.ExtensionMode={}));var Pn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Pn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var An;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(An=e.StandardTokenType||(e.StandardTokenType={}));class vn{constructor($,re){this.ranges=$,this.wordPattern=re}}e.LinkedEditingRanges=vn;class Tn{constructor($,re){this._port=$,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Tn;var Rn;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Rn=e.TestResultState||(e.TestResultState={}));var wn;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information",j[j.Hint=3]="Hint"})(wn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var bn;(function(j){j[j.Pending=0]="Pending",j[j.Resolved=1]="Resolved"})(bn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(j,$,re,ke)=>{let Ge=re;return{enumerable:!0,configurable:!1,get(){return Ge},set(nt){ke(Ge,nt)||(Ge=nt,j.bus.fire([3,$,nt]))}}},ee=(j,$)=>j===$,de=(j,$)=>j===$?!0:!j||!$?!1:j.isEqual($);class Te{constructor($,re,ke,Ge){this.label=re,this.data=Ge;const nt=(0,f.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:$,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>nt.parent},children:{value:new A.ReadonlyMapView(nt.children),enumerable:!0,writable:!1},range:Bt(nt,"range",void 0,de),description:Bt(nt,"description",void 0,ee),runnable:Bt(nt,"runnable",!0,ee),debuggable:Bt(nt,"debuggable",!1,ee),status:Bt(nt,"status",bn.Resolved,ee),error:Bt(nt,"error",void 0,ee)})}invalidate(){(0,f.getPrivateApiFor)(this).bus.fire([2])}dispose(){const $=(0,f.getPrivateApiFor)(this);$.parent&&(0,f.getPrivateApiFor)($.parent).children.delete(this.id),$.bus.fire([1])}addChild($){if(!($ instanceof Te))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,f.getPrivateApiFor)(this);if(re.children.has($.id))throw new Error(`Attempted to insert a duplicate test item ID ${$.id}`);re.children.set($.id,$),re.bus.fire([0,$])}}e.TestItemImpl=Te;class st{constructor($){this.message=$,this.severity=wn.Error}static diff($,re,ke){const Ge=new st($);return Ge.expectedOutput=re,Ge.actualOutput=ke,Ge}}e.TestMessage=st;var bt;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(bt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ct;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Ct=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Un;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore"})(Un=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[120],ge([0,1,52,12,8,144,108,7,16]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function r(o,d){d?k.set(o,d):k.delete(o)}e.setWordDefinitionFor=r;function P(o){return k.get(o)}e.getWordDefinitionFor=P;class f extends A.MirrorTextModel{constructor(d,E,v,S,u,c,h,t){super(E,v,S,u);this._proxy=d,this._languageId=c,this._isDirty=h,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,D.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===R.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(E){return E?d._getTextInRange(E):d.getText()},get eol(){return d._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(E){return d._lineAt(E)},offsetAt(E){return d._offsetAt(E)},positionAt(E){return d._positionAt(E)},validateRange(E){return d._validateRange(E)},validatePosition(E){return d._validatePosition(E)},getWordRangeAtPosition(E,v){return d._getWordRangeAtPosition(E,v)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,b.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,b.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const E=this._validateRange(d);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const v=this._eol,S=E.start.line,u=E.end.line,c=[];c.push(this._lines[S].substring(E.start.character));for(let h=S+1;h<u;h++)c.push(this._lines[h]);return c.push(this._lines[u].substring(0,E.end.character)),c.join(v)}_lineAt(d){let E;if(d instanceof C.Position?E=d.line:typeof d=="number"&&(E=d),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new m(E,this._lines[E],E===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(d),v=this._lines[E.index].length;return new C.Position(E.index,Math.min(E.remainder,v))}_validateRange(d){if(!(d instanceof C.Range))throw new Error("Invalid argument");const E=this._validatePosition(d.start),v=this._validatePosition(d.end);return E===d.start&&v===d.end?d:new C.Range(E.line,E.character,v.line,v.character)}_validatePosition(d){if(!(d instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:E,character:v}=d,S=!1;if(E<0)E=0,v=0,S=!0;else if(E>=this._lines.length)E=this._lines.length-1,v=this._lines[E].length,S=!0;else{const u=this._lines[E].length;v<0?(v=0,S=!0):v>u&&(v=u,S=!0)}return S?new C.Position(E,v):d}_getWordRangeAtPosition(d,E){const v=this._validatePosition(d);if(!E)E=P(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(v.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[v.line],0);if(S)return new C.Range(v.line,S.startColumn-1,v.line,S.endColumn-1)}}e.ExtHostDocumentData=f;class m{constructor(d,E,v){this._line=d,this._text=E,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[196],ge([0,1,7,3,110,6,78,22,2,30]),function(Q,e,b,R,I,A,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class r{constructor(f,m,o,d){this._notebook=o,this._selector=d,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(v=>{const S=this._cellUris.get(v.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(f.onDidChangeNotebookCells(v=>E(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const f=[],m=[];for(const o of this._notebook.getCells())o.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),f.push(o.document.getText().length+1),m.push(o.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(f)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(f){var m,o;if(!f){let u="";for(const c of this._cells)u+=c.document.getText()+`
`;return u=u.slice(0,-1),u}if(f.isEmpty)return"";const d=this.locationAt(f.start),E=this.locationAt(f.end),v=this._cells[(m=this._cellUris.get(d.uri))!==null&&m!==void 0?m:-1],S=this._cells[(o=this._cellUris.get(E.uri))!==null&&o!==void 0?o:-1];if(!v||!S)return"";if(v===S)return v.document.getText(new b.Range(d.range.start,E.range.end));{const u=v.document.getText(new b.Range(d.range.start,new b.Position(v.document.lineCount,0))),c=S.document.getText(new b.Range(new b.Position(0,0),E.range.end));return u+`
`+c}}offsetAt(f){const m=this._cellLines.getIndexOf(f.line),o=this._cellLengths.getAccumulatedValue(m.index-1),d=this._cells[m.index].document.offsetAt(f.with(m.remainder));return o+d}positionAt(f){if(typeof f=="number"){const o=this._cellLengths.getIndexOf(f),d=this._cellLines.getAccumulatedValue(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(d)}const m=this._cellUris.get(f.uri);if(m!==void 0){const o=this._cellLines.getAccumulatedValue(m-1);return new b.Position(o+f.range.start.line,f.range.start.character)}return new b.Position(0,0)}locationAt(f){b.Range.isRange(f)||(f=new b.Range(f,f));const m=this._cellLines.getIndexOf(f.start.line);let o=m;f.isEmpty||(o=this._cellLines.getIndexOf(f.end.line));const d=new b.Position(m.remainder,f.start.character),E=new b.Position(o.remainder,f.end.character),v=new b.Range(d,E),S=this._cells[m.index];return new b.Location(S.document.uri,S.document.validateRange(v))}contains(f){return this._cellUris.has(f)}validateRange(f){const m=this.validatePosition(f.start),o=this.validatePosition(f.end);return f.with(m,o)}validatePosition(f){const m=this._cellLines.getIndexOf(f.line),o=new b.Position(m.remainder,f.character),d=this._cells[m.index].document.validatePosition(o),E=this._cellLines.getAccumulatedValue(m.index-1);return new b.Position(E+d.line,d.character)}}e.ExtHostNotebookConcatDocument=r}),define(me[197],ge([0,1,7,15,3]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(C){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?b.ColorThemeKind.Light:C==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=qe([He(0,R.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(me[63],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class R{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=R}),define(me[198],ge([0,1,23]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function I(C,D){if(D.serializeBuffersForPostMessage){const k=new R,r=(m,o)=>{if(o instanceof ArrayBuffer){const d=k.add(o);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(o)){const d=A(o);if(d){const E=k.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:d,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},P=JSON.stringify(C,r),f=k.buffers.map(m=>{const o=new Uint8Array(m);return b.VSBuffer.wrap(o)});return{message:P,buffers:f}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=I;function A(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(C,D){const k=D.map(f=>{const m=new ArrayBuffer(f.byteLength);return new Uint8Array(m).set(f.buffer),m}),r=D.length?(f,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const o=m,{index:d}=o,E=k[d];if(o.view)switch(o.view.type){case 1:return new Int8Array(E,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return m}:void 0;return{message:JSON.parse(C,r),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(me[88],ge([0,1,2]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function R(I,A,y){var C;const D=I.webviewResourceRoot.replace("{{resource}}",((C=I.remote.authority)!==null&&C!==void 0?C:"")+"/"+y.scheme+"/"+encodeURIComponent(y.authority)+y.path).replace("{{uuid}}",A);return b.URI.parse(D).with({fragment:y.fragment,query:y.query})}e.asWebviewUri=R}),define(me[199],ge([0,1,3,6,88,30]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,k,r){this._proxy=D,this._editors=k,this._initData=r,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const f of this._insets.values())P.indexOf(f.editor)<0&&f.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,k,r,P,f){let m;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===D){m=c;break}if(!m)throw new Error("not a visible editor");const o=this,d=this._handlePool++,E=new b.Emitter,v=new b.Emitter,S=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,I.asWebviewUri)(o._initData,this._uuid,c)}get cspSource(){return o._initData.webviewCspSource}set options(c){this._options=c,o._proxy.$setOptions(d,c)}get options(){return this._options}set html(c){this._html=c,o._proxy.$setHtml(d,c)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(c){return o._proxy.$postMessage(d,c)}},u=new class{constructor(){this.editor=D,this.line=k,this.height=r,this.webview=S,this.onDidDispose=v.event}dispose(){o._insets.has(d)&&(o._insets.delete(d),o._proxy.$disposeEditorInset(d),v.fire(),v.dispose(),E.dispose())}};return this._proxy.$createEditorInset(d,m.id,m.value.document.uri,k+1,r,P||{},f.identifier,f.extensionLocation),this._insets.set(d,{editor:D,inset:u,onDidReceiveMessage:E}),u}$onDidDispose(D){const k=this._insets.get(D);k&&k.inset.dispose()}$onDidReceiveMessage(D,k){const r=this._insets.get(D);r&&r.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(me[200],ge([0,1,3,81,168,4,6,22,39,16,53,24,46,193]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",f.Codicon.window,(0,I.localize)(0,null));var o;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var d;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function v(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=v;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(p,g,_){var l;const w=this.get(p.id);if(w)return w;const T=p;return T.openCommandActionDescriptor=(_==null?void 0:_.donotRegisterOpenCommand)?void 0:(l=T.openCommandActionDescriptor)!==null&&l!==void 0?l:{id:T.id},(0,C.getOrSet)(this.viewContainers,g,[]).push(T),(_==null?void 0:_.isDefault)&&this.defaultViewContainers.push(T),this._onDidRegister.fire({viewContainer:T,viewContainerLocation:g}),T}deregisterViewContainer(p){for(const g of this.viewContainers.keys()){const _=this.viewContainers.get(g),l=_==null?void 0:_.indexOf(p);if(l!==-1){_==null||_.splice(l,1),_.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:p,viewContainerLocation:g});return}}}get(p){return this.all.filter(g=>g.id===p)[0]}getViewContainers(p){return[...this.viewContainers.get(p)||[]]}getViewContainerLocation(p){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(_=>(_==null?void 0:_.id)===p.id).length>0)[0]}getDefaultViewContainer(p){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===p)}}D.Registry.add(o.ViewContainersRegistry,new S);var u;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function c(a,p){var g,_,l,w;const T=(g=a.group)!==null&&g!==void 0?g:u.More,N=(_=p.group)!==null&&_!==void 0?_:u.More;return T!==N?T.localeCompare(N):((l=a.order)!==null&&l!==void 0?l:5)-((w=p.order)!==null&&w!==void 0?w:5)}class h extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new r.SetMap}registerViews(p,g){this.registerViews2([{views:p,viewContainer:g}])}registerViews2(p){p.forEach(({views:g,viewContainer:_})=>this.addViews(g,_)),this._onViewsRegistered.fire(p)}deregisterViews(p,g){const _=this.removeViews(p,g);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:g})}moveViews(p,g){for(const _ of this._views.keys())if(_!==g){const l=this.removeViews(p,_);l.length&&(this.addViews(l,g),this._onDidChangeContainer.fire({views:l,from:_,to:g}))}}getViews(p){return this._views.get(p)||[]}getView(p){for(const g of this._viewContainers){const _=(this._views.get(g)||[]).filter(l=>l.id===p)[0];if(_)return _}return null}getViewContainer(p){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(l=>l.id===p)[0])return g;return null}registerViewWelcomeContent(p,g){return this._viewWelcomeContents.add(p,g),this._onDidChangeViewWelcomeContent.fire(p),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(p,g),this._onDidChangeViewWelcomeContent.fire(p)})}registerViewWelcomeContent2(p,g){const _=new Map;for(const[l,w]of g)this._viewWelcomeContents.add(p,w),_.set(l,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(p,w),this._onDidChangeViewWelcomeContent.fire(p)}));return this._onDidChangeViewWelcomeContent.fire(p),_}getViewWelcomeContent(p){const g=[];return this._viewWelcomeContents.forEach(p,_=>g.push(_)),g.sort(c)}addViews(p,g){let _=this._views.get(g);_||(_=[],this._views.set(g,_),this._viewContainers.push(g));for(const l of p){if(this.getView(l.id)!==null)throw new Error((0,I.localize)(1,null,l.id));_.push(l)}}removeViews(p,g){const _=this._views.get(g);if(!_)return[];const l=[],w=[];for(const T of _)p.includes(T)?l.push(T):w.push(T);return l.length&&(w.length?this._views.set(g,w):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),l}}D.Registry.add(o.ViewsRegistry,new h),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,I.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(p,g){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,p),this._hasResolve=!!g,this.resolve=async _=>{var l,w;if(g&&!this.resolved){const T=await g(_);T&&(this.tooltip=(l=this.tooltip)!==null&&l!==void 0?l:T.tooltip,this.command=(w=this.command)!==null&&w!==void 0?w:T.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i}),define(me[201],ge([0,1,2,179,118,14,180,200]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(d){return(E,...v)=>d(E.get(R.ICommandService),...v)}class k{static execute(E,v){const S={forceReuseWindow:v&&v.reuseWindow,remoteAuthority:v&&v.remoteAuthority};return E.executeCommand("_files.newWindow",S)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:k.ID,handler:D(k.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(d,E){return d.get(I.IWorkspacesService).removeRecentlyOpened([E])});class r{static execute(E,v){return typeof v=="string"?v=v.match(/^[^:/?#]+:\/\//)?b.URI.parse(v):b.URI.file(v):v=b.URI.revive(v),E.executeCommand("_workbench.removeFromRecentlyOpened",v)}}e.RemoveFromRecentlyOpenedAPICommand=r,r.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(r.ID,D(r.execute));class P{static execute(E,v){const S=typeof v=="string"?{extensionId:v}:v;return E.executeCommand("workbench.action.openIssueReporter",S)}}e.OpenIssueReporter=P,P.ID="vscode.openIssueReporter",R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(d,E){const v=d.get(I.IWorkspacesService);let S;const u=E.uri,c=E.label,h=E.remoteAuthority;return E.type==="workspace"?S={workspace:await v.getWorkspaceIdentifier(u),label:c,remoteAuthority:h}:E.type==="folder"?S={folderUri:u,label:c,remoteAuthority:h}:S={fileUri:u,label:c,remoteAuthority:h},v.addRecentlyOpened([S])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(d){return d.get(I.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(d,E){const v=d.get(A.ILogService),S=d.get(y.IEnvironmentService);S.isExtensionDevelopment&&!!S.extensionTestsLocationURI&&v.setLevel(E)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(d){return d.get(A.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(d,E){const v=d.get(C.IViewDescriptorService),S=v.getViewContainerById(E.destinationId);if(!!S){for(const u of E.viewIds){const c=v.getViewDescriptorById(u);(c==null?void 0:c.canMoveView)&&v.moveViewsToContainer([c],S,C.ViewVisibilityState.Default)}await d.get(C.IViewsService).openViewContainer(S.id,!0)}});class f{static execute(E,v){return!Array.isArray(v==null?void 0:v.viewIds)||typeof(v==null?void 0:v.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",v)}}e.MoveViewsAPICommand=f,f.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:f.ID,handler:D(f.execute),description:{description:"Move Views",args:[]}});class m{static execute(E,v){return E.executeCommand("_workbench.open",v)}}m.ID="vscode.open",R.CommandsRegistry.registerCommand(m.ID,D(m.execute));class o{static execute(E,v,S,u,c){return E.executeCommand("_workbench.diff",[v,S,u])}}o.ID="vscode.diff",R.CommandsRegistry.registerCommand(o.ID,D(o.execute))}),define(me[121],ge([0,1,3,13,169]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,k,r){const P={command:C};if(D&&Object.keys(D).length>0&&(P.arguments=D),this.internalSend("request",P),typeof r=="number"){const f=setTimeout(()=>{clearTimeout(f);const m=this.pendingRequests.get(P.seq);if(m){this.pendingRequests.delete(P.seq);const o={type:"response",seq:0,request_seq:P.seq,success:!1,command:C,message:(0,I.localize)(0,null,r,C)};m(o)}},r)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,R.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,k=this.pendingRequests.get(D.request_seq);k&&(this.pendingRequests.delete(D.request_seq),k(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,k)=>C.set(k,D)),await(0,R.timeout)(500),C.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(me[202],ge([0,1,8,2,9,24,12]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(n,s,i){return n.replace(C,function(a,p){return s&&p.length>0&&p[0]!=="_"?a:i&&i.hasOwnProperty(p)?i[p]:a})}e.formatPII=D;function k(n){const s={};for(const i of Object.keys(n))i.startsWith("!")||(s[i]=n[i]);return s}e.filterExceptionsFromTelemetry=k;function r(n){return n.configuration.request==="attach"&&!P(n)}e.isSessionAttach=r;function P(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(s,"extensionhost")||(0,b.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function m(n,s,i){let a,p=0,g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=g.exec(n);){let l=_.index+1,w=l+_[0].length;if(l<=s&&w>=i){a=_[0],p=l;break}}if(a){let l=/\w+/g,w=null;for(;(w=l.exec(a))&&!(w.index+1+p+w[0].length>=i););w&&(a=a.substring(0,l.lastIndex))}return a?{start:p,end:p+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(n){return!!(n&&n.match(o))}e.isUri=d;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(d(n.path))return R.URI.parse(n.path);if((0,I.isAbsolute)(n.path))return R.URI.file(n.path)}return n.path}function v(n){if(typeof n.path=="object"){const s=R.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function S(n,s){const i=s?E:v,a=(0,A.deepClone)(n);return c(a,(p,g)=>{p&&g&&(g.path=i(g))}),a}e.convertToDAPaths=S;function u(n,s){const i=s?E:v,a=(0,A.deepClone)(n);return c(a,(p,g)=>{!p&&g&&(g.path=i(g))}),a}e.convertToVSCPaths=u;function c(n,s){switch(n.type){case"event":const i=n;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break;case"request":const a=n;switch(a.command){case"setBreakpoints":s(!0,a.arguments.source);break;case"breakpointLocations":s(!0,a.arguments.source);break;case"source":s(!0,a.arguments.source);break;case"gotoTargets":s(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(g=>s(!1,g));break;default:break}break;case"response":const p=n;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(g=>s(!1,g.source));break;case"loadedSources":p.body.sources.forEach(g=>s(!1,g));break;case"scopes":p.body.scopes.forEach(g=>s(!1,g.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(g=>s(!1,g.source));break;case"setBreakpoints":p.body.breakpoints.forEach(g=>s(!1,g.source));break;default:break}break}}function h(n){return n.filter(s=>{var i;return!((i=s.presentation)===null||i===void 0?void 0:i.hidden)}).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):t(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=h;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(me[203],ge([0,1,28,38,170,122,9,8,24,10,181,121]),function(Q,e,b,R,I,A,y,C,D,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class f extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",c=>this.handleData(c))}sendMessage(S){if(this.outputStream){const u=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${f.TWO_CRLF}${u}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+u))}continue}}else{const u=this.rawData.indexOf(f.TWO_CRLF);if(u!==-1){const h=this.rawData.toString("utf8",0,u).split(f.HEADER_LINESEPARATOR);for(const t of h){const n=t.split(f.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(u+f.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=f,f.TWO_CRLF=`\r
\r
`,f.HEADER_LINESEPARATOR=/\r?\n/,f.HEADER_FIELDSEPARATOR=/: */;class m extends f{startSession(){return new Promise((S,u)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",h=>{c?this._onError.fire(h):u(h)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class o extends m{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=o;class d extends m{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=d;class E extends f{constructor(S,u,c){super();this.adapterExecutable=S,this.debugType=u,this.outputService=c}async startSession(){const S=this.adapterExecutable.command,u=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(S)if(y.isAbsolute(S)){if(!await(0,b.exists)(S))throw new Error(I.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let h=process.env;if(c.env&&Object.keys(c.env).length>0&&(h=D.mixin(D.deepClone(process.env),c.env)),S==="node")if(Array.isArray(u)&&u.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:h,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(s.cwd=c.cwd);const i=R.fork(u[0],u.slice(1),s);if(!i.pid)throw new Error(I.localize(2,null,u[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const n={env:h};c.cwd&&(n.cwd=c.cwd),this.serverProcess=R.spawn(S,u,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const i=t.getChannel(r.ExtensionsChannelId);i&&i.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(h){this._onError.fire(h)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((S,u)=>{const c=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(h,t,n){if(h)return u(h)});c.on("exit",S),c.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,u){if(!!S){const c=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?c.runtime=y.join(u,S.runtime):c.runtime=S.runtime),S.runtimeArgs&&(c.runtimeArgs=S.runtimeArgs),S.program&&(y.isAbsolute(S.program)?c.program=S.program:c.program=y.join(u,S.program)),S.args&&(c.args=S.args);const h=S;return h.win&&(c.win=E.extract(h.win,u)),h.winx86&&(c.winx86=E.extract(h.winx86,u)),h.windows&&(c.windows=E.extract(h.windows,u)),h.osx&&(c.osx=E.extract(h.osx,u)),h.linux&&(c.linux=E.extract(h.linux,u)),c}}static platformAdapterExecutable(S,u){let c=Object.create(null);u=u.toLowerCase();for(const a of S)if(a.contributes){const p=a.contributes.debuggers;p&&p.length>0&&p.filter(g=>typeof g.type=="string"&&C.equalsIgnoreCase(g.type,u)).forEach(g=>{const _=E.extract(g,a.extensionLocation.fsPath);c=D.mixin(c,_,a.isBuiltin)})}let h;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?h=c.winx86||c.win||c.windows:k.isWindows?h=c.win||c.windows:k.isMacintosh?h=c.osx:k.isLinux&&(h=c.linux),h=h||c;let t=h.program||c.program;const n=h.args||c.args;let s=h.runtime||c.runtime;const i=h.runtimeArgs||c.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(me[204],ge([0,1,38,10,29,188]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(f,m){return new Promise((o,d)=>{let E="";const v=b.spawn(f,m);v.pid&&v.stdout.on("data",S=>{E+=S.toString()}),v.on("error",S=>{d(S)}),v.on("close",S=>{o(E)})})}let C;function D(f,m){if(!C)if(R.isWindows)C=new A.WindowsExternalTerminalService(void 0);else if(R.isMacintosh)C=new A.MacExternalTerminalService(void 0);else if(R.isLinux)C=new A.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const o=m.getConfiguration("terminal");return C.runInTerminal(f.title,f.cwd,f.args,f.env||{},o.external||{})}e.runInExternalTerminal=D;function k(f){return f?R.isWindows?y("wmic",["process","get","ParentProcessId"]).then(m=>m.split(`\r
`).some(d=>parseInt(d)===f),m=>!0):y("/usr/bin/pgrep",["-lP",String(f)]).then(m=>{const o=m.trim();return!(o.length===0||o.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=k;var r;(function(f){f[f.cmd=0]="cmd",f[f.powershell=1]="powershell",f[f.bash=2]="bash"})(r||(r={}));function P(f,m,o,d){f=f.trim().toLowerCase();let E;f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0?E=1:f.indexOf("cmd.exe")>=0?E=0:f.indexOf("bash")>=0?E=2:R.isWindows?E=0:E=2;let v,S=" ";switch(E){case 1:if(v=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),o){const c=(0,I.getDriveLetter)(o);c&&(S+=`${c}:; `),S+=`cd ${v(o)}; `}if(d)for(let c in d){const h=d[c];h===null?S+=`Remove-Item env:${c}; `:S+=`\${env:${c}}='${h}'; `}if(m.length>0){const c=v(m.shift());S+=c[0]==="'"?`& ${c} `:`${c} `;for(let h of m)S+=`${v(h)} `}break;case 0:if(v=c=>(c=c.replace(/\"/g,'""'),c.indexOf(" ")>=0||c.indexOf('"')>=0||c.length===0?`"${c}"`:c),o){const c=(0,I.getDriveLetter)(o);c&&(S+=`${c}: && `),S+=`cd ${v(o)} && `}if(d){S+='cmd /C "';for(let c in d){let h=d[c];h===null?S+=`set "${c}=" && `:(h=h.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),S+=`set "${c}=${h}" && `)}}for(let c of m)S+=`${v(c)} `;d&&(S+='"');break;case 2:v=c=>(c=c.replace(/(["'\\\$])/g,"\\$1"),c.indexOf(" ")>=0||c.indexOf(";")>=0||c.length===0?`"${c}"`:c);const u=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if(o&&(S+=`cd ${v(o)} ; `),d){S+="/usr/bin/env";for(let c in d){const h=d[c];h===null?S+=` -u ${u(c)}`:S+=` ${u(`${c}=${h}`)}`}S+=" "}for(let c of m)S+=`${v(c)} `;break}return S}e.prepareCommand=P}),define(me[64],ge([0,1,32,12,9,10,81]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(l){l[l.Markup=1]="Markup",l[l.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(l){l[l.Running=1]="Running",l[l.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(l){l[l.Pending=2]="Pending",l[l.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var r;(function(l){l[l.WithHardKernelDependency=0]="WithHardKernelDependency",l[l.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",l[l.Pure=2]="Pure",l[l.Never=3]="Never"})(r=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(l){l[l.ModelChange=1]="ModelChange",l[l.Move=2]="Move",l[l.CellClearOutput=3]="CellClearOutput",l[l.CellsClearOutput=4]="CellsClearOutput",l[l.ChangeLanguage=5]="ChangeLanguage",l[l.Initialize=6]="Initialize",l[l.ChangeCellMetadata=7]="ChangeCellMetadata",l[l.Output=8]="Output",l[l.OutputItem=9]="OutputItem",l[l.ChangeCellContent=10]="ChangeCellContent",l[l.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",l[l.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",l[l.Unknown=100]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var f;(function(l){l[l.Handle=0]="Handle",l[l.Index=1]="Index"})(f=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(l){l[l.Replace=1]="Replace",l[l.Output=2]="Output",l[l.Metadata=3]="Metadata",l[l.CellLanguage=4]="CellLanguage",l[l.DocumentMetadata=5]="DocumentMetadata",l[l.Move=6]="Move",l[l.OutputItems=7]="OutputItems",l[l.PartialMetadata=8]="PartialMetadata",l[l.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));function o(l){const w=d.parse(l);return w?w.notebook.toString():l.toString()}e.getCellUndoRedoComparisonKey=o;var d;(function(l){l.scheme=R.Schemas.vscodeNotebookCell;const w=/^ch(\d{7,})/;function T(U,B){return U.with({scheme:l.scheme,fragment:`ch${B.toString().padStart(7,"0")}${U.scheme!==R.Schemas.file?U.scheme:""}`})}l.generate=T;function N(U){if(U.scheme===l.scheme){const B=w.exec(U.fragment);if(!!B)return{handle:Number(B[1]),notebook:U.with({scheme:U.fragment.substr(B[0].length)||R.Schemas.file,fragment:null})}}}l.parse=N;function z(U){if(U.scheme===R.Schemas.vscodeNotebookCellMetadata){const B=w.exec(U.fragment);if(!!B)return{handle:Number(B[1]),notebook:U.with({scheme:U.fragment.substr(B[0].length)||R.Schemas.file,fragment:null})}}}l.parseCellMetadataUri=z;function ne(U,B,x){return U.with({scheme:x,fragment:`ch${B.toString().padStart(7,"0")}${U.scheme!==R.Schemas.file?U.scheme:""}`})}l.generateCellUri=ne;function ie(U,B){if(U.scheme===B){const x=w.exec(U.fragment);if(!!x)return{handle:Number(x[1]),notebook:U.with({scheme:U.fragment.substr(x[0].length)||R.Schemas.file,fragment:null})}}}l.parseCellUri=ie})(d=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function v(l){var w,T;return(T=(w=E.get(l))===null||w===void 0?void 0:w.alwaysSecure)!==null&&T!==void 0?T:!1}e.mimeTypeIsAlwaysSecure=v;function S(l){var w,T;return(T=(w=E.get(l))===null||w===void 0?void 0:w.supportedByCore)!==null&&T!==void 0?T:!1}e.mimeTypeSupportedByCore=S;function u(l){var w,T;return(T=(w=E.get(l))===null||w===void 0?void 0:w.mergeable)!==null&&T!==void 0?T:!1}e.mimeTypeIsMergeable=u;function c(l,w){return A.isWindows&&(l=l.replace(/\//g,"\\"),w=w.replace(/\//g,"\\")),b.match(l,w)}function h(l,w,T){let N=0;for(let z=0;z<w.length;z++){if(c(w[z],l))return N;N++}for(let z=0;z<T.length;z++){if(c(T[z],l))return N;N++}return N}function t(l,w,T){return l.sort((N,z)=>h(N,w,T)-h(z,w,T))}e.sortMimeTypes=t;function n(l,w,T,N=(z,ne)=>z===ne){const z=[];function ne(B,x,L){if(!(x===0&&L.length===0)){const O=z[z.length-1];O&&O.start+O.deleteCount===B?(O.deleteCount+=x,O.toInsert.push(...L)):z.push({start:B,deleteCount:x,toInsert:L})}}let ie=0,U=0;for(;;){if(ie===l.length){ne(ie,0,w.slice(U));break}if(U===w.length){ne(ie,l.length-ie,[]);break}const B=l[ie],x=w[U];if(N(B,x)){ie+=1,U+=1;continue}T(x)?(ne(ie,1,[]),ie+=1):(ne(ie,0,[x]),U+=1)}return z}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(l){l.default="default",l.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(l){const w=l;return!!((typeof w.include=="string"||b.isRelativePattern(w.include))&&(typeof w.exclude=="string"||b.isRelativePattern(w.exclude)))}e.isDocumentExcludePattern=i;function a(l,w,T){if(Array.isArray(l.viewType)&&l.viewType.indexOf(w)>=0||l.viewType===w)return!0;if(l.filenamePattern){let N=i(l.filenamePattern)?l.filenamePattern.include:l.filenamePattern,z=i(l.filenamePattern)?l.filenamePattern.exclude:void 0;if(b.match(N,(0,I.basename)(T.fsPath).toLowerCase()))return!(z&&b.match(z,(0,I.basename)(T.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class p{constructor(w){this.textModel=w}getElements(){const w=new Int32Array(this.textModel.cells.length);for(let T=0;T<this.textModel.cells.length;T++)w[T]=this.textModel.cells[T].getHashValue();return w}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var g;(function(l){l[l.Left=1]="Left",l[l.Right=2]="Right"})(g=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class _{static create(w){return`${_._prefix}/${w}`}static parse(w){if(w.startsWith(_._prefix))return w.substr(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/"}),define(me[205],ge([0,1,172,4,81]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[206],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=b;function R(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=R}),define(me[123],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(D,k)=>{k.expand!==void 0&&(D.expand=k.expand),k.item!==void 0&&(D.item=D.item?Object.assign(D.item,k.item):k.item)};e.applyTestItemUpdate=R;var I;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(I=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(D,k)=>`${D}:${k.toString()}`;e.getTestSubscriptionKey=A;class y{add(k){}update(k){}remove(k,r){}complete(){}}e.IncrementalChangeCollector=y;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const r=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const f=P[1];if(f.parent){if(this.items.has(f.parent)){const m=this.items.get(f.parent);m.children.add(f.item.extId);const o=this.createItem(f,m);this.items.set(f.item.extId,o),r.add(o)}}else{this.roots.add(f.item.extId);const m=this.createItem(f);this.items.set(f.item.extId,m),r.add(m)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=P[1],m=this.items.get(f.extId);if(!m)break;f.expand!==void 0&&(m.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(m,f),r.update(m);break}case 2:{const f=this.items.get(P[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f.item.extId);const m=[[P[1]]];for(;m.length;)for(const o of m.pop()){const d=this.items.get(o);d&&(m.push(d.children),this.items.delete(o),r.remove(d,d!==f),d.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}r.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=C}),define(me[207],ge([0,1,9,36,11,24,10,77,173]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,f,m){this._contributedVariables=new Map,this._context=P,this._labelService=f,m&&(this._envVariablesPromise=m.then(o=>this.prepareEnv(o)))}prepareEnv(P){if(y.isWindows){const f=Object.create(null);return Object.keys(P).forEach(m=>{f[m.toLowerCase()]=P[m]}),f}return P}resolveWithEnvironment(P,f,m){return this.recursiveResolve(this.prepareEnv(P),f?f.uri:void 0,m)}async resolveAsync(P,f){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,f)}async resolveAnyBase(P,f,m,o){const d=A.deepClone(f);return y.isWindows&&d.windows?Object.keys(d.windows).forEach(E=>d[E]=d.windows[E]):y.isMacintosh&&d.osx?Object.keys(d.osx).forEach(E=>d[E]=d.osx[E]):y.isLinux&&d.linux&&Object.keys(d.linux).forEach(E=>d[E]=d.linux[E]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,d,m,o)}async resolveAnyAsync(P,f,m){return this.resolveAnyBase(P,f,m)}async resolveAnyMap(P,f,m){const o=new Map;return{newConfig:await this.resolveAnyBase(P,f,m,o),resolvedVariables:o}}resolveWithInteractionReplace(P,f,m,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,f,m,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,f){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,f)}recursiveResolve(P,f,m,o,d){if(I.isString(m))return this.resolveString(P,f,m,o,d);if(I.isArray(m))return m.map(E=>this.recursiveResolve(P,f,E,o,d));if(I.isObject(m)){let E=Object.create(null);return Object.keys(m).forEach(v=>{const S=this.resolveString(P,f,v,o,d);E[S]=this.recursiveResolve(P,f,m[v],o,d)}),E}return m}resolveString(P,f,m,o,d){return m.replace(k.VARIABLE_REGEXP,(v,S)=>{if(S.includes(k.VARIABLE_LHS))return v;let u=this.evaluateSingleVariable(P,v,S,f,o);return d&&d.set(S,u),u})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,f,m,o,d){let E;const v=m.split(":");v.length>1&&(m=v[0],E=v[1]);const S=()=>{const h=this._context.getFilePath();if(h)return h;throw new Error((0,D.localize)(0,null,f))},u=()=>{const h=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,f,b.basename(h)))},c=()=>{if(E){const h=this._context.getFolderUri(E);if(h)return h;throw new Error((0,D.localize)(2,null,f,E))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,f)):new Error((0,D.localize)(4,null,f))};switch(m){case"env":if(E){if(P){const h=P[y.isWindows?E.toLowerCase():E];if(I.isString(h))return h}return""}throw new Error((0,D.localize)(5,null,f));case"config":if(E){const h=this._context.getConfigurationValue(o,E);if(I.isUndefinedOrNull(h))throw new Error((0,D.localize)(6,null,f,E));if(I.isObject(h))throw new Error((0,D.localize)(7,null,f,E));return h}throw new Error((0,D.localize)(8,null,f));case"command":return this.resolveFromMap(f,E,d,"command");case"input":return this.resolveFromMap(f,E,d,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return o||E?(0,C.normalizeDriveLetter)(this.fsPath(c())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(c()));case"lineNumber":const h=this._context.getLineNumber();if(h)return h;throw new Error((0,D.localize)(9,null,f));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,f));case"file":return S();case"fileWorkspaceFolder":return u();case"relativeFile":return o||E?b.relative(this.fsPath(c()),S()):S();case"relativeFileDirname":const n=b.dirname(S());if(o||E){const p=b.relative(this.fsPath(c()),n);return p.length===0?".":p}return n;case"fileDirname":return b.dirname(S());case"fileExtname":return b.extname(S());case"fileBasename":return b.basename(S());case"fileBasenameNoExtension":const s=b.basename(S());return s.slice(0,s.length-b.extname(s).length);case"fileDirnameBasename":return b.basename(b.dirname(S()));case"execPath":const i=this._context.getExecPath();return i||f;case"execInstallFolder":const a=this._context.getAppRoot();return a||f;case"pathSeparator":return b.sep;default:try{const p=E?`${m}:${E}`:m;return this.resolveFromMap(f,p,d,void 0)}catch(p){return f}}}}resolveFromMap(P,f,m,o){if(f&&m){const d=o===void 0?m[f]:m[o+":"+f];if(typeof d=="string")return d;throw new Error((0,D.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[208],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var R;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var I;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(f){f[f.GROUP_ACTIVE=0]="GROUP_ACTIVE",f[f.GROUP_INDEX=1]="GROUP_INDEX",f[f.EDITOR_OPEN=2]="EDITOR_OPEN",f[f.EDITOR_CLOSE=3]="EDITOR_CLOSE",f[f.EDITOR_MOVE=4]="EDITOR_MOVE",f[f.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",f[f.EDITOR_LABEL=6]="EDITOR_LABEL",f[f.EDITOR_PIN=7]="EDITOR_PIN",f[f.EDITOR_STICKY=8]="EDITOR_STICKY",f[f.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function P(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(me[209],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,16,97,280,59,24,11,2,43,80,174,114,64,209,7]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(be){function he(Y){const{selectionStartLineNumber:Ne,selectionStartColumn:Le,positionLineNumber:Ye,positionColumn:et}=Y,ct=new d.Position(Ne-1,Le-1),ut=new d.Position(Ye-1,et-1);return new d.Selection(ct,ut)}be.to=he;function ae(Y){const{anchor:Ne,active:Le}=Y;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}be.from=ae})(E=e.Selection||(e.Selection={}));var v;(function(be){function he(Y){if(!!Y){const{start:Ne,end:Le}=Y;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}}be.from=he;function ae(Y){if(!!Y){const{startLineNumber:Ne,startColumn:Le,endLineNumber:Ye,endColumn:et}=Y;return new d.Range(Ne-1,Le-1,Ye-1,et-1)}}be.to=ae})(v=e.Range||(e.Range={}));var S;(function(be){function he(ae){switch(ae){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}be.to=he})(S=e.TokenType||(e.TokenType={}));var u;(function(be){function he(Y){return new d.Position(Y.lineNumber-1,Y.column-1)}be.to=he;function ae(Y){return{lineNumber:Y.line+1,column:Y.character+1}}be.from=ae})(u=e.Position||(e.Position={}));var c;(function(be){function he(Y){switch(Y){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}be.from=he;function ae(Y){switch(Y){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}be.to=ae})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(be){function he(Y){let Ne;return Y.code&&((0,C.isString)(Y.code)||(0,C.isNumber)(Y.code)?Ne=String(Y.code):Ne={value:String(Y.code.value),target:Y.code.target}),Object.assign(Object.assign({},v.from(Y.range)),{message:Y.message,source:Y.source,code:Ne,severity:n.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(t.from),tags:Array.isArray(Y.tags)?(0,b.coalesce)(Y.tags.map(c.from)):void 0})}be.from=he;function ae(Y){var Ne;const Le=new d.Diagnostic(v.to(Y),Y.message,n.to(Y.severity));return Le.source=Y.source,Le.code=(0,C.isString)(Y.code)?Y.code:(Ne=Y.code)===null||Ne===void 0?void 0:Ne.value,Le.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(t.to),Le.tags=Y.tags&&(0,b.coalesce)(Y.tags.map(c.to)),Le}be.to=ae})(h=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function he(Y){return Object.assign(Object.assign({},v.from(Y.location.range)),{message:Y.message,resource:Y.location.uri})}be.from=he;function ae(Y){return new d.DiagnosticRelatedInformation(new d.Location(Y.resource,v.to(Y)),Y.message)}be.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(be){function he(Y){switch(Y){case d.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}be.from=he;function ae(Y){switch(Y){case f.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}be.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(be){function he(Y){return typeof Y=="number"&&Y>=d.ViewColumn.One?Y-1:Y===d.ViewColumn.Beside?o.SIDE_GROUP:o.ACTIVE_GROUP}be.from=he;function ae(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function i(be){return typeof be.range!="undefined"}function a(be){return be.length===0?!0:!!i(be[0])}e.isDecorationOptionsArr=a;var p;(function(be){function he(et){return et.map(be.from)}be.fromMany=he;function ae(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function Y(et){let ct;if(ae(et)){const{language:ht,value:ft}=et;ct={value:"```"+ht+`
`+ft+"\n```\n"}}else d.MarkdownString.isMarkdownString(et)?ct={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ct={value:et}:ct={value:""};const ut=Object.create(null);ct.uris=ut;const Ze=ht=>{try{let ft=D.URI.parse(ht,!0);ft=ft.with({query:Ne(ft.query,ut)}),ut[ht]=ft}catch(ft){}return""},mt=new I.Renderer;return mt.link=Ze,mt.image=ht=>Ze(R.parseHrefAndDimensions(ht).href),I(ct.value,{renderer:mt}),ct}be.from=Y;function Ne(et,ct){if(!et)return et;let ut;try{ut=(0,A.parse)(et)}catch(mt){}if(!ut)return et;let Ze=!1;return ut=(0,y.cloneAndChange)(ut,mt=>{if(D.URI.isUri(mt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ht]=mt,Ze=!0,ht}else return}),Ze?JSON.stringify(ut):et}function Le(et){const ct=new d.MarkdownString(et.value,et.supportThemeIcons);return ct.isTrusted=et.isTrusted,ct}be.to=Le;function Ye(et){if(!!et)return typeof et=="string"?et:be.from(et)}be.fromStrict=Ye})(p=e.MarkdownString||(e.MarkdownString={}));function g(be){return a(be)?be.map(he=>({range:v.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?p.fromMany(he.hoverMessage):he.hoverMessage?p.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):be.map(he=>({range:v.from(he)}))}e.fromRangeOrRangeWithMessage=g;function _(be){return typeof be=="undefined"?be:typeof be=="string"?D.URI.file(be):be}e.pathOrURIToURI=_;var l;(function(be){function he(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?_(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=he})(l=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(be){function he(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?_(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?l.from(ae.before):void 0,after:ae.after?l.from(ae.after):void 0}}be.from=he})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var T;(function(be){function he(ae){if(typeof ae=="undefined")return ae;switch(ae){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=he})(T=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(be){function he(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?T.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?w.from(ae.light):void 0,dark:ae.dark?w.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?_(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?l.from(ae.before):void 0,after:ae.after?l.from(ae.after):void 0}}be.from=he})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(be){function he(Y){return{text:Y.newText,eol:Y.newEol&&te.from(Y.newEol),range:v.from(Y.range)}}be.from=he;function ae(Y){const Ne=new d.TextEdit(v.to(Y.range),Y.text);return Ne.newEol=typeof Y.eol=="undefined"?void 0:te.to(Y.eol),Ne}be.to=ae})(z=e.TextEdit||(e.TextEdit={}));var ne;(function(be){function he(Y,Ne,Le){var Ye,et,ct;const ut={edits:[]};if(Y instanceof d.WorkspaceEdit)for(let Ze of Y._allEntries())if(Ze._type===1)ut.edits.push({_type:1,oldUri:Ze.from,newUri:Ze.to,options:Ze.options,metadata:Ze.metadata});else if(Ze._type===2){const mt=Ne==null?void 0:Ne.getDocument(Ze.uri);ut.edits.push({_type:2,resource:Ze.uri,edit:z.from(Ze.edit),modelVersionId:mt==null?void 0:mt.version,metadata:Ze.metadata})}else Ze._type===3?ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:Ze.edit,notebookMetadata:Ze.notebookMetadata,notebookVersionId:(Ye=Le==null?void 0:Le.getNotebookDocument(Ze.uri,!0))===null||Ye===void 0?void 0:Ye.apiNotebook.version}):Ze._type===4?(Ze.newOutputs&&ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:2,index:Ze.index,append:Ze.append,outputs:Ze.newOutputs.map(Pe.from)}}),Ze.newMetadata&&ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:8,index:Ze.index,metadata:Ze.newMetadata}})):Ze._type===5?ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,notebookVersionId:(et=Le==null?void 0:Le.getNotebookDocument(Ze.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:Ze.index,count:Ze.count,cells:Ze.cells.map(J.from)}}):Ze._type===6&&ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:7,outputId:Ze.outputId,items:((ct=Ze.newOutputItems)===null||ct===void 0?void 0:ct.map(ce.from))||[],append:Ze.append}});return ut}be.from=he;function ae(Y){const Ne=new d.WorkspaceEdit;for(const Le of Y.edits)Le.edit?Ne.replace(D.URI.revive(Le.resource),v.to(Le.edit.range),Le.edit.text):Ne.renameFile(D.URI.revive(Le.oldUri),D.URI.revive(Le.newUri),Le.options);return Ne}be.to=ae})(ne=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ie;(function(be){const he=Object.create(null);he[d.SymbolKind.File]=0,he[d.SymbolKind.Module]=1,he[d.SymbolKind.Namespace]=2,he[d.SymbolKind.Package]=3,he[d.SymbolKind.Class]=4,he[d.SymbolKind.Method]=5,he[d.SymbolKind.Property]=6,he[d.SymbolKind.Field]=7,he[d.SymbolKind.Constructor]=8,he[d.SymbolKind.Enum]=9,he[d.SymbolKind.Interface]=10,he[d.SymbolKind.Function]=11,he[d.SymbolKind.Variable]=12,he[d.SymbolKind.Constant]=13,he[d.SymbolKind.String]=14,he[d.SymbolKind.Number]=15,he[d.SymbolKind.Boolean]=16,he[d.SymbolKind.Array]=17,he[d.SymbolKind.Object]=18,he[d.SymbolKind.Key]=19,he[d.SymbolKind.Null]=20,he[d.SymbolKind.EnumMember]=21,he[d.SymbolKind.Struct]=22,he[d.SymbolKind.Event]=23,he[d.SymbolKind.Operator]=24,he[d.SymbolKind.TypeParameter]=25;function ae(Ne){return typeof he[Ne]=="number"?he[Ne]:6}be.from=ae;function Y(Ne){for(const Le in he)if(he[Le]===Ne)return Number(Le);return d.SymbolKind.Property}be.to=Y})(ie=e.SymbolKind||(e.SymbolKind={}));var U;(function(be){function he(Y){switch(Y){case d.SymbolTag.Deprecated:return 1}}be.from=he;function ae(Y){switch(Y){case 1:return d.SymbolTag.Deprecated}}be.to=ae})(U=e.SymbolTag||(e.SymbolTag={}));var B;(function(be){function he(Y){return{name:Y.name,kind:ie.from(Y.kind),tags:Y.tags&&Y.tags.map(U.from),containerName:Y.containerName,location:M.from(Y.location)}}be.from=he;function ae(Y){const Ne=new d.SymbolInformation(Y.name,ie.to(Y.kind),Y.containerName,M.to(Y.location));return Ne.tags=Y.tags&&Y.tags.map(U.to),Ne}be.to=ae})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var x;(function(be){function he(Y){var Ne,Le;const Ye={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:v.from(Y.range),selectionRange:v.from(Y.selectionRange),kind:ie.from(Y.kind),tags:(Le=(Ne=Y.tags)===null||Ne===void 0?void 0:Ne.map(U.from))!==null&&Le!==void 0?Le:[]};return Y.children&&(Ye.children=Y.children.map(he)),Ye}be.from=he;function ae(Y){const Ne=new d.DocumentSymbol(Y.name,Y.detail,ie.to(Y.kind),v.to(Y.range),v.to(Y.selectionRange));return(0,b.isNonEmptyArray)(Y.tags)&&(Ne.tags=Y.tags.map(U.to)),Y.children&&(Ne.children=Y.children.map(ae)),Ne}be.to=ae})(x=e.DocumentSymbol||(e.DocumentSymbol={}));var L;(function(be){function he(ae){const Y=new d.CallHierarchyItem(ie.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),v.to(ae.range),v.to(ae.selectionRange));return Y._sessionId=ae._sessionId,Y._itemId=ae._itemId,Y}be.to=he})(L=e.CallHierarchyItem||(e.CallHierarchyItem={}));var O;(function(be){function he(ae){return new d.CallHierarchyIncomingCall(L.to(ae.from),ae.fromRanges.map(Y=>v.to(Y)))}be.to=he})(O=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(be){function he(ae){return new d.CallHierarchyOutgoingCall(L.to(ae.to),ae.fromRanges.map(Y=>v.to(Y)))}be.to=he})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(be){function he(Y){return{range:Y.range&&v.from(Y.range),uri:Y.uri}}be.from=he;function ae(Y){return new d.Location(D.URI.revive(Y.uri),v.to(Y.range))}be.to=ae})(M=e.location||(e.location={}));var W;(function(be){function he(Y){const Ne=Y,Le=Y;return{originSelectionRange:Ne.originSelectionRange?v.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Le.uri,range:v.from(Ne.targetRange?Ne.targetRange:Le.range),targetSelectionRange:Ne.targetSelectionRange?v.from(Ne.targetSelectionRange):void 0}}be.from=he;function ae(Y){return{targetUri:D.URI.revive(Y.uri),targetRange:v.to(Y.range),targetSelectionRange:Y.targetSelectionRange?v.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?v.to(Y.originSelectionRange):void 0}}be.to=ae})(W=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(be){function he(Y){return{range:v.from(Y.range),contents:p.fromMany(Y.contents)}}be.from=he;function ae(Y){return new d.Hover(Y.contents.map(p.to),v.to(Y.range))}be.to=ae})(q=e.Hover||(e.Hover={}));var K;(function(be){function he(Y){return{range:v.from(Y.range),expression:Y.expression}}be.from=he;function ae(Y){return new d.EvaluatableExpression(v.to(Y.range),Y.expression)}be.to=ae})(K=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(be){function he(Y){if(Y instanceof d.InlineValueText)return{type:"text",range:v.from(Y.range),text:Y.text};if(Y instanceof d.InlineValueVariableLookup)return{type:"variable",range:v.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}be.from=he;function ae(Y){switch(Y.type){case"text":return{range:v.to(Y.range),text:Y.text};case"variable":return{range:v.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:v.to(Y.range),expression:Y.expression}}}be.to=ae})(le=e.InlineValue||(e.InlineValue={}));var ve;(function(be){function he(Y){return{frameId:Y.frameId,stoppedLocation:v.from(Y.stoppedLocation)}}be.from=he;function ae(Y){return new d.InlineValueContext(Y.frameId,v.to(Y.stoppedLocation))}be.to=ae})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Re;(function(be){function he(Y){return{range:v.from(Y.range),kind:Y.kind}}be.from=he;function ae(Y){return new d.DocumentHighlight(v.to(Y.range),Y.kind)}be.to=ae})(Re=e.DocumentHighlight||(e.DocumentHighlight={}));var Se;(function(be){function he(ae){switch(ae){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}be.to=he})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(be){function he(ae){return{triggerKind:Se.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=he})(Oe=e.CompletionContext||(e.CompletionContext={}));var V;(function(be){function he(Y){switch(Y){case d.CompletionItemTag.Deprecated:return 1}}be.from=he;function ae(Y){switch(Y){case 1:return d.CompletionItemTag.Deprecated}}be.to=ae})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(be){const he=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ae(Le){var Ye;return(Ye=he.get(Le))!==null&&Ye!==void 0?Ye:9}be.from=ae;const Y=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Ne(Le){var Ye;return(Ye=Y.get(Le))!==null&&Ye!==void 0?Ye:d.CompletionItemKind.Property}be.to=Ne})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(be){function he(ae,Y){var Ne;const Le=new d.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Le.label2=ae.label),Le.insertText=ae.insertText,Le.kind=X.to(ae.kind),Le.tags=(Ne=ae.tags)===null||Ne===void 0?void 0:Ne.map(V.to),Le.detail=ae.detail,Le.documentation=R.isMarkdownString(ae.documentation)?p.to(ae.documentation):ae.documentation,Le.sortText=ae.sortText,Le.filterText=ae.filterText,Le.preselect=ae.preselect,Le.commitCharacters=ae.commitCharacters,k.Range.isIRange(ae.range)?Le.range=v.to(ae.range):typeof ae.range=="object"&&(Le.range={inserting:v.to(ae.range.insert),replacing:v.to(ae.range.replace)}),Le.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Le.insertText=new d.SnippetString(ae.insertText):(Le.insertText=ae.insertText,Le.textEdit=Le.range instanceof d.Range?new d.TextEdit(Le.range,Le.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Le.additionalTextEdits=ae.additionalTextEdits.map(Ye=>z.to(Ye))),Le.command=Y&&ae.command?Y.fromInternal(ae.command):void 0,Le}be.to=he})(Z=e.CompletionItem||(e.CompletionItem={}));var se;(function(be){function he(Y){return{label:Y.label,documentation:Y.documentation?p.fromStrict(Y.documentation):void 0}}be.from=he;function ae(Y){return{label:Y.label,documentation:R.isMarkdownString(Y.documentation)?p.to(Y.documentation):Y.documentation}}be.to=ae})(se=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(be){function he(Y){return{label:Y.label,documentation:Y.documentation?p.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(se.from):[],activeParameter:Y.activeParameter}}be.from=he;function ae(Y){return{label:Y.label,documentation:R.isMarkdownString(Y.documentation)?p.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(se.to):[],activeParameter:Y.activeParameter}}be.to=ae})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(be){function he(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(fe.from):[]}}be.from=he;function ae(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(fe.to):[]}}be.to=ae})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Be;(function(be){function he(Y){var Ne;return{text:Y.text,position:u.from(Y.position),kind:pe.from((Ne=Y.kind)!==null&&Ne!==void 0?Ne:d.InlayHintKind.Other),whitespaceBefore:Y.whitespaceBefore,whitespaceAfter:Y.whitespaceAfter}}be.from=he;function ae(Y){const Ne=new d.InlayHint(Y.text,u.to(Y.position),pe.to(Y.kind));return Ne.whitespaceAfter=Y.whitespaceAfter,Ne.whitespaceBefore=Y.whitespaceBefore,Ne}be.to=ae})(Be=e.InlayHint||(e.InlayHint={}));var pe;(function(be){function he(Y){return Y}be.from=he;function ae(Y){return Y}be.to=ae})(pe=e.InlayHintKind||(e.InlayHintKind={}));var Ce;(function(be){function he(Y){return{range:v.from(Y.range),url:Y.target,tooltip:Y.tooltip}}be.from=he;function ae(Y){let Ne;if(Y.url)try{Ne=typeof Y.url=="string"?D.URI.parse(Y.url,!0):D.URI.revive(Y.url)}catch(Le){}return new d.DocumentLink(v.to(Y.range),Ne)}be.to=ae})(Ce=e.DocumentLink||(e.DocumentLink={}));var Me;(function(be){function he(Y){const Ne=new d.ColorPresentation(Y.label);return Y.textEdit&&(Ne.textEdit=z.to(Y.textEdit)),Y.additionalTextEdits&&(Ne.additionalTextEdits=Y.additionalTextEdits.map(Le=>z.to(Le))),Ne}be.to=he;function ae(Y){return{label:Y.label,textEdit:Y.textEdit?z.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Ne=>z.from(Ne)):void 0}}be.from=ae})(Me=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(be){function he(Y){return new d.Color(Y[0],Y[1],Y[2],Y[3])}be.to=he;function ae(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}be.from=ae})(ze=e.Color||(e.Color={}));var _e;(function(be){function he(Y){return{range:v.from(Y.range)}}be.from=he;function ae(Y){return new d.SelectionRange(v.to(Y.range))}be.to=ae})(_e=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(be){function he(ae){switch(ae){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}be.to=he})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var G;(function(be){function he(Y){switch(Y){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}be.from=he;function ae(Y){switch(Y){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}be.to=ae})(G=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(be){function he(Y){if(Y===d.EndOfLine.CRLF)return 1;if(Y===d.EndOfLine.LF)return 0}be.from=he;function ae(Y){if(Y===1)return d.EndOfLine.CRLF;if(Y===0)return d.EndOfLine.LF}be.to=ae})(te=e.EndOfLine||(e.EndOfLine={}));var we;(function(be){function he(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=he})(we=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(be){function he(ae){const Y={start:ae.start+1,end:ae.end+1};return ae.kind&&(Y.kind=je.from(ae.kind)),Y}be.from=he})(xe=e.FoldingRange||(e.FoldingRange={}));var je;(function(be){function he(ae){if(ae)switch(ae){case d.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}be.from=he})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ve;(function(be){function he(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?v.from(ae.selection):void 0,override:typeof ae.override=="boolean"?P.EditorOverride.DISABLED:void 0}}be.from=he})(Ve=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Je;(function(be){function he(Y){return Y instanceof d.RelativePattern||typeof Y=="string"?Y:ae(Y)?new d.RelativePattern(Y.base,Y.pattern):Y}be.from=he;function ae(Y){const Ne=Y;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(Je=e.GlobPattern||(e.GlobPattern={}));var De;(function(be){function he(ae){if(ae){if(Array.isArray(ae))return ae.map(he);if(typeof ae=="string")return ae;{const Y=ae;return{language:Y.language,scheme:Y.scheme,pattern:typeof Y.pattern=="undefined"?void 0:Je.from(Y.pattern),exclusive:Y.exclusive}}}else return}be.from=he})(De=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(be){function he(Y){return{start:Y.start,end:Y.end}}be.from=he;function ae(Y){return new d.NotebookRange(Y.start,Y.end)}be.to=ae})(ye=e.NotebookRange||(e.NotebookRange={}));var Ie;(function(be){function he(ae){return new d.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}be.to=he})(Ie=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var oe;(function(be){function he(Y){return Y}be.from=he;function ae(Y){return new d.NotebookDocumentMetadata().with(Y)}be.to=ae})(oe=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ue;(function(be){function he(Y){return{startTime:Y.runStartTime,endTime:Y.runEndTime,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}be.to=he;function ae(Y){return{lastRunSuccess:Y.success,runStartTime:Y.startTime,runEndTime:Y.endTime,executionOrder:Y.executionOrder}}be.from=ae})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var H;(function(be){function he(Y){switch(Y){case d.NotebookCellKind.Markup:return m.CellKind.Markup;case d.NotebookCellKind.Code:default:return m.CellKind.Code}}be.from=he;function ae(Y){switch(Y){case m.CellKind.Markup:return d.NotebookCellKind.Markup;case m.CellKind.Code:default:return d.NotebookCellKind.Code}}be.to=ae})(H=e.NotebookCellKind||(e.NotebookCellKind={}));var J;(function(be){function he(Y){var Ne;return{cellKind:H.from(Y.kind),language:Y.languageId,source:Y.value,metadata:Y.metadata,internalMetadata:ue.from((Ne=Y.executionSummary)!==null&&Ne!==void 0?Ne:{}),outputs:Y.outputs?Y.outputs.map(Pe.from):[]}}be.from=he;function ae(Y){return new d.NotebookCellData(H.to(Y.cellKind),Y.source,Y.language,Y.outputs?Y.outputs.map(Pe.to):void 0,Y.metadata?Ie.to(Y.metadata):void 0)}be.to=ae})(J=e.NotebookCellData||(e.NotebookCellData={}));var ce;(function(be){function he(Y){return{mime:Y.mime,value:Y.value,metadata:Y.metadata}}be.from=he;function ae(Y){return new d.NotebookCellOutputItem(Y.mime,Y.value,Y.metadata)}be.to=ae})(ce=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(be){function he(Y){return{outputId:Y.id,outputs:Y.outputs.map(ce.from),metadata:Y.metadata}}be.from=he;function ae(Y){const Ne=Y.outputs.map(ce.to);return new d.NotebookCellOutput(Ne,Y.outputId,Y.metadata)}be.to=ae})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ae;(function(be){function he(Le){if(Le!=null){if(Le instanceof d.RelativePattern||typeof Le=="string")return Le;if(Ne(Le))return new d.RelativePattern(Le.base,Le.pattern);if(Y(Le))return{include:Je.from(Le.include)||void 0,exclude:Je.from(Le.exclude)||void 0}}}be.from=he;function ae(Le){return typeof Le=="string"?Le:Ne(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}be.to=ae;function Y(Le){const Ye=Le,et=Je.from(Ye.include);if(!(et&&et instanceof d.RelativePattern||typeof et=="string"))return!1;const ct=Je.from(Ye.exclude);return!!(ct&&ct instanceof d.RelativePattern||typeof ct=="string")}function Ne(Le){const Ye=Le;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Ae=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Fe;(function(be){function he(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?l.from(ae.top):void 0}}be.from=he})(Fe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var We;(function(be){function he(ae,Y,Ne){const Le=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Le,Ne),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=he})(We=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Xe;(function(be){function he(ae){var Y,Ne,Le;return{transientOutputs:(Y=ae==null?void 0:ae.transientOutputs)!==null&&Y!==void 0?Y:!1,transientCellMetadata:(Ne=ae==null?void 0:ae.transientCellMetadata)!==null&&Ne!==void 0?Ne:{},transientDocumentMetadata:(Le=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Le!==void 0?Le:{}}}be.from=he})(Xe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(be){function he(Y){var Ne;return{uri:Y.uri,provides:typeof Y.provides=="string"?[Y.provides]:(Ne=Y.provides)!==null&&Ne!==void 0?Ne:[]}}be.from=he;function ae(Y){return new d.NotebookKernelPreload(D.URI.revive(Y.uri),Y.provides)}be.to=ae})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var tt;(function(be){function he(Y){return{message:p.fromStrict(Y.message)||"",severity:Y.severity,expectedOutput:Y.expectedOutput,actualOutput:Y.actualOutput,location:Y.location?M.from(Y.location):void 0}}be.from=he;function ae(Y){const Ne=new d.TestMessage(typeof Y.message=="string"?Y.message:p.to(Y.message));return Ne.severity=Y.severity,Ne.actualOutput=Y.actualOutput,Ne.expectedOutput=Y.expectedOutput,Ne}be.to=ae})(tt=e.TestMessage||(e.TestMessage={}));var Qe;(function(be){function he(Le){var Ye,et;return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range)||null,debuggable:(Ye=Le.debuggable)!==null&&Ye!==void 0?Ye:!1,description:Le.description||null,runnable:(et=Le.runnable)!==null&&et!==void 0?et:!0,error:Le.error&&p.fromStrict(Le.error)||null}}be.from=he;function ae(Le){return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range)||null,debuggable:!1,description:Le.description||null,error:null,runnable:!0}}be.fromResultSnapshot=ae;function Y(Le){return{id:Le.extId,label:Le.label,uri:D.URI.revive(Le.uri),range:v.to(Le.range||void 0),addChild:()=>{},dispose:()=>{},status:d.TestItemStatus.Pending,data:void 0,debuggable:Le.debuggable,description:Le.description||void 0,runnable:Le.runnable}}be.toPlain=Y;function Ne(Le){const Ye=new d.TestItemImpl(Le.extId,Le.label,D.URI.revive(Le.uri),void 0);return Ye.range=v.to(Le.range||void 0),Ye.debuggable=Le.debuggable,Ye.description=Le.description||void 0,Ye.runnable=Le.runnable,Ye}be.to=Ne})(Qe=e.TestItem||(e.TestItem={}));var gt;(function(be){const he=(Y,Ne)=>Object.assign(Object.assign({},Qe.toPlain(Y.item)),{taskStates:Y.tasks.map(Le=>({state:Le.state,duration:Le.duration,messages:Le.messages.map(tt.to)})),children:Y.children.map(Le=>Ne.get(Le)).filter(C.isDefined).map(Le=>he(Le,Ne))});function ae(Y){const Ne=[],Le=new Map;for(const Ye of Y.items)Le.set(Ye.item.extId,Ye),Ye.direct&&Ne.push(Ye);return{completedAt:Y.completedAt,results:Ne.map(Ye=>he(Ye,Le))}}be.to=ae})(gt=e.TestResults||(e.TestResults={}));var wt;(function(be){function he(ae){switch(ae){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}be.to=he})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[210],ge([0,1,2,17,7,20,57]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(k,r,P,f={timeout:1500,errors:3}){this._logService=k,this._documents=r,this._mainThreadBulkEdits=P,this._thresholds=f,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(r,P,f)=>{const o={dispose:this._callbacks.push([r,P,k])};return Array.isArray(f)&&f.push(o),o}}async $participateInSave(k,r){const P=b.URI.revive(k);let f=!1;const m=setTimeout(()=>f=!0,this._thresholds.timeout),o=[];try{for(let d of[...this._callbacks]){if(f)break;const E=this._documents.getDocument(P),v=await this._deliverEventAsyncAndBlameBadListeners(d,{document:E,reason:A.TextDocumentSaveReason.to(r)});o.push(v)}}finally{clearTimeout(m)}return o}_deliverEventAsyncAndBlameBadListeners([k,r,P],f){const m=this._badListeners.get(k);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,r,f).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const d=this._badListeners.get(k);this._badListeners.set(k,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,r,P,f){const m=[],o=Date.now(),{document:d,reason:E}=f,{version:v}=d,S=Object.freeze({document:d,reason:E,waitUntil(u){if(Object.isFrozen(m))throw(0,R.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(u))}});try{r.apply(P,[S])}catch(u){return Promise.reject(u)}return Object.freeze(m),new Promise((u,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(h),u(t)}).catch(t=>{clearTimeout(h),c(t)})}).then(u=>{const c={edits:[]};for(const h of u)if(Array.isArray(h)&&h.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:n,range:s}of h)c.edits.push({_type:2,resource:d.uri,edit:{range:s&&A.Range.from(s),text:t,eol:n&&A.EndOfLine.from(n)}});if(c.edits.length!==0)return v===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(me[211],ge([0,1,3,13,32,2,20,7]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(P,f,m,o,d){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,m&&(this._config+=1),o&&(this._config+=2),d&&(this._config+=4);const E=(0,I.parse)(f),v=P(S=>{if(!m)for(let u of S.created){const c=A.URI.revive(u);E(c.fsPath)&&this._onDidCreate.fire(c)}if(!o)for(let u of S.changed){const c=A.URI.revive(u);E(c.fsPath)&&this._onDidChange.fire(c)}if(!d)for(let u of S.deleted){const c=A.URI.revive(u);E(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,f,m){this._logService=f,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,f,m,o){return new D(this._onFileSystemEvent.event,P,f,m,o)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,f){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:f.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:f.map(m=>A.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:f.map(m=>A.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,f){return(m,o,d)=>{const E=function(S){m.call(o,S)};return E.extension=P,f.event(E,void 0,d)}}async $onWillRunFileOperation(P,f,m,o){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:f.map(d=>({oldUri:A.URI.revive(d.source),newUri:A.URI.revive(d.target)}))},m,o);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:f.map(d=>A.URI.revive(d.target))},m,o);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:f.map(d=>A.URI.revive(d.target))},m,o)}}async _fireWillEvent(P,f,m,o){const d=new Set,E=[];if(await P.fireAsync(f,o,async(S,u)=>{var c;const h=Date.now(),t=await Promise.resolve(S);t instanceof C.WorkspaceEdit&&(E.push(t),d.add((c=u.extension.displayName)!==null&&c!==void 0?c:u.extension.identifier.value)),Date.now()-h>m&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),!o.isCancellationRequested&&E.length!==0){const v={edits:[]};for(let S of E){let{edits:u}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(u)}return{edit:v,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=k}),define(me[212],ge([0,1,12,24,2,20,7,64]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(f,m,o,d){this.start=f,this.deletedCount=m,this.deletedItems=o,this.items=d}static asApiEvents(f){return f.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(o=>o.apiCell)}))}}class k{constructor(f,m,o){var d,E,v;this.notebook=f,this._extHostDocument=m,this._cellData=o,this.handle=o.handle,this.uri=I.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(d=o.internalMetadata)!==null&&d!==void 0?d:{},this._metadata=A.NotebookCellMetadata.to((E=o.metadata)!==null&&E!==void 0?E:{}),this._previousResult=A.NotebookCellExecutionSummary.to((v=o.internalMetadata)!==null&&v!==void 0?v:{})}static asModelAddData(f,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:f}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const f=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return f.notebook.getCellIndex(f)},notebook:f.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata},get executionSummary(){return f._previousResult}})}return this._apiCell}setOutputs(f){this._outputs=f.map(A.NotebookCellOutput.to)}setOutputItems(f,m,o){const d=o.map(A.NotebookCellOutputItem.to),E=this._outputs.find(v=>v.id===f);E&&(m||(E.outputs.length=0),E.outputs.push(...d))}setMetadata(f){this._metadata=A.NotebookCellMetadata.to(f)}setInternalMetadata(f){this._internalMetadata=f,this._previousResult=A.NotebookCellExecutionSummary.to(f)}}e.ExtHostCell=k;class r{constructor(f,m,o,d,E,v,S){this._proxy=f,this._textDocumentsAndEditors=m,this._textDocuments=o,this._emitter=d,this._viewType=E,this._metadata=v,this.uri=S,this.handle=r._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const f=this;this._notebook={get uri(){return f.uri},get version(){return f._versionId},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===b.Schemas.untitled},get isClosed(){return f._disposed},get metadata(){return f._metadata},get cellCount(){return f._cells.length},cellAt(m){return m=f._validateIndex(m),f._cells[m].apiCell},getCells(m){return(m?f._getCells(m):f._cells).map(d=>d.apiCell)},save(){return f._save()}}}return this._notebook}updateBackup(f){var m;(m=this._backup)===null||m===void 0||m.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,m){this._versionId=f.versionId,this._isDirty=m;for(const o of f.rawEvents)o.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(o.changes,!0),o.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===C.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(f){return f=f|0,f<0?0:f>=this._cells.length?this._cells.length-1:f}_validateRange(f){let m=f.start|0,o=f.end|0;return m<0&&(m=0),o>this._cells.length&&(o=this._cells.length),f.with({start:m,end:o})}_getCells(f){f=this._validateRange(f);const m=[];for(let o=f.start;o<f.end;o++)m.push(this._cells[o]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,m){if(!this._disposed){const o=[],d=[],E=[];f.reverse().forEach(v=>{const u=v[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return m||d.push(k.asModelAddData(this.apiNotebook,t)),n}),c=new D(v[0],v[1],[],u),h=this._cells.splice(v[0],v[1],...u);for(const t of h)E.push(t.uri),c.deletedItems.push(t.apiCell);o.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:E}),m||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(o)}))}}_moveCell(f,m){const o=this._cells.splice(f,1);this._cells.splice(m,0,...o);const d=[new D(f,1,o.map(E=>E.apiCell),[]),new D(m,0,[],o)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(d)}))}_setCellOutputs(f,m){const o=this._cells[f];o.setOutputs(m),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(f,m,o,d){const E=this._cells[f];E.setOutputItems(m,o,d),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(f,m){const o=this._cells[f];o.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(o.uri,m)}_changeCellMetadata(f,m){const o=this._cells[f],d=o.apiCell.metadata;o.setMetadata(m);const E=o.apiCell.metadata;(0,R.equals)(d,E)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(f,m){var o;const d=this._cells[f],E=d.internalMetadata;if(d.setInternalMetadata(m),E.runState!==m.runState){const v=(o=m.runState)!==null&&o!==void 0?o:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:d.apiCell,executionState:v}))}}getCellFromApiCell(f){return this._cells.find(m=>m.apiCell===f)}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(m=>m.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=r,r._handlePool=0}),define(me[213],ge([0,1,7,20]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class I{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:D})}replaceCells(C,D,k){this._throwIfFinalized(),!(C===D&&k.length===0)&&this._collectedEdits.push({editType:1,index:C,count:D-C,cells:k.map(R.NotebookCellData.from)})}}class A{constructor(C,D,k,r,P,f){this.id=C,this._proxy=D,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=r,this._viewColumn=f}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(D,k){C._proxy.$tryRevealRange(C.id,R.NotebookRange.from(D),k!=null?k:b.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(D){const k=new I(this.document.version);return D(k),C._applyEdit(k.finalize())},setDecorations(D,k){return C.setDecorations(D,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const D=[];let k=-1;for(let r=0;r<C.cellEdits.length;r++){if(k<0){D.push(C.cellEdits[r]),k++;continue}const f=D[k],m=C.cellEdits[r];if(f.editType===1&&m.editType===1&&f.index===m.index){f.cells.push(...C.cellEdits[r].cells),f.count+=C.cellEdits[r].count;continue}D.push(C.cellEdits[r]),k++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,D)}setDecorations(C,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return D.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(D),C.key)}}e.ExtHostNotebookEditor=A}),define(me[214],ge([0,1,20,115,162,21,54]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,f,m){const o=this._handles++,{title:d,location:E,cancellable:v}=f,S={label:(0,I.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(o,{location:b.ProgressLocation.from(E),title:d,source:S,cancellable:v},P),this._withProgress(o,m,!!v)}_withProgress(P,f,m){let o;m&&(o=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,o));const d=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),o&&o.dispose()};let E;try{E=f(new k(this._proxy,P),m&&o?o.token:A.CancellationToken.None)}catch(v){throw d(P),v}return E.then(v=>d(P),v=>d(P)),E}$acceptProgressCanceled(P){const f=this._mapHandleToCancellationSource.get(P);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=C;function D(r,P){return r.message=P.message,typeof P.increment=="number"&&(typeof r.increment=="number"?r.increment+=P.increment:r.increment=P.increment),r}class k extends R.Progress{constructor(P,f){super(m=>this.throttledReport(m));this._proxy=P,this._handle=f}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}qe([(0,y.throttle)(100,(r,P)=>D(r,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(me[124],ge([0,1,52,17,73,20,7]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(f,m){const o=C._Keys.nextId();f.$registerTextEditorDecorationType(o,A.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:o,dispose(){f.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=C,C._Keys=new I.IdGenerator("TextEditorDecorationType");class D{constructor(f,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,m){this._throwIfFinalized();let o=null;if(f instanceof y.Position)o=new y.Range(f,f);else if(f instanceof y.Range)o=f;else throw new Error("Unrecognized location");this._pushEdit(o,m,!1)}insert(f,m){this._throwIfFinalized(),this._pushEdit(new y.Range(f,f),m,!0)}delete(f){this._throwIfFinalized();let m=null;if(f instanceof y.Range)m=f;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(f,m,o){const d=this._document.validateRange(f);this._collectedEdits.push({range:d,text:m,forceMoveMarkers:o})}setEndOfLine(f){if(this._throwIfFinalized(),f!==y.EndOfLine.LF&&f!==y.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=f}}e.TextEditorEdit=D;class k{constructor(f,m,o,d){this._proxy=f,this._id=m,this._accept(o),this._logService=d;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(v){E._setTabSize(v)},get insertSpaces(){return E._insertSpaces},set insertSpaces(v){E._setInsertSpaces(v)},get cursorStyle(){return E._cursorStyle},set cursorStyle(v){E._setCursorStyle(v)},get lineNumbers(){return E._lineNumbers},set lineNumbers(v){E._setLineNumbers(v)}}}_accept(f){this._tabSize=f.tabSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const m=Math.floor(f);return m>0?m:null}if(typeof f=="string"){const m=parseInt(f,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(f){const m=this._validateTabSize(f);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}_setInsertSpaces(f){const m=this._validateInsertSpaces(f);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(f)})))}assign(f){const m={};let o=!1;if(typeof f.tabSize!="undefined"){const d=this._validateTabSize(f.tabSize);d==="auto"?(o=!0,m.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,o=!0,m.tabSize=d)}if(typeof f.insertSpaces!="undefined"){const d=this._validateInsertSpaces(f.insertSpaces);d==="auto"?(o=!0,m.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,o=!0,m.insertSpaces=d)}typeof f.cursorStyle!="undefined"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,o=!0,m.cursorStyle=f.cursorStyle),typeof f.lineNumbers!="undefined"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,o=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(f.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(f){f.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=k;class r{constructor(f,m,o,d,E,v,S,u){this.id=f,this._proxy=m,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new k(this._proxy,this.id,v,o),this._visibleRanges=S,this._viewColumn=u;const c=this;this.value=Object.freeze({get document(){return d.getValue()},set document(h){throw(0,R.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(h){if(!(h instanceof y.Selection))throw(0,R.illegalArgument)("selection");c._selections=[h],c._trySetSelection()},get selections(){return c._selections},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof y.Selection)))throw(0,R.illegalArgument)("selections");c._selections=h,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(h){throw(0,R.readonly)("visibleRanges")},get options(){return c._options.value},set options(h){c._disposed||c._options.assign(h)},get viewColumn(){return c._viewColumn},set viewColumn(h){throw(0,R.readonly)("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(d.getValue(),t);return h(n),c._applyEdit(n)},insertSnippet(h,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=c._selections.map(i=>A.Range.from(i));else if(t instanceof y.Position){const{lineNumber:i,column:a}=A.Position.from(t);s=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof y.Range)s=[A.Range.from(t)];else{s=[];for(const i of t)if(i instanceof y.Range)s.push(A.Range.from(i));else{const{lineNumber:a,column:p}=A.Position.from(i);s.push({startLineNumber:a,startColumn:p,endLineNumber:a,endColumn:p})}}return m.$tryInsertSnippet(f,h.value,s,n)},setDecorations(h,t){const n=t.length===0;n&&!c._hasDecorationsForKey.has(h.key)||(n?c._hasDecorationsForKey.delete(h.key):c._hasDecorationsForKey.add(h.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return m.$trySetDecorations(f,h.key,A.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const p=t[i];s[4*i]=p.start.line+1,s[4*i+1]=p.start.character+1,s[4*i+2]=p.end.line+1,s[4*i+3]=p.end.character+1}return m.$trySetDecorationsFast(f,h.key,s)}}))},revealRange(h,t){c._runOnProxy(()=>m.$tryRevealRange(f,A.Range.from(h),t||y.TextEditorRevealType.Default))},show(h){m.$tryShowEditor(f,A.ViewColumn.from(h))},hide(){m.$tryHideEditor(f)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,b.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,b.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,b.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,b.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const m=f.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const o=m.edits.map(E=>E.range);o.sort((E,v)=>E.end.line===v.end.line?E.end.character===v.end.character?E.start.line===v.start.line?E.start.character-v.start.character:E.start.line-v.start.line:E.end.character-v.end.character:E.end.line-v.end.line);for(let E=0,v=o.length-1;E<v;E++){const S=o[E].end;if(o[E+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=m.edits.map(E=>({range:A.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,d,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=r}),define(me[215],ge([0,1,165,25,2,3,6,13,7,11,16,20,21]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(E,v){if((0,k.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let S;return Array.isArray(E.highlights)&&(S=E.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),S=S.length?S:void 0),{label:E.label,highlights:S}}}class o{constructor(v,S,u){this._proxy=v,this.commands=S,this.logService=u,this.treeViews=new Map;function c(h){return h&&h.$treeViewId&&h.$treeItemHandle}S.registerArgumentProcessor({processArgument:h=>c(h)?this.convertArgument(h):Array.isArray(h)&&h.length>0?h.map(t=>c(t)?this.convertArgument(t):t):h})}registerTreeDataProvider(v,S,u){const c=this.createTreeView(v,{treeDataProvider:S},u);return{dispose:()=>c.dispose()}}createTreeView(v,S,u){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=S.dragAndDropController!==void 0,h=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,canDragAndDrop:c}),t=this.createExtHostTreeView(v,S,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,s)=>t.reveal(n,s),dispose:async()=>{await h,this.treeViews.delete(v),t.dispose()}}}$getChildren(v,S){const u=this.treeViews.get(v);return u?u.getChildren(S):Promise.reject(new Error((0,b.localize)(0,null,v)))}$onDrop(v,S,u){const c=this.treeViews.get(v);return c?c.onDrop(S,u):Promise.reject(new Error((0,b.localize)(1,null,v)))}async $hasResolve(v){const S=this.treeViews.get(v);if(!S)throw new Error((0,b.localize)(2,null,v));return S.hasResolve}$resolve(v,S,u){const c=this.treeViews.get(v);if(!c)throw new Error((0,b.localize)(3,null,v));return c.resolveTreeItem(S,u)}$setExpanded(v,S,u){const c=this.treeViews.get(v);if(!c)throw new Error((0,b.localize)(4,null,v));c.setExpanded(S,u)}$setSelection(v,S){const u=this.treeViews.get(v);if(!u)throw new Error((0,b.localize)(5,null,v));u.setSelection(S)}$setVisible(v,S){const u=this.treeViews.get(v);if(!u)throw new Error((0,b.localize)(6,null,v));u.setVisible(S)}createExtHostTreeView(v,S,u){const c=new d(v,S,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(v,c),c}convertArgument(v){const S=this.treeViews.get(v.$treeViewId);return S?S.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=o;class d extends y.Disposable{constructor(v,S,u,c,h,t){super();if(this.viewId=v,this.proxy=u,this.commands=c,this.logService=h,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const a of t.contributes.views[i])a.id===v&&(this._title=a.name);this.dataProvider=S.treeDataProvider,this.dndController=S.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let n,s;this._register(A.Event.debounce(this._onDidChangeData.event,(i,a)=>(i||(i={message:!1,elements:[]}),a.element!==!1&&(n||(n=new Promise(p=>s=p),this.refreshPromise=this.refreshPromise.then(()=>n)),i.elements.push(a.element)),a.message&&(i.message=!0),i),200,!0)(({message:i,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=s;return n=null,this.refresh(a).then(()=>p())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,k.isUndefinedOrNull)(v))}getChildren(v){const S=v?this.getExtensionElement(v):void 0;if(v&&!S)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(v);return(u?Promise.resolve(u):this.fetchChildrenNodes(S)).then(c=>c.map(h=>h.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,S){S=S||{select:!0,focus:!1};const u=(0,k.isUndefinedOrNull)(S.select)?!0:S.select,c=(0,k.isUndefinedOrNull)(S.focus)?!1:S.focus,h=(0,k.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:u,focus:c,expand:h})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:c,expand:h})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,S){const u=this.getExtensionElement(v);u&&(S?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(v){(0,r.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(v,S){const u=v.map(h=>this.getExtensionElement(h)).filter(h=>!(0,k.isUndefinedOrNull)(h)),c=this.getExtensionElement(S);return u&&c?(0,C.asPromise)(()=>{var h;return(h=this.dndController)===null||h===void 0?void 0:h.onDrop(u,c)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,S){var u;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(v);if(c){const h=this.nodes.get(c);if(h){const t=(u=await this.dataProvider.resolveTreeItem(h.extensionItem,c,S))!==null&&u!==void 0?u:h.extensionItem;return h.item.tooltip=this.getTooltip(t.tooltip),h.item.command=this.getCommand(h.disposableStore,t.command),h.item}}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(S=>S?this.resolveUnknownParentChain(S).then(u=>this.resolveTreeNode(S,u[u.length-1]).then(c=>(u.push(c),u))):Promise.resolve([]))}resolveParent(v){const S=this.nodes.get(v);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,S){const u=this.nodes.get(v);return u?Promise.resolve(u):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(c=>this.createHandle(v,c,S,!0)).then(c=>this.getChildren(S?S.item.handle:void 0).then(()=>{const h=this.getExtensionElement(c);if(h){const t=this.nodes.get(h);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(v){if(v){let S;if(typeof v=="string"){const u=this.getExtensionElement(v);S=u?this.nodes.get(u):void 0}else S=v;return S&&S.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const S=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=v?this.nodes.get(v):void 0,c=await this.dataProvider.getChildren(v);if(S.token.isCancellationRequested)return[];const h=await Promise.all((0,r.coalesce)(c||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,u):null}));return S.token.isCancellationRequested?[]:(0,r.coalesce)(h)}finally{S.dispose()}}refresh(v){if(v.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(v);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const S=new Set,u=v.map(h=>this.nodes.get(h));for(const h of u)if(h&&!S.has(h.item.handle)){let t=h;for(;t&&t.parent&&u.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(h.item.handle)}const c=[];return S.forEach(h=>{const t=this.elements.get(h);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&c.push(h)}}),c}refreshHandles(v){const S={};return Promise.all(v.map(u=>this.refreshNode(u).then(c=>{c&&(S[u]=c.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(v){const S=this.getExtensionElement(v);if(S){const u=this.nodes.get(S);if(u)return this.clearChildren(S),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(c=>{if(c){const h=this.createTreeNode(S,c,u.parent);return this.updateNodeCache(S,h,u,u.parent),u.dispose(),h}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,S,u){const c=this.createTreeNode(v,S,u);if(S.id&&this.elements.has(c.item.handle))throw new Error((0,b.localize)(7,null,S.id));return this.addNodeToCache(v,c),this.addNodeToParentCache(c,u),c}getTooltip(v){return D.MarkdownString.isMarkdownString(v)?P.MarkdownString.from(v):v}getCommand(v,S){return S?this.commands.toInternal(S,v):void 0}createTreeNode(v,S,u){const c=new y.DisposableStore,h=this.createHandle(v,S,u),t=this.getLightIconPath(S);return{item:{handle:h,parentHandle:u?u.item.handle:void 0,label:m(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(c,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,k.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:u,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(v){return v.iconPath instanceof D.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:S,label:u,resourceUri:c},h,t){if(S)return`${d.ID_HANDLE_PREFIX}/${S}`;const n=m(u,this.extension),s=h?h.item.handle:d.LABEL_HANDLE_PREFIX;let i=n?n.label:c?(0,R.basename)(c):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const a=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,p=this.getChildrenNodes(h)||[];let g,_=0;do{if(g=`${s}/${_}:${i}`,t||!this.elements.has(g)||a===g)break;_++}while(_<=p.length);return g}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon))return typeof v.iconPath=="string"||I.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return I.URI.isUri(v)?v:I.URI.file(v)}addNodeToCache(v,S){this.elements.set(S.item.handle,v),this.nodes.set(v,S)}updateNodeCache(v,S,u,c){this.elements.delete(S.item.handle),this.nodes.delete(v),S.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(v,S);const h=this.getChildrenNodes(c)||[],t=h.filter(n=>n.item.handle===u.item.handle)[0];t&&h.splice(h.indexOf(t),1,S)}addNodeToParentCache(v,S){S?(S.children||(S.children=[]),S.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const S=this.nodes.get(v);if(S){if(S.children)for(const u of S.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}S.children=void 0}}else this.clearAll()}clear(v){const S=this.nodes.get(v);if(S){if(S.children)for(const u of S.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}this.nodes.delete(v),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(me[216],ge([0,1,16,13,21,11,87,20,7,123]),function(Q,e,b,R,I,A,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class r{constructor(){this.testIdsToInternal=new Map}getTestById(E,v){if(v!==void 0){const S=this.testIdsToInternal.get(v),u=S==null?void 0:S.get(E);if(u)return[S,u]}return(0,b.mapFind)(this.testIdsToInternal.values(),S=>{const u=S.get(E);return u&&[S,u]})}createForHierarchy(E=()=>{}){return new o(this.createIdMap(f++),E)}createIdMap(E){const v=new m(E);return this.testIdsToInternal.set(v.id,v),{object:v,dispose:()=>this.testIdsToInternal.delete(v.id)}}}e.OwnedTestCollection=r;var P;(function(d){d[d.Disconnected=0]="Disconnected",d[d.IsChild=1]="IsChild",d[d.IsParent=2]="IsParent",d[d.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let f=0;class m{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const v=this.map.get(E);return v?(this.map.delete(E),this._roots.delete(v),!0):!1}get(E){return this.map.get(E)}comparePositions(E,v){const S=typeof E=="string"?this.map.get(E):E,u=typeof v=="string"?this.map.get(v):v;if(!S||!u)return 0;if(S===u)return 3;for(let c=this.map.get(u.parent);c;c=this.map.get(c.parent))if(c===S)return 1;for(let c=this.map.get(S.parent);c;c=this.map.get(c.parent))if(c===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=m;class o{constructor(E,v){this.testIdToInternal=E,this.publishDiff=v,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,v){this.addItem(E,v,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const v=this.diff[this.diff.length-1];if(v&&E[0]===1){if(v[0]===1&&v[1].extId===E[1].extId){(0,k.applyTestItemUpdate)(v[1],E[1]);return}if(v[0]===0&&v[1].item.extId===E[1].extId){(0,k.applyTestItemUpdate)(v[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,v){var S;const u=this.testIdToInternal.object.get(E);if(!!u){if((u.expandLevels===void 0||v>u.expandLevels)&&(u.expandLevels=v),u.expand===1){const c=this.refreshChildren(u);return c.isSettled?this.expandChildren(u,v-1):c.p.then(()=>this.expandChildren(u,v-1))}else if(u.expand===3)return((S=u.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,v-1)):this.expandChildren(u,v-1)}}dispose(){var E;for(const v of this.testItemToInternal.values())(E=v.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(v.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,v){const S=E==null?void 0:E.actual.id;switch(v[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(E);break;case 0:this.addItem(v[1],E.src.controller,E);break;case 3:const[u,c,h]=v;switch(c){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:S,item:{range:C.Range.from(h)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:C.MarkdownString.fromStrict(h)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[c]:h!=null?h:null}}]);break}break;default:(0,A.assertNever)(v[0])}}addItem(E,v,S){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const u=S?S.item.extId:null,c=E.resolveHandler?1:0,h=S?S.expandLevels:1,t={controller:v,tree:this.testIdToInternal.object.id},n={actual:E,parent:u,item:C.TestItem.from(E),expandLevels:h?h-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:u,src:t,expand:c,item:n.item}]);const s=(0,y.getPrivateApiFor)(E);s.parent=S==null?void 0:S.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const i of s.children.values())this.testItemToInternal.has(i)||this.addItem(i,v,n)}updateExpandability(E){var v;let S;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?S=E.discoverCts?2:1:((v=E.initialExpand)===null||v===void 0||v.complete(),S=3):S=0,S!==E.expand&&(E.expand=S,this.pushDiff([1,{extId:E.actual.id,expand:S}]),S===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,v){if(!(v<0)){const S=[...E.actual.children.values()].map(u=>this.expand(u.id,v)).filter(R.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const v=new R.DeferredPromise;return v.complete(),v}return E.expand=2,E.discoverCts=new I.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new R.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var v;this.pushDiff([2,E.actual.id]);const S=[E];for(;S.length;){const u=S.pop();if(!!u){(v=u.discoverCts)===null||v===void 0||v.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const c of u.actual.children.values())S.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=o}),define(me[217],ge([0,1,26,3,9]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=A;class y{constructor(r){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(r.identifier))){console.error("Extension `"+r.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(r.identifier),r),this._extensionsArr.push(r),Array.isArray(r.activationEvents))for(let P of r.activationEvents)P==="onUri"&&(P=`onUri:${b.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(r)}}keepOnly(r){const P=new Set;r.forEach(f=>P.add(b.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>P.has(b.ExtensionIdentifier.toKey(f.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,P){r.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(r));const f=y._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(f.map(m=>m.identifier)),P.length>0){const m=new Set;P.forEach(o=>m.add(b.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!m.has(b.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(f)}static _findLoopingExtensions(r){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,v){this.addNode(E),this.addNode(v),this._arcs.has(E)?this._arcs.get(E).push(v):this._arcs.set(E,[v])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,v){const S=P.getArcs(E);for(let u=0;u<S.length;u++)if(!v.has(S[u]))return!1;return!0}getNodes(){return this._nodesArr}};let f=new Map;for(let E of r){const v=b.ExtensionIdentifier.toKey(E.identifier);if(f.set(v,E),E.extensionDependencies)for(let S of E.extensionDependencies){const u=b.ExtensionIdentifier.toKey(S);P.addArc(v,u)}}let m=new Set;P.getNodes().filter(E=>P.getArcs(E).length===0).forEach(E=>m.add(E));let o=P.getNodes().filter(E=>!m.has(E)),d;do{d=!1;for(let E=0;E<o.length;E++){const v=o[E];P.hasOnlyGoodArcs(v,m)&&(o.splice(E,1),E--,m.add(v),d=!0)}}while(d);return o.map(E=>f.get(E))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(r))}getExtensionDescriptionsForActivationEvent(r){const P=this._activationMap.get(r);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const P=this._extensionsMap.get(b.ExtensionIdentifier.toKey(r));return P||void 0}}e.ExtensionDescriptionRegistry=y;var C;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(C||(C={}));function D(k,r){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,f=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(P!==f)return P-f;const m=I.posix.basename(k.extensionLocation.path),o=I.posix.basename(r.extensionLocation.path);return m<o?-1:m>o?1:0}}),define(me[218],ge([0,1,23]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function A(C){const D=b.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function y(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(me[40],ge([0,1,3,2,4,26,182]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class C{constructor(S){this.dependency=S}}e.MissingExtensionDependency=C;var D;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(S,u,c,h){this.codeLoadingTime=S,this.activateCallTime=u,this.activateResolvedTime=c,this.activationReason=h}}e.ActivationTimes=k;class r{constructor(S,u){this.description=S,this.value=u}}e.ExtensionPointContribution=r,e.ExtensionHostLogFileName="exthost";var P;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function f(v){v.enableProposedApi||m(v)}e.checkProposedApiEnabled=f;function m(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=m;function o(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=o;function d(v){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!1,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=d;class E{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,u){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,u,c,h,t){}_onDidActivateExtensionError(S,u){}_onExtensionRuntimeError(S,u){}_onExtensionHostExit(S){}}e.NullExtensionService=E}),define(me[219],ge([0,1,26,40,14]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class y{constructor(o,d,E,v){this.startup=o,this.codeLoadingTime=d,this.activateCallTime=E,this.activateResolvedTime=v}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class C{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,d){return o===-1||d===-1?-1:d-o}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class D{constructor(o,d,E,v,S,u){this.activationFailed=o,this.activationFailedError=d,this.activationTimes=E,this.module=v,this.exports=S,this.subscriptions=u}}e.ActivatedExtension=D;class k extends D{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class r extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=r;class P extends D{constructor(o){super(!0,o,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let f=class{constructor(o,d,E,v,S){this._logService=S,this._registry=o,this._resolvedExtensionsSet=new Set,d.forEach(u=>this._resolvedExtensionsSet.add(b.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,E.forEach(u=>this._hostExtensionsMap.set(b.ExtensionIdentifier.toKey(u),u)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const d=b.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(d)}getActivatedExtension(o){const d=b.ExtensionIdentifier.toKey(o),E=this._activatedExtensions.get(d);if(!E)throw new Error("Extension `"+o.value+"` is not known or not activated");return E}activateByEvent(o,d){if(this._alreadyActivatedEvents[o])return A;const E=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(E.map(v=>({id:v.identifier,reason:{startup:d,extensionId:v.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,d){const E=this._registry.getExtensionDescription(o);if(!E)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:E.identifier,reason:d}])}_handleActivateRequest(o,d,E){if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(o.id))){d[b.ExtensionIdentifier.toKey(o.id)]=o;return}const v=this._registry.getExtensionDescription(o.id);if(!v){const c=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,c,new R.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(o.id),new P(c));return}const S=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let u=!0;for(let c=0,h=S.length;c<h;c++){const t=S[c];if(!this._resolvedExtensionsSet.has(b.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(b.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const p=v.displayName||v.identifier.value,g=this._registry.getExtensionDescription(t),_=g&&g.displayName||t,l=new Error(`Cannot activate the '${p}' extension because its dependency '${_}' failed to activate`);l.detail=n.activationFailedError,this._host.onExtensionActivationError(v.identifier,l,null),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(v.identifier),new P(l));return}if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(t))){u=!1,d[b.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(b.ExtensionIdentifier.toKey(t)),reason:o.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){u=!1,d[b.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:o.reason};continue}const i=v.displayName||v.identifier.value,a=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(v.identifier,a,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(v.identifier),new P(a));return}}}u?d[b.ExtensionIdentifier.toKey(v.identifier)]=o:E.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(S=>!this._activatedExtensions.has(b.ExtensionIdentifier.toKey(S.id))),o.length===0))return Promise.resolve(void 0);const d=Object.create(null),E=[];for(let S=0,u=o.length;S<u;S++)this._handleActivateRequest(o[S],d,E);for(let S=0,u=E.length;S<u;S++){const c=b.ExtensionIdentifier.toKey(E[S].id);d[c]&&delete d[c]}const v=Object.keys(d).map(S=>d[S]);return E.length===0?Promise.all(v.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(v).then(S=>this._activateExtensions(E))}_activateExtension(o,d){const E=b.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const v=this._activatingExtensions.get(E);if(v)return v;const S=this._host.actualActivateExtension(o,d).then(void 0,u=>{const c=new Error;return u&&u.name&&(c.name=u.name),u&&u.message?c.message=`Activating extension '${o.value}' failed: ${u.message}.`:c.message=`Activating extension '${o.value}' failed: ${u}.`,u&&u.stack&&(c.stack=u.stack),this._host.onExtensionActivationError(o,c,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(u),new P(u)}).then(u=>{this._activatedExtensions.set(E,u),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,S),S}};f=qe([He(4,I.ILogService)],f),e.ExtensionsActivator=f}),define(me[220],ge([0,1,14,40,27,12,113]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends b.LogService{constructor(k){if(k.logFile.scheme!==A.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(R.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};C=qe([He(0,I.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[221],ge([0,1,17]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,b.onUnexpectedError)(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=R}),define(me[125],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(D,k){this.isMain=D,this.sid=k,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const R=[];function I(C){const D=new b(!0,C);return R[D.nid]=D,D}e.createMainContextProxyIdentifier=I;function A(C){const D=new b(!1,C);return R[D.nid]=D,D}e.createExtHostContextProxyIdentifier=A;function y(C){return R[C].sid}e.getStringIdentifierForProxy=y}),define(me[5],ge([0,1,59,2,125]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var r;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(r=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var f;(function(u){u.name="$ident";function c(t,n){return Object.defineProperty(t,u.name,{value:n,enumerable:!0}),t}u.mixin=c;function h(t){return t[u.name]}u.of=h})(f=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(c){return c._id=m._n++,c}}e.IdObject=m,m._n=0;var o;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(u){if(u&&u.edits)for(const c of u.edits)typeof c.resource=="object"?c.resource=R.URI.revive(c.resource):(c.newUri=R.URI.revive(c.newUri),c.oldUri=R.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,b.revive)(c.metadata));return u}e.reviveWorkspaceEditDto=v;var S;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[89],ge([0,1,5,3,4]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(C){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,k){return this._proxy.$setPassword(C,D,k)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(me[65],ge([0,1,4,14,5,15]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(I.MainContext.MainThreadTelemetry)}report(D,k,r){const P=this.getUsageKey(D,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${r}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}getUsageKey(D,k){return`${D}-${k.identifier.value}`}};y=qe([He(0,A.IExtHostRpcService),He(1,R.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,k){}})}),define(me[222],ge([0,1,3,5,7,26]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,k,r,P={}){const f=A.ExtensionIdentifier.toKey(D.identifier),m=this._inFlightRequests.get(f)||[],o=r.sort().join(" ");let d=m.find(E=>E.scopes===o);if(d)return d.result;{const E=this._getSession(D,f,k,r,P);d={scopes:o,result:E},m.push(d),this._inFlightRequests.set(f,m);try{await E}finally{const v=m.findIndex(S=>S.scopes===o);v>-1&&(m.splice(v),this._inFlightRequests.set(f,m))}return E}}async _getSession(D,k,r,P,f={}){await this._proxy.$ensureProvider(r);const m=D.displayName||D.name;return this._proxy.$getSession(r,P,k,m,f)}async removeSession(D,k){const r=this._authenticationProviders.get(D);return r?r.provider.removeSession(k):this._proxy.$removeSession(D,k)}registerAuthenticationProvider(D,k,r,P){var f;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:k,provider:r,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(o=>o.id===D)||this._providers.push({id:D,label:k});const m=r.onDidChangeSessions(o=>{var d,E,v;this._proxy.$sendDidChangeSessions(D,{added:(d=o.added)!==null&&d!==void 0?d:[],changed:(E=o.changed)!==null&&E!==void 0?E:[],removed:(v=o.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(D,k,(f=P==null?void 0:P.supportsMultipleAccounts)!==null&&f!==void 0?f:!1),new I.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(D);const o=this._providers.findIndex(d=>d.id===D);o>-1&&this._providers.splice(o),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this._onDidChangeSessions.fire({provider:{id:D,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,k){return D.forEach(r=>{this._providers.some(P=>P.id===r.id)||this._providers.push(r)}),k.forEach(r=>{const P=this._providers.findIndex(f=>f.id===r.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(me[223],ge([0,1,5,15,20]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=I.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=qe([He(0,R.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(me[224],ge([0,1,5]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(A){const y=A.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(C){return y.$writeText(C)}})}}e.ExtHostClipboard=R}),define(me[50],ge([0,1,11,7,20,24,5,16,14,59,43,47,2,6,4,15]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new v(this,s=>{const i=this._apiCommands.get(s);return(i==null?void 0:i.result)===u.Void?i:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,A.cloneAndChange)(s,function(i){if(r.Range.isIRange(i))return I.Range.to(i);if(P.Position.isIPosition(i))return I.Position.to(i);if(r.Range.isIRange(i.range)&&f.URI.isUri(i.uri))return I.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((p,g)=>{if(!p.validate(s[g]))throw new Error(`Invalid argument '${p.name}' when running '${t.id}', received: ${s[g]}`);return p.convert(s[g])}),a=await this.executeCommand(t.internalId,...i);return t.result.convert(a,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,i,a){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:i,description:a}),t&&this._proxy.$registerCommand(n),new R.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const i=(0,A.cloneAndChange)(n,function(a){if(a instanceof R.Position)return I.Position.from(a);if(a instanceof R.Range)return I.Range.from(a);if(a instanceof R.Location)return I.location.from(a);if(R.NotebookRange.isNotebookRange(a))return I.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,i,s);return(0,k.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw a}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:a,description:p}=s;if(p)for(let g=0;g<p.args.length;g++)try{(0,b.validateConstraint)(n[g],p.args[g].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${p.args[g].name}' - ${p.args[g].description}`)}try{return await i.apply(a,n)}catch(g){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...n);_&&(t=_.command)}throw this._logService.error(g,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((i,a)=>a.processArgument(i),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:i}=s;i&&(t[n]=i)}return Promise.resolve(t)}};E=qe([He(0,d.IExtHostRpcService),He(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class v{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((a,p)=>a.convert(t.arguments&&t.arguments[p]));else if((0,C.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),n.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),s.$ident=a,s.id=this.delegatingCommandId,s.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return s}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class S{constructor(t,n,s,i){this.name=t,this.description=n,this.validate=s,this.convert=i}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",h=>f.URI.isUri(h),h=>h),S.Position=new S("position","A position in a text document",h=>R.Position.isPosition(h),I.Position.from),S.Range=new S("range","A range in a text document",h=>R.Range.isRange(h),I.Range.from),S.Selection=new S("selection","A selection in a text document",h=>R.Selection.isSelection(h),I.Selection.from),S.Number=new S("number","",h=>typeof h=="number",h=>h),S.String=new S("string","",h=>typeof h=="string",h=>h),S.CallHierarchyItem=new S("item","A call hierarchy item",h=>h instanceof R.CallHierarchyItem,I.CallHierarchyItem.to);class u{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=u,u.Void=new u("no result",h=>h);class c{constructor(t,n,s,i,a){this.id=t,this.internalId=n,this.description=s,this.args=i,this.result=a}}e.ApiCommand=c}),define(me[225],ge([0,1,6,20,7,80,50,201,16,109]),function(Q,e,b,R,I,A,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const r=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",f(R.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,d)=>{if(!(0,D.isFalsyOrEmpty)(o)){class E extends I.SymbolInformation{static to(S){const u=new E(S.name,R.SymbolKind.to(S.kind),S.containerName||"",new I.Location(d[0],R.Range.to(S.range)));return u.detail=S.detail,u.range=u.location.range,u.selectionRange=R.Range.to(S.selectionRange),u.children=S.children?S.children.map(E.to):[],u}}return o.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(R.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",f(R.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",f(R.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(d=>I.Position.isPosition(d)),o=>o.map(R.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(d=>{let E;for(const v of d.reverse())E=new I.SelectionRange(R.Range.to(v),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const d=[];if(Array.isArray(o))for(let E of o)d.push(...E[1].map(R.WorkspaceSymbol.to));return d})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(R.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(R.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(R.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return R.WorkspaceEdit.to(o)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(R.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new I.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!!o){const d=(0,k.decodeSemanticTokensDto)(o);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new I.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!!o){const d=(0,k.decodeSemanticTokensDto)(o);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,d,E)=>{if(!o)return new I.CompletionList([]);const v=o.suggestions.map(S=>R.CompletionItem.to(S,E));return new I.CompletionList(v,o.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return R.SignatureHelp.to(o)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,d,E)=>f(v=>new I.CodeLens(R.Range.to(v.range),v.command&&E.fromInternal(v.command)))(o))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>I.Range.isRange(o),o=>I.Selection.isSelection(o)?R.Selection.from(o):R.Range.from(o)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,d,E)=>f(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(v.command)}else{const S=new I.CodeAction(v.title,v.kind?new I.CodeActionKind(v.kind):void 0);return v.edit&&(S.edit=R.WorkspaceEdit.to(v.edit)),v.command&&(S.command=E.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(o))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(d=>new I.ColorInformation(R.Range.to(d.range),R.Color.to(d.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",o=>o instanceof I.Color,R.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:R.Range.from(o.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(R.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(R.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",f(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(d=>R.NotebookExclusiveDocumentPattern.to(d))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(R.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[R.ViewColumn.from(o.viewColumn),R.TextEditorOpenOptions.from(o)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[R.ViewColumn.from(o.viewColumn),R.TextEditorOpenOptions.from(o)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[R.ViewColumn.from(o.viewColumn),R.TextEditorOpenOptions.from(o)]).optional()],y.ApiCommandResult.Void)];class P{constructor(d){this._disposables=new b.DisposableStore,this._commands=d}static register(d){return r.forEach(d.registerApiCommand,d),new P(d).registerCommands()}registerCommands(){const d=E=>(...v)=>E(this._commands,...v);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,d(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(C.OpenIssueReporter.ID,d(C.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(d,E,v){const S=this._commands.registerCommand(!1,d,E,this,v);this._disposables.add(S)}}e.ExtHostApiCommands=P;function f(o){return d=>{if(Array.isArray(d))return d.map(o)}}function m(o){if(!!Array.isArray(o)){const d=[];for(const E of o)A.isLocationLink(E)?d.push(R.DefinitionLink.to(E)):d.push(R.location.to(E));return d}}}),define(me[226],ge([0,1,13,54,3,6,2,80,26,20,7,5]),function(Q,e,b,R,I,A,y,C,D,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class f{constructor(c,h,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(P.MainContext.MainThreadComments),h.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.commentThreadHandle);return i||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.thread.commentThreadHandle);return i?{thread:i,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let a=n.commentUniqueId,p=i.getCommentByUniqueId(a);return p||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let a=n.text,p=n.commentUniqueId,g=i.getCommentByUniqueId(p);return g?(g.body=a,g):n}return n}})}createCommentController(c,h,t){const n=f.handlePool++,s=new o(c,n,this._proxy,h,t);this._commentControllers.set(s.handle,s);const i=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(c.identifier))||[];return i.push(s),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(c.identifier),i),s}$createCommentThreadTemplate(c,h,t){const n=this._commentControllers.get(c);!n||n.$createCommentThreadTemplate(h,t)}async $updateCommentThreadTemplate(c,h,t){const n=this._commentControllers.get(c);!n||n.$updateCommentThreadTemplate(h,t)}$deleteCommentThread(c,h){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(h)}$provideCommentingRanges(c,h,t){const n=this._commentControllers.get(c);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(h));return(0,b.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(i=>i?i.map(a=>k.Range.from(a)):void 0)}$toggleReaction(c,h,t,n,s){const i=this._commentControllers.get(c);return!i||!i.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const a=i.getCommentThread(h);if(a){const p=a.getCommentByUniqueId(n.uniqueIdInThread);if(i!==void 0&&p&&i.reactionHandler)return i.reactionHandler(p,v(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=f,f.handlePool=0;class m{constructor(c,h,t,n,s,i,a){this._proxy=c,this._commentController=h,this._id=t,this._uri=n,this._range=s,this._comments=i,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${h.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),h={};c("range")&&(h.range=k.Range.from(this._range)),c("label")&&(h.label=this.label),c("contextValue")&&(h.contextValue=this.contextValue),c("comments")&&(h.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(h.collapseState=S(this._collapseState)),c("canReply")&&(h.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,h)}}getCommentByUniqueId(c){for(let h of this._commentsMap){let t=h[0],n=h[1];if(c===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,qe([(0,R.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class o{constructor(c,h,t,n,s){this._extension=c,this._handle=h,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,h,t,n){if(typeof c=="string"){const s=new m(this._proxy,this,c,h,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new m(this._proxy,this,void 0,c,h,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(c,h){const t=new m(this._proxy,this,void 0,y.URI.revive(c),k.Range.to(h),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,h){let t=this._threads.get(c);t&&(t.range=k.Range.to(h))}$deleteCommentThread(c){let h=this._threads.get(c);h&&h.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(u,c,h,t){let n=t.get(h);n||(n=++u.commentHandle,t.set(h,n));const s=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;return{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(h.body),userName:h.author.name,userIconPath:s,label:h.label,commentReactions:h.reactions?h.reactions.map(i=>E(i)):void 0}}function E(u){return{label:u.label,iconPath:u.iconPath?k.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function v(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?y.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function S(u){if(u!==void 0)switch(u){case r.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case r.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(me[126],ge([0,1,2,5,7,4,15,14,16,8,9]),function(Q,e,b,R,I,A,y,C,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class _n{constructor(m,o){this._logService=o,this._provider=new Map,this._proxy=m.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,o){const d=_n._handlePool++;this._provider.set(d,{provider:m,extensionId:o}),this._proxy.$registerDecorationProvider(d,o.value);const E=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(d,null);return}let S=(0,D.asArray)(v);if(S.length<=_n._maxEventSize){this._proxy.$onDidChange(d,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,S.length);const u=S.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),c=(0,D.groupBy)(u,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let h=[];e:for(let t of c){let n;for(let s of t){let i=(0,r.dirname)(s.uri.path);if(n!==i&&(n=i,h.push(s.uri)>=_n._maxEventSize))break e}}this._proxy.$onDidChange(d,h)});return new I.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(m,o,d){if(!this._provider.has(m))return Object.create(null);const E=Object.create(null),{provider:v,extensionId:S}=this._provider.get(m);return await Promise.all(o.map(async u=>{try{const{uri:c,id:h}=u,t=await Promise.resolve(v.provideFileDecoration(b.URI.revive(c),d));if(!t)return;try{I.FileDecoration.validate(t),E[h]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(c){this._logService.error(c)}})),E}};P._handlePool=0,P._maxEventSize=250,P=qe([He(0,y.IExtHostRpcService),He(1,C.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(me[227],ge([0,1,160,114,2,5,7,20,3,14,22]),function(Q,e,b,R,I,A,y,C,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(o,d,E,v,S){this._name=o,this._owner=d,this._maxDiagnosticsPerFile=E,this._proxy=v,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new r.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,d){if(!o){this.clear();return}this._checkDisposed();let E=[];if(I.URI.isUri(o)){if(!d){this.delete(o);return}this._data.set(o,d.slice()),E=[o]}else if(Array.isArray(o)){E=[];let S;o=[...o].sort(P._compareIndexedTuplesByUri);for(const u of o){const[c,h]=u;if((!S||c.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=c,E.push(c),this._data.set(c,[])),h){const t=this._data.get(c);t&&t.push(...h)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const v=[];for(let S of E){let u=[];const c=this._data.get(S);if(c)if(c.length>this._maxDiagnosticsPerFile){u=[];const h=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of c)if(n.severity===h[t]&&u.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:(0,b.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=c.map(h=>C.Diagnostic.from(h));v.push([S,u])}this._proxy.$changeMany(this._owner,v)}}delete(o){this._checkDisposed(),this._onDidChangeDiagnostics.fire([o]),this._data.delete(o),this._proxy&&this._proxy.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(o,d){this._checkDisposed();for(let E of this._data.keys())o.apply(d,[E,this.get(E),this])}get(o){this._checkDisposed();const d=this._data.get(o);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this._data.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,d){return o[0].toString()<d[0].toString()?-1:o[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=P;let f=class jt{constructor(o,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=o.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(o,d){return o?o.concat(d):d}static _mapper(o){const d=new r.ResourceMap;for(const E of o)d.set(E,E);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(o,d){const{_collections:E,_proxy:v,_onDidChangeDiagnostics:S,_logService:u}=this,c=new class{$changeMany(n,s){v.$changeMany(n,s),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,n,s.length===0?"CLEARING":s)}$clear(n){v.$clear(n),u.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,n)}dispose(){v.dispose()}};let h;if(!d)d="_generated_diagnostic_collection_name_#"+jt._idPool++,h=d;else if(!E.has(d))h=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do h=d+jt._idPool++;while(E.has(h))}return new class extends P{constructor(){super(d,h,jt._maxDiagnosticsPerFile,c,S);E.set(h,this)}dispose(){super.dispose(),E.delete(h)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const d=new Map,E=[];for(const v of this._collections.values())v.forEach((S,u)=>{let c=d.get(S.toString());typeof c=="undefined"&&(c=E.length,d.set(S.toString(),c),E.push([S,[]])),E[c][1]=E[c][1].concat(...u)});return E}}_getDiagnostics(o){let d=[];for(let E of this._collections.values())E.has(o)&&(d=d.concat(E.get(o)));return d}$acceptMarkersChange(o){if(!this._mirrorCollection){const d="_generated_mirror",E=new P(d,d,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,E),this._mirrorCollection=E}for(const[d,E]of o)this._mirrorCollection.set(I.URI.revive(d),E.map(C.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=qe([He(1,k.ILogService)],f),e.ExtHostDiagnostics=f}),define(me[228],ge([0,1,2,5]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(y){this._proxy=y.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(C=>C?C.map(D=>b.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(C=>C?b.URI.revive(C):void 0)}}e.ExtHostDialogs=I}),define(me[229],ge([0,1,17,2,7,5,12,21,8]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,f,m){this._documentsAndEditors=f,this._logService=m,this._documentContentProviders=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,f){if(Object.keys(y.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const m=k._handlePool++;this._documentContentProviders.set(m,f),this._proxy.$registerTextContentProvider(m,P);let o;return typeof f.onDidChange=="function"&&(o=f.onDidChange(d=>{if(d.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(m,d).then(E=>{if(!(!E&&typeof E!="string")){const v=this._documentsAndEditors.getDocument(d);if(!!v){const S=(0,D.splitLines)(E);if(!v.equalLines(S))return this._proxy.$onVirtualDocumentChange(d,E)}}},b.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(P,f){const m=this._documentContentProviders.get(P);return m?Promise.resolve(m.provideTextDocumentContent(R.URI.revive(f),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(me[230],ge([0,1,3,6,2,5,120,20,11,24]),function(Q,e,b,R,I,A,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class r{constructor(f,m){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const d of o)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const d of o)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!!f){const m=this._documentsAndEditors.getDocument(f);if(m)return m}}getDocument(f){const m=this.getDocumentData(f);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${f}'`);return m.document}ensureDocumentData(f){const m=this._documentsAndEditors.getDocument(f);if(m)return Promise.resolve(m);let o=this._documentLoader.get(f.toString());return o||(o=this._proxy.$tryOpenDocument(f).then(d=>{this._documentLoader.delete(f.toString());const E=I.URI.revive(d);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},d=>(this._documentLoader.delete(f.toString()),Promise.reject(d))),this._documentLoader.set(f.toString(),o)),o}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(m=>I.URI.revive(m))}$acceptModelModeChanged(f,m){const o=I.URI.revive(f),d=this._documentsAndEditors.getDocument(o);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(m),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(f){const m=I.URI.revive(f),o=this._documentsAndEditors.getDocument(m);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(f,m){const o=I.URI.revive(f),d=this._documentsAndEditors.getDocument(o);if(!d)throw new Error("unknown document");d._acceptIsDirty(m),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(f,m,o){const d=I.URI.revive(f),E=this._documentsAndEditors.getDocument(d);if(!E)throw new Error("unknown document");E._acceptIsDirty(o),E.onEvents(m),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:E.document,contentChanges:m.changes.map(v=>({range:C.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(f,m){(0,y.setWordDefinitionFor)(f,m)}}e.ExtHostDocuments=r}),define(me[41],ge([0,1,52,3,6,2,4,5,120,15,124,20,14,22,12,55,134]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(c,h){this._extHostRpc=c,this._logService=h,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],t=[],n=[];if(c.removedDocuments)for(const s of c.removedDocuments){const i=A.URI.revive(s),a=this._documents.get(i);(a==null?void 0:a.unref())&&(this._documents.delete(i),h.push(a.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const i=A.URI.revive(s.uri);let a=this._documents.get(i);if(a&&i.scheme!==o.Schemas.vscodeNotebookCell)throw new Error(`document '${i} already exists!'`);a||(a=new v(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,a),t.push(a.value)),a.ref()}if(c.removedEditors)for(const s of c.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&n.push(i)}if(c.addedEditors)for(const s of c.addedEditors){const i=A.URI.revive(s.documentUri);b.ok(this._documents.has(i),`document '${i}' does not exist`),b.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const a=this._documents.get(i).value,p=new r.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>a.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(g=>P.Range.to(g)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,p)}c.newActiveEditor!==void 0&&(b.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,I.dispose)(h),(0,I.dispose)(n),c.removedDocuments&&this._onDidRemoveDocuments.fire(h),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var h;return(h=this._documents.get(c))===null||h===void 0?void 0:h.value}allDocuments(){return d.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const h=this._editors.get(this._activeEditorId);return c?h:h==null?void 0:h.value}}allEditors(){return[...this._editors.values()]}};S=qe([He(0,k.IExtHostRpcService),He(1,f.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[231],ge([0,1,2,5,6,7,20,142,8,23]),function(Q,e,b,R,I,A,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class r{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const o=this._schemes.indexOf(m);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),o=[];let d,E,v=14,S=14;for(const u of m){let c=d?(0,D.commonPrefixLength)(d,u):0;for(c===0?E=1:E=S;c<u.length;c++)c+1===u.length?(v=S,S=9):S+=1,o.push([E,u.toUpperCase().charCodeAt(c),S]),o.push([E,u.toLowerCase().charCodeAt(c),S]),E=S;d=u,S=v}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new C.StateMachine(o)}}provideDocumentLinks(m){this._initStateMachine();const o=[],d=C.LinkComputer.computeLinks({getLineContent(E){return m.lineAt(E-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const E of d){const v=y.DocumentLink.to(E);v.target&&o.push(v)}return o}}class P{constructor(m,o){this._extHostLanguageFeatures=o,this._linkProvider=new r,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=m.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,o,d,E={},v){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(S,d),this._enableProposedApi.set(S,v!=null?v:!1);let u=2;E.isCaseSensitive&&(u+=1024),E.isReadonly&&(u+=2048),typeof d.copy=="function"&&(u+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(S,o,u).catch(h=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${o}`),console.error(h)});const c=d.onDidChangeFile(h=>{const t=[];for(const n of h){let{uri:s,type:i}=n;if(s.scheme===o){let a;switch(i){case A.FileChangeType.Changed:a=0;break;case A.FileChangeType.Created:a=1;break;case A.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:a})}}this._proxy.$onFileSystemChange(S,t)});return(0,I.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(S),this._enableProposedApi.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(m,o){const{type:d,ctime:E,mtime:v,size:S,permissions:u}=m;return o?{type:d,ctime:E,mtime:v,size:S,permissions:u}:{type:d,ctime:E,mtime:v,size:S}}$stat(m,o){return Promise.resolve(this._getFsProvider(m).stat(b.URI.revive(o))).then(d=>{var E;return P._asIStat(d,(E=this._enableProposedApi.get(m))!==null&&E!==void 0?E:!1)})}$readdir(m,o){return Promise.resolve(this._getFsProvider(m).readDirectory(b.URI.revive(o)))}$readFile(m,o){return Promise.resolve(this._getFsProvider(m).readFile(b.URI.revive(o))).then(d=>k.VSBuffer.wrap(d))}$writeFile(m,o,d,E){return Promise.resolve(this._getFsProvider(m).writeFile(b.URI.revive(o),d.buffer,E))}$delete(m,o,d){return Promise.resolve(this._getFsProvider(m).delete(b.URI.revive(o),d))}$rename(m,o,d,E){return Promise.resolve(this._getFsProvider(m).rename(b.URI.revive(o),b.URI.revive(d),E))}$copy(m,o,d,E){const v=this._getFsProvider(m);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(b.URI.revive(o),b.URI.revive(d),E))}$mkdir(m,o){return Promise.resolve(this._getFsProvider(m).createDirectory(b.URI.revive(o)))}$watch(m,o,d,E){const v=this._getFsProvider(m).watch(b.URI.revive(d),E);this._watches.set(o,v)}$unwatch(m,o){const d=this._watches.get(o);d&&(d.dispose(),this._watches.delete(o))}$open(m,o,d){const E=this._getFsProvider(m);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(b.URI.revive(o),d))}$close(m,o){const d=this._getFsProvider(m);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(o))}$read(m,o,d,E){const v=this._getFsProvider(m);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(E);return Promise.resolve(v.read(o,d,S.buffer,0,E)).then(u=>S.slice(0,u))}$write(m,o,d,E){const v=this._getFsProvider(m);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(o,d,E.buffer,0,E.byteLength))}_getFsProvider(m){const o=this._fsProvider.get(m);if(!o){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return o}}e.ExtHostFileSystem=P}),define(me[90],ge([0,1,5,44,7,23,4,15,62]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Mt{constructor(P,f){const m=P.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return m.$stat(o).catch(Mt._handleError)},readDirectory(o){return m.$readdir(o).catch(Mt._handleError)},createDirectory(o){return m.$mkdir(o).catch(Mt._handleError)},async readFile(o){return m.$readFile(o).then(d=>d.buffer).catch(Mt._handleError)},writeFile(o,d){return m.$writeFile(o,A.VSBuffer.wrap(d)).catch(Mt._handleError)},delete(o,d){return m.$delete(o,Object.assign({recursive:!1,useTrash:!1},d)).catch(Mt._handleError)},rename(o,d,E){return m.$rename(o,d,Object.assign({overwrite:!1},E)).catch(Mt._handleError)},copy(o,d,E){return m.$copy(o,d,Object.assign({overwrite:!1},E)).catch(Mt._handleError)},isWritableFileSystem(o){const d=f.getCapabilities(o);if(typeof d=="number")return!(d&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new I.FileSystemError(String(P));if(P.name==="ENOPRO")throw I.FileSystemError.Unavailable(P.message);switch(P.name){case R.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(P.message);case R.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(P.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(P.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(P.message);case R.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(P.message);case R.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(P.message);default:throw new I.FileSystemError(P.message,P.name)}}};k=qe([He(0,C.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(me[232],ge([0,1,6,5]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(y){this._handlePool=0,this._proxy=y.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=I}),define(me[233],ge([0,1,2,24,20,7,13,5,8,43,16,11,139,6,109,73,86,45,17]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(V,X){this._documents=V,this._provider=X}provideDocumentSymbols(V,X){const Z=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(Z,X)).then(se=>{if(!(0,r.isFalsyOrEmpty)(se))return se[0]instanceof A.DocumentSymbol?se.map(I.DocumentSymbol.from):u._asDocumentSymbolTree(se)})}static _asDocumentSymbolTree(V){var X;V=V.slice(0).sort((fe,Ee)=>{let Be=fe.location.range.start.compareTo(Ee.location.range.start);return Be===0&&(Be=Ee.location.range.end.compareTo(fe.location.range.end)),Be});const Z=[],se=[];for(const fe of V){const Ee={name:fe.name||"!!MISSING: name!!",kind:I.SymbolKind.from(fe.kind),tags:((X=fe.tags)===null||X===void 0?void 0:X.map(I.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:I.Range.from(fe.location.range),selectionRange:I.Range.from(fe.location.range),children:[]};for(;;){if(se.length===0){se.push(Ee),Z.push(Ee);break}const Be=se[se.length-1];if(k.Range.containsRange(Be.range,Ee.range)&&!k.Range.equalsRange(Be.range,Ee.range)){Be.children&&Be.children.push(Ee),se.push(Ee);break}se.pop()}}return Z}}class c{constructor(V,X,Z){this._documents=V,this._commands=X,this._provider=Z,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,X){const Z=this._documents.getDocument(V),se=await this._provider.provideCodeLenses(Z,X);if(!(!se||X.isCancellationRequested)){const fe=this._cache.add(se),Ee=new m.DisposableStore;this._disposables.set(fe,Ee);const Be={cacheId:fe,lenses:[]};for(let pe=0;pe<se.length;pe++)Be.lenses.push({cacheId:[fe,pe],range:I.Range.from(se[pe].range),command:this._commands.toInternal(se[pe].command,Ee)});return Be}}async resolveCodeLens(V,X){var Z;const se=V.cacheId&&this._cache.get(...V.cacheId);if(!!se){let fe;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?fe=se:fe=await this._provider.resolveCodeLens(se,X),fe||(fe=se),!X.isCancellationRequested){const Ee=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!Ee)return V.command=this._commands.toInternal((Z=fe.command)!==null&&Z!==void 0?Z:c._badCmd,Ee),V}}}releaseCodeLenses(V){var X;(X=this._disposables.get(V))===null||X===void 0||X.dispose(),this._disposables.delete(V),this._cache.delete(V)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function h(Oe){return Array.isArray(Oe)?Oe.map(I.DefinitionLink.from):Oe?[I.DefinitionLink.from(Oe)]:[]}class t{constructor(V,X){this._documents=V,this._provider=X}provideDefinition(V,X,Z){const se=this._documents.getDocument(V),fe=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideDefinition(se,fe,Z)).then(h)}}class n{constructor(V,X){this._documents=V,this._provider=X}provideDeclaration(V,X,Z){const se=this._documents.getDocument(V),fe=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideDeclaration(se,fe,Z)).then(h)}}class s{constructor(V,X){this._documents=V,this._provider=X}provideImplementation(V,X,Z){const se=this._documents.getDocument(V),fe=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideImplementation(se,fe,Z)).then(h)}}class i{constructor(V,X){this._documents=V,this._provider=X}provideTypeDefinition(V,X,Z){const se=this._documents.getDocument(V),fe=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(se,fe,Z)).then(h)}}class a{constructor(V,X){this._documents=V,this._provider=X}provideHover(V,X,Z){const se=this._documents.getDocument(V),fe=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideHover(se,fe,Z)).then(Ee=>{if(!(!Ee||(0,r.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=se.getWordRangeAtPosition(fe)),Ee.range||(Ee.range=new A.Range(fe,fe)),I.Hover.from(Ee)})}}class p{constructor(V,X){this._documents=V,this._provider=X}provideEvaluatableExpression(V,X,Z){const se=this._documents.getDocument(V),fe=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(se,fe,Z)).then(Ee=>{if(Ee)return I.EvaluatableExpression.from(Ee)})}}class g{constructor(V,X){this._documents=V,this._provider=X}provideInlineValues(V,X,Z,se){const fe=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideInlineValues(fe,I.Range.to(X),I.InlineValueContext.to(Z),se)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(Be=>I.InlineValue.from(Be))})}}class _{constructor(V,X){this._documents=V,this._provider=X}provideDocumentHighlights(V,X,Z){const se=this._documents.getDocument(V),fe=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(se,fe,Z)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(I.DocumentHighlight.from)})}}class l{constructor(V,X){this._documents=V,this._provider=X}provideLinkedEditingRanges(V,X,Z){const se=this._documents.getDocument(V),fe=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(se,fe,Z)).then(Ee=>{if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,r.coalesce)(Ee.ranges.map(I.Range.from)),wordPattern:Ee.wordPattern}})}}class w{constructor(V,X){this._documents=V,this._provider=X}provideReferences(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideReferences(fe,Ee,Z,se)).then(Be=>{if(Array.isArray(Be))return Be.map(I.location.from)})}}class T{constructor(V,X,Z,se,fe,Ee,Be){this._documents=V,this._commands=X,this._diagnostics=Z,this._provider=se,this._logService=fe,this._extension=Ee,this._apiDeprecation=Be,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=f.Selection.isISelection(X)?I.Selection.to(X):I.Range.to(X),Be=[];for(const Ce of this._diagnostics.getDiagnostics(V))if(Ee.intersection(Ce.range)&&Be.push(Ce)>T._maxCodeActionsPerFile)break;const pe={diagnostics:Be,only:Z.only?new A.CodeActionKind(Z.only):void 0,triggerKind:I.CodeActionTriggerKind.to(Z.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(fe,Ee,pe,se)).then(Ce=>{var Me;if(!(!(0,r.isNonEmptyArray)(Ce)||se.isCancellationRequested)){const ze=this._cache.add(Ce),_e=new m.DisposableStore;this._disposables.set(ze,_e);const Ke=[];for(let G=0;G<Ce.length;G++){const te=Ce[G];!te||(T._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,_e)})):(pe.only&&(te.kind?pe.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[ze,G],title:te.title,command:te.command&&this._commands.toInternal(te.command,_e),diagnostics:te.diagnostics&&te.diagnostics.map(I.Diagnostic.from),edit:te.edit&&I.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:(Me=te.disabled)===null||Me===void 0?void 0:Me.reason})))}return{cacheId:ze,actions:Ke}}})}async resolveCodeAction(V,X){var Z;const[se,fe]=V,Ee=this._cache.get(se,fe);if(!(!Ee||T._isCommand(Ee))&&!!this._provider.resolveCodeAction){const Be=(Z=await this._provider.resolveCodeAction(Ee,X))!==null&&Z!==void 0?Z:Ee;return(Be==null?void 0:Be.edit)?I.WorkspaceEdit.from(Be.edit):void 0}}releaseCodeActions(V){var X;(X=this._disposables.get(V))===null||X===void 0||X.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}T._maxCodeActionsPerFile=1e3;class N{constructor(V,X){this._documents=V,this._provider=X}provideDocumentFormattingEdits(V,X,Z){const se=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(se,X,Z)).then(fe=>{if(Array.isArray(fe))return fe.map(I.TextEdit.from)})}}class z{constructor(V,X){this._documents=V,this._provider=X}provideDocumentRangeFormattingEdits(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=I.Range.to(X);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,Ee,Z,se)).then(Be=>{if(Array.isArray(Be))return Be.map(I.TextEdit.from)})}}class ne{constructor(V,X){this._documents=V,this._provider=X,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(V,X,Z,se,fe){const Ee=this._documents.getDocument(V),Be=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ee,Be,Z,se,fe)).then(pe=>{if(Array.isArray(pe))return pe.map(I.TextEdit.from)})}}class ie{constructor(V,X){this._provider=V,this._logService=X,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(V,X){const Z=C.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(V,X)).then(se=>{if((0,r.isNonEmptyArray)(se)){for(const fe of se)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const Ee=C.IdObject.mixin(I.WorkspaceSymbol.from(fe));this._symbolCache.set(Ee._id,fe),Z.symbols.push(Ee)}}}).then(()=>(Z.symbols.length>0&&this._resultCache.set(Z._id,[Z.symbols[0]._id,Z.symbols[Z.symbols.length-1]._id]),Z))}async resolveWorkspaceSymbol(V,X){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const Z=this._symbolCache.get(V._id);if(Z){const se=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(Z,X));return se&&(0,R.mixin)(V,I.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(V){const X=this._resultCache.get(V);if(X){for(let[Z,se]=X;Z<=se;Z++)this._symbolCache.delete(Z);this._resultCache.delete(V)}}}class U{constructor(V,X,Z){this._documents=V,this._provider=X,this._logService=Z}static supportsResolving(V){return typeof V.prepareRename=="function"}provideRenameEdits(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(fe,Ee,Z,se)).then(Be=>{if(!!Be)return I.WorkspaceEdit.from(Be)},Be=>{const pe=U._asMessage(Be);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Be)})}resolveRenameLocation(V,X,Z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(V),fe=I.Position.to(X);return(0,y.asPromise)(()=>this._provider.prepareRename(se,fe,Z)).then(Ee=>{let Be,pe;if(A.Range.isRange(Ee)?(Be=Ee,pe=se.getText(Ee)):(0,P.isObject)(Ee)&&(Be=Ee.range,pe=Ee.placeholder),!!Be){if(Be.start.line>fe.line||Be.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Be),text:pe}}},Ee=>{const Be=U._asMessage(Ee);return Be?{rejectReason:Be,range:void 0,text:void 0}:Promise.reject(Ee)})}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class B{constructor(V,X){this.resultId=V,this.tokens=X}}class x{constructor(V,X){this._documents=V,this._provider=X,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(V,X,Z){const se=this._documents.getDocument(V),fe=X!==0?this._previousResults.get(X):null;return(0,y.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(se,fe.resultId,Z):this._provider.provideDocumentSemanticTokens(se,Z)).then(Ee=>(fe&&this._previousResults.delete(X),Ee?(Ee=x._fixProvidedSemanticTokens(Ee),this._send(x._convertToEdits(fe,Ee),Ee)):null))}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return x._isSemanticTokens(V)?x._isCorrectSemanticTokens(V)?V:new A.SemanticTokens(new Uint32Array(V.data),V.resultId):x._isSemanticTokensEdits(V)?x._isCorrectSemanticTokensEdits(V)?V:new A.SemanticTokensEdits(V.edits.map(X=>new A.SemanticTokensEdit(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const X of V.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,X){if(!x._isSemanticTokens(X)||!V||!V.tokens)return X;const Z=V.tokens,se=Z.length,fe=X.data,Ee=fe.length;let Be=0;const pe=Math.min(se,Ee);for(;Be<pe&&Z[Be]===fe[Be];)Be++;if(Be===se&&Be===Ee)return new A.SemanticTokensEdits([],X.resultId);let Ce=0;const Me=pe-Be;for(;Ce<Me&&Z[se-Ce-1]===fe[Ee-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Be,deleteCount:se-Be-Ce,data:fe.subarray(Be,Ee-Ce)}],X.resultId)}_send(V,X){if(x._isSemanticTokens(V)){const Z=this._nextResultId++;return this._previousResults.set(Z,new B(V.resultId,V.data)),(0,o.encodeSemanticTokensDto)({id:Z,type:"full",data:V.data})}if(x._isSemanticTokensEdits(V)){const Z=this._nextResultId++;return x._isSemanticTokens(X)?this._previousResults.set(Z,new B(X.resultId,X.data)):this._previousResults.set(Z,new B(V.resultId)),(0,o.encodeSemanticTokensDto)({id:Z,type:"delta",deltas:(V.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class L{constructor(V,X){this._documents=V,this._provider=X}provideDocumentRangeSemanticTokens(V,X,Z){const se=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(se,I.Range.to(X),Z)).then(fe=>fe?this._send(fe):null)}_send(V){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=L;class O{constructor(V,X,Z,se,fe){this._documents=V,this._commands=X,this._provider=Z,this._apiDeprecation=se,this._extension=fe,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=I.Position.to(X),Be=fe.getWordRangeAtPosition(Ee)||new A.Range(Ee,Ee),pe=Be.with({end:Ee}),Ce=new v.StopWatch(!0),Me=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(fe,Ee,se,I.CompletionContext.to(Z)));if(!!Me&&!se.isCancellationRequested){const ze=Array.isArray(Me)?new A.CompletionList(Me):Me,_e=O.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),Ke=new m.DisposableStore;this._disposables.set(_e,Ke);const G=[],te={x:_e,b:G,a:{replace:I.Range.from(Be),insert:I.Range.from(pe)},c:ze.isIncomplete||void 0,d:Ce.elapsed()};for(let we=0;we<ze.items.length;we++){const xe=ze.items[we],je=this._convertCompletionItem(xe,[_e,we],pe,Be);G.push(je)}return te}}async resolveCompletionItem(V,X){if(typeof this._provider.resolveCompletionItem=="function"){const Z=this._cache.get(...V);if(!!Z){const se=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(Z,X));if(!!se)return this._convertCompletionItem(se,V)}}}releaseCompletionItems(V){var X;(X=this._disposables.get(V))===null||X===void 0||X.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,X,Z,se){var fe;const Ee=this._disposables.get(X[0]);if(!Ee)throw Error("DisposableStore is missing...");const Be={x:X,a:(fe=V.label)!==null&&fe!==void 0?fe:"",o:V.label2,b:V.kind!==void 0?I.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(I.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(V.command,Ee)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Be.h=V.textEdit.newText):typeof V.insertText=="string"?Be.h=V.insertText:V.insertText instanceof A.SnippetString&&(Be.h=V.insertText.value,Be.i|=4);let pe;return V.textEdit?pe=V.textEdit.range:V.range&&(pe=V.range),A.Range.isRange(pe)?Be.j=I.Range.from(pe):pe&&(!(Z==null?void 0:Z.isEqual(pe.inserting))||!(se==null?void 0:se.isEqual(pe.replacing)))&&(Be.j={insert:I.Range.from(pe.inserting),replace:I.Range.from(pe.replacing)}),Be}}class F{constructor(V,X){this._documents=V,this._provider=X,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=I.Position.to(X),Be=this.reviveContext(Z);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(fe,Ee,se,Be)).then(pe=>{if(pe){const Ce=this._cache.add([pe]);return Object.assign(Object.assign({},I.SignatureHelp.from(pe)),{id:Ce})}})}reviveContext(V){let X;if(V.activeSignatureHelp){const Z=I.SignatureHelp.to(V.activeSignatureHelp),se=this._cache.get(V.activeSignatureHelp.id,0);se?(X=se,X.activeSignature=Z.activeSignature,X.activeParameter=Z.activeParameter):X=Z}return Object.assign(Object.assign({},V),{activeSignatureHelp:X})}releaseSignatureHelp(V){this._cache.delete(V)}}class M{constructor(V,X){this._documents=V,this._provider=X}provideInlayHints(V,X,Z){const se=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideInlayHints(se,I.Range.to(X),Z)).then(fe=>fe?{hints:fe.map(I.InlayHint.from)}:void 0)}}class W{constructor(V,X){this._documents=V,this._provider=X,this._cache=new E.Cache("DocumentLink")}provideLinks(V,X){const Z=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(Z,X)).then(se=>{if(!(!Array.isArray(se)||se.length===0)&&!X.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.map(I.DocumentLink.from)};{const fe=this._cache.add(se),Ee={links:[],id:fe};for(let Be=0;Be<se.length;Be++){const pe=I.DocumentLink.from(se[Be]);pe.cacheId=[fe,Be],Ee.links.push(pe)}return Ee}}})}resolveLink(V,X){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const Z=this._cache.get(...V);return Z?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(Z,X)).then(se=>se&&I.DocumentLink.from(se)||void 0):Promise.resolve(void 0)}releaseLinks(V){this._cache.delete(V)}}class q{constructor(V,X){this._documents=V,this._provider=X}provideColors(V,X){const Z=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(Z,X)).then(se=>Array.isArray(se)?se.map(Ee=>({color:I.Color.from(Ee.color),range:I.Range.from(Ee.range)})):[])}provideColorPresentations(V,X,Z){const se=this._documents.getDocument(V),fe=I.Range.to(X.range),Ee=I.Color.to(X.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Ee,{document:se,range:fe},Z)).then(Be=>{if(!!Array.isArray(Be))return Be.map(I.ColorPresentation.from)})}}class K{constructor(V,X){this._documents=V,this._provider=X}provideFoldingRanges(V,X,Z){const se=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(se,X,Z)).then(fe=>{if(!!Array.isArray(fe))return fe.map(I.FoldingRange.from)})}}class le{constructor(V,X,Z){this._documents=V,this._provider=X,this._logService=Z}provideSelectionRanges(V,X,Z){const se=this._documents.getDocument(V),fe=X.map(I.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(se,fe,Z)).then(Ee=>{if(!(0,r.isNonEmptyArray)(Ee))return[];if(Ee.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Be=[];for(let pe=0;pe<fe.length;pe++){const Ce=[];Be.push(Ce);let Me=fe[pe],ze=Ee[pe];for(;;){if(!ze.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(I.SelectionRange.from(ze)),!ze.parent)break;Me=ze.range,ze=ze.parent}}return Be})}}class ve{constructor(V,X){this._documents=V,this._provider=X,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(V,X,Z){const se=this._documents.getDocument(V),fe=I.Position.to(X),Ee=await this._provider.prepareCallHierarchy(se,fe,Z);if(!!Ee){const Be=this._idPool.nextId();return this._cache.set(Be,new Map),Array.isArray(Ee)?Ee.map(pe=>this._cacheAndConvertItem(Be,pe)):[this._cacheAndConvertItem(Be,Ee)]}}async provideCallsTo(V,X,Z){const se=this._itemFromCache(V,X);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(se,Z);if(!!fe)return fe.map(Ee=>({from:this._cacheAndConvertItem(V,Ee.from),fromRanges:Ee.fromRanges.map(Be=>I.Range.from(Be))}))}async provideCallsFrom(V,X,Z){const se=this._itemFromCache(V,X);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(se,Z);if(!!fe)return fe.map(Ee=>({to:this._cacheAndConvertItem(V,Ee.to),fromRanges:Ee.fromRanges.map(Be=>I.Range.from(Be))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,X){var Z;const se=this._cache.get(V),fe={_sessionId:V,_itemId:se.size.toString(36),name:X.name,detail:X.detail,kind:I.SymbolKind.from(X.kind),uri:X.uri,range:I.Range.from(X.range),selectionRange:I.Range.from(X.selectionRange),tags:(Z=X.tags)===null||Z===void 0?void 0:Z.map(I.SymbolTag.from)};return se.set(fe._itemId,X),fe}_itemFromCache(V,X){const Z=this._cache.get(V);return Z==null?void 0:Z.get(X)}}class Re{constructor(V,X){this.adapter=V,this.extension=X}}class Se{constructor(V,X,Z,se,fe,Ee,Be){this._adapter=new Map,this._uriTransformer=X,this._proxy=V.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=Z,this._commands=se,this._diagnostics=fe,this._logService=Ee,this._apiDeprecation=Be}_transformDocumentSelector(V){return(0,r.coalesce)((0,r.asArray)(V).map(X=>this._doTransformDocumentSelector(X)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:I.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new A.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return Se._handlePool++}_withAdapter(V,X,Z,se,fe=!1){const Ee=this._adapter.get(V);if(!Ee)return Promise.resolve(se);if(Ee.adapter instanceof X){let Be;Ee.extension&&(Be=Date.now(),this._logService.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${X.name}'`));const pe=Z(Ee.adapter,Ee.extension),Ce=Ee.extension;return Ce&&Promise.resolve(pe).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Be}ms`),Me=>{fe&&Me instanceof S.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Me))}),pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,X){const Z=this._nextHandle();return this._adapter.set(Z,new Re(V,X)),Z}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,X,Z,se){const fe=this._addNewAdapter(new u(this._documents,Z),V),Ee=se&&se.label||Se._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(X),Ee),this._createDisposable(fe)}$provideDocumentSymbols(V,X,Z){return this._withAdapter(V,u,se=>se.provideDocumentSymbols(b.URI.revive(X),Z),void 0)}registerCodeLensProvider(V,X,Z){const se=this._nextHandle(),fe=typeof Z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Re(new c(this._documents,this._commands.converter,Z),V)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(X),fe);let Ee=this._createDisposable(se);if(fe!==void 0){const Be=Z.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(fe));Ee=A.Disposable.from(Ee,Be)}return Ee}$provideCodeLenses(V,X,Z){return this._withAdapter(V,c,se=>se.provideCodeLenses(b.URI.revive(X),Z),void 0)}$resolveCodeLens(V,X,Z){return this._withAdapter(V,c,se=>se.resolveCodeLens(X,Z),void 0)}$releaseCodeLenses(V,X){this._withAdapter(V,c,Z=>Promise.resolve(Z.releaseCodeLenses(X)),void 0)}registerDefinitionProvider(V,X,Z){const se=this._addNewAdapter(new t(this._documents,Z),V);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideDefinition(V,X,Z,se){return this._withAdapter(V,t,fe=>fe.provideDefinition(b.URI.revive(X),Z,se),[])}registerDeclarationProvider(V,X,Z){const se=this._addNewAdapter(new n(this._documents,Z),V);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideDeclaration(V,X,Z,se){return this._withAdapter(V,n,fe=>fe.provideDeclaration(b.URI.revive(X),Z,se),[])}registerImplementationProvider(V,X,Z){const se=this._addNewAdapter(new s(this._documents,Z),V);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideImplementation(V,X,Z,se){return this._withAdapter(V,s,fe=>fe.provideImplementation(b.URI.revive(X),Z,se),[])}registerTypeDefinitionProvider(V,X,Z){const se=this._addNewAdapter(new i(this._documents,Z),V);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideTypeDefinition(V,X,Z,se){return this._withAdapter(V,i,fe=>fe.provideTypeDefinition(b.URI.revive(X),Z,se),[])}registerHoverProvider(V,X,Z,se){const fe=this._addNewAdapter(new a(this._documents,Z),V);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(X)),this._createDisposable(fe)}$provideHover(V,X,Z,se){return this._withAdapter(V,a,fe=>fe.provideHover(b.URI.revive(X),Z,se),void 0)}registerEvaluatableExpressionProvider(V,X,Z,se){const fe=this._addNewAdapter(new p(this._documents,Z),V);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(X)),this._createDisposable(fe)}$provideEvaluatableExpression(V,X,Z,se){return this._withAdapter(V,p,fe=>fe.provideEvaluatableExpression(b.URI.revive(X),Z,se),void 0)}registerInlineValuesProvider(V,X,Z,se){const fe=typeof Z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new g(this._documents,Z),V);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(X),fe);let Be=this._createDisposable(Ee);if(fe!==void 0){const pe=Z.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(fe));Be=A.Disposable.from(Be,pe)}return Be}$provideInlineValues(V,X,Z,se,fe){return this._withAdapter(V,g,Ee=>Ee.provideInlineValues(b.URI.revive(X),Z,se,fe),void 0)}registerDocumentHighlightProvider(V,X,Z){const se=this._addNewAdapter(new _(this._documents,Z),V);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideDocumentHighlights(V,X,Z,se){return this._withAdapter(V,_,fe=>fe.provideDocumentHighlights(b.URI.revive(X),Z,se),void 0)}registerLinkedEditingRangeProvider(V,X,Z){const se=this._addNewAdapter(new l(this._documents,Z),V);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideLinkedEditingRanges(V,X,Z,se){return this._withAdapter(V,l,async fe=>{const Ee=await fe.provideLinkedEditingRanges(b.URI.revive(X),Z,se);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Se._serializeRegExp(Ee.wordPattern):void 0}},void 0)}registerReferenceProvider(V,X,Z){const se=this._addNewAdapter(new w(this._documents,Z),V);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideReferences(V,X,Z,se,fe){return this._withAdapter(V,w,Ee=>Ee.provideReferences(b.URI.revive(X),Z,se,fe),void 0)}registerCodeActionProvider(V,X,Z,se){var fe,Ee;const Be=new m.DisposableStore,pe=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,Z,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(X),{providedKinds:(fe=se==null?void 0:se.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ce=>Ce.value),documentation:(Ee=se==null?void 0:se.documentation)===null||Ee===void 0?void 0:Ee.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Be)}))},Se._extLabel(V),Boolean(Z.resolveCodeAction)),Be.add(this._createDisposable(pe)),Be}$provideCodeActions(V,X,Z,se,fe){return this._withAdapter(V,T,Ee=>Ee.provideCodeActions(b.URI.revive(X),Z,se,fe),void 0)}$resolveCodeAction(V,X,Z){return this._withAdapter(V,T,se=>se.resolveCodeAction(X,Z),void 0)}$releaseCodeActions(V,X){this._withAdapter(V,T,Z=>Promise.resolve(Z.releaseCodeActions(X)),void 0)}registerDocumentFormattingEditProvider(V,X,Z){const se=this._addNewAdapter(new N(this._documents,Z),V);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(X),V.identifier,V.displayName||V.name),this._createDisposable(se)}$provideDocumentFormattingEdits(V,X,Z,se){return this._withAdapter(V,N,fe=>fe.provideDocumentFormattingEdits(b.URI.revive(X),Z,se),void 0)}registerDocumentRangeFormattingEditProvider(V,X,Z){const se=this._addNewAdapter(new z(this._documents,Z),V);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(X),V.identifier,V.displayName||V.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(V,X,Z,se,fe){return this._withAdapter(V,z,Ee=>Ee.provideDocumentRangeFormattingEdits(b.URI.revive(X),Z,se,fe),void 0)}registerOnTypeFormattingEditProvider(V,X,Z,se){const fe=this._addNewAdapter(new ne(this._documents,Z),V);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(X),se,V.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(V,X,Z,se,fe,Ee){return this._withAdapter(V,ne,Be=>Be.provideOnTypeFormattingEdits(b.URI.revive(X),Z,se,fe,Ee),void 0)}registerWorkspaceSymbolProvider(V,X){const Z=this._addNewAdapter(new ie(X,this._logService),V);return this._proxy.$registerNavigateTypeSupport(Z),this._createDisposable(Z)}$provideWorkspaceSymbols(V,X,Z){return this._withAdapter(V,ie,se=>se.provideWorkspaceSymbols(X,Z),{symbols:[]})}$resolveWorkspaceSymbol(V,X,Z){return this._withAdapter(V,ie,se=>se.resolveWorkspaceSymbol(X,Z),void 0)}$releaseWorkspaceSymbols(V,X){this._withAdapter(V,ie,Z=>Z.releaseWorkspaceSymbols(X),void 0)}registerRenameProvider(V,X,Z){const se=this._addNewAdapter(new U(this._documents,Z,this._logService),V);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(X),U.supportsResolving(Z)),this._createDisposable(se)}$provideRenameEdits(V,X,Z,se,fe){return this._withAdapter(V,U,Ee=>Ee.provideRenameEdits(b.URI.revive(X),Z,se,fe),void 0)}$resolveRenameLocation(V,X,Z,se){return this._withAdapter(V,U,fe=>fe.resolveRenameLocation(b.URI.revive(X),Z,se),void 0)}registerDocumentSemanticTokensProvider(V,X,Z,se){const fe=this._nextHandle(),Ee=typeof Z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Re(new x(this._documents,Z),V)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(X),se,Ee);let Be=this._createDisposable(fe);if(Ee){const pe=Z.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Be=A.Disposable.from(Be,pe)}return Be}$provideDocumentSemanticTokens(V,X,Z,se){return this._withAdapter(V,x,fe=>fe.provideDocumentSemanticTokens(b.URI.revive(X),Z,se),null,!0)}$releaseDocumentSemanticTokens(V,X){this._withAdapter(V,x,Z=>Z.releaseDocumentSemanticColoring(X),void 0)}registerDocumentRangeSemanticTokensProvider(V,X,Z,se){const fe=this._addNewAdapter(new L(this._documents,Z),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(X),se),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(V,X,Z,se){return this._withAdapter(V,L,fe=>fe.provideDocumentRangeSemanticTokens(b.URI.revive(X),Z,se),null,!0)}registerCompletionItemProvider(V,X,Z,se){const fe=this._addNewAdapter(new O(this._documents,this._commands.converter,Z,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(X),se,O.supportsResolving(Z),`${V.identifier.value}(${se.join("")})`),this._createDisposable(fe)}$provideCompletionItems(V,X,Z,se,fe){return this._withAdapter(V,O,Ee=>Ee.provideCompletionItems(b.URI.revive(X),Z,se,fe),void 0)}$resolveCompletionItem(V,X,Z){return this._withAdapter(V,O,se=>se.resolveCompletionItem(X,Z),void 0)}$releaseCompletionItems(V,X){this._withAdapter(V,O,Z=>Z.releaseCompletionItems(X),void 0)}registerSignatureHelpProvider(V,X,Z,se){const fe=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,Ee=this._addNewAdapter(new F(this._documents,Z),V);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(X),fe),this._createDisposable(Ee)}$provideSignatureHelp(V,X,Z,se,fe){return this._withAdapter(V,F,Ee=>Ee.provideSignatureHelp(b.URI.revive(X),Z,se,fe),void 0)}$releaseSignatureHelp(V,X){this._withAdapter(V,F,Z=>Z.releaseSignatureHelp(X),void 0)}registerInlayHintsProvider(V,X,Z){const se=typeof Z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new M(this._documents,Z),V);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(X),se);let Ee=this._createDisposable(fe);if(se!==void 0){const Be=Z.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(se));Ee=A.Disposable.from(Ee,Be)}return Ee}$provideInlayHints(V,X,Z,se){return this._withAdapter(V,M,fe=>fe.provideInlayHints(b.URI.revive(X),Z,se),void 0)}registerDocumentLinkProvider(V,X,Z){const se=this._addNewAdapter(new W(this._documents,Z),V);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(X),typeof Z.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(V,X,Z){return this._withAdapter(V,W,se=>se.provideLinks(b.URI.revive(X),Z),void 0)}$resolveDocumentLink(V,X,Z){return this._withAdapter(V,W,se=>se.resolveLink(X,Z),void 0)}$releaseDocumentLinks(V,X){this._withAdapter(V,W,Z=>Z.releaseLinks(X),void 0)}registerColorProvider(V,X,Z){const se=this._addNewAdapter(new q(this._documents,Z),V);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideDocumentColors(V,X,Z){return this._withAdapter(V,q,se=>se.provideColors(b.URI.revive(X),Z),[])}$provideColorPresentations(V,X,Z,se){return this._withAdapter(V,q,fe=>fe.provideColorPresentations(b.URI.revive(X),Z,se),void 0)}registerFoldingRangeProvider(V,X,Z){const se=this._nextHandle(),fe=typeof Z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Re(new K(this._documents,Z),V)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(X),fe);let Ee=this._createDisposable(se);if(fe!==void 0){const Be=Z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Ee=A.Disposable.from(Ee,Be)}return Ee}$provideFoldingRanges(V,X,Z,se){return this._withAdapter(V,K,fe=>fe.provideFoldingRanges(b.URI.revive(X),Z,se),void 0)}registerSelectionRangeProvider(V,X,Z){const se=this._addNewAdapter(new le(this._documents,Z,this._logService),V);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideSelectionRanges(V,X,Z,se){return this._withAdapter(V,le,fe=>fe.provideSelectionRanges(b.URI.revive(X),Z,se),[])}registerCallHierarchyProvider(V,X,Z){const se=this._addNewAdapter(new ve(this._documents,Z),V);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$prepareCallHierarchy(V,X,Z,se){return this._withAdapter(V,ve,fe=>Promise.resolve(fe.prepareSession(b.URI.revive(X),Z,se)),void 0)}$provideCallHierarchyIncomingCalls(V,X,Z,se){return this._withAdapter(V,ve,fe=>fe.provideCallsTo(X,Z,se),void 0)}$provideCallHierarchyOutgoingCalls(V,X,Z,se){return this._withAdapter(V,ve,fe=>fe.provideCallsFrom(X,Z,se),void 0)}$releaseCallHierarchy(V,X){this._withAdapter(V,ve,Z=>Promise.resolve(Z.releaseSession(X)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,D.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:Se._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:Se._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Se._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Se._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:Se._serializeRegExp(V.beforeText),afterText:V.afterText?Se._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?Se._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(Se._serializeOnEnterRule)}setLanguageConfiguration(V,X,Z){let{wordPattern:se}=Z;if(se&&(0,D.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(X,se):this._documents.setWordDefinitionFor(X,void 0),Z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const fe=this._nextHandle(),Ee={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?Se._serializeRegExp(Z.wordPattern):void 0,indentationRules:Z.indentationRules?Se._serializeIndentationRule(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?Se._serializeOnEnterRules(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,X,Ee),this._createDisposable(fe)}$setWordDefinitions(V){for(const X of V)this._documents.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.ExtHostLanguageFeatures=Se,Se._handlePool=0}),define(me[234],ge([0,1,5,20,7]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(C,D){this._proxy=C.getProxy(b.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,D){await this._proxy.$changeLanguage(C,D);const k=this._documents.getDocumentData(C);if(!k)throw new Error(`document '${C.toString}' NOT found`);return k.document}async tokenAtPosition(C,D){var k;const r=C.version,P=R.Position.from(D),f=await this._proxy.$tokensAtPosition(C.uri,P),m={type:I.StandardTokenType.Other,range:(k=C.getWordRangeAtPosition(D))!==null&&k!==void 0?k:new I.Range(D.line,D.character,D.line,D.character)};if(!f)return m;const o={range:R.Range.to(f.range),type:R.TokenType.to(f.type)};return!o.range.contains(D)||r!==C.version?m:o}}e.ExtHostLanguages=A}),define(me[235],ge([0,1,5,14,40]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(C){return C&&C.title}let y=class{constructor(D,k){this._logService=k,this._proxy=D.getProxy(b.MainContext.MainThreadMessageService)}showMessage(D,k,r,P,f){const m={extension:D};let o;typeof P=="string"||A(P)?o=[P,...f]:(m.modal=P&&P.modal,m.useCustom=P&&P.useCustom,o=f),m.useCustom&&(0,I.checkProposedApiEnabled)(D);const d=[];for(let E=0;E<o.length;E++){const v=o[E];if(typeof v=="string")d.push({title:v,handle:E,isCloseAffordance:!1});else if(typeof v=="object"){let{title:S,isCloseAffordance:u}=v;d.push({title:S,isCloseAffordance:!!u,handle:E})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(k,r,m,d).then(E=>{if(typeof E=="number")return o[E]})}};y=qe([He(1,R.ILogService)],y),e.ExtHostMessageService=y}),define(me[236],ge([0,1,23,3,75,73,6,22,8,11,2,86,5,20,7,64,212,213]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class S{constructor(h,t){const n=S._Keys.nextId();h.$registerNotebookEditorDecorationType(n,m.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){h.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=S,S._Keys=new A.IdGenerator("NotebookEditorDecorationType");class u{constructor(h,t,n,s,i,a){this._textDocumentsAndEditors=n,this._textDocuments=s,this.logService=i,this._extensionStoragePaths=a,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=h.getProxy(f.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(f.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(f.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:p=>{var g;if(p&&p.$mid===12){const _=(g=p.notebookEditor)===null||g===void 0?void 0:g.notebookUri,l=p.cell.handle,w=this._documents.get(_),T=w==null?void 0:w.getCell(l);if(T)return T.apiCell}return p}})}get activeNotebookEditor(){var h;return(h=this._activeNotebookEditor)===null||h===void 0?void 0:h.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}getEditorById(h){return this._editors.get(h)}getIdByEditor(h){for(const[t,n]of this._editors)if(n.apiEditor===h)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,t){const n=this._documents.get(h);if(!n&&!t)throw new Error(`NO notebook document for '${h}'`);return n}_getProviderData(h){const t=this._notebookContentProviders.get(h);if(!t)throw new Error(`NO provider for '${h}'`);return t}registerNotebookContentProvider(h,t,n,s,i){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:h,provider:n});let a;return n.onDidChangeNotebookContentOptions&&(a=n.onDidChangeNotebookContentOptions(()=>{const p=m.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,p)})),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},t,m.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(h,i)),new o.Disposable(()=>{a==null||a.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(h,t){if(!!t){const n=t.filenamePattern.map(s=>m.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(h,t,n){const s=u._notebookStatusBarItemProviderHandlePool++,i=typeof n.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,i,t);let a;return i!==void 0&&(a=n.onDidChangeCellStatusBarItems(p=>this._notebookProxy.$emitCellStatusBarEvent(i))),new o.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,i),a&&a.dispose()})}createNotebookEditorDecorationType(h){return new S(this._notebookEditorsProxy,h).value}async openNotebookDocument(h){const t=this._documents.get(h);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenDocument(h),s=this._documents.get(r.URI.revive(n));return(0,k.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(h,t){var n;r.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let s;typeof t=="object"?s={position:m.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(m.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.viewType,s),a=i&&((n=this._editors.get(i))===null||n===void 0?void 0:n.apiEditor);if(a)return a;throw i?new Error(`Could NOT open editor for "${h.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.toString()}".`)}async $provideNotebookCellStatusBarItems(h,t,n,s){var i;const a=this._notebookStatusBarItemProviders.get(h),p=r.URI.revive(t),g=this._documents.get(p);if(!(!g||!a)){const _=g.getCellFromIndex(n);if(!!_){const l=await a.provideCellStatusBarItems(_.apiCell,s);if(!!l){const w=new y.DisposableStore,T=this._statusBarCache.add([w]),N=(i=l&&l.map(z=>m.NotebookStatusBarItem.from(z,this._commandsConverter,w)))!==null&&i!==void 0?i:void 0;return{cacheId:T,items:N}}}}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,t,n,s,i){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,n),this._notebookProxy.$registerNotebookSerializer(a,{id:h.identifier,location:h.extensionLocation},t,m.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(h,i)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(h,t,n){const s=this._notebookSerializer.get(h);if(!s)throw new Error("NO serializer found");const i=await s.deserializeNotebook(t.buffer,n),a={metadata:m.NotebookDocumentMetadata.from(i.metadata),cells:[]};for(let p of i.cells)o.NotebookCellData.validate(p),a.cells.push(m.NotebookCellData.from(p));return a}async $notebookToData(h,t,n){const s=this._notebookSerializer.get(h);if(!s)throw new Error("NO serializer found");const i=await s.serializeNotebook({metadata:m.NotebookDocumentMetadata.to(t.metadata),cells:t.cells.map(m.NotebookCellData.to)},n);return b.VSBuffer.wrap(i)}async $openNotebook(h,t,n,s,i){const{provider:a}=this._getProviderData(h),p=await a.openNotebook(r.URI.revive(t),{backupId:n,untitledDocumentData:s==null?void 0:s.buffer},i);return{metadata:m.NotebookDocumentMetadata.from(p.metadata),cells:p.cells.map(m.NotebookCellData.from)}}async $saveNotebook(h,t,n){const s=this.getNotebookDocument(r.URI.revive(t)),{provider:i}=this._getProviderData(h);return await i.saveNotebook(s.apiNotebook,n),!0}async $saveNotebookAs(h,t,n,s){const i=this.getNotebookDocument(r.URI.revive(t)),{provider:a}=this._getProviderData(h);return await a.saveNotebookAs(r.URI.revive(n),i.apiNotebook,s),!0}async $backupNotebook(h,t,n){var s;const i=this.getNotebookDocument(r.URI.revive(t)),a=this._getProviderData(h),p=(s=this._extensionStoragePaths.workspaceValue(a.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(a.extension),g=String((0,I.hash)([i.uri.toString(),this._backupIdPool++])),_=r.URI.joinPath(p,g),l=await a.provider.backupNotebook(i.apiNotebook,{destination:_},n);return i.updateBackup(l),l.id}$acceptModelChanged(h,t,n){this.getNotebookDocument(r.URI.revive(h)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(h,t){const n=this.getNotebookDocument(r.URI.revive(h));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(h){const t=this.getNotebookDocument(r.URI.revive(h));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(h,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",h,t);const n=this._editors.get(h);if(!n)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(m.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(m.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(h){for(const t in h){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(m.ViewColumn.to(h[t]))}}$acceptDocumentPropertiesChanged(h,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",h.path,t);const n=this.getNotebookDocument(r.URI.revive(h));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(h,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new v.ExtHostNotebookEditor(t,this._notebookEditorsProxy,h,n.visibleRanges.map(m.NotebookRange.to),n.selections.map(m.NotebookRange.to),typeof n.viewColumn=="number"?m.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(h){var t,n,s;if(h.removedDocuments)for(const a of h.removedDocuments){const p=r.URI.revive(a),g=this._documents.get(p);g&&(g.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(_=>_.document.uri)}),this._onDidCloseNotebookDocument.fire(g.apiNotebook));for(const _ of this._editors.values())_.notebookData.uri.toString()===p.toString()&&this._editors.delete(_.id)}if(h.addedDocuments){const a=[];for(const p of h.addedDocuments){const g=r.URI.revive(p.uri),_=p.viewType;if(this._documents.has(g))throw new Error(`adding EXISTING notebook ${g} `);const l=this,w=new E.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(T){l._onDidChangeNotebookCells.fire(T)},emitCellOutputsChange(T){l._onDidChangeCellOutputs.fire(T)},emitCellMetadataChange(T){l._onDidChangeCellMetadata.fire(T)},emitCellExecutionStateChange(T){l._onDidChangeCellExecutionState.fire(T)}},_,p.metadata?m.NotebookDocumentMetadata.to(p.metadata):new o.NotebookDocumentMetadata,g);w.acceptModelChanged({versionId:p.versionId,rawEvents:[{kind:d.NotebookCellsChangeType.Initialize,changes:[[0,0,p.cells]]}]},!1),a.push(...p.cells.map(T=>E.ExtHostCell.asModelAddData(w.apiNotebook,T))),(t=this._documents.get(g))===null||t===void 0||t.dispose(),this._documents.set(g,w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this._onDidOpenNotebookDocument.fire(w.apiNotebook)}}if(h.addedEditors)for(const a of h.addedEditors){if(this._editors.has(a.id))return;const p=r.URI.revive(a.documentUri),g=this._documents.get(p);g&&this._createExtHostEditor(g,a.id,a)}const i=[];if(h.removedEditors)for(const a of h.removedEditors){const p=this._editors.get(a);p&&(this._editors.delete(a),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===p.id&&(this._activeNotebookEditor=void 0),i.push(p))}if(h.visibleEditors){this._visibleNotebookEditors=h.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const a=new Set;this._visibleNotebookEditors.forEach(p=>a.add(p.id));for(const p of this._editors.values()){const g=a.has(p.id);p._acceptVisibility(g)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.newActiveEditor===null?this._activeNotebookEditor=void 0:h.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.newActiveEditor)),h.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(me[237],ge([0,1,3,6,5,26,2,20,88,22,13,64,21,16,14]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let d=class{constructor(c,h,t,n){this._mainContext=c,this._initData=h,this._extHostNotebook=t,this._logService=n,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=c.getProxy(I.MainContext.MainThreadNotebookKernels)}createNotebookController(c,h,t,n,s,i){for(let L of this._kernelData.values())if(L.controller.id===h&&A.ExtensionIdentifier.equals(c.identifier,L.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const a=this._handlePool++,p=this;this._logService.trace(`NotebookController[${a}], CREATED by ${c.identifier.value}, ${h}`);const g=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${c.identifier}'`);let _=!1;const l=new R.DisposableStore,w=new b.Emitter,T=new b.Emitter,N={id:`${c.identifier.value}/${h}`,viewType:t,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:n||c.identifier.value,preloads:i?i.map(C.NotebookKernelPreload.from):[]};let z=s!=null?s:g,ne;this._proxy.$addKernel(a,N).catch(L=>{console.log(L),_=!0});let ie=0;const U=()=>{if(!_){const L=++ie;Promise.resolve().then(()=>{L===ie&&this._proxy.$updateKernel(a,N)})}},B=new k.ResourceMap,x={get id(){return h},get viewType(){return N.viewType},onDidChangeNotebookAssociation:w.event,get label(){return N.label},set label(L){var O;N.label=(O=L!=null?L:c.displayName)!==null&&O!==void 0?O:c.name,U()},get detail(){var L;return(L=N.detail)!==null&&L!==void 0?L:""},set detail(L){N.detail=L,U()},get description(){var L;return(L=N.description)!==null&&L!==void 0?L:""},set description(L){N.description=L,U()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(L){N.supportedLanguages=L,U()},get hasExecutionOrder(){var L;return(L=N.hasExecutionOrder)!==null&&L!==void 0?L:!1},set hasExecutionOrder(L){N.hasExecutionOrder=L,U()},get preloads(){return N.preloads?N.preloads.map(C.NotebookKernelPreload.to):[]},get executeHandler(){return z},set executeHandler(L){z=L!=null?L:g},get interruptHandler(){return ne},set interruptHandler(L){ne=L,N.supportsInterrupt=Boolean(L),U()},createNotebookCellExecutionTask(L){if(_)throw new Error("notebook controller is DISPOSED");if(!B.has(L.notebook.uri))throw p._logService.trace(`NotebookController[${a}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(B.keys()).map(O=>O.toString())),new Error(`notebook controller is NOT associated to notebook: ${L.notebook.uri.toString()}`);return p._createNotebookCellExecution(L)},dispose:()=>{_||(this._logService.trace(`NotebookController[${a}], DISPOSED`),_=!0,this._kernelData.delete(a),l.dispose(),w.dispose(),T.dispose(),this._proxy.$removeKernel(a))},onDidReceiveMessage:T.event,postMessage(L,O){return p._proxy.$postMessage(a,O&&p._extHostNotebook.getIdByEditor(O),L)},asWebviewUri(L){return(0,D.asWebviewUri)(Object.assign(Object.assign({},p._initData.environment),{remote:p._initData.remote}),String(a),L)},updateNotebookAffinity(L,O){p._proxy.$updateNotebookPriority(a,L.uri,O)}};return this._kernelData.set(a,{extensionId:c.identifier,controller:x,onDidReceiveMessage:T,onDidChangeSelection:w,associatedNotebooks:B}),x}$acceptNotebookAssociation(c,h,t){const n=this._kernelData.get(c);if(n){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(h));t?n.associatedNotebooks.set(s.uri,!0):n.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,s.uri.toString(),t),n.onDidChangeSelection.fire({selected:t,notebook:s.apiNotebook})}}async $executeCells(c,h,t){const n=this._kernelData.get(c);if(!!n){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(h)),i=[];for(let a of t){const p=s.getCell(a);p&&i.push(p.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,s.uri.toString(),i.length),await n.controller.executeHandler.call(n.controller,i,s.apiNotebook,n.controller)}catch(a){this._logService.error(`NotebookController[${c}] execute cells FAILED`,a),console.error(a)}}}async $cancelCells(c,h,t){var n;const s=this._kernelData.get(c);if(!!s){const i=this._extHostNotebook.getNotebookDocument(y.URI.revive(h));s.controller.interruptHandler&&await s.controller.interruptHandler.call(s.controller,i.apiNotebook);for(let a of t){const p=i.getCell(a);p&&((n=this._activeExecutions.get(p.uri))===null||n===void 0||n.cancel())}}}$acceptKernelMessageFromRenderer(c,h,t){const n=this._kernelData.get(c);if(!!n){const s=this._extHostNotebook.getEditorById(h);if(!s)throw new Error(`send message for UNKNOWN editor: ${h}`);n.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:t}))}}_createNotebookCellExecution(c){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const n=new v(t.notebook,t,this._mainContext.getProxy(I.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(t.uri,n);const s=n.onDidChangeState(()=>{n.state===E.Resolved&&(n.dispose(),s.dispose(),this._activeExecutions.delete(t.uri))});return n.asApiObject()}};d=qe([He(3,o.ILogService)],d),e.ExtHostNotebookKernels=d;var E;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(E||(E={}));class v extends R.Disposable{constructor(c,h,t){super();this._document=c,this._cell=h,this._proxy=t,this._onDidChangeState=new b.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new f.CancellationTokenSource),this._collector=new S(10,n=>this.applyEdits(n)),this._executionOrder=h.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(c){await this._collector.addItem(c)}async applyEdits(c){return this._proxy.$applyEdits(this._document.uri,c,!1)}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(c){const h={editType:9,handle:this._cell.handle,internalMetadata:c};this.applyEdits([h])}cellIndexToHandle(c){if(typeof c!="number")return this._cell.handle;const h=this._document.getCellFromIndex(c);if(!h)throw new Error("INVALID cell index");return h.handle}asApiObject(){const c=this;return Object.freeze({get document(){return c._document.apiNotebook},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(h){c._executionOrder=h,c.mixinMetadata({executionOrder:h})},start(h){var t;if(c._state===E.Resolved||c._state===E.Started)throw new Error("Cannot call start again");c._state=E.Started,c._onDidChangeState.fire(),c.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:(t=h==null?void 0:h.startTime)!==null&&t!==void 0?t:null})},end(h){var t,n;if(c._state===E.Resolved)throw new Error("Cannot call resolve twice");c._state=E.Resolved,c._onDidChangeState.fire(),c.mixinMetadata({runState:null,lastRunSuccess:(t=h==null?void 0:h.success)!==null&&t!==void 0?t:null,runEndTime:(n=h==null?void 0:h.endTime)!==null&&n!==void 0?n:null})},clearOutput(h){return c.verifyStateForOutput(),this.replaceOutput([],h)},async appendOutput(h,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return h=(0,m.asArray)(h),c.applyEditSoon({editType:2,handle:n,append:!0,outputs:h.map(C.NotebookCellOutput.from)})},async replaceOutput(h,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return h=(0,m.asArray)(h),c.applyEditSoon({editType:2,handle:n,outputs:h.map(C.NotebookCellOutput.from)})},async appendOutputItems(h,t){return c.verifyStateForOutput(),h=(0,m.asArray)(h),c.applyEditSoon({editType:7,append:!0,items:h.map(C.NotebookCellOutputItem.from),outputId:t})},async replaceOutputItems(h,t){return c.verifyStateForOutput(),h=(0,m.asArray)(h),c.applyEditSoon({editType:7,items:h.map(C.NotebookCellOutputItem.from),outputId:t})},token:c._tokenSource.token})}}class S{constructor(c,h){this.delay=c,this.callback=h,this.batch=[]}addItem(c){return this.batch.push(c),this.waitPromise||(this.waitPromise=(0,r.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const h=this.batch;return this.batch=[],this.callback(h)})),this.waitPromise}}}),define(me[66],ge([0,1,5,3,6,23,4,15]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends I.Disposable{constructor(o,d,E,v){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=v,this._id=v.$register(this.name,d,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?A.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(d=>this._proxy.$clear(d,o))}show(o,d){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof o=="boolean"?o:d)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class k extends D{constructor(o,d){super(o,!1,void 0,d)}append(o){super.append(o),this._id.then(d=>this._proxy.$append(d,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class r extends D{constructor(o,d,E){super(o,!0,d,E)}append(o){throw new Error("Not supported")}}class P{constructor(o,d){this.name=o,this._channel=d}append(o){this._channel.then(d=>d.append(o))}appendLine(o){this._channel.then(d=>d.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,d){this._channel.then(E=>E.show(o,d))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=P;let f=class{constructor(o){this._proxy=o.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new k(o,this._proxy)}createOutputChannelFromLogFile(o,d){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new r(o,d,this._proxy)}};f=qe([He(0,C.IExtHostRpcService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(me[238],ge([0,1,13,21,3,6,5,2,7,17,16,58]),function(Q,e,b,R,I,A,y,C,D,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(m,o,d){const E=m.getProxy(y.MainContext.MainThreadQuickOpen);class v{constructor(i,a){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=a}showQuickPick(i,a,p,g=R.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(i),l=++this._instances,w=E.$show(l,{title:p==null?void 0:p.title,placeHolder:p==null?void 0:p.placeHolder,matchOnDescription:p==null?void 0:p.matchOnDescription,matchOnDetail:p==null?void 0:p.matchOnDetail,ignoreFocusLost:p==null?void 0:p.ignoreFocusOut,canPickMany:p==null?void 0:p.canPickMany},g),T={},N=w.then(()=>T);return Promise.race([N,_]).then(z=>{if(z!==T)return _.then(ne=>{const ie=[];for(let U=0;U<ne.length;U++){const B=ne[U];let x,L,O,F,M;typeof B=="string"?x=B:(x=B.label,L=B.description,O=B.detail,F=B.picked,M=B.alwaysShow),ie.push({label:x,description:L,handle:U,detail:O,picked:F,alwaysShow:M})}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{p.onDidSelectItem(ne[U])}),E.$setItems(l,ie),w.then(U=>{if(typeof U=="number")return ne[U];if(Array.isArray(U))return U.map(B=>ne[B])})})}).then(void 0,z=>{if(!(0,k.isPromiseCanceledError)(z))return E.$setError(l,z),Promise.reject(z)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,a=R.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,E.$input(i,typeof this._validateInput=="function",a).then(void 0,p=>{if(!(0,k.isPromiseCanceledError)(p))return Promise.reject(p)})}$validateInput(i){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,a=R.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!!p){const g=await this._workspace.getWorkspaceFolders2();if(!!g)return g.find(_=>_.uri.toString()===p.uri.toString())}}createQuickPick(i,a){const p=new t(i,a,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}createInputBox(i){const a=new n(i,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(i,a){const p=this._sessions.get(i);p&&p._fireDidChangeValue(a)}$onDidAccept(i){const a=this._sessions.get(i);a&&a._fireDidAccept()}$onDidChangeActive(i,a){const p=this._sessions.get(i);p instanceof t&&p._fireDidChangeActive(a)}$onDidChangeSelection(i,a){const p=this._sessions.get(i);p instanceof t&&p._fireDidChangeSelection(a)}$onDidTriggerButton(i,a){const p=this._sessions.get(i);p&&p._fireDidTriggerButton(a)}$onDidHide(i){const a=this._sessions.get(i);a&&a._fireDidHide()}}class S{constructor(i,a){this._extensionId=i,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((a,p)=>{const g=a===D.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(g,a)}),this.update({buttons:i.map((a,p)=>({iconPath:u(a.iconPath),tooltip:a.tooltip,handle:a===D.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const a=this._handlesToButtons.get(i);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(i){if(!this._disposed){for(const a of Object.keys(i)){const p=i[a];this._pendingUpdate[a]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function u(s){if(s instanceof D.ThemeIcon)return{id:s.id};const i=h(s),a=c(s);return{dark:typeof i=="string"?C.URI.file(i):i,light:typeof a=="string"?C.URI.file(a):a}}function c(s){return typeof s=="object"&&"light"in s?s.light:s}function h(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends S{constructor(i,a,p){super(i,p);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((a,p)=>{this._handlesToItems.set(p,a),this._itemsToHandles.set(a,p)}),this.update({items:i.map((a,p)=>({label:a.label,description:a.description,handle:p,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(i){const a=(0,r.coalesce)(i.map(p=>this._handlesToItems.get(p)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(i){const a=(0,r.coalesce)(i.map(p=>this._handlesToItems.get(p)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class n extends S{constructor(i,a){super(i,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?P.default.Error:P.default.Ignore})}}return new v(o,d)}e.createExtHostQuickOpen=f}),define(me[239],ge([0,1,2,3,54,6,13,5,16,98,14,26,40]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(i){if(i)return typeof i.iconPath=="string"?b.URI.file(i.iconPath):i.iconPath}function o(i,a){if(!i.iconPath&&!a.iconPath)return 0;if(i.iconPath){if(!a.iconPath)return 1}else return-1;const p=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,g=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return(0,k.comparePaths)(p,g)}function d(i,a){let p=0;if(i.strikeThrough!==a.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==a.faded)return i.faded?1:-1;if(i.tooltip!==a.tooltip)return(i.tooltip||"").localeCompare(a.tooltip||"");if(p=o(i,a),p!==0)return p;if(i.light&&a.light)p=o(i.light,a.light);else{if(i.light)return 1;if(a.light)return-1}if(p!==0)return p;if(i.dark&&a.dark)p=o(i.dark,a.dark);else{if(i.dark)return 1;if(a.dark)return-1}return p}function E(i,a){if(i.command!==a.command)return i.command<a.command?-1:1;if(i.title!==a.title)return i.title<a.title?-1:1;if(i.tooltip!==a.tooltip){if(i.tooltip!==void 0&&a.tooltip!==void 0)return i.tooltip<a.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(i.arguments===a.arguments)return 0;if(i.arguments)if(a.arguments){if(i.arguments.length!==a.arguments.length)return i.arguments.length-a.arguments.length}else return 1;else return-1;for(let p=0;p<i.arguments.length;p++){const g=i.arguments[p],_=a.arguments[p];if(g!==_)return g<_?-1:1}return 0}function v(i,a){let p=(0,k.comparePaths)(i.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(p!==0)return p;if(i.command&&a.command)p=E(i.command,a.command);else{if(i.command)return 1;if(a.command)return-1}if(p!==0)return p;if(i.decorations&&a.decorations)p=d(i.decorations,a.decorations);else{if(i.decorations)return 1;if(a.decorations)return-1}return p}function S(i,a){for(let p=0;p<i.length;p++)if(i[p]!==a[p])return!1;return!0}function u(i,a){return i.command===a.command&&i.title===a.title&&i.tooltip===a.tooltip&&(i.arguments&&a.arguments?S(i.arguments,a.arguments):i.arguments===a.arguments)}function c(i,a){return(0,D.equals)(i,a,u)}class h{constructor(a,p,g){this._extension=a,this._proxy=p,this._sourceControlHandle=g,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(a){if((0,f.checkProposedApiEnabled)(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){(0,f.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,p){(0,f.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,p)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=h;class t{constructor(a,p,g,_,l){this._proxy=a,this._commands=p,this._sourceControlHandle=g,this._id=_,this._label=l,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,p){const g=this._resourceStatesCommandsMap.get(a);return g?(0,y.asPromise)(()=>this._commands.executeCommand(g.command,...g.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const p=[...this._resourceStates].sort(v),_=(0,D.sortedDiff)(this._resourceSnapshot,p,v).map(T=>{const N=T.toInsert.map(z=>{const ne=this._resourceHandlePool++;this._resourceStatesMap.set(ne,z);const ie=z.resourceUri,U=m(z.decorations),B=z.decorations&&m(z.decorations.light)||U,x=z.decorations&&m(z.decorations.dark)||U,L=[];let O;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const le=new A.DisposableStore;O=this._commands.converter.toInternal(z.command,le),this._resourceStatesDisposablesMap.set(ne,le)}else this._resourceStatesCommandsMap.set(ne,z.command);B&&L.push(B),x&&x.toString()!==(B==null?void 0:B.toString())&&L.push(x);const F=z.decorations&&z.decorations.tooltip||"",M=z.decorations&&!!z.decorations.strikeThrough,W=z.decorations&&!!z.decorations.faded,q=z.contextValue||"";return{rawResource:[ne,ie,L,F,M,W,q,O],handle:ne}});return{start:T.start,deleteCount:T.deleteCount,toInsert:N}}),l=_.map(({start:T,deleteCount:N,toInsert:z})=>[T,N,z.map(ne=>ne.rawResource)]),w=_.reverse();for(const{start:T,deleteCount:N,toInsert:z}of w){const ne=z.map(U=>U.handle),ie=this._handlesSnapshot.splice(T,N,...ne);for(const U of ie)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),(a=this._resourceStatesDisposablesMap.get(U))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=p,l}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(a,p,g,_,l,w){this._proxy=p,this._commands=g,this._id=_,this._label=l,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new h(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,l,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=a;const p=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:p})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(!(this._statusBarCommands&&a&&c(this._statusBarCommands,a))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=a;const p=(a||[]).map(g=>this._commands.converter.toInternal(g,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:p})}}get selected(){return this._selected}createResourceGroup(a,p){const g=new t(this._proxy,this._commands,this.handle,a,p),_=R.Event.once(g.onDidDispose)(()=>this.createdResourceGroups.delete(g));return this.createdResourceGroups.set(g,_),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const a=[],p=[];for(const[g,_]of this.createdResourceGroups){_.dispose();const l=g.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(g),this.eventuallyUpdateResourceStates()});R.Event.once(g.onDidDispose)(()=>{this.updatedResourceGroups.delete(g),l.dispose(),this._groups.delete(g.handle),this._proxy.$unregisterGroup(this.handle,g.handle)}),a.push([g.handle,g.id,g.label,g.features]);const w=g._takeResourceStateSnapshot();w.length>0&&p.push([g.handle,w]),this._groups.set(g.handle,g)}this._proxy.$registerGroups(this.handle,a,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(p=>{const g=p._takeResourceStateSnapshot();g.length!==0&&a.push([p.handle,g])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,qe([(0,I.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,I.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Mn{constructor(a,p,g){this._commands=p,this.logService=g,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=a.getProxy(C.MainContext.MainThreadSCM),this._telemetry=a.getProxy(C.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const l=this._sourceControls.get(_.sourceControlHandle);if(!l)return _;const w=l.getResourceGroup(_.groupHandle);return w?w.getResourceState(_.handle):_}else if(_&&_.$mid===4){const l=this._sourceControls.get(_.sourceControlHandle);return l?l.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const l=this._sourceControls.get(_.handle);return l||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,p,g,_){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,p,g,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const l=Mn._handlePool++,w=new n(a,this._proxy,this._commands,p,g,_);this._sourceControls.set(l,w);const T=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(a.identifier))||[];return T.push(w),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(a.identifier),T),w}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const p=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(a.identifier)),g=p&&p[p.length-1];return g&&g.inputBox}$provideOriginalResource(a,p,g){const _=b.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,_.toString());const l=this._sourceControls.get(a);return!l||!l.quickDiffProvider||!l.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>l.quickDiffProvider.provideOriginalResource(_,g)).then(w=>w||null)}$onInputBoxValueChange(a,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const g=this._sourceControls.get(a);return g&&g.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(a,p,g,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,p,g);const l=this._sourceControls.get(a);if(!l)return Promise.resolve(void 0);const w=l.getResourceGroup(p);return w?w.$executeResourceCommand(g,_):Promise.resolve(void 0)}$validateInput(a,p,g){this.logService.trace("ExtHostSCM#$validateInput",a);const _=this._sourceControls.get(a);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>_.inputBox.validateInput(p,g)).then(l=>l?Promise.resolve([l.message,l.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var p,g;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((p=this._sourceControls.get(a))===null||p===void 0||p.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((g=this._sourceControls.get(this._selectedSourceControlHandle))===null||g===void 0||g.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};s._handlePool=0,s=qe([He(2,r.ILogService)],s),e.ExtHostSCM=s});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)};define(me[240],ge([0,1,7,5,163,6]),function(Q,e,b,R,I,A){"use strict";var y,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(f,m,o,d,E=b.StatusBarAlignment.Left,v,S){y.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,it(this,y,f,"f"),it(this,C,m,"f"),this._id=D.ID_GEN++,this._statusId=o,this._statusName=d,this._alignment=E,this._priority=v,this._accessibilityInformation=S}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!D.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:$e(this,C,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:$e(this,C,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(f=this._command)===null||f===void 0?void 0:f.internal,m,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,C=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(f){this._messages=[],this._item=f.createStatusBarEntry("status.extensionMessage",(0,I.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const m={message:f};return this._messages.unshift(m),this._update(),new b.Disposable(()=>{const o=this._messages.indexOf(m);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class r{constructor(f,m){this._proxy=f.getProxy(R.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new k(this)}createStatusBarEntry(f,m,o,d,E){return new D(this._proxy,this._commands,f,m,o,d,E)}setStatusBarMessage(f,m){const o=this._statusMessage.setMessage(f);let d;return typeof m=="number"?d=setTimeout(()=>o.dispose(),m):typeof m!="undefined"&&m.then(()=>o.dispose(),()=>o.dispose()),new b.Disposable(()=>{o.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=r}),define(me[91],ge([0,1,5,3,4]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(C){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,k){return this._proxy.$getValue(C,D).then(r=>r||k)}setValue(C,D,k){return this._proxy.$setValue(C,D,k)}$acceptValue(C,D,k){this._onDidChangeStorage.fire({shared:C,key:D,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(me[92],ge([0,1,4,27,14,90,2]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let C=class{constructor(k,r,P){var f;this._logService=r,this._extHostFileSystem=P,this._workspace=(f=k.workspace)!==null&&f!==void 0?f:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const r=this._workspace.id,P=y.URI.joinPath(this._environment.workspaceStorageHome,r);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(f){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(f){this._logService.error("[ExtHostStorage]",f);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};C=qe([He(0,R.IExtHostInitDataService),He(1,I.ILogService),He(2,A.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(me[33],ge([0,1,3,5,4,2,15,6,7,164,17,206,21,30,190]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class d{constructor(t,n,s,i){this._proxy=t,this._id=n,this._creationOptions=s,this._name=i,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(p=>this._pidPromiseComplete=p);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},sendText(p,g=!0){a._checkDisposed(),a._proxy.$sendText(a._id,p,g)},show(p){a._checkDisposed(),a._proxy.$show(a._id,p)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(t,n,s,i,a,p,g,_,l,w,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:i,icon:a,initialText:p,waitOnExit:g,strictEnv:_,hideFromUser:l,isFeatureTerminal:w,isExtensionOwnedTerminal:T})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let v=1,S=class extends C.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,i]of this._terminalProcesses)i.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[""]}createExtensionTerminal(t){const n=new d(this._proxy,(0,m.generateUuid)(),t,t.name),s=new E(t.pty);return n.createExtensionTerminal().then(i=>{const a=this._setupExtHostProcessListeners(i,s);this._terminalProcessDisposables[i]=a}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const i=new E(n),a=this._setupExtHostProcessListeners(t,i);this._terminalProcessDisposables[t]=a}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const i=this._getTerminalById(t);i&&i.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:i.value,dimensions:i.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const i=this._terminals.splice(s,1)[0];i.setExitCode(n),this._onDidCloseTerminal.fire(i.value)}}$acceptTerminalOpened(t,n,s,i){if(n){const g=this._getTerminalObjectIndexById(this._terminals,n);if(g!==null){this._terminals[g]._id=t,this._onDidOpenTerminal.fire(this.terminals[g]),this._terminals[g].isOpen=!0;return}}const a={name:i.name,shellPath:i.executable,shellArgs:i.args,cwd:typeof i.cwd=="string"?i.cwd:A.URI.revive(i.cwd),env:i.env,hideFromUser:i.hideFromUser},p=new d(this._proxy,t,a,s);this._terminals.push(p),this._onDidOpenTerminal.fire(p.value),p.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,k.localize)(0,null,t)};s.isOpen||await new Promise(a=>{const p=this.onDidOpenTerminal(async g=>{g===s.value&&(p.dispose(),a())})});const i=this._terminalProcesses.get(t);i?i.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new C.DisposableStore;s.add(n.onProcessReady(a=>this._proxy.$sendProcessReady(t,a.pid,a.cwd))),s.add(n.onProcessTitleChanged(a=>this._proxy.$sendProcessTitle(t,a))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(a=>this._onProcessExit(t,a))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(a=>this._proxy.$sendOverrideDimensions(t,a))),this._terminalProcesses.set(t,n);const i=this._extensionTerminalAwaitingStart[t];return i&&n instanceof E&&(n.startSendingEvents(i.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var i;try{(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,s)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const i=this._terminalLinkCancellationSource.get(t);i&&i.dispose(!0);const a=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,a);const p=[],g={terminal:s.value,line:n},_=[];for(const T of this._linkProviders)_.push(new Promise(async N=>{a.token.onCancellationRequested(()=>N({provider:T,links:[]}));const z=await T.provideTerminalLinks(g,a.token)||[];a.token.isCancellationRequested||N({provider:T,links:z})}));const l=await Promise.all(_);if(a.token.isCancellationRequested)return[];const w=new Map;for(const T of l)T&&T.links.length>0&&p.push(...T.links.map(N=>{const z={id:v++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return w.set(z.id,{provider:T.provider,link:N}),z}));return this._terminalLinkCache.set(t,w),p}$activateLink(t,n){var s;const i=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!i||i.provider.handleTerminalLink(i.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((i,a)=>i._id===n?(s=a,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new u,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],i=new u(n[1]);this._setEnvironmentVariableCollection(s,i)})}$acceptDefaultProfile(t,n){this._defaultProfile=t,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};S=qe([He(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class u{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,i)=>t.call(n,i,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let c=class extends S{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new r.NotSupportedError}createTerminalFromOptions(t){throw new r.NotSupportedError}};c=qe([He(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(me[241],ge([0,1,3,16,5,124,20,7]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(r,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=r.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(f=>this._onDidChangeVisibleTextEditors.fire(f)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(f=>this._onDidChangeActiveTextEditor.fire(f))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(r){const P=this._extHostDocumentsAndEditors.allEditors();return r?P:P.map(f=>f.value)}async showTextDocument(r,P,f){let m;typeof P=="number"?m={position:y.ViewColumn.from(P),preserveFocus:f}:typeof P=="object"?m={position:y.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?y.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:m={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(r.uri,m),d=o&&this._extHostDocumentsAndEditors.getEditor(o);if(d)return d.value;throw o?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}createTextEditorDecorationType(r){return new A.TextEditorDecorationType(this._proxy,r).value}$acceptEditorPropertiesChanged(r,P){const f=this._extHostDocumentsAndEditors.getEditor(r);if(!f)throw new Error("unknown text editor");if(P.options&&f._acceptOptions(P.options),P.selections){const m=P.selections.selections.map(y.Selection.to);f._acceptSelections(m)}if(P.visibleRanges){const m=R.coalesce(P.visibleRanges.map(y.Range.to));f._acceptVisibleRanges(m)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:f.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const m=C.TextEditorSelectionChangeKind.fromValue(P.selections.source),o=P.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:f.value,selections:o,kind:m})}if(P.visibleRanges){const m=R.coalesce(P.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:f.value,visibleRanges:m})}}$acceptEditorPositionData(r){for(const P in r){const f=this._extHostDocumentsAndEditors.getEditor(P);if(!f)throw new Error("Unknown text editor");const m=y.ViewColumn.to(r[P]);f.value.viewColumn!==m&&(f._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:f.value,viewColumn:m}))}}getDiffInformation(r){return Promise.resolve(this._proxy.$getDiffInformation(r))}}e.ExtHostEditors=D});var Xt=this&&this.__rest||function(Q,e){var b={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(b[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var I=0,R=Object.getOwnPropertySymbols(Q);I<R.length;I++)e.indexOf(R[I])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[I])&&(b[R[I]]=Q[R[I]]);return b};define(me[242],ge([0,1,2,4,5,6,7]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class C{constructor(r,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=r.getProxy(I.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:f=>{var m,o;if(f&&f.$mid===11){const d=f.uri===void 0?void 0:b.URI.revive(f.uri);return(o=(m=this._itemsBySourceAndUriMap.get(f.source))===null||m===void 0?void 0:m.get(D(d)))===null||o===void 0?void 0:o.get(f.handle)}return f}})}async $getTimeline(r,P,f,m,o){const d=this._providers.get(r);return d==null?void 0:d.provideTimeline(b.URI.revive(P),f,m,o)}registerTimelineProvider(r,P,f,m){const o=new A.DisposableStore,d=this.convertTimelineItem(P.id,m,o).bind(this);let E;P.onDidChange&&(E=P.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:P.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:r,onDidChange:void 0,async provideTimeline(S,u,c,h){var t;(h==null?void 0:h.resetCache)&&(o.clear(),(t=v.get(P.id))===null||t===void 0||t.clear());const n=await P.provideTimeline(S,u,c);if(n!=null){const s=d(S,h);return Object.assign(Object.assign({},n),{source:P.id,items:n.items.map(s)})}},dispose(){var S;for(const u of v.values())(S=u.get(P.id))===null||S===void 0||S.clear();E==null||E.dispose(),o.dispose()}}))}convertTimelineItem(r,P,f){return(m,o)=>{let d;if(o==null?void 0:o.cacheResults){let E=this._itemsBySourceAndUriMap.get(r);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(r,E));const v=D(m);d=E.get(v),d===void 0&&(d=new Map,E.set(v,d))}return E=>{var v,S;const{iconPath:u}=E,c=Xt(E,["iconPath"]),h=`${r}|${(v=E.id)!==null&&v!==void 0?v:E.timestamp}`;d==null||d.set(h,E);let t,n,s;return E.iconPath&&(u instanceof y.ThemeIcon?s={id:u.id}:b.URI.isUri(u)?(t=u,n=u):{light:t,dark:n}=u),Object.assign(Object.assign({},c),{id:(S=c.id)!==null&&S!==void 0?S:void 0,handle:h,source:r,command:E.command?P.toInternal(E.command,f):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(r){if(this._providers.get(r.id))throw new Error(`Timeline Provider ${r.id} already exists.`);return this._proxy.$registerTimelineProvider({id:r.id,label:r.label,scheme:r.scheme}),this._providers.set(r.id,r),(0,A.toDisposable)(()=>{var f;for(const m of this._itemsBySourceAndUriMap.values())(f=m.get(r.id))===null||f===void 0||f.clear();this._providers.delete(r.id),this._proxy.$unregisterTimelineProvider(r.id),r.dispose()})}}e.ExtHostTimeline=C;function D(k){return k==null?void 0:k.toString()}}),define(me[243],ge([0,1,6,12,2,5]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,r,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const f=P.schemes.find(m=>!y.supportedSchemes.has(m));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,r),this._proxy.$registerUriOpener(k,P.schemes,D,P.label),(0,b.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(D,k,r){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener with id: ${D}`);const f=I.URI.revive(k);return P.canOpenExternalUri(f,r)}async $openUri(D,k,r){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener id: '${D}'`);return P.openExternalUri(I.URI.revive(k.resolvedUri),{sourceUri:I.URI.revive(k.sourceUri)},r)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(me[244],ge([0,1,5,2,6,17,26]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(k,r){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=C.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(P,r),this._proxy.$registerUriHandler(P,k),(0,I.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,r){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(r))}catch(f){(0,A.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(k){return R.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=C,C.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)};define(me[67],ge([0,1,3,2,175,198,88,5]),function(Q,e,b,R,I,A,y,C){"use strict";var D,k,r,P,f,m,o,d,E,v,S,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class c{constructor(g,_,l,w,T,N,z){D.set(this,void 0),k.set(this,void 0),r.set(this,void 0),P.set(this,void 0),f.set(this,void 0),m.set(this,void 0),o.set(this,""),d.set(this,void 0),E.set(this,!1),v.set(this,!1),S.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new b.Emitter),this._onDidDispose=$e(this,u,"f").event,it(this,D,g,"f"),it(this,k,_,"f"),it(this,d,l,"f"),it(this,P,w,"f"),it(this,f,T,"f"),it(this,m,N,"f"),it(this,S,h(N),"f"),it(this,r,z,"f")}dispose(){it(this,E,!0,"f"),$e(this,u,"f").fire(),$e(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return it(this,v,!0,"f"),(0,y.asWebviewUri)($e(this,P,"f"),$e(this,D,"f"),g)}get cspSource(){return $e(this,P,"f").webviewCspSource.replace("{{uuid}}",$e(this,D,"f"))}get html(){return this.assertNotDisposed(),$e(this,o,"f")}set html(g){this.assertNotDisposed(),$e(this,o,"f")!==g&&(it(this,o,g,"f"),!$e(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(it(this,v,!0,"f"),$e(this,r,"f").report("Webview vscode-resource: uris",$e(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,k,"f").$setHtml($e(this,D,"f"),g))}get options(){return this.assertNotDisposed(),$e(this,d,"f")}set options(g){this.assertNotDisposed(),$e(this,k,"f").$setOptions($e(this,D,"f"),s($e(this,m,"f"),$e(this,f,"f"),g)),it(this,d,g,"f")}async postMessage(g){if($e(this,E,"f"))return!1;const _=(0,A.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:$e(this,S,"f")});return $e(this,k,"f").$postMessage($e(this,D,"f"),_.message,..._.buffers)}assertNotDisposed(){if($e(this,E,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=c,D=new WeakMap,k=new WeakMap,r=new WeakMap,P=new WeakMap,f=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,E=new WeakMap,v=new WeakMap,S=new WeakMap,u=new WeakMap;function h(p){try{const g=(0,I.normalizeVersion)((0,I.parseVersion)(p.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch(g){return!1}}e.shouldSerializeBuffersForPostMessage=h;class t{constructor(g,_,l,w,T){this.initData=_,this.workspace=l,this._logService=w,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=g.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(g,_,...l){const w=this.getWebview(g);if(w){const{message:T}=(0,A.deserializeWebviewMessage)(_,l);w._onMessageEmitter.fire(T)}}$onMissingCsp(g,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,_,l){const w=new c(g,this._webviewProxy,i(_),this.initData,this.workspace,l,this._deprecationService);return this._webviews.set(g,w),w._onDidDispose(()=>{this._webviews.delete(g)}),w}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=t;function n(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=n;function s(p,g,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||a(p,g)}}e.serializeWebviewOptions=s;function i(p){var g;return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:(g=p.localResourceRoots)===null||g===void 0?void 0:g.map(_=>R.URI.from(_))}}e.reviveOptions=i;function a(p,g){return[...((g==null?void 0:g.getWorkspaceFolders())||[]).map(_=>_.uri),p.extensionLocation]}}),define(me[245],ge([0,1,21,75,6,12,25,2,20,67,86,5,7]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new r.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class o{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const i=this.key(t,n.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const a=new m(n,s);return this._documents.set(i,a),a}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var d;(function(h){h[h.Text=0]="Text",h[h.Custom=1]="Custom"})(d||(d={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,i){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:i}),new f.Disposable(()=>this._providers.delete(n))}}class v{constructor(t,n,s,i,a){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=a,this._editorProviders=new E,this._documents=new o,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,i){const a=new I.DisposableStore;return S(s)?(a.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&a.add(s.onDidChangeCustomDocument(p=>{const g=this.getCustomDocumentEntry(n,p.document.uri);if(u(p)){const _=g.addEdit(p);this._proxy.$onDidEdit(p.document.uri,n,_,p.label)}else this._proxy.$onContentChange(p.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),f.Disposable.from(a,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,i,a){var p;const g=this._editorProviders.get(n);if(!g)throw new Error(`No provider found for '${n}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${n}'`);const _=C.URI.revive(t),l=await g.provider.openCustomDocument(_,{backupId:s,untitledDocumentData:i==null?void 0:i.buffer},a);let w;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(w=(p=this._extensionStoragePaths.workspaceValue(g.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(n,l,w),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const i=C.URI.revive(t),{document:a}=this.getCustomDocumentEntry(n,i);this._documents.delete(n,a),a.dispose()}async $resolveWebviewEditor(t,n,s,i,a,p){const g=this._editorProviders.get(s);if(!g)throw new Error(`No provider found for '${s}'`);const _=D.ViewColumn.to(a),l=this._extHostWebview.createNewWebview(n,i.webviewOptions,g.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(n,s,i.title,_,i.panelOptions,l),T=C.URI.revive(t);switch(g.type){case 1:{const{document:N}=this.getCustomDocumentEntry(s,T);return g.provider.resolveCustomEditor(N,w,p)}case 0:{const N=this._extHostDocuments.getDocument(T);return g.provider.resolveCustomTextEditor(N,w,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const p=C.URI.revive(n),g=this._extHostDocuments.getDocument(p);await i.provider.moveCustomTextEditor(g,a,b.CancellationToken.None)}async $undo(t,n,s,i){return this.getCustomDocumentEntry(n,t).undo(s,i)}async $redo(t,n,s,i){return this.getCustomDocumentEntry(n,t).redo(s,i)}async $revert(t,n,s){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,n,s){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,n,s,i){const a=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(a.document,C.URI.revive(s),i)}async $backup(t,n,s){const i=this.getCustomDocumentEntry(n,t),p=await this.getCustomEditorProvider(n).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(p),p.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,C.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function S(h){return typeof h.resolveCustomTextEditor=="function"}function u(h){return typeof h.undo=="function"&&typeof h.redo=="function"}function c(h){const t=h.scheme===A.Schemas.file||h.scheme===A.Schemas.untitled?h.fsPath:h.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)};define(me[246],ge([0,1,3,6,2,30,20,67,5,7]),function(Q,e,b,R,I,A,y,C,D,k){"use strict";var r,P,f,m,o,d,E,v,S,u,c,h,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends R.Disposable{constructor(p,g,_,l,w,T,N){super();r.set(this,void 0),P.set(this,void 0),f.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,void 0),E.set(this,void 0),v.set(this,void 0),S.set(this,!0),u.set(this,!0),c.set(this,!1),h.set(this,this._register(new b.Emitter)),this.onDidDispose=$e(this,h,"f").event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,it(this,r,p,"f"),it(this,P,g,"f"),it(this,f,_,"f"),it(this,o,T,"f"),it(this,v,w,"f"),it(this,d,l,"f"),it(this,m,N,"f")}dispose(){$e(this,c,"f")||(it(this,c,!0,"f"),$e(this,h,"f").fire(),$e(this,P,"f").$disposeWebview($e(this,r,"f")),$e(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,m,"f")}get viewType(){return this.assertNotDisposed(),$e(this,f,"f")}get title(){return this.assertNotDisposed(),$e(this,d,"f")}set title(p){this.assertNotDisposed(),$e(this,d,"f")!==p&&(it(this,d,p,"f"),$e(this,P,"f").$setTitle($e(this,r,"f"),p))}get iconPath(){return this.assertNotDisposed(),$e(this,E,"f")}set iconPath(p){this.assertNotDisposed(),$e(this,E,"f")!==p&&(it(this,E,p,"f"),$e(this,P,"f").$setIconPath($e(this,r,"f"),I.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return $e(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,v,"f")=="number"&&$e(this,v,"f")<0))return $e(this,v,"f")}get active(){return this.assertNotDisposed(),$e(this,u,"f")}get visible(){return this.assertNotDisposed(),$e(this,S,"f")}_updateViewState(p){$e(this,c,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(it(this,u,p.active,"f"),it(this,S,p.visible,"f"),it(this,v,p.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(p,g){this.assertNotDisposed(),$e(this,P,"f").$reveal($e(this,r,"f"),{viewColumn:p?y.ViewColumn.from(p):void 0,preserveFocus:!!g})}assertNotDisposed(){if($e(this,c,"f"))throw new Error("Webview is disposed")}}r=new WeakMap,P=new WeakMap,f=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,E=new WeakMap,v=new WeakMap,S=new WeakMap,u=new WeakMap,c=new WeakMap,h=new WeakMap,t=new WeakMap;class s{constructor(p,g,_){this.webviews=g,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(p,g,_,l,w={}){const T=typeof l=="object"?l.viewColumn:l,N={viewColumn:y.ViewColumn.from(T),preserveFocus:typeof l=="object"&&!!l.preserveFocus},z=(0,C.shouldSerializeBuffersForPostMessage)(p),ne=s.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(p),ne,g,{title:_,panelOptions:i(w),webviewOptions:(0,C.serializeWebviewOptions)(p,this.workspace,w),serializeBuffersForPostMessage:z},N);const ie=this.webviews.createNewWebview(ne,w,p);return this.createNewWebviewPanel(ne,g,_,T,w,ie)}$onDidChangeWebviewPanelViewStates(p){const g=Object.keys(p);g.sort((_,l)=>{const w=p[_],T=p[l];return w.active?1:T.active?-1:+w.visible-+T.visible});for(const _ of g){const l=this.getWebviewPanel(_);if(!!l){const w=p[_];l._updateViewState({active:w.active,visible:w.visible,viewColumn:y.ViewColumn.to(w.position)})}}}async $onDidDisposeWebviewPanel(p){const g=this.getWebviewPanel(p);g==null||g.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,g,_){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:_,extension:p}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(p)}),new k.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(p,g,_,l){const w=this._serializers.get(g);if(!w)throw new Error(`No serializer found for '${g}'`);const{serializer:T,extension:N}=w,z=this.webviews.createNewWebview(p,_.webviewOptions,N),ne=this.createNewWebviewPanel(p,g,_.title,l,_.panelOptions,z);await T.deserializeWebviewPanel(ne,_.state)}createNewWebviewPanel(p,g,_,l,w,T){const N=new n(p,this._proxy,g,_,l,w,T);return this._webviewPanels.set(p,N),N}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=s;function i(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)};define(me[247],ge([0,1,3,6,67,5,7]),function(Q,e,b,R,I,A,y){"use strict";var C,D,k,r,P,f,m,o,d,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends R.Disposable{constructor(c,h,t,n,s,i){super();C.set(this,void 0),D.set(this,void 0),k.set(this,void 0),r.set(this,void 0),P.set(this,!1),f.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=$e(this,d,"f").event,E.set(this,this._register(new b.Emitter)),this.onDidDispose=$e(this,E,"f").event,it(this,k,t,"f"),it(this,m,n,"f"),it(this,C,c,"f"),it(this,D,h,"f"),it(this,r,s,"f"),it(this,f,i,"f")}dispose(){$e(this,P,"f")||(it(this,P,!0,"f"),$e(this,E,"f").fire(),$e(this,r,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,m,"f")}set title(c){this.assertNotDisposed(),$e(this,m,"f")!==c&&(it(this,m,c,"f"),$e(this,D,"f").$setWebviewViewTitle($e(this,C,"f"),c))}get description(){return this.assertNotDisposed(),$e(this,o,"f")}set description(c){this.assertNotDisposed(),$e(this,o,"f")!==c&&(it(this,o,c,"f"),$e(this,D,"f").$setWebviewViewDescription($e(this,C,"f"),c))}get visible(){return $e(this,f,"f")}get webview(){return $e(this,r,"f")}get viewType(){return $e(this,k,"f")}_setVisible(c){c===$e(this,f,"f")||$e(this,P,"f")||(it(this,f,c,"f"),$e(this,d,"f").fire())}show(c){this.assertNotDisposed(),$e(this,D,"f").$show($e(this,C,"f"),!!c)}assertNotDisposed(){if($e(this,P,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,k=new WeakMap,r=new WeakMap,P=new WeakMap,f=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,E=new WeakMap;class S{constructor(c,h){this._extHostWebview=h,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,h,t,n){if(this._viewProviders.has(h))throw new Error(`View provider for '${h}' already registered`);return this._viewProviders.set(h,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(c),h,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(h),this._proxy.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(c,h,t,n,s){const i=this._viewProviders.get(h);if(!i)throw new Error(`No view provider found for '${h}'`);const{provider:a,extension:p}=i,g=this._extHostWebview.createNewWebview(c,{},p),_=new v(c,this._proxy,h,t,g,!0);this._webviewViews.set(c,_),await a.resolveWebviewView(_,{state:n},s)}async $onDidChangeWebviewViewVisibility(c,h){this.getWebviewView(c)._setVisible(h)}async $disposeWebviewView(c){const h=this.getWebviewView(c);this._webviewViews.delete(c),h.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const h=this._webviewViews.get(c);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=S}),define(me[127],ge([0,1,3,5,2,12,8,4,15]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class On{constructor(P){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=On.InitialState,this._proxy=P.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,f){let m;if(typeof P=="string"){m=P;try{P=I.URI.parse(P)}catch(o){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,y.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,m,f)}async asExternalUri(P,f){if((0,y.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(P.scheme))return Promise.reject(`Invalid scheme '${P.scheme}'`);const m=await this._proxy.$asExternalUri(P,f);return I.URI.from(m)}};k.InitialState={focused:!0},k=qe([He(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(me[248],ge([0,1,9,102,30,50,6,5,2,15]),function(Q,e,b,R,I,A,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let r=class extends y.Disposable{constructor(f,m){super();const o=f.getProxy(C.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async d=>{const E=D.URI.file((0,b.join)((0,R.tmpdir)(),(0,I.generateUuid)()));return await o.$download(d,E),E})}};r=qe([He(0,k.IExtHostRpcService),He(1,A.IExtHostCommands)],r),e.ExtHostDownloadService=r}),define(me[249],ge([0,1,2,9,146,28,37,66,27,15,6,14,113,44]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class o{constructor(S,u,c){this.name=S,this.file=u,this.appender=c}static async create(S,u){const c=await(0,f.createRotatingLogger)(S,u,30*m.ByteSize.MB,1);return c.clearFormatters(),new o(S,u,c)}append(S){this.appender.critical(S)}flush(){this.appender.flush()}}class d extends C.AbstractExtHostOutputChannel{constructor(S,u,c){super(S,!1,b.URI.file(u.file),c);this._appender=u}append(S){super.append(S),this._appender.append(S),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(S,u){this._appender.flush(),super.show(S,u)}clear(){this._appender.flush(),super.clear()}}let E=class extends C.ExtHostOutputService{constructor(S,u,c){super(S);this.logService=u,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new r.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(S){if(S){const u=this._channels.get(S);u&&(this._visibleChannelDisposable.value=u.onDidAppend(()=>u.update()))}}createOutputChannel(S){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const u=this._doCreateOutChannel(S);return u.then(c=>c._id.then(h=>this._channels.set(h,c))),new C.LazyOutputChannel(S,u)}async _doCreateOutChannel(S){try{const u=(0,R.join)(this._logsLocation.fsPath,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await A.SymlinkSupport.existsDirectory(u)||await y.promises.mkdir(u,{recursive:!0});const h=`${this._namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=b.URI.file((0,R.join)(u,`${h}.log`)),n=await o.create(h,t.fsPath);return new d(S,n,this._proxy)}catch(u){return this.logService.error(u),new C.ExtHostPushOutputChannel(S,this._proxy)}}};E=qe([He(0,k.IExtHostRpcService),He(1,P.ILogService),He(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(me[250],ge([0,1,11,30,15,33]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends A.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,k,r){const P=new A.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),{name:D,shellPath:k,shellArgs:r},D);return this._terminals.push(P),P.create(k,r),P.value}createTerminalFromOptions(D,k){const r=new A.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),D,D.name);return this._terminals.push(r),r.create((0,b.withNullAsUndefined)(D.shellPath),(0,b.withNullAsUndefined)(D.shellArgs),(0,b.withNullAsUndefined)(D.cwd),(0,b.withNullAsUndefined)(D.env),(0,b.withNullAsUndefined)(D.icon),(0,b.withNullAsUndefined)(D.message),void 0,(0,b.withNullAsUndefined)(D.strictEnv),(0,b.withNullAsUndefined)(D.hideFromUser),(0,b.withNullAsUndefined)(k),!0),r.value}};y=qe([He(0,I.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(me[251],ge([0,1,5,15,6,27,2,38,25,37,28,7,10,49,3,74,14]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v{constructor(g,_,l){this.remoteAddress=g,this.localAddress=_,this._dispose=l,this._onDispose=new o.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function S(p){const g=p.trim().split(`
`),_=[];return g.forEach(w=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);T&&T.length>=3&&_.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),_.reduce((w,T)=>(w[T.socket]=T,w),{})}e.getSockets=S;function u(...p){const g=[].concat(...p.map(h));return[...new Map(g.filter(_=>_.st==="0A").map(_=>{const l=_.local_address.split(":");return{socket:parseInt(_.inode,10),ip:c(l[0]),port:parseInt(l[1],16)}}).map(_=>[_.ip+":"+_.port,_])).values()]}e.loadListeningPorts=u;function c(p){let g="";if(p.length===8)for(let _=p.length-2;_>=0;_-=2)g+=parseInt(p.substr(_,2),16),_!==0&&(g+=".");else for(let _=p.length-4;_>=0;_-=4)g+=parseInt(p.substr(_,4),16).toString(16),_!==0&&(g+=":");return g}e.parseIpAddress=c;function h(p){const g=p.trim().split(`
`),_=g.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return g.map(w=>w.trim().split(/\s+/).reduce((T,N,z)=>(T[_[z]||z]=N,T),{}))}e.loadConnectionTable=h;function t(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/vs/server/main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function n(p){const g=p.trim().split(`
`),_=[];return g.forEach(l=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(l);w&&w.length>=4&&_.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),_}e.getRootProcesses=n;async function s(p,g,_){const l=_.reduce((T,N)=>(T[N.pid]=N,T),{}),w=[];return p.forEach(({socket:T,ip:N,port:z})=>{var ne;const ie=g[T]?g[T].pid:void 0,U=ie?(ne=l[ie])===null||ne===void 0?void 0:ne.cmd:void 0;ie&&U&&!t(U)&&w.push({host:N,port:z,detail:U,pid:ie})}),w}e.findPorts=s;function i(p,g,_){const l=new Map,w=n(g);for(const T of p){const N=_.get(T.port);if(N){l.set(T.port,N);continue}const z=w.find(ne=>ne.cmd.includes(`${T.port}`));if(z){let ne=z,ie;do ie=w.find(U=>U.ppid===ne.pid),ie&&(ne=ie);while(ie);l.set(T.port,{host:T.ip,port:T.port,pid:ne.pid,detail:ne.cmd,ppid:ne.ppid})}else l.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return l}e.tryFindRootPorts=i;let a=class extends I.Disposable{constructor(g,_,l){super();this.logService=l,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new o.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=g.getProxy(b.MainContext.MainThreadTunnelService),f.isLinux&&_.remote.isRemote&&_.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(g,_){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${_.remoteAddress.host}:${_.remoteAddress.port}.`);const l=await this._proxy.$openTunnel(_,g.displayName);if(l){const w=new v(l.remoteAddress,l.localAddress,()=>this._proxy.$closeTunnel(l.remoteAddress));return this._register(w),w}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(g){return Math.max(g*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(g,_){const l=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(l,{selector:g,provider:_}),this._proxy.$registerPortsAttributesProvider(g,l),new P.Disposable(()=>{this._portAttributesProviders.delete(l),this._proxy.$unregisterPortsAttributesProvider(l)})}async $providePortAttributes(g,_,l,w,T){const N=[];for(const ne of g){const ie=this._portAttributesProviders.get(ne);if(!ie)return[];N.push(...await Promise.all(_.map(async U=>ie.provider.providePortAttributes(U,l,w,T))))}const z=N.filter(ne=>!!ne);return z.length>0?z.map(ne=>({autoForwardAction:ne.autoForwardAction,port:ne.port})):[]}async $registerCandidateFinder(g){if(!(g&&this._candidateFindingEnabled)){this._candidateFindingEnabled=g;let _=new d.MovingAverage,l;for(;this._candidateFindingEnabled;){const w=new Date().getTime(),T=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(z=>z.port).join(", ")}`);const N=new Date().getTime()-w;_.update(N),(!l||JSON.stringify(l)!==JSON.stringify(T))&&(l=T,await this._proxy.$onFoundNewCandidates(l)),await new Promise(z=>setTimeout(()=>z(),this.calculateDelay(_.value)))}}}async setTunnelExtensionFunctions(g){var _;return g?(g.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this._showCandidatePort=g.showCandidatePort,this._proxy.$setCandidateFilter()),g.tunnelFactory&&(this._forwardPortProvider=g.tunnelFactory,this._proxy.$setTunnelProvider((_=g.tunnelFeatures)!==null&&_!==void 0?_:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(g,_){if(this._extensionTunnels.has(g.host)){const l=this._extensionTunnels.get(g.host);l.has(g.port)&&(_&&l.get(g.port).disposeListener.dispose(),await l.get(g.port).tunnel.dispose(),l.delete(g.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(g,_){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const l=this._forwardPortProvider(g,_);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),l!==void 0){const w=await l;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(g.remoteAddress.host)||this._extensionTunnels.set(g.remoteAddress.host,new Map);const T=this._register(w.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(w.remoteAddress))));return this._extensionTunnels.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:w,disposeListener:T}),m.TunnelDto.fromApiTunnel(w)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(l){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(g){const _=await Promise.all(g.map(w=>{var T;return this._showCandidatePort(w.host,w.port,(T=w.detail)!==null&&T!==void 0?T:"")})),l=g.filter((w,T)=>_[T]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(w=>w.port).join(", ")} to ${l.map(w=>w.port).join(", ")}`),l}async findCandidatePorts(){let g="",_="";try{g=await k.promises.readFile("/proc/net/tcp","utf8"),_=await k.promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const l=u(g,_),w=await new Promise(x=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,O,F)=>{x(O)})}),T=S(w),N=await r.readdir("/proc"),z=[];for(let x of N)try{const L=Number(x),O=D.joinPath(y.URI.file("/proc"),x);if((await k.promises.stat(O.fsPath)).isDirectory()&&!isNaN(L)){const M=await k.promises.readlink(D.joinPath(O,"cwd").fsPath),W=await k.promises.readFile(D.joinPath(O,"cmdline").fsPath,"utf8");z.push({pid:L,cwd:M,cmd:W})}}catch(L){}const ne=[],ie=l.filter(x=>{const L=T[x.socket];return L||ne.push(x),L}),U=s(ie,T,z);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ne.length}`),ne.length>0){const x=await new Promise(L=>{(0,C.exec)("ps -F -A -l | grep root",(O,F,M)=>{L(F)})});this._foundRootPorts=i(ne,x,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.join(", ")}`)}return U.then(x=>B?x.concat(B):x)}};a=qe([He(0,R.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,E.ILogService)],a),e.ExtHostTunnelService=a}),define(me[252],ge([0,1,13,21,17,3,6,100,221,125,23]),function(Q,e,b,R,I,A,y,C,D,k,r){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function f(i,a){try{return JSON.stringify(i,a)}catch(p){return"null"}}function m(i,a){return JSON.stringify(i,a)}function o(i){return i?(a,p)=>p&&p.$mid===1?i.transformOutgoing(p):p:null}var d;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},S=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(a,p=null,g=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=p,this._uriTransformer=g,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,l=k.ProxyIdentifier.count;_<l;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(I.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,C.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:p,sid:g}=a;return this._proxies[p]||(this._proxies[p]=this._createProxy(p,g)),this._proxies[p]}_createProxy(a,p){let g={get:(_,l)=>(typeof l=="string"&&!_[l]&&l.charCodeAt(0)===36&&(_[l]=(...w)=>this._remoteCall(a,l,w)),l===u?p:_[l])};return new Proxy(Object.create(null),g)}set(a,p){return this._locals[a.nid]=p,p}assertRegistered(a){for(let p=0,g=a.length;p<g;p++){const _=a[p];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(a){if(!this._isDisposed){const p=a.byteLength,g=h.read(a,0),_=g.readUInt8(),l=g.readUInt32();switch(_){case 1:case 2:{let{rpcId:w,method:T,args:N}=t.deserializeRequestJSONArgs(g);this._uriTransformer&&(N=(0,C.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(p,l,w,T,N,_===2);break}case 3:case 4:{let{rpcId:w,method:T,args:N}=t.deserializeRequestMixedArgs(g);this._uriTransformer&&(N=(0,C.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(p,l,w,T,N,_===4);break}case 5:{this._logger&&this._logger.logIncoming(p,l,0,"ack"),this._onDidReceiveAcknowledge(l);break}case 6:{this._receiveCancel(p,l);break}case 7:{this._receiveReply(p,l,void 0);break}case 9:{let w=t.deserializeReplyOKJSON(g);this._uriTransformer&&(w=(0,C.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReply(p,l,w);break}case 8:{let w=t.deserializeReplyOKVSBuffer(g);this._receiveReply(p,l,w);break}case 10:{let w=t.deserializeReplyErrError(g);this._uriTransformer&&(w=(0,C.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReplyErr(p,l,w);break}case 11:{this._receiveReplyErr(p,l,void 0);break}default:console.error("received unexpected message"),console.error(a)}}}_receiveRequest(a,p,g,_,l,w){this._logger&&this._logger.logIncoming(a,p,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(g)}.${_}(`,l);const T=String(p);let N,z;if(w){const ie=new R.CancellationTokenSource;l.push(ie.token),N=this._invokeHandler(g,_,l),z=()=>ie.cancel()}else N=this._invokeHandler(g,_,l),z=v;this._cancelInvokedHandlers[T]=z;const ne=t.serializeAcknowledged(p);this._logger&&this._logger.logOutgoing(ne.byteLength,p,1,"ack"),this._protocol.send(ne),N.then(ie=>{delete this._cancelInvokedHandlers[T];const U=t.serializeReplyOK(p,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,p,1,"reply:",ie),this._protocol.send(U)},ie=>{delete this._cancelInvokedHandlers[T];const U=t.serializeReplyErr(p,ie);this._logger&&this._logger.logOutgoing(U.byteLength,p,1,"replyErr:",ie),this._protocol.send(U)})}_receiveCancel(a,p){this._logger&&this._logger.logIncoming(a,p,1,"receiveCancel");const g=String(p);this._cancelInvokedHandlers[g]&&this._cancelInvokedHandlers[g]()}_receiveReply(a,p,g){this._logger&&this._logger.logIncoming(a,p,0,"receiveReply:",g);const _=String(p);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const l=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],l.resolveOk(g)}}_receiveReplyErr(a,p,g){this._logger&&this._logger.logIncoming(a,p,0,"receiveReplyErr:",g);const _=String(p);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const l=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let w;g&&(g.$isError?(w=new Error,w.name=g.name,w.message=g.message,w.stack=g.stack):w=g),l.resolveErr(w)}}_invokeHandler(a,p,g){try{return Promise.resolve(this._doInvokeHandler(a,p,g))}catch(_){return Promise.reject(_)}}_doInvokeHandler(a,p,g){const _=this._locals[a];if(!_)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(a));let l=_[p];if(typeof l!="function")throw new Error("Unknown method "+p+" on actor "+(0,k.getStringIdentifierForProxy)(a));return l.apply(_,g)}_remoteCall(a,p,g){if(this._isDisposed)return Promise.reject(I.canceled());let _=null;if(g.length>0&&R.CancellationToken.isCancellationToken(g[g.length-1])&&(_=g.pop()),_&&_.isCancellationRequested)return Promise.reject(I.canceled());const l=t.serializeRequestArguments(g,this._uriReplacer),w=++this._lastMessageId,T=String(w),N=new D.LazyPromise;_&&_.onCancellationRequested(()=>{const ne=t.serializeCancel(w);this._logger&&this._logger.logOutgoing(ne.byteLength,w,0,"cancel"),this._protocol.send(t.serializeCancel(w))}),this._pendingRPCReplies[T]=N,this._onWillSendRequest(w);const z=t.serializeRequest(w,a,p,l,!!_);return this._logger&&this._logger.logOutgoing(z.byteLength,w,0,`request: ${(0,k.getStringIdentifierForProxy)(a)}.${p}(`,g),this._protocol.send(z),N}}e.RPCProtocol=c,P=S,c.UNRESPONSIVE_TIME=3*1e3;class h{constructor(a,p){this._buff=a,this._offset=p}static alloc(a,p,g){let _=new h(r.VSBuffer.alloc(g+1+4),0);return _.writeUInt8(a),_.writeUInt32(p),_}static read(a,p){return new h(a,p)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const g=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,g}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,g}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,p}static sizeMixedArray(a,p){let g=0;g+=1;for(let _=0,l=a.length;_<l;_++){const w=a[_],T=p[_];switch(g+=1,T){case 1:g+=this.sizeLongString(w);break;case 2:g+=this.sizeVSBuffer(w);break;case 3:break}}return g}writeMixedArray(a,p){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let g=0,_=a.length;g<_;g++){const l=a[g];switch(p[g]){case 1:this.writeUInt8(1),this.writeLongString(l);break;case 2:this.writeUInt8(2),this.writeVSBuffer(l);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let p=new Array(a);for(let g=0;g<a;g++)switch(this.readUInt8()){case 1:p[g]=this.readLongString();break;case 2:p[g]=this.readVSBuffer();break;case 3:p[g]=void 0;break}return p}}class t{static _arrayContainsBufferOrUndefined(a){for(let p=0,g=a.length;p<g;p++)if(a[p]instanceof r.VSBuffer||typeof a[p]=="undefined")return!0;return!1}static serializeRequestArguments(a,p){if(this._arrayContainsBufferOrUndefined(a)){let g=[],_=[];for(let l=0,w=a.length;l<w;l++){const T=a[l];T instanceof r.VSBuffer?(g[l]=T,_[l]=2):typeof T=="undefined"?(g[l]=r.VSBuffer.alloc(0),_[l]=3):(g[l]=r.VSBuffer.fromString(m(T,p)),_[l]=1)}return{type:"mixed",args:g,argsType:_}}return{type:"simple",args:m(a,p)}}static serializeRequest(a,p,g,_,l){return _.type==="mixed"?this._requestMixedArgs(a,p,g,_.args,_.argsType,l):this._requestJSONArgs(a,p,g,_.args,l)}static _requestJSONArgs(a,p,g,_,l){const w=r.VSBuffer.fromString(g),T=r.VSBuffer.fromString(_);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(w),N+=h.sizeLongString(T);let z=h.alloc(l?2:1,a,N);return z.writeUInt8(p),z.writeShortString(w),z.writeLongString(T),z.buffer}static deserializeRequestJSONArgs(a){const p=a.readUInt8(),g=a.readShortString(),_=a.readLongString();return{rpcId:p,method:g,args:JSON.parse(_)}}static _requestMixedArgs(a,p,g,_,l,w){const T=r.VSBuffer.fromString(g);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(T),N+=h.sizeMixedArray(_,l);let z=h.alloc(w?4:3,a,N);return z.writeUInt8(p),z.writeShortString(T),z.writeMixedArray(_,l),z.buffer}static deserializeRequestMixedArgs(a){const p=a.readUInt8(),g=a.readShortString(),_=a.readMixedArray(),l=new Array(_.length);for(let w=0,T=_.length;w<T;w++){const N=_[w];typeof N=="string"?l[w]=JSON.parse(N):l[w]=N}return{rpcId:p,method:g,args:l}}static serializeAcknowledged(a){return h.alloc(5,a,0).buffer}static serializeCancel(a){return h.alloc(6,a,0).buffer}static serializeReplyOK(a,p,g){return typeof p=="undefined"?this._serializeReplyOKEmpty(a):p instanceof r.VSBuffer?this._serializeReplyOKVSBuffer(a,p):this._serializeReplyOKJSON(a,f(p,g))}static _serializeReplyOKEmpty(a){return h.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,p){let g=0;g+=h.sizeVSBuffer(p);let _=h.alloc(8,a,g);return _.writeVSBuffer(p),_.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,p){const g=r.VSBuffer.fromString(p);let _=0;_+=h.sizeLongString(g);let l=h.alloc(9,a,_);return l.writeLongString(g),l.buffer}static deserializeReplyOKJSON(a){const p=a.readLongString();return JSON.parse(p)}static serializeReplyErr(a,p){return p?this._serializeReplyErrEror(a,p):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,p){const g=r.VSBuffer.fromString(f(I.transformErrorForSerialization(p),null));let _=0;_+=h.sizeLongString(g);let l=h.alloc(10,a,_);return l.writeLongString(g),l.buffer}static deserializeReplyErrError(a){const p=a.readLongString();return JSON.parse(p)}static _serializeReplyErrEmpty(a){return h.alloc(11,a,0).buffer}}var n;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(s||(s={}))}),define(me[253],ge([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(me[254],ge([0,1,12,9,10,2,4,253]),function(Q,e,b,R,I,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(r,P){this.localUserHome=r,this.remoteAgentService=P,this.resolveOS=(async()=>{const f=await this.remoteAgentService.getEnvironment();return(f==null?void 0:f.os)||I.OS})(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(f==null?void 0:f.userHome)||r})()}async userHome(r){return(r==null?void 0:r.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(r=>r===1?R.win32:R.posix)}async fileURI(r){let P="";if(await this.resolveOS===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const m=r.indexOf("/",2);m===-1?(P=r.substring(2),r="/"):(P=r.substring(2,m),r=r.substring(m)||"/")}return A.URI.from({scheme:b.Schemas.file,authority:P,path:r,query:"",fragment:""})}};D=qe([He(1,C.IRemoteAgentService)],D),e.AbstractPathService=D}),define(me[68],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class b{constructor(y,C){this.line=y,this.character=C}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,C){return new b(0,0)}with(y){return new b(0,0)}}e.Position=b;class R{constructor(y,C,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(y,C),this.end=new b(D,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new R(0,0,0,0)}with(y){return new R(0,0,0,0)}}e.Range=R;var I;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,16,32,24,29,8,4,9,17,68]),function(Q,e,b,R,I,A,y,C,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return r.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",f=" characters skipped \u27EB",m=(P.length+f.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var o;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(o=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function E(L){return!!L.preview}e.resultIsMatch=E;function v(L){return!!L.resource}e.isFileMatch=v;function S(L){return!!L.message}e.isProgressMessage=S;var u;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(O){this.resource=O,this.results=[]}}e.FileMatch=c;class h{constructor(O,F,M){this.ranges=F;const W=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(W)){O=(0,y.getNLines)(O,M.matchLines);let q="",K=0,le=0;const ve=Math.floor(M.charsPerLine/5),Re=[];for(const Se of W){const Oe=Math.max(Se.startColumn-ve,0),V=Se.startColumn+M.charsPerLine;if(Oe>le+ve+m){const X=P+(Oe-le)+f;q+=X+O.slice(Oe,V),K+=Oe-(le+X.length)}else q+=O.slice(le,V);Re.push(new s(0,Se.startColumn-K,Se.endColumn-K)),le=V}this.preview={text:q,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const q=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:O,matches:(0,b.mapArrayOrNot)(F,K=>new n(K.startLineNumber-q,K.startColumn,K.endLineNumber-q,K.endColumn))}}}}e.TextSearchMatch=h;function t(L){const O=L[0].startLineNumber;for(const F of L)if(F.startLineNumber!==O||F.endLineNumber!==O)return!1;return!0}class n{constructor(O,F,M,W){this.startLineNumber=O,this.startColumn=F,this.endLineNumber=M,this.endColumn=W}}e.SearchRange=n;class s extends n{constructor(O,F,M){super(O,F,O,M)}}e.OneLineRange=s;var i;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function a(L,O=!0){const F=L&&L.files&&L.files.exclude,M=O&&L&&L.search&&L.search.exclude;if(!(!F&&!M)){if(!F||!M)return F||M;let W=Object.create(null);return W=I.mixin(W,I.deepClone(F)),W=I.mixin(W,I.deepClone(M),!0),W}}e.getExcludes=a;function p(L,O){return L.excludePattern&&R.match(L.excludePattern,O)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&R.match(L.includePattern,O)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(F=>{const M=F.folder.fsPath;if(A.isEqualOrParent(O,M)){const W=D.relative(M,O);return!F.includePattern||!!R.match(F.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var g;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(O,F){super(O);this.code=F}}e.SearchError=_;function l(L){const O=L.message;if((0,k.isPromiseCanceledError)(L))return new _(O,g.canceled);try{const F=JSON.parse(O);return new _(F.message,F.code)}catch(F){return new _(O,g.other)}}e.deserializeSearchError=l;function w(L){const O={message:L.message,code:L.code};return new Error(JSON.stringify(O))}e.serializeSearchError=w;function T(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=T;function N(L){return L.type==="success"}e.isSerializedSearchSuccess=N;function z(L){return!!L.path}e.isSerializedFileMatch=z;function ne(L,O){const F=L.searchPath?L.searchPath:L.relativePath;return(0,y.fuzzyContains)(F,O)}e.isFilePatternMatch=ne;class ie{constructor(O){this.path=O,this.results=[]}addMatch(O){this.results.push(O)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ie;function U(L,O){const F=Object.assign(Object.assign({},L||{}),O||{});return Object.keys(F).filter(M=>{const W=F[M];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=U;class B{constructor(O,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},O.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=O.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(O,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(O,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(O,F,M))}includedInQuery(O,F,M){return Promise.resolve(this._parsedExcludeExpression(O,F,M)).then(q=>!!q).then(q=>q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(O,F,M)).then(K=>!!K):Promise.resolve(!0)).then(q=>q)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=B;function x(L){for(const O in L)if(typeof L[O]!="boolean")return!0;return!1}}),define(me[34],ge([0,1,16,13,21,3,22,12,74,25,8,11,2,166,4,14,185,61,62,27,15,7,31,5]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S,u,c,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(T,N,z){return new k.ExtUri(ne=>g(ne,z)).isEqual(T,N)}function i(T,N,z){return s(T.uri,N.uri,z)?0:(0,r.compare)(T.uri.toString(),N.uri.toString())}function a(T,N,z){return T.index!==N.index?T.index<N.index?-1:1:s(T.uri,N.uri,z)?(0,r.compare)(T.name,N.name):(0,r.compare)(T.uri.toString(),N.uri.toString())}function p(T,N,z,ne){const ie=T.slice(0).sort((B,x)=>z(B,x,ne)),U=N.slice(0).sort((B,x)=>z(B,x,ne));return(0,b.delta)(ie,U,(B,x)=>z(B,x,ne))}function g(T,N){const z=N.getCapabilities(T.scheme);return!(z&&z&1024)}class _ extends v.Workspace{constructor(N,z,ne,ie,U,B){super(N,ne.map(x=>new v.WorkspaceFolder(x)),ie,B);this._name=z,this._isUntitled=U,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(B),ne.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(N,z,ne,ie){if(!N)return{workspace:null,added:[],removed:[]};const{id:U,name:B,folders:x,configuration:L,isUntitled:O}=N,F=[],M=z;z?x.forEach((le,ve)=>{const Re=f.URI.revive(le.uri),Se=_._findFolder(ne||z,Re,ie);Se?(Se.name=le.name,Se.index=le.index,F.push(Se)):F.push({uri:Re,name:le.name,index:ve})}):F.push(...x.map(({uri:le,name:ve,index:Re})=>({uri:f.URI.revive(le),name:ve,index:Re}))),F.sort((le,ve)=>le.index<ve.index?-1:1);const W=new _(U,B,F,L?f.URI.revive(L):null,!!O,le=>g(le,ie)),{added:q,removed:K}=p(M?M.workspaceFolders:[],W.workspaceFolders,i,ie);return{workspace:W,added:q,removed:K}}static _findFolder(N,z,ne){for(let ie=0;ie<N.folders.length;ie++){const U=N.workspaceFolders[ie];if(s(U.uri,z,ne))return U}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,z){return z&&this._structure.get(N)&&(N=(0,k.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let l=class{constructor(N,z,ne,ie){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ie,this._extHostFileSystemInfo=ne,this._requestIdProvider=new D.Counter,this._barrier=new R.Barrier,this._proxy=N.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(n.MainContext.MainThreadMessageService);const U=z.workspace;this._confirmedWorkspace=U?new _(U.id,U.name,[],U.configuration?f.URI.revive(U.configuration):null,!!U.isUntitled,B=>g(B,ne)):void 0}$initializeWorkspace(N,z){this._trusted=z,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?f.URI.from({scheme:C.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,z,ne,...ie){const U=[];if(Array.isArray(ie)&&ie.forEach(F=>{f.URI.isUri(F.uri)&&!U.some(M=>s(M.uri,F.uri,this._extHostFileSystemInfo))&&U.push({uri:F.uri,name:F.name||(0,k.basenameOrAuthority)(F.uri)})}),this._unconfirmedWorkspace||[z,ne].some(F=>typeof F!="number"||F<0)||ne===0&&U.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+ne>B.length)return!1;const x=B.slice(0);x.splice(z,ne,...U.map(F=>({uri:F.uri,name:F.name||(0,k.basenameOrAuthority)(F.uri),index:void 0})));for(let F=0;F<x.length;F++){const M=x[F];if(x.some((W,q)=>q!==F&&s(M.uri,W.uri,this._extHostFileSystemInfo)))return!1}x.forEach((F,M)=>F.index=M);const{added:L,removed:O}=p(B,x,a,this._extHostFileSystemInfo);if(L.length===0&&O.length===0)return!1;if(this._proxy){const F=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(F,z,ne,U).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,m.localize)(0,null,F,M.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(N,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,z)}async getWorkspaceFolder2(N,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,z)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!!this._actualWorkspace){const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}}getRelativePath(N,z){let ne,ie="";if(typeof N=="string"?(ne=f.URI.file(N),ie=N):typeof N!="undefined"&&(ne=N,ie=N.fsPath),!ne)return ie;const U=this.getWorkspaceFolder(ne,!0);if(!U)return ie;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let B=(0,k.relativePath)(U.uri,ne);return z&&U.name&&(B=`${U.name}/${B}`),B}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:z,added:ne,removed:ie}=_.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ne,removed:ie}))}findFiles(N,z,ne,ie,U=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ie.value}, entryPoint: findFiles`);let B;if(z===null?B=!1:z&&(typeof z=="string"?B=z:B=z.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:L}=w(N);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(x),(0,P.withUndefinedAsNull)(L),(0,P.withUndefinedAsNull)(B),(0,P.withUndefinedAsNull)(ne),U).then(O=>Array.isArray(O)?O.map(F=>f.URI.revive(F)):[])}async findTextInFiles(N,z,ne,ie,U=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ie.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),x=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:L,folder:O}=w(z.include),F=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,M={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:x,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:L,excludePattern:F},W=!1;if(this._activeSearchCallbacks[B]=q=>{if(!W){const K=f.URI.revive(q.resource);q.results.forEach(le=>{(0,t.resultIsMatch)(le)?ne({uri:K,preview:{text:le.preview.text,matches:(0,b.mapArrayOrNot)(le.preview.matches,ve=>new h.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,b.mapArrayOrNot)(le.ranges,ve=>new h.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):ne({uri:K,text:le.text,lineNumber:le.lineNumber})})}},U.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(N,(0,P.withUndefinedAsNull)(O),M,B,U);return delete this._activeSearchCallbacks[B],q||{}}catch(q){throw delete this._activeSearchCallbacks[B],q}}$handleTextSearchResult(N,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};l=qe([He(0,c.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,S.IExtHostFileSystemInfo),He(3,d.ILogService)],l),e.ExtHostWorkspace=l,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function w(T){let N,z;return T&&(typeof T=="string"?N=T:(N=T.pattern,z=T.baseFolder||f.URI.file(T.base))),{includePattern:N,folder:z}}}),define(me[35],ge([0,1,24,3,34,5,7,187,83,11,13,4,15,14,2]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(n,s){if(s){const i=s.split(".");let a=n;for(let p=0;a&&p<i.length;p++)a=a[i[p]];return a}}function E(n){return n instanceof o.URI}function v(n){return n&&n.uri instanceof o.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function u(n){return n&&n.uri instanceof o.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function c(n){if(E(n))return{resource:n};if(v(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(u(n))return{resource:n.uri};if(n===null)return{resource:null}}let h=class{constructor(s,i,a){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=a,this._barrier=new r.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,i))}};h=qe([He(0,f.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,m.ILogService)],h),e.ExtHostConfiguration=h;class t{constructor(s,i,a,p){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=p,this._extHostWorkspace=i,this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,a))}getConfiguration(s,i,a){const p=c(i)||{},g=this._toReadonlyValue(s?d(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,p,a==null?void 0:a.identifier);function _(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const l={has(w){return typeof d(g,w)!="undefined"},get:(w,T)=>{this._validateConfigurationAccess(s?`${s}.${w}`:w,p,a==null?void 0:a.identifier);let N=d(g,w);if(typeof N=="undefined")N=T;else{let z;const ne=(ie,U)=>{let B;const x=()=>{z=z||(0,b.deepClone)(g),B=B||d(z,U)};return(0,k.isObject)(ie)?new Proxy(ie,{get:(L,O)=>{if(typeof O=="string"&&O.toLowerCase()==="tojson")return x(),()=>B;if(z)return B=B||d(z,U),B[O];const F=L[O];return typeof O=="string"?ne(F,`${U}.${O}`):F},set:(L,O,F)=>(x(),B&&(B[O]=F),!0),deleteProperty:(L,O)=>(x(),B&&delete B[O],!0),defineProperty:(L,O,F)=>(x(),B&&Object.defineProperty(B,O,F),!0)}):ie};N=ne(N,w)}return N},update:(w,T,N,z)=>{w=s?`${s}.${w}`:w;const ne=_(N);return T!==void 0?this._proxy.$updateConfigurationOption(ne,w,T,p,z):this._proxy.$removeConfigurationOption(ne,w,p,z)},inspect:w=>{var T,N,z,ne,ie,U,B,x;w=s?`${s}.${w}`:w;const L=(0,b.deepClone)(this._configuration.inspect(w,p,this._extHostWorkspace.workspace));if(L)return{key:w,defaultValue:(T=L.default)===null||T===void 0?void 0:T.value,globalValue:(N=L.user)===null||N===void 0?void 0:N.value,workspaceValue:(z=L.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(ne=L.workspaceFolder)===null||ne===void 0?void 0:ne.value,defaultLanguageValue:(ie=L.default)===null||ie===void 0?void 0:ie.override,globalLanguageValue:(U=L.user)===null||U===void 0?void 0:U.override,workspaceLanguageValue:(B=L.workspace)===null||B===void 0?void 0:B.override,workspaceFolderLanguageValue:(x=L.workspaceFolder)===null||x===void 0?void 0:x.override,languageIds:L.overrideIdentifiers}}};return typeof g=="object"&&(0,b.mixin)(l,g,!1),Object.freeze(l)}_toReadonlyValue(s){const i=a=>(0,k.isObject)(a)?new Proxy(a,{get:(p,g)=>i(p[g]),set:(p,g,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(p,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(p,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(s)}_validateConfigurationAccess(s,i,a){const p=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),g=a?`[${a.value}] `:"";if(p===4){typeof(i==null?void 0:i.resource)=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){(i==null?void 0:i.resource)&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const a=new C.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,g)=>a.affectsConfiguration(p,c(g))})}_toMap(s){return s.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)};define(me[69],ge([0,1,2,13,3,5,7,34,41,35,21,33,15,27,4,12,10,14,65,205,17]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S,u,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(ie){function U(x){if(x!=null)return x}ie.from=U;function B(x){if(x!=null)return x}ie.to=B})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(ie){function U(x){if(x!=null)return x}ie.from=U;function B(x){if(x!=null)return x}ie.to=B})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(ie){function U(x){if(x!=null)return x}ie.from=U;function B(x){if(x!=null)return x}ie.to=B})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(ie){function U(L){if(L){const O=L;return O&&!!O.process}else return!1}ie.is=U;function B(L){if(L!=null){const O={process:L.process,args:L.args};return L.options&&(O.options=s.from(L.options)),O}}ie.from=B;function x(L){if(L!=null)return new y.ProcessExecution(L.process,L.args,L.options)}ie.to=x})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(ie){function U(x){if(x!=null)return x}ie.from=U;function B(x){if(x!=null)return x}ie.to=B})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var p;(function(ie){function U(L){if(L){const O=L;return O&&(!!O.commandLine||!!O.command)}else return!1}ie.is=U;function B(L){if(L!=null){const O={};return L.commandLine!==void 0?O.commandLine=L.commandLine:(O.command=L.command,O.args=L.args),L.options&&(O.options=a.from(L.options)),O}}ie.from=B;function x(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new y.ShellExecution(L.commandLine,L.options):new y.ShellExecution(L.command,L.args?L.args:[],L.options)}ie.to=x})(p=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(ie){function U(L){if(L){let O=L;return O&&O.customExecution==="customExecution"}else return!1}ie.is=U;function B(L){return{customExecution:"customExecution"}}ie.from=B;function x(L,O){return O.get(L)}ie.to=x})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(ie){function U(B,x){let L;return B.scope!==void 0&&typeof B.scope!="number"?L=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===y.TaskScope.Workspace&&x&&x.workspaceFile?L=x.workspaceFile:L=u.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:L}}ie.from=U})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var l;(function(ie){function U(L,O){if(L==null)return[];const F=[];for(let M of L){const W=B(M,O);W&&F.push(W)}return F}ie.fromMany=U;function B(L,O){if(L!=null){let F;L.execution instanceof y.ProcessExecution?F=i.from(L.execution):L.execution instanceof y.ShellExecution?F=p.from(L.execution):L.execution&&L.execution instanceof y.CustomExecution&&(F=g.from(L.execution));const M=t.from(L.definition);let W;if(L.scope?typeof L.scope=="number"?W=L.scope:W=L.scope.uri:W=y.TaskScope.Workspace,!(!M||!W)){const q=L.group?L.group.id:void 0;return{_id:L._id,definition:M,name:L.name,source:{extensionId:O.identifier.value,label:L.source,scope:W},execution:F,isBackground:L.isBackground,group:q,presentationOptions:n.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}}}ie.from=B;async function x(L,O,F){if(L!=null){let M;i.is(L.execution)?M=i.to(L.execution):p.is(L.execution)?M=p.to(L.execution):g.is(L.execution)&&(M=g.to(L._id,F));const W=t.to(L.definition);let q;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?q=L.source.scope:q=await O.resolveWorkspaceFolder(b.URI.revive(L.source.scope)):q=y.TaskScope.Workspace),!(!W||!q)){const K=new y.Task(W,q,L.name,L.source.label,M,L.problemMatchers);return L.isBackground!==void 0&&(K.isBackground=L.isBackground),L.group!==void 0&&(K.group=y.TaskGroup.from(L.group)),L.presentationOptions&&(K.presentationOptions=n.to(L.presentationOptions)),L._id&&(K._id=L._id),L.detail&&(K.detail=L.detail),K}}}ie.to=x})(l=e.TaskDTO||(e.TaskDTO={}));var w;(function(ie){function U(x){return x}ie.from=U;function B(x){if(!!x)return Object.assign(Object.create(null),x)}ie.to=B})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(U,B,x){this._id=B,this._task=x,h.set(this,void 0),it(this,h,U,"f")}get task(){return this._task}terminate(){$e(this,h,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}h=new WeakMap;var N;(function(ie){function U(B){return{id:B._id,task:void 0}}ie.from=U})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(U,B,x,L,O,F,M,W){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=U.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=L,this._configurationService=O,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,B,x){if(!x)return new y.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:B,provider:x,extension:U}),this._proxy.$registerTaskProvider(L,B),new y.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(U,B){this._proxy.$registerTaskSystem(U,B)}fetchTasks(U){return this._proxy.$fetchTasks(w.from(U)).then(async B=>{const x=[];for(let L of B){const O=await l.to(L,this._workspaceProvider,this._providedCustomExecutions2);O&&x.push(O)}return x})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(B=>U.push(B)),U}terminateTask(U){if(!(U instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,B,x){const L=this._providedCustomExecutions2.get(U.id);if(L){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,L),this._terminalService.attachPtyToTerminal(B,await L.callback(x))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const B=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const B=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:B,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const B=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:U.exitCode})}$provideTasks(U,B){const x=this._handlers.get(U);if(!x)return Promise.reject(new Error("no handler found"));const L=[],O=(0,R.asPromise)(()=>x.provider.provideTasks(r.CancellationToken.None)).then(F=>this.provideTasksInternal(B,L,x,F));return new Promise(F=>{O.then(M=>{Promise.all(L).then(()=>{F(M)})})})}async $resolveTask(U,B){const x=this._handlers.get(U);if(!x)return Promise.reject(new Error("no handler found"));if(B.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${x.type}].`);const L=await l.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const O=await x.provider.resolveTask(L,r.CancellationToken.None);if(!!O){this.checkDeprecation(O,x);const F=l.from(O,x.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(O.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(F.execution)&&await this.addCustomExecution(F,O,!0),await this.resolveTaskInternal(F)}}nextHandle(){return this._handleCounter++}async addCustomExecution(U,B,x){const L=await this._proxy.$createTaskId(U);!x&&!this._providedCustomExecutions2.has(L)&&this._notProvidedCustomExecutions.add(L),this._providedCustomExecutions2.set(L,B.execution)}async getTaskExecution(U,B){if(typeof U=="string"){const O=this._taskExecutionPromises.get(U);if(!O)throw new Error("Unexpected: The specified task is missing an execution");return O}let x=this._taskExecutionPromises.get(U.id);if(x)return x;const L=new Promise(async(O,F)=>{const M=B||await l.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);M?O(new T(this,U.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,L),L.then(O=>(this._taskExecutions.set(U.id,O),O),O=>Promise.reject(O))}checkDeprecation(U,B){U._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let x=this._notProvidedCustomExecutions.values(),L=x.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=x.next()}};z=qe([He(0,f.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,v.ILogService),He(7,S.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let ne=class extends z{constructor(U,B,x,L,O,F,M,W){super(U,B,x,L,O,F,M,W);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(U,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const x=l.from(B,U);if(x===void 0)throw new Error("Task is not valid");if(g.is(x.execution))await this.addCustomExecution(x,B,!1);else throw new c.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),B);return this._proxy.$executeTask(x).catch(O=>{throw new Error(O)}),L}provideTasksInternal(U,B,x,L){const O=[];if(L)for(let F of L){this.checkDeprecation(F,x),(!F.definition||!U[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=l.from(F,x.extension);M&&g.is(M.execution)?(O.push(M),B.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:O,extension:x.extension}}async resolveTaskInternal(U){if(g.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,B,x){}};ne=qe([He(0,f.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,v.ILogService),He(7,S.IExtHostApiDeprecationService)],ne),e.WorkerExtHostTask=ne,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)},Xt=this&&this.__rest||function(Q,e){var b={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(b[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var I=0,R=Object.getOwnPropertySymbols(Q);I<R.length;I++)e.indexOf(R[I])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[I])&&(b[R[I]]=Q[R[I]]);return b};define(me[255],ge([0,1,16,13,23,21,3,72,55,6,24,11,2,30,5,41,15,87,20,7,34,216,123]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S,u,c,h,t){"use strict";var n,s,i,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const p=(x,L)=>`${x}:${L.toString()}`;let g=class{constructor(L,O,F){this.documents=O,this.workspace=F,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new h.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(o.MainContext.MainThreadTesting),this.runQueue=new _(this.proxy),this.workspaceObservers=new U(this.proxy),this.textDocumentObservers=new B(this.proxy,O)}registerTestController(L,O){const F=(0,m.generateUuid)();this.controllers.set(F,{instance:O,extensionId:L}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var W;for(const q of M)(W=this.testControllers.get(q))===null||W===void 0||W.subscribeFn(F,O)},0),new u.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(L){return this.textDocumentObservers.checkout(L.uri)}createWorkspaceTestObserver(L){return this.workspaceObservers.checkout(L.uri)}async runTests(L,O=A.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(P.isDefined).map(W=>({src:W.src,testId:W.item.extId}));await this.proxy.$runTests({exclude:L.exclude?F(L.exclude).map(M=>M.testId):void 0,tests:F(L.tests),debug:L.debug},O)}createTestRun(L,O,F,M=!0){return this.runQueue.createTestRun(L,O,F,M)}$publishTestResults(L){this.results=Object.freeze(L.map(O=>(0,r.deepFreeze)(S.TestResults.to(O))).concat(this.results).sort((O,F)=>F.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(L,O){const F=f.URI.revive(O),M=p(L,F);if(!this.testControllers.has(M)){const W=new A.CancellationTokenSource;let q;if(L===1){let Se=this.documents.getDocument(F);if(!Se){const Oe=new k.DisposableStore;Se=await new Promise(V=>{Oe.add((0,R.disposableTimeout)(()=>V(void 0),5e3)),Oe.add(this.documents.onDidAddDocuments(X=>{const Z=X.find(se=>se.document.uri.toString()===F.toString());Z&&V(Z)}))}).finally(()=>Oe.dispose())}if(Se){const Oe=await this.workspace.getWorkspaceFolder2(F,!1);q=V=>V.createDocumentTestRoot?V.createDocumentTestRoot(Se.document,W.token):(0,e.createDefaultDocumentTestRoot)(V,Se.document,Oe,W.token)}}else{const Se=await this.workspace.getWorkspaceFolder2(F,!1);Se&&(q=Oe=>Oe.createWorkspaceTestRoot(Se,W.token))}if(!!q){const K=async(Se,Oe)=>{try{const V=await q(Oe);V&&ve.addRoot(V,Se)}catch(V){console.error(V)}},le=new k.DisposableStore,ve=le.add(this.ownedTests.createForHierarchy(Se=>this.proxy.$publishDiff(L,O,Se)));le.add((0,k.toDisposable)(()=>W.dispose(!0)));const Re=[];for(const[Se,Oe]of this.controllers)Re.push(K(Se,Oe.instance));Promise.all(Re).then(()=>ve.pushDiff([3,-1])),this.testControllers.set(M,{store:le,collection:ve,subscribeFn:K})}}}async $expandTest(L,O){const F=(0,b.mapFind)(this.testControllers.values(),M=>M.collection.treeId===L.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(L.testId,O<0?Infinity:O)),this.flushCollectionDiffs()}$unsubscribeFromTests(L,O){var F;const M=f.URI.revive(O),W=p(L,M);(F=this.testControllers.get(W))===null||F===void 0||F.store.dispose(),this.testControllers.delete(W)}$acceptDiff(L,O,F){L===1?this.textDocumentObservers.acceptDiff(f.URI.revive(O),F):this.workspaceObservers.acceptDiff(f.URI.revive(O),F)}async $runTestsForProvider(L,O){const F=this.controllers.get(L.tests[0].src.controller);if(!!F){const M=L.tests.map(({testId:K,src:le})=>this.ownedTests.getTestById(K,le==null?void 0:le.tree)).filter(P.isDefined).map(([K,le])=>le),W=L.excludeExtIds.map(K=>this.ownedTests.getTestById(K)).filter(P.isDefined).filter(([K,le])=>M.some(ve=>K.comparePositions(ve,le)===1));if(!!M.length){const q={tests:M.map(K=>N.unwrap(K.actual)),exclude:W.map(([,K])=>N.unwrap(K.actual)),debug:L.debug};await this.runQueue.enqueueRun({dto:l.fromInternal(L),token:O,extensionId:F.extensionId,req:q,doRun:()=>F.instance.runTests(q,O)})}}}$lookupTest(L){const O=this.ownedTests.getTestById(L.testId);if(!O)return Promise.resolve(void 0);const F=O[1],{actual:M,discoverCts:W,expandLevels:q}=F,K=Xt(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(K)}flushCollectionDiffs(){for(const{collection:L}of this.testControllers.values())L.flushDiff()}getInternalTestForReference(L){var O,F;return(F=(O=this.workspaceObservers.getMirroredTestDataByReference(L))!==null&&O!==void 0?O:(0,b.mapFind)(this.testControllers.values(),M=>M.collection.getTestByReference(L)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(L)}};g=qe([He(0,E.IExtHostRpcService),He(1,d.IExtHostDocumentsAndEditors),He(2,c.IExtHostWorkspace)],g),e.ExtHostTesting=g;class _{constructor(L){this.proxy=L,this.state=new Map}enqueueRun(L){let O=this.state.get(L.extensionId);O||(O={queue:[],current:void 0},this.state.set(L.extensionId,O));const F=new R.DeferredPromise,M=()=>{const W=[],q=new Set;O.current={publicReq:L.req,factory:K=>{const le=new w(K,L.dto,q,this.proxy);return W.push(le),L.token.onCancellationRequested(()=>le.end()),le}},this.invokeRunner(L.extensionId,L.dto.id,L.doRun,W).finally(()=>F.complete())};return O.queue.push(M),O.queue.length===1&&M(),F.p}createTestRun(L,O,F,M){var W,q;const K=this.state.get(L);if((K==null?void 0:K.current.publicReq)===O)return K.current.factory(F);const le=l.fromPublic(O),ve=new w(F,le,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:O.debug,exclude:(q=(W=O.exclude)===null||W===void 0?void 0:W.map(Re=>Re.id))!==null&&q!==void 0?q:[],id:le.id,tests:O.tests.map(Re=>Re.id),persist:M}),ve.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(le.id)),ve}invokeRunner(L,O,F,M){try{const W=F();return(0,R.isThenable)(W)?W.then(()=>this.handleInvokeResult(L,O,M,void 0)).catch(q=>this.handleInvokeResult(L,O,M,q)):this.handleInvokeResult(L,O,M,void 0)}catch(W){return this.handleInvokeResult(L,O,M,W)}}async handleInvokeResult(L,O,F,M){const W=this.state.get(L);!W||(W.queue.shift(),W.queue.length>0?W.queue[0]():this.state.delete(L),await Promise.all(F.map(q=>q.onEnd.wait())))}}class l{constructor(L,O,F){this.id=L,this.include=O,this.exclude=F}static fromPublic(L){var O,F;return new l((0,m.generateUuid)(),new Set(L.tests.map(M=>M.id)),new Set((F=(O=L.exclude)===null||O===void 0?void 0:O.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(L){return new l(L.runId,new Set(L.tests.map(O=>O.testId)),new Set(L.excludeExtIds))}isIncluded(L){for(let O=L;O;O=O.parent){if(this.include.has(O.id))return!0;if(this.exclude.has(O.id))return!1}return!0}}class w{constructor(L,O,F,M){this.name=L,n.set(this,void 0),s.set(this,void 0),i.set(this,(0,m.generateUuid)()),a.set(this,void 0),this.onEnd=new R.Barrier,it(this,n,M,"f"),it(this,s,O,"f"),it(this,a,F,"f"),M.$startedTestRunTask(O.id,{id:$e(this,i,"f"),name:L,running:!0})}setState(L,O,F){$e(this,s,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),$e(this,n,"f").$updateTestStateInRun($e(this,s,"f").id,$e(this,i,"f"),L.id,O,F))}appendMessage(L,O){$e(this,s,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),$e(this,n,"f").$appendTestMessageInRun($e(this,s,"f").id,$e(this,i,"f"),L.id,S.TestMessage.from(O)))}appendOutput(L){$e(this,n,"f").$appendOutputToRun($e(this,s,"f").id,$e(this,i,"f"),I.VSBuffer.fromString(L))}end(){$e(this,n,"f").$finishedTestRunTask($e(this,s,"f").id,$e(this,i,"f")),this.onEnd.open()}ensureTestIsKnown(L){const O=$e(this,a,"f");if(!O.has(L.id)){const F=[];for(;F.unshift(S.TestItem.from(L)),!(O.has(L.id)||(O.add(L.id),!L.parent));)L=L.parent;$e(this,n,"f").$addTestsToRun($e(this,s,"f").id,F)}}}n=new WeakMap,s=new WeakMap,i=new WeakMap,a=new WeakMap;const T=async(x,L,O,F)=>{if(!!O){const M=await x.createWorkspaceTestRoot(O,F);if(!!M){F.onCancellationRequested(()=>{N.removeFilter(L)});const W=N.getWrapperForTestItem(M,L);return W.refreshMatch(),W}}};e.createDefaultDocumentTestRoot=T;class N extends u.TestItemImpl{constructor(L,O,F){super(L.id,L.label,L.uri,void 0);if(this.actual=L,this.filterDocument=O,this.actualParent=F,!(L instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${L.id} did not`);this.debuggable=L.debuggable,this.runnable=L.runnable,this.description=L.description,this.error=L.error,this.status=L.status,this.range=L.range,this.resolveHandler=L.resolveHandler;const M=(0,v.getPrivateApiFor)(this);(0,v.getPrivateApiFor)(L).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const K=N.getWrapperForTestItem(q[1],this.filterDocument,this);(0,v.getPrivateApiFor)(K).parent=L,K.refreshMatch();break;default:M.bus.fire(q)}})}static removeFilter(L){this.wrapperMap.delete(L)}static getWrapperForTestItem(L,O,F){let M=this.wrapperMap.get(O);if(M==null?void 0:M.has(L))return M.get(L);M||(M=new WeakMap,this.wrapperMap.set(O,M));const W=new N(L,O,F);return M.set(L,W),W}static unwrap(L){return L instanceof N?L.actual:L}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var L,O;const F=this._cachedMatchesFilter;for(const W of this.actual.children.values()){const q=N.getWrapperForTestItem(W,this.filterDocument,this);q.hasNodeMatchingFilter?this.children.has(q.id)||this.addChild(q):q.dispose()}const M=this.children.size>0||((L=this.actual.uri)===null||L===void 0?void 0:L.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((O=this.actualParent)===null||O===void 0||O.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,v.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,v.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class z extends t.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,S.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:O,removed:F}=this;return{get added(){return[...L].map(M=>M.revived)},get updated(){return[...O].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ne extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(L){let O=[];for(const F of L){const M=this.items.get(F);M&&O.push(M.revived)}return O}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,O){return Object.assign(Object.assign({},L),{revived:S.TestItem.toPlain(L.item),depth:O?O.depth+1:0,children:new Set})}createChangeCollector(){return new z(this.changeEmitter)}}e.MirroredTestCollection=ne;class ie{constructor(){this.resources=new Map}checkout(L){var O,F;const M=L.toString(),W=(O=this.resources.get(M))!==null&&O!==void 0?O:this.createObserverData(L);return(F=W.pendingDeletion)===null||F===void 0||F.dispose(),W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return W.tests.rootTestItems},dispose:(0,C.once)(()=>{--W.observers||(W.pendingDeletion=this.eventuallyDispose(L))})}}getMirroredTestDataByReference(L){for(const{tests:O}of this.resources.values()){const F=O.getMirroredTestDataByReference(L);if(F)return F}}eventuallyDispose(L){return(0,R.disposableTimeout)(()=>this.unlisten(L),10*1e3)}createObserverData(L){const O=new ne,F=this.listen(L,W=>O.apply(W)),M={observers:0,tests:O,listener:F};return this.resources.set(L.toString(),M),M}unlisten(L){var O;const F=L.toString(),M=this.resources.get(F);M&&(M.observers=-1,(O=M.pendingDeletion)===null||O===void 0||O.dispose(),M.listener.dispose(),this.resources.delete(F))}}class U extends ie{constructor(L){super();this.proxy=L,this.diffListeners=new Map}acceptDiff(L,O){var F;(F=this.diffListeners.get(L.toString()))===null||F===void 0||F(O)}listen(L,O){this.proxy.$subscribeToDiffs(0,L);const F=L.toString();return this.diffListeners.set(F,O),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,L),this.diffListeners.delete(F)})}}class B extends ie{constructor(L,O){super();this.proxy=L,this.documents=O,this.diffListeners=new Map}acceptDiff(L,O){var F;(F=this.diffListeners.get(L.toString()))===null||F===void 0||F(O)}listen(L,O){if(!this.documents.getDocument(L))return new u.Disposable(()=>{});const M=L.toString();return this.diffListeners.set(M,O),this.proxy.$subscribeToDiffs(1,L),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,L),this.diffListeners.delete(M)})}}}),define(me[256],ge([0,1,16,53,32,77,22,12,9,25,8,11,2,140,171,84,61,208,254,31]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(_,l,w,T){this.configurationService=_,this.workspaceContextService=l,this.editorGroupsService=w,this.pathService=T}text(_,l,w={}){_=this.getContentPattern(_,w);const T=this.configurationService.getValue(),N=l&&l.some(ne=>!this.configurationService.getValue({resource:ne}).search.useRipgrep),z=this.commonQuery(l==null?void 0:l.map(E.toWorkspaceFolder),w);return Object.assign(Object.assign({},z),{type:2,contentPattern:_,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:T.search.usePCRE2||N||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles})}getContentPattern(_,l){const w=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const T=Object.assign(Object.assign({},_),{wordSeparators:w.editor.wordSeparators});return this.isCaseSensitive(_,l)&&(T.isCaseSensitive=!0),this.isMultiline(_)&&(T.isMultiline=!0),T}file(_,l={}){const w=this.commonQuery(_,l);return Object.assign(Object.assign({},w),{type:1,filePattern:l.filePattern?l.filePattern.trim():l.filePattern,exists:l.exists,sortByScore:l.sortByScore,cacheKey:l.cacheKey})}handleIncludeExclude(_,l){return _?(_=Array.isArray(_)?_.map(i):i(_),l?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],l={}){const w=this.handleIncludeExclude(l.includePattern,l.expandPatterns),T=this.handleIncludeExclude(l.excludePattern,l.expandPatterns),N=_.length>1,z=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,l,T)):_.map(U=>this.getFolderQueryForRoot(U,l,T,N))).filter(U=>!!U),ne={_reason:l._reason,folderQueries:z,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:l.extraFileResources,excludePattern:T.pattern,includePattern:w.pattern,onlyOpenEditors:l.onlyOpenEditors,maxResults:l.maxResults};if(l.onlyOpenEditors){const B=b.coalesce(b.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(O=>O.resource)))).filter(L=>(0,u.pathIncludedInQuery)(ne,L.fsPath)),x=this.commonQueryFromFileList(B);return Object.assign(Object.assign({},ne),x)}const ie=l.extraFileResources&&l.extraFileResources.filter(U=>(0,u.pathIncludedInQuery)(ne,U.fsPath));return ne.extraFileResources=ie&&ie.length?ie:void 0,ne}commonQueryFromFileList(_){const l=[],w=new y.ResourceMap,T={};let N=!1;return _.forEach(z=>{var ne,ie;if(z.scheme!==C.Schemas.walkThrough)if((0,k.isAbsolutePath)(z)){const B=(ie=(ne=this.workspaceContextService.getWorkspaceFolder(z))===null||ne===void 0?void 0:ne.uri)!==null&&ie!==void 0?ie:z.with({path:D.dirname(z.fsPath)});let x=w.get(B);x||(N=!0,x={folder:B,includePattern:{}},l.push(x),w.set(B,x));const L=D.relative(B.fsPath,z.fsPath);(0,P.assertIsDefined)(x.includePattern)[L.replace(/\\/g,"/")]=!0}else z.fsPath&&(N=!0,T[z.fsPath]=!0)}),{folderQueries:l,includePattern:T,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(_,l){if(l.isSmartCase){if(_.isRegExp){if(r.containsUppercaseCharacter(_.pattern,!0))return!0}else if(r.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,m.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const l=x=>D.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),T=(Array.isArray(_)?_:n(_)).map(x=>{const L=this.pathService.resolvedUserHome;return L?(0,A.untildify)(x,L.scheme===C.Schemas.file?L.fsPath:L.path):x}),N=R.groupBy(T,x=>l(x)?"searchPaths":"exprSegments"),z=(N.exprSegments||[]).map(x=>r.rtrim(x,"/")).map(x=>r.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),s(x))),ne={},ie=this.expandSearchPathPatterns(N.searchPaths||[]);ie&&ie.length&&(ne.searchPaths=ie);const U=b.flatten(z),B=t(...U);return B&&(ne.pattern=B),ne}getExcludesForFolder(_,l){return l.disregardExcludeSettings?void 0:(0,u.getExcludes)(_,!l.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const l=b.flatten(_.map(T=>{let{pathPortion:N,globPortion:z}=h(T);z&&(z=a(z));const ne=this.expandOneSearchPath(N);return b.flatten(ne.map(ie=>this.resolveOneSearchPathPattern(ie,z)))})),w=new Map;return l.forEach(T=>{const N=T.searchPath.toString(),z=w.get(N);z?T.pattern&&(z.pattern=z.pattern||{},z.pattern[T.pattern]=!0):w.set(N,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(_){if(D.isAbsolute(_)){const l=this.workspaceContextService.getWorkspace().folders;return l[0]&&l[0].uri.scheme!==C.Schemas.file?[{searchPath:l[0].uri.with({path:_})}]:[{searchPath:f.URI.file(D.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const l=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=i(_),_.startsWith("../")||_===".."){const T=D.posix.resolve(l.path,_);return[{searchPath:l.with({path:T})}]}const w=a(_);return[{searchPath:l,pattern:w}]}else{if(_==="./"||_===".\\")return[];{const l=_.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(N=>{const z=l.match(new RegExp(`^${N.name}(?:/(.*))?`));return z?{match:z,folder:N}:null}).filter(P.isDefined);if(T.length)return T.map(N=>{const z=N.match[1];return{searchPath:N.folder.uri,pattern:z&&a(z)}});{const N=_.match(/\.[\/\\](.+)[\/\\]?/),z=N?N[1]:_,ne=o.localize(0,null,z);throw new Error(ne)}}}}resolveOneSearchPathPattern(_,l){const w=_.pattern&&l?`${_.pattern}/${l}`:_.pattern||l,T=[{searchPath:_.searchPath,pattern:w}];return w&&!w.endsWith("**")&&T.push({searchPath:_.searchPath,pattern:w+"/**"}),T}getFolderQueryForSearchPath(_,l,w){const T=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(_.searchPath),l,w,!1);return T?Object.assign(Object.assign({},T),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,l,w,T){let N;const z=f.URI.isUri(_)?_:_.uri;if(w.searchPaths){const x=w.searchPaths.filter(L=>(0,k.isEqual)(L.searchPath,z))[0];if(x&&!x.pattern)return null;x&&(N=x.pattern)}const ne=this.configurationService.getValue({resource:z}),ie=this.getExcludesForFolder(ne,l),U=Object.assign(Object.assign({},ie||{}),N||{}),B=f.URI.isUri(_)?(0,k.basename)(_):_.name;return{folder:z,folderName:T?B:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:ne.files&&ne.files.encoding,disregardIgnoreFiles:typeof l.disregardIgnoreFiles=="boolean"?l.disregardIgnoreFiles:!ne.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof l.disregardGlobalIgnoreFiles=="boolean"?l.disregardGlobalIgnoreFiles:!ne.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof l.ignoreSymlinks=="boolean"?l.ignoreSymlinks:!ne.search.followSymlinks}}};c=qe([He(0,d.IConfigurationService),He(1,E.IWorkspaceContextService),He(2,v.IEditorGroupsService),He(3,S.IPathService)],c),e.QueryBuilder=c;function h(g){const _=g.match(/[\*\{\}\(\)\[\]\?]/);if(_){const l=_.index,w=g.substr(0,l).match(/[/|\\][^/\\]*$/);if(w){let T=g.substr(0,w.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:g.substr((w.index||0)+1)}}}return{pathPortion:g}}function t(...g){return g.length?g.reduce((_,l)=>(_[l]=!0,_),Object.create(null)):void 0}function n(g){return I.splitGlobAware(g,",").map(_=>_.trim()).filter(_=>!!_.length)}function s(g){return[`**/${g}/**`,`**/${g}`].map(l=>l.replace(/\*\*\/\*\*/g,"**"))}function i(g){return g.replace(/\\/g,"/")}function a(g){return i(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(g,_){g=b.distinct(g,T=>T.toString());const l=[],w=_.getWorkspace();return g&&g.forEach(T=>{let N;if(_.getWorkbenchState()===2)N=(0,k.relativePath)(w.folders[0].uri,T),N&&N!=="."&&(N="./"+N);else{const z=_.getWorkspaceFolder(T);if(z){const ne=z.name;if(w.folders.filter(U=>U.name===ne).length===1){const U=(0,k.relativePath)(z.uri,T);U===""?N=`./${z.name}`:N=`./${z.name}/${U}`}else N=T.fsPath}}N&&l.push(N)}),l}e.resolveResourcesForSearchIncludes=p}),define(me[257],ge([0,1,25,2,21,17,4,256,31,61]),function(Q,e,b,R,I,A,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const r=7e3;function P(d,E){const v=E.activationEvents;if(!v)return Promise.resolve(void 0);const S=[],u=[];for(const i of v)if(/^workspaceContains:/.test(i)){const a=i.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||d.forceUsingSearch?u.push(a):S.push(a)}if(S.length===0&&u.length===0)return Promise.resolve(void 0);let c;const h=new Promise((i,a)=>{c=i}),t=i=>c({activationEvent:i}),n=Promise.all(S.map(i=>f(d,i,t))).then(()=>{}),s=m(d,E.identifier,u,t);return Promise.all([n,s]).then(()=>{c(void 0)}),h}e.checkActivateWorkspaceContainsExtension=P;async function f(d,E,v){for(const S of d.folders)if(await d.exists(b.joinPath(R.URI.revive(S),E))){v(`workspaceContains:${E}`);return}}async function m(d,E,v,S){if(v.length===0)return Promise.resolve(void 0);const u=new I.CancellationTokenSource,c=d.checkExists(d.folders,v,u.token),h=setTimeout(async()=>{u.cancel(),S(`workspaceContainsTimeout:${v.join(",")}`)},r);let t=!1;try{t=await c}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}u.dispose(),clearTimeout(h),t&&S(`workspaceContains:${v.join(",")}`)}function o(d,E,v,S){const u=d.get(y.IInstantiationService),c=d.get(D.ISearchService),t=u.createInstance(C.QueryBuilder).file(E.map(n=>(0,k.toWorkspaceFolder)(R.URI.revive(n))),{_reason:"checkExists",includePattern:v,exists:!0});return c.fileSearch(t,S).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=o});var it=this&&this.__classPrivateFieldSet||function(Q,e,b,R,I){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?I.call(Q,b):I?I.value=b:e.set(Q,b),b},$e=this&&this.__classPrivateFieldGet||function(Q,e,b,R){if(b==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?R:b==="a"?R.call(Q):R?R.value:e.get(Q)};define(me[42],ge([0,1,161,9,70,25,13,6,22,2,14,5,35,219,91,34,40,217,17,26,23,194,7,85,4,27,92,15,82,49,33,3,257,89,195]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S,u,c,h,t,n,s,i,a,p,g,_,l,w,T,N,z){"use strict";var ne,ie,U;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let B=class Nn extends C.Disposable{constructor(F,M,W,q,K,le,ve,Re,Se,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=W,this._initData=ve,this._extHostWorkspace=q,this._extHostConfiguration=K,this._logService=le,this._extHostTunnelService=Se,this._extHostTerminalService=Oe,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=F.createChild(new g.ServiceCollection([o.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const V=new Set;this._initData.hostExtensions.forEach(X=>V.add(u.ExtensionIdentifier.toKey(X))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(X,Z,se)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(X,S.transformErrorForSerialization(Z),se)},actualActivateExtension:async(X,Z)=>{if(V.has(u.ExtensionIdentifier.toKey(X)))return await this._mainThreadExtensionsProxy.$activateExtension(X,Z),new m.HostExtension;const se=this._registry.getExtensionDescription(X);return this._activateExtension(se,Z)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){S.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const W=this._activator.getActivatedExtension(F);if(W.activationFailed)return Promise.reject(W.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(W=>{if(!!this._getEntryPoint(W))return this._hostUtils.realpath(W.extensionLocation.fsPath).then(q=>F.set(k.URI.file(q).fsPath,W))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const W=this._activator.getActivatedExtension(F);if(!W)return M;try{typeof W.module.deactivate=="function"&&(M=Promise.resolve(W.module.deactivate()).then(void 0,q=>Promise.resolve(void 0)))}catch(q){}try{(0,C.dispose)(W.subscriptions)}catch(q){}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(W=>{const q=W.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",q),W},W=>{throw this._logExtensionActivationTimes(F,M,"failure"),W})}_logExtensionActivationTimes(F,M,W,q){const K=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},K),q||{}),{outcome:W}))}_doActivateExtension(F,M){const W=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",W);const q=this._getEntryPoint(F);if(!q)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const K=new m.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,(0,A.joinPath)(F.extensionLocation,q),K),this._loadExtensionContext(F)]).then(le=>(I.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),Nn._callActivate(this._logService,F.identifier,le[0],le[1],K))).then(le=>(I.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),le))}_loadExtensionContext(F){const M=new h.ExtensionGlobalMemento(F,this._storage),W=new h.ExtensionMemento(F.identifier.value,!1,this._storage),q=new z.ExtensionSecrets(F,this._secretState),K=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,W.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Re;return Object.freeze({globalState:M,workspaceState:W,secrets:q,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(Se){return R.join(F.extensionLocation.fsPath,Se)},get storagePath(){var Se;return(Se=ve._storagePath.workspaceValue(F))===null||Se===void 0?void 0:Se.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(F).fsPath},get logPath(){return R.join(ve._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return k.URI.joinPath(ve._initData.logsLocation,F.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(F)},get globalStorageUri(){return ve._storagePath.globalValue(F)},get extensionMode(){return K},get extension(){return Re===void 0&&(Re=new L(ve,F.identifier,F,le)),Re},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(F),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,W,q,K){return W=W||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,W,q,K).then(le=>new m.ActivatedExtension(!1,null,K.build(),W,le,q.subscriptions))}static _callActivateOptional(F,M,W,q,K){if(typeof W.activate=="function")try{K.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const le=typeof global=="object"?global:self,ve=W.activate.apply(le,[q]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(ve).then(Re=>(K.activateResolveStop(),Re))}catch(le){return Promise.reject(le)}else return Promise.resolve(W)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,W=>{this._logService.error(W)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],W=this._handleWorkspaceContainsEagerExtensions(M),q=Promise.all([F,W]).then(()=>{});return Promise.race([q,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(!this.isActivated(M.identifier)){const W=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:F.map(le=>le.uri),forceUsingSearch:W,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,ve,Re)=>this._mainThreadWorkspaceProxy.$checkExists(le,ve,Re)},K=await(0,T.checkActivateWorkspaceContainsExtension)(q,M);if(!!K)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:K.activationEvent}).then(void 0,le=>this._logService.error(le))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(b.localize(0,null));const W=await this._loadCommonJSModule(null,M,new m.ExtensionActivationTimesBuilder(!1));if(!W||typeof W.run!="function")throw new Error(b.localize(1,null,M.toString()));return new Promise((q,K)=>{const le=(Se,Oe)=>{Se?K(Se):q(typeof Oe=="number"&&Oe>0?1:0)},ve=(0,A.originalFSPath)(M),Re=W.run(ve,le);Re&&Re.then&&Re.then(()=>{q(0)}).catch(Se=>{K(Se.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,(0,C.toDisposable)(()=>{delete this._resolvers[F]})}async $resolveAuthority(F,M){const W=F.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const q=F.substr(0,W);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1);const K=this._resolvers[q];if(!K)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(K)),I.mark(`code/extHost/willResolveAuthority/${q}`);const le=await K.resolve(F,{resolveAttempt:M});I.mark(`code/extHost/didResolveAuthorityOK/${q}`);const ve={authority:F,host:le.host,port:le.port,connectionToken:le.connectionToken},Re={extensionHostEnv:le.extensionHostEnv,trust:le.trust};return{type:"ok",value:{authority:ve,options:Re,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(I.mark(`code/extHost/didResolveAuthorityError/${q}`),le instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(W=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(q=>q.extensionLocation=k.URI.revive(q.extensionLocation));const W=await this.getExtensionPathIndex();return await Promise.all(M.map(async q=>{const K=this._registry.getExtensionDescription(q);if(!!K){const le=await this._hostUtils.realpath(K.extensionLocation.fsPath);W.delete(k.URI.file(le).fsPath)}})),await Promise.all(F.map(async q=>{const K=await this._hostUtils.realpath(q.extensionLocation.fsPath);W.set(k.URI.file(K).fsPath,q)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=c.VSBuffer.alloc(F),W=Math.random()%256;for(let q=0;q<F;q++)M.writeUInt8(W,q);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};B=qe([He(0,s.IInstantiationService),He(1,e.IHostUtils),He(2,p.IExtHostRpcService),He(3,d.IExtHostWorkspace),He(4,f.IExtHostConfiguration),He(5,r.ILogService),He(6,i.IExtHostInitDataService),He(7,a.IExtensionStoragePaths),He(8,_.IExtHostTunnelService),He(9,l.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function x(O,F){return{id:O.identifier.value,name:O.name,extensionVersion:O.version,publisherDisplayName:O.publisher,activationEvents:O.activationEvents?O.activationEvents.join(","):null,isBuiltin:O.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class L{constructor(F,M,W,q){ne.set(this,void 0),ie.set(this,void 0),U.set(this,void 0),it(this,ne,F,"f"),it(this,ie,M,"f"),it(this,U,W.identifier,"f"),this.id=W.identifier.value,this.extensionUri=W.extensionLocation,this.extensionPath=R.normalize((0,A.originalFSPath)(W.extensionLocation)),this.packageJSON=W,this.extensionKind=q}get isActive(){return $e(this,ne,"f").isActivated($e(this,U,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,ne,"f").getExtensionExports($e(this,U,"f"))}activate(){return $e(this,ne,"f").activateByIdWithErrors($e(this,U,"f"),{startup:!1,extensionId:$e(this,ie,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,ne=new WeakMap,ie=new WeakMap,U=new WeakMap}),define(me[51],ge([0,1,9,2,3,13,5,7,121,34,42,41,207,35,202,15,4,11,36,48]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let c=class{constructor(g,_,l,w,T,N){this._workspaceService=_,this._extensionService=l,this._editorsService=w,this._configurationService=T,this._editorTabs=N,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=g.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(ne=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(g,_){const l=g;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let w=`debug:${encodeURIComponent(l.path||"")}`,T="?";return _&&(w+=`${T}session=${encodeURIComponent(_.id)}`,T="&"),w+=`${T}ref=${l.sourceReference}`,R.URI.parse(w)}else{if(l.path)return R.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const _=[];for(const l of g.getAllExtensionDescriptions())if(l.contributes){const w=l.contributes.debuggers;if(w&&w.length>0)for(const T of w)(0,o.isDebuggerMainContribution)(T)&&_.push(T.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const g=[];return this._breakpoints.forEach(_=>g.push(_)),g}addBreakpoints(g){this.startBreakpoints();const _=g.filter(T=>{const N=T.id;return this._breakpoints.has(N)?!1:(this._breakpoints.set(N,T),!0)});this.fireBreakpointChanges(_,[],[]);const l=[],w=new Map;for(const T of _)if(T instanceof C.SourceBreakpoint){let N=w.get(T.location.uri.toString());N||(N={type:"sourceMulti",uri:T.location.uri,lines:[]},w.set(T.location.uri.toString(),N),l.push(N)),N.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof C.FunctionBreakpoint&&l.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(l)}removeBreakpoints(g){this.startBreakpoints();const _=g.filter(N=>this._breakpoints.delete(N.id));this.fireBreakpointChanges([],_,[]);const l=_.filter(N=>N instanceof C.SourceBreakpoint).map(N=>N.id),w=_.filter(N=>N instanceof C.FunctionBreakpoint).map(N=>N.id),T=_.filter(N=>N instanceof C.DataBreakpoint).map(N=>N.id);return this._debugServiceProxy.$unregisterBreakpoints(l,w,T)}startDebugging(g,_,l){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,_,{parentSessionID:l.parentSession?l.parentSession.id:void 0,repl:l.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,_,l){if(!_)return new C.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:w,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,l,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,w),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(g,_,l){if(!l)return new C.Disposable(()=>{});if(!this.definesDebugType(g,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:w,factory:l}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,w),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==l),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(g,_){if(!_)return new C.Disposable(()=>{});const l=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:l,factory:_}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==_)})}async $runInTerminal(g,_){return Promise.resolve(void 0)}async $substituteVariables(g,_){if(!this._variableResolver){const[T,N]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,N)}let l;const w=await this.getFolder(g);return w&&(l={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(l,_)}createDebugAdapter(g,_){if(g.type==="implementation")return new i(g.implementation)}createSignService(){}async $startDASession(g,_){const l=this,w=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const N=this.convertToDto(T),z=this.createDebugAdapter(N,w);if(!z)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const ne=z;return this._debugAdapters.set(g,ne),this.getDebugAdapterTrackers(w).then(ie=>(ie&&this._debugAdaptersTrackers.set(g,ie),ne.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const B=U,x={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(B.arguments.value);x.body={signature:L},ne.sendResponse(x)}else throw new Error("no signer")}catch(L){x.success=!1,x.message=L.message,ne.sendResponse(x)}}else ie&&ie.onDidSendMessage&&ie.onDidSendMessage(U),U=(0,o.convertToVSCPaths)(U,!0),l._debugServiceProxy.$acceptDAMessage(g,U)}),ne.onError(U=>{ie&&ie.onError&&ie.onError(U),this._debugServiceProxy.$acceptDAError(g,U.name,U.message,U.stack)}),ne.onExit(U=>{ie&&ie.onExit&&ie.onExit((0,v.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(g,(0,v.withNullAsUndefined)(U),void 0)}),ie&&ie.onWillStartSession&&ie.onWillStartSession(),ne.startSession()))})}$sendDAMessage(g,_){_=(0,o.convertToDAPaths)(_,!1);const l=this._debugAdaptersTrackers.get(g);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(_);const w=this._debugAdapters.get(g);w&&w.sendMessage(_)}$stopDASession(g){const _=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),_&&_.onWillStopSession&&_.onWillStopSession();const l=this._debugAdapters.get(g);return this._debugAdapters.delete(g),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const _=[],l=[],w=[];if(g.added)for(const T of g.added){const N=T.id;if(N&&!this._breakpoints.has(N)){let z;if(T.type==="function")z=new C.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")z=new C.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const ne=R.URI.revive(T.uri);z=new C.SourceBreakpoint(new C.Location(ne,new C.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}z._id=N,this._breakpoints.set(N,z),_.push(z)}}if(g.removed)for(const T of g.removed){const N=this._breakpoints.get(T);N&&(this._breakpoints.delete(T),l.push(N))}if(g.changed){for(const T of g.changed)if(T.id){const N=this._breakpoints.get(T.id);if(N){if(N instanceof C.FunctionBreakpoint&&T.type==="function"){const z=N;z.enabled=T.enabled,z.condition=T.condition,z.hitCondition=T.hitCondition,z.logMessage=T.logMessage,z.functionName=T.functionName}else if(N instanceof C.SourceBreakpoint&&T.type==="source"){const z=N;z.enabled=T.enabled,z.condition=T.condition,z.hitCondition=T.hitCondition,z.logMessage=T.logMessage,z.location=new C.Location(R.URI.revive(T.uri),new C.Position(T.line,T.character))}w.push(N)}}}this.fireBreakpointChanges(_,l,w)}$provideDebugConfigurations(g,_,l){return(0,A.asPromise)(async()=>{const w=this.getConfigProviderByHandle(g);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(_);return w.provideDebugConfigurations(T,l)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(g,_,l,w){return(0,A.asPromise)(async()=>{const T=this.getConfigProviderByHandle(g);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.getFolder(_);return T.resolveDebugConfiguration(N,l,w)})}$resolveDebugConfigurationWithSubstitutedVariables(g,_,l,w){return(0,A.asPromise)(async()=>{const T=this.getConfigProviderByHandle(g);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.getFolder(_);return T.resolveDebugConfigurationWithSubstitutedVariables(N,l,w)})}async $provideDebugAdapter(g,_){const l=this.getAdapterDescriptorFactoryByHandle(g);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(_);return this.getAdapterDescriptor(l,w).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(g){const _=await this.getSession(g);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(g){const _=await this.getSession(g);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(g,_){const l=await this.getSession(g);l&&l._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(g,_){const w={session:await this.getSession(g),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(g){if(g instanceof C.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof C.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const _=this._adapterFactories.filter(l=>l.type===g);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(g){const _=this._adapterFactories.filter(l=>l.handle===g);if(_.length>0)return _[0].factory}getConfigProviderByHandle(g){const _=this._configProviders.filter(l=>l.handle===g);if(_.length>0)return _[0].provider}definesDebugType(g,_){if(g.contributes){const l=g.contributes.debuggers;if(l&&l.length>0){for(const w of l)if(w.label&&w.type&&w.type===_)return!0}}return!1}getDebugAdapterTrackers(g){const l=g.configuration.type,w=this._trackerFactories.filter(T=>T.type===l||T.type==="*").map(T=>(0,A.asPromise)(()=>T.factory.createDebugAdapterTracker(g)).then(N=>N,N=>null));return Promise.race([Promise.all(w).then(T=>{const N=T.filter(z=>!!z);if(N.length>0)return new s(N)}),new Promise((T,N)=>{const z=setTimeout(()=>{clearTimeout(z),N(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(g,_){const l=_.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new C.DebugAdapterServer(l));if(g){const T=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>g.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,T))).then(N=>{if(N)return N})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,w))}daExecutableFromPackage(g,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(g,_,l){(g.length>0||_.length>0||l.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:_,changed:l}))}async getSession(g){if(g)if(typeof g=="string"){const _=this._debugSessions.get(g);if(_)return _}else{let _=this._debugSessions.get(g.id);if(!_){const l=await this.getFolder(g.folderUri);_=new h(this._debugServiceProxy,g.id,g.type,g.name,l,g.configuration),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(g){if(g){const _=R.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};c=qe([He(0,d.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,r.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class h{constructor(g,_,l,w,T,N){this._debugServiceProxy=g,this._id=_,this._type=l,this._name=w,this._workspaceFolder=T,this._configuration=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(g){this._name=g,this._debugServiceProxy.$setDebugSessionName(this._id,g)}_acceptNameChanged(g){this._name=g}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(g,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,g,_)}getDebugProtocolBreakpoint(g){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,g.id)}}e.ExtHostDebugSession=h;class t{constructor(g){this.value=Object.freeze({append(_){g.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=t;class n extends f.AbstractVariableResolverService{constructor(g,_,l,w,T){function N(){if(_){const z=_.activeEditor();if(z)return z.document.uri;const ne=w.tabs.filter(ie=>ie.isActive);if(ne.length>0)return ne[0].resource}}super({getFolderUri:z=>{const ne=g.filter(ie=>ie.name===z);if(ne&&ne.length>0)return ne[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(z,ne)=>l.getConfiguration(void 0,z).get(ne),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const z=N();if(z)return b.normalize(z.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const z=N();if(z){const ne=T.getWorkspaceFolder(z);if(ne)return b.normalize(ne.uri.fsPath)}}},getSelectedText:()=>{if(_){const z=_.activeEditor();if(z&&!z.selection.isEmpty)return z.document.getText(z.selection)}},getLineNumber:()=>{if(_){const z=_.activeEditor();if(z)return String(z.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=n;class s{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(_=>_.onError?_.onError(g):void 0)}onExit(g,_){this.trackers.forEach(l=>l.onExit?l.onExit(g,_):void 0)}}class i extends D.AbstractDebugAdapter{constructor(g){super();this.implementation=g,g.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends c{constructor(g,_,l,w,T,N){super(g,_,l,w,T,N)}createVariableResolver(g,_,l){return new n(g,_,l,this._editorTabs)}};a=qe([He(0,d.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,r.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(me[258],ge([0,1,70,2,5,35,40,26,15,27,4,42,36,14]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(u,c,h,t,n,s,i){this._apiFactory=u,this._extensionRegistry=c,this._instaService=h,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,c,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,c,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let c of u.nodeModuleName)this._factories.set(c,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(c=>u.alternativeModuleName(c))}};o=qe([He(2,r.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,k.IExtHostInitDataService),He(6,m.ILogService)],o),e.RequireInterceptor=o;class d{constructor(u,c,h,t,n){this._apiFactory=u,this._extensionPaths=c,this._extensionRegistry=h,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,c){const h=this._extensionPaths.findSubstr(c.fsPath);if(h){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(h.identifier));return t||(t=this._apiFactory(h,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(h.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(u,c){this.nodeModuleName="keytar";const{environment:h}=c,t=u.getProxy(I.MainContext.MainThreadKeytar);if(h.appRoot){let n=h.appRoot.fsPath;f.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,i)=>t.$setPassword(n,s,i),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(u,c){return this._impl}alternativeModuleName(u){const c=u.length;if(!(c<=7||!this.alternativeNames)){const h=c-7;if((u.charAt(h)==="/"||u.charAt(h)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}}};E=qe([He(0,D.IExtHostRpcService),He(1,k.IExtHostInitDataService)],E);let v=class{constructor(u,c,h){this._extensionPaths=u,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=h.getProxy(I.MainContext.MainThreadTelemetry);const t=h.getProxy(I.MainContext.MainThreadWindow);this._impl=(n,s)=>{const i=R.URI.parse(n);return s?this.callOriginal(n,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,n,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,n,{}):this.callOriginal(n,s)}}load(u,c,h){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=h(u),this._impl}callOriginal(u,c){return this.sendNoForwardTelemetry(),this._original(u,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=qe([He(2,D.IExtHostRpcService)],v)}),define(me[259],ge([0,1,167,10,7,203,34,42,41,35,33,15,51,189,13,204,48]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let v=class extends f.ExtHostDebugServiceBase{constructor(c,h,t,n,s,i,a){super(c,h,t,n,s,a);this._terminalService=i,this._integratedTerminalInstances=new S}createDebugAdapter(c,h){switch(c.type){case"server":return new A.SocketDebugAdapter(c);case"pipeServer":return new A.NamedPipeDebugAdapter(c);case"executable":return new A.ExecutableDebugAdapter(c,h.type)}return super.createDebugAdapter(c,h)}daExecutableFromPackage(c,h){const t=A.ExecutableDebugAdapter.platformAdapterExecutable(h.getAllExtensionDescriptions(),c.type);if(t)return new I.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(c,h){if(c.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(T=>{this._integratedTerminalInstances.onTerminalClosed(T)}));const t=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),i=JSON.stringify({shell:n,shellArgs:s});let a=await this._integratedTerminalInstances.checkout(i),p,g=!1;if(a)p=c.cwd;else{const T={shellPath:n,shellArgs:s,cwd:c.cwd,name:c.title||b.localize(0,null)};g=!0,a=this._terminalService.createTerminalFromOptions(T,!0),this._integratedTerminalInstances.insert(a,i)}a.show(!0);const _=await a.processId;g?await new Promise(T=>setTimeout(T,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?a.sendText("cls"):n.indexOf("bash")>=0?a.sendText("clear"):R.isWindows?a.sendText("cls"):a.sendText("clear"));const l=(0,d.prepareCommand)(n,c.args,p,c.env);a.sendText(l);const w=this.onDidTerminateDebugSession(T=>{T.id===h&&(this._integratedTerminalInstances.free(a),w.dispose())});return _}else if(c.kind==="external")return(0,d.runInExternalTerminal)(c,await this._configurationService.getConfigProvider());return super.$runInTerminal(c,h)}createVariableResolver(c,h,t){return new f.ExtHostVariableResolverService(c,h,t,this._editorTabs,this._workspaceService)}};v=qe([He(0,P.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,r.IExtHostTerminalService),He(6,E.IExtHostEditorTabs)],v),e.ExtHostDebugService=v;class S{constructor(){this._terminalInstances=new Map}async checkout(c){const t=[...this._terminalInstances.entries()].map(([n,s])=>(0,o.createCancelablePromise)(async i=>{if(s.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await n.processId))return null;const a=Date.now();return s.lastUsedAt+S.minUseDelay>a||i.isCancellationRequested||s.config!==c?null:(s.lastUsedAt=a,n)}));return await(0,o.firstParallel)(t,n=>!!n)}insert(c,h){this._terminalInstances.set(c,{lastUsedAt:Date.now(),config:h})}free(c){const h=this._terminalInstances.get(c);h&&(h.lastUsedAt=-1)}onTerminalClosed(c){this._terminalInstances.delete(c)}}S.minUseDelay=1e3}),define(me[260],ge([0,1,9,2,111,34,51,41,35,33,15,27,69,12,14,65,48]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let v=class extends f.ExtHostTaskBase{constructor(u,c,h,t,n,s,i,a,p){super(u,c,h,t,n,s,i,a);this.workspaceService=h,this.editorTabs=p,c.remote.isRemote&&c.remote.authority?this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:c.remote.authority,platform:process.platform}):this.registerTaskSystem(m.Schemas.file,{scheme:m.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,c){const h=c;if(!c.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const t=f.TaskHandleDTO.from(h,this.workspaceService),n=await this._proxy.$getTaskExecution(t);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(n,c);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=f.TaskDTO.from(c,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,c,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),c);return this._proxy.$executeTask(t).catch(()=>{}),n}}provideTasksInternal(u,c,h,t){const n=[];if(t)for(let s of t){this.checkDeprecation(s,h),(!s.definition||!u[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const i=f.TaskDTO.from(s,h.extension);i&&(n.push(i),f.CustomExecutionDTO.is(i.execution)&&c.push(this.addCustomExecution(i,s,!0)))}return{tasks:n,extension:h.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const c=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(u,this._editorService,c,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,c){const h=R.URI.revive(u),t={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(h),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!n)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const i=await this.getVariableResolver(s),a={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}};for(let p of c.variables)t.variables[p]=await i.resolveAsync(a,p);if(c.process!==void 0){let p;if(c.process.path!==void 0){p=c.process.path.split(b.delimiter);for(let g=0;g<p.length;g++)p[g]=await i.resolveAsync(a,p[g])}t.process=await I.win32.findExecutable(await i.resolveAsync(a,c.process.name),c.process.cwd!==void 0?await i.resolveAsync(a,c.process.cwd):void 0,p)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,c,h){return I.win32.findExecutable(u,c,h)}};v=qe([He(0,r.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,k.IExtHostTerminalService),He(6,o.ILogService),He(7,d.IExtHostApiDeprecationService),He(8,E.IExtHostEditorTabs)],v),e.ExtHostTask=v}),define(me[261],ge([0,1,13,17,70,6,2,5,252,14,79,82,27,184,15,63,42,33]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(c,h,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new D.RPCProtocol(c,null,n);h=S._transform(h,s);const i=new P.ServiceCollection(...(0,r.getSingletonServiceDescriptors)());i.set(f.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},h)),i.set(o.IExtHostRpcService,new o.ExtHostRpcService(s)),i.set(d.IURITransformerService,new d.URITransformerService(n)),i.set(E.IHostUtils,t);const a=new m.InstantiationService(i,!0),p=a.invokeFunction(w=>w.get(v.IExtHostTerminalService));this._disposables.add(p),this._logService=a.invokeFunction(w=>w.get(k.ILogService)),I.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",h),this._extensionService=a.invokeFunction(w=>w.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(w=>{Error.prepareStackTrace=(T,N)=>{let z="",ne,ie;for(const U of N)z+=`
	at ${U.toString()}`,ie=U.getFileName(),!ne&&ie&&(ne=w.findSubstr(ie));return g.set(T,ne),`${T.name||"Error"}: ${T.message||""}${z}`}});const _=s.getProxy(C.MainContext.MainThreadExtensionService),l=s.getProxy(C.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(w=>{const T=R.transformErrorForSerialization(w),N=g.get(w);N?_.$onExtensionRuntimeError(N.identifier,T):l.$onUnexpectedError(T)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{});const h=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),h]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,h){c.extensions.forEach(n=>n.extensionLocation=y.URI.revive(h.transformIncomingURIs(n.extensionLocation))),c.environment.appRoot=y.URI.revive(h.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(h.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=y.URI.revive(h.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(h.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(h.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(h.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(h.transformIncomingURIs(c.logFile)),c.workspace=h.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=S}),define(me[262],ge([0,1,9,21,60,32,25,45,31]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(f,m,o){this.config=f,this.provider=m,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&A.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&A.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const m=this.config.folderQueries||[];return new Promise((o,d)=>{const E=v=>{this.resultCount++,f(v)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const S=v.toString(),u=b.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,u)||this.matchFile(E,{base:v,basename:u})}),Promise.all(m.map(v=>this.searchInFolder(v,E))).then(v=>{o({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{d(new Error((0,I.toErrorMessage)(v)))})})}async searchInFolder(f,m){const o=new R.CancellationTokenSource,d=this.getSearchOptionsForFolder(f),E=this.initDirectoryTree(),v=new D.QueryGlobTester(this.config,f),S=!v.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(o),u=C.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,o.token),h=u.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(n=>{const s=b.posix.relative(f.folder.path,n.path);if(S){const i=b.basename(n.path);this.matchFile(m,{base:f.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(E,f.folder,s,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,v,m),{providerTime:h,postProcessTime:t.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(f){const m=(0,D.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),o=(0,D.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:o,includes:m,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},m,o,d){if(o===this.filePattern){const v=b.basename(this.filePattern);this.matchFile(d,{base:m,relativePath:this.filePattern,basename:v})}function E(v){const S=b.basename(v),u=b.dirname(v);let c=f[u];c||(c=f[u]=[],E(u)),c.push({base:m,relativePath:v,basename:S})}E(o)}matchDirectoryTree({rootEntries:f,pathToEntries:m},o,d){const E=this,v=this.filePattern;function S(u){const c=A.hasSiblingFn(()=>u.map(h=>h.basename));for(let h=0,t=u.length;h<t;h++){const n=u[h],{relativePath:s,basename:i}=n;if(!!o.includedInQuerySync(s,i,v!==i?c:void 0)){const a=m[s];if(a)S(a);else{if(s===v)continue;E.matchFile(d,n)}if(E.isLimitHit)break}}}S(f)}matchFile(f,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(m))}}class r{constructor(){this.sessions=new Map}fileSearch(f,m,o,d){const E=this.getSessionTokenSource(f.cacheKey),v=new k(f,m,E&&E.token);let S=0;const u=c=>{S+=c.length,o(c.map(h=>this.rawMatchToSearchItem(h)))};return this.doSearch(v,r.BATCH_SIZE,u,d).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:c.stats}}))}clearCache(f){const m=this.getSessionTokenSource(f);m&&m.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new R.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:y.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,m,o,d){d.onCancellationRequested(()=>{f.cancel()});const E=S=>{S&&(v.push(S),m>0&&v.length>=m&&(o(v),v=[]))};let v=[];return f.search(E).then(S=>(v.length&&o(v),S),S=>(v.length&&o(v),Promise.reject(S)))}}e.FileSearchManager=r,r.BATCH_SIZE=512}),define(me[128],ge([0,1,9,16,21,60,25,32,2,31,12,11]),function(Q,e,b,R,I,A,y,C,D,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class f{constructor(u,c,h){this.query=u,this.provider=c,this.fileUtils=h,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,c){const h=this.query.folderQueries||[],t=new I.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new o(u);let i=!1;const a=(p,g)=>{if(!i&&!this.isLimitHit){const _=this.resultSize(p);E(p)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const l=this.resultSize(p);this.resultCount+=l,(l>0||!E(p))&&this.collector.add(p,g)}};Promise.all(h.map((p,g)=>this.searchInFolder(p,_=>a(_,g),t.token))).then(p=>{t.dispose(),this.collector.flush();const g=p.some(_=>!!_&&!!_.limitHit);n({limitHit:this.isLimitHit||g,messages:(0,R.flatten)(p.map(_=>(_==null?void 0:_.message)?(0,P.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},p=>{t.dispose();const g=(0,A.toErrorMessage)(p);s(new Error(g))})})}resultSize(u){return E(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,c){const h=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:h.slice(0,c),preview:{matches:t.slice(0,c),text:u.preview.text},uri:u.uri}}async searchInFolder(u,c,h){const t=new k.QueryGlobTester(this.query,u),n=[],s={report:p=>{if(!!this.validateProviderResult(p)){const g=u.folder.scheme===r.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(p.uri))):void 0,_=y.relativePath(u.folder,p.uri);_&&n.push(t.includedInQuery(_,b.basename(_),g).then(l=>{l&&c(p)}))}}},i=this.getSearchOptionsForFolder(u),a=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,s,h);return await Promise.all(n),a}validateProviderResult(u){if(E(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const c=(0,k.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),h=(0,k.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),t={folder:D.URI.from(u.folder),excludes:h,includes:c,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=f;function m(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class o{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,c=>this.sendItems(c))}add(u,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(d(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=o;function d(S){return E(S)?{preview:{matches:(0,R.mapArrayOrNot)(S.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:S.preview.text},ranges:(0,R.mapArrayOrNot)(S.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function E(S){return!!S.preview}e.extensionResultIsMatch=E;class v{constructor(u,c){this.maxBatchSize=u,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,c){!u||this.addItemToBatch(u,c)}addItems(u,c){!u||this.addItemsToBatch(u,c)}addItemToBatch(u,c){this.batch.push(u),this.batchSize+=c,this.onUpdate()}addItemsToBatch(u,c){this.batch=this.batch.concat(u),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(me[71],ge([0,1,6,5,4,262,15,63,14,2,128]),function(Q,e,b,R,I,A,y,C,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let P=class{constructor(d,E,v){this.extHostRpc=d,this._uriTransformer=E,this._logService=v,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,E){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const v=this._handlePool++;return this._textSearchProvider.set(v,E),this._proxy.$registerTextSearchProvider(v,this._transformScheme(d)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(d,E){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const v=this._handlePool++;return this._fileSearchProvider.set(v,E),this._proxy.$registerFileSearchProvider(v,this._transformScheme(d)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(d,E,v,S){const u=f(v),c=this._fileSearchProvider.get(d);if(c)return this._fileSearchManager.fileSearch(u,c,h=>{this._proxy.$handleFileMatch(d,E,h.map(t=>t.resource))},S);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,E,v,S){const u=this._textSearchProvider.get(d);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const c=f(v);return this.createTextSearchManager(c,u).search(t=>this._proxy.$handleTextMatch(d,E,t),S)}createTextSearchManager(d,E){return new r.TextSearchManager(d,E,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};P=qe([He(0,y.IExtHostRpcService),He(1,C.IURITransformerService),He(2,D.ILogService)],P),e.ExtHostSearch=P;function f(o){return Object.assign(Object.assign({},o),{folderQueries:o.folderQueries&&o.folderQueries.map(m),extraFileResources:o.extraFileResources&&o.extraFileResources.map(d=>k.URI.revive(d))})}e.reviveQuery=f;function m(o){return Object.assign(Object.assign({},o),{folder:k.URI.revive(o.folder)})}}),define(me[263],ge([0,1,159,21,17,3,58,2,150,107,141,78,44,5,225,224,50,226,35,227,228,229,210,230,41,42,231,211,233,234,235,66,214,238,239,240,91,33,241,215,20,7,244,67,127,34,40,53,199,232,117,126,69,51,71,14,63,15,27,236,197,49,65,222,242,196,92,90,247,245,246,223,62,255,243,89,48,119,237,85,68]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S,u,c,h,t,n,s,i,a,p,g,_,l,w,T,N,z,ne,ie,U,B,x,L,O,F,M,W,q,K,le,ve,Re,Se,Oe,V,X,Z,se,fe,Ee,Be,pe,Ce,Me,ze,_e,Ke,G,te,we,xe,je,Ve,Je,De,ye,Ie,oe,ue,H,J,ce,Pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ae(Fe){const We=Fe.get(Be.IExtHostInitDataService),Xe=Fe.get(De.IExtHostFileSystemInfo),rt=Fe.get(we.IExtHostConsumerFileSystem),tt=Fe.get(i.IExtHostExtensionService),Qe=Fe.get(q.IExtHostWorkspace),gt=Fe.get(H.IExtHostTelemetry),wt=Fe.get(S.IExtHostConfiguration),be=Fe.get(fe.IURITransformerService),he=Fe.get(Ee.IExtHostRpcService),ae=Fe.get(ie.IExtHostStorage),Y=Fe.get(te.IExtensionStoragePaths),Ne=Fe.get(se.ILogService),Le=Fe.get(Me.IExtHostTunnelService),Ye=Fe.get(ze.IExtHostApiDeprecationService),et=Fe.get(W.IExtHostWindow),ct=Fe.get(oe.IExtHostSecretState),ut=Fe.get(ue.IExtHostEditorTabs);he.set(m.ExtHostContext.ExtHostFileSystemInfo,Xe),he.set(m.ExtHostContext.ExtHostLogService,Ne),he.set(m.ExtHostContext.ExtHostWorkspace,Qe),he.set(m.ExtHostContext.ExtHostConfiguration,wt),he.set(m.ExtHostContext.ExtHostExtensionService,tt),he.set(m.ExtHostContext.ExtHostStorage,ae),he.set(m.ExtHostContext.ExtHostTunnelService,Le),he.set(m.ExtHostContext.ExtHostWindow,et),he.set(m.ExtHostContext.ExtHostSecretState,ct),he.set(m.ExtHostContext.ExtHostTelemetry,gt),he.set(m.ExtHostContext.ExtHostEditorTabs,ut);const Ze=he.set(m.ExtHostContext.ExtHostDecorations,Fe.get(Oe.IExtHostDecorations)),mt=he.set(m.ExtHostContext.ExtHostDocumentsAndEditors,Fe.get(s.IExtHostDocumentsAndEditors)),ht=he.set(m.ExtHostContext.ExtHostCommands,Fe.get(E.IExtHostCommands)),ft=he.set(m.ExtHostContext.ExtHostTerminalService,Fe.get(U.IExtHostTerminalService)),at=he.set(m.ExtHostContext.ExtHostDebugService,Fe.get(X.IExtHostDebugService)),St=he.set(m.ExtHostContext.ExtHostSearch,Fe.get(Z.IExtHostSearch)),Et=he.set(m.ExtHostContext.ExtHostTask,Fe.get(V.IExtHostTask)),Ot=he.set(m.ExtHostContext.ExtHostOutputService,Fe.get(w.IExtHostOutputService)),Tt=he.set(m.ExtHostContext.ExtHostUrls,new F.ExtHostUrls(he)),_t=he.set(m.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(he,mt)),Yt=he.set(m.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(he,mt,Ne)),Jt=he.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ne,_t,he.getProxy(m.MainContext.MainThreadBulkEdits))),pt=he.set(m.ExtHostContext.ExtHostNotebook,new pe.ExtHostNotebookController(he,ht,mt,_t,Ne,Y)),Zt=he.set(m.ExtHostContext.ExtHostNotebookKernels,new J.ExtHostNotebookKernels(he,We,pt,Ne)),Dt=he.set(m.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(he,mt)),qt=he.set(m.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(he.getProxy(m.MainContext.MainThreadTreeViews),ht,Ne)),en=he.set(m.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(he.getProxy(m.MainContext.MainThreadEditorInsets),Dt,Object.assign(Object.assign({},We.environment),{remote:We.remote}))),Kt=he.set(m.ExtHostContext.ExtHostDiagnostics,new u.ExtHostDiagnostics(he,Ne)),lt=he.set(m.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(he,be,_t,ht,Kt,Ne,Ye)),tn=he.set(m.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(he,lt)),Rt=he.set(m.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(he,Ne,mt)),$t=he.set(m.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(he,Qe,ht)),dn=he.set(m.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(he,ht,Ne)),En=he.set(m.ExtHostContext.ExtHostComments,new v.ExtHostComments(he,ht,_t)),hn=he.set(m.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(he.getProxy(m.MainContext.MainThreadProgress))),nn=he.set(m.ExtHostContext.ExtHosLabelService,new Re.ExtHostLabelService(he)),Gt=he.set(m.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(he)),Nt=he.set(m.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(he)),Sn=he.set(m.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(he,ht)),rn=he.set(m.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(he,Object.assign(Object.assign({},We.environment),{remote:We.remote}),Qe,Ne,Ye)),sn=he.set(m.ExtHostContext.ExtHostWebviewPanels,new Ve.ExtHostWebviewPanels(he,rn,Qe)),Qt=he.set(m.ExtHostContext.ExtHostCustomEditors,new je.ExtHostCustomEditors(he,_t,Y,rn,sn)),yn=he.set(m.ExtHostContext.ExtHostWebviewViews,new xe.ExtHostWebviewViews(he,rn)),Lt=he.set(m.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(he,mt,Qe)),on=he.set(m.ExtHostContext.ExtHostUriOpeners,new Ie.ExtHostUriOpeners(he)),Dn=(0,le.values)(m.ExtHostContext);he.assertRegistered(Dn);const Wt=new Je.ExtHostBulkEdits(he,mt),an=new d.ExtHostClipboard(he),Ut=new l.ExtHostMessageService(he,Ne),Pt=new c.ExtHostDialogs(he),fn=new ne.ExtHostStatusBar(he,ht.converter),xt=new _.ExtHostLanguages(he,_t);return o.ExtHostApiCommands.register(ht),function(Ue,ln,mn){const vt=function(){let ee=!Ue.isUnderDevelopment;function de(Te){ee||(Ne.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")de(st);else{const bt=st;typeof bt.scheme=="undefined"&&de(st),!Ue.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,K.throwProposedApiError)(Ue)}return st}}(),Cn={getSession(ee,de,Te){return Nt.getSession(Ue,ee,de,Te)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(ee,de,Te,st){return Nt.registerAuthenticationProvider(ee,de,Te,st)},get onDidChangeAuthenticationProviders(){return(0,K.checkProposedApiEnabled)(Ue),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,K.checkProposedApiEnabled)(Ue),Nt.providers},logout(ee,de){return(0,K.checkProposedApiEnabled)(Ue),Nt.removeSession(ee,de)}},kn={registerCommand(ee,de,Te){return ht.registerCommand(!0,ee,de,Te)},registerTextEditorCommand(ee,de,Te){return ht.registerCommand(!0,ee,(...st)=>{const bt=Dt.getActiveTextEditor();if(!bt){Ne.warn("Cannot execute "+ee+" because there is no active text editor.");return}return bt.edit(Ct=>{de.apply(Te,[bt,Ct,...st])}).then(Ct=>{Ct||Ne.warn("Edits from command "+ee+" were not applied.")},Ct=>{Ne.warn("An error occurred while running command "+ee,Ct)})})},registerDiffInformationCommand:(ee,de,Te)=>((0,K.checkProposedApiEnabled)(Ue),ht.registerCommand(!0,ee,async(...st)=>{const bt=mt.activeEditor(!0);if(!bt){Ne.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(bt.id);de.apply(Te,[Ct,...st])})),executeCommand(ee,...de){return ht.executeCommand(ee,...de)},getCommands(ee=!1){return ht.getCommands(ee)}},gn={get machineId(){return We.telemetryInfo.machineId},get sessionId(){return We.telemetryInfo.sessionId},get language(){return We.environment.appLanguage},get appName(){return We.environment.appName},get appRoot(){var ee,de;return(de=(ee=We.environment.appRoot)===null||ee===void 0?void 0:ee.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return We.environment.appUriScheme},get clipboard(){return an.value},get shell(){return ft.getDefaultShell(!1)},get isTelemetryEnabled(){return gt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return gt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ee=Date.now()-new Date(We.telemetryInfo.firstSessionDate).getTime();return isNaN(ee)?!1:ee<1e3*60*60*24},openExternal(ee,de){return et.openUri(ee,{allowTunneling:!!We.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(ee){return ee.scheme===We.environment.appUriScheme?Tt.createAppUri(ee):et.asExternalUri(ee,{allowTunneling:!!We.remote.authority})},get remoteName(){return(0,Se.getRemoteName)(We.remote.authority)},get uiKind(){return We.uiKind}};We.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=We.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Ht={registerTestController(ee){return(0,K.checkProposedApiEnabled)(Ue),Lt.registerTestController(Ue.identifier.value,ee)},createDocumentTestObserver(ee){return(0,K.checkProposedApiEnabled)(Ue),Lt.createTextDocumentTestObserver(ee)},createWorkspaceTestObserver(ee){return(0,K.checkProposedApiEnabled)(Ue),Lt.createWorkspaceTestObserver(ee)},runTests(ee){return(0,K.checkProposedApiEnabled)(Ue),Lt.runTests(ee)},createTestItem(ee,de){return new O.TestItemImpl(ee.id,ee.label,ee.uri,de)},createTestRun(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),Lt.createTestRun(Ue.identifier.value,ee,de,Te)},get onDidChangeTestResults(){return(0,K.checkProposedApiEnabled)(Ue),Lt.onResultsChanged},get testResults(){return(0,K.checkProposedApiEnabled)(Ue),Lt.results}};Ht.createTestRunTask=Ht.createTestRun;const In={getExtension(ee){const de=ln.getExtensionDescription(ee);if(de)return new i.Extension(tt,Ue.identifier,de,pn)},get all(){return ln.getAllExtensionDescriptions().map(ee=>new i.Extension(tt,Ue.identifier,ee,pn))},get onDidChange(){return ln.onDidChange}},Pn={createDiagnosticCollection(ee){return Kt.createDiagnosticCollection(Ue.identifier,ee)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:ee=>Kt.getDiagnostics(ee),getLanguages(){return xt.getLanguages()},setTextDocumentLanguage(ee,de){return xt.changeLanguage(ee.uri,de)},match(ee,de){return(0,P.score)(L.LanguageSelector.from(ee),de.uri,de.languageId,!0)},registerCodeActionsProvider(ee,de,Te){return lt.registerCodeActionProvider(Ue,vt(ee),de,Te)},registerCodeLensProvider(ee,de){return lt.registerCodeLensProvider(Ue,vt(ee),de)},registerDefinitionProvider(ee,de){return lt.registerDefinitionProvider(Ue,vt(ee),de)},registerDeclarationProvider(ee,de){return lt.registerDeclarationProvider(Ue,vt(ee),de)},registerImplementationProvider(ee,de){return lt.registerImplementationProvider(Ue,vt(ee),de)},registerTypeDefinitionProvider(ee,de){return lt.registerTypeDefinitionProvider(Ue,vt(ee),de)},registerHoverProvider(ee,de){return lt.registerHoverProvider(Ue,vt(ee),de,Ue.identifier)},registerEvaluatableExpressionProvider(ee,de){return lt.registerEvaluatableExpressionProvider(Ue,vt(ee),de,Ue.identifier)},registerInlineValuesProvider(ee,de){return lt.registerInlineValuesProvider(Ue,vt(ee),de,Ue.identifier)},registerDocumentHighlightProvider(ee,de){return lt.registerDocumentHighlightProvider(Ue,vt(ee),de)},registerLinkedEditingRangeProvider(ee,de){return lt.registerLinkedEditingRangeProvider(Ue,vt(ee),de)},registerReferenceProvider(ee,de){return lt.registerReferenceProvider(Ue,vt(ee),de)},registerRenameProvider(ee,de){return lt.registerRenameProvider(Ue,vt(ee),de)},registerDocumentSymbolProvider(ee,de,Te){return lt.registerDocumentSymbolProvider(Ue,vt(ee),de,Te)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(Ue,ee)},registerDocumentFormattingEditProvider(ee,de){return lt.registerDocumentFormattingEditProvider(Ue,vt(ee),de)},registerDocumentRangeFormattingEditProvider(ee,de){return lt.registerDocumentRangeFormattingEditProvider(Ue,vt(ee),de)},registerOnTypeFormattingEditProvider(ee,de,Te,...st){return lt.registerOnTypeFormattingEditProvider(Ue,vt(ee),de,[Te].concat(st))},registerDocumentSemanticTokensProvider(ee,de,Te){return lt.registerDocumentSemanticTokensProvider(Ue,vt(ee),de,Te)},registerDocumentRangeSemanticTokensProvider(ee,de,Te){return lt.registerDocumentRangeSemanticTokensProvider(Ue,vt(ee),de,Te)},registerSignatureHelpProvider(ee,de,Te,...st){return typeof Te=="object"?lt.registerSignatureHelpProvider(Ue,vt(ee),de,Te):lt.registerSignatureHelpProvider(Ue,vt(ee),de,typeof Te=="undefined"?[]:[Te,...st])},registerCompletionItemProvider(ee,de,...Te){return lt.registerCompletionItemProvider(Ue,vt(ee),de,Te)},registerDocumentLinkProvider(ee,de){return lt.registerDocumentLinkProvider(Ue,vt(ee),de)},registerColorProvider(ee,de){return lt.registerColorProvider(Ue,vt(ee),de)},registerFoldingRangeProvider(ee,de){return lt.registerFoldingRangeProvider(Ue,vt(ee),de)},registerSelectionRangeProvider(ee,de){return lt.registerSelectionRangeProvider(Ue,ee,de)},registerCallHierarchyProvider(ee,de){return lt.registerCallHierarchyProvider(Ue,ee,de)},setLanguageConfiguration:(ee,de)=>lt.setLanguageConfiguration(Ue,ee,de),getTokenInformationAtPosition(ee,de){return(0,K.checkProposedApiEnabled)(Ue),xt.tokenAtPosition(ee,de)},registerInlayHintsProvider(ee,de){return(0,K.checkProposedApiEnabled)(Ue),lt.registerInlayHintsProvider(Ue,ee,de)}},An={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(ee,de,Te){const st=await(C.URI.isUri(ee)?Promise.resolve(vn.openTextDocument(ee)):Promise.resolve(ee));return Dt.showTextDocument(st,de,Te)},createTextEditorDecorationType(ee){return Dt.createTextEditorDecorationType(ee)},onDidChangeActiveTextEditor(ee,de,Te){return Dt.onDidChangeActiveTextEditor(ee,de,Te)},onDidChangeVisibleTextEditors(ee,de,Te){return Dt.onDidChangeVisibleTextEditors(ee,de,Te)},onDidChangeTextEditorSelection(ee,de,Te){return Dt.onDidChangeTextEditorSelection(ee,de,Te)},onDidChangeTextEditorOptions(ee,de,Te){return Dt.onDidChangeTextEditorOptions(ee,de,Te)},onDidChangeTextEditorVisibleRanges(ee,de,Te){return Dt.onDidChangeTextEditorVisibleRanges(ee,de,Te)},onDidChangeTextEditorViewColumn(ee,de,Te){return Dt.onDidChangeTextEditorViewColumn(ee,de,Te)},onDidCloseTerminal(ee,de,Te){return ft.onDidCloseTerminal(ee,de,Te)},onDidOpenTerminal(ee,de,Te){return ft.onDidOpenTerminal(ee,de,Te)},onDidChangeActiveTerminal(ee,de,Te){return ft.onDidChangeActiveTerminal(ee,de,Te)},onDidChangeTerminalDimensions(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),ft.onDidChangeTerminalDimensions(ee,de,Te)},onDidWriteTerminalData(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),ft.onDidWriteTerminalData(ee,de,Te)},get state(){return et.state},onDidChangeWindowState(ee,de,Te){return et.onDidChangeWindowState(ee,de,Te)},showInformationMessage(ee,...de){return Ut.showMessage(Ue,y.default.Info,ee,de[0],de.slice(1))},showWarningMessage(ee,...de){return Ut.showMessage(Ue,y.default.Warning,ee,de[0],de.slice(1))},showErrorMessage(ee,...de){return Ut.showMessage(Ue,y.default.Error,ee,de[0],de.slice(1))},showQuickPick(ee,de,Te){return $t.showQuickPick(ee,!!Ue.enableProposedApi,de,Te)},showWorkspaceFolderPick(ee){return $t.showWorkspaceFolderPick(ee)},showInputBox(ee,de){return $t.showInput(ee,de)},showOpenDialog(ee){return Pt.showOpenDialog(ee)},showSaveDialog(ee){return Pt.showSaveDialog(ee)},createStatusBarItem(ee,de){let Te,st,bt,Ct;return ee&&typeof ee!="number"?(Te=ee.id,st=ee.name,bt=ee.alignment,de=ee.priority,Ct=ee.accessibilityInformation):(Te=Ue.identifier.value,st=b.localize(0,null,Ue.displayName||Ue.name),bt=ee),fn.createStatusBarEntry(Te,st,bt,de,Ct)},setStatusBarMessage(ee,de){return fn.setStatusBarMessage(ee,de)},withScmProgress(ee){return Ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),hn.withProgress(Ue,{location:O.ProgressLocation.SourceControl},(de,Te)=>ee({report(st){}}))},withProgress(ee,de){return hn.withProgress(Ue,ee,de)},createOutputChannel(ee){return Ot.createOutputChannel(ee)},createWebviewPanel(ee,de,Te,st){return sn.createWebviewPanel(Ue,ee,de,Te,st)},createWebviewTextEditorInset(ee,de,Te,st){return(0,K.checkProposedApiEnabled)(Ue),en.createWebviewEditorInset(ee,de,Te,st,Ue)},createTerminal(ee,de,Te){return typeof ee=="object"?"pty"in ee?ft.createExtensionTerminal(ee):(ee.icon&&(0,K.checkProposedApiEnabled)(Ue),ft.createTerminalFromOptions(ee)):ft.createTerminal(ee,de,Te)},registerTerminalLinkProvider(ee){return ft.registerLinkProvider(ee)},registerTreeDataProvider(ee,de){return qt.registerTreeDataProvider(ee,de,Ue)},createTreeView(ee,de){return qt.createTreeView(ee,de,Ue)},registerWebviewPanelSerializer:(ee,de)=>sn.registerWebviewPanelSerializer(Ue,ee,de),registerCustomEditorProvider:(ee,de,Te={})=>Qt.registerCustomEditorProvider(Ue,ee,de,Te),registerFileDecorationProvider(ee){return Ze.registerFileDecorationProvider(ee,Ue.identifier)},registerUriHandler(ee){return Tt.registerUriHandler(Ue.identifier,ee)},createQuickPick(){return $t.createQuickPick(Ue.identifier,!!Ue.enableProposedApi)},createInputBox(){return $t.createInputBox(Ue.identifier)},get activeColorTheme(){return Gt.activeColorTheme},onDidChangeActiveColorTheme(ee,de,Te){return Gt.onDidChangeActiveColorTheme(ee,de,Te)},registerWebviewViewProvider(ee,de,Te){return yn.registerWebviewViewProvider(Ue,ee,de,Te==null?void 0:Te.webviewOptions)},get activeNotebookEditor(){return(0,K.checkProposedApiEnabled)(Ue),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidChangeActiveNotebookEditor(ee,de,Te)},get visibleNotebookEditors(){return(0,K.checkProposedApiEnabled)(Ue),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookEditorSelection(ee,de,Te)},onDidChangeNotebookEditorVisibleRanges(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookEditorVisibleRanges(ee,de,Te)},showNotebookDocument(ee,de){return(0,K.checkProposedApiEnabled)(Ue),pt.showNotebookDocument(ee,de)},registerExternalUriOpener(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),on.registerExternalUriOpener(Ue.identifier,ee,de,Te)},get openEditors(){return(0,K.checkProposedApiEnabled)(Ue),ut.tabs},get onDidChangeOpenEditors(){return(0,K.checkProposedApiEnabled)(Ue),ut.onDidChangeTabs}},vn={get rootPath(){return Ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Qe.getPath()},set rootPath(ee){throw I.readonly()},getWorkspaceFolder(ee){return Qe.getWorkspaceFolder(ee)},get workspaceFolders(){return Qe.getWorkspaceFolders()},get name(){return Qe.name},set name(ee){throw I.readonly()},get workspaceFile(){return Qe.workspaceFile},set workspaceFile(ee){throw I.readonly()},updateWorkspaceFolders:(ee,de,...Te)=>Qe.updateWorkspaceFolders(Ue,ee,de||0,...Te),onDidChangeWorkspaceFolders:function(ee,de,Te){return Qe.onDidChangeWorkspace(ee,de,Te)},asRelativePath:(ee,de)=>Qe.getRelativePath(ee,de),findFiles:(ee,de,Te,st)=>Qe.findFiles(L.GlobPattern.from(ee),L.GlobPattern.from(de),Te,Ue.identifier,st),findTextInFiles:(ee,de,Te,st)=>{let bt,Ct;return typeof de=="object"?(bt=de,Ct=Te):(bt={},Ct=de,st=Te),Qe.findTextInFiles(ee,bt||{},Ct,Ue.identifier,st)},saveAll:ee=>Qe.saveAll(ee),applyEdit(ee){return Wt.applyWorkspaceEdit(ee)},createFileSystemWatcher:(ee,de,Te,st)=>Rt.createFileSystemWatcher(L.GlobPattern.from(ee),de,Te,st),get textDocuments(){return _t.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw I.readonly()},openTextDocument(ee){let de;const Te=ee;if(typeof ee=="string")de=Promise.resolve(C.URI.file(ee));else if(C.URI.isUri(ee))de=Promise.resolve(ee);else if(!Te||typeof Te=="object")de=_t.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>_t.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(ee,de,Te)=>_t.onDidAddDocument(ee,de,Te),onDidCloseTextDocument:(ee,de,Te)=>_t.onDidRemoveDocument(ee,de,Te),onDidChangeTextDocument:(ee,de,Te)=>_t.onDidChangeDocument(ee,de,Te),onDidSaveTextDocument:(ee,de,Te)=>_t.onDidSaveDocument(ee,de,Te),onWillSaveTextDocument:(ee,de,Te)=>Jt.getOnWillSaveTextDocumentEvent(Ue)(ee,de,Te),onDidChangeConfiguration:(ee,de,Te)=>mn.onDidChangeConfiguration(ee,de,Te),getConfiguration(ee,de){return de=arguments.length===1?void 0:de,mn.getConfiguration(ee,de,Ue)},registerTextDocumentContentProvider(ee,de){return Yt.registerTextDocumentContentProvider(ee,de)},registerTaskProvider:(ee,de)=>(Ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Ue,ee,de)),registerFileSystemProvider(ee,de,Te){return tn.registerFileSystemProvider(Ue.identifier,ee,de,Te,Ue.enableProposedApi)},get fs(){return rt.value},registerFileSearchProvider:(ee,de)=>((0,K.checkProposedApiEnabled)(Ue),St.registerFileSearchProvider(ee,de)),registerTextSearchProvider:(ee,de)=>((0,K.checkProposedApiEnabled)(Ue),St.registerTextSearchProvider(ee,de)),registerRemoteAuthorityResolver:(ee,de)=>((0,K.checkProposedApiEnabled)(Ue),tt.registerRemoteAuthorityResolver(ee,de)),registerResourceLabelFormatter:ee=>((0,K.checkProposedApiEnabled)(Ue),nn.$registerResourceLabelFormatter(ee)),onDidCreateFiles:(ee,de,Te)=>Rt.onDidCreateFile(ee,de,Te),onDidDeleteFiles:(ee,de,Te)=>Rt.onDidDeleteFile(ee,de,Te),onDidRenameFiles:(ee,de,Te)=>Rt.onDidRenameFile(ee,de,Te),onWillCreateFiles:(ee,de,Te)=>Rt.getOnWillCreateFileEvent(Ue)(ee,de,Te),onWillDeleteFiles:(ee,de,Te)=>Rt.getOnWillDeleteFileEvent(Ue)(ee,de,Te),onWillRenameFiles:(ee,de,Te)=>Rt.getOnWillRenameFileEvent(Ue)(ee,de,Te),openTunnel:ee=>((0,K.checkProposedApiEnabled)(Ue),Le.openTunnel(Ue,ee).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,K.checkProposedApiEnabled)(Ue),Le.getTunnels()},onDidChangeTunnels:(ee,de,Te)=>((0,K.checkProposedApiEnabled)(Ue),Le.onDidChangeTunnels(ee,de,Te)),registerPortAttributesProvider:(ee,de)=>((0,K.checkProposedApiEnabled)(Ue),Le.registerPortsAttributesProvider(ee,de)),registerTimelineProvider:(ee,de)=>((0,K.checkProposedApiEnabled)(Ue),Sn.registerTimelineProvider(ee,de,Ue.identifier,ht.converter)),get isTrusted(){return Qe.trusted},requestWorkspaceTrust:ee=>((0,K.checkProposedApiEnabled)(Ue),Qe.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,de,Te)=>Qe.onDidGrantWorkspaceTrust(ee,de,Te)},Tn={get inputBox(){return Ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),dn.getLastInputBox(Ue)},createSourceControl(ee,de,Te){return dn.createSourceControl(Ue,ee,de,Te)}},Rn={createCommentController(ee,de){return En.createCommentController(Ue,ee,de)}},wn={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(ee,de,Te){return at.onDidStartDebugSession(ee,de,Te)},onDidTerminateDebugSession(ee,de,Te){return at.onDidTerminateDebugSession(ee,de,Te)},onDidChangeActiveDebugSession(ee,de,Te){return at.onDidChangeActiveDebugSession(ee,de,Te)},onDidReceiveDebugSessionCustomEvent(ee,de,Te){return at.onDidReceiveDebugSessionCustomEvent(ee,de,Te)},onDidChangeBreakpoints(ee,de,Te){return at.onDidChangeBreakpoints(ee,de,Te)},registerDebugConfigurationProvider(ee,de,Te){return at.registerDebugConfigurationProvider(ee,de,Te||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,de){return at.registerDebugAdapterDescriptorFactory(Ue,ee,de)},registerDebugAdapterTrackerFactory(ee,de){return at.registerDebugAdapterTrackerFactory(ee,de)},startDebugging(ee,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?at.startDebugging(ee,de,{parentSession:Te}):at.startDebugging(ee,de,Te||{})},stopDebugging(ee){return at.stopDebugging(ee)},addBreakpoints(ee){return at.addBreakpoints(ee)},removeBreakpoints(ee){return at.removeBreakpoints(ee)},asDebugSourceUri(ee,de){return at.asDebugSourceUri(ee,de)}},bn={registerTaskProvider:(ee,de)=>Et.registerTaskProvider(Ue,ee,de),fetchTasks:ee=>Et.fetchTasks(ee),executeTask:ee=>Et.executeTask(Ue,ee),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ee,de,Te)=>Et.onDidStartTask(ee,de,Te),onDidEndTask:(ee,de,Te)=>Et.onDidEndTask(ee,de,Te),onDidStartTaskProcess:(ee,de,Te)=>Et.onDidStartTaskProcess(ee,de,Te),onDidEndTaskProcess:(ee,de,Te)=>Et.onDidEndTaskProcess(ee,de,Te)},Bt={openNotebookDocument:ee=>((0,K.checkProposedApiEnabled)(Ue),pt.openNotebookDocument(ee)),get onDidOpenNotebookDocument(){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,K.checkProposedApiEnabled)(Ue),pt.notebookDocuments.map(ee=>ee.apiNotebook)},registerNotebookSerializer(ee,de,Te,st){return(0,K.checkProposedApiEnabled)(Ue),pt.registerNotebookSerializer(Ue,ee,de,Te,Ue.enableProposedApi?st:void 0)},registerNotebookContentProvider:(ee,de,Te,st)=>((0,K.checkProposedApiEnabled)(Ue),pt.registerNotebookContentProvider(Ue,ee,de,Te,Ue.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(ee,de)=>((0,K.checkProposedApiEnabled)(Ue),pt.registerNotebookCellStatusBarItemProvider(Ue,ee,de)),createNotebookEditorDecorationType(ee){return(0,K.checkProposedApiEnabled)(Ue),pt.createNotebookEditorDecorationType(ee)},onDidChangeNotebookDocumentMetadata(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookDocumentMetadata(ee,de,Te)},onDidChangeNotebookCells(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookCells(ee,de,Te)},onDidChangeNotebookCellExecutionState(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookCellExecutionState(ee,de,Te)},onDidChangeCellOutputs(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidChangeCellOutputs(ee,de,Te)},onDidChangeCellMetadata(ee,de,Te){return(0,K.checkProposedApiEnabled)(Ue),pt.onDidChangeCellMetadata(ee,de,Te)},createConcatTextDocument(ee,de){return(0,K.checkProposedApiEnabled)(Ue),new G.ExtHostNotebookConcatDocument(pt,_t,ee,de)},createNotebookController(ee,de,Te,st,bt){return(0,K.checkProposedApiEnabled)(Ue),Zt.createNotebookController(Ue,ee,de,Te,st,bt)}};return{version:We.version,authentication:Cn,commands:kn,comments:Rn,debug:wn,env:gn,extensions:In,languages:Pn,notebook:Bt,scm:Tn,tasks:bn,test:Ht,window:An,workspace:vn,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:R.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,Hover:O.Hover,IndentAction:r.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:C.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlayHint:O.InlayHint,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,RemoteTrustOption:ce.RemoteTrustOption,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookDocumentMetadata:O.NotebookDocumentMetadata,NotebookCellMetadata:O.NotebookCellMetadata,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookKernelPreload:O.NotebookKernelPreload,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestItemStatus:O.TestItemStatus,TestResultState:O.TestResultState,TestMessage:O.TestMessage,TextSearchCompleteMessageType:Pe.TextSearchCompleteMessageType,TestMessageSeverity:O.TestMessageSeverity,WorkspaceTrustState:O.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ae}),define(me[264],ge([0,1,79,66,34,126,35,50,41,33,69,51,71,92,91,49,65,127,90,62,89,119,48]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S,u,c,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,b.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,b.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,b.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,b.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,b.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),(0,b.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,b.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch),(0,b.registerSingleton)(o.IExtHostStorage,o.ExtHostStorage),(0,b.registerSingleton)(r.IExtHostTask,r.WorkerExtHostTask),(0,b.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,b.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,b.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,b.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,b.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,b.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,b.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(me[93],ge([0,1,16,14,31,68]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=y;function C(P,f,m,o){const d=(0,b.mapArrayOrNot)(m,D),E=new I.TextSearchMatch(f,d,o),v=E.preview.matches;return{ranges:(0,b.mapArrayOrNot)(d,k),uri:P,preview:{text:E.preview.text,matches:(0,b.mapArrayOrNot)(v,k)}}}e.createTextSearchResult=C;function D(P){return new I.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function k(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let r=class{constructor(f,m){this.prefix=f,this.logService=m}appendLine(f){this.logService.debug(`${this.prefix}#search`,f)}};r=qe([He(1,R.ILogService)],r),e.OutputChannel=r}),define(me[265],ge([0,1,94,23]),function(Q,e,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,y=512,C=512*8,D=512*128;class k{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((a,p)=>{Q(["iconv-lite-umd"],a,p)})).getDecoder(m(n));else{const i=new TextDecoder;s={write(a){return i.decode(a,{stream:!0})},end(){return i.decode()}}}return new k(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function r(t,n){var s;const i=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?C:y;return new Promise((a,p)=>{const g=(0,b.newWriteableStream)(N=>N.join("")),_=[];let l=0,w;const T=async()=>{try{const N=await h({buffer:R.VSBuffer.concat(_),bytesRead:l},n.guessEncoding);N.encoding=await n.overwriteEncoding(N.encoding),w=await k.create(N.encoding);const z=w.write(R.VSBuffer.concat(_).buffer);g.write(z),_.length=0,l=0,a({stream:g,detected:N})}catch(N){p(N)}};(0,b.listenStream)(t,{onData:async N=>{w?g.write(w.write(N.buffer)):(_.push(N),l+=N.byteLength,l>=i&&(t.pause(),await T(),setTimeout(()=>t.resume())))},onError:N=>g.error(N),onEnd:async()=>{w||await T(),g.end(w==null?void 0:w.end())}})})}e.toDecodeStream=r;async function P(t,n,s){const a=(await new Promise((_,l)=>{Q(["iconv-lite-umd"],_,l)})).getEncoder(m(n),s);let p=!1,g=!1;return{read(){if(g)return null;const _=t.read();if(typeof _!="string"){if(g=!0,!p&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const l=a.end();return l&&l.length>0?(p=!0,R.VSBuffer.wrap(l)):null}return p=!0,R.VSBuffer.wrap(a.write(_))}}}e.toEncodeReadable=P;async function f(t){return(await new Promise((s,i)=>{Q(["iconv-lite-umd"],s,i)})).encodingExists(m(t))}e.encodingExists=f;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function o(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),i=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return s===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=o;const d=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((g,_)=>{Q(["jschardet"],g,_)}),s=t.slice(0,D),i=u(s.buffer),a=n.detect(i);if(!a||!a.encoding)return null;const p=a.encoding.toLowerCase();return 0<=d.indexOf(p)?null:S(a.encoding)}const v={ibm866:"cp866",big5:"cp950"};function S(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[n]||n}function u(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function c(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=c;function h({buffer:t,bytesRead:n},s){let i=o(t,n),a=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let p=!0,g=!0,_=!1;for(let l=0;l<n&&l<A;l++){const w=l%2==1,T=t.readUInt8(l)===0;if(T&&(_=!0),p&&(w&&!T||!w&&T)&&(p=!1),g&&(w&&T||!w&&!T)&&(g=!1),T&&!p&&!g)break}_&&(p?i=e.UTF16le:g?i=e.UTF16be:a=!0)}return s&&!a&&!i&&t?E(t.slice(0,n)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:a,encoding:i}}e.detectEncodingFromBuffer=h,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[129],ge([0,1,265,28,128]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends I.TextSearchManager{constructor(C,D,k=R){super(C,D,{readdir:r=>k.readdir(r.fsPath),toCanonicalName:r=>(0,b.toCanonicalName)(r)})}}e.NativeTextSearchManager=A}),define(me[266],ge([0,1,267,281,282,2,283]),function(Q,e,b,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(P,f,m,o,d,E){const v=E.environment.useHostProxy,S=typeof v=="boolean"?v:!E.remote.isRemote,u=(0,y.createProxyResolver)({resolveProxy:h=>P.resolveProxy(h),getHttpProxySetting:()=>f.getConfiguration("http").get("proxy"),log:(h,t,...n)=>{switch(h){case y.LogLevel.Trace:o.trace(t,...n);break;case y.LogLevel.Debug:o.debug(t,...n);break;case y.LogLevel.Info:o.info(t,...n);break;case y.LogLevel.Warning:o.warn(t,...n);break;case y.LogLevel.Error:o.error(t,...n);break;case y.LogLevel.Critical:o.critical(t,...n);break;case y.LogLevel.Off:break;default:s(h,t,n);break}function s(i,a,...p){o.error("Unknown log level",i),o.error(a,...p)}},getLogLevel:()=>o.getLevel(),proxyResolveTelemetry:h=>{d.$publicLog2("resolveProxy",h)},useHostProxy:S,env:process.env}),c=D(f,u);return r(m,c)}e.connectProxyResolver=C;function D(P,f){const m={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(d=>{m.config=P.getConfiguration("http").get("proxySupport")||"off"});const o={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(d=>{o.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"off"},o,!0)),on:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"on"},o,!0)),override:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"override"},o,!0)),onRequest:Object.assign({},b,(0,y.createHttpPatch)(b,f,m,o,!0)),default:Object.assign(b,(0,y.createHttpPatch)(b,f,m,o,!1))},https:{off:Object.assign({},R,(0,y.createHttpPatch)(R,f,{config:"off"},o,!0)),on:Object.assign({},R,(0,y.createHttpPatch)(R,f,{config:"on"},o,!0)),override:Object.assign({},R,(0,y.createHttpPatch)(R,f,{config:"override"},o,!0)),onRequest:Object.assign({},R,(0,y.createHttpPatch)(R,f,m,o,!0)),default:Object.assign(R,(0,y.createHttpPatch)(R,f,m,o,!1))},tls:Object.assign(I,(0,y.createTlsPatch)(I))}}const k=new Map;function r(P,f){return P.getExtensionPathIndex().then(m=>{const o=Q.__$__nodeRequire("module"),d=o._load;o._load=function(v,S,u){if(v==="tls")return f.tls;if(v!=="http"&&v!=="https")return d.apply(this,arguments);const c=f[v],h=m.findSubstr(A.URI.file(S.filename).fsPath);let t=k.get(h);if(t||k.set(h,t={}),!t[v]){let n=c.default;h&&h.enableProposedApi&&(n=c[h.proxySupport]||c.onRequest),t[v]=Object.assign({},n)}return t[v]}})}}),define(me[268],ge([0,1,38,9,76,29,10,8,93,269]),function(Q,e,b,R,I,A,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const r=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(u,c,h,t){const n=f(u,c,h,t),s=c.folder.fsPath;return{cmd:b.spawn(r,n.args,{cwd:s}),rgDiskPath:r,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=P;function f(u,c,h,t){const n=["--files","--hidden","--case-sensitive"];o([c],h,!1).forEach(i=>{const a=(0,D.anchorGlob)(i);if(n.push("-g",a),y.isMacintosh){const p=(0,I.normalizeNFD)(a);p!==a&&n.push("-g",p)}});const s=m([c],t,void 0,!1);return s.globArgs.forEach(i=>{const a=`!${(0,D.anchorGlob)(i)}`;if(n.push("-g",a),y.isMacintosh){const p=(0,I.normalizeNFD)(a);p!==a&&n.push("-g",p)}}),c.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),c.ignoreSymlinks||n.push("--follow"),u.exists&&n.push("--quiet"),n.push("--no-config"),c.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function m(u,c,h,t=!0){const n=[];let s={};return u.forEach(i=>{const a=Object.assign({},i.excludePattern||{},c||{}),p=d(a,t?i.folder.fsPath:void 0,h);n.push(...p.globArgs),p.siblingClauses&&(s=Object.assign(s,p.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=m;function o(u,c,h=!0){const t=[];return u.forEach(n=>{const s=Object.assign({},c||{},n.includePattern||{}),i=d(s,h?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=o;function d(u,c,h){const t=[],n={};return Object.keys(u).forEach(s=>{if(!(h&&h.has(s))&&!!s){const i=u[s];s=v(c?E(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),t.push(S(s))):i&&i.when&&(n[s]=i)}}),{globArgs:t,siblingClauses:n}}function E(u,c){return R.isAbsolute(c)?c:R.join(u,c)}e.getAbsoluteGlob=E;function v(u){return u=C.rtrim(u,"\\"),C.rtrim(u,"/")}function S(u){return A.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=S}),define(me[270],ge([0,1,38,37,9,101,16,60,32,76,29,10,45,8,11,28,31,268,99]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(s=>s())});class c{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(a=>{const p=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),g=a.folder.fsPath;i.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==g).forEach(_=>{(0,r.isEqualOrParent)(_,g)&&(p[I.relative(g,_)]=!0)}),this.folderExcludePatterns.set(g,new t(p,g))})}cancel(){this.isCanceled=!0}walk(i,a,p,g,_){if(this.fileWalkSW=f.StopWatch.create(!1),this.isCanceled)return _(null,this.isLimitHit);a.forEach(l=>{const w=I.basename(l.fsPath);this.globalExcludePattern&&this.globalExcludePattern(l.fsPath,w)||this.matchFile(p,{relativePath:l.fsPath,searchPath:void 0})}),this.cmdSW=f.StopWatch.create(!1),this.parallel(i,(l,w)=>{this.call(this.cmdTraversal,this,l,p,g,T=>{if(T){const N=(0,C.toErrorMessage)(T);console.error(N),this.errors.push(N),w(T,void 0)}else w(null,void 0)})},(l,w)=>{this.fileWalkSW.stop();const T=l?y.coalesce(l)[0]:null;_(T,this.isLimitHit)})}parallel(i,a,p){const g=new Array(i.length),_=new Array(i.length);let l=!1,w=0;if(i.length===0)return p(null,[]);i.forEach((T,N)=>{a(T,(z,ne)=>{if(z?(l=!0,g[N]=null,_[N]=z):(g[N]=ne,_[N]=null),++w===i.length)return p(l?_:null,g)})})}call(i,a,...p){try{i.apply(a,p)}catch(g){p[p.length-1](g)}}cmdTraversal(i,a,p,g){const _=i.folder.fsPath,l=P.isMacintosh;let w;const T=()=>w&&w.kill();u.add(T);let N=L=>{u.delete(T),N=()=>{},g(L)},z="";const ne=this.initDirectoryTree();let ie;const U=(0,v.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);w=U.cmd,ie=!Object.keys(U.siblingClauses).length;const B=U.rgArgs.args.map(L=>L.match(/^-/)?L:`'${L}'`).join(" ");let x=`${U.rgDiskPath} ${B}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),p({message:x}),this.cmdResultCount=0,this.collectStdout(w,"utf8",p,(L,O,F)=>{if(L){N(L);return}if(this.isLimitHit){N();return}const W=(z+(l?k.normalizeNFC(O||""):O)).split(`
`);if(F){const q=W.length;W[q-1]=W[q-1].trim(),W[q-1]||W.pop()}else z=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){N(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,ie){for(const q of W)if(this.matchFile(a,{base:_,relativePath:q,searchPath:this.getSearchPath(i,q)}),this.isLimitHit){T();break}(F||this.isLimitHit)&&N();return}this.addDirectoryEntries(i,ne,_,W,a),F&&(this.matchDirectoryTree(ne,_,a),N())})}spawnFindCmd(i){const a=this.folderExcludePatterns.get(i.folder.fsPath),p=a.getBasenameTerms(),g=a.getPathTerms(),_=["-L","."];if(p.length||g.length){_.push("-not","(","(");for(const l of p)_.push("-name",l),_.push("-o");for(const l of g)_.push("-path",l),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),b.spawn("find",_,{cwd:i.folder.fsPath})}readStdout(i,a,p){let g="";this.collectStdout(i,a,()=>{},(_,l,w)=>{if(_){p(_);return}g+=l,w&&p(null,g)})}collectStdout(i,a,p,g){let _=(T,N,z)=>{(T||z)&&(_=()=>{},this.cmdSW&&this.cmdSW.stop()),g(T,N,z)},l=!1;i.stdout?(this.forwardData(i.stdout,a,_),i.stdout.once("data",()=>l=!0)):p({message:"stdout is null"});let w;i.stderr?w=this.collectData(i.stderr):p({message:"stderr is null"}),i.on("error",T=>{_(T)}),i.on("close",T=>{let N;!l&&(N=this.decodeData(w,a))&&n(N)?_(new Error(`command failed with error code ${T}: ${this.decodeData(w,a)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(i,a,p){const g=new A.StringDecoder(a);return i.on("data",_=>{p(null,g.write(_))}),g}collectData(i){const a=[];return i.on("data",p=>{a.push(p)}),a}decodeData(i,a){const p=new A.StringDecoder(a);return i.map(g=>p.write(g)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:a},p,g,_){g.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:p,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const l=w=>{const T=I.basename(w),N=I.dirname(w);let z=a[N];z||(z=a[N]=[],l(N)),z.push({base:p,relativePath:w,basename:T,searchPath:this.getSearchPath(i,w)})};g.forEach(l)}matchDirectoryTree({rootEntries:i,pathToEntries:a},p,g){const _=this,l=this.folderExcludePatterns.get(p),w=this.filePattern;function T(N){_.directoriesWalked++;const z=D.hasSiblingFn(()=>N.map(ne=>ne.basename));for(let ne=0,ie=N.length;ne<ie;ne++){const U=N[ne],{relativePath:B,basename:x}=U;if(!l.test(B,x,w!==x?z:void 0)){const L=a[B];if(L)T(L);else{if(_.filesWalked++,B===w)continue;_.matchFile(g,U)}if(_.isLimitHit)break}}}T(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,a,p,g,_){const l=i.folder,w=D.hasSiblingFn(()=>p);this.parallel(p,(T,N)=>{if(this.isCanceled||this.isLimitHit)return N(null);const z=a?[a,T].join(I.sep):T;if(this.folderExcludePatterns.get(i.folder.fsPath).test(z,T,this.config.filePattern!==T?w:void 0))return N(null);const ne=[l.fsPath,z].join(I.sep);R.lstat(ne,(ie,U)=>{if(ie||this.isCanceled||this.isLimitHit)return N(null);this.statLinkIfNeeded(ne,U,(B,x)=>B||this.isCanceled||this.isLimitHit?N(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ne,U,(L,O)=>L||this.isCanceled||this.isLimitHit||(O=O||"",this.walkedPaths[O])?N(null):(this.walkedPaths[O]=!0,(0,d.readdir)(ne).then(F=>{if(this.isCanceled||this.isLimitHit)return N(null);this.doWalk(i,z,F,g,M=>N(M||null))},F=>{N(null)})))):(this.filesWalked++,z===this.filePattern||this.maxFilesize&&o.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(g,{base:l.fsPath,relativePath:z,searchPath:this.getSearchPath(i,z)}),N(null,void 0)))})},T=>{const N=T&&y.coalesce(T);return _(N&&N.length>0?N[0]:void 0)})}matchFile(i,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,I.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(a))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,a,p){return a.isSymbolicLink()?R.stat(i,p):p(null,a)}realPathIfNeeded(i,a,p){return a.isSymbolicLink()?R.realpath(i,(g,_)=>g?p(g):p(null,_)):p(null,i)}getSearchPath(i,a){return i.folderName?I.join(i.folderName,a):a}}e.FileWalker=c;class h{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new c(i)}search(i,a,p){this.walker.walk(this.folderQueries,this.extraFiles,i,a,(g,_)=>{p(g,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=h;class t{constructor(i,a){this.expression=i,this.root=a,this.init(i)}init(i){let a,p;Object.keys(i).filter(g=>i[g]).forEach(g=>{I.isAbsolute(g)?(a=a||D.getEmptyExpression(),a[g]=i[g]):(p=p||D.getEmptyExpression(),p[g]=i[g])}),this.absoluteParsedExpr=a&&D.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=p&&D.parse(p,{trimForExclusions:!0})}test(i,a,p){return this.relativeParsedExpr&&this.relativeParsedExpr(i,a,p)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),a,p)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function n(s){const i=s.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return m.uppercaseFirstLetter(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=n}),define(me[130],ge([0,1,38,284,101,16,53,32,9,8,2,31,68,285,269,93]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=o.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(l){this.outputChannel=l}provideTextSearchResults(l,w,T,N){return this.outputChannel.appendLine(`provideTextSearchResults ${l.pattern}, ${JSON.stringify(Object.assign(Object.assign({},w),{folder:w.folder.toString()}))}`),new Promise((z,ne)=>{N.onCancellationRequested(()=>M());const ie=n(l,w),U=w.folder.fsPath,B=ie.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${E} ${B}
 - cwd: ${U}`);let x=b.spawn(E,ie,{cwd:U});x.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),ne((0,P.serializeSearchError)(new P.SearchError(ve&&ve.message,P.SearchErrorCode.rgProcessError)))});let L=!1;const O=new c(w.maxResults,U,w.previewOptions);O.on("result",ve=>{L=!0,q="",T.report(ve)});let F=!1;const M=()=>{F=!0,x&&x.kill(),O&&O.cancel()};let W=!1;O.on("hitLimit",()=>{W=!0,M()});let q="";x.stdout.on("data",ve=>{O.handleData(ve),L||(q+=ve)});let K=!1;x.stdout.once("data",()=>K=!0);let le="";x.stderr.on("data",ve=>{const Re=ve.toString();this.outputChannel.appendLine(Re),le+=Re}),x.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(L?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),F)z({limitHit:W});else{O.flush(),x=null;let ve;le&&!K&&(ve=S(le))?ne((0,P.serializeSearchError)(new P.SearchError(ve.message,ve.code))):z({limitHit:W})}})})}}e.RipgrepTextSearchEngine=v;function S(_){const l=_.split(`
`),w=l[0].trim();if(l.some(N=>N.startsWith("regex parse error")))return new P.SearchError(u(l),P.SearchErrorCode.regexParseError);const T=w.match(/grep config error: unknown encoding: (.*)/);if(T)return new P.SearchError(`Unknown encoding: ${T[1]}`,P.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new P.SearchError(w.charAt(0).toUpperCase()+w.substr(1),P.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new P.SearchError(w.charAt(0).toUpperCase()+w.substr(1),P.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(w,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function u(_){const l=["Regex parse error"],w=_.filter(T=>T.startsWith("PCRE2:"));if(w.length>=1){const T=w[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const N=T.split(":")[1];l.push(":"+N)}}return l.join("")}e.buildRegexParseError=u;class c extends R.EventEmitter{constructor(l,w,T){super();this.maxResults=l,this.rootFolder=w,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(l,w){return super.on(l,w),this}handleData(l){if(!this.isDone){const w=typeof l=="string"?l:this.stringDecoder.write(l);this.handleDecodedData(w)}}handleDecodedData(l){let w=l.indexOf(`
`);const T=this.remainder+l;if(w>=0)w+=this.remainder.length;else{this.remainder=T;return}let N=0;for(;w>=0;)this.handleLine(T.substring(N,w).trim()),N=w+1,w=T.indexOf(`
`,N);this.remainder=T.substring(N)}handleLine(l){if(!(this.isDone||!l)){let w;try{w=JSON.parse(l)}catch(T){throw new Error(`malformed line from rg: ${l}`)}if(w.type==="match"){const T=h(w.data.path),N=r.URI.file(D.join(this.rootFolder,T)),z=this.createTextSearchMatch(w.data,N);this.onResult(z),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const T=h(w.data.path),N=r.URI.file(D.join(this.rootFolder,T));this.createTextSearchContext(w.data,N).forEach(ne=>this.onResult(ne))}}}createTextSearchMatch(l,w){const T=l.line_number-1;let N=!1,z=h(l.lines);T===0&&(0,k.startsWithUTF8BOM)(z)&&(N=!0,z=(0,k.stripUTF8BOM)(z));const ne=Buffer.from(z);let ie=0,U=0,B=T;l.submatches.length===0&&l.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const x=(0,A.coalesce)(l.submatches.map((L,O)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=h(L.match);T===0&&O===0&&N&&(F=(0,k.stripUTF8BOM)(F),L.start=L.start<=3?0:L.start-3,L.end=L.end<=3?0:L.end-3);const M=ne.slice(ie,L.start).toString().length,W=U+M,q=t(F),K=B,le=q.numLines+K,ve=q.numLines>0?q.lastLineLength:q.lastLineLength+W;return ie=L.end,U=ve,B=le,new f.Range(K,W,le,ve)}));return(0,d.createTextSearchResult)(w,z,x,this.previewOptions)}createTextSearchContext(l,w){const T=h(l.lines),N=l.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((z,ne)=>({text:z,uri:w,lineNumber:N+ne}))}onResult(l){this.emit("result",l)}}e.RipgrepParser=c;function h(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function t(_){const l=/\n/g;let w=0,T=-1,N;for(;N=l.exec(_);)w++,T=N.index;const z=T>=0?_.length-T-1:_.length;return{numLines:w,lastLineLength:z}}function n(_,l){const w=["--hidden"];w.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:N}=(0,y.groupBy)(l.includes,ne=>ne.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const ne=new Set;N.forEach(ie=>{ne.add(ie)}),w.push("-g","!*"),ne.forEach(ie=>{s(ie).map(d.anchorGlob).forEach(U=>{w.push("-g",U)})})}T&&T.length&&T.forEach(ne=>{w.push("-g",ne)}),l.excludes.map(d.anchorGlob).forEach(ne=>w.push("-g",`!${ne}`)),l.maxFileSize&&w.push("--max-filesize",l.maxFileSize+""),l.useIgnoreFiles?w.push("--no-ignore-parent"):w.push("--no-ignore"),l.followSymlinks&&w.push("--follow"),l.encoding&&l.encoding!=="utf8"&&w.push("--encoding",l.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=(0,k.escapeRegExpCharacters)(_.pattern),_.isRegExp=!0),l.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),_.isRegExp&&(_.pattern=i(_.pattern),w.push("--auto-hybrid-regex"));let z;if(_.isWordMatch){const ie=(0,k.createRegExp)(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",ie)}else if(_.isRegExp){let ne=p(_.pattern);ne=g(ne),w.push("--regexp",ne)}else z=_.pattern,w.push("--fixed-strings");return w.push("--no-config"),l.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),_.isMultiline&&w.push("--multiline"),l.beforeContext&&w.push("--before-context",l.beforeContext+""),l.afterContext&&w.push("--after-context",l.afterContext+""),w.push("--"),z&&w.push(z),w.push("."),w}function s(_){const l=(0,C.splitGlobAware)(_,"/");return l.map((w,T)=>l.slice(0,T+1).join("/"))}e.spreadGlobComponents=s;function i(_){const l=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(l);)_=_.replace(l,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(w);)_=_.replace(w,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=i;const a=_=>_.type==="Assertion"&&_.kind==="lookbehind";function p(_){let l;try{l=new m.RegExpParser().parsePattern(_)}catch(ie){return _}let w="",T=0;const N=(ie,U,B)=>{w+=_.slice(T,ie)+B,T=U},z=[];return new m.RegExpVisitor({onCharacterEnter(ie){if(ie.raw==="\\n"){const U=z[0];if(!U)N(ie.start,ie.end,"\\r?\\n");else if(!z.some(a))if(U.type==="CharacterClass")if(U.negate){const B=_.slice(U.start+2,ie.start)+_.slice(ie.end,U.end-1);N(U.start,U.end,"(?!\\r?\\n"+(B?`|[${B}]`:"")+")")}else{const B=_.slice(U.start+1,ie.start)+_.slice(ie.end,U.end-1);N(U.start,U.end,B===""?"\\r?\\n":`(?:[${B}]|\\r?\\n)`)}else U.type==="Quantifier"&&N(ie.start,ie.end,"(?:\\r?\\n)")}},onQuantifierEnter(ie){z.unshift(ie)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(ie){z.unshift(ie)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(ie){z.unshift(ie)},onCharacterClassLeave(){z.shift()},onAssertionEnter(ie){a(ie)&&z.push(ie)},onAssertionLeave(ie){z[0]===ie&&z.shift()}}).visit(l),w+=_.slice(T),w}e.fixRegexNewline=p;function g(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=g}),define(me[271],ge([0,1,21,130,115,12]),function(Q,e,b,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,r,P,f){const m=new R.RipgrepTextSearchEngine(this.outputChannel);if(r.folder.scheme===A.Schemas.userData){const o=Object.assign(Object.assign({},r),{folder:r.folder.with({scheme:A.Schemas.file})}),d=new I.Progress(E=>P.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:r.folder.scheme})})));return this.withToken(f,E=>m.provideTextSearchResults(k,o,d,E))}else return this.withToken(f,o=>m.provideTextSearchResults(k,r,P,o))}async withToken(k,r){const P=C(k);this.inProgress.add(P);const f=await r(P.token);return this.inProgress.delete(P),f}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=y;function C(D){const k=new b.CancellationTokenSource;return D.onCancellationRequested(()=>k.cancel()),k}}),define(me[272],ge([0,1,28,130,129]),function(Q,e,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(D){this.query=D}search(D,k,r){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(m){r({message:m})}},f=new I.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(P),b);return new Promise((m,o)=>f.search(d=>{k(d.map(y))},D).then(d=>m({limitHit:d.limitHit,type:"success"}),o))}}e.TextSearchEngineAdapter=A;function y(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((D,k)=>{if(k.ranges){const r=k;return D+(Array.isArray(r.ranges)?r.ranges.length:1)}else return D+1},0)}}}),define(me[273],ge([0,1,37,286,16,13,17,3,99,9,45,2,44,31,270,272]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(b);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=u(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(a=>this.doFileSearchWithEngine(o.Engine,s,p=>i.fire(p),a)),n.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}textSearch(t){let n;const s=u(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(a=>this.ripgrepTextSearch(s,p=>i.fire(p),a)),n.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,f.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new d.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(o.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,i,a=E.BATCH_SIZE){let p=0;const g=l=>{Array.isArray(l)?(p+=l.length,s(l.map(w=>this.rawMatchToSearchItem(w)))):l.relativePath?(p++,s(this.rawMatchToSearchItem(l))):s(l)};if(n.sortByScore){let l=this.trySortedSearchFromCache(n,g,i);if(!l){const w=n.maxResults?Object.assign({},n,{maxResults:null}):n,T=new t(w);l=this.doSortedSearch(T,n,s,g,i)}return new Promise((w,T)=>{l.then(([N,z])=>{const ne=z.map(ie=>this.rawMatchToSearchItem(ie));this.sendProgress(ne,s,a),w(N)},T)})}const _=new t(n);return this.doSearch(_,g,a,i).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:"searchProcess",fromCache:!1,resultCount:p,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,k.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,i,a){const p=new C.Emitter;let g=(0,A.createCancelablePromise)(l=>{let w=[];const T=N=>{Array.isArray(N)?w=N:(i(N),p.fire(N))};return this.doSearch(t,T,-1,l).then(N=>[N,w])}),_;if(n.cacheKey){_=this.getOrCreateCache(n.cacheKey);const l={promise:g,event:p.event,resolved:!1};_.resultsToSearchCache[n.filePattern||""]=l,g.then(()=>{l.resolved=!0},w=>{delete _.resultsToSearchCache[n.filePattern||""]}),g=this.preventCancellation(g)}return g.then(([l,w])=>{const T=_?_.scorerCache:Object.create(null),N=(typeof n.maxResults!="number"||n.maxResults>0)&&r.StopWatch.create(!1);return this.sortResults(n,w,T,a).then(z=>{const ne=N?N.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:ne,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:z.length},messages:l.messages,limitHit:l.limitHit||typeof n.maxResults=="number"&&w.length>n.maxResults},z]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new v)}trySortedSearchFromCache(t,n,s){const i=t.cacheKey&&this.caches[t.cacheKey];if(!!i){const a=this.getResultsFromCache(i,t.filePattern||"",n,s);if(a)return a.then(([p,g,_])=>{const l=r.StopWatch.create(!1);return this.sortResults(t,g,i.scorerCache,s).then(w=>{const T=l.elapsed(),N={fromCache:!0,detailStats:_,type:"searchProcess",resultCount:g.length,sortingTime:T};return[{type:"success",limitHit:p.limitHit||typeof t.maxResults=="number"&&g.length>t.maxResults,stats:N},w]})})}}sortResults(t,n,s,i){const a=(0,D.prepareQuery)(t.filePattern||""),p=(_,l)=>(0,D.compareItemsByFuzzyScore)(_,l,a,!0,S,s),g=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return I.topAsync(n,p,g,1e4,i)}sendProgress(t,n,s){if(s&&s>0)for(let i=0;i<t.length;i+=s)n(t.slice(i,i+s));else n(t)}getResultsFromCache(t,n,s,i){const a=r.StopWatch.create(!1),p=n.indexOf(k.sep)>=0;let g;for(const T in t.resultsToSearchCache)if(n.startsWith(T)){if(p&&T.indexOf(k.sep)<0&&T!=="")continue;const N=t.resultsToSearchCache[T];g={promise:this.preventCancellation(N.promise),event:N.event,resolved:N.resolved};break}if(!g)return null;const _=a.elapsed(),l=r.StopWatch.create(!1),w=g.event(s);return i&&i.onCancellationRequested(()=>{w.dispose()}),g.promise.then(([T,N])=>{if(i&&i.isCancellationRequested)throw(0,y.canceled)();const z=[],ne=(0,D.prepareQuery)(n).normalizedLowercase;for(const ie of N)!(0,m.isFilePatternMatch)(ie,ne)||z.push(ie);return[T,z,{cacheWasResolved:g.resolved,cacheLookupTime:_,cacheFilterTime:l.elapsed(),cacheEntryCount:N.length}]})}doSearch(t,n,s,i){return new Promise((a,p)=>{let g=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(_=>{_&&(s?(g.push(_),s>0&&g.length>=s&&(n(g),g=[])):n(_))},_=>{n(_)},(_,l)=>{g.length&&n(g),_?p(_):a(l)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(h){return(0,k.basename)(h.relativePath)}getItemDescription(h){return(0,k.dirname)(h.relativePath)}getItemPath(h){return h.relativePath}};function u(h){return Object.assign(Object.assign({},h),{folderQueries:h.folderQueries&&h.folderQueries.map(c),extraFileResources:h.extraFileResources&&h.extraFileResources.map(t=>P.URI.revive(t))})}function c(h){return Object.assign(Object.assign({},h),{folder:P.URI.revive(h.folder)})}}),define(me[274],ge([0,1,6,2,28,14,31,273,271,93,15,63,27,71,12,129]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends m.ExtHostSearch{constructor(S,u,c,h){super(S,c,h);this._pfs=I,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new k.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(o.Schemas.userData,new D.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const S=new k.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(o.Schemas.file,new D.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(o.Schemas.file,new C.SearchService)}registerInternalFileSearchProvider(S,u){const c=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(S)),(0,b.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(S,u,c,h){const t=(0,m.reviveQuery)(c);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,u,t,h):super.$provideFileSearchResults(S,u,c,h)}doInternalFileSearch(S,u,c,h){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(S,u,n.map(s=>R.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,t,h)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,u){return new d.NativeTextSearchManager(S,u)}};E=qe([He(0,r.IExtHostRpcService),He(1,f.IExtHostInitDataService),He(2,P.IURITransformerService),He(3,A.ILogService)],E),e.NativeExtHostSearch=E}),define(me[131],ge([0,1,287,122,288,3,104,9,102,30,6,23,105,17,10]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(g){this.socket=g,this._errorListener=_=>{if(_){if(_.code==="EPIPE")return;(0,m.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(g){const _=l=>g(P.VSBuffer.wrap(l));return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(g){return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,m.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,m.onUnexpectedError)(_)}}end(){this.socket.end()}drain(){return new Promise((g,_)=>{if(this.socket.bufferSize===0){g();return}const l=()=>{this.socket.off("close",l),this.socket.off("end",l),this.socket.off("error",l),this.socket.off("timeout",l),this.socket.off("drain",l),g()};this.socket.on("close",l),this.socket.on("end",l),this.socket.on("error",l),this.socket.on("timeout",l),this.socket.on("drain",l)})}}e.NodeSocket=d;var E;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var v;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(v||(v={}));class S extends r.Disposable{constructor(g,_,l,w){super();this._onDidZlibFlush=this._register(new A.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new A.Emitter),this._onClose=this._register(new A.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=_,this._recordInflateBytes=w,_?(this._zlibInflate=I.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),(0,m.onUnexpectedError)(T),this._onClose.fire()}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),l&&(this._zlibInflate.write(l.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=I.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),(0,m.onUnexpectedError)(T),this._onClose.fire()}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):P.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let _=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.length-4),this._isEnded||this._write(P.VSBuffer.wrap(_),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,_){let l=2;g.byteLength<126?l+=0:g.byteLength<2**16?l+=2:l+=8;const w=P.VSBuffer.alloc(l);if(_?w.writeUInt8(194,0):w.writeUInt8(130,0),g.byteLength<126)w.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){w.writeUInt8(126,1);let T=1;w.writeUInt8(g.byteLength>>>8&255,++T),w.writeUInt8(g.byteLength>>>0&255,++T)}else{w.writeUInt8(127,1);let T=1;w.writeUInt8(0,++T),w.writeUInt8(0,++T),w.writeUInt8(0,++T),w.writeUInt8(0,++T),w.writeUInt8(g.byteLength>>>24&255,++T),w.writeUInt8(g.byteLength>>>16&255,++T),w.writeUInt8(g.byteLength>>>8&255,++T),w.writeUInt8(g.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=w.byteLength+g.byteLength,this.socket.write(P.VSBuffer.concat([w,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),w=(_.readUInt8(0)&128)>>>7,T=_.readUInt8(1),N=(T&128)>>>7,z=T&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=w,this._state.mask=0}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),l=_.readUInt8(1),w=(l&128)>>>7;let T=l&127,N=1;T===126?T=_.readUInt8(++N)*2**8+_.readUInt8(++N):T===127&&(T=_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*0+_.readUInt8(++N)*2**24+_.readUInt8(++N)*2**16+_.readUInt8(++N)*2**8+_.readUInt8(++N));let z=0;w&&(z=_.readUInt8(++N)*2**24+_.readUInt8(++N)*2**16+_.readUInt8(++N)*2**8+_.readUInt8(++N)),this._state.state=3,this._state.readLen=T,this._state.mask=z}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);u(_,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(_.buffer)),this._zlibInflate.write(_.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const l=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=l.length,this._onData.fire(P.VSBuffer.wrap(l))})):(this._totalIncomingDataBytes+=_.byteLength,this._onData.fire(_))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await A.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function u(p,g){if(g!==0){let _=p.byteLength>>>2;for(let ne=0;ne<_;ne++){const ie=p.readUInt32BE(ne*4);p.writeUInt32BE(ie^g,ne*4)}let l=_*4,w=p.byteLength-l;const T=g>>>24&255,N=g>>>16&255,z=g>>>8&255;w>=1&&p.writeUInt8(p.readUInt8(l)^T,l),w>=2&&p.writeUInt8(p.readUInt8(l+1)^N,l+1),w>=3&&p.writeUInt8(p.readUInt8(l+2)^z,l+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function h(){const p=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let g;return e.XDG_RUNTIME_DIR?g=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):g=(0,C.join)((0,D.tmpdir)(),`vscode-ipc-${p}.sock`),n(g),g}e.createRandomIPCHandle=h;function t(p,g,_){const l=(0,b.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${l}-${_}-${g}-sock`;let w;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?w=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${l.substr(0,8)}-${_}-${g}.sock`):w=(0,C.join)(p,`${_}-${g}.sock`),n(w),w}e.createStaticIPCHandle=t;function n(p){const g=c[o.platform];typeof g=="number"&&p.length>=g&&console.warn(`WARNING: IPC handle "${p}" is longer than ${g} chars, try a shorter --user-data-dir`)}class s extends y.IPCServer{constructor(g){super(s.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const _=A.Event.fromNodeEventEmitter(g,"connection");return A.Event.map(_,l=>({protocol:new f.Protocol(new d(l)),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(l,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(p){return new Promise((g,_)=>{const l=(0,R.createServer)();l.on("error",_),l.listen(p,()=>{l.removeListener("error",_),g(new s(l))})})}e.serve=i;function a(p,g){return new Promise((_,l)=>{const w=(0,R.createConnection)(p,()=>{w.removeListener("error",l),_(f.Client.fromSocket(new d(w),g))});w.once("error",l)})}e.connect=a}),define(me[275],ge([0,1,131,267,37,50,2,118,14]),function(Q,e,b,R,I,A,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(f,m,o){this._commands=f,this.logService=m,this._ipcHandlePath=o,this._server=R.createServer((d,E)=>this.onRequest(d,E)),this.setup().catch(d=>(m.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",f=>this.logService.error(f))}catch(f){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(f,m){const o=[];f.setEncoding("utf8"),f.on("data",d=>o.push(d)),f.on("end",()=>{const d=JSON.parse(o.join(""));switch(d.type){case"open":this.open(d,m);break;case"openExternal":this.openExternal(d,m);break;case"status":this.getStatus(d,m);break;case"extensionManagement":this.manageExtensions(d,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${d.type}`,E=>{E&&this.logService.error(E)}),m.end();break}})}open(f,m){let{fileURIs:o,folderURIs:d,forceNewWindow:E,diffMode:v,addMode:S,forceReuseWindow:u,gotoLineMode:c,waitMarkerFilePath:h}=f;const t=[];if(Array.isArray(d))for(const n of d)try{t.push({folderUri:y.URI.parse(n)})}catch(s){}if(Array.isArray(o))for(const n of o)try{(0,C.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(s){}if(t.length){const n=h?y.URI.file(h):void 0,i={forceNewWindow:E,diffMode:v,addMode:S,gotoLineMode:c,forceReuseWindow:u,preferNewWindow:!u&&!n&&!S,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}m.writeHead(200),m.end()}async openExternal(f,m){for(const o of f.uris){const d=y.URI.parse(o),E=d.scheme==="file"?d:o;await this._commands.executeCommand("_remoteCLI.openExternal",E)}m.writeHead(200),m.end()}async manageExtensions(f,m){try{const o=v=>v==null?void 0:v.map(S=>/\.vsix$/i.test(S)?y.URI.parse(S):S),d={list:f.list,install:o(f.install),uninstall:o(f.uninstall),force:f.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);m.writeHead(200),m.write(E)}catch(o){m.writeHead(500),m.write(String(o),d=>{d&&this.logService.error(d)})}m.end()}async getStatus(f,m){try{const o=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(o),m.end()}catch(o){m.writeHead(500),m.write(String(o),d=>{d&&this.logService.error(d)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let r=class extends k{constructor(f,m){super(f,m,(0,b.createRandomIPCHandle)())}};r=qe([He(0,A.IExtHostCommands),He(1,D.ILogService)],r),e.CLIServer=r}),define(me[276],ge([0,1,70,263,258,5,266,42,248,2,12,7,275,103]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class o extends I.RequireInterceptor{_installInterceptor(){const v=this,S=Q.__$__nodeRequire("module"),u=S._load;S._load=function(h,t,n){for(let s of v._alternatives){let i=s(h);if(i){h=i;break}}return v._factories.has(h)?v._factories.get(h).load(h,k.URI.file((0,m.realpathSync)(t.filename)),s=>u.apply(this,[s,t,n])):u.apply(this,arguments)}}}class d extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(f.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(o,v,this._registry).install(),b.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),b.mark("code/extHost/didInitProxyResolver");const c=process.send,h=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?c.apply(process,t):(h.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,S,u){if(S.scheme!==r.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let c=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{v&&b.mark(`code/extHost/willLoadExtensionCode/${v.value}`),c=Q.__$__nodeRequire(S.fsPath)}catch(h){return Promise.reject(h)}finally{v&&b.mark(`code/extHost/didLoadExtensionCode/${v.value}`),u.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const S in v){const u=v[S];u===null?delete process.env[S]:process.env[S]=u}}}e.ExtHostExtensionService=d}),define(me[277],ge([0,1,79,249,250,260,259,274,276,220,251,51,42,66,71,69,33,49,14]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d,E,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(f.IExtHostExtensionService,D.ExtHostExtensionService),(0,b.registerSingleton)(S.ILogService,k.ExtHostLogService),(0,b.registerSingleton)(P.IExtHostDebugService,y.ExtHostDebugService),(0,b.registerSingleton)(m.IExtHostOutputService,R.ExtHostOutputService2),(0,b.registerSingleton)(o.IExtHostSearch,C.NativeExtHostSearch),(0,b.registerSingleton)(d.IExtHostTask,A.ExtHostTask),(0,b.registerSingleton)(E.IExtHostTerminalService,I.ExtHostTerminalService),(0,b.registerSingleton)(v.IExtHostTunnelService,r.ExtHostTunnelService)}),define(me[278],ge([0,1,122,289,70,17,105,131,186,218,261,23,100,28,103,13,264,277]),function(Q,e,b,R,I,A,y,C,D,k,r,P,f,m,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const E=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=Q.__$__nodeRequire("module"),i=s._load;s._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}})();const v=process.exit.bind(process);function S(s){process.exit=function(i){if(s)v(i);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let u=function(s){v()};function c(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,i)=>{let a=null,p=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const g=108e5,_=3e5,l=new d.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),g),w=new d.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),_);process.on("message",(N,z)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ne=P.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let ie;if(N.skipWebSocketFrames)ie=new C.NodeSocket(z);else{const U=P.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));ie=new C.WebSocketNodeSocket(new C.NodeSocket(z),N.permessageDeflate,U,!1)}a?(l.cancel(),w.cancel(),a.beginAcceptReconnection(ie,ne),a.endAcceptReconnection()):(clearTimeout(p),a=new y.PersistentProtocol(ie,ne),a.onDidDispose(()=>u("renderer disconnected")),s(a),a.onSocketClose(()=>{l.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(w.isScheduled())return;l.isScheduled()&&w.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(T)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,a)=>{const p=b.createConnection(s,()=>{p.removeListener("error",a),i(new y.PersistentProtocol(new C.NodeSocket(p)))});p.once("error",a)})}}async function h(){const s=await c();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(i=>{(0,k.isMessageOfType)(i,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||s.send(i)}drain(){return s.drain()}}}function t(s){return new Promise(i=>{const a=s.onMessage(p=>{a.dispose();const g=JSON.parse(p.toString()),_=g.commit,l=D.default.commit;_&&l&&_!==l&&v(55);const w=[];process.on("unhandledRejection",(z,ne)=>{w.push(ne),setTimeout(()=>{const ie=w.indexOf(ne);ie>=0&&ne.catch(U=>{w.splice(ie,1),console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,A.onUnexpectedError)(z)})},1e3)}),process.on("rejectionHandled",z=>{const ne=w.indexOf(z);ne>=0&&w.splice(ne,1)}),process.on("uncaughtException",function(z){(0,A.onUnexpectedError)(z)});let T=0;setInterval(function(){try{process.kill(g.parentPid,0),T=0}catch(z){z&&z.code==="EPERM"?(T++,T>=3&&u(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):u(`parent process ${g.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let N;try{N=Q.__$__nodeRequire("native-watchdog"),N.start(g.parentPid)}catch(z){(0,A.onUnexpectedError)(z)}s.send((0,k.createMessageOfType)(0)),i({protocol:s,initData:g})});s.send((0,k.createMessageOfType)(1))})}async function n(){I.mark("code/extHost/willConnectToRenderer");const s=await h();I.mark("code/extHost/didConnectToRenderer");const i=await t(s);I.mark("code/extHost/didWaitForInitData");const{initData:a}=i;S(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const p=new class{exit(w){v(w)}exists(w){return(0,m.exists)(w)}realpath(w){return(0,o.realpath)(w)}};let g=null;if(a.remote.authority&&E.uriTransformerPath)try{const w=Q.__$__nodeRequire(E.uriTransformerPath)(a.remote.authority);g=new f.URITransformer(w)}catch(l){console.error(l)}const _=new r.ExtensionHostMain(i.protocol,a,p,g);u=l=>_.terminate(l)}e.startExtensionHostProcess=n}),define(me[290],ge([0,1,278]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.startExtensionHostProcess)().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/40d5e6796fbc32d67dd0009e5b0027003803fd7e/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
